%% gh -- a compiler for Generic Haskell.
%% Copyright (c) 2001  The Generic Haskell Team. Utrecht University
%% 
%% This library is free software; you can redistribute it and/or modify
%% it under the terms of the GNU Lesser General Public License as
%% published by the Free Software Foundation; either version 2.1 of the
%% License, or (at your option) any later version.
%% 
%% This library is distributed in the hope that it will be useful, but
%% WITHOUT ANY WARRANTY; without even the implied warranty of
%% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%% Lesser General Public License for more details.
%% 
%% You should have received a copy of the GNU Lesser General Public
%% License along with this library; if not, write to the Free Software
%% Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
%%
%% $Id: GHIParseUtils.lhs,v 1.2 2002/04/15 11:56:00 cvs-4 Exp $
%%
%% author: Andres Loeh (andres@cs.uu.nl)

> module GHIParseUtils (
>    tryToRun
>  ) where
> 
> import AbstractD
> import GHParseMonad
> -- import ImportUtils
> import ErrorUtils
> import FMap

Try to run a (foreign) parser. 

> tryToRun :: Range -> Lex a -> String -> Lex a
> tryToRun r p i = do let (Range_Range pos _) = r
>                     case run p i pos 0 [] of
>                       Fail err -> parseError $ "Interface file corrupted:\n" ++ err
>                       Return r -> return r
>
> {-
> mergeImport :: [ImportData] -> ImportData
> mergeImport = foldr (\(a1s,b1s,c1s,d1s) (a2s,b2s,c2s,d2s)
>                      -> (a1s ++ a2s, b1s ++ b2s, c1s ++ c2s, d1s ++ d2s)
>                     ) 
>                     ([],[],[],[])
> -}



