






















  module GHIParser_NG (parseImport,xImport) where
  
  import AbstractD 
  import AbstractPP
  import GHParseMonad
  import GHILexer
  import GHParser_NG
  import GHIParseUtils
  import Monad
  import Name
  import FileNameUtils
  -- import GlaExts



  parseImport                    :: Int             -- verbose?
                                 -> [String]        -- search path
                                 -> FilePath        -- filename
                                 -> IO (ImportedModule   -- the abstract representation
                                       ,[Modid]          -- modules we depend on
                                       )
  parseImport verbose p file_    = 
    do let file                  =  file_ ++ ".ghi"
           atVerbosity n s       =  if verbose >= n then putStr s 
                                                    else return ()
 
       x <- catch (      do (f,fn) <- chaseFile p file
                            atVerbosity 1 $ "Interface file " ++ fn ++ " read.\n"
                            return $ Just f
                  )
                  (\_ -> do atVerbosity 0 $ "Interface file " ++ file ++ " not found.\n"
                            return Nothing
                  )
       
       case x of
         Nothing -> return (ImportedModule_Empty,[])
         Just f  -> case run xImport f
                             (Position_Position file 1 1) 0 [] of
                      Fail err -> do atVerbosity 1 $ err ++ "\n"
                                     atVerbosity 1 $ "Interface file ignored.\n"
                                     return (ImportedModule_Empty,[])
                      Return r -> return r



  frown t                       =  
     parseError $ "syntax error: " ++ show t 
  
  

{-



-}



{- frown :-( -}

  data Stack__
      = Empty__
      | T_1__ State__ Stack__
      | T_2__ State__ Stack__ ImportData
      | T_3__ State__ Stack__ String
      | T_4__ State__ Stack__ String Range
      | T_5__ State__ Stack__ ((ImportData,Modid))
      | T_6__ State__ Stack__ ((ImportData,[Modid]))
      | T_7__ State__ Stack__ ((ImportedModule,[Modid]))
      | T_8__ State__ Stack__ (([ImportData],[Modid]))
      | T'_1__ Stack__
      | T'_2__ Stack__ ImportData
      | T'_3__ Stack__ String
      | T'_4__ Stack__ String Range
      | T'_5__ Stack__ ((ImportData,Modid))
      | T'_6__ Stack__ ((ImportData,[Modid]))
      | T'_7__ Stack__ ((ImportedModule,[Modid]))
      | T'_8__ Stack__ (([ImportData],[Modid]))
  
  data State__ = S_12__ | S_13__ | S_14__ | S_30__
  
  data Nonterminal__ = XImport__ ((ImportedModule,[Modid]))
  
  
  xImport = (get >>= (\ t'__ -> parse_1__ t'__ Empty__)) >>= (\ (XImport__ v1) -> return (v1))
  
  parse_1__ KW_Module st__ = get >>= (\ t'__ -> parse_4__ t'__ st__)
  parse_1__ t__ st__ = frown t__
  
  parse_2__ EOF st__ = get >>= (\ t'__ -> parse_3__ t'__ st__)
  parse_2__ t__ st__ = frown t__
  
  parse_3__ t__ st__ = reduce_1__ t__ st__
  
  parse_4__ (StringTok v1 v2) st__ = get >>= (\ t'__ -> parse_5__ t'__ (T'_4__ st__ v1 v2))
  parse_4__ t__ st__ = frown t__
  
  parse_5__ SemiColon st__ = get >>= (\ t'__ -> parse_6__ t'__ st__)
  parse_5__ t__ st__ = frown t__
  
  parse_6__ KW_ExportTp st__ = get >>= (\ t'__ -> parse_7__ t'__ st__)
  parse_6__ t__ st__ = frown t__
  
  parse_7__ (StringTok v1 v2) st__ = get >>= (\ t'__ -> parse_8__ t'__ (T'_4__ st__ v1 v2))
  parse_7__ t__ st__ = frown t__
  
  parse_8__ SemiColon st__ = get >>= (\ t'__ -> parse_9__ t'__ st__)
  parse_8__ t__ st__ = frown t__
  
  parse_9__ KW_ExportVal st__ = get >>= (\ t'__ -> parse_10__ t'__ st__)
  parse_9__ t__ st__ = frown t__
  
  parse_10__ (StringTok v1 v2) st__ = get >>= (\ t'__ -> parse_11__ t'__ (T'_4__ st__ v1 v2))
  parse_10__ t__ st__ = frown t__
  
  parse_11__ SemiColon st__ = get >>= (\ t'__ -> parse_12__ t'__ st__)
  parse_11__ t__ st__ = frown t__
  
  parse_12__ t__ st__ = reduce_4__ t__ S_12__ st__
  
  parse_13__ KW_Abstract st__ = get >>= (\ t'__ -> parse_34__ t'__ (T_1__ S_13__ st__))
  parse_13__ KW_Binding st__ = get >>= (\ t'__ -> parse_38__ t'__ (T_1__ S_13__ st__))
  parse_13__ KW_SetModule st__ = get >>= (\ t'__ -> parse_28__ t'__ (T_1__ S_13__ st__))
  parse_13__ KW_Import st__ = get >>= (\ t'__ -> parse_32__ t'__ (T_1__ S_13__ st__))
  parse_13__ KW_Decl st__ = get >>= (\ t'__ -> parse_40__ t'__ (T_1__ S_13__ st__))
  parse_13__ KW_Consig st__ = get >>= (\ t'__ -> parse_42__ t'__ (T_1__ S_13__ st__))
  parse_13__ t__@EOF st__ = reduce_2__ t__ st__
  parse_13__ t__ st__ = frown t__
  
  parse_14__ RightParen st__ = get >>= (\ t'__ -> parse_31__ t'__ (T_1__ S_14__ st__))
  parse_14__ KW_Abstract st__ = get >>= (\ t'__ -> parse_34__ t'__ (T_1__ S_14__ st__))
  parse_14__ KW_Binding st__ = get >>= (\ t'__ -> parse_38__ t'__ (T_1__ S_14__ st__))
  parse_14__ KW_SetModule st__ = get >>= (\ t'__ -> parse_28__ t'__ (T_1__ S_14__ st__))
  parse_14__ KW_Import st__ = get >>= (\ t'__ -> parse_32__ t'__ (T_1__ S_14__ st__))
  parse_14__ KW_Decl st__ = get >>= (\ t'__ -> parse_40__ t'__ (T_1__ S_14__ st__))
  parse_14__ KW_Consig st__ = get >>= (\ t'__ -> parse_42__ t'__ (T_1__ S_14__ st__))
  parse_14__ t__ st__ = frown t__
  
  parse_15__ t__ st__ = reduce_3__ t__ st__
  
  parse_16__ SemiColon st__ = get >>= (\ t'__ -> parse_17__ t'__ st__)
  parse_16__ t__ st__ = frown t__
  
  parse_17__ t__ st__ = reduce_5__ t__ st__
  
  parse_18__ SemiColon st__ = get >>= (\ t'__ -> parse_19__ t'__ st__)
  parse_18__ t__ st__ = frown t__
  
  parse_19__ t__ st__ = reduce_6__ t__ st__
  
  parse_20__ SemiColon st__ = get >>= (\ t'__ -> parse_21__ t'__ st__)
  parse_20__ t__ st__ = frown t__
  
  parse_21__ t__ st__ = reduce_7__ t__ st__
  
  parse_22__ SemiColon st__ = get >>= (\ t'__ -> parse_23__ t'__ st__)
  parse_22__ t__ st__ = frown t__
  
  parse_23__ t__ st__ = reduce_8__ t__ st__
  
  parse_24__ SemiColon st__ = get >>= (\ t'__ -> parse_25__ t'__ st__)
  parse_24__ t__ st__ = frown t__
  
  parse_25__ t__ st__ = reduce_9__ t__ st__
  
  parse_26__ SemiColon st__ = get >>= (\ t'__ -> parse_27__ t'__ st__)
  parse_26__ t__ st__ = frown t__
  
  parse_27__ t__ st__ = reduce_10__ t__ st__
  
  parse_28__ (StringTok v1 v2) st__ = get >>= (\ t'__ -> parse_29__ t'__ (T'_4__ st__ v1 v2))
  parse_28__ t__ st__ = frown t__
  
  parse_29__ LeftParen st__ = get >>= (\ t'__ -> parse_30__ t'__ st__)
  parse_29__ t__ st__ = frown t__
  
  parse_30__ t__ st__ = reduce_4__ t__ S_30__ st__
  
  parse_31__ t__ st__ = reduce_11__ t__ st__
  
  parse_32__ (StringTok v1 v2) st__ = get >>= (\ t'__ -> parse_33__ t'__ (T'_4__ st__ v1 v2))
  parse_32__ t__ st__ = frown t__
  
  parse_33__ t__ st__ = reduce_12__ t__ st__
  
  parse_34__ (StringTok v1 v2) st__ = get >>= (\ t'__ -> parse_35__ t'__ (T'_4__ st__ v1 v2))
  parse_34__ t__ st__ = frown t__
  
  parse_35__ (StringTok v1 v2) st__ = get >>= (\ t'__ -> parse_36__ t'__ (T'_4__ st__ v1 v2))
  parse_35__ t__ st__ = frown t__
  
  parse_36__ (StringTok v1 v2) st__ = get >>= (\ t'__ -> parse_37__ t'__ (T'_4__ st__ v1 v2))
  parse_36__ t__ st__ = frown t__
  
  parse_37__ t__ st__ = reduce_13__ t__ st__
  
  parse_38__ (StringTok v1 v2) st__ = get >>= (\ t'__ -> parse_39__ t'__ (T'_4__ st__ v1 v2))
  parse_38__ t__ st__ = frown t__
  
  parse_39__ t__ st__ = reduce_14__ t__ st__
  
  parse_40__ (StringTok v1 v2) st__ = get >>= (\ t'__ -> parse_41__ t'__ (T'_4__ st__ v1 v2))
  parse_40__ t__ st__ = frown t__
  
  parse_41__ t__ st__ = reduce_15__ t__ st__
  
  parse_42__ (StringTok v1 v2) st__ = get >>= (\ t'__ -> parse_43__ t'__ (T'_4__ st__ v1 v2))
  parse_42__ t__ st__ = frown t__
  
  parse_43__ (StringTok v1 v2) st__ = get >>= (\ t'__ -> parse_44__ t'__ (T'_4__ st__ v1 v2))
  parse_43__ t__ st__ = frown t__
  
  parse_44__ t__ st__ = reduce_16__ t__ st__
  
  reduce_1__ t__ (T'_7__ st__ v1) = return (XImport__ v1)
  
  reduce_2__ t__ (T_8__ _ (T'_4__ (T'_4__ (T'_4__ st__ modid _) exp_tp r1) exp_val r2) ((ids,ms)))
      = (tryToRun r1 xQnames exp_tp >>= \tps ->
              tryToRun r2 xQnames exp_val >>= \vals ->
              return $ (ImportedModule_Module modid tps vals (reverse $ ids),reverse ms))
            >>=
            (\ v1 -> parse_2__ t__ (T'_7__ st__ v1))
  
  reduce_3__ t__ (T_6__ _ (T_8__ s__ st__ ((xs,ms))) ((x,m)))
      = (return (x : xs,m ++ ms)) >>= (\ v1 -> goto_decls'1__ s__ t__ (T_8__ s__ st__ v1))
  
  reduce_4__ t__ s__ st__ = (return ([],[])) >>= (\ v1 -> goto_decls'1__ s__ t__ (T_8__ s__ st__ v1))
  
  reduce_5__ t__ (T_2__ s__ st__ a) = (return (a,[])) >>= (\ v1 -> goto_decl'1__ s__ t__ (T_6__ s__ st__ v1))
  
  reduce_6__ t__ (T_2__ s__ st__ b) = (return (b,[])) >>= (\ v1 -> goto_decl'1__ s__ t__ (T_6__ s__ st__ v1))
  
  reduce_7__ t__ (T_2__ s__ st__ d) = (return (d,[])) >>= (\ v1 -> goto_decl'1__ s__ t__ (T_6__ s__ st__ v1))
  
  reduce_8__ t__ (T_2__ s__ st__ c) = (return (c,[])) >>= (\ v1 -> goto_decl'1__ s__ t__ (T_6__ s__ st__ v1))
  
  reduce_9__ t__ (T_6__ s__ st__ m) = (return m) >>= (\ v1 -> goto_decl'1__ s__ t__ (T_6__ s__ st__ v1))
  
  reduce_10__ t__ (T_5__ s__ st__ ((i,m))) = (return (i,[m])) >>= (\ v1 -> goto_decl'1__ s__ t__ (T_6__ s__ st__ v1))
  
  reduce_11__ t__ (T_1__ _ (T_8__ _ (T'_4__ (T_1__ s__ st__) modid _) ((ds,m))))
      = (return (ImportData_SetModule modid ds,m)) >>= (\ v1 -> goto_setmod'1__ s__ t__ (T_6__ s__ st__ v1))
  
  reduce_12__ t__ (T'_4__ (T_1__ s__ st__) modid _)
      = (return (ImportData_Import modid,modid)) >>= (\ v1 -> goto_import'1__ s__ t__ (T_5__ s__ st__ v1))
  
  reduce_13__ t__ (T'_4__ (T'_4__ (T'_4__ (T_1__ s__ st__) name r1) conss r2) kind r3)
      = (tryToRun r1 xCon name >>= \n ->
               tryToRun r2 xQnames conss >>= \c ->
               tryToRun r3 xKind kind >>= \k ->
               return (ImportData_Abstract n c k))
            >>=
            (\ v1 -> goto_abstract'1__ s__ t__ (T_2__ s__ st__ v1))
  
  reduce_14__ t__ (T'_4__ (T_1__ s__ st__) name r)
      = (tryToRun r xVar name >>= \n ->
              return (ImportData_Binding n))
            >>=
            (\ v1 -> goto_binding'1__ s__ t__ (T_2__ s__ st__ v1))
  
  reduce_15__ t__ (T'_4__ (T_1__ s__ st__) decls r)
      = (tryToRun r xDecls decls >>= \ds ->
             return (ImportData_Decl ds))
            >>=
            (\ v1 -> goto_ghdecl'1__ s__ t__ (T_2__ s__ st__ v1))
  
  reduce_16__ t__ (T'_4__ (T'_4__ (T_1__ s__ st__) genfun r1) tps r2)
      = (tryToRun r1 xConVar genfun >>= \gf ->
             tryToRun r2 xQnames tps >>= \ts ->
             return (ImportData_Consig gf ts))
            >>=
            (\ v1 -> goto_consig'1__ s__ t__ (T_2__ s__ st__ v1))
  
  goto_decls'1__ S_12__ = parse_13__
  goto_decls'1__ S_30__ = parse_14__
  
  goto_decl'1__ S_13__ = parse_15__
  goto_decl'1__ S_14__ = parse_15__
  
  goto_setmod'1__ S_13__ = parse_24__
  goto_setmod'1__ S_14__ = parse_24__
  
  goto_import'1__ S_13__ = parse_26__
  goto_import'1__ S_14__ = parse_26__
  
  goto_abstract'1__ S_13__ = parse_16__
  goto_abstract'1__ S_14__ = parse_16__
  
  goto_binding'1__ S_13__ = parse_18__
  goto_binding'1__ S_14__ = parse_18__
  
  goto_ghdecl'1__ S_13__ = parse_20__
  goto_ghdecl'1__ S_14__ = parse_20__
  
  goto_consig'1__ S_13__ = parse_22__
  goto_consig'1__ S_14__ = parse_22__
  
  impossible__ t__ st__ = fail "The `impossible' happened."


{- )-: frown -}


