-- do not edit; automatically generated by UU_AG
module Specialise where

import Maybe

import Name
import KindUtils
import FMap
import ErrorUtils
import Utils

import AbstractD
import AbstractPP
import AbstractS

import qualified Type as T
import qualified TypeReduce as TR
import qualified TypeReplace as TRR
import TiTypes
import qualified StructureTypes as ST

specialise                     :: QualName      -- name of generic function
                               -> StrTypeDecl   -- structure type
                               -> KSubst        -- kinds
                               -> FMap QualName PKType -- polykinded types
                               -> FMap QualName QualNames -- dependencies
                               -> PTS           -- sig of generic function
                               -> [TypedBinding]
specialise n 
           (StrTypeDecl_Decl tp a str)
           kinds
           pkts
           deps
           pts                 =
    let k           = applyFMM kinds (const $ internalError "Specialise.specialise: no kind") tp
        (ctx,pkt)   = TRR.liftPKT pts pkts

        PTS_PTS _ kr _  = pts
        restricted  = isRestricted kr
        
        strspecname = specName n (strName tp)
        strspectype = handleTiTypes deps
                    $ T.makeRank2Type
                    $ TR.reduce (pkt k) [qconT $ strName tp]

        dgfs        = maybe [n] id (find deps n)
        strspeclhs' = map prefixName
                      $ concatMap (\ x -> map ( \ f -> specName f x ) dgfs ) a
        strspeclhs  = map Pattern_Var strspeclhs'
        strspecrhs  = Rhs_Unguarded $ specialiseStrType deps str n

        orispecname = specName n tp
        orispectype = handleTiTypes deps
                    $ T.makeRank2Type
                    $ TR.reduce (pkt k) [qconT tp]

        orispeclhs  = strspeclhs
        orispecrhs' = Expr_Parens $ specialiseBimap pkt tp
        orispecrhs  = Rhs_Unguarded
                      $ apply' (Expr_Var genloc eptoName)
                               ([ orispecrhs'
                                , Expr_Parens $ apply' (qvarE strspecname)
                                                       (map qvarE strspeclhs')
                                ]
                               )

        strspecbind = TypedBinding_TypedBinding strspecname
                                                ctx
                                                strspectype
                                                [Binding_Binding strspeclhs
                                                                 strspecrhs
                                                                 []
                                                ]
        orispecbind = TypedBinding_TypedBinding orispecname
                                                ctx
                                                orispectype
                                                [Binding_Binding orispeclhs
                                                                 orispecrhs
                                                                 []
                                                ]
    in  if restricted then [] else [strspecbind,orispecbind]

specialise_component           :: QualName      -- name of generic function
                               -> QualName      -- name of type
                               -> KSubst        -- kinds
                               -> FMap QualName PKType -- kind-indexed types
                               -> FMap QualName QualNames -- dependencies
                               -> PTS           -- sig of generic function
                               -> [TypedBinding]
specialise_component n tp kinds pkts deps pts =
    
    let k           = applyFMM kinds (const $ internalError "Specialise.specialise_component: no kind") tp
        (ctx,pkt)   = TRR.liftPKT pts pkts

        specname    = specName n tp
        spectype'   = handleTiTypes deps
                    $ T.makeRank2Type
                    $ TR.reduce (pkt k) [qconT tp]

        {- this is a dirty hack, as it is elsewhere in the program;
           would be nice to find a common solution for this 
           everywhere ... 
        -}
        prefixes    = [ (conName  , arr (qconT condescrName  ))
                      , (labelName, arr (qconT labeldescrName))
                      ]
        spectype    = maybe id id (lookup tp prefixes) spectype'

        {- to allow polymorphic arguments, we have to eta-expand our component
           specialisation; therefore we count the number of arguments of the
           type
        -}
 
        args        = take (T.args spectype) prefixedVarNames

        specrhs     = Rhs_Unguarded $ apply' (qvarE (componentName n tp)) (map qvarE args)

        specbind    = TypedBinding_TypedBinding 
                          specname
                          ctx
                          spectype
                          [Binding_Binding (map Pattern_Var args) specrhs []]
    in  [specbind]

specialiseStrType              :: FMap QualName QualNames -> StrType -> QualName -> Expr
specialiseStrType deps str n   =  (fst $ (sem_SStrType . SStrType_Id $ str) deps) n

specialiseType                 :: FMap QualName QualNames -> Type -> QualName -> Expr
specialiseType deps tp n       =  (fst $ (sem_S_Type . S_Type_Id $ tp) 
                                         (deps,False,emptyFM)
                                  ) n

specialiseBimap                :: PKType -> QualName -> Expr
specialiseBimap pkt t          =  (fst $ (sem_S_Type . S_Type_Id $ tp) 
                                         (emptyFM,True,subst)
                                  ) n
  where subst = fromList [(impossibleName,t)] {- was strName t ... -}
        n     = bimapName
        tp    = T.makeRank2Type
              $ TR.reduce (pkt Kind_Star) [qconT $ impossibleName] {- was strName t ... -}


specargs                       :: QualName           {- constructor name -}
                               -> FMap QualName QualNames {- dependencies -}
                               -> [Expr]             {- descriptors, if any -}
                               -> [QualName -> Expr] {- argument specialisations -}
                               -> QualName           {- generic function name -}
                               -> Expr               {- result -}

specargs cn deps ds chldrn gf =  
           let dgfs' = find deps gf
               dgfs  = maybe [gf] id dgfs'
           in  apply' (qvarE (specName gf cn))
                      (ds ++ 
                       map Expr_Parens
                         (concatMap (\f -> map f dgfs) chldrn)
                      )



specialise_t                   :: QualName          -- name of type-indexed type
                               -> StrTypeDecl   -- structure type
                         --    -> KSubst        -- kinds
                         --    -> FMap QualName PKType -- polykinded types
                               -> TDecl         -- unit declaration
                               -> FMap QualName QualNames -- deps
                               -> ([TDecl],[TypedBinding])
specialise_t n 
             (StrTypeDecl_Decl tp a str)
             (TDecl_TiType _ _ _ ea _)
             deps
                               =
    let strspecname = specTITName n (strTITName tp)

        dgfs        = maybe [n] id (find deps n)
        strspeclhs  = map prefixName
                      $ concatMap (\ x -> map ( \ f -> specTITName f x ) dgfs ) a
        strspecrhs  = specialiseStrType_t deps str n

        orispecname = specTITName n tp

        orispeclhs  = strspeclhs ++ ea  {- name clashes possible! -}
        orispecrhs  = Constr_Constr orispecname
                                    [LabelType_Type False
                                         (tapply' (qconT strspecname)
                                                  (map (Type_Var genloc) orispeclhs)
                                         )
                                    ]

        epbind      = ST.mkEP orispecname strspecname Context_Empty orispeclhs
                              [from] [to]

        from        = let l = [ Pattern_Parens 
                              $ Pattern_Con orispecname [Pattern_Var v]
                              ]
                          r = Rhs_Unguarded . qvarE $ v
                          v = prefixName $ head varNames
                      in  Binding_Binding l r []
        to          = let l = [Pattern_Var v]
                          r = Rhs_Unguarded $ apply' (Expr_Con genloc orispecname) 
                                                     [qvarE v]
                          v = prefixName $ head varNames
                      in  Binding_Binding l r []

        strspecbind = TDecl_Type genloc
                                 strspecname
                                 strspeclhs
                                 strspecrhs

        orispecbind = TDecl_New  genloc
                                 Context_Empty
                                 orispecname
                                 orispeclhs
                                 orispecrhs
                                 []
                                 
    in  ([strspecbind,orispecbind],[epbind])

specialise_component_t         :: QualName      -- name of type-indexed type
                               -> QualName      -- name of type
                               -> ([TDecl],[TypedBinding])
specialise_component_t n tp =

   let specname     = specTITName n tp
       specrhs      = qconT (componentTITName n tp)
       specbind     = TDecl_Type genloc
                                 specname
                                 []
                                 specrhs
   in  ([specbind],[])



specargs_t                     :: QualName           {- constructor name -}
                               -> FMap QualName QualNames {- dependencies -}
                               -> [QualName -> Type] {- argument specialisations -}
                               -> QualName           {- type-indexed type name -}
                               -> Type               {- result -}

specargs_t cn deps chldrn gf =  
           let dgfs' = find deps gf
               dgfs  = maybe [gf] id dgfs'
           in  tapply' (qconT (specTITName gf cn))
                       (concatMap (\f -> map f dgfs) chldrn)



specialiseStrType_t            :: FMap QualName QualNames -> StrType -> QualName -> Type
specialiseStrType_t deps str n =  (snd $ (sem_SStrType . SStrType_Id $ str) deps) n

specialiseType_t               :: FMap QualName QualNames -> Type -> QualName -> Type
specialiseType_t deps tp n     =  (snd $ (sem_S_Type . S_Type_Id $ tp) 
                                         (deps,False,emptyFM)
                                  ) n

lambdaSpecialisationError      :: a
lambdaSpecialisationError      =
  internalError "Specialise: specialisation called on type with lambda"

allSpecialisationError         :: a
allSpecialisationError         =
  internalError "Specialise: specialisation called on type with forall"

kindAppSpecialisationError     :: a
kindAppSpecialisationError     =
  internalError "Specialise: specialisation called on type with kind application"


{- Hack for type-indexed types; do this correctly sometime !! -}

mkString (Type_Con _ x)        =  x
mkString (Type_Var _ x)        =  x
mkString _                     =  internalError "Specialise.mkString: seems strange"


qvarE :: QualName -> Expr
qvarE =  Expr_Var genloc

qconT :: QualName -> Type
qconT =  Type_Con genloc
-- Alt ---------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Alt

-}
{-
   local variables for Alt.Alt:

-}
{-
   local variables for Alt.Empty:

-}
-- semantic domain
type T_Alt = ((Alt))
-- cata
sem_Alt :: (Alt) ->
           (T_Alt)
sem_Alt ((Alt_Alt (_pattern) (_cs) (_where))) =
    (sem_Alt_Alt ((sem_Pattern (_pattern))) ((sem_Case (_cs))) ((sem_SDecls (_where))))
sem_Alt ((Alt_Empty )) =
    (sem_Alt_Empty )
sem_Alt_Alt :: (T_Pattern) ->
               (T_Case) ->
               (T_SDecls) ->
               (T_Alt)
sem_Alt_Alt (_pattern) (_cs) (_where) =
    let ( _pattern_self) =
            (_pattern )
        ( _cs_self) =
            (_cs )
        ( _where_self) =
            (_where )
    in  (Alt_Alt _pattern_self _cs_self _where_self)
sem_Alt_Empty :: (T_Alt)
sem_Alt_Empty  =
    let 
    in  (Alt_Empty)
-- Alts --------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Alts

-}
{-
   local variables for Alts.Cons:

-}
{-
   local variables for Alts.Nil:

-}
-- semantic domain
type T_Alts = ((Alts))
-- cata
sem_Alts :: (Alts) ->
            (T_Alts)
sem_Alts (list) =
    (foldr (sem_Alts_Cons) (sem_Alts_Nil) ((map sem_Alt list)))
sem_Alts_Cons :: (T_Alt) ->
                 (T_Alts) ->
                 (T_Alts)
sem_Alts_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_Alts_Nil :: (T_Alts)
sem_Alts_Nil  =
    let 
    in  ([])
-- Args --------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Args

-}
{-
   local variables for Args.Cons:

-}
{-
   local variables for Args.Nil:

-}
-- semantic domain
type T_Args = ((Args))
-- cata
sem_Args :: (Args) ->
            (T_Args)
sem_Args (list) =
    (foldr (sem_Args_Cons) (sem_Args_Nil) ((map sem_QualName list)))
sem_Args_Cons :: (T_QualName) ->
                 (T_Args) ->
                 (T_Args)
sem_Args_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_Args_Nil :: (T_Args)
sem_Args_Nil  =
    let 
    in  ([])
-- Binding -----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Binding

-}
{-
   local variables for Binding.Binding:

-}
-- semantic domain
type T_Binding = ((Binding))
-- cata
sem_Binding :: (Binding) ->
               (T_Binding)
sem_Binding ((Binding_Binding (_lh) (_rh) (_where))) =
    (sem_Binding_Binding ((sem_Patterns (_lh))) ((sem_Rhs (_rh))) ((sem_SDecls (_where))))
sem_Binding_Binding :: (T_Patterns) ->
                       (T_Rhs) ->
                       (T_SDecls) ->
                       (T_Binding)
sem_Binding_Binding (_lh) (_rh) (_where) =
    let ( _lh_self) =
            (_lh )
        ( _rh_self) =
            (_rh )
        ( _where_self) =
            (_where )
    in  (Binding_Binding _lh_self _rh_self
                         _where_self
        )
-- Bindings ----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Bindings

-}
{-
   local variables for Bindings.Cons:

-}
{-
   local variables for Bindings.Nil:

-}
-- semantic domain
type T_Bindings = ((Bindings))
-- cata
sem_Bindings :: (Bindings) ->
                (T_Bindings)
sem_Bindings (list) =
    (foldr (sem_Bindings_Cons) (sem_Bindings_Nil) ((map sem_Binding list)))
sem_Bindings_Cons :: (T_Binding) ->
                     (T_Bindings) ->
                     (T_Bindings)
sem_Bindings_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_Bindings_Nil :: (T_Bindings)
sem_Bindings_Nil  =
    let 
    in  ([])
-- Body --------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Body

-}
{-
   local variables for Body.Body:

-}
-- semantic domain
type T_Body = ((Body))
-- cata
sem_Body :: (Body) ->
            (T_Body)
sem_Body ((Body_Body (_impdecls) (_decls))) =
    (sem_Body_Body ((sem_Impdecls (_impdecls))) ((sem_Decls (_decls))))
sem_Body_Body :: (T_Impdecls) ->
                 (T_Decls) ->
                 (T_Body)
sem_Body_Body (_impdecls) (_decls) =
    let ( _impdecls_self) =
            (_impdecls )
        ( _decls_self) =
            (_decls )
    in  (Body_Body _impdecls_self _decls_self)
-- Case --------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Case

-}
{-
   local variables for Case.Guarded:

-}
{-
   local variables for Case.Unguarded:

-}
-- semantic domain
type T_Case = ((Case))
-- cata
sem_Case :: (Case) ->
            (T_Case)
sem_Case ((Case_Guarded (_grds))) =
    (sem_Case_Guarded ((sem_GuardedAlts (_grds))))
sem_Case ((Case_Unguarded (_expr))) =
    (sem_Case_Unguarded ((sem_Expr (_expr))))
sem_Case_Guarded :: (T_GuardedAlts) ->
                    (T_Case)
sem_Case_Guarded (_grds) =
    let ( _grds_self) =
            (_grds )
    in  (Case_Guarded _grds_self)
sem_Case_Unguarded :: (T_Expr) ->
                      (T_Case)
sem_Case_Unguarded (_expr) =
    let ( _expr_self) =
            (_expr )
    in  (Case_Unguarded _expr_self)
-- Class -------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Class

-}
{-
   local variables for Class.Class:

-}
-- semantic domain
type T_Class = ((Class))
-- cata
sem_Class :: (Class) ->
             (T_Class)
sem_Class ((Class_Class (_name) (_tps))) =
    (sem_Class_Class ((sem_QualName (_name))) ((sem_Types (_tps))))
sem_Class_Class :: (T_QualName) ->
                   (T_Types) ->
                   (T_Class)
sem_Class_Class (_name) (_tps) =
    let ( _name_self) =
            (_name )
        ( _tps_self) =
            (_tps )
    in  (Class_Class _name_self _tps_self)
-- Classes -----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Classes

-}
{-
   local variables for Classes.Cons:

-}
{-
   local variables for Classes.Nil:

-}
-- semantic domain
type T_Classes = ((Classes))
-- cata
sem_Classes :: (Classes) ->
               (T_Classes)
sem_Classes (list) =
    (foldr (sem_Classes_Cons) (sem_Classes_Nil) ((map sem_Class list)))
sem_Classes_Cons :: (T_Class) ->
                    (T_Classes) ->
                    (T_Classes)
sem_Classes_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_Classes_Nil :: (T_Classes)
sem_Classes_Nil  =
    let 
    in  ([])
-- Constr ------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Constr

-}
{-
   local variables for Constr.Constr:

-}
-- semantic domain
type T_Constr = ((Constr))
-- cata
sem_Constr :: (Constr) ->
              (T_Constr)
sem_Constr ((Constr_Constr (_name) (_types))) =
    (sem_Constr_Constr ((sem_QualName (_name))) ((sem_LabelTypes (_types))))
sem_Constr_Constr :: (T_QualName) ->
                     (T_LabelTypes) ->
                     (T_Constr)
sem_Constr_Constr (_name) (_types) =
    let ( _name_self) =
            (_name )
        ( _types_self) =
            (_types )
    in  (Constr_Constr _name_self _types_self)
-- Constrs -----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Constrs

-}
{-
   local variables for Constrs.Cons:

-}
{-
   local variables for Constrs.Nil:

-}
-- semantic domain
type T_Constrs = ((Constrs))
-- cata
sem_Constrs :: (Constrs) ->
               (T_Constrs)
sem_Constrs (list) =
    (foldr (sem_Constrs_Cons) (sem_Constrs_Nil) ((map sem_Constr list)))
sem_Constrs_Cons :: (T_Constr) ->
                    (T_Constrs) ->
                    (T_Constrs)
sem_Constrs_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_Constrs_Nil :: (T_Constrs)
sem_Constrs_Nil  =
    let 
    in  ([])
-- Context -----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Context

-}
{-
   local variables for Context.Context:

-}
{-
   local variables for Context.Empty:

-}
-- semantic domain
type T_Context = ((Context))
-- cata
sem_Context :: (Context) ->
               (T_Context)
sem_Context ((Context_Context (_classes))) =
    (sem_Context_Context ((sem_Classes (_classes))))
sem_Context ((Context_Empty )) =
    (sem_Context_Empty )
sem_Context_Context :: (T_Classes) ->
                       (T_Context)
sem_Context_Context (_classes) =
    let ( _classes_self) =
            (_classes )
    in  (Context_Context _classes_self)
sem_Context_Empty :: (T_Context)
sem_Context_Empty  =
    let 
    in  (Context_Empty)
-- Decl --------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Decl

-}
{-
   local variables for Decl.Simple:

-}
{-
   local variables for Decl.Top:

-}
-- semantic domain
type T_Decl = ((Decl))
-- cata
sem_Decl :: (Decl) ->
            (T_Decl)
sem_Decl ((Decl_Simple (_decl))) =
    (sem_Decl_Simple ((sem_SDecl (_decl))))
sem_Decl ((Decl_Top (_decl))) =
    (sem_Decl_Top ((sem_TDecl (_decl))))
sem_Decl_Simple :: (T_SDecl) ->
                   (T_Decl)
sem_Decl_Simple (_decl) =
    let ( _decl_self) =
            (_decl )
    in  (Decl_Simple _decl_self)
sem_Decl_Top :: (T_TDecl) ->
                (T_Decl)
sem_Decl_Top (_decl) =
    let ( _decl_self) =
            (_decl )
    in  (Decl_Top _decl_self)
-- Decls -------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Decls

-}
{-
   local variables for Decls.Cons:

-}
{-
   local variables for Decls.Nil:

-}
-- semantic domain
type T_Decls = ((Decls))
-- cata
sem_Decls :: (Decls) ->
             (T_Decls)
sem_Decls (list) =
    (foldr (sem_Decls_Cons) (sem_Decls_Nil) ((map sem_Decl list)))
sem_Decls_Cons :: (T_Decl) ->
                  (T_Decls) ->
                  (T_Decls)
sem_Decls_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_Decls_Nil :: (T_Decls)
sem_Decls_Nil  =
    let 
    in  ([])
-- Derivings ---------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Derivings

-}
{-
   local variables for Derivings.Cons:

-}
{-
   local variables for Derivings.Nil:

-}
-- semantic domain
type T_Derivings = ((Derivings))
-- cata
sem_Derivings :: (Derivings) ->
                 (T_Derivings)
sem_Derivings (list) =
    (foldr (sem_Derivings_Cons) (sem_Derivings_Nil) ((map sem_QualName list)))
sem_Derivings_Cons :: (T_QualName) ->
                      (T_Derivings) ->
                      (T_Derivings)
sem_Derivings_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_Derivings_Nil :: (T_Derivings)
sem_Derivings_Nil  =
    let 
    in  ([])
-- Entities ----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Entities

-}
{-
   local variables for Entities.Cons:

-}
{-
   local variables for Entities.Nil:

-}
-- semantic domain
type T_Entities = ((Entities))
-- cata
sem_Entities :: (Entities) ->
                (T_Entities)
sem_Entities (list) =
    (foldr (sem_Entities_Cons) (sem_Entities_Nil) ((map sem_Entity list)))
sem_Entities_Cons :: (T_Entity) ->
                     (T_Entities) ->
                     (T_Entities)
sem_Entities_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_Entities_Nil :: (T_Entities)
sem_Entities_Nil  =
    let 
    in  ([])
-- Entity ------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Entity

-}
{-
   local variables for Entity.Entity:
      self

-}
-- semantic domain
type T_Entity = ((Entity))
-- cata
sem_Entity :: (Entity) ->
              (T_Entity)
sem_Entity ((Entity_Entity (_modid) (_name))) =
    (sem_Entity_Entity (_modid) ((sem_Name (_name))))
sem_Entity_Entity :: (Maybe Modid) ->
                     (T_Name) ->
                     (T_Entity)
sem_Entity_Entity (_modid) (_name) =
    let (_self) =
            Entity_Entity _modid _name_self
        ( _name_self) =
            (_name )
    in  (_self)
-- Export ------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Export

-}
{-
   local variables for Export.Abstract:

-}
{-
   local variables for Export.Module:

-}
{-
   local variables for Export.TypeAll:

-}
{-
   local variables for Export.TypeSome:

-}
{-
   local variables for Export.Var:

-}
-- semantic domain
type T_Export = ((Export))
-- cata
sem_Export :: (Export) ->
              (T_Export)
sem_Export ((Export_Abstract (_name))) =
    (sem_Export_Abstract ((sem_QualName (_name))))
sem_Export ((Export_Module (_modid))) =
    (sem_Export_Module (_modid))
sem_Export ((Export_TypeAll (_name))) =
    (sem_Export_TypeAll ((sem_QualName (_name))))
sem_Export ((Export_TypeSome (_name) (_conss))) =
    (sem_Export_TypeSome ((sem_QualName (_name))) ((sem_QualNames (_conss))))
sem_Export ((Export_Var (_name))) =
    (sem_Export_Var ((sem_QualName (_name))))
sem_Export_Abstract :: (T_QualName) ->
                       (T_Export)
sem_Export_Abstract (_name) =
    let ( _name_self) =
            (_name )
    in  (Export_Abstract _name_self)
sem_Export_Module :: (Modid) ->
                     (T_Export)
sem_Export_Module (_modid) =
    let 
    in  (Export_Module   _modid)
sem_Export_TypeAll :: (T_QualName) ->
                      (T_Export)
sem_Export_TypeAll (_name) =
    let ( _name_self) =
            (_name )
    in  (Export_TypeAll  _name_self)
sem_Export_TypeSome :: (T_QualName) ->
                       (T_QualNames) ->
                       (T_Export)
sem_Export_TypeSome (_name) (_conss) =
    let ( _name_self) =
            (_name )
        ( _conss_self) =
            (_conss )
    in  (Export_TypeSome _name_self _conss_self)
sem_Export_Var :: (T_QualName) ->
                  (T_Export)
sem_Export_Var (_name) =
    let ( _name_self) =
            (_name )
    in  (Export_Var      _name_self)
-- Exported ----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Exported

-}
{-
   local variables for Exported.Exports:

-}
{-
   local variables for Exported.NoExports:

-}
-- semantic domain
type T_Exported = ((Exported))
-- cata
sem_Exported :: (Exported) ->
                (T_Exported)
sem_Exported ((Exported_Exports (_exports))) =
    (sem_Exported_Exports ((sem_Exports (_exports))))
sem_Exported ((Exported_NoExports )) =
    (sem_Exported_NoExports )
sem_Exported_Exports :: (T_Exports) ->
                        (T_Exported)
sem_Exported_Exports (_exports) =
    let ( _exports_self) =
            (_exports )
    in  (Exported_Exports _exports_self)
sem_Exported_NoExports :: (T_Exported)
sem_Exported_NoExports  =
    let 
    in  (Exported_NoExports)
-- Exports -----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Exports

-}
{-
   local variables for Exports.Cons:

-}
{-
   local variables for Exports.Nil:

-}
-- semantic domain
type T_Exports = ((Exports))
-- cata
sem_Exports :: (Exports) ->
               (T_Exports)
sem_Exports (list) =
    (foldr (sem_Exports_Cons) (sem_Exports_Nil) ((map sem_Export list)))
sem_Exports_Cons :: (T_Export) ->
                    (T_Exports) ->
                    (T_Exports)
sem_Exports_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_Exports_Nil :: (T_Exports)
sem_Exports_Nil  =
    let 
    in  ([])
-- Expr --------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Expr

-}
{-
   local variables for Expr.App:
      self

-}
{-
   local variables for Expr.As:
      self

-}
{-
   local variables for Expr.Case:
      self

-}
{-
   local variables for Expr.Compr:
      self

-}
{-
   local variables for Expr.Con:
      self

-}
{-
   local variables for Expr.Do:
      self

-}
{-
   local variables for Expr.EnumFrom:
      self

-}
{-
   local variables for Expr.EnumFromThen:
      self

-}
{-
   local variables for Expr.EnumFromThenTo:
      self

-}
{-
   local variables for Expr.EnumFromTo:
      self

-}
{-
   local variables for Expr.If:
      self

-}
{-
   local variables for Expr.Irr:
      self

-}
{-
   local variables for Expr.LabCon:
      self

-}
{-
   local variables for Expr.LabUp:
      self

-}
{-
   local variables for Expr.Lam:
      self

-}
{-
   local variables for Expr.LeftSection:
      self

-}
{-
   local variables for Expr.Let:
      self

-}
{-
   local variables for Expr.List:
      self

-}
{-
   local variables for Expr.Lit:
      self

-}
{-
   local variables for Expr.Negate:
      self

-}
{-
   local variables for Expr.OpApp:
      self

-}
{-
   local variables for Expr.Parens:
      self

-}
{-
   local variables for Expr.RightSection:
      self

-}
{-
   local variables for Expr.Tuple:
      self

-}
{-
   local variables for Expr.TyApp:
      self

-}
{-
   local variables for Expr.TypeSig:
      self

-}
{-
   local variables for Expr.Var:
      self

-}
{-
   local variables for Expr.Wild:
      self

-}
-- semantic domain
type T_Expr = ((Expr))
-- cata
sem_Expr :: (Expr) ->
            (T_Expr)
sem_Expr ((Expr_App (_left) (_right))) =
    (sem_Expr_App ((sem_Expr (_left))) ((sem_Expr (_right))))
sem_Expr ((Expr_As (_name) (_expr))) =
    (sem_Expr_As ((sem_QualName (_name))) ((sem_Expr (_expr))))
sem_Expr ((Expr_Case (_expr) (_alts))) =
    (sem_Expr_Case ((sem_Expr (_expr))) ((sem_Alts (_alts))))
sem_Expr ((Expr_Compr (_body) (_quals))) =
    (sem_Expr_Compr ((sem_Expr (_body))) ((sem_Quals (_quals))))
sem_Expr ((Expr_Con (_srcloc) (_name))) =
    (sem_Expr_Con ((sem_Position (_srcloc))) ((sem_QualName (_name))))
sem_Expr ((Expr_Do (_stmts))) =
    (sem_Expr_Do ((sem_Stmts (_stmts))))
sem_Expr ((Expr_EnumFrom (_from))) =
    (sem_Expr_EnumFrom ((sem_Expr (_from))))
sem_Expr ((Expr_EnumFromThen (_from) (_then))) =
    (sem_Expr_EnumFromThen ((sem_Expr (_from))) ((sem_Expr (_then))))
sem_Expr ((Expr_EnumFromThenTo (_from) (_then) (_to))) =
    (sem_Expr_EnumFromThenTo ((sem_Expr (_from))) ((sem_Expr (_then))) ((sem_Expr (_to))))
sem_Expr ((Expr_EnumFromTo (_from) (_to))) =
    (sem_Expr_EnumFromTo ((sem_Expr (_from))) ((sem_Expr (_to))))
sem_Expr ((Expr_If (_cond) (_thenp) (_elsep))) =
    (sem_Expr_If ((sem_Expr (_cond))) ((sem_Expr (_thenp))) ((sem_Expr (_elsep))))
sem_Expr ((Expr_Irr (_expr))) =
    (sem_Expr_Irr ((sem_Expr (_expr))))
sem_Expr ((Expr_LabCon (_con) (_fbinds))) =
    (sem_Expr_LabCon ((sem_QualName (_con))) ((sem_FBinds (_fbinds))))
sem_Expr ((Expr_LabUp (_body) (_fbinds))) =
    (sem_Expr_LabUp ((sem_Expr (_body))) ((sem_FBinds (_fbinds))))
sem_Expr ((Expr_Lam (_from) (_body))) =
    (sem_Expr_Lam ((sem_Patterns (_from))) ((sem_Expr (_body))))
sem_Expr ((Expr_LeftSection (_op) (_left))) =
    (sem_Expr_LeftSection ((sem_QualName (_op))) ((sem_Expr (_left))))
sem_Expr ((Expr_Let (_decls) (_body))) =
    (sem_Expr_Let ((sem_SDecls (_decls))) ((sem_Expr (_body))))
sem_Expr ((Expr_List (_exprs))) =
    (sem_Expr_List ((sem_Exprs (_exprs))))
sem_Expr ((Expr_Lit (_name))) =
    (sem_Expr_Lit ((sem_Literal (_name))))
sem_Expr ((Expr_Negate (_expr))) =
    (sem_Expr_Negate ((sem_Expr (_expr))))
sem_Expr ((Expr_OpApp (_op) (_left) (_right))) =
    (sem_Expr_OpApp ((sem_QualName (_op))) ((sem_Expr (_left))) ((sem_Expr (_right))))
sem_Expr ((Expr_Parens (_body))) =
    (sem_Expr_Parens ((sem_Expr (_body))))
sem_Expr ((Expr_RightSection (_op) (_right))) =
    (sem_Expr_RightSection ((sem_QualName (_op))) ((sem_Expr (_right))))
sem_Expr ((Expr_Tuple (_exprs))) =
    (sem_Expr_Tuple ((sem_Exprs (_exprs))))
sem_Expr ((Expr_TyApp (_srcloc) (_expr) (_tp))) =
    (sem_Expr_TyApp ((sem_Position (_srcloc))) ((sem_QualName (_expr))) ((sem_Type (_tp))))
sem_Expr ((Expr_TypeSig (_body) (_tp))) =
    (sem_Expr_TypeSig ((sem_Expr (_body))) ((sem_QualType (_tp))))
sem_Expr ((Expr_Var (_srcloc) (_name))) =
    (sem_Expr_Var ((sem_Position (_srcloc))) ((sem_QualName (_name))))
sem_Expr ((Expr_Wild )) =
    (sem_Expr_Wild )
sem_Expr_App :: (T_Expr) ->
                (T_Expr) ->
                (T_Expr)
sem_Expr_App (_left) (_right) =
    let (_self) =
            Expr_App _left_self _right_self
        ( _left_self) =
            (_left )
        ( _right_self) =
            (_right )
    in  (_self)
sem_Expr_As :: (T_QualName) ->
               (T_Expr) ->
               (T_Expr)
sem_Expr_As (_name) (_expr) =
    let (_self) =
            Expr_As _name_self _expr_self
        ( _name_self) =
            (_name )
        ( _expr_self) =
            (_expr )
    in  (_self)
sem_Expr_Case :: (T_Expr) ->
                 (T_Alts) ->
                 (T_Expr)
sem_Expr_Case (_expr) (_alts) =
    let (_self) =
            Expr_Case _expr_self _alts_self
        ( _expr_self) =
            (_expr )
        ( _alts_self) =
            (_alts )
    in  (_self)
sem_Expr_Compr :: (T_Expr) ->
                  (T_Quals) ->
                  (T_Expr)
sem_Expr_Compr (_body) (_quals) =
    let (_self) =
            Expr_Compr _body_self _quals_self
        ( _body_self) =
            (_body )
        ( _quals_self) =
            (_quals )
    in  (_self)
sem_Expr_Con :: (T_Position) ->
                (T_QualName) ->
                (T_Expr)
sem_Expr_Con (_srcloc) (_name) =
    let (_self) =
            Expr_Con _srcloc_self _name_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_self) =
            (_name )
    in  (_self)
sem_Expr_Do :: (T_Stmts) ->
               (T_Expr)
sem_Expr_Do (_stmts) =
    let (_self) =
            Expr_Do _stmts_self
        ( _stmts_self) =
            (_stmts )
    in  (_self)
sem_Expr_EnumFrom :: (T_Expr) ->
                     (T_Expr)
sem_Expr_EnumFrom (_from) =
    let (_self) =
            Expr_EnumFrom _from_self
        ( _from_self) =
            (_from )
    in  (_self)
sem_Expr_EnumFromThen :: (T_Expr) ->
                         (T_Expr) ->
                         (T_Expr)
sem_Expr_EnumFromThen (_from) (_then) =
    let (_self) =
            Expr_EnumFromThen _from_self _then_self
        ( _from_self) =
            (_from )
        ( _then_self) =
            (_then )
    in  (_self)
sem_Expr_EnumFromThenTo :: (T_Expr) ->
                           (T_Expr) ->
                           (T_Expr) ->
                           (T_Expr)
sem_Expr_EnumFromThenTo (_from) (_then) (_to) =
    let (_self) =
            Expr_EnumFromThenTo
              _from_self _then_self _to_self
        ( _from_self) =
            (_from )
        ( _then_self) =
            (_then )
        ( _to_self) =
            (_to )
    in  (_self)
sem_Expr_EnumFromTo :: (T_Expr) ->
                       (T_Expr) ->
                       (T_Expr)
sem_Expr_EnumFromTo (_from) (_to) =
    let (_self) =
            Expr_EnumFromTo _from_self _to_self
        ( _from_self) =
            (_from )
        ( _to_self) =
            (_to )
    in  (_self)
sem_Expr_If :: (T_Expr) ->
               (T_Expr) ->
               (T_Expr) ->
               (T_Expr)
sem_Expr_If (_cond) (_thenp) (_elsep) =
    let (_self) =
            Expr_If _cond_self _thenp_self _elsep_self
        ( _cond_self) =
            (_cond )
        ( _thenp_self) =
            (_thenp )
        ( _elsep_self) =
            (_elsep )
    in  (_self)
sem_Expr_Irr :: (T_Expr) ->
                (T_Expr)
sem_Expr_Irr (_expr) =
    let (_self) =
            Expr_Irr _expr_self
        ( _expr_self) =
            (_expr )
    in  (_self)
sem_Expr_LabCon :: (T_QualName) ->
                   (T_FBinds) ->
                   (T_Expr)
sem_Expr_LabCon (_con) (_fbinds) =
    let (_self) =
            Expr_LabCon _con_self _fbinds_self
        ( _con_self) =
            (_con )
        ( _fbinds_self) =
            (_fbinds )
    in  (_self)
sem_Expr_LabUp :: (T_Expr) ->
                  (T_FBinds) ->
                  (T_Expr)
sem_Expr_LabUp (_body) (_fbinds) =
    let (_self) =
            Expr_LabUp _body_self _fbinds_self
        ( _body_self) =
            (_body )
        ( _fbinds_self) =
            (_fbinds )
    in  (_self)
sem_Expr_Lam :: (T_Patterns) ->
                (T_Expr) ->
                (T_Expr)
sem_Expr_Lam (_from) (_body) =
    let (_self) =
            Expr_Lam _from_self _body_self
        ( _from_self) =
            (_from )
        ( _body_self) =
            (_body )
    in  (_self)
sem_Expr_LeftSection :: (T_QualName) ->
                        (T_Expr) ->
                        (T_Expr)
sem_Expr_LeftSection (_op) (_left) =
    let (_self) =
            Expr_LeftSection _op_self _left_self
        ( _op_self) =
            (_op )
        ( _left_self) =
            (_left )
    in  (_self)
sem_Expr_Let :: (T_SDecls) ->
                (T_Expr) ->
                (T_Expr)
sem_Expr_Let (_decls) (_body) =
    let (_self) =
            Expr_Let _decls_self _body_self
        ( _decls_self) =
            (_decls )
        ( _body_self) =
            (_body )
    in  (_self)
sem_Expr_List :: (T_Exprs) ->
                 (T_Expr)
sem_Expr_List (_exprs) =
    let (_self) =
            Expr_List _exprs_self
        ( _exprs_self) =
            (_exprs )
    in  (_self)
sem_Expr_Lit :: (T_Literal) ->
                (T_Expr)
sem_Expr_Lit (_name) =
    let (_self) =
            Expr_Lit _name_self
        ( _name_self) =
            (_name )
    in  (_self)
sem_Expr_Negate :: (T_Expr) ->
                   (T_Expr)
sem_Expr_Negate (_expr) =
    let (_self) =
            Expr_Negate _expr_self
        ( _expr_self) =
            (_expr )
    in  (_self)
sem_Expr_OpApp :: (T_QualName) ->
                  (T_Expr) ->
                  (T_Expr) ->
                  (T_Expr)
sem_Expr_OpApp (_op) (_left) (_right) =
    let (_self) =
            Expr_OpApp _op_self _left_self _right_self
        ( _op_self) =
            (_op )
        ( _left_self) =
            (_left )
        ( _right_self) =
            (_right )
    in  (_self)
sem_Expr_Parens :: (T_Expr) ->
                   (T_Expr)
sem_Expr_Parens (_body) =
    let (_self) =
            Expr_Parens _body_self
        ( _body_self) =
            (_body )
    in  (_self)
sem_Expr_RightSection :: (T_QualName) ->
                         (T_Expr) ->
                         (T_Expr)
sem_Expr_RightSection (_op) (_right) =
    let (_self) =
            Expr_RightSection _op_self _right_self
        ( _op_self) =
            (_op )
        ( _right_self) =
            (_right )
    in  (_self)
sem_Expr_Tuple :: (T_Exprs) ->
                  (T_Expr)
sem_Expr_Tuple (_exprs) =
    let (_self) =
            Expr_Tuple _exprs_self
        ( _exprs_self) =
            (_exprs )
    in  (_self)
sem_Expr_TyApp :: (T_Position) ->
                  (T_QualName) ->
                  (T_Type) ->
                  (T_Expr)
sem_Expr_TyApp (_srcloc) (_expr) (_tp) =
    let (_self) =
            Expr_TyApp _srcloc_self _expr_self _tp_self
        ( _srcloc_self) =
            (_srcloc )
        ( _expr_self) =
            (_expr )
        ( _tp_done,_tp_is_var,_tp_self,_tp_spec,_tp_spec_t) =
            (_tp (internalError "Specialise.Expr.TyApp.bimap: not used") (internalError "Specialise.Expr.TyApp.deps: not used") (internalError "Specialise.Expr.TyApp.subst: not used"))
    in  (_self)
sem_Expr_TypeSig :: (T_Expr) ->
                    (T_QualType) ->
                    (T_Expr)
sem_Expr_TypeSig (_body) (_tp) =
    let (_self) =
            Expr_TypeSig _body_self _tp_self
        ( _body_self) =
            (_body )
        ( _tp_self) =
            (_tp )
    in  (_self)
sem_Expr_Var :: (T_Position) ->
                (T_QualName) ->
                (T_Expr)
sem_Expr_Var (_srcloc) (_name) =
    let (_self) =
            Expr_Var _srcloc_self _name_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_self) =
            (_name )
    in  (_self)
sem_Expr_Wild :: (T_Expr)
sem_Expr_Wild  =
    let (_self) =
            Expr_Wild
    in  (_self)
-- Exprs -------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Exprs

-}
{-
   local variables for Exprs.Cons:

-}
{-
   local variables for Exprs.Nil:

-}
-- semantic domain
type T_Exprs = ((Exprs))
-- cata
sem_Exprs :: (Exprs) ->
             (T_Exprs)
sem_Exprs (list) =
    (foldr (sem_Exprs_Cons) (sem_Exprs_Nil) ((map sem_Expr list)))
sem_Exprs_Cons :: (T_Expr) ->
                  (T_Exprs) ->
                  (T_Exprs)
sem_Exprs_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_Exprs_Nil :: (T_Exprs)
sem_Exprs_Nil  =
    let 
    in  ([])
-- FBind -------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : FBind

-}
{-
   local variables for FBind.FBind:

-}
-- semantic domain
type T_FBind = ((FBind))
-- cata
sem_FBind :: (FBind) ->
             (T_FBind)
sem_FBind ((FBind_FBind (_field) (_expr))) =
    (sem_FBind_FBind ((sem_QualName (_field))) ((sem_Expr (_expr))))
sem_FBind_FBind :: (T_QualName) ->
                   (T_Expr) ->
                   (T_FBind)
sem_FBind_FBind (_field) (_expr) =
    let ( _field_self) =
            (_field )
        ( _expr_self) =
            (_expr )
    in  (FBind_FBind _field_self _expr_self)
-- FBinds ------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : FBinds

-}
{-
   local variables for FBinds.Cons:

-}
{-
   local variables for FBinds.Nil:

-}
-- semantic domain
type T_FBinds = ((FBinds))
-- cata
sem_FBinds :: (FBinds) ->
              (T_FBinds)
sem_FBinds (list) =
    (foldr (sem_FBinds_Cons) (sem_FBinds_Nil) ((map sem_FBind list)))
sem_FBinds_Cons :: (T_FBind) ->
                   (T_FBinds) ->
                   (T_FBinds)
sem_FBinds_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_FBinds_Nil :: (T_FBinds)
sem_FBinds_Nil  =
    let 
    in  ([])
-- GuardedAlt --------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : GuardedAlt

-}
{-
   local variables for GuardedAlt.GuardedAlt:

-}
-- semantic domain
type T_GuardedAlt = ((GuardedAlt))
-- cata
sem_GuardedAlt :: (GuardedAlt) ->
                  (T_GuardedAlt)
sem_GuardedAlt ((GuardedAlt_GuardedAlt (_guard) (_expr))) =
    (sem_GuardedAlt_GuardedAlt ((sem_Expr (_guard))) ((sem_Expr (_expr))))
sem_GuardedAlt_GuardedAlt :: (T_Expr) ->
                             (T_Expr) ->
                             (T_GuardedAlt)
sem_GuardedAlt_GuardedAlt (_guard) (_expr) =
    let ( _guard_self) =
            (_guard )
        ( _expr_self) =
            (_expr )
    in  (GuardedAlt_GuardedAlt _guard_self _expr_self)
-- GuardedAlts -------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : GuardedAlts

-}
{-
   local variables for GuardedAlts.Cons:

-}
{-
   local variables for GuardedAlts.Nil:

-}
-- semantic domain
type T_GuardedAlts = ((GuardedAlts))
-- cata
sem_GuardedAlts :: (GuardedAlts) ->
                   (T_GuardedAlts)
sem_GuardedAlts (list) =
    (foldr (sem_GuardedAlts_Cons) (sem_GuardedAlts_Nil) ((map sem_GuardedAlt list)))
sem_GuardedAlts_Cons :: (T_GuardedAlt) ->
                        (T_GuardedAlts) ->
                        (T_GuardedAlts)
sem_GuardedAlts_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_GuardedAlts_Nil :: (T_GuardedAlts)
sem_GuardedAlts_Nil  =
    let 
    in  ([])
-- GuardedRhs --------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : GuardedRhs

-}
{-
   local variables for GuardedRhs.GuardedRhs:

-}
-- semantic domain
type T_GuardedRhs = ((GuardedRhs))
-- cata
sem_GuardedRhs :: (GuardedRhs) ->
                  (T_GuardedRhs)
sem_GuardedRhs ((GuardedRhs_GuardedRhs (_guard) (_expr))) =
    (sem_GuardedRhs_GuardedRhs ((sem_Expr (_guard))) ((sem_Expr (_expr))))
sem_GuardedRhs_GuardedRhs :: (T_Expr) ->
                             (T_Expr) ->
                             (T_GuardedRhs)
sem_GuardedRhs_GuardedRhs (_guard) (_expr) =
    let ( _guard_self) =
            (_guard )
        ( _expr_self) =
            (_expr )
    in  (GuardedRhs_GuardedRhs _guard_self _expr_self)
-- GuardedRhss -------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : GuardedRhss

-}
{-
   local variables for GuardedRhss.Cons:

-}
{-
   local variables for GuardedRhss.Nil:

-}
-- semantic domain
type T_GuardedRhss = ((GuardedRhss))
-- cata
sem_GuardedRhss :: (GuardedRhss) ->
                   (T_GuardedRhss)
sem_GuardedRhss (list) =
    (foldr (sem_GuardedRhss_Cons) (sem_GuardedRhss_Nil) ((map sem_GuardedRhs list)))
sem_GuardedRhss_Cons :: (T_GuardedRhs) ->
                        (T_GuardedRhss) ->
                        (T_GuardedRhss)
sem_GuardedRhss_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_GuardedRhss_Nil :: (T_GuardedRhss)
sem_GuardedRhss_Nil  =
    let 
    in  ([])
-- Impdecl -----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Impdecl

-}
{-
   local variables for Impdecl.Empty:
      self

-}
{-
   local variables for Impdecl.Import:
      self

-}
-- semantic domain
type T_Impdecl = ((Impdecl))
-- cata
sem_Impdecl :: (Impdecl) ->
               (T_Impdecl)
sem_Impdecl ((Impdecl_Empty )) =
    (sem_Impdecl_Empty )
sem_Impdecl ((Impdecl_Import (_srcloc) (_qual) (_modid) (_as) (_imported))) =
    (sem_Impdecl_Import ((sem_Position (_srcloc))) (_qual) (_modid) (_as) ((sem_Imported (_imported))))
sem_Impdecl_Empty :: (T_Impdecl)
sem_Impdecl_Empty  =
    let (_self) =
            Impdecl_Empty
    in  (_self)
sem_Impdecl_Import :: (T_Position) ->
                      (Bool) ->
                      (Modid) ->
                      (Maybe Modid) ->
                      (T_Imported) ->
                      (T_Impdecl)
sem_Impdecl_Import (_srcloc) (_qual) (_modid) (_as) (_imported) =
    let (_self) =
            Impdecl_Import _srcloc_self _qual _modid _as _imported_self
        ( _srcloc_self) =
            (_srcloc )
        ( _imported_self) =
            (_imported )
    in  (_self)
-- Impdecls ----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Impdecls

-}
{-
   local variables for Impdecls.Cons:

-}
{-
   local variables for Impdecls.Nil:

-}
-- semantic domain
type T_Impdecls = ((Impdecls))
-- cata
sem_Impdecls :: (Impdecls) ->
                (T_Impdecls)
sem_Impdecls (list) =
    (foldr (sem_Impdecls_Cons) (sem_Impdecls_Nil) ((map sem_Impdecl list)))
sem_Impdecls_Cons :: (T_Impdecl) ->
                     (T_Impdecls) ->
                     (T_Impdecls)
sem_Impdecls_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_Impdecls_Nil :: (T_Impdecls)
sem_Impdecls_Nil  =
    let 
    in  ([])
-- Import ------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Import

-}
{-
   local variables for Import.Abstract:

-}
{-
   local variables for Import.TypeAll:

-}
{-
   local variables for Import.TypeSome:

-}
{-
   local variables for Import.Var:

-}
-- semantic domain
type T_Import = ((Import))
-- cata
sem_Import :: (Import) ->
              (T_Import)
sem_Import ((Import_Abstract (_name))) =
    (sem_Import_Abstract ((sem_QualName (_name))))
sem_Import ((Import_TypeAll (_name))) =
    (sem_Import_TypeAll ((sem_QualName (_name))))
sem_Import ((Import_TypeSome (_name) (_conss))) =
    (sem_Import_TypeSome ((sem_QualName (_name))) ((sem_QualNames (_conss))))
sem_Import ((Import_Var (_name))) =
    (sem_Import_Var ((sem_QualName (_name))))
sem_Import_Abstract :: (T_QualName) ->
                       (T_Import)
sem_Import_Abstract (_name) =
    let ( _name_self) =
            (_name )
    in  (Import_Abstract _name_self)
sem_Import_TypeAll :: (T_QualName) ->
                      (T_Import)
sem_Import_TypeAll (_name) =
    let ( _name_self) =
            (_name )
    in  (Import_TypeAll  _name_self)
sem_Import_TypeSome :: (T_QualName) ->
                       (T_QualNames) ->
                       (T_Import)
sem_Import_TypeSome (_name) (_conss) =
    let ( _name_self) =
            (_name )
        ( _conss_self) =
            (_conss )
    in  (Import_TypeSome _name_self _conss_self)
sem_Import_Var :: (T_QualName) ->
                  (T_Import)
sem_Import_Var (_name) =
    let ( _name_self) =
            (_name )
    in  (Import_Var      _name_self)
-- ImportData --------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : ImportData

-}
{-
   local variables for ImportData.Abstract:

-}
{-
   local variables for ImportData.Binding:

-}
{-
   local variables for ImportData.Consig:

-}
{-
   local variables for ImportData.Decl:

-}
{-
   local variables for ImportData.Import:

-}
{-
   local variables for ImportData.SetModule:

-}
-- semantic domain
type T_ImportData = ((ImportData))
-- cata
sem_ImportData :: (ImportData) ->
                  (T_ImportData)
sem_ImportData ((ImportData_Abstract (_name) (_conss) (_kind))) =
    (sem_ImportData_Abstract ((sem_QualName (_name))) ((sem_QualNames (_conss))) ((sem_Kind (_kind))))
sem_ImportData ((ImportData_Binding (_name))) =
    (sem_ImportData_Binding ((sem_QualName (_name))))
sem_ImportData ((ImportData_Consig (_name) (_tps))) =
    (sem_ImportData_Consig ((sem_QualName (_name))) ((sem_QualNames (_tps))))
sem_ImportData ((ImportData_Decl (_decls))) =
    (sem_ImportData_Decl ((sem_Decls (_decls))))
sem_ImportData ((ImportData_Import (_modid))) =
    (sem_ImportData_Import (_modid))
sem_ImportData ((ImportData_SetModule (_modid) (_datas))) =
    (sem_ImportData_SetModule (_modid) ((sem_ImportDatas (_datas))))
sem_ImportData_Abstract :: (T_QualName) ->
                           (T_QualNames) ->
                           (T_Kind) ->
                           (T_ImportData)
sem_ImportData_Abstract (_name) (_conss) (_kind) =
    let ( _name_self) =
            (_name )
        ( _conss_self) =
            (_conss )
        ( _kind_self) =
            (_kind )
    in  (ImportData_Abstract _name_self _conss_self _kind_self)
sem_ImportData_Binding :: (T_QualName) ->
                          (T_ImportData)
sem_ImportData_Binding (_name) =
    let ( _name_self) =
            (_name )
    in  (ImportData_Binding _name_self)
sem_ImportData_Consig :: (T_QualName) ->
                         (T_QualNames) ->
                         (T_ImportData)
sem_ImportData_Consig (_name) (_tps) =
    let ( _name_self) =
            (_name )
        ( _tps_self) =
            (_tps )
    in  (ImportData_Consig _name_self _tps_self)
sem_ImportData_Decl :: (T_Decls) ->
                       (T_ImportData)
sem_ImportData_Decl (_decls) =
    let ( _decls_self) =
            (_decls )
    in  (ImportData_Decl _decls_self)
sem_ImportData_Import :: (Modid) ->
                         (T_ImportData)
sem_ImportData_Import (_modid) =
    let 
    in  (ImportData_Import _modid)
sem_ImportData_SetModule :: (Modid) ->
                            (T_ImportDatas) ->
                            (T_ImportData)
sem_ImportData_SetModule (_modid) (_datas) =
    let ( _datas_self) =
            (_datas )
    in  (ImportData_SetModule _modid _datas_self)
-- ImportDatas -------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : ImportDatas

-}
{-
   local variables for ImportDatas.Cons:

-}
{-
   local variables for ImportDatas.Nil:

-}
-- semantic domain
type T_ImportDatas = ((ImportDatas))
-- cata
sem_ImportDatas :: (ImportDatas) ->
                   (T_ImportDatas)
sem_ImportDatas (list) =
    (foldr (sem_ImportDatas_Cons) (sem_ImportDatas_Nil) ((map sem_ImportData list)))
sem_ImportDatas_Cons :: (T_ImportData) ->
                        (T_ImportDatas) ->
                        (T_ImportDatas)
sem_ImportDatas_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_ImportDatas_Nil :: (T_ImportDatas)
sem_ImportDatas_Nil  =
    let 
    in  ([])
-- Imported ----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Imported

-}
{-
   local variables for Imported.Hiding:

-}
{-
   local variables for Imported.Imports:

-}
{-
   local variables for Imported.NoImports:

-}
-- semantic domain
type T_Imported = ((Imported))
-- cata
sem_Imported :: (Imported) ->
                (T_Imported)
sem_Imported ((Imported_Hiding (_imports))) =
    (sem_Imported_Hiding ((sem_Imports (_imports))))
sem_Imported ((Imported_Imports (_imports))) =
    (sem_Imported_Imports ((sem_Imports (_imports))))
sem_Imported ((Imported_NoImports )) =
    (sem_Imported_NoImports )
sem_Imported_Hiding :: (T_Imports) ->
                       (T_Imported)
sem_Imported_Hiding (_imports) =
    let ( _imports_self) =
            (_imports )
    in  (Imported_Hiding _imports_self)
sem_Imported_Imports :: (T_Imports) ->
                        (T_Imported)
sem_Imported_Imports (_imports) =
    let ( _imports_self) =
            (_imports )
    in  (Imported_Imports _imports_self)
sem_Imported_NoImports :: (T_Imported)
sem_Imported_NoImports  =
    let 
    in  (Imported_NoImports)
-- ImportedModule ----------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : ImportedModule

-}
{-
   local variables for ImportedModule.Empty:

-}
{-
   local variables for ImportedModule.Module:

-}
-- semantic domain
type T_ImportedModule = ((ImportedModule))
-- cata
sem_ImportedModule :: (ImportedModule) ->
                      (T_ImportedModule)
sem_ImportedModule ((ImportedModule_Empty )) =
    (sem_ImportedModule_Empty )
sem_ImportedModule ((ImportedModule_Module (_modid) (_export_tp) (_export_val) (_datas))) =
    (sem_ImportedModule_Module (_modid) ((sem_QualNames (_export_tp))) ((sem_QualNames (_export_val))) ((sem_ImportDatas (_datas))))
sem_ImportedModule_Empty :: (T_ImportedModule)
sem_ImportedModule_Empty  =
    let 
    in  (ImportedModule_Empty)
sem_ImportedModule_Module :: (Modid) ->
                             (T_QualNames) ->
                             (T_QualNames) ->
                             (T_ImportDatas) ->
                             (T_ImportedModule)
sem_ImportedModule_Module (_modid) (_export_tp) (_export_val) (_datas) =
    let ( _export_tp_self) =
            (_export_tp )
        ( _export_val_self) =
            (_export_val )
        ( _datas_self) =
            (_datas )
    in  (ImportedModule_Module _modid _export_tp_self
                               _export_val_self _datas_self
        )
-- ImportedModules ---------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : ImportedModules

-}
{-
   local variables for ImportedModules.Cons:

-}
{-
   local variables for ImportedModules.Nil:

-}
-- semantic domain
type T_ImportedModules = ((ImportedModules))
-- cata
sem_ImportedModules :: (ImportedModules) ->
                       (T_ImportedModules)
sem_ImportedModules (list) =
    (foldr (sem_ImportedModules_Cons) (sem_ImportedModules_Nil) ((map sem_ImportedModule list)))
sem_ImportedModules_Cons :: (T_ImportedModule) ->
                            (T_ImportedModules) ->
                            (T_ImportedModules)
sem_ImportedModules_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_ImportedModules_Nil :: (T_ImportedModules)
sem_ImportedModules_Nil  =
    let 
    in  ([])
-- Imports -----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Imports

-}
{-
   local variables for Imports.Cons:

-}
{-
   local variables for Imports.Nil:

-}
-- semantic domain
type T_Imports = ((Imports))
-- cata
sem_Imports :: (Imports) ->
               (T_Imports)
sem_Imports (list) =
    (foldr (sem_Imports_Cons) (sem_Imports_Nil) ((map sem_Import list)))
sem_Imports_Cons :: (T_Import) ->
                    (T_Imports) ->
                    (T_Imports)
sem_Imports_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_Imports_Nil :: (T_Imports)
sem_Imports_Nil  =
    let 
    in  ([])
-- Infix -------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Infix

-}
{-
   local variables for Infix.Left:

-}
{-
   local variables for Infix.No:

-}
{-
   local variables for Infix.Right:

-}
-- semantic domain
type T_Infix = ((Infix))
-- cata
sem_Infix :: (Infix) ->
             (T_Infix)
sem_Infix ((Infix_Left )) =
    (sem_Infix_Left )
sem_Infix ((Infix_No )) =
    (sem_Infix_No )
sem_Infix ((Infix_Right )) =
    (sem_Infix_Right )
sem_Infix_Left :: (T_Infix)
sem_Infix_Left  =
    let 
    in  (Infix_Left)
sem_Infix_No :: (T_Infix)
sem_Infix_No  =
    let 
    in  (Infix_No)
sem_Infix_Right :: (T_Infix)
sem_Infix_Right  =
    let 
    in  (Infix_Right)
-- Kind --------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Kind

-}
{-
   local variables for Kind.Arr:

-}
{-
   local variables for Kind.Box:

-}
{-
   local variables for Kind.Error:

-}
{-
   local variables for Kind.Star:

-}
{-
   local variables for Kind.Var:

-}
-- semantic domain
type T_Kind = ((Kind))
-- cata
sem_Kind :: (Kind) ->
            (T_Kind)
sem_Kind ((Kind_Arr (_left) (_right))) =
    (sem_Kind_Arr ((sem_Kind (_left))) ((sem_Kind (_right))))
sem_Kind ((Kind_Box (_kind))) =
    (sem_Kind_Box ((sem_Kind (_kind))))
sem_Kind ((Kind_Error )) =
    (sem_Kind_Error )
sem_Kind ((Kind_Star )) =
    (sem_Kind_Star )
sem_Kind ((Kind_Var (_name))) =
    (sem_Kind_Var ((sem_QualName (_name))))
sem_Kind_Arr :: (T_Kind) ->
                (T_Kind) ->
                (T_Kind)
sem_Kind_Arr (_left) (_right) =
    let ( _left_self) =
            (_left )
        ( _right_self) =
            (_right )
    in  (Kind_Arr _left_self _right_self)
sem_Kind_Box :: (T_Kind) ->
                (T_Kind)
sem_Kind_Box (_kind) =
    let ( _kind_self) =
            (_kind )
    in  (Kind_Box _kind_self)
sem_Kind_Error :: (T_Kind)
sem_Kind_Error  =
    let 
    in  (Kind_Error)
sem_Kind_Star :: (T_Kind)
sem_Kind_Star  =
    let 
    in  (Kind_Star)
sem_Kind_Var :: (T_QualName) ->
                (T_Kind)
sem_Kind_Var (_name) =
    let ( _name_self) =
            (_name )
    in  (Kind_Var _name_self)
-- LabelType ---------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : LabelType

-}
{-
   local variables for LabelType.LabelType:

-}
{-
   local variables for LabelType.Type:

-}
-- semantic domain
type T_LabelType = ((LabelType))
-- cata
sem_LabelType :: (LabelType) ->
                 (T_LabelType)
sem_LabelType ((LabelType_LabelType (_label) (_strict) (_body))) =
    (sem_LabelType_LabelType ((sem_QualName (_label))) (_strict) ((sem_Type (_body))))
sem_LabelType ((LabelType_Type (_strict) (_body))) =
    (sem_LabelType_Type (_strict) ((sem_Type (_body))))
sem_LabelType_LabelType :: (T_QualName) ->
                           (Bool) ->
                           (T_Type) ->
                           (T_LabelType)
sem_LabelType_LabelType (_label) (_strict) (_body) =
    let ( _label_self) =
            (_label )
        ( _body_done,_body_is_var,_body_self,_body_spec,_body_spec_t) =
            (_body (internalError "Specialise.LabelType.LabelType.bimap: not used") (internalError "Specialise.LabelType.LabelType.deps: not used") (internalError "Specialise.LabelType.LabelType.subst: not used"))
    in  (LabelType_LabelType _label_self _strict
                             _body_self
        )
sem_LabelType_Type :: (Bool) ->
                      (T_Type) ->
                      (T_LabelType)
sem_LabelType_Type (_strict) (_body) =
    let ( _body_done,_body_is_var,_body_self,_body_spec,_body_spec_t) =
            (_body (internalError "Specialise.LabelType.Type.bimap: not used") (internalError "Specialise.LabelType.Type.deps: not used") (internalError "Specialise.LabelType.Type.subst: not used"))
    in  (LabelType_Type _strict _body_self)
-- LabelTypes --------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : LabelTypes

-}
{-
   local variables for LabelTypes.Cons:

-}
{-
   local variables for LabelTypes.Nil:

-}
-- semantic domain
type T_LabelTypes = ((LabelTypes))
-- cata
sem_LabelTypes :: (LabelTypes) ->
                  (T_LabelTypes)
sem_LabelTypes (list) =
    (foldr (sem_LabelTypes_Cons) (sem_LabelTypes_Nil) ((map sem_LabelType list)))
sem_LabelTypes_Cons :: (T_LabelType) ->
                       (T_LabelTypes) ->
                       (T_LabelTypes)
sem_LabelTypes_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_LabelTypes_Nil :: (T_LabelTypes)
sem_LabelTypes_Nil  =
    let 
    in  ([])
-- Literal -----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Literal

-}
{-
   local variables for Literal.Char:

-}
{-
   local variables for Literal.Float:

-}
{-
   local variables for Literal.Frac:

-}
{-
   local variables for Literal.Int:

-}
{-
   local variables for Literal.String:

-}
-- semantic domain
type T_Literal = ((Literal))
-- cata
sem_Literal :: (Literal) ->
               (T_Literal)
sem_Literal ((Literal_Char (_name))) =
    (sem_Literal_Char (_name))
sem_Literal ((Literal_Float (_name))) =
    (sem_Literal_Float (_name))
sem_Literal ((Literal_Frac (_name))) =
    (sem_Literal_Frac (_name))
sem_Literal ((Literal_Int (_name))) =
    (sem_Literal_Int (_name))
sem_Literal ((Literal_String (_name))) =
    (sem_Literal_String (_name))
sem_Literal_Char :: (String) ->
                    (T_Literal)
sem_Literal_Char (_name) =
    let 
    in  (Literal_Char   _name)
sem_Literal_Float :: (String) ->
                     (T_Literal)
sem_Literal_Float (_name) =
    let 
    in  (Literal_Float  _name)
sem_Literal_Frac :: (String) ->
                    (T_Literal)
sem_Literal_Frac (_name) =
    let 
    in  (Literal_Frac   _name)
sem_Literal_Int :: (String) ->
                   (T_Literal)
sem_Literal_Int (_name) =
    let 
    in  (Literal_Int    _name)
sem_Literal_String :: (String) ->
                      (T_Literal)
sem_Literal_String (_name) =
    let 
    in  (Literal_String _name)
-- Module ------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Module

-}
{-
   local variables for Module.Main:

-}
{-
   local variables for Module.Named:

-}
-- semantic domain
type T_Module = ((Module))
-- cata
sem_Module :: (Module) ->
              (T_Module)
sem_Module ((Module_Main (_body))) =
    (sem_Module_Main ((sem_Body (_body))))
sem_Module ((Module_Named (_modid) (_exported) (_body))) =
    (sem_Module_Named (_modid) ((sem_Exported (_exported))) ((sem_Body (_body))))
sem_Module_Main :: (T_Body) ->
                   (T_Module)
sem_Module_Main (_body) =
    let ( _body_self) =
            (_body )
    in  (Module_Main _body_self)
sem_Module_Named :: (Modid) ->
                    (T_Exported) ->
                    (T_Body) ->
                    (T_Module)
sem_Module_Named (_modid) (_exported) (_body) =
    let ( _exported_self) =
            (_exported )
        ( _body_self) =
            (_body )
    in  (Module_Named _modid _exported_self _body_self)
-- ModuleSystem ------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : ModuleSystem

-}
{-
   local variables for ModuleSystem.ModuleSystem:

-}
-- semantic domain
type T_ModuleSystem = ((ModuleSystem))
-- cata
sem_ModuleSystem :: (ModuleSystem) ->
                    (T_ModuleSystem)
sem_ModuleSystem ((ModuleSystem_ModuleSystem (_imports) (_module))) =
    (sem_ModuleSystem_ModuleSystem ((sem_ImportedModules (_imports))) ((sem_Module (_module))))
sem_ModuleSystem_ModuleSystem :: (T_ImportedModules) ->
                                 (T_Module) ->
                                 (T_ModuleSystem)
sem_ModuleSystem_ModuleSystem (_imports) (_module) =
    let ( _imports_self) =
            (_imports )
        ( _module_self) =
            (_module )
    in  (ModuleSystem_ModuleSystem _imports_self _module_self)
-- Name --------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Name

-}
{-
   local variables for Name.Ident:
      self

-}
{-
   local variables for Name.Special:
      self

-}
{-
   local variables for Name.Symbol:
      self

-}
-- semantic domain
type T_Name = ((Name))
-- cata
sem_Name :: (Name) ->
            (T_Name)
sem_Name ((Name_Ident (_range) (_name))) =
    (sem_Name_Ident ((sem_Range (_range))) (_name))
sem_Name ((Name_Special (_range) (_name))) =
    (sem_Name_Special ((sem_Range (_range))) (_name))
sem_Name ((Name_Symbol (_range) (_name))) =
    (sem_Name_Symbol ((sem_Range (_range))) (_name))
sem_Name_Ident :: (T_Range) ->
                  (String) ->
                  (T_Name)
sem_Name_Ident (_range) (_name) =
    let (_self) =
            Name_Ident   _range_self _name
        ( _range_self) =
            (_range )
    in  (_self)
sem_Name_Special :: (T_Range) ->
                    (String) ->
                    (T_Name)
sem_Name_Special (_range) (_name) =
    let (_self) =
            Name_Special _range_self _name
        ( _range_self) =
            (_range )
    in  (_self)
sem_Name_Symbol :: (T_Range) ->
                   (String) ->
                   (T_Name)
sem_Name_Symbol (_range) (_name) =
    let (_self) =
            Name_Symbol  _range_self _name
        ( _range_self) =
            (_range )
    in  (_self)
-- Names -------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Names

-}
{-
   local variables for Names.Cons:

-}
{-
   local variables for Names.Nil:

-}
-- semantic domain
type T_Names = ((Names))
-- cata
sem_Names :: (Names) ->
             (T_Names)
sem_Names (list) =
    (foldr (sem_Names_Cons) (sem_Names_Nil) ((map sem_Name list)))
sem_Names_Cons :: (T_Name) ->
                  (T_Names) ->
                  (T_Names)
sem_Names_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_Names_Nil :: (T_Names)
sem_Names_Nil  =
    let 
    in  ([])
-- PBind -------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : PBind

-}
{-
   local variables for PBind.PBind:

-}
-- semantic domain
type T_PBind = ((PBind))
-- cata
sem_PBind :: (PBind) ->
             (T_PBind)
sem_PBind ((PBind_PBind (_field) (_pattern))) =
    (sem_PBind_PBind ((sem_QualName (_field))) ((sem_Pattern (_pattern))))
sem_PBind_PBind :: (T_QualName) ->
                   (T_Pattern) ->
                   (T_PBind)
sem_PBind_PBind (_field) (_pattern) =
    let ( _field_self) =
            (_field )
        ( _pattern_self) =
            (_pattern )
    in  (PBind_PBind _field_self _pattern_self)
-- PBinds ------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : PBinds

-}
{-
   local variables for PBinds.Cons:

-}
{-
   local variables for PBinds.Nil:

-}
-- semantic domain
type T_PBinds = ((PBinds))
-- cata
sem_PBinds :: (PBinds) ->
              (T_PBinds)
sem_PBinds (list) =
    (foldr (sem_PBinds_Cons) (sem_PBinds_Nil) ((map sem_PBind list)))
sem_PBinds_Cons :: (T_PBind) ->
                   (T_PBinds) ->
                   (T_PBinds)
sem_PBinds_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_PBinds_Nil :: (T_PBinds)
sem_PBinds_Nil  =
    let 
    in  ([])
-- PTS ---------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : PTS

-}
{-
   local variables for PTS.PTS:

-}
-- semantic domain
type T_PTS = ((PTS))
-- cata
sem_PTS :: (PTS) ->
           (T_PTS)
sem_PTS ((PTS_PTS (_tpvar) (_kind) (_tp))) =
    (sem_PTS_PTS ((sem_QualName (_tpvar))) ((sem_Kind (_kind))) ((sem_QualType (_tp))))
sem_PTS_PTS :: (T_QualName) ->
               (T_Kind) ->
               (T_QualType) ->
               (T_PTS)
sem_PTS_PTS (_tpvar) (_kind) (_tp) =
    let ( _tpvar_self) =
            (_tpvar )
        ( _kind_self) =
            (_kind )
        ( _tp_self) =
            (_tp )
    in  (PTS_PTS _tpvar_self _kind_self _tp_self)
-- Pattern -----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Pattern

-}
{-
   local variables for Pattern.As:

-}
{-
   local variables for Pattern.Con:

-}
{-
   local variables for Pattern.Irr:

-}
{-
   local variables for Pattern.Lab:

-}
{-
   local variables for Pattern.List:

-}
{-
   local variables for Pattern.Lit:

-}
{-
   local variables for Pattern.Negate:

-}
{-
   local variables for Pattern.OpApp:

-}
{-
   local variables for Pattern.Parens:

-}
{-
   local variables for Pattern.Tuple:

-}
{-
   local variables for Pattern.Var:

-}
{-
   local variables for Pattern.Wild:

-}
-- semantic domain
type T_Pattern = ((Pattern))
-- cata
sem_Pattern :: (Pattern) ->
               (T_Pattern)
sem_Pattern ((Pattern_As (_name) (_pattern))) =
    (sem_Pattern_As ((sem_QualName (_name))) ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_Con (_name) (_args))) =
    (sem_Pattern_Con ((sem_QualName (_name))) ((sem_Patterns (_args))))
sem_Pattern ((Pattern_Irr (_pattern))) =
    (sem_Pattern_Irr ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_Lab (_name) (_pbinds))) =
    (sem_Pattern_Lab ((sem_QualName (_name))) ((sem_PBinds (_pbinds))))
sem_Pattern ((Pattern_List (_patterns))) =
    (sem_Pattern_List ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_Lit (_name))) =
    (sem_Pattern_Lit ((sem_Literal (_name))))
sem_Pattern ((Pattern_Negate (_pattern))) =
    (sem_Pattern_Negate ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_OpApp (_op) (_left) (_right))) =
    (sem_Pattern_OpApp ((sem_QualName (_op))) ((sem_Pattern (_left))) ((sem_Pattern (_right))))
sem_Pattern ((Pattern_Parens (_pattern))) =
    (sem_Pattern_Parens ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_Tuple (_patterns))) =
    (sem_Pattern_Tuple ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_Var (_name))) =
    (sem_Pattern_Var ((sem_QualName (_name))))
sem_Pattern ((Pattern_Wild )) =
    (sem_Pattern_Wild )
sem_Pattern_As :: (T_QualName) ->
                  (T_Pattern) ->
                  (T_Pattern)
sem_Pattern_As (_name) (_pattern) =
    let ( _name_self) =
            (_name )
        ( _pattern_self) =
            (_pattern )
    in  (Pattern_As  _name_self _pattern_self)
sem_Pattern_Con :: (T_QualName) ->
                   (T_Patterns) ->
                   (T_Pattern)
sem_Pattern_Con (_name) (_args) =
    let ( _name_self) =
            (_name )
        ( _args_self) =
            (_args )
    in  (Pattern_Con _name_self _args_self)
sem_Pattern_Irr :: (T_Pattern) ->
                   (T_Pattern)
sem_Pattern_Irr (_pattern) =
    let ( _pattern_self) =
            (_pattern )
    in  (Pattern_Irr _pattern_self)
sem_Pattern_Lab :: (T_QualName) ->
                   (T_PBinds) ->
                   (T_Pattern)
sem_Pattern_Lab (_name) (_pbinds) =
    let ( _name_self) =
            (_name )
        ( _pbinds_self) =
            (_pbinds )
    in  (Pattern_Lab _name_self _pbinds_self)
sem_Pattern_List :: (T_Patterns) ->
                    (T_Pattern)
sem_Pattern_List (_patterns) =
    let ( _patterns_self) =
            (_patterns )
    in  (Pattern_List  _patterns_self)
sem_Pattern_Lit :: (T_Literal) ->
                   (T_Pattern)
sem_Pattern_Lit (_name) =
    let ( _name_self) =
            (_name )
    in  (Pattern_Lit _name_self)
sem_Pattern_Negate :: (T_Pattern) ->
                      (T_Pattern)
sem_Pattern_Negate (_pattern) =
    let ( _pattern_self) =
            (_pattern )
    in  (Pattern_Negate _pattern_self)
sem_Pattern_OpApp :: (T_QualName) ->
                     (T_Pattern) ->
                     (T_Pattern) ->
                     (T_Pattern)
sem_Pattern_OpApp (_op) (_left) (_right) =
    let ( _op_self) =
            (_op )
        ( _left_self) =
            (_left )
        ( _right_self) =
            (_right )
    in  (Pattern_OpApp _op_self _left_self
                                _right_self
        )
sem_Pattern_Parens :: (T_Pattern) ->
                      (T_Pattern)
sem_Pattern_Parens (_pattern) =
    let ( _pattern_self) =
            (_pattern )
    in  (Pattern_Parens _pattern_self)
sem_Pattern_Tuple :: (T_Patterns) ->
                     (T_Pattern)
sem_Pattern_Tuple (_patterns) =
    let ( _patterns_self) =
            (_patterns )
    in  (Pattern_Tuple _patterns_self)
sem_Pattern_Var :: (T_QualName) ->
                   (T_Pattern)
sem_Pattern_Var (_name) =
    let ( _name_self) =
            (_name )
    in  (Pattern_Var _name_self)
sem_Pattern_Wild :: (T_Pattern)
sem_Pattern_Wild  =
    let 
    in  (Pattern_Wild)
-- Patterns ----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Patterns

-}
{-
   local variables for Patterns.Cons:

-}
{-
   local variables for Patterns.Nil:

-}
-- semantic domain
type T_Patterns = ((Patterns))
-- cata
sem_Patterns :: (Patterns) ->
                (T_Patterns)
sem_Patterns (list) =
    (foldr (sem_Patterns_Cons) (sem_Patterns_Nil) ((map sem_Pattern list)))
sem_Patterns_Cons :: (T_Pattern) ->
                     (T_Patterns) ->
                     (T_Patterns)
sem_Patterns_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_Patterns_Nil :: (T_Patterns)
sem_Patterns_Nil  =
    let 
    in  ([])
-- Position ----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Position

-}
{-
   local variables for Position.Position:

-}
{-
   local variables for Position.Unknown:

-}
-- semantic domain
type T_Position = ((Position))
-- cata
sem_Position :: (Position) ->
                (T_Position)
sem_Position ((Position_Position (_filename) (_line) (_column))) =
    (sem_Position_Position (_filename) (_line) (_column))
sem_Position ((Position_Unknown )) =
    (sem_Position_Unknown )
sem_Position_Position :: (String) ->
                         (Int) ->
                         (Int) ->
                         (T_Position)
sem_Position_Position (_filename) (_line) (_column) =
    let 
    in  (Position_Position _filename _line _column)
sem_Position_Unknown :: (T_Position)
sem_Position_Unknown  =
    let 
    in  (Position_Unknown)
-- Qual --------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Qual

-}
{-
   local variables for Qual.Empty:

-}
{-
   local variables for Qual.Gen:

-}
{-
   local variables for Qual.Guard:

-}
{-
   local variables for Qual.Let:

-}
-- semantic domain
type T_Qual = ((Qual))
-- cata
sem_Qual :: (Qual) ->
            (T_Qual)
sem_Qual ((Qual_Empty )) =
    (sem_Qual_Empty )
sem_Qual ((Qual_Gen (_pattern) (_body))) =
    (sem_Qual_Gen ((sem_Pattern (_pattern))) ((sem_Expr (_body))))
sem_Qual ((Qual_Guard (_expr))) =
    (sem_Qual_Guard ((sem_Expr (_expr))))
sem_Qual ((Qual_Let (_decls))) =
    (sem_Qual_Let ((sem_SDecls (_decls))))
sem_Qual_Empty :: (T_Qual)
sem_Qual_Empty  =
    let 
    in  (Qual_Empty)
sem_Qual_Gen :: (T_Pattern) ->
                (T_Expr) ->
                (T_Qual)
sem_Qual_Gen (_pattern) (_body) =
    let ( _pattern_self) =
            (_pattern )
        ( _body_self) =
            (_body )
    in  (Qual_Gen _pattern_self _body_self)
sem_Qual_Guard :: (T_Expr) ->
                  (T_Qual)
sem_Qual_Guard (_expr) =
    let ( _expr_self) =
            (_expr )
    in  (Qual_Guard _expr_self)
sem_Qual_Let :: (T_SDecls) ->
                (T_Qual)
sem_Qual_Let (_decls) =
    let ( _decls_self) =
            (_decls )
    in  (Qual_Let _decls_self)
-- QualName ----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : QualName

-}
{-
   local variables for QualName.Entity:
      self

-}
{-
   local variables for QualName.Plain:
      self

-}
{-
   local variables for QualName.Qual:
      self

-}
-- semantic domain
type T_QualName = ((QualName))
-- cata
sem_QualName :: (QualName) ->
                (T_QualName)
sem_QualName ((QualName_Entity (_range) (_entity) (_inscope))) =
    (sem_QualName_Entity ((sem_Range (_range))) ((sem_Entity (_entity))) (_inscope))
sem_QualName ((QualName_Plain (_range) (_name))) =
    (sem_QualName_Plain ((sem_Range (_range))) ((sem_Name (_name))))
sem_QualName ((QualName_Qual (_range) (_modid) (_name))) =
    (sem_QualName_Qual ((sem_Range (_range))) (_modid) ((sem_Name (_name))))
sem_QualName_Entity :: (T_Range) ->
                       (T_Entity) ->
                       (Maybe QualName) ->
                       (T_QualName)
sem_QualName_Entity (_range) (_entity) (_inscope) =
    let (_self) =
            QualName_Entity _range_self _entity_self _inscope
        ( _range_self) =
            (_range )
        ( _entity_self) =
            (_entity )
    in  (_self)
sem_QualName_Plain :: (T_Range) ->
                      (T_Name) ->
                      (T_QualName)
sem_QualName_Plain (_range) (_name) =
    let (_self) =
            QualName_Plain  _range_self        _name_self
        ( _range_self) =
            (_range )
        ( _name_self) =
            (_name )
    in  (_self)
sem_QualName_Qual :: (T_Range) ->
                     (Modid) ->
                     (T_Name) ->
                     (T_QualName)
sem_QualName_Qual (_range) (_modid) (_name) =
    let (_self) =
            QualName_Qual   _range_self _modid _name_self
        ( _range_self) =
            (_range )
        ( _name_self) =
            (_name )
    in  (_self)
-- QualNames ---------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : QualNames

-}
{-
   local variables for QualNames.Cons:

-}
{-
   local variables for QualNames.Nil:

-}
-- semantic domain
type T_QualNames = ((QualNames))
-- cata
sem_QualNames :: (QualNames) ->
                 (T_QualNames)
sem_QualNames (list) =
    (foldr (sem_QualNames_Cons) (sem_QualNames_Nil) ((map sem_QualName list)))
sem_QualNames_Cons :: (T_QualName) ->
                      (T_QualNames) ->
                      (T_QualNames)
sem_QualNames_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_QualNames_Nil :: (T_QualNames)
sem_QualNames_Nil  =
    let 
    in  ([])
-- QualType ----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : QualType

-}
{-
   local variables for QualType.QualType:

-}
-- semantic domain
type T_QualType = ((QualType))
-- cata
sem_QualType :: (QualType) ->
                (T_QualType)
sem_QualType ((QualType_QualType (_context) (_tp))) =
    (sem_QualType_QualType ((sem_Context (_context))) ((sem_Type (_tp))))
sem_QualType_QualType :: (T_Context) ->
                         (T_Type) ->
                         (T_QualType)
sem_QualType_QualType (_context) (_tp) =
    let ( _context_self) =
            (_context )
        ( _tp_done,_tp_is_var,_tp_self,_tp_spec,_tp_spec_t) =
            (_tp (internalError "Specialise.QualType.QualType.bimap: not used") (internalError "Specialise.QualType.QualType.deps: not used") (internalError "Specialise.QualType.QualType.subst: not used"))
    in  (QualType_QualType _context_self _tp_self)
-- Quals -------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Quals

-}
{-
   local variables for Quals.Cons:

-}
{-
   local variables for Quals.Nil:

-}
-- semantic domain
type T_Quals = ((Quals))
-- cata
sem_Quals :: (Quals) ->
             (T_Quals)
sem_Quals (list) =
    (foldr (sem_Quals_Cons) (sem_Quals_Nil) ((map sem_Qual list)))
sem_Quals_Cons :: (T_Qual) ->
                  (T_Quals) ->
                  (T_Quals)
sem_Quals_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_Quals_Nil :: (T_Quals)
sem_Quals_Nil  =
    let 
    in  ([])
-- Range -------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Range

-}
{-
   local variables for Range.Range:

-}
-- semantic domain
type T_Range = ((Range))
-- cata
sem_Range :: (Range) ->
             (T_Range)
sem_Range ((Range_Range (_start) (_stop))) =
    (sem_Range_Range ((sem_Position (_start))) ((sem_Position (_stop))))
sem_Range_Range :: (T_Position) ->
                   (T_Position) ->
                   (T_Range)
sem_Range_Range (_start) (_stop) =
    let ( _start_self) =
            (_start )
        ( _stop_self) =
            (_stop )
    in  (Range_Range _start_self _stop_self)
-- Rhs ---------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Rhs

-}
{-
   local variables for Rhs.Guarded:

-}
{-
   local variables for Rhs.Unguarded:

-}
-- semantic domain
type T_Rhs = ((Rhs))
-- cata
sem_Rhs :: (Rhs) ->
           (T_Rhs)
sem_Rhs ((Rhs_Guarded (_grds))) =
    (sem_Rhs_Guarded ((sem_GuardedRhss (_grds))))
sem_Rhs ((Rhs_Unguarded (_expr))) =
    (sem_Rhs_Unguarded ((sem_Expr (_expr))))
sem_Rhs_Guarded :: (T_GuardedRhss) ->
                   (T_Rhs)
sem_Rhs_Guarded (_grds) =
    let ( _grds_self) =
            (_grds )
    in  (Rhs_Guarded _grds_self)
sem_Rhs_Unguarded :: (T_Expr) ->
                     (T_Rhs)
sem_Rhs_Unguarded (_expr) =
    let ( _expr_self) =
            (_expr )
    in  (Rhs_Unguarded _expr_self)
-- Root --------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:

-}
{-
   local variables for Root.Root:

-}
-- semantic domain
type T_Root = ()
-- cata
sem_Root :: (Root) ->
            (T_Root)
sem_Root ((Root_Root (_contents))) =
    (sem_Root_Root ((sem_ModuleSystem (_contents))))
sem_Root_Root :: (T_ModuleSystem) ->
                 (T_Root)
sem_Root_Root (_contents) =
    let ( _contents_self) =
            (_contents )
    in  ()
-- SBinding ----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:

-}
{-
   local variables for SBinding.Id:

-}
-- semantic domain
type T_SBinding = ()
-- cata
sem_SBinding :: (SBinding) ->
                (T_SBinding)
sem_SBinding ((SBinding_Id (_it))) =
    (sem_SBinding_Id ((sem_Binding (_it))))
sem_SBinding_Id :: (T_Binding) ->
                   (T_SBinding)
sem_SBinding_Id (_it) =
    let ( _it_self) =
            (_it )
    in  ()
-- SBindings ---------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:

-}
{-
   local variables for SBindings.Id:

-}
-- semantic domain
type T_SBindings = ()
-- cata
sem_SBindings :: (SBindings) ->
                 (T_SBindings)
sem_SBindings ((SBindings_Id (_it))) =
    (sem_SBindings_Id ((sem_Bindings (_it))))
sem_SBindings_Id :: (T_Bindings) ->
                    (T_SBindings)
sem_SBindings_Id (_it) =
    let ( _it_self) =
            (_it )
    in  ()
-- SDecl -------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SDecl

-}
{-
   local variables for SDecl.Binding:
      self

-}
{-
   local variables for SDecl.Empty:
      self

-}
{-
   local variables for SDecl.Fixity:
      self

-}
{-
   local variables for SDecl.PatBinding:
      self

-}
{-
   local variables for SDecl.PolyBinding:
      self

-}
{-
   local variables for SDecl.PolyTypeSig:
      self

-}
{-
   local variables for SDecl.TypeSig:
      self

-}
-- semantic domain
type T_SDecl = ((SDecl))
-- cata
sem_SDecl :: (SDecl) ->
             (T_SDecl)
sem_SDecl ((SDecl_Binding (_srcloc) (_name) (_bindings))) =
    (sem_SDecl_Binding ((sem_Position (_srcloc))) ((sem_QualName (_name))) ((sem_Bindings (_bindings))))
sem_SDecl ((SDecl_Empty )) =
    (sem_SDecl_Empty )
sem_SDecl ((SDecl_Fixity (_srcloc) (_inf) (_priority) (_ops))) =
    (sem_SDecl_Fixity ((sem_Position (_srcloc))) ((sem_Infix (_inf))) (_priority) ((sem_QualNames (_ops))))
sem_SDecl ((SDecl_PatBinding (_srcloc) (_pat) (_rhs) (_where))) =
    (sem_SDecl_PatBinding ((sem_Position (_srcloc))) ((sem_Pattern (_pat))) ((sem_Rhs (_rhs))) ((sem_SDecls (_where))))
sem_SDecl ((SDecl_PolyBinding (_srcloc) (_name) (_tp) (_bindings))) =
    (sem_SDecl_PolyBinding ((sem_Position (_srcloc))) ((sem_QualName (_name))) ((sem_SType (_tp))) ((sem_Bindings (_bindings))))
sem_SDecl ((SDecl_PolyTypeSig (_srcloc) (_name) (_pts))) =
    (sem_SDecl_PolyTypeSig ((sem_Position (_srcloc))) ((sem_QualName (_name))) ((sem_PTS (_pts))))
sem_SDecl ((SDecl_TypeSig (_srcloc) (_name) (_tp))) =
    (sem_SDecl_TypeSig ((sem_Position (_srcloc))) ((sem_QualName (_name))) ((sem_QualType (_tp))))
sem_SDecl_Binding :: (T_Position) ->
                     (T_QualName) ->
                     (T_Bindings) ->
                     (T_SDecl)
sem_SDecl_Binding (_srcloc) (_name) (_bindings) =
    let (_self) =
            SDecl_Binding _srcloc_self _name_self _bindings_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_self) =
            (_name )
        ( _bindings_self) =
            (_bindings )
    in  (_self)
sem_SDecl_Empty :: (T_SDecl)
sem_SDecl_Empty  =
    let (_self) =
            SDecl_Empty
    in  (_self)
sem_SDecl_Fixity :: (T_Position) ->
                    (T_Infix) ->
                    (Priority) ->
                    (T_QualNames) ->
                    (T_SDecl)
sem_SDecl_Fixity (_srcloc) (_inf) (_priority) (_ops) =
    let (_self) =
            SDecl_Fixity _srcloc_self _inf_self _priority _ops_self
        ( _srcloc_self) =
            (_srcloc )
        ( _inf_self) =
            (_inf )
        ( _ops_self) =
            (_ops )
    in  (_self)
sem_SDecl_PatBinding :: (T_Position) ->
                        (T_Pattern) ->
                        (T_Rhs) ->
                        (T_SDecls) ->
                        (T_SDecl)
sem_SDecl_PatBinding (_srcloc) (_pat) (_rhs) (_where) =
    let (_self) =
            SDecl_PatBinding _srcloc_self _pat_self _rhs_self
                             _where_self
        ( _srcloc_self) =
            (_srcloc )
        ( _pat_self) =
            (_pat )
        ( _rhs_self) =
            (_rhs )
        ( _where_self) =
            (_where )
    in  (_self)
sem_SDecl_PolyBinding :: (T_Position) ->
                         (T_QualName) ->
                         (T_SType) ->
                         (T_Bindings) ->
                         (T_SDecl)
sem_SDecl_PolyBinding (_srcloc) (_name) (_tp) (_bindings) =
    let (_self) =
            SDecl_PolyBinding _srcloc_self _name_self _tp_self
                              _bindings_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_self) =
            (_name )
        ( _tp_self) =
            (_tp )
        ( _bindings_self) =
            (_bindings )
    in  (_self)
sem_SDecl_PolyTypeSig :: (T_Position) ->
                         (T_QualName) ->
                         (T_PTS) ->
                         (T_SDecl)
sem_SDecl_PolyTypeSig (_srcloc) (_name) (_pts) =
    let (_self) =
            SDecl_PolyTypeSig _srcloc_self _name_self _pts_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_self) =
            (_name )
        ( _pts_self) =
            (_pts )
    in  (_self)
sem_SDecl_TypeSig :: (T_Position) ->
                     (T_QualName) ->
                     (T_QualType) ->
                     (T_SDecl)
sem_SDecl_TypeSig (_srcloc) (_name) (_tp) =
    let (_self) =
            SDecl_TypeSig _srcloc_self _name_self _tp_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_self) =
            (_name )
        ( _tp_self) =
            (_tp )
    in  (_self)
-- SDecls ------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SDecls

-}
{-
   local variables for SDecls.Cons:

-}
{-
   local variables for SDecls.Nil:

-}
-- semantic domain
type T_SDecls = ((SDecls))
-- cata
sem_SDecls :: (SDecls) ->
              (T_SDecls)
sem_SDecls (list) =
    (foldr (sem_SDecls_Cons) (sem_SDecls_Nil) ((map sem_SDecl list)))
sem_SDecls_Cons :: (T_SDecl) ->
                   (T_SDecls) ->
                   (T_SDecls)
sem_SDecls_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_SDecls_Nil :: (T_SDecls)
sem_SDecls_Nil  =
    let 
    in  ([])
-- SExported ---------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:

-}
{-
   local variables for SExported.Id:

-}
-- semantic domain
type T_SExported = ()
-- cata
sem_SExported :: (SExported) ->
                 (T_SExported)
sem_SExported ((SExported_Id (_it))) =
    (sem_SExported_Id ((sem_Exported (_it))))
sem_SExported_Id :: (T_Exported) ->
                    (T_SExported)
sem_SExported_Id (_it) =
    let ( _it_self) =
            (_it )
    in  ()
-- SExpr -------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:

-}
{-
   local variables for SExpr.Id:

-}
-- semantic domain
type T_SExpr = ()
-- cata
sem_SExpr :: (SExpr) ->
             (T_SExpr)
sem_SExpr ((SExpr_Id (_it))) =
    (sem_SExpr_Id ((sem_Expr (_it))))
sem_SExpr_Id :: (T_Expr) ->
                (T_SExpr)
sem_SExpr_Id (_it) =
    let ( _it_self) =
            (_it )
    in  ()
-- SImpdecl ----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:

-}
{-
   local variables for SImpdecl.Id:

-}
-- semantic domain
type T_SImpdecl = ()
-- cata
sem_SImpdecl :: (SImpdecl) ->
                (T_SImpdecl)
sem_SImpdecl ((SImpdecl_Id (_it))) =
    (sem_SImpdecl_Id ((sem_Impdecl (_it))))
sem_SImpdecl_Id :: (T_Impdecl) ->
                   (T_SImpdecl)
sem_SImpdecl_Id (_it) =
    let ( _it_self) =
            (_it )
    in  ()
-- SKind -------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SKind

-}
{-
   local variables for SKind.Arr:

-}
{-
   local variables for SKind.Star:

-}
-- semantic domain
type T_SKind = ((SKind))
-- cata
sem_SKind :: (SKind) ->
             (T_SKind)
sem_SKind ((SKind_Arr (_left) (_right))) =
    (sem_SKind_Arr ((sem_QualName (_left))) ((sem_QualName (_right))))
sem_SKind ((SKind_Star )) =
    (sem_SKind_Star )
sem_SKind_Arr :: (T_QualName) ->
                 (T_QualName) ->
                 (T_SKind)
sem_SKind_Arr (_left) (_right) =
    let ( _left_self) =
            (_left )
        ( _right_self) =
            (_right )
    in  (SKind_Arr _left_self _right_self)
sem_SKind_Star :: (T_SKind)
sem_SKind_Star  =
    let 
    in  (SKind_Star)
-- SModule -----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:

-}
{-
   local variables for SModule.Id:

-}
-- semantic domain
type T_SModule = ()
-- cata
sem_SModule :: (SModule) ->
               (T_SModule)
sem_SModule ((SModule_Id (_it))) =
    (sem_SModule_Id ((sem_Module (_it))))
sem_SModule_Id :: (T_Module) ->
                  (T_SModule)
sem_SModule_Id (_it) =
    let ( _it_self) =
            (_it )
    in  ()
-- SName -------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:

-}
{-
   local variables for SName.Id:

-}
-- semantic domain
type T_SName = ()
-- cata
sem_SName :: (SName) ->
             (T_SName)
sem_SName ((SName_Id (_it))) =
    (sem_SName_Id ((sem_Name (_it))))
sem_SName_Id :: (T_Name) ->
                (T_SName)
sem_SName_Id (_it) =
    let ( _it_self) =
            (_it )
    in  ()
-- SPTS --------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:

-}
{-
   local variables for SPTS.Id:

-}
-- semantic domain
type T_SPTS = ()
-- cata
sem_SPTS :: (SPTS) ->
            (T_SPTS)
sem_SPTS ((SPTS_Id (_it))) =
    (sem_SPTS_Id ((sem_PTS (_it))))
sem_SPTS_Id :: (T_PTS) ->
               (T_SPTS)
sem_SPTS_Id (_it) =
    let ( _it_self) =
            (_it )
    in  ()
-- SQualName ---------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:

-}
{-
   local variables for SQualName.Id:

-}
-- semantic domain
type T_SQualName = ()
-- cata
sem_SQualName :: (SQualName) ->
                 (T_SQualName)
sem_SQualName ((SQualName_Id (_it))) =
    (sem_SQualName_Id ((sem_QualName (_it))))
sem_SQualName_Id :: (T_QualName) ->
                    (T_SQualName)
sem_SQualName_Id (_it) =
    let ( _it_self) =
            (_it )
    in  ()
-- SQualType ---------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:

-}
{-
   local variables for SQualType.Id:

-}
-- semantic domain
type T_SQualType = ()
-- cata
sem_SQualType :: (SQualType) ->
                 (T_SQualType)
sem_SQualType ((SQualType_Id (_it))) =
    (sem_SQualType_Id ((sem_QualType (_it))))
sem_SQualType_Id :: (T_QualType) ->
                    (T_SQualType)
sem_SQualType_Id (_it) =
    let ( _it_self) =
            (_it )
    in  ()
-- SSDecl ------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:

-}
{-
   local variables for SSDecl.Id:

-}
-- semantic domain
type T_SSDecl = ()
-- cata
sem_SSDecl :: (SSDecl) ->
              (T_SSDecl)
sem_SSDecl ((SSDecl_Id (_it))) =
    (sem_SSDecl_Id ((sem_SDecl (_it))))
sem_SSDecl_Id :: (T_SDecl) ->
                 (T_SSDecl)
sem_SSDecl_Id (_it) =
    let ( _it_self) =
            (_it )
    in  ()
-- SSKind ------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:

-}
{-
   local variables for SSKind.Id:

-}
-- semantic domain
type T_SSKind = ()
-- cata
sem_SSKind :: (SSKind) ->
              (T_SSKind)
sem_SSKind ((SSKind_Id (_it))) =
    (sem_SSKind_Id ((sem_SKind (_it))))
sem_SSKind_Id :: (T_SKind) ->
                 (T_SSKind)
sem_SSKind_Id (_it) =
    let ( _it_self) =
            (_it )
    in  ()
-- SStrType ----------------------------------------------------
{-
   inherited attributes:
      deps                 : FMap QualName QualNames

   chained attributes:

   synthesised attributes:
      specs                : (QualName -> Expr,QualName -> Type)

-}
{-
   local variables for SStrType.Id:

-}
-- semantic domain
type T_SStrType = (FMap QualName QualNames) ->
                  (((QualName -> Expr,QualName -> Type)))
-- cata
sem_SStrType :: (SStrType) ->
                (T_SStrType)
sem_SStrType ((SStrType_Id (_it))) =
    (sem_SStrType_Id ((sem_StrType (_it))))
sem_SStrType_Id :: (T_StrType) ->
                   (T_SStrType)
sem_SStrType_Id (_it) (_lhs_deps) =
    let ( _it_spec,_it_spec_t) =
            (_it (_lhs_deps))
    in  ((_it_spec,_it_spec_t))
-- SStrTypeDecl ------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:

-}
{-
   local variables for SStrTypeDecl.Id:

-}
-- semantic domain
type T_SStrTypeDecl = ()
-- cata
sem_SStrTypeDecl :: (SStrTypeDecl) ->
                    (T_SStrTypeDecl)
sem_SStrTypeDecl ((SStrTypeDecl_Id (_it))) =
    (sem_SStrTypeDecl_Id ((sem_StrTypeDecl (_it))))
sem_SStrTypeDecl_Id :: (T_StrTypeDecl) ->
                       (T_SStrTypeDecl)
sem_SStrTypeDecl_Id (_it) =
    let 
    in  ()
-- STB ---------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:

-}
{-
   local variables for STB.Id:

-}
-- semantic domain
type T_STB = ()
-- cata
sem_STB :: (STB) ->
           (T_STB)
sem_STB ((STB_Id (_it))) =
    (sem_STB_Id ((sem_TypedBinding (_it))))
sem_STB_Id :: (T_TypedBinding) ->
              (T_STB)
sem_STB_Id (_it) =
    let 
    in  ()
-- STDecl ------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:

-}
{-
   local variables for STDecl.Id:

-}
-- semantic domain
type T_STDecl = ()
-- cata
sem_STDecl :: (STDecl) ->
              (T_STDecl)
sem_STDecl ((STDecl_Id (_it))) =
    (sem_STDecl_Id ((sem_TDecl (_it))))
sem_STDecl_Id :: (T_TDecl) ->
                 (T_STDecl)
sem_STDecl_Id (_it) =
    let ( _it_self) =
            (_it )
    in  ()
-- SType -------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : SType

-}
{-
   local variables for SType.Con:

-}
{-
   local variables for SType.ConCase:

-}
{-
   local variables for SType.Const:

-}
{-
   local variables for SType.Fun:

-}
{-
   local variables for SType.Label:

-}
{-
   local variables for SType.Prod:

-}
{-
   local variables for SType.Sum:

-}
{-
   local variables for SType.Unit:

-}
{-
   local variables for SType.Var:

-}
-- semantic domain
type T_SType = ((SType))
-- cata
sem_SType :: (SType) ->
             (T_SType)
sem_SType ((SType_Con (_var))) =
    (sem_SType_Con ((sem_QualName (_var))))
sem_SType ((SType_ConCase (_srcloc) (_name))) =
    (sem_SType_ConCase ((sem_Position (_srcloc))) ((sem_QualName (_name))))
sem_SType ((SType_Const (_srcloc) (_name))) =
    (sem_SType_Const ((sem_Position (_srcloc))) ((sem_QualName (_name))))
sem_SType ((SType_Fun )) =
    (sem_SType_Fun )
sem_SType ((SType_Label (_var))) =
    (sem_SType_Label ((sem_QualName (_var))))
sem_SType ((SType_Prod )) =
    (sem_SType_Prod )
sem_SType ((SType_Sum )) =
    (sem_SType_Sum )
sem_SType ((SType_Unit )) =
    (sem_SType_Unit )
sem_SType ((SType_Var (_srcloc) (_name))) =
    (sem_SType_Var ((sem_Position (_srcloc))) ((sem_QualName (_name))))
sem_SType_Con :: (T_QualName) ->
                 (T_SType)
sem_SType_Con (_var) =
    let ( _var_self) =
            (_var )
    in  (SType_Con   _var_self)
sem_SType_ConCase :: (T_Position) ->
                     (T_QualName) ->
                     (T_SType)
sem_SType_ConCase (_srcloc) (_name) =
    let ( _srcloc_self) =
            (_srcloc )
        ( _name_self) =
            (_name )
    in  (SType_ConCase _srcloc_self _name_self)
sem_SType_Const :: (T_Position) ->
                   (T_QualName) ->
                   (T_SType)
sem_SType_Const (_srcloc) (_name) =
    let ( _srcloc_self) =
            (_srcloc )
        ( _name_self) =
            (_name )
    in  (SType_Const   _srcloc_self _name_self)
sem_SType_Fun :: (T_SType)
sem_SType_Fun  =
    let 
    in  (SType_Fun)
sem_SType_Label :: (T_QualName) ->
                   (T_SType)
sem_SType_Label (_var) =
    let ( _var_self) =
            (_var )
    in  (SType_Label _var_self)
sem_SType_Prod :: (T_SType)
sem_SType_Prod  =
    let 
    in  (SType_Prod)
sem_SType_Sum :: (T_SType)
sem_SType_Sum  =
    let 
    in  (SType_Sum)
sem_SType_Unit :: (T_SType)
sem_SType_Unit  =
    let 
    in  (SType_Unit)
sem_SType_Var :: (T_Position) ->
                 (T_QualName) ->
                 (T_SType)
sem_SType_Var (_srcloc) (_name) =
    let ( _srcloc_self) =
            (_srcloc )
        ( _name_self) =
            (_name )
    in  (SType_Var     _srcloc_self _name_self)
-- STypeBindings -----------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:

-}
{-
   local variables for STypeBindings.Id:

-}
-- semantic domain
type T_STypeBindings = ()
-- cata
sem_STypeBindings :: (STypeBindings) ->
                     (T_STypeBindings)
sem_STypeBindings ((STypeBindings_Id (_it))) =
    (sem_STypeBindings_Id ((sem_TypeBindings (_it))))
sem_STypeBindings_Id :: (T_TypeBindings) ->
                        (T_STypeBindings)
sem_STypeBindings_Id (_it) =
    let ( _it_self) =
            (_it )
    in  ()
-- S_Decl ------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:

-}
{-
   local variables for S_Decl.Id:

-}
-- semantic domain
type T_S_Decl = ()
-- cata
sem_S_Decl :: (S_Decl) ->
              (T_S_Decl)
sem_S_Decl ((S_Decl_Id (_it))) =
    (sem_S_Decl_Id ((sem_Decl (_it))))
sem_S_Decl_Id :: (T_Decl) ->
                 (T_S_Decl)
sem_S_Decl_Id (_it) =
    let ( _it_self) =
            (_it )
    in  ()
-- S_Kind ------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:

-}
{-
   local variables for S_Kind.Id:

-}
-- semantic domain
type T_S_Kind = ()
-- cata
sem_S_Kind :: (S_Kind) ->
              (T_S_Kind)
sem_S_Kind ((S_Kind_Id (_it))) =
    (sem_S_Kind_Id ((sem_Kind (_it))))
sem_S_Kind_Id :: (T_Kind) ->
                 (T_S_Kind)
sem_S_Kind_Id (_it) =
    let ( _it_self) =
            (_it )
    in  ()
-- S_Type ------------------------------------------------------
{-
   inherited attributes:
      in                   : (FMap QualName QualNames,Bool,FMap QualName QualName)

   chained attributes:

   synthesised attributes:
      specs                : (QualName -> Expr,QualName -> Type)

-}
{-
   local variables for S_Type.Id:

-}
-- semantic domain
type T_S_Type = ((FMap QualName QualNames,Bool,FMap QualName QualName)) ->
                (((QualName -> Expr,QualName -> Type)))
-- cata
sem_S_Type :: (S_Type) ->
              (T_S_Type)
sem_S_Type ((S_Type_Id (_it))) =
    (sem_S_Type_Id ((sem_Type (_it))))
sem_S_Type_Id :: (T_Type) ->
                 (T_S_Type)
sem_S_Type_Id (_it) (_lhs_in) =
    let ( _it_done,_it_is_var,_it_self,_it_spec,_it_spec_t) =
            (_it ((\(_,x,_) -> x) _lhs_in) ((\(x,_,_) -> x) _lhs_in) ((\(_,_,x) -> x) _lhs_in))
    in  ((_it_spec,_it_spec_t))
-- Stmt --------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Stmt

-}
{-
   local variables for Stmt.Empty:

-}
{-
   local variables for Stmt.Expr:

-}
{-
   local variables for Stmt.Gen:

-}
{-
   local variables for Stmt.Let:

-}
-- semantic domain
type T_Stmt = ((Stmt))
-- cata
sem_Stmt :: (Stmt) ->
            (T_Stmt)
sem_Stmt ((Stmt_Empty )) =
    (sem_Stmt_Empty )
sem_Stmt ((Stmt_Expr (_expr))) =
    (sem_Stmt_Expr ((sem_Expr (_expr))))
sem_Stmt ((Stmt_Gen (_pattern) (_body))) =
    (sem_Stmt_Gen ((sem_Pattern (_pattern))) ((sem_Expr (_body))))
sem_Stmt ((Stmt_Let (_decls))) =
    (sem_Stmt_Let ((sem_SDecls (_decls))))
sem_Stmt_Empty :: (T_Stmt)
sem_Stmt_Empty  =
    let 
    in  (Stmt_Empty)
sem_Stmt_Expr :: (T_Expr) ->
                 (T_Stmt)
sem_Stmt_Expr (_expr) =
    let ( _expr_self) =
            (_expr )
    in  (Stmt_Expr _expr_self)
sem_Stmt_Gen :: (T_Pattern) ->
                (T_Expr) ->
                (T_Stmt)
sem_Stmt_Gen (_pattern) (_body) =
    let ( _pattern_self) =
            (_pattern )
        ( _body_self) =
            (_body )
    in  (Stmt_Gen _pattern_self _body_self)
sem_Stmt_Let :: (T_SDecls) ->
                (T_Stmt)
sem_Stmt_Let (_decls) =
    let ( _decls_self) =
            (_decls )
    in  (Stmt_Let _decls_self)
-- Stmts -------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Stmts

-}
{-
   local variables for Stmts.Cons:

-}
{-
   local variables for Stmts.Nil:

-}
-- semantic domain
type T_Stmts = ((Stmts))
-- cata
sem_Stmts :: (Stmts) ->
             (T_Stmts)
sem_Stmts (list) =
    (foldr (sem_Stmts_Cons) (sem_Stmts_Nil) ((map sem_Stmt list)))
sem_Stmts_Cons :: (T_Stmt) ->
                  (T_Stmts) ->
                  (T_Stmts)
sem_Stmts_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_Stmts_Nil :: (T_Stmts)
sem_Stmts_Nil  =
    let 
    in  ([])
-- StrType -----------------------------------------------------
{-
   inherited attributes:
      deps                 : FMap QualName QualNames

   chained attributes:

   synthesised attributes:
      spec                 : QualName -> Expr
      spec_t               : QualName -> Type

-}
{-
   local variables for StrType.Con:

-}
{-
   local variables for StrType.Fun:

-}
{-
   local variables for StrType.Label:

-}
{-
   local variables for StrType.Prod:

-}
{-
   local variables for StrType.Sum:

-}
{-
   local variables for StrType.Type:

-}
{-
   local variables for StrType.Unit:

-}
-- semantic domain
type T_StrType = (FMap QualName QualNames) ->
                 ((QualName -> Expr),(QualName -> Type))
-- cata
sem_StrType :: (StrType) ->
               (T_StrType)
sem_StrType ((StrType_Con (_descr) (_body))) =
    (sem_StrType_Con ((sem_Expr (_descr))) ((sem_StrType (_body))))
sem_StrType ((StrType_Fun (_left) (_right))) =
    (sem_StrType_Fun ((sem_StrType (_left))) ((sem_StrType (_right))))
sem_StrType ((StrType_Label (_descr) (_body))) =
    (sem_StrType_Label ((sem_Expr (_descr))) ((sem_StrType (_body))))
sem_StrType ((StrType_Prod (_left) (_right))) =
    (sem_StrType_Prod ((sem_StrType (_left))) ((sem_StrType (_right))))
sem_StrType ((StrType_Sum (_left) (_right))) =
    (sem_StrType_Sum ((sem_StrType (_left))) ((sem_StrType (_right))))
sem_StrType ((StrType_Type (_tp))) =
    (sem_StrType_Type ((sem_Type (_tp))))
sem_StrType ((StrType_Unit )) =
    (sem_StrType_Unit )
sem_StrType_Con :: (T_Expr) ->
                   (T_StrType) ->
                   (T_StrType)
sem_StrType_Con (_descr) (_body) (_lhs_deps) =
    let ( _descr_self) =
            (_descr )
        ( _body_spec,_body_spec_t) =
            (_body (_lhs_deps))
    in  (specargs conName   _lhs_deps [_descr_self] [_body_spec],specargs_t conName   _lhs_deps [_body_spec_t])
sem_StrType_Fun :: (T_StrType) ->
                   (T_StrType) ->
                   (T_StrType)
sem_StrType_Fun (_left) (_right) (_lhs_deps) =
    let ( _left_spec,_left_spec_t) =
            (_left (_lhs_deps))
        ( _right_spec,_right_spec_t) =
            (_right (_lhs_deps))
    in  (specargs funName   _lhs_deps [] [_left_spec,_right_spec],specargs_t funName   _lhs_deps [_left_spec_t,_right_spec_t])
sem_StrType_Label :: (T_Expr) ->
                     (T_StrType) ->
                     (T_StrType)
sem_StrType_Label (_descr) (_body) (_lhs_deps) =
    let ( _descr_self) =
            (_descr )
        ( _body_spec,_body_spec_t) =
            (_body (_lhs_deps))
    in  (specargs labelName _lhs_deps [_descr_self] [_body_spec],specargs_t labelName _lhs_deps [_body_spec_t])
sem_StrType_Prod :: (T_StrType) ->
                    (T_StrType) ->
                    (T_StrType)
sem_StrType_Prod (_left) (_right) (_lhs_deps) =
    let ( _left_spec,_left_spec_t) =
            (_left (_lhs_deps))
        ( _right_spec,_right_spec_t) =
            (_right (_lhs_deps))
    in  (specargs prodName  _lhs_deps [] [_left_spec,_right_spec],specargs_t prodName  _lhs_deps [_left_spec_t,_right_spec_t])
sem_StrType_Sum :: (T_StrType) ->
                   (T_StrType) ->
                   (T_StrType)
sem_StrType_Sum (_left) (_right) (_lhs_deps) =
    let ( _left_spec,_left_spec_t) =
            (_left (_lhs_deps))
        ( _right_spec,_right_spec_t) =
            (_right (_lhs_deps))
    in  (specargs sumName   _lhs_deps [] [_left_spec,_right_spec],specargs_t sumName   _lhs_deps [_left_spec_t,_right_spec_t])
sem_StrType_Type :: (T_Type) ->
                    (T_StrType)
sem_StrType_Type (_tp) (_lhs_deps) =
    let ( _tp_done,_tp_is_var,_tp_self,_tp_spec,_tp_spec_t) =
            (_tp (internalError "Specialise.StrType.Type.bimap: not used") (internalError "Specialise.StrType.Type.deps: not used") (internalError "Specialise.StrType.Type.subst: not used"))
    in  (specialiseType _lhs_deps _tp_self,specialiseType_t _lhs_deps _tp_self)
sem_StrType_Unit :: (T_StrType)
sem_StrType_Unit (_lhs_deps) =
    let 
    in  (\gf -> qvarE $ specName gf unitName,\ gf -> qconT $ specTITName gf unitName)
-- StrTypeDecl -------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:

-}
{-
   local variables for StrTypeDecl.Decl:

-}
-- semantic domain
type T_StrTypeDecl = ()
-- cata
sem_StrTypeDecl :: (StrTypeDecl) ->
                   (T_StrTypeDecl)
sem_StrTypeDecl ((StrTypeDecl_Decl (_name) (_args) (_body))) =
    (sem_StrTypeDecl_Decl ((sem_QualName (_name))) ((sem_Args (_args))) ((sem_StrType (_body))))
sem_StrTypeDecl_Decl :: (T_QualName) ->
                        (T_Args) ->
                        (T_StrType) ->
                        (T_StrTypeDecl)
sem_StrTypeDecl_Decl (_name) (_args) (_body) =
    let ( _name_self) =
            (_name )
        ( _args_self) =
            (_args )
        ( _body_spec,_body_spec_t) =
            (_body (internalError "Specialise.StrTypeDecl.Decl.deps: not used"))
    in  ()
-- StrTypes ----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:

-}
{-
   local variables for StrTypes.Cons:

-}
{-
   local variables for StrTypes.Nil:

-}
-- semantic domain
type T_StrTypes = ()
-- cata
sem_StrTypes :: (StrTypes) ->
                (T_StrTypes)
sem_StrTypes (list) =
    (foldr (sem_StrTypes_Cons) (sem_StrTypes_Nil) ((map sem_StrType list)))
sem_StrTypes_Cons :: (T_StrType) ->
                     (T_StrTypes) ->
                     (T_StrTypes)
sem_StrTypes_Cons (_hd) (_tl) =
    let ( _hd_spec,_hd_spec_t) =
            (_hd (internalError "Specialise.StrTypes.Cons.deps: not used"))
    in  ()
sem_StrTypes_Nil :: (T_StrTypes)
sem_StrTypes_Nil  =
    let 
    in  ()
-- TDecl -------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : TDecl

-}
{-
   local variables for TDecl.Class:
      self

-}
{-
   local variables for TDecl.Data:
      self

-}
{-
   local variables for TDecl.Default:
      self

-}
{-
   local variables for TDecl.Dependency:
      self

-}
{-
   local variables for TDecl.Instance:
      self

-}
{-
   local variables for TDecl.New:
      self

-}
{-
   local variables for TDecl.Poly:
      self

-}
{-
   local variables for TDecl.TiType:
      self

-}
{-
   local variables for TDecl.Type:
      self

-}
-- semantic domain
type T_TDecl = ((TDecl))
-- cata
sem_TDecl :: (TDecl) ->
             (T_TDecl)
sem_TDecl ((TDecl_Class (_srcloc) (_context) (_name) (_args) (_decls))) =
    (sem_TDecl_Class ((sem_Position (_srcloc))) ((sem_Context (_context))) ((sem_QualName (_name))) ((sem_Args (_args))) ((sem_SDecls (_decls))))
sem_TDecl ((TDecl_Data (_srcloc) (_context) (_name) (_args) (_conss) (_ders))) =
    (sem_TDecl_Data ((sem_Position (_srcloc))) ((sem_Context (_context))) ((sem_QualName (_name))) ((sem_Args (_args))) ((sem_Constrs (_conss))) ((sem_Derivings (_ders))))
sem_TDecl ((TDecl_Default (_srcloc) (_tps))) =
    (sem_TDecl_Default ((sem_Position (_srcloc))) ((sem_Types (_tps))))
sem_TDecl ((TDecl_Dependency (_srcloc) (_istp) (_name) (_names))) =
    (sem_TDecl_Dependency ((sem_Position (_srcloc))) (_istp) ((sem_QualName (_name))) ((sem_QualNames (_names))))
sem_TDecl ((TDecl_Instance (_srcloc) (_context) (_name) (_tps) (_decls))) =
    (sem_TDecl_Instance ((sem_Position (_srcloc))) ((sem_Context (_context))) ((sem_QualName (_name))) ((sem_Types (_tps))) ((sem_SDecls (_decls))))
sem_TDecl ((TDecl_New (_srcloc) (_context) (_name) (_args) (_cons) (_ders))) =
    (sem_TDecl_New ((sem_Position (_srcloc))) ((sem_Context (_context))) ((sem_QualName (_name))) ((sem_Args (_args))) ((sem_Constr (_cons))) ((sem_Derivings (_ders))))
sem_TDecl ((TDecl_Poly (_srcloc) (_name) (_bindings))) =
    (sem_TDecl_Poly ((sem_Position (_srcloc))) ((sem_QualName (_name))) ((sem_TypeBindings (_bindings))))
sem_TDecl ((TDecl_TiType (_srcloc) (_name) (_tp) (_args) (_cons))) =
    (sem_TDecl_TiType ((sem_Position (_srcloc))) ((sem_QualName (_name))) ((sem_SType (_tp))) ((sem_Args (_args))) ((sem_Constr (_cons))))
sem_TDecl ((TDecl_Type (_srcloc) (_name) (_args) (_tp))) =
    (sem_TDecl_Type ((sem_Position (_srcloc))) ((sem_QualName (_name))) ((sem_Args (_args))) ((sem_Type (_tp))))
sem_TDecl_Class :: (T_Position) ->
                   (T_Context) ->
                   (T_QualName) ->
                   (T_Args) ->
                   (T_SDecls) ->
                   (T_TDecl)
sem_TDecl_Class (_srcloc) (_context) (_name) (_args) (_decls) =
    let (_self) =
            TDecl_Class _srcloc_self _context_self _name_self
                        _args_self _decls_self
        ( _srcloc_self) =
            (_srcloc )
        ( _context_self) =
            (_context )
        ( _name_self) =
            (_name )
        ( _args_self) =
            (_args )
        ( _decls_self) =
            (_decls )
    in  (_self)
sem_TDecl_Data :: (T_Position) ->
                  (T_Context) ->
                  (T_QualName) ->
                  (T_Args) ->
                  (T_Constrs) ->
                  (T_Derivings) ->
                  (T_TDecl)
sem_TDecl_Data (_srcloc) (_context) (_name) (_args) (_conss) (_ders) =
    let (_self) =
            TDecl_Data _srcloc_self _context_self _name_self
                       _args_self _conss_self _ders_self
        ( _srcloc_self) =
            (_srcloc )
        ( _context_self) =
            (_context )
        ( _name_self) =
            (_name )
        ( _args_self) =
            (_args )
        ( _conss_self) =
            (_conss )
        ( _ders_self) =
            (_ders )
    in  (_self)
sem_TDecl_Default :: (T_Position) ->
                     (T_Types) ->
                     (T_TDecl)
sem_TDecl_Default (_srcloc) (_tps) =
    let (_self) =
            TDecl_Default _srcloc_self _tps_self
        ( _srcloc_self) =
            (_srcloc )
        ( _tps_self) =
            (_tps )
    in  (_self)
sem_TDecl_Dependency :: (T_Position) ->
                        (Bool) ->
                        (T_QualName) ->
                        (T_QualNames) ->
                        (T_TDecl)
sem_TDecl_Dependency (_srcloc) (_istp) (_name) (_names) =
    let (_self) =
            TDecl_Dependency _srcloc_self _istp _name_self _names_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_self) =
            (_name )
        ( _names_self) =
            (_names )
    in  (_self)
sem_TDecl_Instance :: (T_Position) ->
                      (T_Context) ->
                      (T_QualName) ->
                      (T_Types) ->
                      (T_SDecls) ->
                      (T_TDecl)
sem_TDecl_Instance (_srcloc) (_context) (_name) (_tps) (_decls) =
    let (_self) =
            TDecl_Instance _srcloc_self _context_self _name_self
                           _tps_self _decls_self
        ( _srcloc_self) =
            (_srcloc )
        ( _context_self) =
            (_context )
        ( _name_self) =
            (_name )
        ( _tps_self) =
            (_tps )
        ( _decls_self) =
            (_decls )
    in  (_self)
sem_TDecl_New :: (T_Position) ->
                 (T_Context) ->
                 (T_QualName) ->
                 (T_Args) ->
                 (T_Constr) ->
                 (T_Derivings) ->
                 (T_TDecl)
sem_TDecl_New (_srcloc) (_context) (_name) (_args) (_cons) (_ders) =
    let (_self) =
            TDecl_New _srcloc_self _context_self _name_self
                      _args_self _cons_self _ders_self
        ( _srcloc_self) =
            (_srcloc )
        ( _context_self) =
            (_context )
        ( _name_self) =
            (_name )
        ( _args_self) =
            (_args )
        ( _cons_self) =
            (_cons )
        ( _ders_self) =
            (_ders )
    in  (_self)
sem_TDecl_Poly :: (T_Position) ->
                  (T_QualName) ->
                  (T_TypeBindings) ->
                  (T_TDecl)
sem_TDecl_Poly (_srcloc) (_name) (_bindings) =
    let (_self) =
            TDecl_Poly _srcloc_self _name_self _bindings_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_self) =
            (_name )
        ( _bindings_self) =
            (_bindings )
    in  (_self)
sem_TDecl_TiType :: (T_Position) ->
                    (T_QualName) ->
                    (T_SType) ->
                    (T_Args) ->
                    (T_Constr) ->
                    (T_TDecl)
sem_TDecl_TiType (_srcloc) (_name) (_tp) (_args) (_cons) =
    let (_self) =
            TDecl_TiType _srcloc_self _name_self _tp_self _args_self
                         _cons_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_self) =
            (_name )
        ( _tp_self) =
            (_tp )
        ( _args_self) =
            (_args )
        ( _cons_self) =
            (_cons )
    in  (_self)
sem_TDecl_Type :: (T_Position) ->
                  (T_QualName) ->
                  (T_Args) ->
                  (T_Type) ->
                  (T_TDecl)
sem_TDecl_Type (_srcloc) (_name) (_args) (_tp) =
    let (_self) =
            TDecl_Type _srcloc_self _name_self _args_self _tp_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_self) =
            (_name )
        ( _args_self) =
            (_args )
        ( _tp_done,_tp_is_var,_tp_self,_tp_spec,_tp_spec_t) =
            (_tp (internalError "Specialise.TDecl.Type.bimap: not used") (internalError "Specialise.TDecl.Type.deps: not used") (internalError "Specialise.TDecl.Type.subst: not used"))
    in  (_self)
-- Type --------------------------------------------------------
{-
   inherited attributes:
      bimap                : Bool
      deps                 : FMap QualName QualNames
      subst                : FMap QualName QualName

   chained attributes:

   synthesised attributes:
      done                 : Bool
      is_var               : Bool
      self                 : Type
      spec                 : QualName -> Expr
      spec_t               : QualName -> Type

-}
{-
   local variables for Type.All:
      self

-}
{-
   local variables for Type.App:
      self

-}
{-
   local variables for Type.Con:
      self
      repl

-}
{-
   local variables for Type.ConCase:
      self

-}
{-
   local variables for Type.Fun:
      self

-}
{-
   local variables for Type.KindApp:
      self

-}
{-
   local variables for Type.Lam:
      self

-}
{-
   local variables for Type.List:
      self

-}
{-
   local variables for Type.Tuple:
      self

-}
{-
   local variables for Type.TypeApp:
      self
      repl

-}
{-
   local variables for Type.Unit:
      self

-}
{-
   local variables for Type.Var:
      self

-}
-- semantic domain
type T_Type = (Bool) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualName) ->
              ((Bool),(Bool),(Type),(QualName -> Expr),(QualName -> Type))
-- cata
sem_Type :: (Type) ->
            (T_Type)
sem_Type ((Type_All (_var) (_body))) =
    (sem_Type_All ((sem_QualName (_var))) ((sem_Type (_body))))
sem_Type ((Type_App (_left) (_right))) =
    (sem_Type_App ((sem_Type (_left))) ((sem_Type (_right))))
sem_Type ((Type_Con (_srcloc) (_name))) =
    (sem_Type_Con ((sem_Position (_srcloc))) ((sem_QualName (_name))))
sem_Type ((Type_ConCase (_srcloc) (_name))) =
    (sem_Type_ConCase ((sem_Position (_srcloc))) ((sem_QualName (_name))))
sem_Type ((Type_Fun )) =
    (sem_Type_Fun )
sem_Type ((Type_KindApp (_srcloc) (_tp) (_kind))) =
    (sem_Type_KindApp ((sem_Position (_srcloc))) ((sem_QualName (_tp))) ((sem_Kind (_kind))))
sem_Type ((Type_Lam (_from) (_body))) =
    (sem_Type_Lam ((sem_QualName (_from))) ((sem_Type (_body))))
sem_Type ((Type_List )) =
    (sem_Type_List )
sem_Type ((Type_Tuple (_n))) =
    (sem_Type_Tuple (_n))
sem_Type ((Type_TypeApp (_srcloc) (_tp) (_type))) =
    (sem_Type_TypeApp ((sem_Position (_srcloc))) ((sem_QualName (_tp))) ((sem_Type (_type))))
sem_Type ((Type_Unit )) =
    (sem_Type_Unit )
sem_Type ((Type_Var (_srcloc) (_name))) =
    (sem_Type_Var ((sem_Position (_srcloc))) ((sem_QualName (_name))))
sem_Type_All :: (T_QualName) ->
                (T_Type) ->
                (T_Type)
sem_Type_All (_var) (_body) (_lhs_bimap) (_lhs_deps) (_lhs_subst) =
    let (_self) =
            Type_All _var_self _body_self
        ( _var_self) =
            (_var )
        ( _body_done,_body_is_var,_body_self,_body_spec,_body_spec_t) =
            (_body (_lhs_bimap) (_lhs_deps) (_lhs_subst))
    in  (_body_done,False,_self,\ gf -> Expr_TyApp genloc (inPrelude "HEREWASALL") _self,\ gf -> allSpecialisationError)
sem_Type_App :: (T_Type) ->
                (T_Type) ->
                (T_Type)
sem_Type_App (_left) (_right) (_lhs_bimap) (_lhs_deps) (_lhs_subst) =
    let (_self) =
            Type_App _left_self _right_self
        ( _left_done,_left_is_var,_left_self,_left_spec,_left_spec_t) =
            (_left (_lhs_bimap) (_lhs_deps) (_lhs_subst))
        ( _right_done,_right_is_var,_right_self,_right_spec,_right_spec_t) =
            (_right (_lhs_bimap) (_lhs_deps) (_lhs_subst))
    in  (_left_done
        ,False
        ,_self
        ,\ gf ->
         if   _left_done
         then (_left_spec gf)
         else if   _left_is_var && _lhs_bimap
              then
                   apply' (Expr_Var genloc liftEPName)
                          [Expr_Parens (_right_spec gf)]
              else let dgfs' = find _lhs_deps gf
                       dgfs  = maybe [gf] id dgfs'
                   in  apply' (_left_spec gf)
                              (map Expr_Parens
                                 (map _right_spec dgfs)
                              )
        ,\ gf -> let dgfs' = find _lhs_deps gf
                     dgfs  = maybe [gf] id dgfs'
                 in  tapply' (_left_spec_t gf) (map _right_spec_t dgfs)
        )
sem_Type_Con :: (T_Position) ->
                (T_QualName) ->
                (T_Type)
sem_Type_Con (_srcloc) (_name) (_lhs_bimap) (_lhs_deps) (_lhs_subst) =
    let (_repl) =
            find _lhs_subst _name_self
        (_self) =
            Type_Con _srcloc_self _name_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_self) =
            (_name )
    in  (isJust _repl
        ,False
        ,_self
        ,\ gf ->
         case _repl of
           Just x | _lhs_bimap -> qvarE $ epName x
           _                   -> qvarE
                                    (specName gf _name_self)
        ,\ gf -> Type_Var genloc $ specTITName gf _name_self
        )
sem_Type_ConCase :: (T_Position) ->
                    (T_QualName) ->
                    (T_Type)
sem_Type_ConCase (_srcloc) (_name) (_lhs_bimap) (_lhs_deps) (_lhs_subst) =
    let (_self) =
            Type_ConCase _srcloc_self _name_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_self) =
            (_name )
    in  (False,False,_self,\ gf -> qvarE $ specName gf (concaseName _name_self),\ gf -> Type_Var genloc $ specTITName gf (concaseName _name_self))
sem_Type_Fun :: (T_Type)
sem_Type_Fun (_lhs_bimap) (_lhs_deps) (_lhs_subst) =
    let (_self) =
            Type_Fun
    in  (False,False,_self,\ gf -> qvarE $ specName gf funName,\ gf -> Type_Var genloc $ specTITName gf funName)
sem_Type_KindApp :: (T_Position) ->
                    (T_QualName) ->
                    (T_Kind) ->
                    (T_Type)
sem_Type_KindApp (_srcloc) (_tp) (_kind) (_lhs_bimap) (_lhs_deps) (_lhs_subst) =
    let (_self) =
            Type_KindApp _srcloc_self _tp_self _kind_self
        ( _srcloc_self) =
            (_srcloc )
        ( _tp_self) =
            (_tp )
        ( _kind_self) =
            (_kind )
    in  (False,False,_self,kindAppSpecialisationError,\ gf -> kindAppSpecialisationError)
sem_Type_Lam :: (T_QualName) ->
                (T_Type) ->
                (T_Type)
sem_Type_Lam (_from) (_body) (_lhs_bimap) (_lhs_deps) (_lhs_subst) =
    let (_self) =
            Type_Lam _from_self _body_self
        ( _from_self) =
            (_from )
        ( _body_done,_body_is_var,_body_self,_body_spec,_body_spec_t) =
            (_body (_lhs_bimap) (_lhs_deps) (_lhs_subst))
    in  (_body_done,_body_is_var,_self,\ gf -> lambdaSpecialisationError,\ gf -> lambdaSpecialisationError)
sem_Type_List :: (T_Type)
sem_Type_List (_lhs_bimap) (_lhs_deps) (_lhs_subst) =
    let (_self) =
            Type_List
    in  (False,False,_self,\ gf -> qvarE $ specName gf hsListName,\ gf -> Type_Var genloc $ specTITName gf hsListName)
sem_Type_Tuple :: (Int) ->
                  (T_Type)
sem_Type_Tuple (_n) (_lhs_bimap) (_lhs_deps) (_lhs_subst) =
    let (_self) =
            Type_Tuple _n
    in  (False,False,_self,\ gf -> qvarE $ specName gf (hsTupleName _n),\ gf -> Type_Var genloc $ specTITName gf pairName)
sem_Type_TypeApp :: (T_Position) ->
                    (T_QualName) ->
                    (T_Type) ->
                    (T_Type)
sem_Type_TypeApp (_srcloc) (_tp) (_type) (_lhs_bimap) (_lhs_deps) (_lhs_subst) =
    let (_repl) =
            find _lhs_subst (mkString _type_self)
        (_self) =
            Type_TypeApp _srcloc_self _tp_self _type_self
        ( _srcloc_self) =
            (_srcloc )
        ( _tp_self) =
            (_tp )
        ( _type_done,_type_is_var,_type_self,_type_spec,_type_spec_t) =
            (_type (_lhs_bimap) (_lhs_deps) (_lhs_subst))
    in  (_lhs_bimap
        ,False
        ,_self
        ,\ gf ->
         case _repl of
           Just x | _lhs_bimap -> qvarE (epName (specTITName _tp_self x))
           _                   -> internalError "Specialise.Type.TypeApp.spec: don't know what to do"
        ,_type_spec_t
        )
sem_Type_Unit :: (T_Type)
sem_Type_Unit (_lhs_bimap) (_lhs_deps) (_lhs_subst) =
    let (_self) =
            Type_Unit
    in  (False,False,_self,\ gf -> qvarE $ specName gf hsUnitName,\ gf -> Type_Var genloc $ specTITName gf hsUnitName)
sem_Type_Var :: (T_Position) ->
                (T_QualName) ->
                (T_Type)
sem_Type_Var (_srcloc) (_name) (_lhs_bimap) (_lhs_deps) (_lhs_subst) =
    let (_self) =
            Type_Var _srcloc_self _name_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_self) =
            (_name )
    in  (False
        ,True
        ,_self
        ,\ gf ->
         if   _lhs_bimap
         then                         Expr_Var genloc idEPName
         else qvarE (prefixName (specName gf _name_self))
        ,\ gf -> Type_Var genloc $ prefixName (specTITName gf _name_self)
        )
-- TypeBinding -------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : TypeBinding

-}
{-
   local variables for TypeBinding.Binding:

-}
-- semantic domain
type T_TypeBinding = ((TypeBinding))
-- cata
sem_TypeBinding :: (TypeBinding) ->
                   (T_TypeBinding)
sem_TypeBinding ((TypeBinding_Binding (_kind) (_lh) (_rh))) =
    (sem_TypeBinding_Binding ((sem_SKind (_kind))) ((sem_Args (_lh))) ((sem_Type (_rh))))
sem_TypeBinding_Binding :: (T_SKind) ->
                           (T_Args) ->
                           (T_Type) ->
                           (T_TypeBinding)
sem_TypeBinding_Binding (_kind) (_lh) (_rh) =
    let ( _kind_self) =
            (_kind )
        ( _lh_self) =
            (_lh )
        ( _rh_done,_rh_is_var,_rh_self,_rh_spec,_rh_spec_t) =
            (_rh (internalError "Specialise.TypeBinding.Binding.bimap: not used") (internalError "Specialise.TypeBinding.Binding.deps: not used") (internalError "Specialise.TypeBinding.Binding.subst: not used"))
    in  (TypeBinding_Binding _kind_self _lh_self
                             _rh_self
        )
-- TypeBindings ------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : TypeBindings

-}
{-
   local variables for TypeBindings.Cons:

-}
{-
   local variables for TypeBindings.Nil:

-}
-- semantic domain
type T_TypeBindings = ((TypeBindings))
-- cata
sem_TypeBindings :: (TypeBindings) ->
                    (T_TypeBindings)
sem_TypeBindings (list) =
    (foldr (sem_TypeBindings_Cons) (sem_TypeBindings_Nil) ((map sem_TypeBinding list)))
sem_TypeBindings_Cons :: (T_TypeBinding) ->
                         (T_TypeBindings) ->
                         (T_TypeBindings)
sem_TypeBindings_Cons (_hd) (_tl) =
    let ( _hd_self) =
            (_hd )
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_TypeBindings_Nil :: (T_TypeBindings)
sem_TypeBindings_Nil  =
    let 
    in  ([])
-- TypedBinding ------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:

-}
{-
   local variables for TypedBinding.TypedBinding:

-}
-- semantic domain
type T_TypedBinding = ()
-- cata
sem_TypedBinding :: (TypedBinding) ->
                    (T_TypedBinding)
sem_TypedBinding ((TypedBinding_TypedBinding (_name) (_context) (_tp) (_bindings))) =
    (sem_TypedBinding_TypedBinding ((sem_QualName (_name))) ((sem_Context (_context))) ((sem_Type (_tp))) ((sem_Bindings (_bindings))))
sem_TypedBinding_TypedBinding :: (T_QualName) ->
                                 (T_Context) ->
                                 (T_Type) ->
                                 (T_Bindings) ->
                                 (T_TypedBinding)
sem_TypedBinding_TypedBinding (_name) (_context) (_tp) (_bindings) =
    let ( _name_self) =
            (_name )
        ( _context_self) =
            (_context )
        ( _tp_done,_tp_is_var,_tp_self,_tp_spec,_tp_spec_t) =
            (_tp (internalError "Specialise.TypedBinding.TypedBinding.bimap: not used") (internalError "Specialise.TypedBinding.TypedBinding.deps: not used") (internalError "Specialise.TypedBinding.TypedBinding.subst: not used"))
        ( _bindings_self) =
            (_bindings )
    in  ()
-- Types -------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Types

-}
{-
   local variables for Types.Cons:

-}
{-
   local variables for Types.Nil:

-}
-- semantic domain
type T_Types = ((Types))
-- cata
sem_Types :: (Types) ->
             (T_Types)
sem_Types (list) =
    (foldr (sem_Types_Cons) (sem_Types_Nil) ((map sem_Type list)))
sem_Types_Cons :: (T_Type) ->
                  (T_Types) ->
                  (T_Types)
sem_Types_Cons (_hd) (_tl) =
    let ( _hd_done,_hd_is_var,_hd_self,_hd_spec,_hd_spec_t) =
            (_hd (internalError "Specialise.Types.Cons.bimap: not used") (internalError "Specialise.Types.Cons.deps: not used") (internalError "Specialise.Types.Cons.subst: not used"))
        ( _tl_self) =
            (_tl )
    in  (_hd_self : _tl_self)
sem_Types_Nil :: (T_Types)
sem_Types_Nil  =
    let 
    in  ([])

