-- do not edit; automatically generated by UU_AG
module GH where

import AbstractD
import AbstractPP

import Maybe

import Utils
import ErrorUtils
import ImportUtils
import FMap
import Pretty
import Name
import qualified PrettyPrint as PP
import ErrorMessages
import qualified List
import qualified Maybe

import qualified StructureTypes as ST

import qualified Type as T
import qualified TypeReduce as TR
import qualified TypeReplace as TRR
import TiTypes

import qualified ExprReplace as ER

import qualified Specialise as SPEC

import qualified PrettyPrintI as PPI

import KindUtils
import IOExts

import IOExts
import Set

mkKindComment name kind        = pp $ comment $ (pretty $ PP.ppQualName False name) 
                                                     ++ " :: " 
                                                     ++ pretty (PP.ppKind False kind)
mkStrTypeComment name          = pp $ comment $ "structure type for " 
                                             ++ (pretty $ PP.ppQualName False name)
mkEPComment name               = pp $ comment $ "EP pair for " 
                                             ++ (pretty $ PP.ppQualName False name)


extractNameFromTB              :: TypedBinding -> QualName
extractNameFromTB (TypedBinding_TypedBinding n _ _ _) = n

extractModuleFromEntity        :: QualName -> Modid
extractModuleFromEntity (QualName_Entity _ (Entity_Entity (Just m) _) _) = m
extractModuleFromEntity q      =  internalError
                                    $ "Exports.extractModuleFromEntity: Can't get module name from " 
                                   ++ show q ++ "\n"
                                   ++ "Should be an entity name."

isExportedModule               :: Exports -> Modid -> Bool
isExportedModule ex m          =  or . map check $ ex
  where check (Export_Module x) =  x == m
        check _                 =  False

isExportedConstructor          :: Exports -> QualName -> QualName -> Modid -> Bool
isExportedConstructor ex n t i =  or . map check $ ex
  where check (Export_TypeAll s)    = s == t
        check (Export_TypeSome s m) = s == t && n `List.elem` m
        check (Export_Module x)     = x == i
        check _                     = False

isExportedValue                :: Exports -> QualName -> Modid -> Bool
isExportedValue ex n i         =  or . map check $ ex
  where check (Export_Var m)    =  m == n
        check (Export_Module x) =  x == i
        check _                 =  False

isExportedAbstract             :: Exports -> QualName -> Modid -> Bool
isExportedAbstract ex n i      =  or . map check $ ex
  where check (Export_Abstract m) = m == n
        check (Export_Module x)   = x == i
        check _                   = False

isExportedType                 :: Exports -> QualName -> Modid -> Bool
isExportedType ex n i          =  or . map check $ ex
  where check (Export_Abstract m)   = m == n
        check (Export_TypeAll m)    = m == n
        check (Export_TypeSome m _) = m == n
        check (Export_Module x)     = x == i
        check _                     = False

isExportedFully                :: Exports -> QualName -> Modid -> Bool
isExportedFully ex n i         =  or . map check $ ex
  where check (Export_TypeAll m) = m == n
        check (Export_Module x)  = x == i
        check _                  = False



exports_iterate                :: Int                       {- how many iterations? -}
                               -> [QualName]                {- initial values -}
                               -> [QualName]                {- initial types -}
                               -> [Request_TypeImply]
                               -> [Request_FunImply]
                               -> (Int                      {- iterations left -}
                                  ,[QualName]               {- final values -}
                                  ,[QualName]               {- final types -}
                                  )

exports_iterate n init_vals init_tps tis fis =
     let vals                  =  List.nub init_vals
         tps                   =  List.nub init_tps
     in  exports_fix n (vals,tps) (vals,tps)
  where
   exports_fix                 :: Int                       {- iteration count -}
                               -> ([QualName],[QualName])   {- accumulator -}
                               -> ([QualName],[QualName])   {- new -}
                               -> (Int,[QualName],[QualName])
   exports_fix n (avals,atps) ([],[]) = (n,avals,atps)
   exports_fix 0 (avals,atps) _       = (-1,avals,atps)
   exports_fix n (avals,atps) (vals,tps) =
     let new_from_vals         =  fun_implications vals
         new_from_tps          =  type_implications tps
         cvals                 =  List.nub new_from_vals
         ctps                  =  List.nub new_from_tps
         rnvals                =  (List.\\) cvals avals
         rntps                 =  (List.\\) ctps  atps
     in  exports_fix (n-1) (rnvals ++ avals,rntps ++ atps) (rnvals,rntps)

   type_implications           :: [QualName] -> [QualName]
   type_implications tps       =
     [ tp
     | t'                      <- tps
     , let t                   =  Type_Con genloc t'
     , (Request_TypeImply (u,ts)) <- tis
     , t `matchType` u
     , x'                      <- ts
     , x                       <- splitType x'
     , let tp                  =  type_to_name x
     ]

   fun_implications            :: [QualName] -> [QualName]
   fun_implications vals       =
     [ val
     | v                       <- vals
     , (Request_FunImply (n,rs)) <- fis
     , v == n
     , (RawRequest (val,_))    <- rs
     ]


type PKT                       =  Kind -> Type

mkImportPKTs                   :: [TDecl] -> FMap QualName PKT
                               -> FMap QualName PKT
mkImportPKTs i dist            =  foldl add' emptyFM i
  where add' fm (TDecl_Poly _ n bd) = 
          let pkt = TRR.makePKT bd dist
          in  add fm (n,pkt)

differentSKind                 :: SKind -> SKind -> Bool
differentSKind SKind_Star (SKind_Arr _ _)  =  True
differentSKind (SKind_Arr _ _) SKind_Star  =  True
differentSKind _ _                         =  False

type PConsigs = FMap QualName ([SType],(Maybe QualName))
type Consigs  = FMap QualName [SType]

consigs_expand :: PConsigs -> Consigs -> Consigs
consigs_expand pcs cs =  mapFM (consig_expand) pcs
  where
  {- consig_expand :: PConsig -> Consig -}
  consig_expand (stps,Nothing) = stps
  consig_expand (stps,Just n ) = let stps' = applyFMM cs (const $ internalError "Consig.consigs_expand: no consig") n
                                 in  {- trace (" unifying: " ++ show stps ++ "\n and: " ++ show stps') $ -} stps `List.union` stps'



{- (moved to Name)
stype_ctor                     :: SType -> QualName
stype_ctor (SType_Const _ n)   =  n
stype_ctor SType_Sum           =  sumName
stype_ctor SType_Prod          =  prodName
stype_ctor (SType_Con _)       =  conName
stype_ctor (SType_Label _)     =  labelName
stype_ctor SType_Unit          =  unitName
stype_ctor (SType_Var _ _)     =  internalError "Components.stype_ctor: Var case called"
stype_ctor (SType_ConCase _ n) =  concaseName n
stype_ctor SType_Fun           =  funName
-}

stype_ctpprefix                 :: SType -> (Type -> Type)
stype_ctpprefix (SType_Con _)   =  arr (Type_Var genloc condescrName)
stype_ctpprefix (SType_Label _) =  arr (Type_Var genloc labeldescrName)
stype_ctpprefix (SType_Const _ n)
  | n == conName                =  arr (Type_Var genloc condescrName)
  | n == labelName              =  arr (Type_Var genloc labeldescrName)
stype_ctpprefix _               =  id

stype_eargs                     :: SType -> QualNames
stype_eargs (SType_Con n)       =  [n]
stype_eargs (SType_Label n)     =  [n]
stype_eargs _                   =  []


makeComponent                  :: Kind     {- kind of the type -}
                               -> (Context,PKType) {- type of the generic function -}
                               -> QualName {- name of the generic function -}
                               -> SType   
                               -> QualNames
                               -> Set QualName {- generic abstractions -}
                               -> FMap QualName QualNames {- dependencies -}
                               -> Bindings {- bindings of the component -}
                               -> TypedBinding
makeComponent k (ctx,pkt) cn stp eargs gas deps bindings =
  let ct                       =  stype_ctor stp
      ctpp                     =  stype_ctpprefix stp
      tp                       =  handleTiTypes deps
                               .  T.makeRank2Type
                               .  ctpp  
                               $  TR.reduce (pkt k) [Type_Con genloc ct]
  in  TypedBinding_TypedBinding (componentName cn ct)
                                ctx
                                tp
                                (map (addArgs eargs
				     . ER.replaceBinding deps emptyFM gas)
				     bindings)
 where addArgs                 :: [QualName] -> Binding -> Binding
       addArgs ns (Binding_Binding lh rh w) 
                               =  Binding_Binding (map Pattern_Var ns ++ lh)
                                                  rh w


request_iterate                :: Int                         {- how many iterations? -}
                               -> [RawRequest]                {- new requests -}
                               -> Set QualName                {- generic abstractions -}
                               -> [Request_TypeImply]
                               -> [Request_BimapImply]
                               -> [Request_FunImply]
                               -> FMap QualName [Type]        {- consigs -}
                               -> (Int                        {- iterations left -}
                                  ,[RawRequest]               {- final genabs requests -}
                                  ,[RawRequest]               {- final mpc requests -}
                                  )

request_iterate n rs genabs tis bis fis consigs =
    let (gas,mpcs)             =  clean_requests rs
    in  request_fix n (gas,mpcs) (gas,mpcs) 
 where
  request_fix                  :: Int                         {- iteration count -}
                               -> ([RawRequest],[RawRequest]) {- accumulator -}
                               -> ([RawRequest],[RawRequest]) {- new -}
                               -> (Int,[RawRequest],[RawRequest])
  request_fix n (agas,ampcs) ([],[]) = (n,agas,ampcs)
  request_fix 0 (agas,ampcs) _ =  (-1,agas,ampcs)
  request_fix n (agas,ampcs) (gas,mpcs) =
    let new_from_mpcs          =  bimap_implications mpcs ++ type_implications mpcs ++ fun_implications mpcs
        new_from_gas           =  fun_implications gas
        (cgas,cmpcs)           =  clean_requests (new_from_mpcs ++ new_from_gas) 
        (rngas,rnmpcs)         =  ((List.\\) cgas agas,(List.\\) cmpcs ampcs)
    in  request_fix (n-1) (rngas ++ agas,rnmpcs ++ ampcs) (rngas,rnmpcs)
      
  clean_requests               :: [RawRequest] -> ([RawRequest],[RawRequest])
  clean_requests rs            =
    let (gas,mpcs)             =  List.partition (\(RawRequest (n,t)) -> n `Set.elementOf` genabs) rs
        nubbed_gas             =  List.nub gas
        splitted_mpcs          =  List.nub [ RawRequest (n,x)
                                           | (RawRequest (n,t)) <- mpcs
                                           , x <- splitType t
                                           ]
    in  (nubbed_gas,splitted_mpcs)

  type_implications            :: [RawRequest] -> [RawRequest]
  type_implications rs         =
   {- (old, but seemingly correct version) -
    let consigs_for n          =  applyFMM consigs (const []) n
        filtered_rs            =  filter (\(RawRequest (n,t)) -> 
                                             Maybe.isNothing (List.find (matchType t) (consigs_for n))) rs
        run x (Request_TypeImply (t,ts)) = if x `matchType` t then ts else []
    in  [ RawRequest (n,x)
        | (RawRequest (n,t)) <- filtered_rs
        , x <- concatMap (run t) tis
        ]
   -}
   {- (seems much clearer; is it correct, too?) -}
     [ RawRequest (n,x)
     | (RawRequest (n,t))         <- rs
     , let consigs_for = applyFMM consigs (const []) n
     , Maybe.isNothing (List.find (matchType t) consigs_for) {- should not be component request -}
     , (Request_TypeImply (u,ts)) <- tis
     , t `matchType` u
     , x <- ts
     ]

  bimap_implications           :: [RawRequest] -> [RawRequest]
  bimap_implications rs        =  [ RawRequest (bimapName,x)
                                  | (RawRequest (n,_))         <- rs
                                  , (Request_BimapImply (m,x)) <- bis
                                  , n == m
                                  ]

  fun_implications             :: [RawRequest] -> [RawRequest]
  fun_implications rs          =  [ RawRequest (nn,nt)
                                  | (RawRequest (n,t))         <- rs
                                  , (Request_FunImply (m,fs))  <- fis
                                  , n == m
                                  , (RawRequest (nn,ntf))      <- fs
                                  , let nt = TR.reduce ntf [t]
                                  ]



stype_to_type                  :: SType -> Type
stype_to_type (SType_Const l n)=  Type_Con l n
stype_to_type (SType_Var l n)  =  Type_Var l n
stype_to_type (SType_ConCase l n)=Type_ConCase l n
stype_to_type (SType_Sum)      =  Type_Con genloc sumName
stype_to_type (SType_Prod)     =  Type_Con genloc prodName
stype_to_type (SType_Con _)    =  Type_Con genloc conName
stype_to_type (SType_Label _)  =  Type_Con genloc labelName
stype_to_type (SType_Fun)      =  Type_Con genloc funName
stype_to_type (SType_Unit)     =  Type_Con genloc unitName

type_to_name                   :: Type -> QualName
type_to_name (Type_Con l n)    =  n
type_to_name (Type_Var l n)    =  n
type_to_name (Type_ConCase l n)=  concaseName n
type_to_name (Type_Unit)       =  hsUnitName
type_to_name (Type_List)       =  hsListName
type_to_name (Type_Fun)        =  funName {- should be hsFunName !! -}
type_to_name (Type_Tuple n)    =  hsTupleName n
type_to_name (Type_KindApp _ _ _)=internalError "Request.type_to_name: kindapp not yet implemented"
type_to_name (Type_TypeApp _ _ _)=internalError "Request.type_to_name: typeapp not yet implemented"
type_to_name (Type_Lam _ _)    =  internalError "Request.type_to_name: lambda not yet implemented"
type_to_name (Type_All _ _)    =  internalError "Request.type_to_name: forall not yet implemented"



showTypeImply                            :: Request_TypeImply -> String
showTypeImply (Request_TypeImply (t,ts)) =  let l   = "? __ " ++ pretty (PP.ppType True t)
                                                ind = replicate ((30 - length l) `max` 0) ' '
                                            in  pretty 
                                              $ l ++ ind ++ " =>" 
                                             >#< vlist (map (\t -> ("? __" >#< PP.ppType True t)) ts)

showBimapImply                           :: Request_BimapImply -> String
showBimapImply (Request_BimapImply (n,t))=  let l   = pretty (PP.ppQualName True n) ++ " __ ?"
                                                ind = replicate ((30 - length l) `max` 0) ' '
                                            in  l ++ ind ++ " => " 
                                             ++ (pretty $ PP.ppQualName True bimapName) ++ " __ "
                                             ++ (pretty $ PP.ppType True t)

showFunImply                             :: Request_FunImply -> String
showFunImply (Request_FunImply (n,r))    =  let l   = pretty (PP.ppQualName True n) ++ " __ ?"
                                                ind = replicate ((30 - length l) `max` 0) ' '
                                            in  pretty $ l ++ ind ++ " =>" >#< vlist (map showrreq r)
  where showrreq (RawRequest (n,t))      =  PP.ppQualName True n >|< " __ " >|< PP.ppType True t

showRawRequest                           :: RawRequest -> String
showRawRequest (RawRequest (n,t))        =  let l   = pretty $ PP.ppQualName True n
                                                ind = replicate ((30 - length l) `max` 0) ' '
                                            in  l ++ ind ++ " __ " ++ (pretty $ PP.ppType True t)

showRequest                              :: Request -> String
showRequest (f,StrTypeDecl_Decl t _ _,_) =  let l   = pretty $ PP.ppQualName True f
                                                ind = replicate ((30 - length l) `max` 0) ' '
                                            in  l ++ ind ++ " __ " ++ (pretty $ PP.ppQualName True t)


isUnit                         :: SType -> Bool
isUnit SType_Unit              =  True
isUnit _                       =  False


showRequestTIT                              :: RequestTIT -> String
showRequestTIT (f,StrTypeDecl_Decl t _ _,_) = let l   = pretty $ PP.ppQualName True f
                                                  ind = replicate ((30 - length l) `max` 0) ' '
                                              in  l ++ ind ++ " __ " ++ (pretty $ PP.ppQualName True t)


makeNonRec                     :: (Context,Type)  {- type of function; parametrised by tyvar -}
                               -> QualName        {- name of function -}
                               -> QualName        {- tyvar occuring in body -}
                               -> Set QualName    {- generic abstractions -}
                               -> FMap QualName QualNames {- dependencies -}
                               -> Bindings        {- body -}
                               -> RawRequest      {- request to be handled; contains type -}
                               -> TypedBinding
makeNonRec (ctx,tp) nrn tv gas deps bindings (RawRequest (_,tpexp)) =
  let {- we extract the type name from the structure type declaration -}
      final_tp                 =  handleTiTypes deps
                               .  T.makeRank2Type
                               $  TR.reduce tp [tpexp]
      r_env                    =  fromList [(tv,tpexp)]
  in  TypedBinding_TypedBinding (specGAName nrn tpexp)
                                ctx
                                final_tp
                                {- replace the expressions/rhs
                                   in the bindings
                                -}
                                (map (ER.replaceBinding deps r_env gas)
                                     bindings
                                )

ptsMissingError                :: QualName -> a
ptsMissingError v              =
  unstaticError $ "Generic function " ++ pretty (PP.ppQualName False v) ++ " has no type signature.\n"

illegalVariableUseError        :: a
illegalVariableUseError        = 
  unstaticError "illegal use of variable in component of generic function"

mkKindVar                       :: Int -> QualName
mkKindVar n                     =  QualName_Plain unkrange . Name_Special unkrange
                                $ "_kv" ++ show n {- special? -}

mkKindVar'                      :: Int -> Kind
mkKindVar'                      =  Kind_Var . mkKindVar

unifyToplevel                   :: Position -> PP_Doc -> String 
                                -> Kind -> Kind -> KSubst -> (KSubst,[GHError])
unifyToplevel sl n d k1 k2 s    =  unifyWithError (GHError_KindUTError sl n d (applyKind s k2) 
                                                                              (applyKind s k1)
                                                  ) k1 k2 s

unifyWithError                  :: GHError -> Kind -> Kind -> KSubst -> (KSubst,[GHError])
unifyWithError e k1 k2 s        =  let (sub,succeed) = unify k1 k2 s 
                                   in  (sub,if succeed then [] else [e])


apply                          :: T_Expr -> [T_Expr] -> T_Expr
apply                          =  foldl sem_Expr_App

tapply                         :: T_Type -> [T_Type] -> T_Type
tapply                         =  foldl sem_Type_App



{-

We have different implication types:

TypeImply:  "If you specialise whatever to this type, you also have to specialise whatever
             to these other types"

BimapImply: "If you specialise this function to whatever, you also have to specialise 
             bimap to this type"

FunImply:   "If you specialise this function to type t, you also have to perform all the
             provided requests, but apply t to their type first"

-}

newtype Request_TypeImply      =  Request_TypeImply  (Type,[Type])
newtype Request_BimapImply     =  Request_BimapImply (QualName,Type)
newtype Request_FunImply       =  Request_FunImply   (QualName,[RawRequest])
newtype RawRequest             =  RawRequest         (QualName,Type)

instance Eq RawRequest where
  RawRequest (n1,t1) == RawRequest (n2,t2) = n1 == n2 && t1 `matchType` t2

type Request                   =  (QualName,StrTypeDecl,PTS)
                    {- (generic function name
                       ,type name
                       ,generic function type signature
                       )
                    -}
type Requests                  =  [Request]

{- These functions should probably be moved to |Type| -}

splitType                      :: Type -> [Type]
splitType (Type_App l r)       =  splitType l ++ splitType r
splitType (Type_Lam _ t)       =  splitType t {- we ignore for convenience; cf. bimap implications -}
splitType (Type_All _ t)       =  splitType t {- this might be wrong, though ?? -}
splitType (Type_Var _ _)       =  []
splitType t@(Type_Con _ _)     =  [t]
splitType t@Type_Unit          =  [t]
splitType t@Type_List          =  [t]
splitType t@Type_Fun           =  [t]
splitType t@(Type_Tuple _)     =  [t]
splitType (Type_KindApp _ _ _) =  internalError "Request.splitType: kind application not implemented"
{- bimap specialisation requests may contain ti-types -}
splitType (Type_TypeApp _ _ _) =  [] -- internalError "Request.splitType: type application not implemented"
splitType t@(Type_ConCase _ _) =  [t]

simpleType                     :: Type -> Bool
simpleType (Type_Con _ _)      =  True
simpleType (Type_ConCase _ _)  =  True
simpleType Type_Unit           =  True
simpleType Type_List           =  True
simpleType Type_Fun            =  True
simpleType (Type_Tuple _)      =  True
simpleType _                   =  False

matchType                                   :: Type -> Type -> Bool
matchType (Type_App l1 r1) (Type_App l2 r2) =  matchType l1 l2 && matchType r1 r2
matchType (Type_Lam _ _) (Type_Lam _ _)     =  False {- ?? -}
matchType (Type_All _ _) (Type_All _ _)     =  False {- ?? -}
matchType (Type_Var _ v1) (Type_Var _ v2)   =  False {- ?? -}
matchType (Type_Con _ c1) (Type_Con _ c2)   =  c1 == c2
matchType Type_Unit Type_Unit               =  True
matchType Type_Unit o                       =  matchType (Type_Con genloc hsUnitName) o
matchType o Type_Unit                       =  matchType o (Type_Con genloc hsUnitName)
matchType Type_List Type_List               =  True
matchType Type_List o                       =  matchType (Type_Con genloc hsListName) o
matchType o Type_List                       =  matchType o (Type_Con genloc hsListName)
matchType Type_Fun  Type_Fun                =  True
matchType Type_Fun o                        =  matchType (Type_Con genloc hsFunName) o
matchType o Type_Fun                        =  matchType o (Type_Con genloc hsFunName)
matchType (Type_Tuple n1) (Type_Tuple n2)   =  n1 == n2
matchType (Type_Tuple n1) o                 =  matchType (Type_Con genloc $ hsTupleName n1) o
matchType o (Type_Tuple n2)                 =  matchType o (Type_Con genloc $ hsTupleName n2)
matchType (Type_ConCase _ n1) (Type_ConCase _ n2) = n1 == n2
matchType (Type_ConCase l n1) o             =  matchType (Type_Con l $ concaseName n1) o
matchType o (Type_ConCase l n2)             =  matchType o (Type_Con l $ concaseName n2)
matchType _ _                               =  False {- ?? -}

extracttitypes                     :: Type -> [RawRequest]
extracttitypes (Type_Lam v b)      =  [ RawRequest (f,Type_Lam v tp)
                                      | RawRequest (f,tp) <- extracttitypes $ TR.reduce b []
                                      ]
extracttitypes (Type_TypeApp _ t a)=  [RawRequest (t,a)]
extracttitypes (Type_App l r)      =  extracttitypes l ++ extracttitypes r
extracttitypes (Type_All v b)      =  extracttitypes b
extracttitypes _                   =  []


type RequestTIT                =  (QualName,StrTypeDecl,TDecl)
type RequestTITs               =  [Request]
-- Alt ---------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Alt

-}
{-
   local variables for Alt.Alt:

-}
{-
   local variables for Alt.Empty:

-}
-- semantic domain
type T_Alt = (Set QualName) ->
             ([Request_BimapImply]) ->
             (Maybe QualName) ->
             (Consigs) ->
             (FMap QualName QualNames) ->
             (FMap QualName QualNames) ->
             (Modid) ->
             (FMap QualName QualNames) ->
             (FMap QualName QualNames) ->
             (Set QualName) ->
             (Set QualName) ->
             (Exports) ->
             ([Request_FunImply]) ->
             (Set QualName) ->
             (Set QualName) ->
             (Set QualName) ->
             (Set QualName) ->
             (Bool) ->
             ([Request_TypeImply]) ->
             (Set QualName) ->
             (Set QualName) ->
             (Bool) ->
             (Set QualName) ->
             (Set QualName) ->
             (KSubst) ->
             (KSubst) ->
             (Int) ->
             (KSubst) ->
             (Bool) ->
             (FMap QualName QualNames) ->
             (FMap QualName QualNames) ->
             (Set Modid) ->
             (PConsigs) ->
             (PConsigs) ->
             (FMap QualName PKT) ->
             (FMap QualName PKT) ->
             (KSubst) ->
             (FMap QualName PTS) ->
             (FMap QualName PTS) ->
             ([RawRequest]) ->
             ([RawRequest]) ->
             (Bool) ->
             (Int) ->
             ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Alt))
-- cata
sem_Alt :: (Alt) ->
           (T_Alt)
sem_Alt ((Alt_Alt (_pattern) (_cs) (_where))) =
    (sem_Alt_Alt ((sem_Pattern (_pattern))) ((sem_Case (_cs))) ((sem_SDecls (_where))))
sem_Alt ((Alt_Empty )) =
    (sem_Alt_Empty )
sem_Alt_Alt :: (T_Pattern) ->
               (T_Case) ->
               (T_SDecls) ->
               (T_Alt)
sem_Alt_Alt (_pattern)
            (_cs)
            (_where)
            (_lhs_abstracttps_collect)
            (_lhs_bimapimps_collect)
            (_lhs_classname)
            (_lhs_consigs)
            (_lhs_constructors_collect)
            (_lhs_constructors_dist)
            (_lhs_currentModule)
            (_lhs_deps)
            (_lhs_deps_collect)
            (_lhs_exportedTypes)
            (_lhs_exportedValues)
            (_lhs_exports)
            (_lhs_funimps_collect)
            (_lhs_genabs)
            (_lhs_genabs_collect)
            (_lhs_hiddenTypes)
            (_lhs_hiddenValues)
            (_lhs_hiding)
            (_lhs_implications_collect)
            (_lhs_impliedTypes)
            (_lhs_impliedValues)
            (_lhs_importedModule)
            (_lhs_importedTypes)
            (_lhs_importedValues)
            (_lhs_kinames)
            (_lhs_kinds)
            (_lhs_kindvar)
            (_lhs_ksubst)
            (_lhs_local)
            (_lhs_methods_collect)
            (_lhs_methods_dist)
            (_lhs_modules)
            (_lhs_pconsigs)
            (_lhs_pconsigs_col)
            (_lhs_pktcoll)
            (_lhs_pktdist)
            (_lhs_prekind)
            (_lhs_ptscoll)
            (_lhs_ptsdist)
            (_lhs_rawrequest_collect)
            (_lhs_requests_gas)
            (_lhs_toplevel)
            (_lhs_verbosity) =
    let ( _pattern_abstracttps_collect,_pattern_bimapimps_collect,_pattern_constructors_collect,_pattern_deps_collect,_pattern_exports_collect,_pattern_funimps_collect,_pattern_genabs_collect,_pattern_implications_collect,_pattern_imports_collect,_pattern_initialTypes,_pattern_initialValues,_pattern_methods_collect,_pattern_nonrecs,_pattern_pconsigs_col,_pattern_pktcoll,_pattern_ptscoll,_pattern_rawrequest_collect,_pattern_self) =
            (_pattern (_lhs_abstracttps_collect)
                      (_lhs_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_lhs_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_lhs_funimps_collect)
                      (_lhs_genabs)
                      (_lhs_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_lhs_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_pconsigs)
                      (_lhs_pconsigs_col)
                      (_lhs_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_ptscoll)
                      (_lhs_ptsdist)
                      (_lhs_rawrequest_collect)
                      (_lhs_toplevel))
        ( _cs_abstracttps_collect,_cs_bimapimps_collect,_cs_constructors_collect,_cs_deps_collect,_cs_exports_collect,_cs_funimps_collect,_cs_genabs_collect,_cs_implications_collect,_cs_imports_collect,_cs_initialTypes,_cs_initialValues,_cs_kinames,_cs_kindvar,_cs_ksubst,_cs_methods_collect,_cs_nonrecs,_cs_pconsigs_col,_cs_pktcoll,_cs_ptscoll,_cs_rawrequest_collect,_cs_self) =
            (_cs (_pattern_abstracttps_collect)
                 (_pattern_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_pattern_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_pattern_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_pattern_funimps_collect)
                 (_lhs_genabs)
                 (_pattern_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_pattern_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kinds)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_pattern_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_pattern_pconsigs_col)
                 (_pattern_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_pattern_ptscoll)
                 (_lhs_ptsdist)
                 (_pattern_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
        ( _where_abstracttps_collect
         ,_where_bimapimps_collect
         ,_where_constructors_collect
         ,_where_count
         ,_where_deps_collect
         ,_where_exports_collect
         ,_where_funimps_collect
         ,_where_genabs_collect
         ,_where_implications_collect
         ,_where_imports_collect
         ,_where_initialTypes
         ,_where_initialValues
         ,_where_kinames
         ,_where_kindvar
         ,_where_ksubst
         ,_where_methods_collect
         ,_where_nil
         ,_where_nonrecs
         ,_where_pconsigs_col
         ,_where_pktcoll
         ,_where_ptscoll
         ,_where_rawrequest_collect
         ,_where_self
         ) =
            (_where (_cs_abstracttps_collect)
                    (_cs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_cs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_cs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_cs_funimps_collect)
                    (_lhs_genabs)
                    (_cs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_cs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_cs_kinames)
                    (_lhs_kinds)
                    (_cs_kindvar)
                    (_cs_ksubst)
                    (_lhs_local)
                    (_cs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_cs_pconsigs_col)
                    (_cs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_cs_ptscoll)
                    (_lhs_ptsdist)
                    (_cs_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_toplevel)
                    (_lhs_verbosity))
    in  (_where_abstracttps_collect
        ,_where_bimapimps_collect
        ,_where_constructors_collect
        ,_where_deps_collect
        ,_pattern_exports_collect ++ _cs_exports_collect ++ _where_exports_collect
        ,_where_funimps_collect
        ,_where_genabs_collect
        ,_where_implications_collect
        ,_pattern_imports_collect ++ _cs_imports_collect ++ _where_imports_collect
        ,_pattern_initialTypes ++ _cs_initialTypes ++ _where_initialTypes
        ,_pattern_initialValues ++ _cs_initialValues ++ _where_initialValues
        ,_where_kinames
        ,_where_kindvar
        ,_where_ksubst
        ,_where_methods_collect
        ,_pattern_nonrecs ++ _cs_nonrecs ++ _where_nonrecs
        ,_where_pconsigs_col
        ,_where_pktcoll
        ,_where_ptscoll
        ,_where_rawrequest_collect
        ,Alt_Alt _pattern_self _cs_self _where_self
        )
sem_Alt_Empty :: (T_Alt)
sem_Alt_Empty (_lhs_abstracttps_collect)
              (_lhs_bimapimps_collect)
              (_lhs_classname)
              (_lhs_consigs)
              (_lhs_constructors_collect)
              (_lhs_constructors_dist)
              (_lhs_currentModule)
              (_lhs_deps)
              (_lhs_deps_collect)
              (_lhs_exportedTypes)
              (_lhs_exportedValues)
              (_lhs_exports)
              (_lhs_funimps_collect)
              (_lhs_genabs)
              (_lhs_genabs_collect)
              (_lhs_hiddenTypes)
              (_lhs_hiddenValues)
              (_lhs_hiding)
              (_lhs_implications_collect)
              (_lhs_impliedTypes)
              (_lhs_impliedValues)
              (_lhs_importedModule)
              (_lhs_importedTypes)
              (_lhs_importedValues)
              (_lhs_kinames)
              (_lhs_kinds)
              (_lhs_kindvar)
              (_lhs_ksubst)
              (_lhs_local)
              (_lhs_methods_collect)
              (_lhs_methods_dist)
              (_lhs_modules)
              (_lhs_pconsigs)
              (_lhs_pconsigs_col)
              (_lhs_pktcoll)
              (_lhs_pktdist)
              (_lhs_prekind)
              (_lhs_ptscoll)
              (_lhs_ptsdist)
              (_lhs_rawrequest_collect)
              (_lhs_requests_gas)
              (_lhs_toplevel)
              (_lhs_verbosity) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_kinames,_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,Alt_Empty)
-- Alts --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Alts

-}
{-
   local variables for Alts.Cons:

-}
{-
   local variables for Alts.Nil:

-}
-- semantic domain
type T_Alts = (Set QualName) ->
              ([Request_BimapImply]) ->
              (Maybe QualName) ->
              (Consigs) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Modid) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Set QualName) ->
              (Set QualName) ->
              (Exports) ->
              ([Request_FunImply]) ->
              (Set QualName) ->
              (Set QualName) ->
              (Set QualName) ->
              (Set QualName) ->
              (Bool) ->
              ([Request_TypeImply]) ->
              (Set QualName) ->
              (Set QualName) ->
              (Bool) ->
              (Set QualName) ->
              (Set QualName) ->
              (KSubst) ->
              (KSubst) ->
              (Int) ->
              (KSubst) ->
              (Bool) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Set Modid) ->
              (PConsigs) ->
              (PConsigs) ->
              (FMap QualName PKT) ->
              (FMap QualName PKT) ->
              (KSubst) ->
              (FMap QualName PTS) ->
              (FMap QualName PTS) ->
              ([RawRequest]) ->
              ([RawRequest]) ->
              (Bool) ->
              (Int) ->
              ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Alts))
-- cata
sem_Alts :: (Alts) ->
            (T_Alts)
sem_Alts (list) =
    (foldr (sem_Alts_Cons) (sem_Alts_Nil) ((map sem_Alt list)))
sem_Alts_Cons :: (T_Alt) ->
                 (T_Alts) ->
                 (T_Alts)
sem_Alts_Cons (_hd)
              (_tl)
              (_lhs_abstracttps_collect)
              (_lhs_bimapimps_collect)
              (_lhs_classname)
              (_lhs_consigs)
              (_lhs_constructors_collect)
              (_lhs_constructors_dist)
              (_lhs_currentModule)
              (_lhs_deps)
              (_lhs_deps_collect)
              (_lhs_exportedTypes)
              (_lhs_exportedValues)
              (_lhs_exports)
              (_lhs_funimps_collect)
              (_lhs_genabs)
              (_lhs_genabs_collect)
              (_lhs_hiddenTypes)
              (_lhs_hiddenValues)
              (_lhs_hiding)
              (_lhs_implications_collect)
              (_lhs_impliedTypes)
              (_lhs_impliedValues)
              (_lhs_importedModule)
              (_lhs_importedTypes)
              (_lhs_importedValues)
              (_lhs_kinames)
              (_lhs_kinds)
              (_lhs_kindvar)
              (_lhs_ksubst)
              (_lhs_local)
              (_lhs_methods_collect)
              (_lhs_methods_dist)
              (_lhs_modules)
              (_lhs_pconsigs)
              (_lhs_pconsigs_col)
              (_lhs_pktcoll)
              (_lhs_pktdist)
              (_lhs_prekind)
              (_lhs_ptscoll)
              (_lhs_ptsdist)
              (_lhs_rawrequest_collect)
              (_lhs_requests_gas)
              (_lhs_toplevel)
              (_lhs_verbosity) =
    let ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_kinames,_hd_kindvar,_hd_ksubst,_hd_methods_collect,_hd_nonrecs,_hd_pconsigs_col,_hd_pktcoll,_hd_ptscoll,_hd_rawrequest_collect,_hd_self) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kinds)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_initialTypes,_tl_initialValues,_tl_kinames,_tl_kindvar,_tl_ksubst,_tl_methods_collect,_tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_ptscoll,_tl_rawrequest_collect,_tl_self) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_hd_kinames)
                 (_lhs_kinds)
                 (_hd_kindvar)
                 (_hd_ksubst)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_hd_ptscoll)
                 (_lhs_ptsdist)
                 (_hd_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
    in  (_tl_abstracttps_collect
        ,_tl_bimapimps_collect
        ,_tl_constructors_collect
        ,_tl_deps_collect
        ,_hd_exports_collect ++ _tl_exports_collect
        ,_tl_funimps_collect
        ,_tl_genabs_collect
        ,_tl_implications_collect
        ,_hd_imports_collect ++ _tl_imports_collect
        ,_hd_initialTypes ++ _tl_initialTypes
        ,_hd_initialValues ++ _tl_initialValues
        ,_tl_kinames
        ,_tl_kindvar
        ,_tl_ksubst
        ,_tl_methods_collect
        ,_hd_nonrecs ++ _tl_nonrecs
        ,_tl_pconsigs_col
        ,_tl_pktcoll
        ,_tl_ptscoll
        ,_tl_rawrequest_collect
        ,_hd_self : _tl_self
        )
sem_Alts_Nil :: (T_Alts)
sem_Alts_Nil (_lhs_abstracttps_collect)
             (_lhs_bimapimps_collect)
             (_lhs_classname)
             (_lhs_consigs)
             (_lhs_constructors_collect)
             (_lhs_constructors_dist)
             (_lhs_currentModule)
             (_lhs_deps)
             (_lhs_deps_collect)
             (_lhs_exportedTypes)
             (_lhs_exportedValues)
             (_lhs_exports)
             (_lhs_funimps_collect)
             (_lhs_genabs)
             (_lhs_genabs_collect)
             (_lhs_hiddenTypes)
             (_lhs_hiddenValues)
             (_lhs_hiding)
             (_lhs_implications_collect)
             (_lhs_impliedTypes)
             (_lhs_impliedValues)
             (_lhs_importedModule)
             (_lhs_importedTypes)
             (_lhs_importedValues)
             (_lhs_kinames)
             (_lhs_kinds)
             (_lhs_kindvar)
             (_lhs_ksubst)
             (_lhs_local)
             (_lhs_methods_collect)
             (_lhs_methods_dist)
             (_lhs_modules)
             (_lhs_pconsigs)
             (_lhs_pconsigs_col)
             (_lhs_pktcoll)
             (_lhs_pktdist)
             (_lhs_prekind)
             (_lhs_ptscoll)
             (_lhs_ptsdist)
             (_lhs_rawrequest_collect)
             (_lhs_requests_gas)
             (_lhs_toplevel)
             (_lhs_verbosity) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_kinames,_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,[])
-- Args --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      count                : Int
      exports_collect      : Exports
      imports_collect      : Imports
      inferkind            : Kind
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nil                  : Bool
      nonrecs              : [TypedBinding]
      self                 : Args

-}
{-
   local variables for Args.Cons:
      kinames
      kvar
      kindvar

-}
{-
   local variables for Args.Nil:

-}
-- semantic domain
type T_Args = (Set QualName) ->
              ([Request_BimapImply]) ->
              (Maybe QualName) ->
              (Consigs) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Modid) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Set QualName) ->
              (Set QualName) ->
              (Exports) ->
              ([Request_FunImply]) ->
              (Set QualName) ->
              (Set QualName) ->
              (Set QualName) ->
              (Set QualName) ->
              (Bool) ->
              ([Request_TypeImply]) ->
              (Set QualName) ->
              (Set QualName) ->
              (Bool) ->
              (Set QualName) ->
              (Set QualName) ->
              (KSubst) ->
              (Int) ->
              (KSubst) ->
              (Bool) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (PConsigs) ->
              (PConsigs) ->
              (FMap QualName PKT) ->
              (FMap QualName PKT) ->
              (KSubst) ->
              (FMap QualName PTS) ->
              (FMap QualName PTS) ->
              ([RawRequest]) ->
              (Bool) ->
              ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(Int),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),(Kind),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(FMap QualName QualNames),(Bool),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Args))
-- cata
sem_Args :: (Args) ->
            (T_Args)
sem_Args (list) =
    (foldr (sem_Args_Cons) (sem_Args_Nil) ((map sem_QualName list)))
sem_Args_Cons :: (T_QualName) ->
                 (T_Args) ->
                 (T_Args)
sem_Args_Cons (_hd)
              (_tl)
              (_lhs_abstracttps_collect)
              (_lhs_bimapimps_collect)
              (_lhs_classname)
              (_lhs_consigs)
              (_lhs_constructors_collect)
              (_lhs_constructors_dist)
              (_lhs_currentModule)
              (_lhs_deps)
              (_lhs_deps_collect)
              (_lhs_exportedTypes)
              (_lhs_exportedValues)
              (_lhs_exports)
              (_lhs_funimps_collect)
              (_lhs_genabs)
              (_lhs_genabs_collect)
              (_lhs_hiddenTypes)
              (_lhs_hiddenValues)
              (_lhs_hiding)
              (_lhs_implications_collect)
              (_lhs_impliedTypes)
              (_lhs_impliedValues)
              (_lhs_importedModule)
              (_lhs_importedTypes)
              (_lhs_importedValues)
              (_lhs_kinames)
              (_lhs_kindvar)
              (_lhs_ksubst)
              (_lhs_local)
              (_lhs_methods_collect)
              (_lhs_methods_dist)
              (_lhs_pconsigs)
              (_lhs_pconsigs_col)
              (_lhs_pktcoll)
              (_lhs_pktdist)
              (_lhs_prekind)
              (_lhs_ptscoll)
              (_lhs_ptsdist)
              (_lhs_rawrequest_collect)
              (_lhs_toplevel) =
    let (_kindvar) =
            _lhs_kindvar + 1
        (_kvar) =
            mkKindVar' _kindvar
        (_kinames) =
            add _lhs_kinames (_hd_self,_kvar)
        ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_methods_collect,_hd_nonrecs,_hd_pconsigs_col,_hd_pktcoll,_hd_rawrequest_collect,_hd_self) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_count,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_inferkind,_tl_initialTypes,_tl_initialValues,_tl_kinames,_tl_kindvar,_tl_ksubst,_tl_methods_collect,_tl_nil,_tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_ptscoll,_tl_rawrequest_collect,_tl_self) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_kinames)
                 (_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_hd_rawrequest_collect)
                 (_lhs_toplevel))
    in  (_tl_abstracttps_collect
        ,_tl_bimapimps_collect
        ,_tl_constructors_collect
        ,_tl_count + 1
        ,_tl_deps_collect
        ,_hd_exports_collect ++ _tl_exports_collect
        ,_tl_funimps_collect
        ,_tl_genabs_collect
        ,_tl_implications_collect
        ,_hd_imports_collect ++ _tl_imports_collect
        ,Kind_Arr _kvar _tl_inferkind
        ,_hd_initialTypes ++ _tl_initialTypes
        ,_hd_initialValues ++ _tl_initialValues
        ,_tl_kinames
        ,_tl_kindvar
        ,_tl_ksubst
        ,_tl_methods_collect
        ,False
        ,_hd_nonrecs ++ _tl_nonrecs
        ,_tl_pconsigs_col
        ,_tl_pktcoll
        ,_tl_ptscoll
        ,_tl_rawrequest_collect
        ,_hd_self : _tl_self
        )
sem_Args_Nil :: (T_Args)
sem_Args_Nil (_lhs_abstracttps_collect)
             (_lhs_bimapimps_collect)
             (_lhs_classname)
             (_lhs_consigs)
             (_lhs_constructors_collect)
             (_lhs_constructors_dist)
             (_lhs_currentModule)
             (_lhs_deps)
             (_lhs_deps_collect)
             (_lhs_exportedTypes)
             (_lhs_exportedValues)
             (_lhs_exports)
             (_lhs_funimps_collect)
             (_lhs_genabs)
             (_lhs_genabs_collect)
             (_lhs_hiddenTypes)
             (_lhs_hiddenValues)
             (_lhs_hiding)
             (_lhs_implications_collect)
             (_lhs_impliedTypes)
             (_lhs_impliedValues)
             (_lhs_importedModule)
             (_lhs_importedTypes)
             (_lhs_importedValues)
             (_lhs_kinames)
             (_lhs_kindvar)
             (_lhs_ksubst)
             (_lhs_local)
             (_lhs_methods_collect)
             (_lhs_methods_dist)
             (_lhs_pconsigs)
             (_lhs_pconsigs_col)
             (_lhs_pktcoll)
             (_lhs_pktdist)
             (_lhs_prekind)
             (_lhs_ptscoll)
             (_lhs_ptsdist)
             (_lhs_rawrequest_collect)
             (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,0,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],Kind_Star,[],[],_lhs_kinames,_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,True,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,[])
-- Binding -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      linkname             : Maybe QualName
      nonrecs              : [TypedBinding]
      self                 : Binding

-}
{-
   local variables for Binding.Binding:

-}
-- semantic domain
type T_Binding = (Set QualName) ->
                 ([Request_BimapImply]) ->
                 (Maybe QualName) ->
                 (Consigs) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Modid) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Exports) ->
                 ([Request_FunImply]) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Bool) ->
                 ([Request_TypeImply]) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Bool) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (KSubst) ->
                 (KSubst) ->
                 (Int) ->
                 (KSubst) ->
                 (Bool) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Set Modid) ->
                 (PConsigs) ->
                 (PConsigs) ->
                 (FMap QualName PKT) ->
                 (FMap QualName PKT) ->
                 (KSubst) ->
                 (FMap QualName PTS) ->
                 (FMap QualName PTS) ->
                 ([RawRequest]) ->
                 ([RawRequest]) ->
                 (Bool) ->
                 (Int) ->
                 ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(Maybe QualName),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Binding))
-- cata
sem_Binding :: (Binding) ->
               (T_Binding)
sem_Binding ((Binding_Binding (_lh) (_rh) (_where))) =
    (sem_Binding_Binding ((sem_Patterns (_lh))) ((sem_Rhs (_rh))) ((sem_SDecls (_where))))
sem_Binding_Binding :: (T_Patterns) ->
                       (T_Rhs) ->
                       (T_SDecls) ->
                       (T_Binding)
sem_Binding_Binding (_lh)
                    (_rh)
                    (_where)
                    (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_kinames)
                    (_lhs_kinds)
                    (_lhs_kindvar)
                    (_lhs_ksubst)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_lhs_ptscoll)
                    (_lhs_ptsdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_toplevel)
                    (_lhs_verbosity) =
    let ( _lh_abstracttps_collect,_lh_bimapimps_collect,_lh_constructors_collect,_lh_deps_collect,_lh_exports_collect,_lh_funimps_collect,_lh_genabs_collect,_lh_implications_collect,_lh_imports_collect,_lh_initialTypes,_lh_initialValues,_lh_methods_collect,_lh_nonrecs,_lh_pconsigs_col,_lh_pktcoll,_lh_ptscoll,_lh_rawrequest_collect,_lh_self) =
            (_lh (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel))
        ( _rh_abstracttps_collect,_rh_bimapimps_collect,_rh_constructors_collect,_rh_deps_collect,_rh_exports_collect,_rh_funimps_collect,_rh_genabs_collect,_rh_implications_collect,_rh_imports_collect,_rh_initialTypes,_rh_initialValues,_rh_kinames,_rh_kindvar,_rh_ksubst,_rh_linkname,_rh_methods_collect,_rh_nonrecs,_rh_pconsigs_col,_rh_pktcoll,_rh_ptscoll,_rh_rawrequest_collect,_rh_self) =
            (_rh (_lh_abstracttps_collect)
                 (_lh_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lh_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lh_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lh_funimps_collect)
                 (_lhs_genabs)
                 (_lh_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lh_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kinds)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lh_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_lh_pconsigs_col)
                 (_lh_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lh_ptscoll)
                 (_lhs_ptsdist)
                 (_lh_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
        ( _where_abstracttps_collect
         ,_where_bimapimps_collect
         ,_where_constructors_collect
         ,_where_count
         ,_where_deps_collect
         ,_where_exports_collect
         ,_where_funimps_collect
         ,_where_genabs_collect
         ,_where_implications_collect
         ,_where_imports_collect
         ,_where_initialTypes
         ,_where_initialValues
         ,_where_kinames
         ,_where_kindvar
         ,_where_ksubst
         ,_where_methods_collect
         ,_where_nil
         ,_where_nonrecs
         ,_where_pconsigs_col
         ,_where_pktcoll
         ,_where_ptscoll
         ,_where_rawrequest_collect
         ,_where_self
         ) =
            (_where (_rh_abstracttps_collect)
                    (_rh_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_rh_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_rh_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_rh_funimps_collect)
                    (_lhs_genabs)
                    (_rh_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_rh_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_rh_kinames)
                    (_lhs_kinds)
                    (_rh_kindvar)
                    (_rh_ksubst)
                    (_lhs_local)
                    (_rh_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_rh_pconsigs_col)
                    (_rh_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_rh_ptscoll)
                    (_lhs_ptsdist)
                    (_rh_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_toplevel)
                    (_lhs_verbosity))
    in  (_where_abstracttps_collect
        ,_where_bimapimps_collect
        ,_where_constructors_collect
        ,_where_deps_collect
        ,_lh_exports_collect ++ _rh_exports_collect ++ _where_exports_collect
        ,_where_funimps_collect
        ,_where_genabs_collect
        ,_where_implications_collect
        ,_lh_imports_collect ++ _rh_imports_collect ++ _where_imports_collect
        ,_lh_initialTypes ++ _rh_initialTypes ++ _where_initialTypes
        ,_lh_initialValues ++ _rh_initialValues ++ _where_initialValues
        ,_where_kinames
        ,_where_kindvar
        ,_where_ksubst
        ,_rh_linkname
        ,_where_methods_collect
        ,_lh_nonrecs ++ _rh_nonrecs ++ _where_nonrecs
        ,_where_pconsigs_col
        ,_where_pktcoll
        ,_where_ptscoll
        ,_where_rawrequest_collect
        ,Binding_Binding _lh_self _rh_self
                         _where_self
        )
-- Bindings ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      linkname             : Maybe QualName
      nonrecs              : [TypedBinding]
      self                 : Bindings

-}
{-
   local variables for Bindings.Cons:

-}
{-
   local variables for Bindings.Nil:

-}
-- semantic domain
type T_Bindings = (Set QualName) ->
                  ([Request_BimapImply]) ->
                  (Maybe QualName) ->
                  (Consigs) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Modid) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Exports) ->
                  ([Request_FunImply]) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Bool) ->
                  ([Request_TypeImply]) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Bool) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (KSubst) ->
                  (KSubst) ->
                  (Int) ->
                  (KSubst) ->
                  (Bool) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Set Modid) ->
                  (PConsigs) ->
                  (PConsigs) ->
                  (FMap QualName PKT) ->
                  (FMap QualName PKT) ->
                  (KSubst) ->
                  (FMap QualName PTS) ->
                  (FMap QualName PTS) ->
                  ([RawRequest]) ->
                  ([RawRequest]) ->
                  (Bool) ->
                  (Int) ->
                  ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(Maybe QualName),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Bindings))
-- cata
sem_Bindings :: (Bindings) ->
                (T_Bindings)
sem_Bindings (list) =
    (foldr (sem_Bindings_Cons) (sem_Bindings_Nil) ((map sem_Binding list)))
sem_Bindings_Cons :: (T_Binding) ->
                     (T_Bindings) ->
                     (T_Bindings)
sem_Bindings_Cons (_hd)
                  (_tl)
                  (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_kinames)
                  (_lhs_kinds)
                  (_lhs_kindvar)
                  (_lhs_ksubst)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_modules)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_prekind)
                  (_lhs_ptscoll)
                  (_lhs_ptsdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_requests_gas)
                  (_lhs_toplevel)
                  (_lhs_verbosity) =
    let ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_kinames,_hd_kindvar,_hd_ksubst,_hd_linkname,_hd_methods_collect,_hd_nonrecs,_hd_pconsigs_col,_hd_pktcoll,_hd_ptscoll,_hd_rawrequest_collect,_hd_self) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kinds)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_initialTypes,_tl_initialValues,_tl_kinames,_tl_kindvar,_tl_ksubst,_tl_linkname,_tl_methods_collect,_tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_ptscoll,_tl_rawrequest_collect,_tl_self) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_hd_kinames)
                 (_lhs_kinds)
                 (_hd_kindvar)
                 (_hd_ksubst)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_hd_ptscoll)
                 (_lhs_ptsdist)
                 (_hd_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
    in  (_tl_abstracttps_collect
        ,_tl_bimapimps_collect
        ,_tl_constructors_collect
        ,_tl_deps_collect
        ,_hd_exports_collect ++ _tl_exports_collect
        ,_tl_funimps_collect
        ,_tl_genabs_collect
        ,_tl_implications_collect
        ,_hd_imports_collect ++ _tl_imports_collect
        ,_hd_initialTypes ++ _tl_initialTypes
        ,_hd_initialValues ++ _tl_initialValues
        ,_tl_kinames
        ,_tl_kindvar
        ,_tl_ksubst
        ,_hd_linkname `const` _tl_linkname
        ,_tl_methods_collect
        ,_hd_nonrecs ++ _tl_nonrecs
        ,_tl_pconsigs_col
        ,_tl_pktcoll
        ,_tl_ptscoll
        ,_tl_rawrequest_collect
        ,_hd_self : _tl_self
        )
sem_Bindings_Nil :: (T_Bindings)
sem_Bindings_Nil (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kinds)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_kinames,_lhs_kindvar,_lhs_ksubst,Nothing,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,[])
-- Body --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenEntities       : [(Set QualName,Set QualName)]
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedEntities     : [(Set QualName,Set QualName)]
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      output               : [PP_Doc]
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]
      strtypes             : FMap QualName StrTypeDecl

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      kind_errors          : [GHError]
      nonrecs              : [TypedBinding]
      outputi              : [PP_Doc]
      self                 : Body
      titypes              : [(QualName,TDecl)]

-}
{-
   local variables for Body.Body:

-}
-- semantic domain
type T_Body = (Set QualName) ->
              ([Request_BimapImply]) ->
              (Maybe QualName) ->
              (Consigs) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Modid) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Set QualName) ->
              (Set QualName) ->
              (Exports) ->
              ([Request_FunImply]) ->
              (Set QualName) ->
              (Set QualName) ->
              ([(Set QualName,Set QualName)]) ->
              (Set QualName) ->
              (Set QualName) ->
              (Bool) ->
              ([Request_TypeImply]) ->
              (Set QualName) ->
              (Set QualName) ->
              ([(Set QualName,Set QualName)]) ->
              (Bool) ->
              (Set QualName) ->
              (Set QualName) ->
              (KSubst) ->
              (KSubst) ->
              (Int) ->
              (KSubst) ->
              (Bool) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Set Modid) ->
              ([PP_Doc]) ->
              (PConsigs) ->
              (PConsigs) ->
              (FMap QualName PKT) ->
              (FMap QualName PKT) ->
              (KSubst) ->
              (FMap QualName PTS) ->
              (FMap QualName PTS) ->
              ([RawRequest]) ->
              ([RawRequest]) ->
              (FMap QualName StrTypeDecl) ->
              (Bool) ->
              (Int) ->
              ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),([GHError]),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),([PP_Doc]),([PP_Doc]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Body),(FMap QualName StrTypeDecl),([(QualName,TDecl)]))
-- cata
sem_Body :: (Body) ->
            (T_Body)
sem_Body ((Body_Body (_impdecls) (_decls))) =
    (sem_Body_Body ((sem_Impdecls (_impdecls))) ((sem_Decls (_decls))))
sem_Body_Body :: (T_Impdecls) ->
                 (T_Decls) ->
                 (T_Body)
sem_Body_Body (_impdecls)
              (_decls)
              (_lhs_abstracttps_collect)
              (_lhs_bimapimps_collect)
              (_lhs_classname)
              (_lhs_consigs)
              (_lhs_constructors_collect)
              (_lhs_constructors_dist)
              (_lhs_currentModule)
              (_lhs_deps)
              (_lhs_deps_collect)
              (_lhs_exportedTypes)
              (_lhs_exportedValues)
              (_lhs_exports)
              (_lhs_funimps_collect)
              (_lhs_genabs)
              (_lhs_genabs_collect)
              (_lhs_hiddenEntities)
              (_lhs_hiddenTypes)
              (_lhs_hiddenValues)
              (_lhs_hiding)
              (_lhs_implications_collect)
              (_lhs_impliedTypes)
              (_lhs_impliedValues)
              (_lhs_importedEntities)
              (_lhs_importedModule)
              (_lhs_importedTypes)
              (_lhs_importedValues)
              (_lhs_kinames)
              (_lhs_kinds)
              (_lhs_kindvar)
              (_lhs_ksubst)
              (_lhs_local)
              (_lhs_methods_collect)
              (_lhs_methods_dist)
              (_lhs_modules)
              (_lhs_output)
              (_lhs_pconsigs)
              (_lhs_pconsigs_col)
              (_lhs_pktcoll)
              (_lhs_pktdist)
              (_lhs_prekind)
              (_lhs_ptscoll)
              (_lhs_ptsdist)
              (_lhs_rawrequest_collect)
              (_lhs_requests_gas)
              (_lhs_strtypes)
              (_lhs_toplevel)
              (_lhs_verbosity) =
    let ( _impdecls_abstracttps_collect
         ,_impdecls_bimapimps_collect
         ,_impdecls_constructors_collect
         ,_impdecls_deps_collect
         ,_impdecls_exports_collect
         ,_impdecls_funimps_collect
         ,_impdecls_genabs_collect
         ,_impdecls_implications_collect
         ,_impdecls_imports_collect
         ,_impdecls_initialTypes
         ,_impdecls_initialValues
         ,_impdecls_kinames
         ,_impdecls_kind_errors
         ,_impdecls_kindvar
         ,_impdecls_ksubst
         ,_impdecls_methods_collect
         ,_impdecls_nonrecs
         ,_impdecls_output
         ,_impdecls_outputi
         ,_impdecls_pconsigs_col
         ,_impdecls_pktcoll
         ,_impdecls_ptscoll
         ,_impdecls_rawrequest_collect
         ,_impdecls_self
         ,_impdecls_strtypes
         ,_impdecls_titypes
         ) =
            (_impdecls (_lhs_abstracttps_collect)
                       (_lhs_bimapimps_collect)
                       (_lhs_classname)
                       (_lhs_consigs)
                       (_lhs_constructors_collect)
                       (_lhs_constructors_dist)
                       (_lhs_currentModule)
                       (_lhs_deps)
                       (_lhs_deps_collect)
                       (_lhs_exportedTypes)
                       (_lhs_exportedValues)
                       (_lhs_exports)
                       (_lhs_funimps_collect)
                       (_lhs_genabs)
                       (_lhs_genabs_collect)
                       (_lhs_hiddenEntities)
                       (_lhs_hiddenTypes)
                       (_lhs_hiddenValues)
                       (_lhs_hiding)
                       (_lhs_implications_collect)
                       (_lhs_impliedTypes)
                       (_lhs_impliedValues)
                       (_lhs_importedEntities)
                       (_lhs_importedModule)
                       (_lhs_importedTypes)
                       (_lhs_importedValues)
                       (_lhs_kinames)
                       (_lhs_kinds)
                       (_lhs_kindvar)
                       (_lhs_ksubst)
                       (_lhs_local)
                       (_lhs_methods_collect)
                       (_lhs_methods_dist)
                       (_lhs_modules)
                       (_lhs_output)
                       (_lhs_pconsigs)
                       (_lhs_pconsigs_col)
                       (_lhs_pktcoll)
                       (_lhs_pktdist)
                       (_lhs_prekind)
                       (_lhs_ptscoll)
                       (_lhs_ptsdist)
                       (_lhs_rawrequest_collect)
                       (_lhs_requests_gas)
                       (_lhs_strtypes)
                       (_lhs_toplevel)
                       (_lhs_verbosity))
        ( _decls_abstracttps_collect
         ,_decls_bimapimps_collect
         ,_decls_constructors_collect
         ,_decls_deps_collect
         ,_decls_exports_collect
         ,_decls_funimps_collect
         ,_decls_genabs_collect
         ,_decls_implications_collect
         ,_decls_imports_collect
         ,_decls_initialTypes
         ,_decls_initialValues
         ,_decls_kinames
         ,_decls_kind_errors
         ,_decls_kindvar
         ,_decls_ksubst
         ,_decls_methods_collect
         ,_decls_nonrecs
         ,_decls_output
         ,_decls_outputi
         ,_decls_pconsigs_col
         ,_decls_pktcoll
         ,_decls_ptscoll
         ,_decls_rawrequest_collect
         ,_decls_self
         ,_decls_strtypes
         ,_decls_titypes
         ) =
            (_decls (_impdecls_abstracttps_collect)
                    (_impdecls_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_impdecls_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_impdecls_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_impdecls_funimps_collect)
                    (_lhs_genabs)
                    (_impdecls_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_impdecls_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_impdecls_kinames)
                    (_lhs_kinds)
                    (_impdecls_kindvar)
                    (_impdecls_ksubst)
                    (_lhs_local)
                    (_impdecls_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_impdecls_output)
                    (_lhs_pconsigs)
                    (_impdecls_pconsigs_col)
                    (_impdecls_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_impdecls_ptscoll)
                    (_lhs_ptsdist)
                    (_impdecls_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_impdecls_strtypes)
                    (_lhs_toplevel)
                    (_lhs_verbosity))
    in  (_decls_abstracttps_collect
        ,_decls_bimapimps_collect
        ,_decls_constructors_collect
        ,_decls_deps_collect
        ,_impdecls_exports_collect ++ _decls_exports_collect
        ,_decls_funimps_collect
        ,_decls_genabs_collect
        ,_decls_implications_collect
        ,_impdecls_imports_collect ++ _decls_imports_collect
        ,_impdecls_initialTypes ++ _decls_initialTypes
        ,_impdecls_initialValues ++ _decls_initialValues
        ,_decls_kinames
        ,_impdecls_kind_errors ++ _decls_kind_errors
        ,_decls_kindvar
        ,_decls_ksubst
        ,_decls_methods_collect
        ,_impdecls_nonrecs ++ _decls_nonrecs
        ,_decls_output
        ,PPI.ppiExportType  (Set.setToList _lhs_exportedTypes)
           :
         PPI.ppiExportValue (Set.setToList _lhs_exportedValues)
           :
         (_impdecls_outputi ++ _decls_outputi)
        ,_decls_pconsigs_col
        ,_decls_pktcoll
        ,_decls_ptscoll
        ,_decls_rawrequest_collect
        ,Body_Body _impdecls_self _decls_self
        ,_decls_strtypes
        ,_impdecls_titypes ++ _decls_titypes
        )
-- Case --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Case

-}
{-
   local variables for Case.Guarded:

-}
{-
   local variables for Case.Unguarded:

-}
-- semantic domain
type T_Case = (Set QualName) ->
              ([Request_BimapImply]) ->
              (Maybe QualName) ->
              (Consigs) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Modid) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Set QualName) ->
              (Set QualName) ->
              (Exports) ->
              ([Request_FunImply]) ->
              (Set QualName) ->
              (Set QualName) ->
              (Set QualName) ->
              (Set QualName) ->
              (Bool) ->
              ([Request_TypeImply]) ->
              (Set QualName) ->
              (Set QualName) ->
              (Bool) ->
              (Set QualName) ->
              (Set QualName) ->
              (KSubst) ->
              (KSubst) ->
              (Int) ->
              (KSubst) ->
              (Bool) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Set Modid) ->
              (PConsigs) ->
              (PConsigs) ->
              (FMap QualName PKT) ->
              (FMap QualName PKT) ->
              (KSubst) ->
              (FMap QualName PTS) ->
              (FMap QualName PTS) ->
              ([RawRequest]) ->
              ([RawRequest]) ->
              (Bool) ->
              (Int) ->
              ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Case))
-- cata
sem_Case :: (Case) ->
            (T_Case)
sem_Case ((Case_Guarded (_grds))) =
    (sem_Case_Guarded ((sem_GuardedAlts (_grds))))
sem_Case ((Case_Unguarded (_expr))) =
    (sem_Case_Unguarded ((sem_Expr (_expr))))
sem_Case_Guarded :: (T_GuardedAlts) ->
                    (T_Case)
sem_Case_Guarded (_grds)
                 (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kinds)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity) =
    let ( _grds_abstracttps_collect,_grds_bimapimps_collect,_grds_constructors_collect,_grds_deps_collect,_grds_exports_collect,_grds_funimps_collect,_grds_genabs_collect,_grds_implications_collect,_grds_imports_collect,_grds_initialTypes,_grds_initialValues,_grds_kinames,_grds_kindvar,_grds_ksubst,_grds_methods_collect,_grds_nonrecs,_grds_pconsigs_col,_grds_pktcoll,_grds_ptscoll,_grds_rawrequest_collect,_grds_self) =
            (_grds (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_grds_abstracttps_collect,_grds_bimapimps_collect,_grds_constructors_collect,_grds_deps_collect,_grds_exports_collect,_grds_funimps_collect,_grds_genabs_collect,_grds_implications_collect,_grds_imports_collect,_grds_initialTypes,_grds_initialValues,_grds_kinames,_grds_kindvar,_grds_ksubst,_grds_methods_collect,_grds_nonrecs,_grds_pconsigs_col,_grds_pktcoll,_grds_ptscoll,_grds_rawrequest_collect,Case_Guarded _grds_self)
sem_Case_Unguarded :: (T_Expr) ->
                      (T_Case)
sem_Case_Unguarded (_expr)
                   (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity) =
    let ( _expr_abstracttps_collect,_expr_bimapimps_collect,_expr_constructors_collect,_expr_deps_collect,_expr_exports_collect,_expr_funimps_collect,_expr_genabs_collect,_expr_implications_collect,_expr_imports_collect,_expr_initialTypes,_expr_initialValues,_expr_kinames,_expr_kindvar,_expr_ksubst,_expr_linkname,_expr_methods_collect,_expr_nonrecs,_expr_pconsigs_col,_expr_pktcoll,_expr_ptscoll,_expr_rawrequest_collect,_expr_self) =
            (_expr (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_expr_abstracttps_collect,_expr_bimapimps_collect,_expr_constructors_collect,_expr_deps_collect,_expr_exports_collect,_expr_funimps_collect,_expr_genabs_collect,_expr_implications_collect,_expr_imports_collect,_expr_initialTypes,_expr_initialValues,_expr_kinames,_expr_kindvar,_expr_ksubst,_expr_methods_collect,_expr_nonrecs,_expr_pconsigs_col,_expr_pktcoll,_expr_ptscoll,_expr_rawrequest_collect,Case_Unguarded _expr_self)
-- Class -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Class

-}
{-
   local variables for Class.Class:

-}
-- semantic domain
type T_Class = (Set QualName) ->
               ([Request_BimapImply]) ->
               (Maybe QualName) ->
               (Consigs) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Set QualName) ->
               (Set QualName) ->
               (Exports) ->
               ([Request_FunImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               ([Request_TypeImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               (Set QualName) ->
               (Set QualName) ->
               (KSubst) ->
               (Int) ->
               (KSubst) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (PConsigs) ->
               (PConsigs) ->
               (FMap QualName PKT) ->
               (FMap QualName PKT) ->
               (KSubst) ->
               (FMap QualName PTS) ->
               (FMap QualName PTS) ->
               ([RawRequest]) ->
               (Bool) ->
               ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Class))
-- cata
sem_Class :: (Class) ->
             (T_Class)
sem_Class ((Class_Class (_name) (_tps))) =
    (sem_Class_Class ((sem_QualName (_name))) ((sem_Types (_tps))))
sem_Class_Class :: (T_QualName) ->
                   (T_Types) ->
                   (T_Class)
sem_Class_Class (_name)
                (_tps)
                (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_kinames)
                (_lhs_kindvar)
                (_lhs_ksubst)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_prekind)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_toplevel) =
    let ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
        ( _tps_abstracttps_collect,_tps_bimapimps_collect,_tps_constructors_collect,_tps_count,_tps_deps_collect,_tps_exports_collect,_tps_funimps_collect,_tps_genabs_collect,_tps_implications_collect,_tps_imports_collect,_tps_initialTypes,_tps_initialValues,_tps_kinames,_tps_kind_errors,_tps_kindvar,_tps_ksubst,_tps_methods_collect,_tps_nil,_tps_nonrecs,_tps_pconsigs_col,_tps_pktcoll,_tps_ptscoll,_tps_rawrequest_collect,_tps_self) =
            (_tps (_name_abstracttps_collect)
                  (_name_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_name_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_name_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_name_funimps_collect)
                  (_lhs_genabs)
                  (_name_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_name_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_kinames)
                  (_lhs_kindvar)
                  (_lhs_ksubst)
                  (_lhs_local)
                  (_name_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_name_pconsigs_col)
                  (_name_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_prekind)
                  (_lhs_ptscoll)
                  (_lhs_ptsdist)
                  (_name_rawrequest_collect)
                  (_lhs_toplevel))
    in  (_tps_abstracttps_collect
        ,_tps_bimapimps_collect
        ,_tps_constructors_collect
        ,_tps_deps_collect
        ,_name_exports_collect ++ _tps_exports_collect
        ,_tps_funimps_collect
        ,_tps_genabs_collect
        ,_tps_implications_collect
        ,_name_imports_collect ++ _tps_imports_collect
        ,_name_initialTypes ++ _tps_initialTypes
        ,_name_initialValues ++ _tps_initialValues
        ,_tps_kinames
        ,_tps_kindvar
        ,_tps_ksubst
        ,_tps_methods_collect
        ,_name_nonrecs ++ _tps_nonrecs
        ,_tps_pconsigs_col
        ,_tps_pktcoll
        ,_tps_ptscoll
        ,_tps_rawrequest_collect
        ,Class_Class _name_self _tps_self
        )
-- Classes -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Classes

-}
{-
   local variables for Classes.Cons:

-}
{-
   local variables for Classes.Nil:

-}
-- semantic domain
type T_Classes = (Set QualName) ->
                 ([Request_BimapImply]) ->
                 (Maybe QualName) ->
                 (Consigs) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Modid) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Exports) ->
                 ([Request_FunImply]) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Bool) ->
                 ([Request_TypeImply]) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Bool) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (KSubst) ->
                 (Int) ->
                 (KSubst) ->
                 (Bool) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (PConsigs) ->
                 (PConsigs) ->
                 (FMap QualName PKT) ->
                 (FMap QualName PKT) ->
                 (KSubst) ->
                 (FMap QualName PTS) ->
                 (FMap QualName PTS) ->
                 ([RawRequest]) ->
                 (Bool) ->
                 ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Classes))
-- cata
sem_Classes :: (Classes) ->
               (T_Classes)
sem_Classes (list) =
    (foldr (sem_Classes_Cons) (sem_Classes_Nil) ((map sem_Class list)))
sem_Classes_Cons :: (T_Class) ->
                    (T_Classes) ->
                    (T_Classes)
sem_Classes_Cons (_hd)
                 (_tl)
                 (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel) =
    let ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_kinames,_hd_kindvar,_hd_ksubst,_hd_methods_collect,_hd_nonrecs,_hd_pconsigs_col,_hd_pktcoll,_hd_ptscoll,_hd_rawrequest_collect,_hd_self) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_initialTypes,_tl_initialValues,_tl_kinames,_tl_kindvar,_tl_ksubst,_tl_methods_collect,_tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_ptscoll,_tl_rawrequest_collect,_tl_self) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_hd_kinames)
                 (_hd_kindvar)
                 (_hd_ksubst)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_hd_ptscoll)
                 (_lhs_ptsdist)
                 (_hd_rawrequest_collect)
                 (_lhs_toplevel))
    in  (_tl_abstracttps_collect
        ,_tl_bimapimps_collect
        ,_tl_constructors_collect
        ,_tl_deps_collect
        ,_hd_exports_collect ++ _tl_exports_collect
        ,_tl_funimps_collect
        ,_tl_genabs_collect
        ,_tl_implications_collect
        ,_hd_imports_collect ++ _tl_imports_collect
        ,_hd_initialTypes ++ _tl_initialTypes
        ,_hd_initialValues ++ _tl_initialValues
        ,_tl_kinames
        ,_tl_kindvar
        ,_tl_ksubst
        ,_tl_methods_collect
        ,_hd_nonrecs ++ _tl_nonrecs
        ,_tl_pconsigs_col
        ,_tl_pktcoll
        ,_tl_ptscoll
        ,_tl_rawrequest_collect
        ,_hd_self : _tl_self
        )
sem_Classes_Nil :: (T_Classes)
sem_Classes_Nil (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_kinames)
                (_lhs_kindvar)
                (_lhs_ksubst)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_prekind)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_kinames,_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,[])
-- Constr ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      toplevel             : Bool
      tpname               : QualName

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      arity                : Int
      consname             : QualName
      constructors         : QualNames
      exports_collect      : Exports
      hasLabels            : Bool
      implications         : [Type]
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      kind_errors          : [GHError]
      nonrecs              : [TypedBinding]
      self                 : Constr

-}
{-
   local variables for Constr.Constr:
      imp_concase
      imp_unitprod
      imp_label
      is_imported_h
      is_hidden
      is_imported
      is_exported
      arity

-}
-- semantic domain
type T_Constr = (Set QualName) ->
                ([Request_BimapImply]) ->
                (Maybe QualName) ->
                (Consigs) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Modid) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Set QualName) ->
                (Set QualName) ->
                (Exports) ->
                ([Request_FunImply]) ->
                (Set QualName) ->
                (Set QualName) ->
                (Set QualName) ->
                (Set QualName) ->
                (Bool) ->
                ([Request_TypeImply]) ->
                (Set QualName) ->
                (Set QualName) ->
                (Bool) ->
                (Set QualName) ->
                (Set QualName) ->
                (KSubst) ->
                (Int) ->
                (KSubst) ->
                (Bool) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (PConsigs) ->
                (PConsigs) ->
                (FMap QualName PKT) ->
                (FMap QualName PKT) ->
                (KSubst) ->
                (FMap QualName PTS) ->
                (FMap QualName PTS) ->
                ([RawRequest]) ->
                (Bool) ->
                (QualName) ->
                ((Set QualName),(Int),([Request_BimapImply]),(QualName),(QualNames),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),(Bool),([Type]),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),([GHError]),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Constr))
-- cata
sem_Constr :: (Constr) ->
              (T_Constr)
sem_Constr ((Constr_Constr (_name) (_types))) =
    (sem_Constr_Constr ((sem_QualName (_name))) ((sem_LabelTypes (_types))))
sem_Constr_Constr :: (T_QualName) ->
                     (T_LabelTypes) ->
                     (T_Constr)
sem_Constr_Constr (_name)
                  (_types)
                  (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_kinames)
                  (_lhs_kindvar)
                  (_lhs_ksubst)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_prekind)
                  (_lhs_ptscoll)
                  (_lhs_ptsdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_toplevel)
                  (_lhs_tpname) =
    let (_arity) =
            _types_count
        (_is_exported) =
            _name_self `Set.elementOf` _lhs_exportedValues
        (_is_imported) =
            _name_self `Set.elementOf` _lhs_importedValues
        (_is_hidden) =
            _name_self `Set.elementOf` _lhs_hiddenValues
        (_is_imported_h) =
            if _lhs_hiding then _is_hidden else _is_imported
        (_imp_label) =
            if   _types_hasLabels
            then [Type_Con genloc labelName]
            else []
        (_imp_unitprod) =
            if   null _types_self
            then [Type_Con genloc unitName]
            else if   length _types_self > 1
                 then [Type_Con genloc prodName]
                 else []
        (_imp_concase) =
            [Type_ConCase genloc _name_self]
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
        ( _types_abstracttps_collect
         ,_types_bimapimps_collect
         ,_types_constructors
         ,_types_constructors_collect
         ,_types_count
         ,_types_deps_collect
         ,_types_exports_collect
         ,_types_funimps_collect
         ,_types_genabs_collect
         ,_types_hasLabels
         ,_types_implications
         ,_types_implications_collect
         ,_types_imports_collect
         ,_types_initialTypes
         ,_types_initialValues
         ,_types_kinames
         ,_types_kind_errors
         ,_types_kindvar
         ,_types_ksubst
         ,_types_methods_collect
         ,_types_nil
         ,_types_nonrecs
         ,_types_pconsigs_col
         ,_types_pktcoll
         ,_types_ptscoll
         ,_types_rawrequest_collect
         ,_types_self
         ) =
            (_types (_name_abstracttps_collect)
                    (_name_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_name_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_name_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_name_funimps_collect)
                    (_lhs_genabs)
                    (_name_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_name_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_kinames)
                    (_lhs_kindvar)
                    (_name_self)
                    (_lhs_ksubst)
                    (_lhs_local)
                    (_name_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_pconsigs)
                    (_name_pconsigs_col)
                    (_name_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_lhs_ptscoll)
                    (_lhs_ptsdist)
                    (_name_rawrequest_collect)
                    (_lhs_toplevel)
                    (_lhs_tpname))
    in  (_types_abstracttps_collect
        ,_arity
        ,_types_bimapimps_collect
        ,concaseName _name_self
        ,[_name_self]
        ,_types_constructors_collect
        ,_types_deps_collect
        ,_name_exports_collect ++ _types_exports_collect
        ,_types_funimps_collect
        ,_types_genabs_collect
        ,_types_hasLabels
        ,_imp_label ++ _imp_unitprod ++ _imp_concase ++ _types_implications
        ,_types_implications_collect
        ,_name_imports_collect ++ _types_imports_collect
        ,_name_initialTypes ++ _types_initialTypes
        ,_name_initialValues ++ _types_initialValues
        ,_types_kinames
        ,_types_kind_errors
        ,_types_kindvar
        ,_types_ksubst
        ,_types_methods_collect
        ,_name_nonrecs ++ _types_nonrecs
        ,_types_pconsigs_col
        ,_types_pktcoll
        ,_types_ptscoll
        ,_types_rawrequest_collect
        ,Constr_Constr _name_self _types_self
        )
-- Constrs -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      toplevel             : Bool
      tpname               : QualName

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      consname             : QualNames
      constructors         : QualNames
      count                : Int
      exports_collect      : Exports
      implications         : [Type]
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      kind_errors          : [GHError]
      nil                  : Bool
      nonrecs              : [TypedBinding]
      self                 : Constrs

-}
{-
   local variables for Constrs.Cons:

-}
{-
   local variables for Constrs.Nil:

-}
-- semantic domain
type T_Constrs = (Set QualName) ->
                 ([Request_BimapImply]) ->
                 (Maybe QualName) ->
                 (Consigs) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Modid) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Exports) ->
                 ([Request_FunImply]) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Bool) ->
                 ([Request_TypeImply]) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Bool) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (KSubst) ->
                 (Int) ->
                 (KSubst) ->
                 (Bool) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (PConsigs) ->
                 (PConsigs) ->
                 (FMap QualName PKT) ->
                 (FMap QualName PKT) ->
                 (KSubst) ->
                 (FMap QualName PTS) ->
                 (FMap QualName PTS) ->
                 ([RawRequest]) ->
                 (Bool) ->
                 (QualName) ->
                 ((Set QualName),([Request_BimapImply]),(QualNames),(QualNames),(FMap QualName QualNames),(Int),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Type]),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),([GHError]),(Int),(KSubst),(FMap QualName QualNames),(Bool),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Constrs))
-- cata
sem_Constrs :: (Constrs) ->
               (T_Constrs)
sem_Constrs (list) =
    (foldr (sem_Constrs_Cons) (sem_Constrs_Nil) ((map sem_Constr list)))
sem_Constrs_Cons :: (T_Constr) ->
                    (T_Constrs) ->
                    (T_Constrs)
sem_Constrs_Cons (_hd)
                 (_tl)
                 (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel)
                 (_lhs_tpname) =
    let ( _hd_abstracttps_collect
         ,_hd_arity
         ,_hd_bimapimps_collect
         ,_hd_consname
         ,_hd_constructors
         ,_hd_constructors_collect
         ,_hd_deps_collect
         ,_hd_exports_collect
         ,_hd_funimps_collect
         ,_hd_genabs_collect
         ,_hd_hasLabels
         ,_hd_implications
         ,_hd_implications_collect
         ,_hd_imports_collect
         ,_hd_initialTypes
         ,_hd_initialValues
         ,_hd_kinames
         ,_hd_kind_errors
         ,_hd_kindvar
         ,_hd_ksubst
         ,_hd_methods_collect
         ,_hd_nonrecs
         ,_hd_pconsigs_col
         ,_hd_pktcoll
         ,_hd_ptscoll
         ,_hd_rawrequest_collect
         ,_hd_self
         ) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel)
                 (_lhs_tpname))
        ( _tl_abstracttps_collect
         ,_tl_bimapimps_collect
         ,_tl_consname
         ,_tl_constructors
         ,_tl_constructors_collect
         ,_tl_count
         ,_tl_deps_collect
         ,_tl_exports_collect
         ,_tl_funimps_collect
         ,_tl_genabs_collect
         ,_tl_implications
         ,_tl_implications_collect
         ,_tl_imports_collect
         ,_tl_initialTypes
         ,_tl_initialValues
         ,_tl_kinames
         ,_tl_kind_errors
         ,_tl_kindvar
         ,_tl_ksubst
         ,_tl_methods_collect
         ,_tl_nil
         ,_tl_nonrecs
         ,_tl_pconsigs_col
         ,_tl_pktcoll
         ,_tl_ptscoll
         ,_tl_rawrequest_collect
         ,_tl_self
         ) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_hd_kinames)
                 (_hd_kindvar)
                 (_hd_ksubst)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_hd_ptscoll)
                 (_lhs_ptsdist)
                 (_hd_rawrequest_collect)
                 (_lhs_toplevel)
                 (_lhs_tpname))
    in  (_tl_abstracttps_collect
        ,_tl_bimapimps_collect
        ,_hd_consname : _tl_consname
        ,_hd_constructors ++ _tl_constructors
        ,_tl_constructors_collect
        ,_tl_count + 1
        ,_tl_deps_collect
        ,_hd_exports_collect ++ _tl_exports_collect
        ,_tl_funimps_collect
        ,_tl_genabs_collect
        ,_hd_implications ++ _tl_implications
        ,_tl_implications_collect
        ,_hd_imports_collect ++ _tl_imports_collect
        ,_hd_initialTypes ++ _tl_initialTypes
        ,_hd_initialValues ++ _tl_initialValues
        ,_tl_kinames
        ,_hd_kind_errors ++ _tl_kind_errors
        ,_tl_kindvar
        ,_tl_ksubst
        ,_tl_methods_collect
        ,False
        ,_hd_nonrecs ++ _tl_nonrecs
        ,_tl_pconsigs_col
        ,_tl_pktcoll
        ,_tl_ptscoll
        ,_tl_rawrequest_collect
        ,_hd_self : _tl_self
        )
sem_Constrs_Nil :: (T_Constrs)
sem_Constrs_Nil (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_kinames)
                (_lhs_kindvar)
                (_lhs_ksubst)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_prekind)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_toplevel)
                (_lhs_tpname) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,[],[],_lhs_constructors_collect,0,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,[],_lhs_implications_collect,[],[],[],_lhs_kinames,[],_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,True,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,[])
-- Context -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Context

-}
{-
   local variables for Context.Context:

-}
{-
   local variables for Context.Empty:

-}
-- semantic domain
type T_Context = (Set QualName) ->
                 ([Request_BimapImply]) ->
                 (Maybe QualName) ->
                 (Consigs) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Modid) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Exports) ->
                 ([Request_FunImply]) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Bool) ->
                 ([Request_TypeImply]) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Bool) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (KSubst) ->
                 (Int) ->
                 (KSubst) ->
                 (Bool) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (PConsigs) ->
                 (PConsigs) ->
                 (FMap QualName PKT) ->
                 (FMap QualName PKT) ->
                 (KSubst) ->
                 (FMap QualName PTS) ->
                 (FMap QualName PTS) ->
                 ([RawRequest]) ->
                 (Bool) ->
                 ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Context))
-- cata
sem_Context :: (Context) ->
               (T_Context)
sem_Context ((Context_Context (_classes))) =
    (sem_Context_Context ((sem_Classes (_classes))))
sem_Context ((Context_Empty )) =
    (sem_Context_Empty )
sem_Context_Context :: (T_Classes) ->
                       (T_Context)
sem_Context_Context (_classes)
                    (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_kinames)
                    (_lhs_kindvar)
                    (_lhs_ksubst)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_lhs_ptscoll)
                    (_lhs_ptsdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_toplevel) =
    let ( _classes_abstracttps_collect
         ,_classes_bimapimps_collect
         ,_classes_constructors_collect
         ,_classes_deps_collect
         ,_classes_exports_collect
         ,_classes_funimps_collect
         ,_classes_genabs_collect
         ,_classes_implications_collect
         ,_classes_imports_collect
         ,_classes_initialTypes
         ,_classes_initialValues
         ,_classes_kinames
         ,_classes_kindvar
         ,_classes_ksubst
         ,_classes_methods_collect
         ,_classes_nonrecs
         ,_classes_pconsigs_col
         ,_classes_pktcoll
         ,_classes_ptscoll
         ,_classes_rawrequest_collect
         ,_classes_self
         ) =
            (_classes (_lhs_abstracttps_collect)
                      (_lhs_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_lhs_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_lhs_funimps_collect)
                      (_lhs_genabs)
                      (_lhs_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_lhs_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_lhs_kinames)
                      (_lhs_kindvar)
                      (_lhs_ksubst)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_pconsigs)
                      (_lhs_pconsigs_col)
                      (_lhs_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_prekind)
                      (_lhs_ptscoll)
                      (_lhs_ptsdist)
                      (_lhs_rawrequest_collect)
                      (_lhs_toplevel))
    in  (_classes_abstracttps_collect
        ,_classes_bimapimps_collect
        ,_classes_constructors_collect
        ,_classes_deps_collect
        ,_classes_exports_collect
        ,_classes_funimps_collect
        ,_classes_genabs_collect
        ,_classes_implications_collect
        ,_classes_imports_collect
        ,_classes_initialTypes
        ,_classes_initialValues
        ,_classes_kinames
        ,_classes_kindvar
        ,_classes_ksubst
        ,_classes_methods_collect
        ,_classes_nonrecs
        ,_classes_pconsigs_col
        ,_classes_pktcoll
        ,_classes_ptscoll
        ,_classes_rawrequest_collect
        ,Context_Context _classes_self
        )
sem_Context_Empty :: (T_Context)
sem_Context_Empty (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_kinames)
                  (_lhs_kindvar)
                  (_lhs_ksubst)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_prekind)
                  (_lhs_ptscoll)
                  (_lhs_ptsdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_kinames,_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,Context_Empty)
-- Decl --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      output               : [PP_Doc]
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]
      strtypes             : FMap QualName StrTypeDecl

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      kind_errors          : [GHError]
      nonrecs              : [TypedBinding]
      outputi              : [PP_Doc]
      self                 : Decl
      titypes              : [(QualName,TDecl)]

-}
{-
   local variables for Decl.Simple:

-}
{-
   local variables for Decl.Top:

-}
-- semantic domain
type T_Decl = (Set QualName) ->
              ([Request_BimapImply]) ->
              (Maybe QualName) ->
              (Consigs) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Modid) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Set QualName) ->
              (Set QualName) ->
              (Exports) ->
              ([Request_FunImply]) ->
              (Set QualName) ->
              (Set QualName) ->
              (Set QualName) ->
              (Set QualName) ->
              (Bool) ->
              ([Request_TypeImply]) ->
              (Set QualName) ->
              (Set QualName) ->
              (Bool) ->
              (Set QualName) ->
              (Set QualName) ->
              (KSubst) ->
              (KSubst) ->
              (Int) ->
              (KSubst) ->
              (Bool) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Set Modid) ->
              ([PP_Doc]) ->
              (PConsigs) ->
              (PConsigs) ->
              (FMap QualName PKT) ->
              (FMap QualName PKT) ->
              (KSubst) ->
              (FMap QualName PTS) ->
              (FMap QualName PTS) ->
              ([RawRequest]) ->
              ([RawRequest]) ->
              (FMap QualName StrTypeDecl) ->
              (Bool) ->
              (Int) ->
              ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),([GHError]),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),([PP_Doc]),([PP_Doc]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Decl),(FMap QualName StrTypeDecl),([(QualName,TDecl)]))
-- cata
sem_Decl :: (Decl) ->
            (T_Decl)
sem_Decl ((Decl_Simple (_decl))) =
    (sem_Decl_Simple ((sem_SDecl (_decl))))
sem_Decl ((Decl_Top (_decl))) =
    (sem_Decl_Top ((sem_TDecl (_decl))))
sem_Decl_Simple :: (T_SDecl) ->
                   (T_Decl)
sem_Decl_Simple (_decl)
                (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_kinames)
                (_lhs_kinds)
                (_lhs_kindvar)
                (_lhs_ksubst)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_modules)
                (_lhs_output)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_prekind)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_requests_gas)
                (_lhs_strtypes)
                (_lhs_toplevel)
                (_lhs_verbosity) =
    let ( _decl_abstracttps_collect,_decl_bimapimps_collect,_decl_constructors_collect,_decl_deps_collect,_decl_exports_collect,_decl_funimps_collect,_decl_genabs_collect,_decl_implications_collect,_decl_imports_collect,_decl_initialTypes,_decl_initialValues,_decl_kinames,_decl_kindvar,_decl_ksubst,_decl_methods_collect,_decl_nonrecs,_decl_output,_decl_outputi,_decl_pconsigs_col,_decl_pktcoll,_decl_ptscoll,_decl_rawrequest_collect,_decl_self) =
            (_decl (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_decl_abstracttps_collect
        ,_decl_bimapimps_collect
        ,_decl_constructors_collect
        ,_decl_deps_collect
        ,_decl_exports_collect
        ,_decl_funimps_collect
        ,_decl_genabs_collect
        ,_decl_implications_collect
        ,_decl_imports_collect
        ,_decl_initialTypes
        ,_decl_initialValues
        ,_decl_kinames
        ,[]
        ,_lhs_kindvar
        ,_lhs_ksubst
        ,_decl_methods_collect
        ,_decl_nonrecs
        ,_decl_output : _lhs_output
        ,_decl_outputi
        ,_decl_pconsigs_col
        ,_decl_pktcoll
        ,_decl_ptscoll
        ,_decl_rawrequest_collect
        ,Decl_Simple _decl_self
        ,_lhs_strtypes
        ,[]
        )
sem_Decl_Top :: (T_TDecl) ->
                (T_Decl)
sem_Decl_Top (_decl)
             (_lhs_abstracttps_collect)
             (_lhs_bimapimps_collect)
             (_lhs_classname)
             (_lhs_consigs)
             (_lhs_constructors_collect)
             (_lhs_constructors_dist)
             (_lhs_currentModule)
             (_lhs_deps)
             (_lhs_deps_collect)
             (_lhs_exportedTypes)
             (_lhs_exportedValues)
             (_lhs_exports)
             (_lhs_funimps_collect)
             (_lhs_genabs)
             (_lhs_genabs_collect)
             (_lhs_hiddenTypes)
             (_lhs_hiddenValues)
             (_lhs_hiding)
             (_lhs_implications_collect)
             (_lhs_impliedTypes)
             (_lhs_impliedValues)
             (_lhs_importedModule)
             (_lhs_importedTypes)
             (_lhs_importedValues)
             (_lhs_kinames)
             (_lhs_kinds)
             (_lhs_kindvar)
             (_lhs_ksubst)
             (_lhs_local)
             (_lhs_methods_collect)
             (_lhs_methods_dist)
             (_lhs_modules)
             (_lhs_output)
             (_lhs_pconsigs)
             (_lhs_pconsigs_col)
             (_lhs_pktcoll)
             (_lhs_pktdist)
             (_lhs_prekind)
             (_lhs_ptscoll)
             (_lhs_ptsdist)
             (_lhs_rawrequest_collect)
             (_lhs_requests_gas)
             (_lhs_strtypes)
             (_lhs_toplevel)
             (_lhs_verbosity) =
    let ( _decl_abstracttps_collect
         ,_decl_bimapimps_collect
         ,_decl_constructors_collect
         ,_decl_deps_collect
         ,_decl_exports_collect
         ,_decl_funimps_collect
         ,_decl_genabs_collect
         ,_decl_implications_collect
         ,_decl_imports_collect
         ,_decl_initialTypes
         ,_decl_initialValues
         ,_decl_kinames
         ,_decl_kind_errors
         ,_decl_kindvar
         ,_decl_ksubst
         ,_decl_methods_collect
         ,_decl_nonrecs
         ,_decl_output
         ,_decl_outputi
         ,_decl_pconsigs_col
         ,_decl_pktcoll
         ,_decl_ptscoll
         ,_decl_rawrequest_collect
         ,_decl_self
         ,_decl_strtypes
         ,_decl_titypes
         ) =
            (_decl (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_strtypes)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_decl_abstracttps_collect
        ,_decl_bimapimps_collect
        ,_decl_constructors_collect
        ,_decl_deps_collect
        ,_decl_exports_collect
        ,_decl_funimps_collect
        ,_decl_genabs_collect
        ,_decl_implications_collect
        ,_decl_imports_collect
        ,_decl_initialTypes
        ,_decl_initialValues
        ,_decl_kinames
        ,_decl_kind_errors
        ,_decl_kindvar
        ,_decl_ksubst
        ,_decl_methods_collect
        ,_decl_nonrecs
        ,_decl_output : _lhs_output
        ,_decl_outputi
        ,_decl_pconsigs_col
        ,_decl_pktcoll
        ,_decl_ptscoll
        ,_decl_rawrequest_collect
        ,Decl_Top _decl_self
        ,_decl_strtypes
        ,_decl_titypes
        )
-- Decls -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      output               : [PP_Doc]
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]
      strtypes             : FMap QualName StrTypeDecl

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      kind_errors          : [GHError]
      nonrecs              : [TypedBinding]
      outputi              : [PP_Doc]
      self                 : Decls
      titypes              : [(QualName,TDecl)]

-}
{-
   local variables for Decls.Cons:

-}
{-
   local variables for Decls.Nil:

-}
-- semantic domain
type T_Decls = (Set QualName) ->
               ([Request_BimapImply]) ->
               (Maybe QualName) ->
               (Consigs) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Set QualName) ->
               (Set QualName) ->
               (Exports) ->
               ([Request_FunImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               ([Request_TypeImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               (Set QualName) ->
               (Set QualName) ->
               (KSubst) ->
               (KSubst) ->
               (Int) ->
               (KSubst) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Set Modid) ->
               ([PP_Doc]) ->
               (PConsigs) ->
               (PConsigs) ->
               (FMap QualName PKT) ->
               (FMap QualName PKT) ->
               (KSubst) ->
               (FMap QualName PTS) ->
               (FMap QualName PTS) ->
               ([RawRequest]) ->
               ([RawRequest]) ->
               (FMap QualName StrTypeDecl) ->
               (Bool) ->
               (Int) ->
               ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),([GHError]),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),([PP_Doc]),([PP_Doc]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Decls),(FMap QualName StrTypeDecl),([(QualName,TDecl)]))
-- cata
sem_Decls :: (Decls) ->
             (T_Decls)
sem_Decls (list) =
    (foldr (sem_Decls_Cons) (sem_Decls_Nil) ((map sem_Decl list)))
sem_Decls_Cons :: (T_Decl) ->
                  (T_Decls) ->
                  (T_Decls)
sem_Decls_Cons (_hd)
               (_tl)
               (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_kinames)
               (_lhs_kinds)
               (_lhs_kindvar)
               (_lhs_ksubst)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_modules)
               (_lhs_output)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_prekind)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_requests_gas)
               (_lhs_strtypes)
               (_lhs_toplevel)
               (_lhs_verbosity) =
    let ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_kinames,_hd_kind_errors,_hd_kindvar,_hd_ksubst,_hd_methods_collect,_hd_nonrecs,_hd_output,_hd_outputi,_hd_pconsigs_col,_hd_pktcoll,_hd_ptscoll,_hd_rawrequest_collect,_hd_self,_hd_strtypes,_hd_titypes) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kinds)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_output)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_strtypes)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_initialTypes,_tl_initialValues,_tl_kinames,_tl_kind_errors,_tl_kindvar,_tl_ksubst,_tl_methods_collect,_tl_nonrecs,_tl_output,_tl_outputi,_tl_pconsigs_col,_tl_pktcoll,_tl_ptscoll,_tl_rawrequest_collect,_tl_self,_tl_strtypes,_tl_titypes) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_hd_kinames)
                 (_lhs_kinds)
                 (_hd_kindvar)
                 (_hd_ksubst)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_hd_output)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_hd_ptscoll)
                 (_lhs_ptsdist)
                 (_hd_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_hd_strtypes)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
    in  (_tl_abstracttps_collect
        ,_tl_bimapimps_collect
        ,_tl_constructors_collect
        ,_tl_deps_collect
        ,_hd_exports_collect ++ _tl_exports_collect
        ,_tl_funimps_collect
        ,_tl_genabs_collect
        ,_tl_implications_collect
        ,_hd_imports_collect ++ _tl_imports_collect
        ,_hd_initialTypes ++ _tl_initialTypes
        ,_hd_initialValues ++ _tl_initialValues
        ,_tl_kinames
        ,_hd_kind_errors ++ _tl_kind_errors
        ,_tl_kindvar
        ,_tl_ksubst
        ,_tl_methods_collect
        ,_hd_nonrecs ++ _tl_nonrecs
        ,_tl_output
        ,_hd_outputi ++ _tl_outputi
        ,_tl_pconsigs_col
        ,_tl_pktcoll
        ,_tl_ptscoll
        ,_tl_rawrequest_collect
        ,_hd_self : _tl_self
        ,_tl_strtypes
        ,_hd_titypes ++ _tl_titypes
        )
sem_Decls_Nil :: (T_Decls)
sem_Decls_Nil (_lhs_abstracttps_collect)
              (_lhs_bimapimps_collect)
              (_lhs_classname)
              (_lhs_consigs)
              (_lhs_constructors_collect)
              (_lhs_constructors_dist)
              (_lhs_currentModule)
              (_lhs_deps)
              (_lhs_deps_collect)
              (_lhs_exportedTypes)
              (_lhs_exportedValues)
              (_lhs_exports)
              (_lhs_funimps_collect)
              (_lhs_genabs)
              (_lhs_genabs_collect)
              (_lhs_hiddenTypes)
              (_lhs_hiddenValues)
              (_lhs_hiding)
              (_lhs_implications_collect)
              (_lhs_impliedTypes)
              (_lhs_impliedValues)
              (_lhs_importedModule)
              (_lhs_importedTypes)
              (_lhs_importedValues)
              (_lhs_kinames)
              (_lhs_kinds)
              (_lhs_kindvar)
              (_lhs_ksubst)
              (_lhs_local)
              (_lhs_methods_collect)
              (_lhs_methods_dist)
              (_lhs_modules)
              (_lhs_output)
              (_lhs_pconsigs)
              (_lhs_pconsigs_col)
              (_lhs_pktcoll)
              (_lhs_pktdist)
              (_lhs_prekind)
              (_lhs_ptscoll)
              (_lhs_ptsdist)
              (_lhs_rawrequest_collect)
              (_lhs_requests_gas)
              (_lhs_strtypes)
              (_lhs_toplevel)
              (_lhs_verbosity) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_kinames,[],_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,[],_lhs_output,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,[],_lhs_strtypes,[])
-- Derivings ---------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      ptsdist              : FMap QualName PTS
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Derivings

-}
{-
   local variables for Derivings.Cons:

-}
{-
   local variables for Derivings.Nil:

-}
-- semantic domain
type T_Derivings = (Set QualName) ->
                   ([Request_BimapImply]) ->
                   (Maybe QualName) ->
                   (Consigs) ->
                   (FMap QualName QualNames) ->
                   (FMap QualName QualNames) ->
                   (Modid) ->
                   (FMap QualName QualNames) ->
                   (FMap QualName QualNames) ->
                   (Set QualName) ->
                   (Set QualName) ->
                   (Exports) ->
                   ([Request_FunImply]) ->
                   (Set QualName) ->
                   (Set QualName) ->
                   (Set QualName) ->
                   (Set QualName) ->
                   (Bool) ->
                   ([Request_TypeImply]) ->
                   (Set QualName) ->
                   (Set QualName) ->
                   (Bool) ->
                   (Set QualName) ->
                   (Set QualName) ->
                   (Bool) ->
                   (FMap QualName QualNames) ->
                   (FMap QualName QualNames) ->
                   (PConsigs) ->
                   (PConsigs) ->
                   (FMap QualName PKT) ->
                   (FMap QualName PKT) ->
                   (FMap QualName PTS) ->
                   (FMap QualName PTS) ->
                   ([RawRequest]) ->
                   (Bool) ->
                   ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Derivings))
-- cata
sem_Derivings :: (Derivings) ->
                 (T_Derivings)
sem_Derivings (list) =
    (foldr (sem_Derivings_Cons) (sem_Derivings_Nil) ((map sem_QualName list)))
sem_Derivings_Cons :: (T_QualName) ->
                      (T_Derivings) ->
                      (T_Derivings)
sem_Derivings_Cons (_hd)
                   (_tl)
                   (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel) =
    let ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_methods_collect,_hd_nonrecs,_hd_pconsigs_col,_hd_pktcoll,_hd_rawrequest_collect,_hd_self) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_initialTypes,_tl_initialValues,_tl_methods_collect,_tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_ptscoll,_tl_rawrequest_collect,_tl_self) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_hd_rawrequest_collect)
                 (_lhs_toplevel))
    in  (_tl_abstracttps_collect
        ,_tl_bimapimps_collect
        ,_tl_constructors_collect
        ,_tl_deps_collect
        ,_hd_exports_collect ++ _tl_exports_collect
        ,_tl_funimps_collect
        ,_tl_genabs_collect
        ,_tl_implications_collect
        ,_hd_imports_collect ++ _tl_imports_collect
        ,_hd_initialTypes ++ _tl_initialTypes
        ,_hd_initialValues ++ _tl_initialValues
        ,_tl_methods_collect
        ,_hd_nonrecs ++ _tl_nonrecs
        ,_tl_pconsigs_col
        ,_tl_pktcoll
        ,_tl_ptscoll
        ,_tl_rawrequest_collect
        ,_hd_self : _tl_self
        )
sem_Derivings_Nil :: (T_Derivings)
sem_Derivings_Nil (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_ptscoll)
                  (_lhs_ptsdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,[])
-- Entities ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Entities

-}
{-
   local variables for Entities.Cons:

-}
{-
   local variables for Entities.Nil:

-}
-- semantic domain
type T_Entities = (Set QualName) ->
                  ([Request_BimapImply]) ->
                  (Maybe QualName) ->
                  (Consigs) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Modid) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Exports) ->
                  ([Request_FunImply]) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Bool) ->
                  ([Request_TypeImply]) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Bool) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Bool) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (PConsigs) ->
                  (PConsigs) ->
                  (FMap QualName PKT) ->
                  (FMap QualName PKT) ->
                  ([RawRequest]) ->
                  (Bool) ->
                  ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),([RawRequest]),(Entities))
-- cata
sem_Entities :: (Entities) ->
                (T_Entities)
sem_Entities (list) =
    (foldr (sem_Entities_Cons) (sem_Entities_Nil) ((map sem_Entity list)))
sem_Entities_Cons :: (T_Entity) ->
                     (T_Entities) ->
                     (T_Entities)
sem_Entities_Cons (_hd)
                  (_tl)
                  (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_toplevel) =
    let ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_methods_collect,_hd_nonrecs,_hd_pconsigs_col,_hd_pktcoll,_hd_rawrequest_collect,_hd_self) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_initialTypes,_tl_initialValues,_tl_methods_collect,_tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_rawrequest_collect,_tl_self) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_hd_rawrequest_collect)
                 (_lhs_toplevel))
    in  (_tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_hd_exports_collect ++ _tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_hd_imports_collect ++ _tl_imports_collect,_hd_initialTypes ++ _tl_initialTypes,_hd_initialValues ++ _tl_initialValues,_tl_methods_collect,_hd_nonrecs ++ _tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_rawrequest_collect,_hd_self : _tl_self)
sem_Entities_Nil :: (T_Entities)
sem_Entities_Nil (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_rawrequest_collect,[])
-- Entity ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Entity

-}
{-
   local variables for Entity.Entity:
      self

-}
-- semantic domain
type T_Entity = (Set QualName) ->
                ([Request_BimapImply]) ->
                (Maybe QualName) ->
                (Consigs) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Modid) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Set QualName) ->
                (Set QualName) ->
                (Exports) ->
                ([Request_FunImply]) ->
                (Set QualName) ->
                (Set QualName) ->
                (Set QualName) ->
                (Set QualName) ->
                (Bool) ->
                ([Request_TypeImply]) ->
                (Set QualName) ->
                (Set QualName) ->
                (Bool) ->
                (Set QualName) ->
                (Set QualName) ->
                (Bool) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (PConsigs) ->
                (PConsigs) ->
                (FMap QualName PKT) ->
                (FMap QualName PKT) ->
                ([RawRequest]) ->
                (Bool) ->
                ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),([RawRequest]),(Entity))
-- cata
sem_Entity :: (Entity) ->
              (T_Entity)
sem_Entity ((Entity_Entity (_modid) (_name))) =
    (sem_Entity_Entity (_modid) ((sem_Name (_name))))
sem_Entity_Entity :: (Maybe Modid) ->
                     (T_Name) ->
                     (T_Entity)
sem_Entity_Entity (_modid)
                  (_name)
                  (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_toplevel) =
    let (_self) =
            Entity_Entity _modid _name_self
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_self)
-- Export ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      rawrequest_collect   : [RawRequest]
      strtypes             : FMap QualName StrTypeDecl

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Export

-}
{-
   local variables for Export.Abstract:
      consigForVar

-}
{-
   local variables for Export.Module:

-}
{-
   local variables for Export.TypeAll:
      constrForVar
      consigForVar

-}
{-
   local variables for Export.TypeSome:
      consigForVar

-}
{-
   local variables for Export.Var:
      consigForVar

-}
-- semantic domain
type T_Export = (Set QualName) ->
                ([Request_BimapImply]) ->
                (Maybe QualName) ->
                (Consigs) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Modid) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Set QualName) ->
                (Set QualName) ->
                (Exports) ->
                ([Request_FunImply]) ->
                (Set QualName) ->
                (Set QualName) ->
                (Set QualName) ->
                (Set QualName) ->
                (Bool) ->
                ([Request_TypeImply]) ->
                (Set QualName) ->
                (Set QualName) ->
                (Bool) ->
                (Set QualName) ->
                (Set QualName) ->
                (Bool) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (PConsigs) ->
                (PConsigs) ->
                (FMap QualName PKT) ->
                (FMap QualName PKT) ->
                ([RawRequest]) ->
                (FMap QualName StrTypeDecl) ->
                (Bool) ->
                ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),([RawRequest]),(Export),(FMap QualName StrTypeDecl))
-- cata
sem_Export :: (Export) ->
              (T_Export)
sem_Export ((Export_Abstract (_name))) =
    (sem_Export_Abstract ((sem_QualName (_name))))
sem_Export ((Export_Module (_modid))) =
    (sem_Export_Module (_modid))
sem_Export ((Export_TypeAll (_name))) =
    (sem_Export_TypeAll ((sem_QualName (_name))))
sem_Export ((Export_TypeSome (_name) (_conss))) =
    (sem_Export_TypeSome ((sem_QualName (_name))) ((sem_QualNames (_conss))))
sem_Export ((Export_Var (_name))) =
    (sem_Export_Var ((sem_QualName (_name))))
sem_Export_Abstract :: (T_QualName) ->
                       (T_Export)
sem_Export_Abstract (_name)
                    (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_strtypes)
                    (_lhs_toplevel) =
    let (_consigForVar) =
            map stype_ctor $ findL _lhs_consigs _name_self
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_name_abstracttps_collect
        ,_name_bimapimps_collect
        ,_name_constructors_collect
        ,_name_deps_collect
        ,if      _name_self `elem` domain _lhs_pktdist
         then    []
         else if not (null _consigForVar)
         then    map (Export_TypeAll . componentTITName _name_self) _consigForVar
         else if _name_self `elem` domain _lhs_methods_dist
         then    [Export_Abstract _name_self]
         else if not (_name_self `elem` domain _lhs_constructors_dist)
         then if   _name_self `elem` domain _lhs_strtypes
              then [Export_Abstract _name_self
                   ,Export_Abstract (strName _name_self)
                   ,Export_Var (epName _name_self)
                   ]
              else [Export_Abstract _name_self]
         else [Export_Abstract _name_self]
        ,_name_funimps_collect
        ,_name_genabs_collect
        ,_name_implications_collect
        ,_name_imports_collect
        ,_name_initialTypes
        ,_name_initialValues
        ,_name_methods_collect
        ,_name_nonrecs
        ,_name_pconsigs_col
        ,_name_pktcoll
        ,_name_rawrequest_collect
        ,Export_Abstract _name_self
        ,_lhs_strtypes
        )
sem_Export_Module :: (Modid) ->
                     (T_Export)
sem_Export_Module (_modid)
                  (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_strtypes)
                  (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[Export_Module _modid],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_rawrequest_collect,Export_Module   _modid,_lhs_strtypes)
sem_Export_TypeAll :: (T_QualName) ->
                      (T_Export)
sem_Export_TypeAll (_name)
                   (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_strtypes)
                   (_lhs_toplevel) =
    let (_consigForVar) =
            map stype_ctor $ findL _lhs_consigs _name_self
        (_constrForVar) =
            findL _lhs_constructors_dist _name_self
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_name_abstracttps_collect
        ,_name_bimapimps_collect
        ,_name_constructors_collect
        ,_name_deps_collect
        ,if      _name_self `elem` domain _lhs_pktdist
         then    []
         else if not (null _consigForVar)
         then    map (Export_TypeAll . componentTITName _name_self) _consigForVar
         else if _name_self `elem` domain _lhs_methods_dist
         then    [Export_TypeAll _name_self]
         else if (null _constrForVar)
         then    [Export_Abstract _name_self
                 ,Export_Abstract (strName _name_self)
                 ,Export_Var (epName _name_self)
                 ]
         else    [Export_TypeAll _name_self
                 ,Export_Abstract (strName _name_self)
                 ,Export_Var (epName _name_self)
                 ]
                 ++ map (Export_Abstract . concaseName) _constrForVar
                 ++ map (Export_Abstract . strName . concaseName) _constrForVar
                 ++ map (Export_Var . epName . concaseName) _constrForVar
        ,_name_funimps_collect
        ,_name_genabs_collect
        ,_name_implications_collect
        ,_name_imports_collect
        ,_name_initialTypes
        ,_name_initialValues
        ,_name_methods_collect
        ,_name_nonrecs
        ,_name_pconsigs_col
        ,_name_pktcoll
        ,_name_rawrequest_collect
        ,Export_TypeAll  _name_self
        ,_lhs_strtypes
        )
sem_Export_TypeSome :: (T_QualName) ->
                       (T_QualNames) ->
                       (T_Export)
sem_Export_TypeSome (_name)
                    (_conss)
                    (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_strtypes)
                    (_lhs_toplevel) =
    let (_consigForVar) =
            map stype_ctor $ findL _lhs_consigs _name_self
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
        ( _conss_abstracttps_collect,_conss_bimapimps_collect,_conss_constructors_collect,_conss_deps_collect,_conss_exports_collect,_conss_funimps_collect,_conss_genabs_collect,_conss_implications_collect,_conss_imports_collect,_conss_initialTypes,_conss_initialValues,_conss_methods_collect,_conss_nonrecs,_conss_pconsigs_col,_conss_pktcoll,_conss_rawrequest_collect,_conss_self) =
            (_conss (_name_abstracttps_collect)
                    (_name_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_name_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_name_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_name_funimps_collect)
                    (_lhs_genabs)
                    (_name_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_name_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_local)
                    (_name_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_pconsigs)
                    (_name_pconsigs_col)
                    (_name_pktcoll)
                    (_lhs_pktdist)
                    (_name_rawrequest_collect)
                    (_lhs_toplevel))
    in  (_conss_abstracttps_collect
        ,_conss_bimapimps_collect
        ,_conss_constructors_collect
        ,_conss_deps_collect
        ,if      _name_self `elem` domain _lhs_pktdist
         then    []
         else if not (null _consigForVar)
         then    map (Export_TypeAll . componentTITName _name_self) _consigForVar
         else if _name_self `elem` domain _lhs_methods_dist
         then    [Export_TypeSome _name_self _conss_self]
         else if not (_name_self `elem` domain _lhs_constructors_dist)
         then if   _name_self `elem` domain _lhs_strtypes
              then [Export_TypeSome _name_self _conss_self
                   ,Export_Abstract (strName _name_self)
                   ,Export_Var (epName _name_self)
                   ]
              else [Export_TypeSome _name_self _conss_self]
         else [Export_TypeSome _name_self _conss_self]
        ,_conss_funimps_collect
        ,_conss_genabs_collect
        ,_conss_implications_collect
        ,_name_imports_collect ++ _conss_imports_collect
        ,_name_initialTypes ++ _conss_initialTypes
        ,_name_initialValues ++ _conss_initialValues
        ,_conss_methods_collect
        ,_name_nonrecs ++ _conss_nonrecs
        ,_conss_pconsigs_col
        ,_conss_pktcoll
        ,_conss_rawrequest_collect
        ,Export_TypeSome _name_self _conss_self
        ,_lhs_strtypes
        )
sem_Export_Var :: (T_QualName) ->
                  (T_Export)
sem_Export_Var (_name)
               (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_rawrequest_collect)
               (_lhs_strtypes)
               (_lhs_toplevel) =
    let (_consigForVar) =
            map stype_ctor $ findL _lhs_consigs _name_self
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_name_abstracttps_collect
        ,_name_bimapimps_collect
        ,_name_constructors_collect
        ,_name_deps_collect
        ,if      _name_self `Set.elementOf` _lhs_genabs
         then    []
         else if not (null _consigForVar)
         then    map (Export_Var . componentName _name_self) _consigForVar
         else    [Export_Var _name_self]
        ,_name_funimps_collect
        ,_name_genabs_collect
        ,_name_implications_collect
        ,_name_imports_collect
        ,_name_initialTypes
        ,_name_initialValues
        ,_name_methods_collect
        ,_name_nonrecs
        ,_name_pconsigs_col
        ,_name_pktcoll
        ,_name_rawrequest_collect
        ,Export_Var      _name_self
        ,_lhs_strtypes
        )
-- Exported ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      rawrequest_collect   : [RawRequest]
      strtypes             : FMap QualName StrTypeDecl

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Exported

-}
{-
   local variables for Exported.Exports:

-}
{-
   local variables for Exported.NoExports:

-}
-- semantic domain
type T_Exported = (Set QualName) ->
                  ([Request_BimapImply]) ->
                  (Maybe QualName) ->
                  (Consigs) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Modid) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Exports) ->
                  ([Request_FunImply]) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Bool) ->
                  ([Request_TypeImply]) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Bool) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Bool) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (PConsigs) ->
                  (PConsigs) ->
                  (FMap QualName PKT) ->
                  (FMap QualName PKT) ->
                  ([RawRequest]) ->
                  (FMap QualName StrTypeDecl) ->
                  (Bool) ->
                  ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),([RawRequest]),(Exported),(FMap QualName StrTypeDecl))
-- cata
sem_Exported :: (Exported) ->
                (T_Exported)
sem_Exported ((Exported_Exports (_exports))) =
    (sem_Exported_Exports ((sem_Exports (_exports))))
sem_Exported ((Exported_NoExports )) =
    (sem_Exported_NoExports )
sem_Exported_Exports :: (T_Exports) ->
                        (T_Exported)
sem_Exported_Exports (_exports)
                     (_lhs_abstracttps_collect)
                     (_lhs_bimapimps_collect)
                     (_lhs_classname)
                     (_lhs_consigs)
                     (_lhs_constructors_collect)
                     (_lhs_constructors_dist)
                     (_lhs_currentModule)
                     (_lhs_deps)
                     (_lhs_deps_collect)
                     (_lhs_exportedTypes)
                     (_lhs_exportedValues)
                     (_lhs_exports)
                     (_lhs_funimps_collect)
                     (_lhs_genabs)
                     (_lhs_genabs_collect)
                     (_lhs_hiddenTypes)
                     (_lhs_hiddenValues)
                     (_lhs_hiding)
                     (_lhs_implications_collect)
                     (_lhs_impliedTypes)
                     (_lhs_impliedValues)
                     (_lhs_importedModule)
                     (_lhs_importedTypes)
                     (_lhs_importedValues)
                     (_lhs_local)
                     (_lhs_methods_collect)
                     (_lhs_methods_dist)
                     (_lhs_pconsigs)
                     (_lhs_pconsigs_col)
                     (_lhs_pktcoll)
                     (_lhs_pktdist)
                     (_lhs_rawrequest_collect)
                     (_lhs_strtypes)
                     (_lhs_toplevel) =
    let ( _exports_abstracttps_collect,_exports_bimapimps_collect,_exports_constructors_collect,_exports_deps_collect,_exports_exports_collect,_exports_funimps_collect,_exports_genabs_collect,_exports_implications_collect,_exports_imports_collect,_exports_initialTypes,_exports_initialValues,_exports_methods_collect,_exports_nonrecs,_exports_pconsigs_col,_exports_pktcoll,_exports_rawrequest_collect,_exports_self,_exports_strtypes) =
            (_exports (_lhs_abstracttps_collect)
                      (_lhs_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_lhs_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_lhs_funimps_collect)
                      (_lhs_genabs)
                      (_lhs_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_lhs_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_pconsigs)
                      (_lhs_pconsigs_col)
                      (_lhs_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_rawrequest_collect)
                      (_lhs_strtypes)
                      (_lhs_toplevel))
    in  (_exports_abstracttps_collect,_exports_bimapimps_collect,_exports_constructors_collect,_exports_deps_collect,_exports_exports_collect,_exports_funimps_collect,_exports_genabs_collect,_exports_implications_collect,_exports_imports_collect,_exports_initialTypes,_exports_initialValues,_exports_methods_collect,_exports_nonrecs,_exports_pconsigs_col,_exports_pktcoll,_exports_rawrequest_collect,Exported_Exports _exports_self,_exports_strtypes)
sem_Exported_NoExports :: (T_Exported)
sem_Exported_NoExports (_lhs_abstracttps_collect)
                       (_lhs_bimapimps_collect)
                       (_lhs_classname)
                       (_lhs_consigs)
                       (_lhs_constructors_collect)
                       (_lhs_constructors_dist)
                       (_lhs_currentModule)
                       (_lhs_deps)
                       (_lhs_deps_collect)
                       (_lhs_exportedTypes)
                       (_lhs_exportedValues)
                       (_lhs_exports)
                       (_lhs_funimps_collect)
                       (_lhs_genabs)
                       (_lhs_genabs_collect)
                       (_lhs_hiddenTypes)
                       (_lhs_hiddenValues)
                       (_lhs_hiding)
                       (_lhs_implications_collect)
                       (_lhs_impliedTypes)
                       (_lhs_impliedValues)
                       (_lhs_importedModule)
                       (_lhs_importedTypes)
                       (_lhs_importedValues)
                       (_lhs_local)
                       (_lhs_methods_collect)
                       (_lhs_methods_dist)
                       (_lhs_pconsigs)
                       (_lhs_pconsigs_col)
                       (_lhs_pktcoll)
                       (_lhs_pktdist)
                       (_lhs_rawrequest_collect)
                       (_lhs_strtypes)
                       (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[Export_Module _lhs_currentModule],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_rawrequest_collect,Exported_NoExports,_lhs_strtypes)
-- Exports -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      rawrequest_collect   : [RawRequest]
      strtypes             : FMap QualName StrTypeDecl

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Exports

-}
{-
   local variables for Exports.Cons:

-}
{-
   local variables for Exports.Nil:

-}
-- semantic domain
type T_Exports = (Set QualName) ->
                 ([Request_BimapImply]) ->
                 (Maybe QualName) ->
                 (Consigs) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Modid) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Exports) ->
                 ([Request_FunImply]) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Bool) ->
                 ([Request_TypeImply]) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Bool) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Bool) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (PConsigs) ->
                 (PConsigs) ->
                 (FMap QualName PKT) ->
                 (FMap QualName PKT) ->
                 ([RawRequest]) ->
                 (FMap QualName StrTypeDecl) ->
                 (Bool) ->
                 ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),([RawRequest]),(Exports),(FMap QualName StrTypeDecl))
-- cata
sem_Exports :: (Exports) ->
               (T_Exports)
sem_Exports (list) =
    (foldr (sem_Exports_Cons) (sem_Exports_Nil) ((map sem_Export list)))
sem_Exports_Cons :: (T_Export) ->
                    (T_Exports) ->
                    (T_Exports)
sem_Exports_Cons (_hd)
                 (_tl)
                 (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_strtypes)
                 (_lhs_toplevel) =
    let ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_methods_collect,_hd_nonrecs,_hd_pconsigs_col,_hd_pktcoll,_hd_rawrequest_collect,_hd_self,_hd_strtypes) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_strtypes)
                 (_lhs_toplevel))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_initialTypes,_tl_initialValues,_tl_methods_collect,_tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_rawrequest_collect,_tl_self,_tl_strtypes) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_hd_rawrequest_collect)
                 (_hd_strtypes)
                 (_lhs_toplevel))
    in  (_tl_abstracttps_collect
        ,_tl_bimapimps_collect
        ,_tl_constructors_collect
        ,_tl_deps_collect
        ,_hd_exports_collect ++ _tl_exports_collect
        ,_tl_funimps_collect
        ,_tl_genabs_collect
        ,_tl_implications_collect
        ,_hd_imports_collect ++ _tl_imports_collect
        ,_hd_initialTypes ++ _tl_initialTypes
        ,_hd_initialValues ++ _tl_initialValues
        ,_tl_methods_collect
        ,_hd_nonrecs ++ _tl_nonrecs
        ,_tl_pconsigs_col
        ,_tl_pktcoll
        ,_tl_rawrequest_collect
        ,_hd_self : _tl_self
        ,_tl_strtypes
        )
sem_Exports_Nil :: (T_Exports)
sem_Exports_Nil (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_rawrequest_collect)
                (_lhs_strtypes)
                (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_rawrequest_collect,[],_lhs_strtypes)
-- Expr --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      linkname             : Maybe QualName
      nonrecs              : [TypedBinding]
      self                 : Expr

-}
{-
   local variables for Expr.App:
      self

-}
{-
   local variables for Expr.As:
      self

-}
{-
   local variables for Expr.Case:
      self

-}
{-
   local variables for Expr.Compr:
      self

-}
{-
   local variables for Expr.Con:
      self

-}
{-
   local variables for Expr.Do:
      self

-}
{-
   local variables for Expr.EnumFrom:
      self

-}
{-
   local variables for Expr.EnumFromThen:
      self

-}
{-
   local variables for Expr.EnumFromThenTo:
      self

-}
{-
   local variables for Expr.EnumFromTo:
      self

-}
{-
   local variables for Expr.If:
      self

-}
{-
   local variables for Expr.Irr:
      self

-}
{-
   local variables for Expr.LabCon:
      self

-}
{-
   local variables for Expr.LabUp:
      self

-}
{-
   local variables for Expr.Lam:
      self

-}
{-
   local variables for Expr.LeftSection:
      self

-}
{-
   local variables for Expr.Let:
      pktdist
      ptsdist
      self

-}
{-
   local variables for Expr.List:
      self

-}
{-
   local variables for Expr.Lit:
      self

-}
{-
   local variables for Expr.Negate:
      self

-}
{-
   local variables for Expr.OpApp:
      self

-}
{-
   local variables for Expr.Parens:
      self

-}
{-
   local variables for Expr.RightSection:
      self

-}
{-
   local variables for Expr.Tuple:
      self

-}
{-
   local variables for Expr.TyApp:
      rawrequest_collect
      self

-}
{-
   local variables for Expr.TypeSig:
      self

-}
{-
   local variables for Expr.Var:
      self

-}
{-
   local variables for Expr.Wild:
      self

-}
-- semantic domain
type T_Expr = (Set QualName) ->
              ([Request_BimapImply]) ->
              (Maybe QualName) ->
              (Consigs) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Modid) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Set QualName) ->
              (Set QualName) ->
              (Exports) ->
              ([Request_FunImply]) ->
              (Set QualName) ->
              (Set QualName) ->
              (Set QualName) ->
              (Set QualName) ->
              (Bool) ->
              ([Request_TypeImply]) ->
              (Set QualName) ->
              (Set QualName) ->
              (Bool) ->
              (Set QualName) ->
              (Set QualName) ->
              (KSubst) ->
              (KSubst) ->
              (Int) ->
              (KSubst) ->
              (Bool) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Set Modid) ->
              (PConsigs) ->
              (PConsigs) ->
              (FMap QualName PKT) ->
              (FMap QualName PKT) ->
              (KSubst) ->
              (FMap QualName PTS) ->
              (FMap QualName PTS) ->
              ([RawRequest]) ->
              ([RawRequest]) ->
              (Bool) ->
              (Int) ->
              ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(Maybe QualName),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Expr))
-- cata
sem_Expr :: (Expr) ->
            (T_Expr)
sem_Expr ((Expr_App (_left) (_right))) =
    (sem_Expr_App ((sem_Expr (_left))) ((sem_Expr (_right))))
sem_Expr ((Expr_As (_name) (_expr))) =
    (sem_Expr_As ((sem_QualName (_name))) ((sem_Expr (_expr))))
sem_Expr ((Expr_Case (_expr) (_alts))) =
    (sem_Expr_Case ((sem_Expr (_expr))) ((sem_Alts (_alts))))
sem_Expr ((Expr_Compr (_body) (_quals))) =
    (sem_Expr_Compr ((sem_Expr (_body))) ((sem_Quals (_quals))))
sem_Expr ((Expr_Con (_srcloc) (_name))) =
    (sem_Expr_Con ((sem_Position (_srcloc))) ((sem_QualName (_name))))
sem_Expr ((Expr_Do (_stmts))) =
    (sem_Expr_Do ((sem_Stmts (_stmts))))
sem_Expr ((Expr_EnumFrom (_from))) =
    (sem_Expr_EnumFrom ((sem_Expr (_from))))
sem_Expr ((Expr_EnumFromThen (_from) (_then))) =
    (sem_Expr_EnumFromThen ((sem_Expr (_from))) ((sem_Expr (_then))))
sem_Expr ((Expr_EnumFromThenTo (_from) (_then) (_to))) =
    (sem_Expr_EnumFromThenTo ((sem_Expr (_from))) ((sem_Expr (_then))) ((sem_Expr (_to))))
sem_Expr ((Expr_EnumFromTo (_from) (_to))) =
    (sem_Expr_EnumFromTo ((sem_Expr (_from))) ((sem_Expr (_to))))
sem_Expr ((Expr_If (_cond) (_thenp) (_elsep))) =
    (sem_Expr_If ((sem_Expr (_cond))) ((sem_Expr (_thenp))) ((sem_Expr (_elsep))))
sem_Expr ((Expr_Irr (_expr))) =
    (sem_Expr_Irr ((sem_Expr (_expr))))
sem_Expr ((Expr_LabCon (_con) (_fbinds))) =
    (sem_Expr_LabCon ((sem_QualName (_con))) ((sem_FBinds (_fbinds))))
sem_Expr ((Expr_LabUp (_body) (_fbinds))) =
    (sem_Expr_LabUp ((sem_Expr (_body))) ((sem_FBinds (_fbinds))))
sem_Expr ((Expr_Lam (_from) (_body))) =
    (sem_Expr_Lam ((sem_Patterns (_from))) ((sem_Expr (_body))))
sem_Expr ((Expr_LeftSection (_op) (_left))) =
    (sem_Expr_LeftSection ((sem_QualName (_op))) ((sem_Expr (_left))))
sem_Expr ((Expr_Let (_decls) (_body))) =
    (sem_Expr_Let ((sem_SDecls (_decls))) ((sem_Expr (_body))))
sem_Expr ((Expr_List (_exprs))) =
    (sem_Expr_List ((sem_Exprs (_exprs))))
sem_Expr ((Expr_Lit (_name))) =
    (sem_Expr_Lit ((sem_Literal (_name))))
sem_Expr ((Expr_Negate (_expr))) =
    (sem_Expr_Negate ((sem_Expr (_expr))))
sem_Expr ((Expr_OpApp (_op) (_left) (_right))) =
    (sem_Expr_OpApp ((sem_QualName (_op))) ((sem_Expr (_left))) ((sem_Expr (_right))))
sem_Expr ((Expr_Parens (_body))) =
    (sem_Expr_Parens ((sem_Expr (_body))))
sem_Expr ((Expr_RightSection (_op) (_right))) =
    (sem_Expr_RightSection ((sem_QualName (_op))) ((sem_Expr (_right))))
sem_Expr ((Expr_Tuple (_exprs))) =
    (sem_Expr_Tuple ((sem_Exprs (_exprs))))
sem_Expr ((Expr_TyApp (_srcloc) (_expr) (_tp))) =
    (sem_Expr_TyApp ((sem_Position (_srcloc))) ((sem_QualName (_expr))) ((sem_Type (_tp))))
sem_Expr ((Expr_TypeSig (_body) (_tp))) =
    (sem_Expr_TypeSig ((sem_Expr (_body))) ((sem_QualType (_tp))))
sem_Expr ((Expr_Var (_srcloc) (_name))) =
    (sem_Expr_Var ((sem_Position (_srcloc))) ((sem_QualName (_name))))
sem_Expr ((Expr_Wild )) =
    (sem_Expr_Wild )
sem_Expr_App :: (T_Expr) ->
                (T_Expr) ->
                (T_Expr)
sem_Expr_App (_left)
             (_right)
             (_lhs_abstracttps_collect)
             (_lhs_bimapimps_collect)
             (_lhs_classname)
             (_lhs_consigs)
             (_lhs_constructors_collect)
             (_lhs_constructors_dist)
             (_lhs_currentModule)
             (_lhs_deps)
             (_lhs_deps_collect)
             (_lhs_exportedTypes)
             (_lhs_exportedValues)
             (_lhs_exports)
             (_lhs_funimps_collect)
             (_lhs_genabs)
             (_lhs_genabs_collect)
             (_lhs_hiddenTypes)
             (_lhs_hiddenValues)
             (_lhs_hiding)
             (_lhs_implications_collect)
             (_lhs_impliedTypes)
             (_lhs_impliedValues)
             (_lhs_importedModule)
             (_lhs_importedTypes)
             (_lhs_importedValues)
             (_lhs_kinames)
             (_lhs_kinds)
             (_lhs_kindvar)
             (_lhs_ksubst)
             (_lhs_local)
             (_lhs_methods_collect)
             (_lhs_methods_dist)
             (_lhs_modules)
             (_lhs_pconsigs)
             (_lhs_pconsigs_col)
             (_lhs_pktcoll)
             (_lhs_pktdist)
             (_lhs_prekind)
             (_lhs_ptscoll)
             (_lhs_ptsdist)
             (_lhs_rawrequest_collect)
             (_lhs_requests_gas)
             (_lhs_toplevel)
             (_lhs_verbosity) =
    let (_self) =
            Expr_App _left_self _right_self
        ( _left_abstracttps_collect,_left_bimapimps_collect,_left_constructors_collect,_left_deps_collect,_left_exports_collect,_left_funimps_collect,_left_genabs_collect,_left_implications_collect,_left_imports_collect,_left_initialTypes,_left_initialValues,_left_kinames,_left_kindvar,_left_ksubst,_left_linkname,_left_methods_collect,_left_nonrecs,_left_pconsigs_col,_left_pktcoll,_left_ptscoll,_left_rawrequest_collect,_left_self) =
            (_left (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
        ( _right_abstracttps_collect
         ,_right_bimapimps_collect
         ,_right_constructors_collect
         ,_right_deps_collect
         ,_right_exports_collect
         ,_right_funimps_collect
         ,_right_genabs_collect
         ,_right_implications_collect
         ,_right_imports_collect
         ,_right_initialTypes
         ,_right_initialValues
         ,_right_kinames
         ,_right_kindvar
         ,_right_ksubst
         ,_right_linkname
         ,_right_methods_collect
         ,_right_nonrecs
         ,_right_pconsigs_col
         ,_right_pktcoll
         ,_right_ptscoll
         ,_right_rawrequest_collect
         ,_right_self
         ) =
            (_right (_left_abstracttps_collect)
                    (_left_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_left_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_left_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_left_funimps_collect)
                    (_lhs_genabs)
                    (_left_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_left_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_left_kinames)
                    (_lhs_kinds)
                    (_left_kindvar)
                    (_left_ksubst)
                    (_lhs_local)
                    (_left_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_left_pconsigs_col)
                    (_left_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_left_ptscoll)
                    (_lhs_ptsdist)
                    (_left_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_toplevel)
                    (_lhs_verbosity))
    in  (_right_abstracttps_collect
        ,_right_bimapimps_collect
        ,_right_constructors_collect
        ,_right_deps_collect
        ,_left_exports_collect ++ _right_exports_collect
        ,_right_funimps_collect
        ,_right_genabs_collect
        ,_right_implications_collect
        ,_left_imports_collect ++ _right_imports_collect
        ,_left_initialTypes ++ _right_initialTypes
        ,_left_initialValues ++ _right_initialValues
        ,_right_kinames
        ,_right_kindvar
        ,_right_ksubst
        ,_left_linkname `const` _right_linkname
        ,_right_methods_collect
        ,_left_nonrecs ++ _right_nonrecs
        ,_right_pconsigs_col
        ,_right_pktcoll
        ,_right_ptscoll
        ,_right_rawrequest_collect
        ,_self
        )
sem_Expr_As :: (T_QualName) ->
               (T_Expr) ->
               (T_Expr)
sem_Expr_As (_name)
            (_expr)
            (_lhs_abstracttps_collect)
            (_lhs_bimapimps_collect)
            (_lhs_classname)
            (_lhs_consigs)
            (_lhs_constructors_collect)
            (_lhs_constructors_dist)
            (_lhs_currentModule)
            (_lhs_deps)
            (_lhs_deps_collect)
            (_lhs_exportedTypes)
            (_lhs_exportedValues)
            (_lhs_exports)
            (_lhs_funimps_collect)
            (_lhs_genabs)
            (_lhs_genabs_collect)
            (_lhs_hiddenTypes)
            (_lhs_hiddenValues)
            (_lhs_hiding)
            (_lhs_implications_collect)
            (_lhs_impliedTypes)
            (_lhs_impliedValues)
            (_lhs_importedModule)
            (_lhs_importedTypes)
            (_lhs_importedValues)
            (_lhs_kinames)
            (_lhs_kinds)
            (_lhs_kindvar)
            (_lhs_ksubst)
            (_lhs_local)
            (_lhs_methods_collect)
            (_lhs_methods_dist)
            (_lhs_modules)
            (_lhs_pconsigs)
            (_lhs_pconsigs_col)
            (_lhs_pktcoll)
            (_lhs_pktdist)
            (_lhs_prekind)
            (_lhs_ptscoll)
            (_lhs_ptsdist)
            (_lhs_rawrequest_collect)
            (_lhs_requests_gas)
            (_lhs_toplevel)
            (_lhs_verbosity) =
    let (_self) =
            Expr_As _name_self _expr_self
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
        ( _expr_abstracttps_collect,_expr_bimapimps_collect,_expr_constructors_collect,_expr_deps_collect,_expr_exports_collect,_expr_funimps_collect,_expr_genabs_collect,_expr_implications_collect,_expr_imports_collect,_expr_initialTypes,_expr_initialValues,_expr_kinames,_expr_kindvar,_expr_ksubst,_expr_linkname,_expr_methods_collect,_expr_nonrecs,_expr_pconsigs_col,_expr_pktcoll,_expr_ptscoll,_expr_rawrequest_collect,_expr_self) =
            (_expr (_name_abstracttps_collect)
                   (_name_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_name_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_name_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_name_funimps_collect)
                   (_lhs_genabs)
                   (_name_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_name_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_name_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_name_pconsigs_col)
                   (_name_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_name_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_expr_abstracttps_collect
        ,_expr_bimapimps_collect
        ,_expr_constructors_collect
        ,_expr_deps_collect
        ,_name_exports_collect ++ _expr_exports_collect
        ,_expr_funimps_collect
        ,_expr_genabs_collect
        ,_expr_implications_collect
        ,_name_imports_collect ++ _expr_imports_collect
        ,_name_initialTypes ++ _expr_initialTypes
        ,_name_initialValues ++ _expr_initialValues
        ,_expr_kinames
        ,_expr_kindvar
        ,_expr_ksubst
        ,_expr_linkname
        ,_expr_methods_collect
        ,_name_nonrecs ++ _expr_nonrecs
        ,_expr_pconsigs_col
        ,_expr_pktcoll
        ,_expr_ptscoll
        ,_expr_rawrequest_collect
        ,_self
        )
sem_Expr_Case :: (T_Expr) ->
                 (T_Alts) ->
                 (T_Expr)
sem_Expr_Case (_expr)
              (_alts)
              (_lhs_abstracttps_collect)
              (_lhs_bimapimps_collect)
              (_lhs_classname)
              (_lhs_consigs)
              (_lhs_constructors_collect)
              (_lhs_constructors_dist)
              (_lhs_currentModule)
              (_lhs_deps)
              (_lhs_deps_collect)
              (_lhs_exportedTypes)
              (_lhs_exportedValues)
              (_lhs_exports)
              (_lhs_funimps_collect)
              (_lhs_genabs)
              (_lhs_genabs_collect)
              (_lhs_hiddenTypes)
              (_lhs_hiddenValues)
              (_lhs_hiding)
              (_lhs_implications_collect)
              (_lhs_impliedTypes)
              (_lhs_impliedValues)
              (_lhs_importedModule)
              (_lhs_importedTypes)
              (_lhs_importedValues)
              (_lhs_kinames)
              (_lhs_kinds)
              (_lhs_kindvar)
              (_lhs_ksubst)
              (_lhs_local)
              (_lhs_methods_collect)
              (_lhs_methods_dist)
              (_lhs_modules)
              (_lhs_pconsigs)
              (_lhs_pconsigs_col)
              (_lhs_pktcoll)
              (_lhs_pktdist)
              (_lhs_prekind)
              (_lhs_ptscoll)
              (_lhs_ptsdist)
              (_lhs_rawrequest_collect)
              (_lhs_requests_gas)
              (_lhs_toplevel)
              (_lhs_verbosity) =
    let (_self) =
            Expr_Case _expr_self _alts_self
        ( _expr_abstracttps_collect,_expr_bimapimps_collect,_expr_constructors_collect,_expr_deps_collect,_expr_exports_collect,_expr_funimps_collect,_expr_genabs_collect,_expr_implications_collect,_expr_imports_collect,_expr_initialTypes,_expr_initialValues,_expr_kinames,_expr_kindvar,_expr_ksubst,_expr_linkname,_expr_methods_collect,_expr_nonrecs,_expr_pconsigs_col,_expr_pktcoll,_expr_ptscoll,_expr_rawrequest_collect,_expr_self) =
            (_expr (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
        ( _alts_abstracttps_collect,_alts_bimapimps_collect,_alts_constructors_collect,_alts_deps_collect,_alts_exports_collect,_alts_funimps_collect,_alts_genabs_collect,_alts_implications_collect,_alts_imports_collect,_alts_initialTypes,_alts_initialValues,_alts_kinames,_alts_kindvar,_alts_ksubst,_alts_methods_collect,_alts_nonrecs,_alts_pconsigs_col,_alts_pktcoll,_alts_ptscoll,_alts_rawrequest_collect,_alts_self) =
            (_alts (_expr_abstracttps_collect)
                   (_expr_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_expr_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_expr_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_expr_funimps_collect)
                   (_lhs_genabs)
                   (_expr_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_expr_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_expr_kinames)
                   (_lhs_kinds)
                   (_expr_kindvar)
                   (_expr_ksubst)
                   (_lhs_local)
                   (_expr_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_expr_pconsigs_col)
                   (_expr_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_expr_ptscoll)
                   (_lhs_ptsdist)
                   (_expr_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_alts_abstracttps_collect
        ,_alts_bimapimps_collect
        ,_alts_constructors_collect
        ,_alts_deps_collect
        ,_expr_exports_collect ++ _alts_exports_collect
        ,_alts_funimps_collect
        ,_alts_genabs_collect
        ,_alts_implications_collect
        ,_expr_imports_collect ++ _alts_imports_collect
        ,_expr_initialTypes ++ _alts_initialTypes
        ,_expr_initialValues ++ _alts_initialValues
        ,_alts_kinames
        ,_alts_kindvar
        ,_alts_ksubst
        ,_expr_linkname
        ,_alts_methods_collect
        ,_expr_nonrecs ++ _alts_nonrecs
        ,_alts_pconsigs_col
        ,_alts_pktcoll
        ,_alts_ptscoll
        ,_alts_rawrequest_collect
        ,_self
        )
sem_Expr_Compr :: (T_Expr) ->
                  (T_Quals) ->
                  (T_Expr)
sem_Expr_Compr (_body)
               (_quals)
               (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_kinames)
               (_lhs_kinds)
               (_lhs_kindvar)
               (_lhs_ksubst)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_modules)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_prekind)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_requests_gas)
               (_lhs_toplevel)
               (_lhs_verbosity) =
    let (_self) =
            Expr_Compr _body_self _quals_self
        ( _body_abstracttps_collect,_body_bimapimps_collect,_body_constructors_collect,_body_deps_collect,_body_exports_collect,_body_funimps_collect,_body_genabs_collect,_body_implications_collect,_body_imports_collect,_body_initialTypes,_body_initialValues,_body_kinames,_body_kindvar,_body_ksubst,_body_linkname,_body_methods_collect,_body_nonrecs,_body_pconsigs_col,_body_pktcoll,_body_ptscoll,_body_rawrequest_collect,_body_self) =
            (_body (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
        ( _quals_abstracttps_collect,_quals_bimapimps_collect,_quals_constructors_collect,_quals_deps_collect,_quals_exports_collect,_quals_funimps_collect,_quals_genabs_collect,_quals_implications_collect,_quals_imports_collect,_quals_initialTypes,_quals_initialValues,_quals_kinames,_quals_kindvar,_quals_ksubst,_quals_methods_collect,_quals_nonrecs,_quals_pconsigs_col,_quals_pktcoll,_quals_ptscoll,_quals_rawrequest_collect,_quals_self) =
            (_quals (_body_abstracttps_collect)
                    (_body_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_body_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_body_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_body_funimps_collect)
                    (_lhs_genabs)
                    (_body_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_body_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_body_kinames)
                    (_lhs_kinds)
                    (_body_kindvar)
                    (_body_ksubst)
                    (_lhs_local)
                    (_body_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_body_pconsigs_col)
                    (_body_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_body_ptscoll)
                    (_lhs_ptsdist)
                    (_body_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_toplevel)
                    (_lhs_verbosity))
    in  (_quals_abstracttps_collect
        ,_quals_bimapimps_collect
        ,_quals_constructors_collect
        ,_quals_deps_collect
        ,_body_exports_collect ++ _quals_exports_collect
        ,_quals_funimps_collect
        ,_quals_genabs_collect
        ,_quals_implications_collect
        ,_body_imports_collect ++ _quals_imports_collect
        ,_body_initialTypes ++ _quals_initialTypes
        ,_body_initialValues ++ _quals_initialValues
        ,_quals_kinames
        ,_quals_kindvar
        ,_quals_ksubst
        ,_body_linkname
        ,_quals_methods_collect
        ,_body_nonrecs ++ _quals_nonrecs
        ,_quals_pconsigs_col
        ,_quals_pktcoll
        ,_quals_ptscoll
        ,_quals_rawrequest_collect
        ,_self
        )
sem_Expr_Con :: (T_Position) ->
                (T_QualName) ->
                (T_Expr)
sem_Expr_Con (_srcloc)
             (_name)
             (_lhs_abstracttps_collect)
             (_lhs_bimapimps_collect)
             (_lhs_classname)
             (_lhs_consigs)
             (_lhs_constructors_collect)
             (_lhs_constructors_dist)
             (_lhs_currentModule)
             (_lhs_deps)
             (_lhs_deps_collect)
             (_lhs_exportedTypes)
             (_lhs_exportedValues)
             (_lhs_exports)
             (_lhs_funimps_collect)
             (_lhs_genabs)
             (_lhs_genabs_collect)
             (_lhs_hiddenTypes)
             (_lhs_hiddenValues)
             (_lhs_hiding)
             (_lhs_implications_collect)
             (_lhs_impliedTypes)
             (_lhs_impliedValues)
             (_lhs_importedModule)
             (_lhs_importedTypes)
             (_lhs_importedValues)
             (_lhs_kinames)
             (_lhs_kinds)
             (_lhs_kindvar)
             (_lhs_ksubst)
             (_lhs_local)
             (_lhs_methods_collect)
             (_lhs_methods_dist)
             (_lhs_modules)
             (_lhs_pconsigs)
             (_lhs_pconsigs_col)
             (_lhs_pktcoll)
             (_lhs_pktdist)
             (_lhs_prekind)
             (_lhs_ptscoll)
             (_lhs_ptsdist)
             (_lhs_rawrequest_collect)
             (_lhs_requests_gas)
             (_lhs_toplevel)
             (_lhs_verbosity) =
    let (_self) =
            Expr_Con _srcloc_self _name_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_lhs_kinames,_lhs_kindvar,_lhs_ksubst,Nothing,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_lhs_ptscoll,_name_rawrequest_collect,_self)
sem_Expr_Do :: (T_Stmts) ->
               (T_Expr)
sem_Expr_Do (_stmts)
            (_lhs_abstracttps_collect)
            (_lhs_bimapimps_collect)
            (_lhs_classname)
            (_lhs_consigs)
            (_lhs_constructors_collect)
            (_lhs_constructors_dist)
            (_lhs_currentModule)
            (_lhs_deps)
            (_lhs_deps_collect)
            (_lhs_exportedTypes)
            (_lhs_exportedValues)
            (_lhs_exports)
            (_lhs_funimps_collect)
            (_lhs_genabs)
            (_lhs_genabs_collect)
            (_lhs_hiddenTypes)
            (_lhs_hiddenValues)
            (_lhs_hiding)
            (_lhs_implications_collect)
            (_lhs_impliedTypes)
            (_lhs_impliedValues)
            (_lhs_importedModule)
            (_lhs_importedTypes)
            (_lhs_importedValues)
            (_lhs_kinames)
            (_lhs_kinds)
            (_lhs_kindvar)
            (_lhs_ksubst)
            (_lhs_local)
            (_lhs_methods_collect)
            (_lhs_methods_dist)
            (_lhs_modules)
            (_lhs_pconsigs)
            (_lhs_pconsigs_col)
            (_lhs_pktcoll)
            (_lhs_pktdist)
            (_lhs_prekind)
            (_lhs_ptscoll)
            (_lhs_ptsdist)
            (_lhs_rawrequest_collect)
            (_lhs_requests_gas)
            (_lhs_toplevel)
            (_lhs_verbosity) =
    let (_self) =
            Expr_Do _stmts_self
        ( _stmts_abstracttps_collect,_stmts_bimapimps_collect,_stmts_constructors_collect,_stmts_deps_collect,_stmts_exports_collect,_stmts_funimps_collect,_stmts_genabs_collect,_stmts_implications_collect,_stmts_imports_collect,_stmts_initialTypes,_stmts_initialValues,_stmts_kinames,_stmts_kindvar,_stmts_ksubst,_stmts_methods_collect,_stmts_nonrecs,_stmts_pconsigs_col,_stmts_pktcoll,_stmts_ptscoll,_stmts_rawrequest_collect,_stmts_self) =
            (_stmts (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_kinames)
                    (_lhs_kinds)
                    (_lhs_kindvar)
                    (_lhs_ksubst)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_lhs_ptscoll)
                    (_lhs_ptsdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_toplevel)
                    (_lhs_verbosity))
    in  (_stmts_abstracttps_collect,_stmts_bimapimps_collect,_stmts_constructors_collect,_stmts_deps_collect,_stmts_exports_collect,_stmts_funimps_collect,_stmts_genabs_collect,_stmts_implications_collect,_stmts_imports_collect,_stmts_initialTypes,_stmts_initialValues,_stmts_kinames,_stmts_kindvar,_stmts_ksubst,Nothing,_stmts_methods_collect,_stmts_nonrecs,_stmts_pconsigs_col,_stmts_pktcoll,_stmts_ptscoll,_stmts_rawrequest_collect,_self)
sem_Expr_EnumFrom :: (T_Expr) ->
                     (T_Expr)
sem_Expr_EnumFrom (_from)
                  (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_kinames)
                  (_lhs_kinds)
                  (_lhs_kindvar)
                  (_lhs_ksubst)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_modules)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_prekind)
                  (_lhs_ptscoll)
                  (_lhs_ptsdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_requests_gas)
                  (_lhs_toplevel)
                  (_lhs_verbosity) =
    let (_self) =
            Expr_EnumFrom _from_self
        ( _from_abstracttps_collect,_from_bimapimps_collect,_from_constructors_collect,_from_deps_collect,_from_exports_collect,_from_funimps_collect,_from_genabs_collect,_from_implications_collect,_from_imports_collect,_from_initialTypes,_from_initialValues,_from_kinames,_from_kindvar,_from_ksubst,_from_linkname,_from_methods_collect,_from_nonrecs,_from_pconsigs_col,_from_pktcoll,_from_ptscoll,_from_rawrequest_collect,_from_self) =
            (_from (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_from_abstracttps_collect,_from_bimapimps_collect,_from_constructors_collect,_from_deps_collect,_from_exports_collect,_from_funimps_collect,_from_genabs_collect,_from_implications_collect,_from_imports_collect,_from_initialTypes,_from_initialValues,_from_kinames,_from_kindvar,_from_ksubst,_from_linkname,_from_methods_collect,_from_nonrecs,_from_pconsigs_col,_from_pktcoll,_from_ptscoll,_from_rawrequest_collect,_self)
sem_Expr_EnumFromThen :: (T_Expr) ->
                         (T_Expr) ->
                         (T_Expr)
sem_Expr_EnumFromThen (_from)
                      (_then)
                      (_lhs_abstracttps_collect)
                      (_lhs_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_lhs_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_lhs_funimps_collect)
                      (_lhs_genabs)
                      (_lhs_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_lhs_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_lhs_kinames)
                      (_lhs_kinds)
                      (_lhs_kindvar)
                      (_lhs_ksubst)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_modules)
                      (_lhs_pconsigs)
                      (_lhs_pconsigs_col)
                      (_lhs_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_prekind)
                      (_lhs_ptscoll)
                      (_lhs_ptsdist)
                      (_lhs_rawrequest_collect)
                      (_lhs_requests_gas)
                      (_lhs_toplevel)
                      (_lhs_verbosity) =
    let (_self) =
            Expr_EnumFromThen _from_self _then_self
        ( _from_abstracttps_collect,_from_bimapimps_collect,_from_constructors_collect,_from_deps_collect,_from_exports_collect,_from_funimps_collect,_from_genabs_collect,_from_implications_collect,_from_imports_collect,_from_initialTypes,_from_initialValues,_from_kinames,_from_kindvar,_from_ksubst,_from_linkname,_from_methods_collect,_from_nonrecs,_from_pconsigs_col,_from_pktcoll,_from_ptscoll,_from_rawrequest_collect,_from_self) =
            (_from (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
        ( _then_abstracttps_collect,_then_bimapimps_collect,_then_constructors_collect,_then_deps_collect,_then_exports_collect,_then_funimps_collect,_then_genabs_collect,_then_implications_collect,_then_imports_collect,_then_initialTypes,_then_initialValues,_then_kinames,_then_kindvar,_then_ksubst,_then_linkname,_then_methods_collect,_then_nonrecs,_then_pconsigs_col,_then_pktcoll,_then_ptscoll,_then_rawrequest_collect,_then_self) =
            (_then (_from_abstracttps_collect)
                   (_from_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_from_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_from_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_from_funimps_collect)
                   (_lhs_genabs)
                   (_from_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_from_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_from_kinames)
                   (_lhs_kinds)
                   (_from_kindvar)
                   (_from_ksubst)
                   (_lhs_local)
                   (_from_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_from_pconsigs_col)
                   (_from_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_from_ptscoll)
                   (_lhs_ptsdist)
                   (_from_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_then_abstracttps_collect
        ,_then_bimapimps_collect
        ,_then_constructors_collect
        ,_then_deps_collect
        ,_from_exports_collect ++ _then_exports_collect
        ,_then_funimps_collect
        ,_then_genabs_collect
        ,_then_implications_collect
        ,_from_imports_collect ++ _then_imports_collect
        ,_from_initialTypes ++ _then_initialTypes
        ,_from_initialValues ++ _then_initialValues
        ,_then_kinames
        ,_then_kindvar
        ,_then_ksubst
        ,_from_linkname `const` _then_linkname
        ,_then_methods_collect
        ,_from_nonrecs ++ _then_nonrecs
        ,_then_pconsigs_col
        ,_then_pktcoll
        ,_then_ptscoll
        ,_then_rawrequest_collect
        ,_self
        )
sem_Expr_EnumFromThenTo :: (T_Expr) ->
                           (T_Expr) ->
                           (T_Expr) ->
                           (T_Expr)
sem_Expr_EnumFromThenTo (_from)
                        (_then)
                        (_to)
                        (_lhs_abstracttps_collect)
                        (_lhs_bimapimps_collect)
                        (_lhs_classname)
                        (_lhs_consigs)
                        (_lhs_constructors_collect)
                        (_lhs_constructors_dist)
                        (_lhs_currentModule)
                        (_lhs_deps)
                        (_lhs_deps_collect)
                        (_lhs_exportedTypes)
                        (_lhs_exportedValues)
                        (_lhs_exports)
                        (_lhs_funimps_collect)
                        (_lhs_genabs)
                        (_lhs_genabs_collect)
                        (_lhs_hiddenTypes)
                        (_lhs_hiddenValues)
                        (_lhs_hiding)
                        (_lhs_implications_collect)
                        (_lhs_impliedTypes)
                        (_lhs_impliedValues)
                        (_lhs_importedModule)
                        (_lhs_importedTypes)
                        (_lhs_importedValues)
                        (_lhs_kinames)
                        (_lhs_kinds)
                        (_lhs_kindvar)
                        (_lhs_ksubst)
                        (_lhs_local)
                        (_lhs_methods_collect)
                        (_lhs_methods_dist)
                        (_lhs_modules)
                        (_lhs_pconsigs)
                        (_lhs_pconsigs_col)
                        (_lhs_pktcoll)
                        (_lhs_pktdist)
                        (_lhs_prekind)
                        (_lhs_ptscoll)
                        (_lhs_ptsdist)
                        (_lhs_rawrequest_collect)
                        (_lhs_requests_gas)
                        (_lhs_toplevel)
                        (_lhs_verbosity) =
    let (_self) =
            Expr_EnumFromThenTo
              _from_self _then_self _to_self
        ( _from_abstracttps_collect,_from_bimapimps_collect,_from_constructors_collect,_from_deps_collect,_from_exports_collect,_from_funimps_collect,_from_genabs_collect,_from_implications_collect,_from_imports_collect,_from_initialTypes,_from_initialValues,_from_kinames,_from_kindvar,_from_ksubst,_from_linkname,_from_methods_collect,_from_nonrecs,_from_pconsigs_col,_from_pktcoll,_from_ptscoll,_from_rawrequest_collect,_from_self) =
            (_from (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
        ( _then_abstracttps_collect,_then_bimapimps_collect,_then_constructors_collect,_then_deps_collect,_then_exports_collect,_then_funimps_collect,_then_genabs_collect,_then_implications_collect,_then_imports_collect,_then_initialTypes,_then_initialValues,_then_kinames,_then_kindvar,_then_ksubst,_then_linkname,_then_methods_collect,_then_nonrecs,_then_pconsigs_col,_then_pktcoll,_then_ptscoll,_then_rawrequest_collect,_then_self) =
            (_then (_from_abstracttps_collect)
                   (_from_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_from_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_from_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_from_funimps_collect)
                   (_lhs_genabs)
                   (_from_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_from_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_from_kinames)
                   (_lhs_kinds)
                   (_from_kindvar)
                   (_from_ksubst)
                   (_lhs_local)
                   (_from_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_from_pconsigs_col)
                   (_from_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_from_ptscoll)
                   (_lhs_ptsdist)
                   (_from_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
        ( _to_abstracttps_collect,_to_bimapimps_collect,_to_constructors_collect,_to_deps_collect,_to_exports_collect,_to_funimps_collect,_to_genabs_collect,_to_implications_collect,_to_imports_collect,_to_initialTypes,_to_initialValues,_to_kinames,_to_kindvar,_to_ksubst,_to_linkname,_to_methods_collect,_to_nonrecs,_to_pconsigs_col,_to_pktcoll,_to_ptscoll,_to_rawrequest_collect,_to_self) =
            (_to (_then_abstracttps_collect)
                 (_then_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_then_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_then_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_then_funimps_collect)
                 (_lhs_genabs)
                 (_then_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_then_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_then_kinames)
                 (_lhs_kinds)
                 (_then_kindvar)
                 (_then_ksubst)
                 (_lhs_local)
                 (_then_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_then_pconsigs_col)
                 (_then_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_then_ptscoll)
                 (_lhs_ptsdist)
                 (_then_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
    in  (_to_abstracttps_collect
        ,_to_bimapimps_collect
        ,_to_constructors_collect
        ,_to_deps_collect
        ,_from_exports_collect ++ _then_exports_collect ++ _to_exports_collect
        ,_to_funimps_collect
        ,_to_genabs_collect
        ,_to_implications_collect
        ,_from_imports_collect ++ _then_imports_collect ++ _to_imports_collect
        ,_from_initialTypes ++ _then_initialTypes ++ _to_initialTypes
        ,_from_initialValues ++ _then_initialValues ++ _to_initialValues
        ,_to_kinames
        ,_to_kindvar
        ,_to_ksubst
        ,_from_linkname `const` _then_linkname `const` _to_linkname
        ,_to_methods_collect
        ,_from_nonrecs ++ _then_nonrecs ++ _to_nonrecs
        ,_to_pconsigs_col
        ,_to_pktcoll
        ,_to_ptscoll
        ,_to_rawrequest_collect
        ,_self
        )
sem_Expr_EnumFromTo :: (T_Expr) ->
                       (T_Expr) ->
                       (T_Expr)
sem_Expr_EnumFromTo (_from)
                    (_to)
                    (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_kinames)
                    (_lhs_kinds)
                    (_lhs_kindvar)
                    (_lhs_ksubst)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_lhs_ptscoll)
                    (_lhs_ptsdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_toplevel)
                    (_lhs_verbosity) =
    let (_self) =
            Expr_EnumFromTo _from_self _to_self
        ( _from_abstracttps_collect,_from_bimapimps_collect,_from_constructors_collect,_from_deps_collect,_from_exports_collect,_from_funimps_collect,_from_genabs_collect,_from_implications_collect,_from_imports_collect,_from_initialTypes,_from_initialValues,_from_kinames,_from_kindvar,_from_ksubst,_from_linkname,_from_methods_collect,_from_nonrecs,_from_pconsigs_col,_from_pktcoll,_from_ptscoll,_from_rawrequest_collect,_from_self) =
            (_from (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
        ( _to_abstracttps_collect,_to_bimapimps_collect,_to_constructors_collect,_to_deps_collect,_to_exports_collect,_to_funimps_collect,_to_genabs_collect,_to_implications_collect,_to_imports_collect,_to_initialTypes,_to_initialValues,_to_kinames,_to_kindvar,_to_ksubst,_to_linkname,_to_methods_collect,_to_nonrecs,_to_pconsigs_col,_to_pktcoll,_to_ptscoll,_to_rawrequest_collect,_to_self) =
            (_to (_from_abstracttps_collect)
                 (_from_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_from_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_from_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_from_funimps_collect)
                 (_lhs_genabs)
                 (_from_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_from_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_from_kinames)
                 (_lhs_kinds)
                 (_from_kindvar)
                 (_from_ksubst)
                 (_lhs_local)
                 (_from_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_from_pconsigs_col)
                 (_from_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_from_ptscoll)
                 (_lhs_ptsdist)
                 (_from_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
    in  (_to_abstracttps_collect
        ,_to_bimapimps_collect
        ,_to_constructors_collect
        ,_to_deps_collect
        ,_from_exports_collect ++ _to_exports_collect
        ,_to_funimps_collect
        ,_to_genabs_collect
        ,_to_implications_collect
        ,_from_imports_collect ++ _to_imports_collect
        ,_from_initialTypes ++ _to_initialTypes
        ,_from_initialValues ++ _to_initialValues
        ,_to_kinames
        ,_to_kindvar
        ,_to_ksubst
        ,_from_linkname `const` _to_linkname
        ,_to_methods_collect
        ,_from_nonrecs ++ _to_nonrecs
        ,_to_pconsigs_col
        ,_to_pktcoll
        ,_to_ptscoll
        ,_to_rawrequest_collect
        ,_self
        )
sem_Expr_If :: (T_Expr) ->
               (T_Expr) ->
               (T_Expr) ->
               (T_Expr)
sem_Expr_If (_cond)
            (_thenp)
            (_elsep)
            (_lhs_abstracttps_collect)
            (_lhs_bimapimps_collect)
            (_lhs_classname)
            (_lhs_consigs)
            (_lhs_constructors_collect)
            (_lhs_constructors_dist)
            (_lhs_currentModule)
            (_lhs_deps)
            (_lhs_deps_collect)
            (_lhs_exportedTypes)
            (_lhs_exportedValues)
            (_lhs_exports)
            (_lhs_funimps_collect)
            (_lhs_genabs)
            (_lhs_genabs_collect)
            (_lhs_hiddenTypes)
            (_lhs_hiddenValues)
            (_lhs_hiding)
            (_lhs_implications_collect)
            (_lhs_impliedTypes)
            (_lhs_impliedValues)
            (_lhs_importedModule)
            (_lhs_importedTypes)
            (_lhs_importedValues)
            (_lhs_kinames)
            (_lhs_kinds)
            (_lhs_kindvar)
            (_lhs_ksubst)
            (_lhs_local)
            (_lhs_methods_collect)
            (_lhs_methods_dist)
            (_lhs_modules)
            (_lhs_pconsigs)
            (_lhs_pconsigs_col)
            (_lhs_pktcoll)
            (_lhs_pktdist)
            (_lhs_prekind)
            (_lhs_ptscoll)
            (_lhs_ptsdist)
            (_lhs_rawrequest_collect)
            (_lhs_requests_gas)
            (_lhs_toplevel)
            (_lhs_verbosity) =
    let (_self) =
            Expr_If _cond_self _thenp_self _elsep_self
        ( _cond_abstracttps_collect,_cond_bimapimps_collect,_cond_constructors_collect,_cond_deps_collect,_cond_exports_collect,_cond_funimps_collect,_cond_genabs_collect,_cond_implications_collect,_cond_imports_collect,_cond_initialTypes,_cond_initialValues,_cond_kinames,_cond_kindvar,_cond_ksubst,_cond_linkname,_cond_methods_collect,_cond_nonrecs,_cond_pconsigs_col,_cond_pktcoll,_cond_ptscoll,_cond_rawrequest_collect,_cond_self) =
            (_cond (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
        ( _thenp_abstracttps_collect
         ,_thenp_bimapimps_collect
         ,_thenp_constructors_collect
         ,_thenp_deps_collect
         ,_thenp_exports_collect
         ,_thenp_funimps_collect
         ,_thenp_genabs_collect
         ,_thenp_implications_collect
         ,_thenp_imports_collect
         ,_thenp_initialTypes
         ,_thenp_initialValues
         ,_thenp_kinames
         ,_thenp_kindvar
         ,_thenp_ksubst
         ,_thenp_linkname
         ,_thenp_methods_collect
         ,_thenp_nonrecs
         ,_thenp_pconsigs_col
         ,_thenp_pktcoll
         ,_thenp_ptscoll
         ,_thenp_rawrequest_collect
         ,_thenp_self
         ) =
            (_thenp (_cond_abstracttps_collect)
                    (_cond_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_cond_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_cond_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_cond_funimps_collect)
                    (_lhs_genabs)
                    (_cond_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_cond_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_cond_kinames)
                    (_lhs_kinds)
                    (_cond_kindvar)
                    (_cond_ksubst)
                    (_lhs_local)
                    (_cond_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_cond_pconsigs_col)
                    (_cond_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_cond_ptscoll)
                    (_lhs_ptsdist)
                    (_cond_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_toplevel)
                    (_lhs_verbosity))
        ( _elsep_abstracttps_collect
         ,_elsep_bimapimps_collect
         ,_elsep_constructors_collect
         ,_elsep_deps_collect
         ,_elsep_exports_collect
         ,_elsep_funimps_collect
         ,_elsep_genabs_collect
         ,_elsep_implications_collect
         ,_elsep_imports_collect
         ,_elsep_initialTypes
         ,_elsep_initialValues
         ,_elsep_kinames
         ,_elsep_kindvar
         ,_elsep_ksubst
         ,_elsep_linkname
         ,_elsep_methods_collect
         ,_elsep_nonrecs
         ,_elsep_pconsigs_col
         ,_elsep_pktcoll
         ,_elsep_ptscoll
         ,_elsep_rawrequest_collect
         ,_elsep_self
         ) =
            (_elsep (_thenp_abstracttps_collect)
                    (_thenp_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_thenp_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_thenp_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_thenp_funimps_collect)
                    (_lhs_genabs)
                    (_thenp_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_thenp_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_thenp_kinames)
                    (_lhs_kinds)
                    (_thenp_kindvar)
                    (_thenp_ksubst)
                    (_lhs_local)
                    (_thenp_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_thenp_pconsigs_col)
                    (_thenp_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_thenp_ptscoll)
                    (_lhs_ptsdist)
                    (_thenp_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_toplevel)
                    (_lhs_verbosity))
    in  (_elsep_abstracttps_collect
        ,_elsep_bimapimps_collect
        ,_elsep_constructors_collect
        ,_elsep_deps_collect
        ,_cond_exports_collect ++ _thenp_exports_collect ++ _elsep_exports_collect
        ,_elsep_funimps_collect
        ,_elsep_genabs_collect
        ,_elsep_implications_collect
        ,_cond_imports_collect ++ _thenp_imports_collect ++ _elsep_imports_collect
        ,_cond_initialTypes ++ _thenp_initialTypes ++ _elsep_initialTypes
        ,_cond_initialValues ++ _thenp_initialValues ++ _elsep_initialValues
        ,_elsep_kinames
        ,_elsep_kindvar
        ,_elsep_ksubst
        ,_cond_linkname `const` _thenp_linkname `const` _elsep_linkname
        ,_elsep_methods_collect
        ,_cond_nonrecs ++ _thenp_nonrecs ++ _elsep_nonrecs
        ,_elsep_pconsigs_col
        ,_elsep_pktcoll
        ,_elsep_ptscoll
        ,_elsep_rawrequest_collect
        ,_self
        )
sem_Expr_Irr :: (T_Expr) ->
                (T_Expr)
sem_Expr_Irr (_expr)
             (_lhs_abstracttps_collect)
             (_lhs_bimapimps_collect)
             (_lhs_classname)
             (_lhs_consigs)
             (_lhs_constructors_collect)
             (_lhs_constructors_dist)
             (_lhs_currentModule)
             (_lhs_deps)
             (_lhs_deps_collect)
             (_lhs_exportedTypes)
             (_lhs_exportedValues)
             (_lhs_exports)
             (_lhs_funimps_collect)
             (_lhs_genabs)
             (_lhs_genabs_collect)
             (_lhs_hiddenTypes)
             (_lhs_hiddenValues)
             (_lhs_hiding)
             (_lhs_implications_collect)
             (_lhs_impliedTypes)
             (_lhs_impliedValues)
             (_lhs_importedModule)
             (_lhs_importedTypes)
             (_lhs_importedValues)
             (_lhs_kinames)
             (_lhs_kinds)
             (_lhs_kindvar)
             (_lhs_ksubst)
             (_lhs_local)
             (_lhs_methods_collect)
             (_lhs_methods_dist)
             (_lhs_modules)
             (_lhs_pconsigs)
             (_lhs_pconsigs_col)
             (_lhs_pktcoll)
             (_lhs_pktdist)
             (_lhs_prekind)
             (_lhs_ptscoll)
             (_lhs_ptsdist)
             (_lhs_rawrequest_collect)
             (_lhs_requests_gas)
             (_lhs_toplevel)
             (_lhs_verbosity) =
    let (_self) =
            Expr_Irr _expr_self
        ( _expr_abstracttps_collect,_expr_bimapimps_collect,_expr_constructors_collect,_expr_deps_collect,_expr_exports_collect,_expr_funimps_collect,_expr_genabs_collect,_expr_implications_collect,_expr_imports_collect,_expr_initialTypes,_expr_initialValues,_expr_kinames,_expr_kindvar,_expr_ksubst,_expr_linkname,_expr_methods_collect,_expr_nonrecs,_expr_pconsigs_col,_expr_pktcoll,_expr_ptscoll,_expr_rawrequest_collect,_expr_self) =
            (_expr (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_expr_abstracttps_collect,_expr_bimapimps_collect,_expr_constructors_collect,_expr_deps_collect,_expr_exports_collect,_expr_funimps_collect,_expr_genabs_collect,_expr_implications_collect,_expr_imports_collect,_expr_initialTypes,_expr_initialValues,_expr_kinames,_expr_kindvar,_expr_ksubst,_expr_linkname,_expr_methods_collect,_expr_nonrecs,_expr_pconsigs_col,_expr_pktcoll,_expr_ptscoll,_expr_rawrequest_collect,_self)
sem_Expr_LabCon :: (T_QualName) ->
                   (T_FBinds) ->
                   (T_Expr)
sem_Expr_LabCon (_con)
                (_fbinds)
                (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_kinames)
                (_lhs_kinds)
                (_lhs_kindvar)
                (_lhs_ksubst)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_modules)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_prekind)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_requests_gas)
                (_lhs_toplevel)
                (_lhs_verbosity) =
    let (_self) =
            Expr_LabCon _con_self _fbinds_self
        ( _con_abstracttps_collect,_con_bimapimps_collect,_con_constructors_collect,_con_deps_collect,_con_exports_collect,_con_funimps_collect,_con_genabs_collect,_con_implications_collect,_con_imports_collect,_con_initialTypes,_con_initialValues,_con_methods_collect,_con_nonrecs,_con_pconsigs_col,_con_pktcoll,_con_rawrequest_collect,_con_self) =
            (_con (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_toplevel))
        ( _fbinds_abstracttps_collect
         ,_fbinds_bimapimps_collect
         ,_fbinds_constructors_collect
         ,_fbinds_deps_collect
         ,_fbinds_exports_collect
         ,_fbinds_funimps_collect
         ,_fbinds_genabs_collect
         ,_fbinds_implications_collect
         ,_fbinds_imports_collect
         ,_fbinds_initialTypes
         ,_fbinds_initialValues
         ,_fbinds_kinames
         ,_fbinds_kindvar
         ,_fbinds_ksubst
         ,_fbinds_methods_collect
         ,_fbinds_nonrecs
         ,_fbinds_pconsigs_col
         ,_fbinds_pktcoll
         ,_fbinds_ptscoll
         ,_fbinds_rawrequest_collect
         ,_fbinds_self
         ) =
            (_fbinds (_con_abstracttps_collect)
                     (_con_bimapimps_collect)
                     (_lhs_classname)
                     (_lhs_consigs)
                     (_con_constructors_collect)
                     (_lhs_constructors_dist)
                     (_lhs_currentModule)
                     (_lhs_deps)
                     (_con_deps_collect)
                     (_lhs_exportedTypes)
                     (_lhs_exportedValues)
                     (_lhs_exports)
                     (_con_funimps_collect)
                     (_lhs_genabs)
                     (_con_genabs_collect)
                     (_lhs_hiddenTypes)
                     (_lhs_hiddenValues)
                     (_lhs_hiding)
                     (_con_implications_collect)
                     (_lhs_impliedTypes)
                     (_lhs_impliedValues)
                     (_lhs_importedModule)
                     (_lhs_importedTypes)
                     (_lhs_importedValues)
                     (_lhs_kinames)
                     (_lhs_kinds)
                     (_lhs_kindvar)
                     (_lhs_ksubst)
                     (_lhs_local)
                     (_con_methods_collect)
                     (_lhs_methods_dist)
                     (_lhs_modules)
                     (_lhs_pconsigs)
                     (_con_pconsigs_col)
                     (_con_pktcoll)
                     (_lhs_pktdist)
                     (_lhs_prekind)
                     (_lhs_ptscoll)
                     (_lhs_ptsdist)
                     (_con_rawrequest_collect)
                     (_lhs_requests_gas)
                     (_lhs_toplevel)
                     (_lhs_verbosity))
    in  (_fbinds_abstracttps_collect
        ,_fbinds_bimapimps_collect
        ,_fbinds_constructors_collect
        ,_fbinds_deps_collect
        ,_con_exports_collect ++ _fbinds_exports_collect
        ,_fbinds_funimps_collect
        ,_fbinds_genabs_collect
        ,_fbinds_implications_collect
        ,_con_imports_collect ++ _fbinds_imports_collect
        ,_con_initialTypes ++ _fbinds_initialTypes
        ,_con_initialValues ++ _fbinds_initialValues
        ,_fbinds_kinames
        ,_fbinds_kindvar
        ,_fbinds_ksubst
        ,Nothing
        ,_fbinds_methods_collect
        ,_con_nonrecs ++ _fbinds_nonrecs
        ,_fbinds_pconsigs_col
        ,_fbinds_pktcoll
        ,_fbinds_ptscoll
        ,_fbinds_rawrequest_collect
        ,_self
        )
sem_Expr_LabUp :: (T_Expr) ->
                  (T_FBinds) ->
                  (T_Expr)
sem_Expr_LabUp (_body)
               (_fbinds)
               (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_kinames)
               (_lhs_kinds)
               (_lhs_kindvar)
               (_lhs_ksubst)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_modules)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_prekind)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_requests_gas)
               (_lhs_toplevel)
               (_lhs_verbosity) =
    let (_self) =
            Expr_LabUp _body_self _fbinds_self
        ( _body_abstracttps_collect,_body_bimapimps_collect,_body_constructors_collect,_body_deps_collect,_body_exports_collect,_body_funimps_collect,_body_genabs_collect,_body_implications_collect,_body_imports_collect,_body_initialTypes,_body_initialValues,_body_kinames,_body_kindvar,_body_ksubst,_body_linkname,_body_methods_collect,_body_nonrecs,_body_pconsigs_col,_body_pktcoll,_body_ptscoll,_body_rawrequest_collect,_body_self) =
            (_body (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
        ( _fbinds_abstracttps_collect
         ,_fbinds_bimapimps_collect
         ,_fbinds_constructors_collect
         ,_fbinds_deps_collect
         ,_fbinds_exports_collect
         ,_fbinds_funimps_collect
         ,_fbinds_genabs_collect
         ,_fbinds_implications_collect
         ,_fbinds_imports_collect
         ,_fbinds_initialTypes
         ,_fbinds_initialValues
         ,_fbinds_kinames
         ,_fbinds_kindvar
         ,_fbinds_ksubst
         ,_fbinds_methods_collect
         ,_fbinds_nonrecs
         ,_fbinds_pconsigs_col
         ,_fbinds_pktcoll
         ,_fbinds_ptscoll
         ,_fbinds_rawrequest_collect
         ,_fbinds_self
         ) =
            (_fbinds (_body_abstracttps_collect)
                     (_body_bimapimps_collect)
                     (_lhs_classname)
                     (_lhs_consigs)
                     (_body_constructors_collect)
                     (_lhs_constructors_dist)
                     (_lhs_currentModule)
                     (_lhs_deps)
                     (_body_deps_collect)
                     (_lhs_exportedTypes)
                     (_lhs_exportedValues)
                     (_lhs_exports)
                     (_body_funimps_collect)
                     (_lhs_genabs)
                     (_body_genabs_collect)
                     (_lhs_hiddenTypes)
                     (_lhs_hiddenValues)
                     (_lhs_hiding)
                     (_body_implications_collect)
                     (_lhs_impliedTypes)
                     (_lhs_impliedValues)
                     (_lhs_importedModule)
                     (_lhs_importedTypes)
                     (_lhs_importedValues)
                     (_body_kinames)
                     (_lhs_kinds)
                     (_body_kindvar)
                     (_body_ksubst)
                     (_lhs_local)
                     (_body_methods_collect)
                     (_lhs_methods_dist)
                     (_lhs_modules)
                     (_lhs_pconsigs)
                     (_body_pconsigs_col)
                     (_body_pktcoll)
                     (_lhs_pktdist)
                     (_lhs_prekind)
                     (_body_ptscoll)
                     (_lhs_ptsdist)
                     (_body_rawrequest_collect)
                     (_lhs_requests_gas)
                     (_lhs_toplevel)
                     (_lhs_verbosity))
    in  (_fbinds_abstracttps_collect
        ,_fbinds_bimapimps_collect
        ,_fbinds_constructors_collect
        ,_fbinds_deps_collect
        ,_body_exports_collect ++ _fbinds_exports_collect
        ,_fbinds_funimps_collect
        ,_fbinds_genabs_collect
        ,_fbinds_implications_collect
        ,_body_imports_collect ++ _fbinds_imports_collect
        ,_body_initialTypes ++ _fbinds_initialTypes
        ,_body_initialValues ++ _fbinds_initialValues
        ,_fbinds_kinames
        ,_fbinds_kindvar
        ,_fbinds_ksubst
        ,_body_linkname
        ,_fbinds_methods_collect
        ,_body_nonrecs ++ _fbinds_nonrecs
        ,_fbinds_pconsigs_col
        ,_fbinds_pktcoll
        ,_fbinds_ptscoll
        ,_fbinds_rawrequest_collect
        ,_self
        )
sem_Expr_Lam :: (T_Patterns) ->
                (T_Expr) ->
                (T_Expr)
sem_Expr_Lam (_from)
             (_body)
             (_lhs_abstracttps_collect)
             (_lhs_bimapimps_collect)
             (_lhs_classname)
             (_lhs_consigs)
             (_lhs_constructors_collect)
             (_lhs_constructors_dist)
             (_lhs_currentModule)
             (_lhs_deps)
             (_lhs_deps_collect)
             (_lhs_exportedTypes)
             (_lhs_exportedValues)
             (_lhs_exports)
             (_lhs_funimps_collect)
             (_lhs_genabs)
             (_lhs_genabs_collect)
             (_lhs_hiddenTypes)
             (_lhs_hiddenValues)
             (_lhs_hiding)
             (_lhs_implications_collect)
             (_lhs_impliedTypes)
             (_lhs_impliedValues)
             (_lhs_importedModule)
             (_lhs_importedTypes)
             (_lhs_importedValues)
             (_lhs_kinames)
             (_lhs_kinds)
             (_lhs_kindvar)
             (_lhs_ksubst)
             (_lhs_local)
             (_lhs_methods_collect)
             (_lhs_methods_dist)
             (_lhs_modules)
             (_lhs_pconsigs)
             (_lhs_pconsigs_col)
             (_lhs_pktcoll)
             (_lhs_pktdist)
             (_lhs_prekind)
             (_lhs_ptscoll)
             (_lhs_ptsdist)
             (_lhs_rawrequest_collect)
             (_lhs_requests_gas)
             (_lhs_toplevel)
             (_lhs_verbosity) =
    let (_self) =
            Expr_Lam _from_self _body_self
        ( _from_abstracttps_collect,_from_bimapimps_collect,_from_constructors_collect,_from_deps_collect,_from_exports_collect,_from_funimps_collect,_from_genabs_collect,_from_implications_collect,_from_imports_collect,_from_initialTypes,_from_initialValues,_from_methods_collect,_from_nonrecs,_from_pconsigs_col,_from_pktcoll,_from_ptscoll,_from_rawrequest_collect,_from_self) =
            (_from (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
        ( _body_abstracttps_collect,_body_bimapimps_collect,_body_constructors_collect,_body_deps_collect,_body_exports_collect,_body_funimps_collect,_body_genabs_collect,_body_implications_collect,_body_imports_collect,_body_initialTypes,_body_initialValues,_body_kinames,_body_kindvar,_body_ksubst,_body_linkname,_body_methods_collect,_body_nonrecs,_body_pconsigs_col,_body_pktcoll,_body_ptscoll,_body_rawrequest_collect,_body_self) =
            (_body (_from_abstracttps_collect)
                   (_from_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_from_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_from_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_from_funimps_collect)
                   (_lhs_genabs)
                   (_from_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_from_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_from_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_from_pconsigs_col)
                   (_from_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_from_ptscoll)
                   (_lhs_ptsdist)
                   (_from_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_body_abstracttps_collect
        ,_body_bimapimps_collect
        ,_body_constructors_collect
        ,_body_deps_collect
        ,_from_exports_collect ++ _body_exports_collect
        ,_body_funimps_collect
        ,_body_genabs_collect
        ,_body_implications_collect
        ,_from_imports_collect ++ _body_imports_collect
        ,_from_initialTypes ++ _body_initialTypes
        ,_from_initialValues ++ _body_initialValues
        ,_body_kinames
        ,_body_kindvar
        ,_body_ksubst
        ,_body_linkname
        ,_body_methods_collect
        ,_from_nonrecs ++ _body_nonrecs
        ,_body_pconsigs_col
        ,_body_pktcoll
        ,_body_ptscoll
        ,_body_rawrequest_collect
        ,_self
        )
sem_Expr_LeftSection :: (T_QualName) ->
                        (T_Expr) ->
                        (T_Expr)
sem_Expr_LeftSection (_op)
                     (_left)
                     (_lhs_abstracttps_collect)
                     (_lhs_bimapimps_collect)
                     (_lhs_classname)
                     (_lhs_consigs)
                     (_lhs_constructors_collect)
                     (_lhs_constructors_dist)
                     (_lhs_currentModule)
                     (_lhs_deps)
                     (_lhs_deps_collect)
                     (_lhs_exportedTypes)
                     (_lhs_exportedValues)
                     (_lhs_exports)
                     (_lhs_funimps_collect)
                     (_lhs_genabs)
                     (_lhs_genabs_collect)
                     (_lhs_hiddenTypes)
                     (_lhs_hiddenValues)
                     (_lhs_hiding)
                     (_lhs_implications_collect)
                     (_lhs_impliedTypes)
                     (_lhs_impliedValues)
                     (_lhs_importedModule)
                     (_lhs_importedTypes)
                     (_lhs_importedValues)
                     (_lhs_kinames)
                     (_lhs_kinds)
                     (_lhs_kindvar)
                     (_lhs_ksubst)
                     (_lhs_local)
                     (_lhs_methods_collect)
                     (_lhs_methods_dist)
                     (_lhs_modules)
                     (_lhs_pconsigs)
                     (_lhs_pconsigs_col)
                     (_lhs_pktcoll)
                     (_lhs_pktdist)
                     (_lhs_prekind)
                     (_lhs_ptscoll)
                     (_lhs_ptsdist)
                     (_lhs_rawrequest_collect)
                     (_lhs_requests_gas)
                     (_lhs_toplevel)
                     (_lhs_verbosity) =
    let (_self) =
            Expr_LeftSection _op_self _left_self
        ( _op_abstracttps_collect,_op_bimapimps_collect,_op_constructors_collect,_op_deps_collect,_op_exports_collect,_op_funimps_collect,_op_genabs_collect,_op_implications_collect,_op_imports_collect,_op_initialTypes,_op_initialValues,_op_methods_collect,_op_nonrecs,_op_pconsigs_col,_op_pktcoll,_op_rawrequest_collect,_op_self) =
            (_op (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel))
        ( _left_abstracttps_collect,_left_bimapimps_collect,_left_constructors_collect,_left_deps_collect,_left_exports_collect,_left_funimps_collect,_left_genabs_collect,_left_implications_collect,_left_imports_collect,_left_initialTypes,_left_initialValues,_left_kinames,_left_kindvar,_left_ksubst,_left_linkname,_left_methods_collect,_left_nonrecs,_left_pconsigs_col,_left_pktcoll,_left_ptscoll,_left_rawrequest_collect,_left_self) =
            (_left (_op_abstracttps_collect)
                   (_op_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_op_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_op_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_op_funimps_collect)
                   (_lhs_genabs)
                   (_op_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_op_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_op_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_op_pconsigs_col)
                   (_op_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_op_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_left_abstracttps_collect
        ,_left_bimapimps_collect
        ,_left_constructors_collect
        ,_left_deps_collect
        ,_op_exports_collect ++ _left_exports_collect
        ,_left_funimps_collect
        ,_left_genabs_collect
        ,_left_implications_collect
        ,_op_imports_collect ++ _left_imports_collect
        ,_op_initialTypes ++ _left_initialTypes
        ,_op_initialValues ++ _left_initialValues
        ,_left_kinames
        ,_left_kindvar
        ,_left_ksubst
        ,_left_linkname
        ,_left_methods_collect
        ,_op_nonrecs ++ _left_nonrecs
        ,_left_pconsigs_col
        ,_left_pktcoll
        ,_left_ptscoll
        ,_left_rawrequest_collect
        ,_self
        )
sem_Expr_Let :: (T_SDecls) ->
                (T_Expr) ->
                (T_Expr)
sem_Expr_Let (_decls)
             (_body)
             (_lhs_abstracttps_collect)
             (_lhs_bimapimps_collect)
             (_lhs_classname)
             (_lhs_consigs)
             (_lhs_constructors_collect)
             (_lhs_constructors_dist)
             (_lhs_currentModule)
             (_lhs_deps)
             (_lhs_deps_collect)
             (_lhs_exportedTypes)
             (_lhs_exportedValues)
             (_lhs_exports)
             (_lhs_funimps_collect)
             (_lhs_genabs)
             (_lhs_genabs_collect)
             (_lhs_hiddenTypes)
             (_lhs_hiddenValues)
             (_lhs_hiding)
             (_lhs_implications_collect)
             (_lhs_impliedTypes)
             (_lhs_impliedValues)
             (_lhs_importedModule)
             (_lhs_importedTypes)
             (_lhs_importedValues)
             (_lhs_kinames)
             (_lhs_kinds)
             (_lhs_kindvar)
             (_lhs_ksubst)
             (_lhs_local)
             (_lhs_methods_collect)
             (_lhs_methods_dist)
             (_lhs_modules)
             (_lhs_pconsigs)
             (_lhs_pconsigs_col)
             (_lhs_pktcoll)
             (_lhs_pktdist)
             (_lhs_prekind)
             (_lhs_ptscoll)
             (_lhs_ptsdist)
             (_lhs_rawrequest_collect)
             (_lhs_requests_gas)
             (_lhs_toplevel)
             (_lhs_verbosity) =
    let (_self) =
            Expr_Let _decls_self _body_self
        (_ptsdist) =
            _decls_ptscoll
        (_pktdist) =
            _decls_pktcoll
        ( _decls_abstracttps_collect
         ,_decls_bimapimps_collect
         ,_decls_constructors_collect
         ,_decls_count
         ,_decls_deps_collect
         ,_decls_exports_collect
         ,_decls_funimps_collect
         ,_decls_genabs_collect
         ,_decls_implications_collect
         ,_decls_imports_collect
         ,_decls_initialTypes
         ,_decls_initialValues
         ,_decls_kinames
         ,_decls_kindvar
         ,_decls_ksubst
         ,_decls_methods_collect
         ,_decls_nil
         ,_decls_nonrecs
         ,_decls_pconsigs_col
         ,_decls_pktcoll
         ,_decls_ptscoll
         ,_decls_rawrequest_collect
         ,_decls_self
         ) =
            (_decls (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_kinames)
                    (_lhs_kinds)
                    (_lhs_kindvar)
                    (_lhs_ksubst)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktdist)
                    (_pktdist)
                    (_lhs_prekind)
                    (_lhs_ptsdist)
                    (_ptsdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_toplevel)
                    (_lhs_verbosity))
        ( _body_abstracttps_collect,_body_bimapimps_collect,_body_constructors_collect,_body_deps_collect,_body_exports_collect,_body_funimps_collect,_body_genabs_collect,_body_implications_collect,_body_imports_collect,_body_initialTypes,_body_initialValues,_body_kinames,_body_kindvar,_body_ksubst,_body_linkname,_body_methods_collect,_body_nonrecs,_body_pconsigs_col,_body_pktcoll,_body_ptscoll,_body_rawrequest_collect,_body_self) =
            (_body (_decls_abstracttps_collect)
                   (_decls_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_decls_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_decls_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_decls_funimps_collect)
                   (_lhs_genabs)
                   (_decls_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_decls_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_decls_kinames)
                   (_lhs_kinds)
                   (_decls_kindvar)
                   (_decls_ksubst)
                   (_lhs_local)
                   (_decls_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_decls_pconsigs_col)
                   (_decls_pktcoll)
                   (_pktdist)
                   (_lhs_prekind)
                   (_decls_ptscoll)
                   (_ptsdist)
                   (_decls_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_body_abstracttps_collect
        ,_body_bimapimps_collect
        ,_body_constructors_collect
        ,_body_deps_collect
        ,_decls_exports_collect ++ _body_exports_collect
        ,_body_funimps_collect
        ,_body_genabs_collect
        ,_body_implications_collect
        ,_decls_imports_collect ++ _body_imports_collect
        ,_decls_initialTypes ++ _body_initialTypes
        ,_decls_initialValues ++ _body_initialValues
        ,_body_kinames
        ,_body_kindvar
        ,_body_ksubst
        ,_body_linkname
        ,_body_methods_collect
        ,_decls_nonrecs ++ _body_nonrecs
        ,_body_pconsigs_col
        ,_lhs_pktcoll
        ,_lhs_ptscoll
        ,_body_rawrequest_collect
        ,_self
        )
sem_Expr_List :: (T_Exprs) ->
                 (T_Expr)
sem_Expr_List (_exprs)
              (_lhs_abstracttps_collect)
              (_lhs_bimapimps_collect)
              (_lhs_classname)
              (_lhs_consigs)
              (_lhs_constructors_collect)
              (_lhs_constructors_dist)
              (_lhs_currentModule)
              (_lhs_deps)
              (_lhs_deps_collect)
              (_lhs_exportedTypes)
              (_lhs_exportedValues)
              (_lhs_exports)
              (_lhs_funimps_collect)
              (_lhs_genabs)
              (_lhs_genabs_collect)
              (_lhs_hiddenTypes)
              (_lhs_hiddenValues)
              (_lhs_hiding)
              (_lhs_implications_collect)
              (_lhs_impliedTypes)
              (_lhs_impliedValues)
              (_lhs_importedModule)
              (_lhs_importedTypes)
              (_lhs_importedValues)
              (_lhs_kinames)
              (_lhs_kinds)
              (_lhs_kindvar)
              (_lhs_ksubst)
              (_lhs_local)
              (_lhs_methods_collect)
              (_lhs_methods_dist)
              (_lhs_modules)
              (_lhs_pconsigs)
              (_lhs_pconsigs_col)
              (_lhs_pktcoll)
              (_lhs_pktdist)
              (_lhs_prekind)
              (_lhs_ptscoll)
              (_lhs_ptsdist)
              (_lhs_rawrequest_collect)
              (_lhs_requests_gas)
              (_lhs_toplevel)
              (_lhs_verbosity) =
    let (_self) =
            Expr_List _exprs_self
        ( _exprs_abstracttps_collect,_exprs_bimapimps_collect,_exprs_constructors_collect,_exprs_deps_collect,_exprs_exports_collect,_exprs_funimps_collect,_exprs_genabs_collect,_exprs_implications_collect,_exprs_imports_collect,_exprs_initialTypes,_exprs_initialValues,_exprs_kinames,_exprs_kindvar,_exprs_ksubst,_exprs_methods_collect,_exprs_nonrecs,_exprs_pconsigs_col,_exprs_pktcoll,_exprs_ptscoll,_exprs_rawrequest_collect,_exprs_self) =
            (_exprs (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_kinames)
                    (_lhs_kinds)
                    (_lhs_kindvar)
                    (_lhs_ksubst)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_lhs_ptscoll)
                    (_lhs_ptsdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_toplevel)
                    (_lhs_verbosity))
    in  (_exprs_abstracttps_collect,_exprs_bimapimps_collect,_exprs_constructors_collect,_exprs_deps_collect,_exprs_exports_collect,_exprs_funimps_collect,_exprs_genabs_collect,_exprs_implications_collect,_exprs_imports_collect,_exprs_initialTypes,_exprs_initialValues,_exprs_kinames,_exprs_kindvar,_exprs_ksubst,Nothing,_exprs_methods_collect,_exprs_nonrecs,_exprs_pconsigs_col,_exprs_pktcoll,_exprs_ptscoll,_exprs_rawrequest_collect,_self)
sem_Expr_Lit :: (T_Literal) ->
                (T_Expr)
sem_Expr_Lit (_name)
             (_lhs_abstracttps_collect)
             (_lhs_bimapimps_collect)
             (_lhs_classname)
             (_lhs_consigs)
             (_lhs_constructors_collect)
             (_lhs_constructors_dist)
             (_lhs_currentModule)
             (_lhs_deps)
             (_lhs_deps_collect)
             (_lhs_exportedTypes)
             (_lhs_exportedValues)
             (_lhs_exports)
             (_lhs_funimps_collect)
             (_lhs_genabs)
             (_lhs_genabs_collect)
             (_lhs_hiddenTypes)
             (_lhs_hiddenValues)
             (_lhs_hiding)
             (_lhs_implications_collect)
             (_lhs_impliedTypes)
             (_lhs_impliedValues)
             (_lhs_importedModule)
             (_lhs_importedTypes)
             (_lhs_importedValues)
             (_lhs_kinames)
             (_lhs_kinds)
             (_lhs_kindvar)
             (_lhs_ksubst)
             (_lhs_local)
             (_lhs_methods_collect)
             (_lhs_methods_dist)
             (_lhs_modules)
             (_lhs_pconsigs)
             (_lhs_pconsigs_col)
             (_lhs_pktcoll)
             (_lhs_pktdist)
             (_lhs_prekind)
             (_lhs_ptscoll)
             (_lhs_ptsdist)
             (_lhs_rawrequest_collect)
             (_lhs_requests_gas)
             (_lhs_toplevel)
             (_lhs_verbosity) =
    let (_self) =
            Expr_Lit _name_self
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_ptscoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_lhs_kinames,_lhs_kindvar,_lhs_ksubst,Nothing,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_ptscoll,_name_rawrequest_collect,_self)
sem_Expr_Negate :: (T_Expr) ->
                   (T_Expr)
sem_Expr_Negate (_expr)
                (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_kinames)
                (_lhs_kinds)
                (_lhs_kindvar)
                (_lhs_ksubst)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_modules)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_prekind)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_requests_gas)
                (_lhs_toplevel)
                (_lhs_verbosity) =
    let (_self) =
            Expr_Negate _expr_self
        ( _expr_abstracttps_collect,_expr_bimapimps_collect,_expr_constructors_collect,_expr_deps_collect,_expr_exports_collect,_expr_funimps_collect,_expr_genabs_collect,_expr_implications_collect,_expr_imports_collect,_expr_initialTypes,_expr_initialValues,_expr_kinames,_expr_kindvar,_expr_ksubst,_expr_linkname,_expr_methods_collect,_expr_nonrecs,_expr_pconsigs_col,_expr_pktcoll,_expr_ptscoll,_expr_rawrequest_collect,_expr_self) =
            (_expr (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_expr_abstracttps_collect,_expr_bimapimps_collect,_expr_constructors_collect,_expr_deps_collect,_expr_exports_collect,_expr_funimps_collect,_expr_genabs_collect,_expr_implications_collect,_expr_imports_collect,_expr_initialTypes,_expr_initialValues,_expr_kinames,_expr_kindvar,_expr_ksubst,_expr_linkname,_expr_methods_collect,_expr_nonrecs,_expr_pconsigs_col,_expr_pktcoll,_expr_ptscoll,_expr_rawrequest_collect,_self)
sem_Expr_OpApp :: (T_QualName) ->
                  (T_Expr) ->
                  (T_Expr) ->
                  (T_Expr)
sem_Expr_OpApp (_op)
               (_left)
               (_right)
               (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_kinames)
               (_lhs_kinds)
               (_lhs_kindvar)
               (_lhs_ksubst)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_modules)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_prekind)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_requests_gas)
               (_lhs_toplevel)
               (_lhs_verbosity) =
    let (_self) =
            Expr_OpApp _op_self _left_self _right_self
        ( _op_abstracttps_collect,_op_bimapimps_collect,_op_constructors_collect,_op_deps_collect,_op_exports_collect,_op_funimps_collect,_op_genabs_collect,_op_implications_collect,_op_imports_collect,_op_initialTypes,_op_initialValues,_op_methods_collect,_op_nonrecs,_op_pconsigs_col,_op_pktcoll,_op_rawrequest_collect,_op_self) =
            (_op (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel))
        ( _left_abstracttps_collect,_left_bimapimps_collect,_left_constructors_collect,_left_deps_collect,_left_exports_collect,_left_funimps_collect,_left_genabs_collect,_left_implications_collect,_left_imports_collect,_left_initialTypes,_left_initialValues,_left_kinames,_left_kindvar,_left_ksubst,_left_linkname,_left_methods_collect,_left_nonrecs,_left_pconsigs_col,_left_pktcoll,_left_ptscoll,_left_rawrequest_collect,_left_self) =
            (_left (_op_abstracttps_collect)
                   (_op_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_op_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_op_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_op_funimps_collect)
                   (_lhs_genabs)
                   (_op_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_op_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_op_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_op_pconsigs_col)
                   (_op_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_op_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
        ( _right_abstracttps_collect
         ,_right_bimapimps_collect
         ,_right_constructors_collect
         ,_right_deps_collect
         ,_right_exports_collect
         ,_right_funimps_collect
         ,_right_genabs_collect
         ,_right_implications_collect
         ,_right_imports_collect
         ,_right_initialTypes
         ,_right_initialValues
         ,_right_kinames
         ,_right_kindvar
         ,_right_ksubst
         ,_right_linkname
         ,_right_methods_collect
         ,_right_nonrecs
         ,_right_pconsigs_col
         ,_right_pktcoll
         ,_right_ptscoll
         ,_right_rawrequest_collect
         ,_right_self
         ) =
            (_right (_left_abstracttps_collect)
                    (_left_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_left_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_left_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_left_funimps_collect)
                    (_lhs_genabs)
                    (_left_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_left_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_left_kinames)
                    (_lhs_kinds)
                    (_left_kindvar)
                    (_left_ksubst)
                    (_lhs_local)
                    (_left_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_left_pconsigs_col)
                    (_left_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_left_ptscoll)
                    (_lhs_ptsdist)
                    (_left_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_toplevel)
                    (_lhs_verbosity))
    in  (_right_abstracttps_collect
        ,_right_bimapimps_collect
        ,_right_constructors_collect
        ,_right_deps_collect
        ,_op_exports_collect ++ _left_exports_collect ++ _right_exports_collect
        ,_right_funimps_collect
        ,_right_genabs_collect
        ,_right_implications_collect
        ,_op_imports_collect ++ _left_imports_collect ++ _right_imports_collect
        ,_op_initialTypes ++ _left_initialTypes ++ _right_initialTypes
        ,_op_initialValues ++ _left_initialValues ++ _right_initialValues
        ,_right_kinames
        ,_right_kindvar
        ,_right_ksubst
        ,_left_linkname `const` _right_linkname
        ,_right_methods_collect
        ,_op_nonrecs ++ _left_nonrecs ++ _right_nonrecs
        ,_right_pconsigs_col
        ,_right_pktcoll
        ,_right_ptscoll
        ,_right_rawrequest_collect
        ,_self
        )
sem_Expr_Parens :: (T_Expr) ->
                   (T_Expr)
sem_Expr_Parens (_body)
                (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_kinames)
                (_lhs_kinds)
                (_lhs_kindvar)
                (_lhs_ksubst)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_modules)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_prekind)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_requests_gas)
                (_lhs_toplevel)
                (_lhs_verbosity) =
    let (_self) =
            Expr_Parens _body_self
        ( _body_abstracttps_collect,_body_bimapimps_collect,_body_constructors_collect,_body_deps_collect,_body_exports_collect,_body_funimps_collect,_body_genabs_collect,_body_implications_collect,_body_imports_collect,_body_initialTypes,_body_initialValues,_body_kinames,_body_kindvar,_body_ksubst,_body_linkname,_body_methods_collect,_body_nonrecs,_body_pconsigs_col,_body_pktcoll,_body_ptscoll,_body_rawrequest_collect,_body_self) =
            (_body (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_body_abstracttps_collect,_body_bimapimps_collect,_body_constructors_collect,_body_deps_collect,_body_exports_collect,_body_funimps_collect,_body_genabs_collect,_body_implications_collect,_body_imports_collect,_body_initialTypes,_body_initialValues,_body_kinames,_body_kindvar,_body_ksubst,_body_linkname,_body_methods_collect,_body_nonrecs,_body_pconsigs_col,_body_pktcoll,_body_ptscoll,_body_rawrequest_collect,_self)
sem_Expr_RightSection :: (T_QualName) ->
                         (T_Expr) ->
                         (T_Expr)
sem_Expr_RightSection (_op)
                      (_right)
                      (_lhs_abstracttps_collect)
                      (_lhs_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_lhs_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_lhs_funimps_collect)
                      (_lhs_genabs)
                      (_lhs_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_lhs_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_lhs_kinames)
                      (_lhs_kinds)
                      (_lhs_kindvar)
                      (_lhs_ksubst)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_modules)
                      (_lhs_pconsigs)
                      (_lhs_pconsigs_col)
                      (_lhs_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_prekind)
                      (_lhs_ptscoll)
                      (_lhs_ptsdist)
                      (_lhs_rawrequest_collect)
                      (_lhs_requests_gas)
                      (_lhs_toplevel)
                      (_lhs_verbosity) =
    let (_self) =
            Expr_RightSection _op_self _right_self
        ( _op_abstracttps_collect,_op_bimapimps_collect,_op_constructors_collect,_op_deps_collect,_op_exports_collect,_op_funimps_collect,_op_genabs_collect,_op_implications_collect,_op_imports_collect,_op_initialTypes,_op_initialValues,_op_methods_collect,_op_nonrecs,_op_pconsigs_col,_op_pktcoll,_op_rawrequest_collect,_op_self) =
            (_op (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel))
        ( _right_abstracttps_collect
         ,_right_bimapimps_collect
         ,_right_constructors_collect
         ,_right_deps_collect
         ,_right_exports_collect
         ,_right_funimps_collect
         ,_right_genabs_collect
         ,_right_implications_collect
         ,_right_imports_collect
         ,_right_initialTypes
         ,_right_initialValues
         ,_right_kinames
         ,_right_kindvar
         ,_right_ksubst
         ,_right_linkname
         ,_right_methods_collect
         ,_right_nonrecs
         ,_right_pconsigs_col
         ,_right_pktcoll
         ,_right_ptscoll
         ,_right_rawrequest_collect
         ,_right_self
         ) =
            (_right (_op_abstracttps_collect)
                    (_op_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_op_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_op_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_op_funimps_collect)
                    (_lhs_genabs)
                    (_op_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_op_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_kinames)
                    (_lhs_kinds)
                    (_lhs_kindvar)
                    (_lhs_ksubst)
                    (_lhs_local)
                    (_op_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_op_pconsigs_col)
                    (_op_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_lhs_ptscoll)
                    (_lhs_ptsdist)
                    (_op_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_toplevel)
                    (_lhs_verbosity))
    in  (_right_abstracttps_collect
        ,_right_bimapimps_collect
        ,_right_constructors_collect
        ,_right_deps_collect
        ,_op_exports_collect ++ _right_exports_collect
        ,_right_funimps_collect
        ,_right_genabs_collect
        ,_right_implications_collect
        ,_op_imports_collect ++ _right_imports_collect
        ,_op_initialTypes ++ _right_initialTypes
        ,_op_initialValues ++ _right_initialValues
        ,_right_kinames
        ,_right_kindvar
        ,_right_ksubst
        ,_right_linkname
        ,_right_methods_collect
        ,_op_nonrecs ++ _right_nonrecs
        ,_right_pconsigs_col
        ,_right_pktcoll
        ,_right_ptscoll
        ,_right_rawrequest_collect
        ,_self
        )
sem_Expr_Tuple :: (T_Exprs) ->
                  (T_Expr)
sem_Expr_Tuple (_exprs)
               (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_kinames)
               (_lhs_kinds)
               (_lhs_kindvar)
               (_lhs_ksubst)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_modules)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_prekind)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_requests_gas)
               (_lhs_toplevel)
               (_lhs_verbosity) =
    let (_self) =
            Expr_Tuple _exprs_self
        ( _exprs_abstracttps_collect,_exprs_bimapimps_collect,_exprs_constructors_collect,_exprs_deps_collect,_exprs_exports_collect,_exprs_funimps_collect,_exprs_genabs_collect,_exprs_implications_collect,_exprs_imports_collect,_exprs_initialTypes,_exprs_initialValues,_exprs_kinames,_exprs_kindvar,_exprs_ksubst,_exprs_methods_collect,_exprs_nonrecs,_exprs_pconsigs_col,_exprs_pktcoll,_exprs_ptscoll,_exprs_rawrequest_collect,_exprs_self) =
            (_exprs (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_kinames)
                    (_lhs_kinds)
                    (_lhs_kindvar)
                    (_lhs_ksubst)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_lhs_ptscoll)
                    (_lhs_ptsdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_toplevel)
                    (_lhs_verbosity))
    in  (_exprs_abstracttps_collect,_exprs_bimapimps_collect,_exprs_constructors_collect,_exprs_deps_collect,_exprs_exports_collect,_exprs_funimps_collect,_exprs_genabs_collect,_exprs_implications_collect,_exprs_imports_collect,_exprs_initialTypes,_exprs_initialValues,_exprs_kinames,_exprs_kindvar,_exprs_ksubst,Nothing,_exprs_methods_collect,_exprs_nonrecs,_exprs_pconsigs_col,_exprs_pktcoll,_exprs_ptscoll,_exprs_rawrequest_collect,_self)
sem_Expr_TyApp :: (T_Position) ->
                  (T_QualName) ->
                  (T_Type) ->
                  (T_Expr)
sem_Expr_TyApp (_srcloc)
               (_expr)
               (_tp)
               (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_kinames)
               (_lhs_kinds)
               (_lhs_kindvar)
               (_lhs_ksubst)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_modules)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_prekind)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_requests_gas)
               (_lhs_toplevel)
               (_lhs_verbosity) =
    let (_self) =
            Expr_TyApp _srcloc_self _expr_self _tp_self
        (_rawrequest_collect) =
            RawRequest (_expr_self,_tp_self) : _lhs_rawrequest_collect
        ( _srcloc_self) =
            (_srcloc )
        ( _expr_abstracttps_collect,_expr_bimapimps_collect,_expr_constructors_collect,_expr_deps_collect,_expr_exports_collect,_expr_funimps_collect,_expr_genabs_collect,_expr_implications_collect,_expr_imports_collect,_expr_initialTypes,_expr_initialValues,_expr_methods_collect,_expr_nonrecs,_expr_pconsigs_col,_expr_pktcoll,_expr_rawrequest_collect,_expr_self) =
            (_expr (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_rawrequest_collect)
                   (_lhs_toplevel))
        ( _tp_abstracttps_collect,_tp_bimapimps_collect,_tp_constructors_collect,_tp_deps_collect,_tp_exports_collect,_tp_funimps_collect,_tp_genabs_collect,_tp_implications_collect,_tp_imports_collect,_tp_inferkind,_tp_initialTypes,_tp_initialValues,_tp_kinames,_tp_kind_errors,_tp_kindvar,_tp_kloc,_tp_ksubst,_tp_methods_collect,_tp_nonrecs,_tp_pconsigs_col,_tp_pktcoll,_tp_ptscoll,_tp_rawrequest_collect,_tp_self) =
            (_tp (_expr_abstracttps_collect)
                 (_expr_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_expr_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_expr_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_expr_funimps_collect)
                 (_lhs_genabs)
                 (_expr_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_expr_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_expr_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_expr_pconsigs_col)
                 (_expr_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_expr_rawrequest_collect)
                 (_lhs_toplevel))
    in  (_tp_abstracttps_collect
        ,_tp_bimapimps_collect
        ,_tp_constructors_collect
        ,_tp_deps_collect
        ,_expr_exports_collect ++ _tp_exports_collect
        ,_tp_funimps_collect
        ,_tp_genabs_collect
        ,_tp_implications_collect
        ,_expr_imports_collect ++ _tp_imports_collect
        ,_expr_initialTypes ++ _tp_initialTypes
        ,_expr_initialValues ++ _tp_initialValues
        ,_tp_kinames
        ,_tp_kindvar
        ,_tp_ksubst
        ,Just _expr_self
        ,_tp_methods_collect
        ,_expr_nonrecs ++ _tp_nonrecs
        ,_tp_pconsigs_col
        ,_tp_pktcoll
        ,_tp_ptscoll
        ,_tp_rawrequest_collect
        ,_self
        )
sem_Expr_TypeSig :: (T_Expr) ->
                    (T_QualType) ->
                    (T_Expr)
sem_Expr_TypeSig (_body)
                 (_tp)
                 (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kinds)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity) =
    let (_self) =
            Expr_TypeSig _body_self _tp_self
        ( _body_abstracttps_collect,_body_bimapimps_collect,_body_constructors_collect,_body_deps_collect,_body_exports_collect,_body_funimps_collect,_body_genabs_collect,_body_implications_collect,_body_imports_collect,_body_initialTypes,_body_initialValues,_body_kinames,_body_kindvar,_body_ksubst,_body_linkname,_body_methods_collect,_body_nonrecs,_body_pconsigs_col,_body_pktcoll,_body_ptscoll,_body_rawrequest_collect,_body_self) =
            (_body (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
        ( _tp_abstracttps_collect,_tp_bimapimps_collect,_tp_constructors_collect,_tp_deps_collect,_tp_exports_collect,_tp_funimps_collect,_tp_genabs_collect,_tp_implications_collect,_tp_imports_collect,_tp_initialTypes,_tp_initialValues,_tp_kinames,_tp_kind_errors,_tp_kindvar,_tp_ksubst,_tp_methods_collect,_tp_nonrecs,_tp_pconsigs_col,_tp_pktcoll,_tp_ptscoll,_tp_rawrequest_collect,_tp_self) =
            (_tp (_body_abstracttps_collect)
                 (_body_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_body_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_body_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_body_funimps_collect)
                 (_lhs_genabs)
                 (_body_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_body_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_body_kinames)
                 (_body_kindvar)
                 (_body_ksubst)
                 (_lhs_local)
                 (_body_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_body_pconsigs_col)
                 (_body_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_body_ptscoll)
                 (_lhs_ptsdist)
                 (_body_rawrequest_collect)
                 (_lhs_toplevel))
    in  (_tp_abstracttps_collect
        ,_tp_bimapimps_collect
        ,_tp_constructors_collect
        ,_tp_deps_collect
        ,_body_exports_collect ++ _tp_exports_collect
        ,_tp_funimps_collect
        ,_tp_genabs_collect
        ,_tp_implications_collect
        ,_body_imports_collect ++ _tp_imports_collect
        ,_body_initialTypes ++ _tp_initialTypes
        ,_body_initialValues ++ _tp_initialValues
        ,_tp_kinames
        ,_tp_kindvar
        ,_tp_ksubst
        ,_body_linkname
        ,_tp_methods_collect
        ,_body_nonrecs ++ _tp_nonrecs
        ,_tp_pconsigs_col
        ,_tp_pktcoll
        ,_tp_ptscoll
        ,_tp_rawrequest_collect
        ,_self
        )
sem_Expr_Var :: (T_Position) ->
                (T_QualName) ->
                (T_Expr)
sem_Expr_Var (_srcloc)
             (_name)
             (_lhs_abstracttps_collect)
             (_lhs_bimapimps_collect)
             (_lhs_classname)
             (_lhs_consigs)
             (_lhs_constructors_collect)
             (_lhs_constructors_dist)
             (_lhs_currentModule)
             (_lhs_deps)
             (_lhs_deps_collect)
             (_lhs_exportedTypes)
             (_lhs_exportedValues)
             (_lhs_exports)
             (_lhs_funimps_collect)
             (_lhs_genabs)
             (_lhs_genabs_collect)
             (_lhs_hiddenTypes)
             (_lhs_hiddenValues)
             (_lhs_hiding)
             (_lhs_implications_collect)
             (_lhs_impliedTypes)
             (_lhs_impliedValues)
             (_lhs_importedModule)
             (_lhs_importedTypes)
             (_lhs_importedValues)
             (_lhs_kinames)
             (_lhs_kinds)
             (_lhs_kindvar)
             (_lhs_ksubst)
             (_lhs_local)
             (_lhs_methods_collect)
             (_lhs_methods_dist)
             (_lhs_modules)
             (_lhs_pconsigs)
             (_lhs_pconsigs_col)
             (_lhs_pktcoll)
             (_lhs_pktdist)
             (_lhs_prekind)
             (_lhs_ptscoll)
             (_lhs_ptsdist)
             (_lhs_rawrequest_collect)
             (_lhs_requests_gas)
             (_lhs_toplevel)
             (_lhs_verbosity) =
    let (_self) =
            Expr_Var _srcloc_self _name_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_lhs_kinames,_lhs_kindvar,_lhs_ksubst,Nothing,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_lhs_ptscoll,_name_rawrequest_collect,_self)
sem_Expr_Wild :: (T_Expr)
sem_Expr_Wild (_lhs_abstracttps_collect)
              (_lhs_bimapimps_collect)
              (_lhs_classname)
              (_lhs_consigs)
              (_lhs_constructors_collect)
              (_lhs_constructors_dist)
              (_lhs_currentModule)
              (_lhs_deps)
              (_lhs_deps_collect)
              (_lhs_exportedTypes)
              (_lhs_exportedValues)
              (_lhs_exports)
              (_lhs_funimps_collect)
              (_lhs_genabs)
              (_lhs_genabs_collect)
              (_lhs_hiddenTypes)
              (_lhs_hiddenValues)
              (_lhs_hiding)
              (_lhs_implications_collect)
              (_lhs_impliedTypes)
              (_lhs_impliedValues)
              (_lhs_importedModule)
              (_lhs_importedTypes)
              (_lhs_importedValues)
              (_lhs_kinames)
              (_lhs_kinds)
              (_lhs_kindvar)
              (_lhs_ksubst)
              (_lhs_local)
              (_lhs_methods_collect)
              (_lhs_methods_dist)
              (_lhs_modules)
              (_lhs_pconsigs)
              (_lhs_pconsigs_col)
              (_lhs_pktcoll)
              (_lhs_pktdist)
              (_lhs_prekind)
              (_lhs_ptscoll)
              (_lhs_ptsdist)
              (_lhs_rawrequest_collect)
              (_lhs_requests_gas)
              (_lhs_toplevel)
              (_lhs_verbosity) =
    let (_self) =
            Expr_Wild
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_kinames,_lhs_kindvar,_lhs_ksubst,Nothing,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,_self)
-- Exprs -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Exprs

-}
{-
   local variables for Exprs.Cons:

-}
{-
   local variables for Exprs.Nil:

-}
-- semantic domain
type T_Exprs = (Set QualName) ->
               ([Request_BimapImply]) ->
               (Maybe QualName) ->
               (Consigs) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Set QualName) ->
               (Set QualName) ->
               (Exports) ->
               ([Request_FunImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               ([Request_TypeImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               (Set QualName) ->
               (Set QualName) ->
               (KSubst) ->
               (KSubst) ->
               (Int) ->
               (KSubst) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Set Modid) ->
               (PConsigs) ->
               (PConsigs) ->
               (FMap QualName PKT) ->
               (FMap QualName PKT) ->
               (KSubst) ->
               (FMap QualName PTS) ->
               (FMap QualName PTS) ->
               ([RawRequest]) ->
               ([RawRequest]) ->
               (Bool) ->
               (Int) ->
               ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Exprs))
-- cata
sem_Exprs :: (Exprs) ->
             (T_Exprs)
sem_Exprs (list) =
    (foldr (sem_Exprs_Cons) (sem_Exprs_Nil) ((map sem_Expr list)))
sem_Exprs_Cons :: (T_Expr) ->
                  (T_Exprs) ->
                  (T_Exprs)
sem_Exprs_Cons (_hd)
               (_tl)
               (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_kinames)
               (_lhs_kinds)
               (_lhs_kindvar)
               (_lhs_ksubst)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_modules)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_prekind)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_requests_gas)
               (_lhs_toplevel)
               (_lhs_verbosity) =
    let ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_kinames,_hd_kindvar,_hd_ksubst,_hd_linkname,_hd_methods_collect,_hd_nonrecs,_hd_pconsigs_col,_hd_pktcoll,_hd_ptscoll,_hd_rawrequest_collect,_hd_self) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kinds)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_initialTypes,_tl_initialValues,_tl_kinames,_tl_kindvar,_tl_ksubst,_tl_methods_collect,_tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_ptscoll,_tl_rawrequest_collect,_tl_self) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_hd_kinames)
                 (_lhs_kinds)
                 (_hd_kindvar)
                 (_hd_ksubst)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_hd_ptscoll)
                 (_lhs_ptsdist)
                 (_hd_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
    in  (_tl_abstracttps_collect
        ,_tl_bimapimps_collect
        ,_tl_constructors_collect
        ,_tl_deps_collect
        ,_hd_exports_collect ++ _tl_exports_collect
        ,_tl_funimps_collect
        ,_tl_genabs_collect
        ,_tl_implications_collect
        ,_hd_imports_collect ++ _tl_imports_collect
        ,_hd_initialTypes ++ _tl_initialTypes
        ,_hd_initialValues ++ _tl_initialValues
        ,_tl_kinames
        ,_tl_kindvar
        ,_tl_ksubst
        ,_tl_methods_collect
        ,_hd_nonrecs ++ _tl_nonrecs
        ,_tl_pconsigs_col
        ,_tl_pktcoll
        ,_tl_ptscoll
        ,_tl_rawrequest_collect
        ,_hd_self : _tl_self
        )
sem_Exprs_Nil :: (T_Exprs)
sem_Exprs_Nil (_lhs_abstracttps_collect)
              (_lhs_bimapimps_collect)
              (_lhs_classname)
              (_lhs_consigs)
              (_lhs_constructors_collect)
              (_lhs_constructors_dist)
              (_lhs_currentModule)
              (_lhs_deps)
              (_lhs_deps_collect)
              (_lhs_exportedTypes)
              (_lhs_exportedValues)
              (_lhs_exports)
              (_lhs_funimps_collect)
              (_lhs_genabs)
              (_lhs_genabs_collect)
              (_lhs_hiddenTypes)
              (_lhs_hiddenValues)
              (_lhs_hiding)
              (_lhs_implications_collect)
              (_lhs_impliedTypes)
              (_lhs_impliedValues)
              (_lhs_importedModule)
              (_lhs_importedTypes)
              (_lhs_importedValues)
              (_lhs_kinames)
              (_lhs_kinds)
              (_lhs_kindvar)
              (_lhs_ksubst)
              (_lhs_local)
              (_lhs_methods_collect)
              (_lhs_methods_dist)
              (_lhs_modules)
              (_lhs_pconsigs)
              (_lhs_pconsigs_col)
              (_lhs_pktcoll)
              (_lhs_pktdist)
              (_lhs_prekind)
              (_lhs_ptscoll)
              (_lhs_ptsdist)
              (_lhs_rawrequest_collect)
              (_lhs_requests_gas)
              (_lhs_toplevel)
              (_lhs_verbosity) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_kinames,_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,[])
-- FBind -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : FBind

-}
{-
   local variables for FBind.FBind:

-}
-- semantic domain
type T_FBind = (Set QualName) ->
               ([Request_BimapImply]) ->
               (Maybe QualName) ->
               (Consigs) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Set QualName) ->
               (Set QualName) ->
               (Exports) ->
               ([Request_FunImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               ([Request_TypeImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               (Set QualName) ->
               (Set QualName) ->
               (KSubst) ->
               (KSubst) ->
               (Int) ->
               (KSubst) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Set Modid) ->
               (PConsigs) ->
               (PConsigs) ->
               (FMap QualName PKT) ->
               (FMap QualName PKT) ->
               (KSubst) ->
               (FMap QualName PTS) ->
               (FMap QualName PTS) ->
               ([RawRequest]) ->
               ([RawRequest]) ->
               (Bool) ->
               (Int) ->
               ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(FBind))
-- cata
sem_FBind :: (FBind) ->
             (T_FBind)
sem_FBind ((FBind_FBind (_field) (_expr))) =
    (sem_FBind_FBind ((sem_QualName (_field))) ((sem_Expr (_expr))))
sem_FBind_FBind :: (T_QualName) ->
                   (T_Expr) ->
                   (T_FBind)
sem_FBind_FBind (_field)
                (_expr)
                (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_kinames)
                (_lhs_kinds)
                (_lhs_kindvar)
                (_lhs_ksubst)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_modules)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_prekind)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_requests_gas)
                (_lhs_toplevel)
                (_lhs_verbosity) =
    let ( _field_abstracttps_collect,_field_bimapimps_collect,_field_constructors_collect,_field_deps_collect,_field_exports_collect,_field_funimps_collect,_field_genabs_collect,_field_implications_collect,_field_imports_collect,_field_initialTypes,_field_initialValues,_field_methods_collect,_field_nonrecs,_field_pconsigs_col,_field_pktcoll,_field_rawrequest_collect,_field_self) =
            (_field (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_toplevel))
        ( _expr_abstracttps_collect,_expr_bimapimps_collect,_expr_constructors_collect,_expr_deps_collect,_expr_exports_collect,_expr_funimps_collect,_expr_genabs_collect,_expr_implications_collect,_expr_imports_collect,_expr_initialTypes,_expr_initialValues,_expr_kinames,_expr_kindvar,_expr_ksubst,_expr_linkname,_expr_methods_collect,_expr_nonrecs,_expr_pconsigs_col,_expr_pktcoll,_expr_ptscoll,_expr_rawrequest_collect,_expr_self) =
            (_expr (_field_abstracttps_collect)
                   (_field_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_field_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_field_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_field_funimps_collect)
                   (_lhs_genabs)
                   (_field_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_field_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_field_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_field_pconsigs_col)
                   (_field_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_field_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_expr_abstracttps_collect
        ,_expr_bimapimps_collect
        ,_expr_constructors_collect
        ,_expr_deps_collect
        ,_field_exports_collect ++ _expr_exports_collect
        ,_expr_funimps_collect
        ,_expr_genabs_collect
        ,_expr_implications_collect
        ,_field_imports_collect ++ _expr_imports_collect
        ,_field_initialTypes ++ _expr_initialTypes
        ,_field_initialValues ++ _expr_initialValues
        ,_expr_kinames
        ,_expr_kindvar
        ,_expr_ksubst
        ,_expr_methods_collect
        ,_field_nonrecs ++ _expr_nonrecs
        ,_expr_pconsigs_col
        ,_expr_pktcoll
        ,_expr_ptscoll
        ,_expr_rawrequest_collect
        ,FBind_FBind _field_self _expr_self
        )
-- FBinds ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : FBinds

-}
{-
   local variables for FBinds.Cons:

-}
{-
   local variables for FBinds.Nil:

-}
-- semantic domain
type T_FBinds = (Set QualName) ->
                ([Request_BimapImply]) ->
                (Maybe QualName) ->
                (Consigs) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Modid) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Set QualName) ->
                (Set QualName) ->
                (Exports) ->
                ([Request_FunImply]) ->
                (Set QualName) ->
                (Set QualName) ->
                (Set QualName) ->
                (Set QualName) ->
                (Bool) ->
                ([Request_TypeImply]) ->
                (Set QualName) ->
                (Set QualName) ->
                (Bool) ->
                (Set QualName) ->
                (Set QualName) ->
                (KSubst) ->
                (KSubst) ->
                (Int) ->
                (KSubst) ->
                (Bool) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Set Modid) ->
                (PConsigs) ->
                (PConsigs) ->
                (FMap QualName PKT) ->
                (FMap QualName PKT) ->
                (KSubst) ->
                (FMap QualName PTS) ->
                (FMap QualName PTS) ->
                ([RawRequest]) ->
                ([RawRequest]) ->
                (Bool) ->
                (Int) ->
                ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(FBinds))
-- cata
sem_FBinds :: (FBinds) ->
              (T_FBinds)
sem_FBinds (list) =
    (foldr (sem_FBinds_Cons) (sem_FBinds_Nil) ((map sem_FBind list)))
sem_FBinds_Cons :: (T_FBind) ->
                   (T_FBinds) ->
                   (T_FBinds)
sem_FBinds_Cons (_hd)
                (_tl)
                (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_kinames)
                (_lhs_kinds)
                (_lhs_kindvar)
                (_lhs_ksubst)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_modules)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_prekind)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_requests_gas)
                (_lhs_toplevel)
                (_lhs_verbosity) =
    let ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_kinames,_hd_kindvar,_hd_ksubst,_hd_methods_collect,_hd_nonrecs,_hd_pconsigs_col,_hd_pktcoll,_hd_ptscoll,_hd_rawrequest_collect,_hd_self) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kinds)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_initialTypes,_tl_initialValues,_tl_kinames,_tl_kindvar,_tl_ksubst,_tl_methods_collect,_tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_ptscoll,_tl_rawrequest_collect,_tl_self) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_hd_kinames)
                 (_lhs_kinds)
                 (_hd_kindvar)
                 (_hd_ksubst)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_hd_ptscoll)
                 (_lhs_ptsdist)
                 (_hd_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
    in  (_tl_abstracttps_collect
        ,_tl_bimapimps_collect
        ,_tl_constructors_collect
        ,_tl_deps_collect
        ,_hd_exports_collect ++ _tl_exports_collect
        ,_tl_funimps_collect
        ,_tl_genabs_collect
        ,_tl_implications_collect
        ,_hd_imports_collect ++ _tl_imports_collect
        ,_hd_initialTypes ++ _tl_initialTypes
        ,_hd_initialValues ++ _tl_initialValues
        ,_tl_kinames
        ,_tl_kindvar
        ,_tl_ksubst
        ,_tl_methods_collect
        ,_hd_nonrecs ++ _tl_nonrecs
        ,_tl_pconsigs_col
        ,_tl_pktcoll
        ,_tl_ptscoll
        ,_tl_rawrequest_collect
        ,_hd_self : _tl_self
        )
sem_FBinds_Nil :: (T_FBinds)
sem_FBinds_Nil (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_kinames)
               (_lhs_kinds)
               (_lhs_kindvar)
               (_lhs_ksubst)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_modules)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_prekind)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_requests_gas)
               (_lhs_toplevel)
               (_lhs_verbosity) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_kinames,_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,[])
-- GuardedAlt --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : GuardedAlt

-}
{-
   local variables for GuardedAlt.GuardedAlt:

-}
-- semantic domain
type T_GuardedAlt = (Set QualName) ->
                    ([Request_BimapImply]) ->
                    (Maybe QualName) ->
                    (Consigs) ->
                    (FMap QualName QualNames) ->
                    (FMap QualName QualNames) ->
                    (Modid) ->
                    (FMap QualName QualNames) ->
                    (FMap QualName QualNames) ->
                    (Set QualName) ->
                    (Set QualName) ->
                    (Exports) ->
                    ([Request_FunImply]) ->
                    (Set QualName) ->
                    (Set QualName) ->
                    (Set QualName) ->
                    (Set QualName) ->
                    (Bool) ->
                    ([Request_TypeImply]) ->
                    (Set QualName) ->
                    (Set QualName) ->
                    (Bool) ->
                    (Set QualName) ->
                    (Set QualName) ->
                    (KSubst) ->
                    (KSubst) ->
                    (Int) ->
                    (KSubst) ->
                    (Bool) ->
                    (FMap QualName QualNames) ->
                    (FMap QualName QualNames) ->
                    (Set Modid) ->
                    (PConsigs) ->
                    (PConsigs) ->
                    (FMap QualName PKT) ->
                    (FMap QualName PKT) ->
                    (KSubst) ->
                    (FMap QualName PTS) ->
                    (FMap QualName PTS) ->
                    ([RawRequest]) ->
                    ([RawRequest]) ->
                    (Bool) ->
                    (Int) ->
                    ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(GuardedAlt))
-- cata
sem_GuardedAlt :: (GuardedAlt) ->
                  (T_GuardedAlt)
sem_GuardedAlt ((GuardedAlt_GuardedAlt (_guard) (_expr))) =
    (sem_GuardedAlt_GuardedAlt ((sem_Expr (_guard))) ((sem_Expr (_expr))))
sem_GuardedAlt_GuardedAlt :: (T_Expr) ->
                             (T_Expr) ->
                             (T_GuardedAlt)
sem_GuardedAlt_GuardedAlt (_guard)
                          (_expr)
                          (_lhs_abstracttps_collect)
                          (_lhs_bimapimps_collect)
                          (_lhs_classname)
                          (_lhs_consigs)
                          (_lhs_constructors_collect)
                          (_lhs_constructors_dist)
                          (_lhs_currentModule)
                          (_lhs_deps)
                          (_lhs_deps_collect)
                          (_lhs_exportedTypes)
                          (_lhs_exportedValues)
                          (_lhs_exports)
                          (_lhs_funimps_collect)
                          (_lhs_genabs)
                          (_lhs_genabs_collect)
                          (_lhs_hiddenTypes)
                          (_lhs_hiddenValues)
                          (_lhs_hiding)
                          (_lhs_implications_collect)
                          (_lhs_impliedTypes)
                          (_lhs_impliedValues)
                          (_lhs_importedModule)
                          (_lhs_importedTypes)
                          (_lhs_importedValues)
                          (_lhs_kinames)
                          (_lhs_kinds)
                          (_lhs_kindvar)
                          (_lhs_ksubst)
                          (_lhs_local)
                          (_lhs_methods_collect)
                          (_lhs_methods_dist)
                          (_lhs_modules)
                          (_lhs_pconsigs)
                          (_lhs_pconsigs_col)
                          (_lhs_pktcoll)
                          (_lhs_pktdist)
                          (_lhs_prekind)
                          (_lhs_ptscoll)
                          (_lhs_ptsdist)
                          (_lhs_rawrequest_collect)
                          (_lhs_requests_gas)
                          (_lhs_toplevel)
                          (_lhs_verbosity) =
    let ( _guard_abstracttps_collect
         ,_guard_bimapimps_collect
         ,_guard_constructors_collect
         ,_guard_deps_collect
         ,_guard_exports_collect
         ,_guard_funimps_collect
         ,_guard_genabs_collect
         ,_guard_implications_collect
         ,_guard_imports_collect
         ,_guard_initialTypes
         ,_guard_initialValues
         ,_guard_kinames
         ,_guard_kindvar
         ,_guard_ksubst
         ,_guard_linkname
         ,_guard_methods_collect
         ,_guard_nonrecs
         ,_guard_pconsigs_col
         ,_guard_pktcoll
         ,_guard_ptscoll
         ,_guard_rawrequest_collect
         ,_guard_self
         ) =
            (_guard (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_kinames)
                    (_lhs_kinds)
                    (_lhs_kindvar)
                    (_lhs_ksubst)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_lhs_ptscoll)
                    (_lhs_ptsdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_toplevel)
                    (_lhs_verbosity))
        ( _expr_abstracttps_collect,_expr_bimapimps_collect,_expr_constructors_collect,_expr_deps_collect,_expr_exports_collect,_expr_funimps_collect,_expr_genabs_collect,_expr_implications_collect,_expr_imports_collect,_expr_initialTypes,_expr_initialValues,_expr_kinames,_expr_kindvar,_expr_ksubst,_expr_linkname,_expr_methods_collect,_expr_nonrecs,_expr_pconsigs_col,_expr_pktcoll,_expr_ptscoll,_expr_rawrequest_collect,_expr_self) =
            (_expr (_guard_abstracttps_collect)
                   (_guard_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_guard_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_guard_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_guard_funimps_collect)
                   (_lhs_genabs)
                   (_guard_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_guard_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_guard_kinames)
                   (_lhs_kinds)
                   (_guard_kindvar)
                   (_guard_ksubst)
                   (_lhs_local)
                   (_guard_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_guard_pconsigs_col)
                   (_guard_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_guard_ptscoll)
                   (_lhs_ptsdist)
                   (_guard_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_expr_abstracttps_collect
        ,_expr_bimapimps_collect
        ,_expr_constructors_collect
        ,_expr_deps_collect
        ,_guard_exports_collect ++ _expr_exports_collect
        ,_expr_funimps_collect
        ,_expr_genabs_collect
        ,_expr_implications_collect
        ,_guard_imports_collect ++ _expr_imports_collect
        ,_guard_initialTypes ++ _expr_initialTypes
        ,_guard_initialValues ++ _expr_initialValues
        ,_expr_kinames
        ,_expr_kindvar
        ,_expr_ksubst
        ,_expr_methods_collect
        ,_guard_nonrecs ++ _expr_nonrecs
        ,_expr_pconsigs_col
        ,_expr_pktcoll
        ,_expr_ptscoll
        ,_expr_rawrequest_collect
        ,GuardedAlt_GuardedAlt _guard_self _expr_self
        )
-- GuardedAlts -------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : GuardedAlts

-}
{-
   local variables for GuardedAlts.Cons:

-}
{-
   local variables for GuardedAlts.Nil:

-}
-- semantic domain
type T_GuardedAlts = (Set QualName) ->
                     ([Request_BimapImply]) ->
                     (Maybe QualName) ->
                     (Consigs) ->
                     (FMap QualName QualNames) ->
                     (FMap QualName QualNames) ->
                     (Modid) ->
                     (FMap QualName QualNames) ->
                     (FMap QualName QualNames) ->
                     (Set QualName) ->
                     (Set QualName) ->
                     (Exports) ->
                     ([Request_FunImply]) ->
                     (Set QualName) ->
                     (Set QualName) ->
                     (Set QualName) ->
                     (Set QualName) ->
                     (Bool) ->
                     ([Request_TypeImply]) ->
                     (Set QualName) ->
                     (Set QualName) ->
                     (Bool) ->
                     (Set QualName) ->
                     (Set QualName) ->
                     (KSubst) ->
                     (KSubst) ->
                     (Int) ->
                     (KSubst) ->
                     (Bool) ->
                     (FMap QualName QualNames) ->
                     (FMap QualName QualNames) ->
                     (Set Modid) ->
                     (PConsigs) ->
                     (PConsigs) ->
                     (FMap QualName PKT) ->
                     (FMap QualName PKT) ->
                     (KSubst) ->
                     (FMap QualName PTS) ->
                     (FMap QualName PTS) ->
                     ([RawRequest]) ->
                     ([RawRequest]) ->
                     (Bool) ->
                     (Int) ->
                     ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(GuardedAlts))
-- cata
sem_GuardedAlts :: (GuardedAlts) ->
                   (T_GuardedAlts)
sem_GuardedAlts (list) =
    (foldr (sem_GuardedAlts_Cons) (sem_GuardedAlts_Nil) ((map sem_GuardedAlt list)))
sem_GuardedAlts_Cons :: (T_GuardedAlt) ->
                        (T_GuardedAlts) ->
                        (T_GuardedAlts)
sem_GuardedAlts_Cons (_hd)
                     (_tl)
                     (_lhs_abstracttps_collect)
                     (_lhs_bimapimps_collect)
                     (_lhs_classname)
                     (_lhs_consigs)
                     (_lhs_constructors_collect)
                     (_lhs_constructors_dist)
                     (_lhs_currentModule)
                     (_lhs_deps)
                     (_lhs_deps_collect)
                     (_lhs_exportedTypes)
                     (_lhs_exportedValues)
                     (_lhs_exports)
                     (_lhs_funimps_collect)
                     (_lhs_genabs)
                     (_lhs_genabs_collect)
                     (_lhs_hiddenTypes)
                     (_lhs_hiddenValues)
                     (_lhs_hiding)
                     (_lhs_implications_collect)
                     (_lhs_impliedTypes)
                     (_lhs_impliedValues)
                     (_lhs_importedModule)
                     (_lhs_importedTypes)
                     (_lhs_importedValues)
                     (_lhs_kinames)
                     (_lhs_kinds)
                     (_lhs_kindvar)
                     (_lhs_ksubst)
                     (_lhs_local)
                     (_lhs_methods_collect)
                     (_lhs_methods_dist)
                     (_lhs_modules)
                     (_lhs_pconsigs)
                     (_lhs_pconsigs_col)
                     (_lhs_pktcoll)
                     (_lhs_pktdist)
                     (_lhs_prekind)
                     (_lhs_ptscoll)
                     (_lhs_ptsdist)
                     (_lhs_rawrequest_collect)
                     (_lhs_requests_gas)
                     (_lhs_toplevel)
                     (_lhs_verbosity) =
    let ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_kinames,_hd_kindvar,_hd_ksubst,_hd_methods_collect,_hd_nonrecs,_hd_pconsigs_col,_hd_pktcoll,_hd_ptscoll,_hd_rawrequest_collect,_hd_self) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kinds)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_initialTypes,_tl_initialValues,_tl_kinames,_tl_kindvar,_tl_ksubst,_tl_methods_collect,_tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_ptscoll,_tl_rawrequest_collect,_tl_self) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_hd_kinames)
                 (_lhs_kinds)
                 (_hd_kindvar)
                 (_hd_ksubst)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_hd_ptscoll)
                 (_lhs_ptsdist)
                 (_hd_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
    in  (_tl_abstracttps_collect
        ,_tl_bimapimps_collect
        ,_tl_constructors_collect
        ,_tl_deps_collect
        ,_hd_exports_collect ++ _tl_exports_collect
        ,_tl_funimps_collect
        ,_tl_genabs_collect
        ,_tl_implications_collect
        ,_hd_imports_collect ++ _tl_imports_collect
        ,_hd_initialTypes ++ _tl_initialTypes
        ,_hd_initialValues ++ _tl_initialValues
        ,_tl_kinames
        ,_tl_kindvar
        ,_tl_ksubst
        ,_tl_methods_collect
        ,_hd_nonrecs ++ _tl_nonrecs
        ,_tl_pconsigs_col
        ,_tl_pktcoll
        ,_tl_ptscoll
        ,_tl_rawrequest_collect
        ,_hd_self : _tl_self
        )
sem_GuardedAlts_Nil :: (T_GuardedAlts)
sem_GuardedAlts_Nil (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_kinames)
                    (_lhs_kinds)
                    (_lhs_kindvar)
                    (_lhs_ksubst)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_lhs_ptscoll)
                    (_lhs_ptsdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_toplevel)
                    (_lhs_verbosity) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_kinames,_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,[])
-- GuardedRhs --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      linkname             : Maybe QualName
      nonrecs              : [TypedBinding]
      self                 : GuardedRhs

-}
{-
   local variables for GuardedRhs.GuardedRhs:

-}
-- semantic domain
type T_GuardedRhs = (Set QualName) ->
                    ([Request_BimapImply]) ->
                    (Maybe QualName) ->
                    (Consigs) ->
                    (FMap QualName QualNames) ->
                    (FMap QualName QualNames) ->
                    (Modid) ->
                    (FMap QualName QualNames) ->
                    (FMap QualName QualNames) ->
                    (Set QualName) ->
                    (Set QualName) ->
                    (Exports) ->
                    ([Request_FunImply]) ->
                    (Set QualName) ->
                    (Set QualName) ->
                    (Set QualName) ->
                    (Set QualName) ->
                    (Bool) ->
                    ([Request_TypeImply]) ->
                    (Set QualName) ->
                    (Set QualName) ->
                    (Bool) ->
                    (Set QualName) ->
                    (Set QualName) ->
                    (KSubst) ->
                    (KSubst) ->
                    (Int) ->
                    (KSubst) ->
                    (Bool) ->
                    (FMap QualName QualNames) ->
                    (FMap QualName QualNames) ->
                    (Set Modid) ->
                    (PConsigs) ->
                    (PConsigs) ->
                    (FMap QualName PKT) ->
                    (FMap QualName PKT) ->
                    (KSubst) ->
                    (FMap QualName PTS) ->
                    (FMap QualName PTS) ->
                    ([RawRequest]) ->
                    ([RawRequest]) ->
                    (Bool) ->
                    (Int) ->
                    ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(Maybe QualName),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(GuardedRhs))
-- cata
sem_GuardedRhs :: (GuardedRhs) ->
                  (T_GuardedRhs)
sem_GuardedRhs ((GuardedRhs_GuardedRhs (_guard) (_expr))) =
    (sem_GuardedRhs_GuardedRhs ((sem_Expr (_guard))) ((sem_Expr (_expr))))
sem_GuardedRhs_GuardedRhs :: (T_Expr) ->
                             (T_Expr) ->
                             (T_GuardedRhs)
sem_GuardedRhs_GuardedRhs (_guard)
                          (_expr)
                          (_lhs_abstracttps_collect)
                          (_lhs_bimapimps_collect)
                          (_lhs_classname)
                          (_lhs_consigs)
                          (_lhs_constructors_collect)
                          (_lhs_constructors_dist)
                          (_lhs_currentModule)
                          (_lhs_deps)
                          (_lhs_deps_collect)
                          (_lhs_exportedTypes)
                          (_lhs_exportedValues)
                          (_lhs_exports)
                          (_lhs_funimps_collect)
                          (_lhs_genabs)
                          (_lhs_genabs_collect)
                          (_lhs_hiddenTypes)
                          (_lhs_hiddenValues)
                          (_lhs_hiding)
                          (_lhs_implications_collect)
                          (_lhs_impliedTypes)
                          (_lhs_impliedValues)
                          (_lhs_importedModule)
                          (_lhs_importedTypes)
                          (_lhs_importedValues)
                          (_lhs_kinames)
                          (_lhs_kinds)
                          (_lhs_kindvar)
                          (_lhs_ksubst)
                          (_lhs_local)
                          (_lhs_methods_collect)
                          (_lhs_methods_dist)
                          (_lhs_modules)
                          (_lhs_pconsigs)
                          (_lhs_pconsigs_col)
                          (_lhs_pktcoll)
                          (_lhs_pktdist)
                          (_lhs_prekind)
                          (_lhs_ptscoll)
                          (_lhs_ptsdist)
                          (_lhs_rawrequest_collect)
                          (_lhs_requests_gas)
                          (_lhs_toplevel)
                          (_lhs_verbosity) =
    let ( _guard_abstracttps_collect
         ,_guard_bimapimps_collect
         ,_guard_constructors_collect
         ,_guard_deps_collect
         ,_guard_exports_collect
         ,_guard_funimps_collect
         ,_guard_genabs_collect
         ,_guard_implications_collect
         ,_guard_imports_collect
         ,_guard_initialTypes
         ,_guard_initialValues
         ,_guard_kinames
         ,_guard_kindvar
         ,_guard_ksubst
         ,_guard_linkname
         ,_guard_methods_collect
         ,_guard_nonrecs
         ,_guard_pconsigs_col
         ,_guard_pktcoll
         ,_guard_ptscoll
         ,_guard_rawrequest_collect
         ,_guard_self
         ) =
            (_guard (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_kinames)
                    (_lhs_kinds)
                    (_lhs_kindvar)
                    (_lhs_ksubst)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_lhs_ptscoll)
                    (_lhs_ptsdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_toplevel)
                    (_lhs_verbosity))
        ( _expr_abstracttps_collect,_expr_bimapimps_collect,_expr_constructors_collect,_expr_deps_collect,_expr_exports_collect,_expr_funimps_collect,_expr_genabs_collect,_expr_implications_collect,_expr_imports_collect,_expr_initialTypes,_expr_initialValues,_expr_kinames,_expr_kindvar,_expr_ksubst,_expr_linkname,_expr_methods_collect,_expr_nonrecs,_expr_pconsigs_col,_expr_pktcoll,_expr_ptscoll,_expr_rawrequest_collect,_expr_self) =
            (_expr (_guard_abstracttps_collect)
                   (_guard_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_guard_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_guard_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_guard_funimps_collect)
                   (_lhs_genabs)
                   (_guard_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_guard_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_guard_kinames)
                   (_lhs_kinds)
                   (_guard_kindvar)
                   (_guard_ksubst)
                   (_lhs_local)
                   (_guard_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_guard_pconsigs_col)
                   (_guard_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_guard_ptscoll)
                   (_lhs_ptsdist)
                   (_guard_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_expr_abstracttps_collect
        ,_expr_bimapimps_collect
        ,_expr_constructors_collect
        ,_expr_deps_collect
        ,_guard_exports_collect ++ _expr_exports_collect
        ,_expr_funimps_collect
        ,_expr_genabs_collect
        ,_expr_implications_collect
        ,_guard_imports_collect ++ _expr_imports_collect
        ,_guard_initialTypes ++ _expr_initialTypes
        ,_guard_initialValues ++ _expr_initialValues
        ,_expr_kinames
        ,_expr_kindvar
        ,_expr_ksubst
        ,_guard_linkname `const` _expr_linkname
        ,_expr_methods_collect
        ,_guard_nonrecs ++ _expr_nonrecs
        ,_expr_pconsigs_col
        ,_expr_pktcoll
        ,_expr_ptscoll
        ,_expr_rawrequest_collect
        ,GuardedRhs_GuardedRhs _guard_self _expr_self
        )
-- GuardedRhss -------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      linkname             : Maybe QualName
      nonrecs              : [TypedBinding]
      self                 : GuardedRhss

-}
{-
   local variables for GuardedRhss.Cons:

-}
{-
   local variables for GuardedRhss.Nil:

-}
-- semantic domain
type T_GuardedRhss = (Set QualName) ->
                     ([Request_BimapImply]) ->
                     (Maybe QualName) ->
                     (Consigs) ->
                     (FMap QualName QualNames) ->
                     (FMap QualName QualNames) ->
                     (Modid) ->
                     (FMap QualName QualNames) ->
                     (FMap QualName QualNames) ->
                     (Set QualName) ->
                     (Set QualName) ->
                     (Exports) ->
                     ([Request_FunImply]) ->
                     (Set QualName) ->
                     (Set QualName) ->
                     (Set QualName) ->
                     (Set QualName) ->
                     (Bool) ->
                     ([Request_TypeImply]) ->
                     (Set QualName) ->
                     (Set QualName) ->
                     (Bool) ->
                     (Set QualName) ->
                     (Set QualName) ->
                     (KSubst) ->
                     (KSubst) ->
                     (Int) ->
                     (KSubst) ->
                     (Bool) ->
                     (FMap QualName QualNames) ->
                     (FMap QualName QualNames) ->
                     (Set Modid) ->
                     (PConsigs) ->
                     (PConsigs) ->
                     (FMap QualName PKT) ->
                     (FMap QualName PKT) ->
                     (KSubst) ->
                     (FMap QualName PTS) ->
                     (FMap QualName PTS) ->
                     ([RawRequest]) ->
                     ([RawRequest]) ->
                     (Bool) ->
                     (Int) ->
                     ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(Maybe QualName),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(GuardedRhss))
-- cata
sem_GuardedRhss :: (GuardedRhss) ->
                   (T_GuardedRhss)
sem_GuardedRhss (list) =
    (foldr (sem_GuardedRhss_Cons) (sem_GuardedRhss_Nil) ((map sem_GuardedRhs list)))
sem_GuardedRhss_Cons :: (T_GuardedRhs) ->
                        (T_GuardedRhss) ->
                        (T_GuardedRhss)
sem_GuardedRhss_Cons (_hd)
                     (_tl)
                     (_lhs_abstracttps_collect)
                     (_lhs_bimapimps_collect)
                     (_lhs_classname)
                     (_lhs_consigs)
                     (_lhs_constructors_collect)
                     (_lhs_constructors_dist)
                     (_lhs_currentModule)
                     (_lhs_deps)
                     (_lhs_deps_collect)
                     (_lhs_exportedTypes)
                     (_lhs_exportedValues)
                     (_lhs_exports)
                     (_lhs_funimps_collect)
                     (_lhs_genabs)
                     (_lhs_genabs_collect)
                     (_lhs_hiddenTypes)
                     (_lhs_hiddenValues)
                     (_lhs_hiding)
                     (_lhs_implications_collect)
                     (_lhs_impliedTypes)
                     (_lhs_impliedValues)
                     (_lhs_importedModule)
                     (_lhs_importedTypes)
                     (_lhs_importedValues)
                     (_lhs_kinames)
                     (_lhs_kinds)
                     (_lhs_kindvar)
                     (_lhs_ksubst)
                     (_lhs_local)
                     (_lhs_methods_collect)
                     (_lhs_methods_dist)
                     (_lhs_modules)
                     (_lhs_pconsigs)
                     (_lhs_pconsigs_col)
                     (_lhs_pktcoll)
                     (_lhs_pktdist)
                     (_lhs_prekind)
                     (_lhs_ptscoll)
                     (_lhs_ptsdist)
                     (_lhs_rawrequest_collect)
                     (_lhs_requests_gas)
                     (_lhs_toplevel)
                     (_lhs_verbosity) =
    let ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_kinames,_hd_kindvar,_hd_ksubst,_hd_linkname,_hd_methods_collect,_hd_nonrecs,_hd_pconsigs_col,_hd_pktcoll,_hd_ptscoll,_hd_rawrequest_collect,_hd_self) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kinds)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_initialTypes,_tl_initialValues,_tl_kinames,_tl_kindvar,_tl_ksubst,_tl_linkname,_tl_methods_collect,_tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_ptscoll,_tl_rawrequest_collect,_tl_self) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_hd_kinames)
                 (_lhs_kinds)
                 (_hd_kindvar)
                 (_hd_ksubst)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_hd_ptscoll)
                 (_lhs_ptsdist)
                 (_hd_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
    in  (_tl_abstracttps_collect
        ,_tl_bimapimps_collect
        ,_tl_constructors_collect
        ,_tl_deps_collect
        ,_hd_exports_collect ++ _tl_exports_collect
        ,_tl_funimps_collect
        ,_tl_genabs_collect
        ,_tl_implications_collect
        ,_hd_imports_collect ++ _tl_imports_collect
        ,_hd_initialTypes ++ _tl_initialTypes
        ,_hd_initialValues ++ _tl_initialValues
        ,_tl_kinames
        ,_tl_kindvar
        ,_tl_ksubst
        ,_hd_linkname `const` _tl_linkname
        ,_tl_methods_collect
        ,_hd_nonrecs ++ _tl_nonrecs
        ,_tl_pconsigs_col
        ,_tl_pktcoll
        ,_tl_ptscoll
        ,_tl_rawrequest_collect
        ,_hd_self : _tl_self
        )
sem_GuardedRhss_Nil :: (T_GuardedRhss)
sem_GuardedRhss_Nil (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_kinames)
                    (_lhs_kinds)
                    (_lhs_kindvar)
                    (_lhs_ksubst)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_lhs_ptscoll)
                    (_lhs_ptsdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_toplevel)
                    (_lhs_verbosity) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_kinames,_lhs_kindvar,_lhs_ksubst,Nothing,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,[])
-- Impdecl -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]
      strtypes             : FMap QualName StrTypeDecl

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      kind_errors          : [GHError]
      nonrecs              : [TypedBinding]
      output               : PP_Doc
      outputi              : [PP_Doc]
      self                 : Impdecl
      titypes              : [(QualName,TDecl)]

-}
{-
   local variables for Impdecl.Empty:
      self

-}
{-
   local variables for Impdecl.Import:
      imports_result
      hiding
      is_exported
      realmodulename
      local
      currentModule
      self

-}
-- semantic domain
type T_Impdecl = (Set QualName) ->
                 ([Request_BimapImply]) ->
                 (Maybe QualName) ->
                 (Consigs) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Modid) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Exports) ->
                 ([Request_FunImply]) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Bool) ->
                 ([Request_TypeImply]) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Bool) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (KSubst) ->
                 (KSubst) ->
                 (Int) ->
                 (KSubst) ->
                 (Bool) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Set Modid) ->
                 (PConsigs) ->
                 (PConsigs) ->
                 (FMap QualName PKT) ->
                 (FMap QualName PKT) ->
                 (KSubst) ->
                 (FMap QualName PTS) ->
                 (FMap QualName PTS) ->
                 ([RawRequest]) ->
                 ([RawRequest]) ->
                 (FMap QualName StrTypeDecl) ->
                 (Bool) ->
                 (Int) ->
                 ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),([GHError]),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PP_Doc),([PP_Doc]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Impdecl),(FMap QualName StrTypeDecl),([(QualName,TDecl)]))
-- cata
sem_Impdecl :: (Impdecl) ->
               (T_Impdecl)
sem_Impdecl ((Impdecl_Empty )) =
    (sem_Impdecl_Empty )
sem_Impdecl ((Impdecl_Import (_srcloc) (_qual) (_modid) (_as) (_imported))) =
    (sem_Impdecl_Import ((sem_Position (_srcloc))) (_qual) (_modid) (_as) ((sem_Imported (_imported))))
sem_Impdecl_Empty :: (T_Impdecl)
sem_Impdecl_Empty (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_kinames)
                  (_lhs_kinds)
                  (_lhs_kindvar)
                  (_lhs_ksubst)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_modules)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_prekind)
                  (_lhs_ptscoll)
                  (_lhs_ptsdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_requests_gas)
                  (_lhs_strtypes)
                  (_lhs_toplevel)
                  (_lhs_verbosity) =
    let (_self) =
            Impdecl_Empty
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_kinames,[],_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,[],empty,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,_self,_lhs_strtypes,[])
sem_Impdecl_Import :: (T_Position) ->
                      (Bool) ->
                      (Modid) ->
                      (Maybe Modid) ->
                      (T_Imported) ->
                      (T_Impdecl)
sem_Impdecl_Import (_srcloc)
                   (_qual)
                   (_modid)
                   (_as)
                   (_imported)
                   (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_strtypes)
                   (_lhs_toplevel)
                   (_lhs_verbosity) =
    let (_self) =
            Impdecl_Import _srcloc_self _qual _modid _as _imported_self
        (_currentModule) =
            _modid
        (_local) =
            False
        (_realmodulename) =
            maybe _modid id _as
        (_is_exported) =
            isExportedModule _lhs_exports _realmodulename
        (_hiding) =
            case _imported_self of
              Imported_Hiding _  -> True
              _                  -> False
        (_imports_result) =
            case _imported_self of
              Imported_NoImports ->
                                    Imported_NoImports
              Imported_Hiding _  -> Imported_Hiding  _imported_imports_collect
              _                  -> Imported_Imports _imported_imports_collect
        ( _srcloc_self) =
            (_srcloc )
        ( _imported_abstracttps_collect,_imported_bimapimps_collect,_imported_constructors_collect,_imported_deps_collect,_imported_exports_collect,_imported_funimps_collect,_imported_genabs_collect,_imported_implications_collect,_imported_imports_collect,_imported_initialTypes,_imported_initialValues,_imported_methods_collect,_imported_nonrecs,_imported_pconsigs_col,_imported_pktcoll,_imported_rawrequest_collect,_imported_self) =
            (_imported (_lhs_abstracttps_collect)
                       (_lhs_bimapimps_collect)
                       (_lhs_classname)
                       (_lhs_consigs)
                       (_lhs_constructors_collect)
                       (_lhs_constructors_dist)
                       (_currentModule)
                       (_lhs_deps)
                       (_lhs_deps_collect)
                       (_lhs_exportedTypes)
                       (_lhs_exportedValues)
                       (_lhs_exports)
                       (_lhs_funimps_collect)
                       (_lhs_genabs)
                       (_lhs_genabs_collect)
                       (_lhs_hiddenTypes)
                       (_lhs_hiddenValues)
                       (_hiding)
                       (_lhs_implications_collect)
                       (_lhs_impliedTypes)
                       (_lhs_impliedValues)
                       (_lhs_importedModule)
                       (_lhs_importedTypes)
                       (_lhs_importedValues)
                       (_local)
                       (_lhs_methods_collect)
                       (_lhs_methods_dist)
                       (_lhs_pconsigs)
                       (_lhs_pconsigs_col)
                       (_lhs_pktcoll)
                       (_lhs_pktdist)
                       (_lhs_rawrequest_collect)
                       (_lhs_toplevel))
    in  (_imported_abstracttps_collect
        ,_imported_bimapimps_collect
        ,_imported_constructors_collect
        ,_imported_deps_collect
        ,_imported_exports_collect
        ,_imported_funimps_collect
        ,_imported_genabs_collect
        ,_imported_implications_collect
        ,_imported_imports_collect
        ,_imported_initialTypes
        ,_imported_initialValues
        ,_lhs_kinames
        ,[]
        ,_lhs_kindvar
        ,_lhs_ksubst
        ,_imported_methods_collect
        ,_imported_nonrecs
        ,PP.ppImpdecl False (Impdecl_Import _srcloc_self _qual
                                            _modid _as _imports_result)
        ,[PPI.ppiImport _modid]
        ,_imported_pconsigs_col
        ,_imported_pktcoll
        ,_lhs_ptscoll
        ,_imported_rawrequest_collect
        ,_self
        ,_lhs_strtypes
        ,[]
        )
-- Impdecls ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenEntities       : [(Set QualName,Set QualName)]
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedEntities     : [(Set QualName,Set QualName)]
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      output               : [PP_Doc]
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]
      strtypes             : FMap QualName StrTypeDecl

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      kind_errors          : [GHError]
      nonrecs              : [TypedBinding]
      outputi              : [PP_Doc]
      self                 : Impdecls
      titypes              : [(QualName,TDecl)]

-}
{-
   local variables for Impdecls.Cons:
      hiddenforhead
      importedforhead

-}
{-
   local variables for Impdecls.Nil:

-}
-- semantic domain
type T_Impdecls = (Set QualName) ->
                  ([Request_BimapImply]) ->
                  (Maybe QualName) ->
                  (Consigs) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Modid) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Exports) ->
                  ([Request_FunImply]) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  ([(Set QualName,Set QualName)]) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Bool) ->
                  ([Request_TypeImply]) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  ([(Set QualName,Set QualName)]) ->
                  (Bool) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (KSubst) ->
                  (KSubst) ->
                  (Int) ->
                  (KSubst) ->
                  (Bool) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Set Modid) ->
                  ([PP_Doc]) ->
                  (PConsigs) ->
                  (PConsigs) ->
                  (FMap QualName PKT) ->
                  (FMap QualName PKT) ->
                  (KSubst) ->
                  (FMap QualName PTS) ->
                  (FMap QualName PTS) ->
                  ([RawRequest]) ->
                  ([RawRequest]) ->
                  (FMap QualName StrTypeDecl) ->
                  (Bool) ->
                  (Int) ->
                  ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),([GHError]),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),([PP_Doc]),([PP_Doc]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Impdecls),(FMap QualName StrTypeDecl),([(QualName,TDecl)]))
-- cata
sem_Impdecls :: (Impdecls) ->
                (T_Impdecls)
sem_Impdecls (list) =
    (foldr (sem_Impdecls_Cons) (sem_Impdecls_Nil) ((map sem_Impdecl list)))
sem_Impdecls_Cons :: (T_Impdecl) ->
                     (T_Impdecls) ->
                     (T_Impdecls)
sem_Impdecls_Cons (_hd)
                  (_tl)
                  (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenEntities)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedEntities)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_kinames)
                  (_lhs_kinds)
                  (_lhs_kindvar)
                  (_lhs_ksubst)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_modules)
                  (_lhs_output)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_prekind)
                  (_lhs_ptscoll)
                  (_lhs_ptsdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_requests_gas)
                  (_lhs_strtypes)
                  (_lhs_toplevel)
                  (_lhs_verbosity) =
    let (_importedforhead) =
            head _lhs_importedEntities
        (_hiddenforhead) =
            head _lhs_hiddenEntities
        ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_kinames,_hd_kind_errors,_hd_kindvar,_hd_ksubst,_hd_methods_collect,_hd_nonrecs,_hd_output,_hd_outputi,_hd_pconsigs_col,_hd_pktcoll,_hd_ptscoll,_hd_rawrequest_collect,_hd_self,_hd_strtypes,_hd_titypes) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (snd _hiddenforhead)
                 (fst _hiddenforhead)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (snd _importedforhead)
                 (fst _importedforhead)
                 (_lhs_kinames)
                 (_lhs_kinds)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_strtypes)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_initialTypes,_tl_initialValues,_tl_kinames,_tl_kind_errors,_tl_kindvar,_tl_ksubst,_tl_methods_collect,_tl_nonrecs,_tl_output,_tl_outputi,_tl_pconsigs_col,_tl_pktcoll,_tl_ptscoll,_tl_rawrequest_collect,_tl_self,_tl_strtypes,_tl_titypes) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (tail _lhs_hiddenEntities)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (tail _lhs_importedEntities)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_hd_kinames)
                 (_lhs_kinds)
                 (_hd_kindvar)
                 (_hd_ksubst)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_hd_output : _lhs_output)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_hd_ptscoll)
                 (_lhs_ptsdist)
                 (_hd_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_hd_strtypes)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
    in  (_tl_abstracttps_collect
        ,_tl_bimapimps_collect
        ,_tl_constructors_collect
        ,_tl_deps_collect
        ,_hd_exports_collect ++ _tl_exports_collect
        ,_tl_funimps_collect
        ,_tl_genabs_collect
        ,_tl_implications_collect
        ,_hd_imports_collect ++ _tl_imports_collect
        ,_hd_initialTypes ++ _tl_initialTypes
        ,_hd_initialValues ++ _tl_initialValues
        ,_tl_kinames
        ,_hd_kind_errors ++ _tl_kind_errors
        ,_tl_kindvar
        ,_tl_ksubst
        ,_tl_methods_collect
        ,_hd_nonrecs ++ _tl_nonrecs
        ,_tl_output
        ,_hd_outputi ++ _tl_outputi
        ,_tl_pconsigs_col
        ,_tl_pktcoll
        ,_tl_ptscoll
        ,_tl_rawrequest_collect
        ,_hd_self : _tl_self
        ,_tl_strtypes
        ,_hd_titypes ++ _tl_titypes
        )
sem_Impdecls_Nil :: (T_Impdecls)
sem_Impdecls_Nil (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenEntities)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedEntities)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kinds)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_output)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_strtypes)
                 (_lhs_toplevel)
                 (_lhs_verbosity) =
    let 
    in  (_lhs_abstracttps_collect
        ,_lhs_bimapimps_collect
        ,_lhs_constructors_collect
        ,_lhs_deps_collect
        ,[]
        ,_lhs_funimps_collect
        ,_lhs_genabs_collect
        ,_lhs_implications_collect
        ,[]
        ,[]
        ,[]
        ,_lhs_kinames
        ,[]
        ,_lhs_kindvar
        ,_lhs_ksubst
        ,_lhs_methods_collect
        ,[]
        ,(  map ( PP.ppImpdecl False
                . \x -> Impdecl_Import genloc True x (Just $ moduleName x)
                                       Imported_NoImports
                ) $ setToList _lhs_modules
         ) ++ _lhs_output
        ,[]
        ,_lhs_pconsigs_col
        ,_lhs_pktcoll
        ,_lhs_ptscoll
        ,_lhs_rawrequest_collect
        ,[]
        ,_lhs_strtypes
        ,[]
        )
-- Import ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Import

-}
{-
   local variables for Import.Abstract:
      consigForVar

-}
{-
   local variables for Import.TypeAll:
      constrForVar
      consigForVar

-}
{-
   local variables for Import.TypeSome:
      consigForVar

-}
{-
   local variables for Import.Var:
      consigForVar

-}
-- semantic domain
type T_Import = (Set QualName) ->
                ([Request_BimapImply]) ->
                (Maybe QualName) ->
                (Consigs) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Modid) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Set QualName) ->
                (Set QualName) ->
                (Exports) ->
                ([Request_FunImply]) ->
                (Set QualName) ->
                (Set QualName) ->
                (Set QualName) ->
                (Set QualName) ->
                (Bool) ->
                ([Request_TypeImply]) ->
                (Set QualName) ->
                (Set QualName) ->
                (Bool) ->
                (Set QualName) ->
                (Set QualName) ->
                (Bool) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (PConsigs) ->
                (PConsigs) ->
                (FMap QualName PKT) ->
                (FMap QualName PKT) ->
                ([RawRequest]) ->
                (Bool) ->
                ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),([RawRequest]),(Import))
-- cata
sem_Import :: (Import) ->
              (T_Import)
sem_Import ((Import_Abstract (_name))) =
    (sem_Import_Abstract ((sem_QualName (_name))))
sem_Import ((Import_TypeAll (_name))) =
    (sem_Import_TypeAll ((sem_QualName (_name))))
sem_Import ((Import_TypeSome (_name) (_conss))) =
    (sem_Import_TypeSome ((sem_QualName (_name))) ((sem_QualNames (_conss))))
sem_Import ((Import_Var (_name))) =
    (sem_Import_Var ((sem_QualName (_name))))
sem_Import_Abstract :: (T_QualName) ->
                       (T_Import)
sem_Import_Abstract (_name)
                    (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_toplevel) =
    let (_consigForVar) =
            map stype_ctor $ findL _lhs_consigs _name_self
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_name_abstracttps_collect
        ,_name_bimapimps_collect
        ,_name_constructors_collect
        ,_name_deps_collect
        ,_name_exports_collect
        ,_name_funimps_collect
        ,_name_genabs_collect
        ,_name_implications_collect
        ,if      _name_self `elem` domain _lhs_pktdist
         then    []
         else if not (null _consigForVar)
         then    map (Import_TypeAll . componentTITName _name_self) _consigForVar
         else if _name_self `elem` domain _lhs_methods_dist
         then    [Import_Abstract _name_self]
         else if not (_name_self `elem` domain _lhs_constructors_dist)
         then    [Import_Abstract _name_self]
         else    [Import_Abstract _name_self]
        ,_name_initialTypes
        ,_name_initialValues
        ,_name_methods_collect
        ,_name_nonrecs
        ,_name_pconsigs_col
        ,_name_pktcoll
        ,_name_rawrequest_collect
        ,Import_Abstract _name_self
        )
sem_Import_TypeAll :: (T_QualName) ->
                      (T_Import)
sem_Import_TypeAll (_name)
                   (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel) =
    let (_consigForVar) =
            map stype_ctor $ findL _lhs_consigs _name_self
        (_constrForVar) =
            findL _lhs_constructors_dist _name_self
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_name_abstracttps_collect
        ,_name_bimapimps_collect
        ,_name_constructors_collect
        ,_name_deps_collect
        ,_name_exports_collect
        ,_name_funimps_collect
        ,_name_genabs_collect
        ,_name_implications_collect
        ,if      _name_self `elem` domain _lhs_pktdist
         then    []
         else if not (null _consigForVar)
         then    map (Import_TypeAll . componentTITName _name_self) _consigForVar
         else if _name_self `elem` domain _lhs_methods_dist
         then    [Import_TypeAll _name_self]
         else if (null _constrForVar)
         then    [Import_TypeAll _name_self]
         else    [Import_TypeAll _name_self]
        ,_name_initialTypes
        ,_name_initialValues
        ,_name_methods_collect
        ,_name_nonrecs
        ,_name_pconsigs_col
        ,_name_pktcoll
        ,_name_rawrequest_collect
        ,Import_TypeAll  _name_self
        )
sem_Import_TypeSome :: (T_QualName) ->
                       (T_QualNames) ->
                       (T_Import)
sem_Import_TypeSome (_name)
                    (_conss)
                    (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_toplevel) =
    let (_consigForVar) =
            map stype_ctor $ findL _lhs_consigs _name_self
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
        ( _conss_abstracttps_collect,_conss_bimapimps_collect,_conss_constructors_collect,_conss_deps_collect,_conss_exports_collect,_conss_funimps_collect,_conss_genabs_collect,_conss_implications_collect,_conss_imports_collect,_conss_initialTypes,_conss_initialValues,_conss_methods_collect,_conss_nonrecs,_conss_pconsigs_col,_conss_pktcoll,_conss_rawrequest_collect,_conss_self) =
            (_conss (_name_abstracttps_collect)
                    (_name_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_name_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_name_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_name_funimps_collect)
                    (_lhs_genabs)
                    (_name_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_name_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_local)
                    (_name_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_pconsigs)
                    (_name_pconsigs_col)
                    (_name_pktcoll)
                    (_lhs_pktdist)
                    (_name_rawrequest_collect)
                    (_lhs_toplevel))
    in  (_conss_abstracttps_collect
        ,_conss_bimapimps_collect
        ,_conss_constructors_collect
        ,_conss_deps_collect
        ,_name_exports_collect ++ _conss_exports_collect
        ,_conss_funimps_collect
        ,_conss_genabs_collect
        ,_conss_implications_collect
        ,if      _name_self `elem` domain _lhs_pktdist
         then    []
         else if not (null _consigForVar)
         then    map (Import_TypeAll . componentTITName _name_self) _consigForVar
         else if _name_self `elem` domain _lhs_methods_dist
         then    [Import_TypeSome _name_self _conss_self]
         else if not (_name_self `elem` domain _lhs_constructors_dist)
         then    [Import_TypeSome _name_self _conss_self]
         else    [Import_TypeSome _name_self _conss_self]
        ,_name_initialTypes ++ _conss_initialTypes
        ,_name_initialValues ++ _conss_initialValues
        ,_conss_methods_collect
        ,_name_nonrecs ++ _conss_nonrecs
        ,_conss_pconsigs_col
        ,_conss_pktcoll
        ,_conss_rawrequest_collect
        ,Import_TypeSome _name_self _conss_self
        )
sem_Import_Var :: (T_QualName) ->
                  (T_Import)
sem_Import_Var (_name)
               (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_rawrequest_collect)
               (_lhs_toplevel) =
    let (_consigForVar) =
            map stype_ctor $ findL _lhs_consigs _name_self
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_name_abstracttps_collect
        ,_name_bimapimps_collect
        ,_name_constructors_collect
        ,_name_deps_collect
        ,_name_exports_collect
        ,_name_funimps_collect
        ,_name_genabs_collect
        ,_name_implications_collect
        ,if      _name_self `Set.elementOf` _lhs_genabs
         then    []
         else if not (null _consigForVar)
         then    map (Import_Var . componentName _name_self) _consigForVar
         else    [Import_Var _name_self]
        ,_name_initialTypes
        ,_name_initialValues
        ,_name_methods_collect
        ,_name_nonrecs
        ,_name_pconsigs_col
        ,_name_pktcoll
        ,_name_rawrequest_collect
        ,Import_Var      _name_self
        )
-- ImportData --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]
      strtypes             : FMap QualName StrTypeDecl

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      kind_errors          : [GHError]
      nonrecs              : [TypedBinding]
      outputi              : [PP_Doc]
      self                 : ImportData
      titypes              : [(QualName,TDecl)]

-}
{-
   local variables for ImportData.Abstract:
      abstracttps_collect
      kinames
      is_implied
      subs_imported
      subs_exported
      is_imported_h
      is_hidden
      is_imported
      is_exported

-}
{-
   local variables for ImportData.Binding:
      is_imported_h
      is_hidden
      is_imported
      is_exported

-}
{-
   local variables for ImportData.Consig:
      pconsigs_col
      is_imported_h
      is_hidden
      is_imported
      is_exported

-}
{-
   local variables for ImportData.Decl:
      output

-}
{-
   local variables for ImportData.Import:

-}
{-
   local variables for ImportData.SetModule:
      currentModule

-}
-- semantic domain
type T_ImportData = (Set QualName) ->
                    ([Request_BimapImply]) ->
                    (Maybe QualName) ->
                    (Consigs) ->
                    (FMap QualName QualNames) ->
                    (FMap QualName QualNames) ->
                    (Modid) ->
                    (FMap QualName QualNames) ->
                    (FMap QualName QualNames) ->
                    (Set QualName) ->
                    (Set QualName) ->
                    (Exports) ->
                    ([Request_FunImply]) ->
                    (Set QualName) ->
                    (Set QualName) ->
                    (Set QualName) ->
                    (Set QualName) ->
                    (Bool) ->
                    ([Request_TypeImply]) ->
                    (Set QualName) ->
                    (Set QualName) ->
                    (Bool) ->
                    (Set QualName) ->
                    (Set QualName) ->
                    (KSubst) ->
                    (KSubst) ->
                    (Int) ->
                    (KSubst) ->
                    (Bool) ->
                    (FMap QualName QualNames) ->
                    (FMap QualName QualNames) ->
                    (Set Modid) ->
                    (PConsigs) ->
                    (PConsigs) ->
                    (FMap QualName PKT) ->
                    (FMap QualName PKT) ->
                    (KSubst) ->
                    (FMap QualName PTS) ->
                    (FMap QualName PTS) ->
                    ([RawRequest]) ->
                    ([RawRequest]) ->
                    (FMap QualName StrTypeDecl) ->
                    (Bool) ->
                    (Int) ->
                    ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),([GHError]),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),([PP_Doc]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(ImportData),(FMap QualName StrTypeDecl),([(QualName,TDecl)]))
-- cata
sem_ImportData :: (ImportData) ->
                  (T_ImportData)
sem_ImportData ((ImportData_Abstract (_name) (_conss) (_kind))) =
    (sem_ImportData_Abstract ((sem_QualName (_name))) ((sem_QualNames (_conss))) ((sem_Kind (_kind))))
sem_ImportData ((ImportData_Binding (_name))) =
    (sem_ImportData_Binding ((sem_QualName (_name))))
sem_ImportData ((ImportData_Consig (_name) (_tps))) =
    (sem_ImportData_Consig ((sem_QualName (_name))) ((sem_QualNames (_tps))))
sem_ImportData ((ImportData_Decl (_decls))) =
    (sem_ImportData_Decl ((sem_Decls (_decls))))
sem_ImportData ((ImportData_Import (_modid))) =
    (sem_ImportData_Import (_modid))
sem_ImportData ((ImportData_SetModule (_modid) (_datas))) =
    (sem_ImportData_SetModule (_modid) ((sem_ImportDatas (_datas))))
sem_ImportData_Abstract :: (T_QualName) ->
                           (T_QualNames) ->
                           (T_Kind) ->
                           (T_ImportData)
sem_ImportData_Abstract (_name)
                        (_conss)
                        (_kind)
                        (_lhs_abstracttps_collect)
                        (_lhs_bimapimps_collect)
                        (_lhs_classname)
                        (_lhs_consigs)
                        (_lhs_constructors_collect)
                        (_lhs_constructors_dist)
                        (_lhs_currentModule)
                        (_lhs_deps)
                        (_lhs_deps_collect)
                        (_lhs_exportedTypes)
                        (_lhs_exportedValues)
                        (_lhs_exports)
                        (_lhs_funimps_collect)
                        (_lhs_genabs)
                        (_lhs_genabs_collect)
                        (_lhs_hiddenTypes)
                        (_lhs_hiddenValues)
                        (_lhs_hiding)
                        (_lhs_implications_collect)
                        (_lhs_impliedTypes)
                        (_lhs_impliedValues)
                        (_lhs_importedModule)
                        (_lhs_importedTypes)
                        (_lhs_importedValues)
                        (_lhs_kinames)
                        (_lhs_kinds)
                        (_lhs_kindvar)
                        (_lhs_ksubst)
                        (_lhs_local)
                        (_lhs_methods_collect)
                        (_lhs_methods_dist)
                        (_lhs_modules)
                        (_lhs_pconsigs)
                        (_lhs_pconsigs_col)
                        (_lhs_pktcoll)
                        (_lhs_pktdist)
                        (_lhs_prekind)
                        (_lhs_ptscoll)
                        (_lhs_ptsdist)
                        (_lhs_rawrequest_collect)
                        (_lhs_requests_gas)
                        (_lhs_strtypes)
                        (_lhs_toplevel)
                        (_lhs_verbosity) =
    let (_is_exported) =
            _name_self `Set.elementOf` _lhs_exportedTypes
        (_is_imported) =
            _name_self `Set.elementOf` _lhs_importedTypes
        (_is_hidden) =
            _name_self `Set.elementOf` _lhs_hiddenTypes
        (_is_imported_h) =
            if _lhs_hiding then _is_hidden else _is_imported
        (_subs_exported) =
            map (makeExplicitName (not _lhs_local)) $
             filter (`Set.elementOf` _lhs_exportedValues) _conss_self
        (_subs_imported) =
            map makePlainName $
             filter (`Set.elementOf` _lhs_importedValues) _conss_self
        (_is_implied) =
            _name_self `Set.elementOf` _lhs_impliedTypes
        (_kinames) =
            add _lhs_kinames (_name_self,_kind_self)
        (_abstracttps_collect) =
            unitSet _name_self `Set.union` _lhs_abstracttps_collect
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
        ( _conss_abstracttps_collect,_conss_bimapimps_collect,_conss_constructors_collect,_conss_deps_collect,_conss_exports_collect,_conss_funimps_collect,_conss_genabs_collect,_conss_implications_collect,_conss_imports_collect,_conss_initialTypes,_conss_initialValues,_conss_methods_collect,_conss_nonrecs,_conss_pconsigs_col,_conss_pktcoll,_conss_rawrequest_collect,_conss_self) =
            (_conss (_name_abstracttps_collect)
                    (_name_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_name_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_name_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_name_funimps_collect)
                    (_lhs_genabs)
                    (_name_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_name_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_local)
                    (_name_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_pconsigs)
                    (_name_pconsigs_col)
                    (_name_pktcoll)
                    (_lhs_pktdist)
                    (_name_rawrequest_collect)
                    (_lhs_toplevel))
        ( _kind_abstracttps_collect,_kind_bimapimps_collect,_kind_constructors_collect,_kind_deps_collect,_kind_exports_collect,_kind_fixedKind,_kind_funimps_collect,_kind_genabs_collect,_kind_implications_collect,_kind_imports_collect,_kind_initialTypes,_kind_initialValues,_kind_methods_collect,_kind_nonrecs,_kind_pconsigs_col,_kind_pktcoll,_kind_ptscoll,_kind_rawrequest_collect,_kind_self) =
            (_kind (_conss_abstracttps_collect)
                   (_conss_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_conss_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_conss_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_conss_funimps_collect)
                   (_lhs_genabs)
                   (_conss_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_conss_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_conss_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_conss_pconsigs_col)
                   (_conss_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_conss_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_kind_abstracttps_collect
        ,_kind_bimapimps_collect
        ,_kind_constructors_collect
        ,_kind_deps_collect
        ,_name_exports_collect ++ _conss_exports_collect ++ _kind_exports_collect
        ,_kind_funimps_collect
        ,_kind_genabs_collect
        ,_kind_implications_collect
        ,_name_imports_collect ++ _conss_imports_collect ++ _kind_imports_collect
        ,_name_initialTypes ++ _conss_initialTypes ++ _kind_initialTypes
        ,_name_initialValues ++ _conss_initialValues ++ _kind_initialValues
        ,_kinames
        ,[]
        ,_lhs_kindvar
        ,_lhs_ksubst
        ,_kind_methods_collect
        ,_name_nonrecs ++ _conss_nonrecs ++ _kind_nonrecs
        ,if   _is_exported
         then [PPI.ppiAbstract _name_self _subs_exported _kind_self]
         else if   _is_implied
              then [PPI.ppiAbstract _name_self [] _kind_self]
              else []
        ,_kind_pconsigs_col
        ,_kind_pktcoll
        ,_kind_ptscoll
        ,_kind_rawrequest_collect
        ,ImportData_Abstract _name_self _conss_self _kind_self
        ,_lhs_strtypes
        ,[]
        )
sem_ImportData_Binding :: (T_QualName) ->
                          (T_ImportData)
sem_ImportData_Binding (_name)
                       (_lhs_abstracttps_collect)
                       (_lhs_bimapimps_collect)
                       (_lhs_classname)
                       (_lhs_consigs)
                       (_lhs_constructors_collect)
                       (_lhs_constructors_dist)
                       (_lhs_currentModule)
                       (_lhs_deps)
                       (_lhs_deps_collect)
                       (_lhs_exportedTypes)
                       (_lhs_exportedValues)
                       (_lhs_exports)
                       (_lhs_funimps_collect)
                       (_lhs_genabs)
                       (_lhs_genabs_collect)
                       (_lhs_hiddenTypes)
                       (_lhs_hiddenValues)
                       (_lhs_hiding)
                       (_lhs_implications_collect)
                       (_lhs_impliedTypes)
                       (_lhs_impliedValues)
                       (_lhs_importedModule)
                       (_lhs_importedTypes)
                       (_lhs_importedValues)
                       (_lhs_kinames)
                       (_lhs_kinds)
                       (_lhs_kindvar)
                       (_lhs_ksubst)
                       (_lhs_local)
                       (_lhs_methods_collect)
                       (_lhs_methods_dist)
                       (_lhs_modules)
                       (_lhs_pconsigs)
                       (_lhs_pconsigs_col)
                       (_lhs_pktcoll)
                       (_lhs_pktdist)
                       (_lhs_prekind)
                       (_lhs_ptscoll)
                       (_lhs_ptsdist)
                       (_lhs_rawrequest_collect)
                       (_lhs_requests_gas)
                       (_lhs_strtypes)
                       (_lhs_toplevel)
                       (_lhs_verbosity) =
    let (_is_exported) =
            _name_self `Set.elementOf` _lhs_exportedValues
        (_is_imported) =
            _name_self `Set.elementOf` _lhs_importedValues
        (_is_hidden) =
            _name_self `Set.elementOf` _lhs_hiddenValues
        (_is_imported_h) =
            if _lhs_hiding then _is_hidden else _is_imported
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_name_abstracttps_collect
        ,_name_bimapimps_collect
        ,_name_constructors_collect
        ,_name_deps_collect
        ,_name_exports_collect
        ,_name_funimps_collect
        ,_name_genabs_collect
        ,_name_implications_collect
        ,_name_imports_collect
        ,_name_initialTypes
        ,_name_initialValues
        ,_lhs_kinames
        ,[]
        ,_lhs_kindvar
        ,_lhs_ksubst
        ,_name_methods_collect
        ,_name_nonrecs
        ,if   _is_exported
         then [PPI.ppiBinding _name_self]
         else []
        ,_name_pconsigs_col
        ,_name_pktcoll
        ,_lhs_ptscoll
        ,_name_rawrequest_collect
        ,ImportData_Binding _name_self
        ,_lhs_strtypes
        ,[]
        )
sem_ImportData_Consig :: (T_QualName) ->
                         (T_QualNames) ->
                         (T_ImportData)
sem_ImportData_Consig (_name)
                      (_tps)
                      (_lhs_abstracttps_collect)
                      (_lhs_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_lhs_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_lhs_funimps_collect)
                      (_lhs_genabs)
                      (_lhs_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_lhs_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_lhs_kinames)
                      (_lhs_kinds)
                      (_lhs_kindvar)
                      (_lhs_ksubst)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_modules)
                      (_lhs_pconsigs)
                      (_lhs_pconsigs_col)
                      (_lhs_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_prekind)
                      (_lhs_ptscoll)
                      (_lhs_ptsdist)
                      (_lhs_rawrequest_collect)
                      (_lhs_requests_gas)
                      (_lhs_strtypes)
                      (_lhs_toplevel)
                      (_lhs_verbosity) =
    let (_is_exported) =
            _name_self `Set.elementOf` _lhs_exportedTypes
             || _name_self `Set.elementOf` _lhs_exportedValues
        (_is_imported) =
            _name_self `Set.elementOf` _lhs_importedTypes
             || _name_self `Set.elementOf` _lhs_importedValues
        (_is_hidden) =
            _name_self `Set.elementOf` _lhs_hiddenTypes
             || _name_self `Set.elementOf` _lhs_hiddenValues
        (_is_imported_h) =
            if _lhs_hiding then _is_hidden else _is_imported
        (_pconsigs_col) =
            case find _lhs_pconsigs_col _name_self of
              Nothing -> add _lhs_pconsigs_col
                             (_name_self,(map (SType_Const genloc) _tps_self,Nothing))
              Just _  -> _lhs_pconsigs_col
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
        ( _tps_abstracttps_collect,_tps_bimapimps_collect,_tps_constructors_collect,_tps_deps_collect,_tps_exports_collect,_tps_funimps_collect,_tps_genabs_collect,_tps_implications_collect,_tps_imports_collect,_tps_initialTypes,_tps_initialValues,_tps_methods_collect,_tps_nonrecs,_tps_pconsigs_col,_tps_pktcoll,_tps_rawrequest_collect,_tps_self) =
            (_tps (_name_abstracttps_collect)
                  (_name_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_name_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_name_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_name_funimps_collect)
                  (_lhs_genabs)
                  (_name_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_name_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_local)
                  (_name_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_name_pconsigs_col)
                  (_name_pktcoll)
                  (_lhs_pktdist)
                  (_name_rawrequest_collect)
                  (_lhs_toplevel))
    in  (_tps_abstracttps_collect
        ,_tps_bimapimps_collect
        ,_tps_constructors_collect
        ,_tps_deps_collect
        ,_name_exports_collect ++ _tps_exports_collect
        ,_tps_funimps_collect
        ,_tps_genabs_collect
        ,_tps_implications_collect
        ,_name_imports_collect ++ _tps_imports_collect
        ,_name_initialTypes ++ _tps_initialTypes
        ,_name_initialValues ++ _tps_initialValues
        ,_lhs_kinames
        ,[]
        ,_lhs_kindvar
        ,_lhs_ksubst
        ,_tps_methods_collect
        ,_name_nonrecs ++ _tps_nonrecs
        ,if   _is_exported
         then [PPI.ppiConsig _name_self _tps_self]
         else []
        ,_tps_pconsigs_col
        ,_tps_pktcoll
        ,_lhs_ptscoll
        ,_tps_rawrequest_collect
        ,ImportData_Consig _name_self _tps_self
        ,_lhs_strtypes
        ,[]
        )
sem_ImportData_Decl :: (T_Decls) ->
                       (T_ImportData)
sem_ImportData_Decl (_decls)
                    (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_kinames)
                    (_lhs_kinds)
                    (_lhs_kindvar)
                    (_lhs_ksubst)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_lhs_ptscoll)
                    (_lhs_ptsdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_strtypes)
                    (_lhs_toplevel)
                    (_lhs_verbosity) =
    let (_output) =
            []
        ( _decls_abstracttps_collect
         ,_decls_bimapimps_collect
         ,_decls_constructors_collect
         ,_decls_deps_collect
         ,_decls_exports_collect
         ,_decls_funimps_collect
         ,_decls_genabs_collect
         ,_decls_implications_collect
         ,_decls_imports_collect
         ,_decls_initialTypes
         ,_decls_initialValues
         ,_decls_kinames
         ,_decls_kind_errors
         ,_decls_kindvar
         ,_decls_ksubst
         ,_decls_methods_collect
         ,_decls_nonrecs
         ,_decls_output
         ,_decls_outputi
         ,_decls_pconsigs_col
         ,_decls_pktcoll
         ,_decls_ptscoll
         ,_decls_rawrequest_collect
         ,_decls_self
         ,_decls_strtypes
         ,_decls_titypes
         ) =
            (_decls (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_kinames)
                    (_lhs_kinds)
                    (_lhs_kindvar)
                    (_lhs_ksubst)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_output)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_lhs_ptscoll)
                    (_lhs_ptsdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_strtypes)
                    (_lhs_toplevel)
                    (_lhs_verbosity))
    in  (_decls_abstracttps_collect
        ,_decls_bimapimps_collect
        ,_decls_constructors_collect
        ,_decls_deps_collect
        ,_decls_exports_collect
        ,_decls_funimps_collect
        ,_decls_genabs_collect
        ,_decls_implications_collect
        ,_decls_imports_collect
        ,_decls_initialTypes
        ,_decls_initialValues
        ,_decls_kinames
        ,_decls_kind_errors
        ,_decls_kindvar
        ,_decls_ksubst
        ,_decls_methods_collect
        ,_decls_nonrecs
        ,_decls_outputi
        ,_decls_pconsigs_col
        ,_decls_pktcoll
        ,_decls_ptscoll
        ,_decls_rawrequest_collect
        ,ImportData_Decl _decls_self
        ,_decls_strtypes
        ,_decls_titypes
        )
sem_ImportData_Import :: (Modid) ->
                         (T_ImportData)
sem_ImportData_Import (_modid)
                      (_lhs_abstracttps_collect)
                      (_lhs_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_lhs_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_lhs_funimps_collect)
                      (_lhs_genabs)
                      (_lhs_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_lhs_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_lhs_kinames)
                      (_lhs_kinds)
                      (_lhs_kindvar)
                      (_lhs_ksubst)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_modules)
                      (_lhs_pconsigs)
                      (_lhs_pconsigs_col)
                      (_lhs_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_prekind)
                      (_lhs_ptscoll)
                      (_lhs_ptsdist)
                      (_lhs_rawrequest_collect)
                      (_lhs_requests_gas)
                      (_lhs_strtypes)
                      (_lhs_toplevel)
                      (_lhs_verbosity) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_kinames,[],_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,[],[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,ImportData_Import _modid,_lhs_strtypes,[])
sem_ImportData_SetModule :: (Modid) ->
                            (T_ImportDatas) ->
                            (T_ImportData)
sem_ImportData_SetModule (_modid)
                         (_datas)
                         (_lhs_abstracttps_collect)
                         (_lhs_bimapimps_collect)
                         (_lhs_classname)
                         (_lhs_consigs)
                         (_lhs_constructors_collect)
                         (_lhs_constructors_dist)
                         (_lhs_currentModule)
                         (_lhs_deps)
                         (_lhs_deps_collect)
                         (_lhs_exportedTypes)
                         (_lhs_exportedValues)
                         (_lhs_exports)
                         (_lhs_funimps_collect)
                         (_lhs_genabs)
                         (_lhs_genabs_collect)
                         (_lhs_hiddenTypes)
                         (_lhs_hiddenValues)
                         (_lhs_hiding)
                         (_lhs_implications_collect)
                         (_lhs_impliedTypes)
                         (_lhs_impliedValues)
                         (_lhs_importedModule)
                         (_lhs_importedTypes)
                         (_lhs_importedValues)
                         (_lhs_kinames)
                         (_lhs_kinds)
                         (_lhs_kindvar)
                         (_lhs_ksubst)
                         (_lhs_local)
                         (_lhs_methods_collect)
                         (_lhs_methods_dist)
                         (_lhs_modules)
                         (_lhs_pconsigs)
                         (_lhs_pconsigs_col)
                         (_lhs_pktcoll)
                         (_lhs_pktdist)
                         (_lhs_prekind)
                         (_lhs_ptscoll)
                         (_lhs_ptsdist)
                         (_lhs_rawrequest_collect)
                         (_lhs_requests_gas)
                         (_lhs_strtypes)
                         (_lhs_toplevel)
                         (_lhs_verbosity) =
    let (_currentModule) =
            _modid
        ( _datas_abstracttps_collect
         ,_datas_bimapimps_collect
         ,_datas_constructors_collect
         ,_datas_deps_collect
         ,_datas_exports_collect
         ,_datas_funimps_collect
         ,_datas_genabs_collect
         ,_datas_implications_collect
         ,_datas_imports_collect
         ,_datas_initialTypes
         ,_datas_initialValues
         ,_datas_kinames
         ,_datas_kind_errors
         ,_datas_kindvar
         ,_datas_ksubst
         ,_datas_methods_collect
         ,_datas_nonrecs
         ,_datas_outputi
         ,_datas_pconsigs_col
         ,_datas_pktcoll
         ,_datas_ptscoll
         ,_datas_rawrequest_collect
         ,_datas_self
         ,_datas_strtypes
         ,_datas_titypes
         ) =
            (_datas (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_kinames)
                    (_lhs_kinds)
                    (_lhs_kindvar)
                    (_lhs_ksubst)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_lhs_ptscoll)
                    (_lhs_ptsdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_strtypes)
                    (_lhs_toplevel)
                    (_lhs_verbosity))
    in  (_datas_abstracttps_collect
        ,_datas_bimapimps_collect
        ,_datas_constructors_collect
        ,_datas_deps_collect
        ,_datas_exports_collect
        ,_datas_funimps_collect
        ,_datas_genabs_collect
        ,_datas_implications_collect
        ,_datas_imports_collect
        ,_datas_initialTypes
        ,_datas_initialValues
        ,_datas_kinames
        ,_datas_kind_errors
        ,_datas_kindvar
        ,_datas_ksubst
        ,_datas_methods_collect
        ,_datas_nonrecs
        ,if   null _datas_outputi
         then []
         else [PPI.ppiSetModule _modid _datas_outputi]
        ,_datas_pconsigs_col
        ,_datas_pktcoll
        ,_datas_ptscoll
        ,_datas_rawrequest_collect
        ,ImportData_SetModule _modid _datas_self
        ,_datas_strtypes
        ,_datas_titypes
        )
-- ImportDatas -------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]
      strtypes             : FMap QualName StrTypeDecl

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      kind_errors          : [GHError]
      nonrecs              : [TypedBinding]
      outputi              : [PP_Doc]
      self                 : ImportDatas
      titypes              : [(QualName,TDecl)]

-}
{-
   local variables for ImportDatas.Cons:

-}
{-
   local variables for ImportDatas.Nil:

-}
-- semantic domain
type T_ImportDatas = (Set QualName) ->
                     ([Request_BimapImply]) ->
                     (Maybe QualName) ->
                     (Consigs) ->
                     (FMap QualName QualNames) ->
                     (FMap QualName QualNames) ->
                     (Modid) ->
                     (FMap QualName QualNames) ->
                     (FMap QualName QualNames) ->
                     (Set QualName) ->
                     (Set QualName) ->
                     (Exports) ->
                     ([Request_FunImply]) ->
                     (Set QualName) ->
                     (Set QualName) ->
                     (Set QualName) ->
                     (Set QualName) ->
                     (Bool) ->
                     ([Request_TypeImply]) ->
                     (Set QualName) ->
                     (Set QualName) ->
                     (Bool) ->
                     (Set QualName) ->
                     (Set QualName) ->
                     (KSubst) ->
                     (KSubst) ->
                     (Int) ->
                     (KSubst) ->
                     (Bool) ->
                     (FMap QualName QualNames) ->
                     (FMap QualName QualNames) ->
                     (Set Modid) ->
                     (PConsigs) ->
                     (PConsigs) ->
                     (FMap QualName PKT) ->
                     (FMap QualName PKT) ->
                     (KSubst) ->
                     (FMap QualName PTS) ->
                     (FMap QualName PTS) ->
                     ([RawRequest]) ->
                     ([RawRequest]) ->
                     (FMap QualName StrTypeDecl) ->
                     (Bool) ->
                     (Int) ->
                     ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),([GHError]),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),([PP_Doc]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(ImportDatas),(FMap QualName StrTypeDecl),([(QualName,TDecl)]))
-- cata
sem_ImportDatas :: (ImportDatas) ->
                   (T_ImportDatas)
sem_ImportDatas (list) =
    (foldr (sem_ImportDatas_Cons) (sem_ImportDatas_Nil) ((map sem_ImportData list)))
sem_ImportDatas_Cons :: (T_ImportData) ->
                        (T_ImportDatas) ->
                        (T_ImportDatas)
sem_ImportDatas_Cons (_hd)
                     (_tl)
                     (_lhs_abstracttps_collect)
                     (_lhs_bimapimps_collect)
                     (_lhs_classname)
                     (_lhs_consigs)
                     (_lhs_constructors_collect)
                     (_lhs_constructors_dist)
                     (_lhs_currentModule)
                     (_lhs_deps)
                     (_lhs_deps_collect)
                     (_lhs_exportedTypes)
                     (_lhs_exportedValues)
                     (_lhs_exports)
                     (_lhs_funimps_collect)
                     (_lhs_genabs)
                     (_lhs_genabs_collect)
                     (_lhs_hiddenTypes)
                     (_lhs_hiddenValues)
                     (_lhs_hiding)
                     (_lhs_implications_collect)
                     (_lhs_impliedTypes)
                     (_lhs_impliedValues)
                     (_lhs_importedModule)
                     (_lhs_importedTypes)
                     (_lhs_importedValues)
                     (_lhs_kinames)
                     (_lhs_kinds)
                     (_lhs_kindvar)
                     (_lhs_ksubst)
                     (_lhs_local)
                     (_lhs_methods_collect)
                     (_lhs_methods_dist)
                     (_lhs_modules)
                     (_lhs_pconsigs)
                     (_lhs_pconsigs_col)
                     (_lhs_pktcoll)
                     (_lhs_pktdist)
                     (_lhs_prekind)
                     (_lhs_ptscoll)
                     (_lhs_ptsdist)
                     (_lhs_rawrequest_collect)
                     (_lhs_requests_gas)
                     (_lhs_strtypes)
                     (_lhs_toplevel)
                     (_lhs_verbosity) =
    let ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_kinames,_hd_kind_errors,_hd_kindvar,_hd_ksubst,_hd_methods_collect,_hd_nonrecs,_hd_outputi,_hd_pconsigs_col,_hd_pktcoll,_hd_ptscoll,_hd_rawrequest_collect,_hd_self,_hd_strtypes,_hd_titypes) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kinds)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_strtypes)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_initialTypes,_tl_initialValues,_tl_kinames,_tl_kind_errors,_tl_kindvar,_tl_ksubst,_tl_methods_collect,_tl_nonrecs,_tl_outputi,_tl_pconsigs_col,_tl_pktcoll,_tl_ptscoll,_tl_rawrequest_collect,_tl_self,_tl_strtypes,_tl_titypes) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_hd_kinames)
                 (_lhs_kinds)
                 (_hd_kindvar)
                 (_hd_ksubst)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_hd_ptscoll)
                 (_lhs_ptsdist)
                 (_hd_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_hd_strtypes)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
    in  (_tl_abstracttps_collect
        ,_tl_bimapimps_collect
        ,_tl_constructors_collect
        ,_tl_deps_collect
        ,_hd_exports_collect ++ _tl_exports_collect
        ,_tl_funimps_collect
        ,_tl_genabs_collect
        ,_tl_implications_collect
        ,_hd_imports_collect ++ _tl_imports_collect
        ,_hd_initialTypes ++ _tl_initialTypes
        ,_hd_initialValues ++ _tl_initialValues
        ,_tl_kinames
        ,_hd_kind_errors ++ _tl_kind_errors
        ,_tl_kindvar
        ,_tl_ksubst
        ,_tl_methods_collect
        ,_hd_nonrecs ++ _tl_nonrecs
        ,_hd_outputi ++ _tl_outputi
        ,_tl_pconsigs_col
        ,_tl_pktcoll
        ,_tl_ptscoll
        ,_tl_rawrequest_collect
        ,_hd_self : _tl_self
        ,_tl_strtypes
        ,_hd_titypes ++ _tl_titypes
        )
sem_ImportDatas_Nil :: (T_ImportDatas)
sem_ImportDatas_Nil (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_kinames)
                    (_lhs_kinds)
                    (_lhs_kindvar)
                    (_lhs_ksubst)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_lhs_ptscoll)
                    (_lhs_ptsdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_strtypes)
                    (_lhs_toplevel)
                    (_lhs_verbosity) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_kinames,[],_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,[],[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,[],_lhs_strtypes,[])
-- Imported ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Imported

-}
{-
   local variables for Imported.Hiding:

-}
{-
   local variables for Imported.Imports:

-}
{-
   local variables for Imported.NoImports:

-}
-- semantic domain
type T_Imported = (Set QualName) ->
                  ([Request_BimapImply]) ->
                  (Maybe QualName) ->
                  (Consigs) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Modid) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Exports) ->
                  ([Request_FunImply]) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Bool) ->
                  ([Request_TypeImply]) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Bool) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Bool) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (PConsigs) ->
                  (PConsigs) ->
                  (FMap QualName PKT) ->
                  (FMap QualName PKT) ->
                  ([RawRequest]) ->
                  (Bool) ->
                  ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),([RawRequest]),(Imported))
-- cata
sem_Imported :: (Imported) ->
                (T_Imported)
sem_Imported ((Imported_Hiding (_imports))) =
    (sem_Imported_Hiding ((sem_Imports (_imports))))
sem_Imported ((Imported_Imports (_imports))) =
    (sem_Imported_Imports ((sem_Imports (_imports))))
sem_Imported ((Imported_NoImports )) =
    (sem_Imported_NoImports )
sem_Imported_Hiding :: (T_Imports) ->
                       (T_Imported)
sem_Imported_Hiding (_imports)
                    (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_toplevel) =
    let ( _imports_abstracttps_collect,_imports_bimapimps_collect,_imports_constructors_collect,_imports_deps_collect,_imports_exports_collect,_imports_funimps_collect,_imports_genabs_collect,_imports_implications_collect,_imports_imports_collect,_imports_initialTypes,_imports_initialValues,_imports_methods_collect,_imports_nonrecs,_imports_pconsigs_col,_imports_pktcoll,_imports_rawrequest_collect,_imports_self) =
            (_imports (_lhs_abstracttps_collect)
                      (_lhs_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_lhs_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_lhs_funimps_collect)
                      (_lhs_genabs)
                      (_lhs_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_lhs_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_pconsigs)
                      (_lhs_pconsigs_col)
                      (_lhs_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_rawrequest_collect)
                      (_lhs_toplevel))
    in  (_imports_abstracttps_collect,_imports_bimapimps_collect,_imports_constructors_collect,_imports_deps_collect,_imports_exports_collect,_imports_funimps_collect,_imports_genabs_collect,_imports_implications_collect,_imports_imports_collect,_imports_initialTypes,_imports_initialValues,_imports_methods_collect,_imports_nonrecs,_imports_pconsigs_col,_imports_pktcoll,_imports_rawrequest_collect,Imported_Hiding _imports_self)
sem_Imported_Imports :: (T_Imports) ->
                        (T_Imported)
sem_Imported_Imports (_imports)
                     (_lhs_abstracttps_collect)
                     (_lhs_bimapimps_collect)
                     (_lhs_classname)
                     (_lhs_consigs)
                     (_lhs_constructors_collect)
                     (_lhs_constructors_dist)
                     (_lhs_currentModule)
                     (_lhs_deps)
                     (_lhs_deps_collect)
                     (_lhs_exportedTypes)
                     (_lhs_exportedValues)
                     (_lhs_exports)
                     (_lhs_funimps_collect)
                     (_lhs_genabs)
                     (_lhs_genabs_collect)
                     (_lhs_hiddenTypes)
                     (_lhs_hiddenValues)
                     (_lhs_hiding)
                     (_lhs_implications_collect)
                     (_lhs_impliedTypes)
                     (_lhs_impliedValues)
                     (_lhs_importedModule)
                     (_lhs_importedTypes)
                     (_lhs_importedValues)
                     (_lhs_local)
                     (_lhs_methods_collect)
                     (_lhs_methods_dist)
                     (_lhs_pconsigs)
                     (_lhs_pconsigs_col)
                     (_lhs_pktcoll)
                     (_lhs_pktdist)
                     (_lhs_rawrequest_collect)
                     (_lhs_toplevel) =
    let ( _imports_abstracttps_collect,_imports_bimapimps_collect,_imports_constructors_collect,_imports_deps_collect,_imports_exports_collect,_imports_funimps_collect,_imports_genabs_collect,_imports_implications_collect,_imports_imports_collect,_imports_initialTypes,_imports_initialValues,_imports_methods_collect,_imports_nonrecs,_imports_pconsigs_col,_imports_pktcoll,_imports_rawrequest_collect,_imports_self) =
            (_imports (_lhs_abstracttps_collect)
                      (_lhs_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_lhs_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_lhs_funimps_collect)
                      (_lhs_genabs)
                      (_lhs_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_lhs_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_pconsigs)
                      (_lhs_pconsigs_col)
                      (_lhs_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_rawrequest_collect)
                      (_lhs_toplevel))
    in  (_imports_abstracttps_collect,_imports_bimapimps_collect,_imports_constructors_collect,_imports_deps_collect,_imports_exports_collect,_imports_funimps_collect,_imports_genabs_collect,_imports_implications_collect,_imports_imports_collect,_imports_initialTypes,_imports_initialValues,_imports_methods_collect,_imports_nonrecs,_imports_pconsigs_col,_imports_pktcoll,_imports_rawrequest_collect,Imported_Imports _imports_self)
sem_Imported_NoImports :: (T_Imported)
sem_Imported_NoImports (_lhs_abstracttps_collect)
                       (_lhs_bimapimps_collect)
                       (_lhs_classname)
                       (_lhs_consigs)
                       (_lhs_constructors_collect)
                       (_lhs_constructors_dist)
                       (_lhs_currentModule)
                       (_lhs_deps)
                       (_lhs_deps_collect)
                       (_lhs_exportedTypes)
                       (_lhs_exportedValues)
                       (_lhs_exports)
                       (_lhs_funimps_collect)
                       (_lhs_genabs)
                       (_lhs_genabs_collect)
                       (_lhs_hiddenTypes)
                       (_lhs_hiddenValues)
                       (_lhs_hiding)
                       (_lhs_implications_collect)
                       (_lhs_impliedTypes)
                       (_lhs_impliedValues)
                       (_lhs_importedModule)
                       (_lhs_importedTypes)
                       (_lhs_importedValues)
                       (_lhs_local)
                       (_lhs_methods_collect)
                       (_lhs_methods_dist)
                       (_lhs_pconsigs)
                       (_lhs_pconsigs_col)
                       (_lhs_pktcoll)
                       (_lhs_pktdist)
                       (_lhs_rawrequest_collect)
                       (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_rawrequest_collect,Imported_NoImports)
-- ImportedModule ----------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]
      strtypes             : FMap QualName StrTypeDecl

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      kind_errors          : [GHError]
      nonrecs              : [TypedBinding]
      self                 : ImportedModule
      titypes              : [(QualName,TDecl)]

-}
{-
   local variables for ImportedModule.Empty:

-}
{-
   local variables for ImportedModule.Module:
      local
      toplevel
      importedModule
      currentModule

-}
-- semantic domain
type T_ImportedModule = (Set QualName) ->
                        ([Request_BimapImply]) ->
                        (Maybe QualName) ->
                        (Consigs) ->
                        (FMap QualName QualNames) ->
                        (FMap QualName QualNames) ->
                        (FMap QualName QualNames) ->
                        (FMap QualName QualNames) ->
                        (Set QualName) ->
                        (Set QualName) ->
                        (Exports) ->
                        ([Request_FunImply]) ->
                        (Set QualName) ->
                        (Set QualName) ->
                        (Set QualName) ->
                        (Set QualName) ->
                        (Bool) ->
                        ([Request_TypeImply]) ->
                        (Set QualName) ->
                        (Set QualName) ->
                        (Bool) ->
                        (Set QualName) ->
                        (Set QualName) ->
                        (KSubst) ->
                        (KSubst) ->
                        (Int) ->
                        (KSubst) ->
                        (FMap QualName QualNames) ->
                        (FMap QualName QualNames) ->
                        (Set Modid) ->
                        (PConsigs) ->
                        (PConsigs) ->
                        (FMap QualName PKT) ->
                        (FMap QualName PKT) ->
                        (KSubst) ->
                        (FMap QualName PTS) ->
                        (FMap QualName PTS) ->
                        ([RawRequest]) ->
                        ([RawRequest]) ->
                        (FMap QualName StrTypeDecl) ->
                        (Bool) ->
                        (Int) ->
                        ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),([GHError]),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(ImportedModule),(FMap QualName StrTypeDecl),([(QualName,TDecl)]))
-- cata
sem_ImportedModule :: (ImportedModule) ->
                      (T_ImportedModule)
sem_ImportedModule ((ImportedModule_Empty )) =
    (sem_ImportedModule_Empty )
sem_ImportedModule ((ImportedModule_Module (_modid) (_export_tp) (_export_val) (_datas))) =
    (sem_ImportedModule_Module (_modid) ((sem_QualNames (_export_tp))) ((sem_QualNames (_export_val))) ((sem_ImportDatas (_datas))))
sem_ImportedModule_Empty :: (T_ImportedModule)
sem_ImportedModule_Empty (_lhs_abstracttps_collect)
                         (_lhs_bimapimps_collect)
                         (_lhs_classname)
                         (_lhs_consigs)
                         (_lhs_constructors_collect)
                         (_lhs_constructors_dist)
                         (_lhs_deps)
                         (_lhs_deps_collect)
                         (_lhs_exportedTypes)
                         (_lhs_exportedValues)
                         (_lhs_exports)
                         (_lhs_funimps_collect)
                         (_lhs_genabs)
                         (_lhs_genabs_collect)
                         (_lhs_hiddenTypes)
                         (_lhs_hiddenValues)
                         (_lhs_hiding)
                         (_lhs_implications_collect)
                         (_lhs_impliedTypes)
                         (_lhs_impliedValues)
                         (_lhs_importedModule)
                         (_lhs_importedTypes)
                         (_lhs_importedValues)
                         (_lhs_kinames)
                         (_lhs_kinds)
                         (_lhs_kindvar)
                         (_lhs_ksubst)
                         (_lhs_methods_collect)
                         (_lhs_methods_dist)
                         (_lhs_modules)
                         (_lhs_pconsigs)
                         (_lhs_pconsigs_col)
                         (_lhs_pktcoll)
                         (_lhs_pktdist)
                         (_lhs_prekind)
                         (_lhs_ptscoll)
                         (_lhs_ptsdist)
                         (_lhs_rawrequest_collect)
                         (_lhs_requests_gas)
                         (_lhs_strtypes)
                         (_lhs_toplevel)
                         (_lhs_verbosity) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_kinames,[],_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,ImportedModule_Empty,_lhs_strtypes,[])
sem_ImportedModule_Module :: (Modid) ->
                             (T_QualNames) ->
                             (T_QualNames) ->
                             (T_ImportDatas) ->
                             (T_ImportedModule)
sem_ImportedModule_Module (_modid)
                          (_export_tp)
                          (_export_val)
                          (_datas)
                          (_lhs_abstracttps_collect)
                          (_lhs_bimapimps_collect)
                          (_lhs_classname)
                          (_lhs_consigs)
                          (_lhs_constructors_collect)
                          (_lhs_constructors_dist)
                          (_lhs_deps)
                          (_lhs_deps_collect)
                          (_lhs_exportedTypes)
                          (_lhs_exportedValues)
                          (_lhs_exports)
                          (_lhs_funimps_collect)
                          (_lhs_genabs)
                          (_lhs_genabs_collect)
                          (_lhs_hiddenTypes)
                          (_lhs_hiddenValues)
                          (_lhs_hiding)
                          (_lhs_implications_collect)
                          (_lhs_impliedTypes)
                          (_lhs_impliedValues)
                          (_lhs_importedModule)
                          (_lhs_importedTypes)
                          (_lhs_importedValues)
                          (_lhs_kinames)
                          (_lhs_kinds)
                          (_lhs_kindvar)
                          (_lhs_ksubst)
                          (_lhs_methods_collect)
                          (_lhs_methods_dist)
                          (_lhs_modules)
                          (_lhs_pconsigs)
                          (_lhs_pconsigs_col)
                          (_lhs_pktcoll)
                          (_lhs_pktdist)
                          (_lhs_prekind)
                          (_lhs_ptscoll)
                          (_lhs_ptsdist)
                          (_lhs_rawrequest_collect)
                          (_lhs_requests_gas)
                          (_lhs_strtypes)
                          (_lhs_toplevel)
                          (_lhs_verbosity) =
    let (_currentModule) =
            _modid
        (_importedModule) =
            True
        (_toplevel) =
            True
        (_local) =
            False
        ( _export_tp_abstracttps_collect
         ,_export_tp_bimapimps_collect
         ,_export_tp_constructors_collect
         ,_export_tp_deps_collect
         ,_export_tp_exports_collect
         ,_export_tp_funimps_collect
         ,_export_tp_genabs_collect
         ,_export_tp_implications_collect
         ,_export_tp_imports_collect
         ,_export_tp_initialTypes
         ,_export_tp_initialValues
         ,_export_tp_methods_collect
         ,_export_tp_nonrecs
         ,_export_tp_pconsigs_col
         ,_export_tp_pktcoll
         ,_export_tp_rawrequest_collect
         ,_export_tp_self
         ) =
            (_export_tp (_lhs_abstracttps_collect)
                        (_lhs_bimapimps_collect)
                        (_lhs_classname)
                        (_lhs_consigs)
                        (_lhs_constructors_collect)
                        (_lhs_constructors_dist)
                        (_currentModule)
                        (_lhs_deps)
                        (_lhs_deps_collect)
                        (_lhs_exportedTypes)
                        (_lhs_exportedValues)
                        (_lhs_exports)
                        (_lhs_funimps_collect)
                        (_lhs_genabs)
                        (_lhs_genabs_collect)
                        (_lhs_hiddenTypes)
                        (_lhs_hiddenValues)
                        (_lhs_hiding)
                        (_lhs_implications_collect)
                        (_lhs_impliedTypes)
                        (_lhs_impliedValues)
                        (_importedModule)
                        (_lhs_importedTypes)
                        (_lhs_importedValues)
                        (_local)
                        (_lhs_methods_collect)
                        (_lhs_methods_dist)
                        (_lhs_pconsigs)
                        (_lhs_pconsigs_col)
                        (_lhs_pktcoll)
                        (_lhs_pktdist)
                        (_lhs_rawrequest_collect)
                        (_toplevel))
        ( _export_val_abstracttps_collect
         ,_export_val_bimapimps_collect
         ,_export_val_constructors_collect
         ,_export_val_deps_collect
         ,_export_val_exports_collect
         ,_export_val_funimps_collect
         ,_export_val_genabs_collect
         ,_export_val_implications_collect
         ,_export_val_imports_collect
         ,_export_val_initialTypes
         ,_export_val_initialValues
         ,_export_val_methods_collect
         ,_export_val_nonrecs
         ,_export_val_pconsigs_col
         ,_export_val_pktcoll
         ,_export_val_rawrequest_collect
         ,_export_val_self
         ) =
            (_export_val (_export_tp_abstracttps_collect)
                         (_export_tp_bimapimps_collect)
                         (_lhs_classname)
                         (_lhs_consigs)
                         (_export_tp_constructors_collect)
                         (_lhs_constructors_dist)
                         (_currentModule)
                         (_lhs_deps)
                         (_export_tp_deps_collect)
                         (_lhs_exportedTypes)
                         (_lhs_exportedValues)
                         (_lhs_exports)
                         (_export_tp_funimps_collect)
                         (_lhs_genabs)
                         (_export_tp_genabs_collect)
                         (_lhs_hiddenTypes)
                         (_lhs_hiddenValues)
                         (_lhs_hiding)
                         (_export_tp_implications_collect)
                         (_lhs_impliedTypes)
                         (_lhs_impliedValues)
                         (_importedModule)
                         (_lhs_importedTypes)
                         (_lhs_importedValues)
                         (_local)
                         (_export_tp_methods_collect)
                         (_lhs_methods_dist)
                         (_lhs_pconsigs)
                         (_export_tp_pconsigs_col)
                         (_export_tp_pktcoll)
                         (_lhs_pktdist)
                         (_export_tp_rawrequest_collect)
                         (_toplevel))
        ( _datas_abstracttps_collect
         ,_datas_bimapimps_collect
         ,_datas_constructors_collect
         ,_datas_deps_collect
         ,_datas_exports_collect
         ,_datas_funimps_collect
         ,_datas_genabs_collect
         ,_datas_implications_collect
         ,_datas_imports_collect
         ,_datas_initialTypes
         ,_datas_initialValues
         ,_datas_kinames
         ,_datas_kind_errors
         ,_datas_kindvar
         ,_datas_ksubst
         ,_datas_methods_collect
         ,_datas_nonrecs
         ,_datas_outputi
         ,_datas_pconsigs_col
         ,_datas_pktcoll
         ,_datas_ptscoll
         ,_datas_rawrequest_collect
         ,_datas_self
         ,_datas_strtypes
         ,_datas_titypes
         ) =
            (_datas (_export_val_abstracttps_collect)
                    (_export_val_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (emptyFM)
                    (_lhs_constructors_dist)
                    (_currentModule)
                    (_lhs_deps)
                    (_export_val_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_export_val_funimps_collect)
                    (_lhs_genabs)
                    (_export_val_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_export_val_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_kinames)
                    (_lhs_kinds)
                    (_lhs_kindvar)
                    (_lhs_ksubst)
                    (_local)
                    (emptyFM)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_export_val_pconsigs_col)
                    (_export_val_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_lhs_ptscoll)
                    (_lhs_ptsdist)
                    (_export_val_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_strtypes)
                    (_toplevel)
                    (_lhs_verbosity))
    in  (_datas_abstracttps_collect
        ,_datas_bimapimps_collect
        ,mergeFM _lhs_constructors_collect
                 _datas_constructors_collect
        ,_datas_deps_collect
        ,[]
        ,_datas_funimps_collect
        ,_datas_genabs_collect
        ,_datas_implications_collect
        ,_export_tp_imports_collect ++ _export_val_imports_collect ++ _datas_imports_collect
        ,_export_tp_initialTypes ++ _export_val_initialTypes ++ _datas_initialTypes
        ,_export_tp_initialValues ++ _export_val_initialValues ++ _datas_initialValues
        ,_datas_kinames
        ,_datas_kind_errors
        ,_datas_kindvar
        ,_datas_ksubst
        ,mergeFM _lhs_methods_collect
                 _datas_methods_collect
        ,_export_tp_nonrecs ++ _export_val_nonrecs ++ _datas_nonrecs
        ,_datas_pconsigs_col
        ,_datas_pktcoll
        ,_datas_ptscoll
        ,_datas_rawrequest_collect
        ,ImportedModule_Module _modid _export_tp_self
                               _export_val_self _datas_self
        ,_datas_strtypes
        ,_datas_titypes
        )
-- ImportedModules ---------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]
      strtypes             : FMap QualName StrTypeDecl

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      kind_errors          : [GHError]
      nonrecs              : [TypedBinding]
      self                 : ImportedModules
      titypes              : [(QualName,TDecl)]

-}
{-
   local variables for ImportedModules.Cons:

-}
{-
   local variables for ImportedModules.Nil:

-}
-- semantic domain
type T_ImportedModules = (Set QualName) ->
                         ([Request_BimapImply]) ->
                         (Maybe QualName) ->
                         (Consigs) ->
                         (FMap QualName QualNames) ->
                         (FMap QualName QualNames) ->
                         (FMap QualName QualNames) ->
                         (FMap QualName QualNames) ->
                         (Set QualName) ->
                         (Set QualName) ->
                         (Exports) ->
                         ([Request_FunImply]) ->
                         (Set QualName) ->
                         (Set QualName) ->
                         (Set QualName) ->
                         (Set QualName) ->
                         (Bool) ->
                         ([Request_TypeImply]) ->
                         (Set QualName) ->
                         (Set QualName) ->
                         (Bool) ->
                         (Set QualName) ->
                         (Set QualName) ->
                         (KSubst) ->
                         (KSubst) ->
                         (Int) ->
                         (KSubst) ->
                         (FMap QualName QualNames) ->
                         (FMap QualName QualNames) ->
                         (Set Modid) ->
                         (PConsigs) ->
                         (PConsigs) ->
                         (FMap QualName PKT) ->
                         (FMap QualName PKT) ->
                         (KSubst) ->
                         (FMap QualName PTS) ->
                         (FMap QualName PTS) ->
                         ([RawRequest]) ->
                         ([RawRequest]) ->
                         (FMap QualName StrTypeDecl) ->
                         (Bool) ->
                         (Int) ->
                         ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),([GHError]),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(ImportedModules),(FMap QualName StrTypeDecl),([(QualName,TDecl)]))
-- cata
sem_ImportedModules :: (ImportedModules) ->
                       (T_ImportedModules)
sem_ImportedModules (list) =
    (foldr (sem_ImportedModules_Cons) (sem_ImportedModules_Nil) ((map sem_ImportedModule list)))
sem_ImportedModules_Cons :: (T_ImportedModule) ->
                            (T_ImportedModules) ->
                            (T_ImportedModules)
sem_ImportedModules_Cons (_hd)
                         (_tl)
                         (_lhs_abstracttps_collect)
                         (_lhs_bimapimps_collect)
                         (_lhs_classname)
                         (_lhs_consigs)
                         (_lhs_constructors_collect)
                         (_lhs_constructors_dist)
                         (_lhs_deps)
                         (_lhs_deps_collect)
                         (_lhs_exportedTypes)
                         (_lhs_exportedValues)
                         (_lhs_exports)
                         (_lhs_funimps_collect)
                         (_lhs_genabs)
                         (_lhs_genabs_collect)
                         (_lhs_hiddenTypes)
                         (_lhs_hiddenValues)
                         (_lhs_hiding)
                         (_lhs_implications_collect)
                         (_lhs_impliedTypes)
                         (_lhs_impliedValues)
                         (_lhs_importedModule)
                         (_lhs_importedTypes)
                         (_lhs_importedValues)
                         (_lhs_kinames)
                         (_lhs_kinds)
                         (_lhs_kindvar)
                         (_lhs_ksubst)
                         (_lhs_methods_collect)
                         (_lhs_methods_dist)
                         (_lhs_modules)
                         (_lhs_pconsigs)
                         (_lhs_pconsigs_col)
                         (_lhs_pktcoll)
                         (_lhs_pktdist)
                         (_lhs_prekind)
                         (_lhs_ptscoll)
                         (_lhs_ptsdist)
                         (_lhs_rawrequest_collect)
                         (_lhs_requests_gas)
                         (_lhs_strtypes)
                         (_lhs_toplevel)
                         (_lhs_verbosity) =
    let ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_kinames,_hd_kind_errors,_hd_kindvar,_hd_ksubst,_hd_methods_collect,_hd_nonrecs,_hd_pconsigs_col,_hd_pktcoll,_hd_ptscoll,_hd_rawrequest_collect,_hd_self,_hd_strtypes,_hd_titypes) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kinds)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_strtypes)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_initialTypes,_tl_initialValues,_tl_kinames,_tl_kind_errors,_tl_kindvar,_tl_ksubst,_tl_methods_collect,_tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_ptscoll,_tl_rawrequest_collect,_tl_self,_tl_strtypes,_tl_titypes) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_hd_kinames)
                 (_lhs_kinds)
                 (_hd_kindvar)
                 (_hd_ksubst)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_hd_ptscoll)
                 (_lhs_ptsdist)
                 (_hd_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_hd_strtypes)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
    in  (_tl_abstracttps_collect
        ,_tl_bimapimps_collect
        ,_tl_constructors_collect
        ,_tl_deps_collect
        ,_hd_exports_collect ++ _tl_exports_collect
        ,_tl_funimps_collect
        ,_tl_genabs_collect
        ,_tl_implications_collect
        ,_hd_imports_collect ++ _tl_imports_collect
        ,_hd_initialTypes ++ _tl_initialTypes
        ,_hd_initialValues ++ _tl_initialValues
        ,_tl_kinames
        ,_hd_kind_errors ++ _tl_kind_errors
        ,_tl_kindvar
        ,_tl_ksubst
        ,_tl_methods_collect
        ,_hd_nonrecs ++ _tl_nonrecs
        ,_tl_pconsigs_col
        ,_tl_pktcoll
        ,_tl_ptscoll
        ,_tl_rawrequest_collect
        ,_hd_self : _tl_self
        ,_tl_strtypes
        ,_hd_titypes ++ _tl_titypes
        )
sem_ImportedModules_Nil :: (T_ImportedModules)
sem_ImportedModules_Nil (_lhs_abstracttps_collect)
                        (_lhs_bimapimps_collect)
                        (_lhs_classname)
                        (_lhs_consigs)
                        (_lhs_constructors_collect)
                        (_lhs_constructors_dist)
                        (_lhs_deps)
                        (_lhs_deps_collect)
                        (_lhs_exportedTypes)
                        (_lhs_exportedValues)
                        (_lhs_exports)
                        (_lhs_funimps_collect)
                        (_lhs_genabs)
                        (_lhs_genabs_collect)
                        (_lhs_hiddenTypes)
                        (_lhs_hiddenValues)
                        (_lhs_hiding)
                        (_lhs_implications_collect)
                        (_lhs_impliedTypes)
                        (_lhs_impliedValues)
                        (_lhs_importedModule)
                        (_lhs_importedTypes)
                        (_lhs_importedValues)
                        (_lhs_kinames)
                        (_lhs_kinds)
                        (_lhs_kindvar)
                        (_lhs_ksubst)
                        (_lhs_methods_collect)
                        (_lhs_methods_dist)
                        (_lhs_modules)
                        (_lhs_pconsigs)
                        (_lhs_pconsigs_col)
                        (_lhs_pktcoll)
                        (_lhs_pktdist)
                        (_lhs_prekind)
                        (_lhs_ptscoll)
                        (_lhs_ptsdist)
                        (_lhs_rawrequest_collect)
                        (_lhs_requests_gas)
                        (_lhs_strtypes)
                        (_lhs_toplevel)
                        (_lhs_verbosity) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_kinames,[],_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,[],_lhs_strtypes,[])
-- Imports -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Imports

-}
{-
   local variables for Imports.Cons:

-}
{-
   local variables for Imports.Nil:

-}
-- semantic domain
type T_Imports = (Set QualName) ->
                 ([Request_BimapImply]) ->
                 (Maybe QualName) ->
                 (Consigs) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Modid) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Exports) ->
                 ([Request_FunImply]) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Bool) ->
                 ([Request_TypeImply]) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Bool) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Bool) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (PConsigs) ->
                 (PConsigs) ->
                 (FMap QualName PKT) ->
                 (FMap QualName PKT) ->
                 ([RawRequest]) ->
                 (Bool) ->
                 ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),([RawRequest]),(Imports))
-- cata
sem_Imports :: (Imports) ->
               (T_Imports)
sem_Imports (list) =
    (foldr (sem_Imports_Cons) (sem_Imports_Nil) ((map sem_Import list)))
sem_Imports_Cons :: (T_Import) ->
                    (T_Imports) ->
                    (T_Imports)
sem_Imports_Cons (_hd)
                 (_tl)
                 (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel) =
    let ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_methods_collect,_hd_nonrecs,_hd_pconsigs_col,_hd_pktcoll,_hd_rawrequest_collect,_hd_self) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_initialTypes,_tl_initialValues,_tl_methods_collect,_tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_rawrequest_collect,_tl_self) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_hd_rawrequest_collect)
                 (_lhs_toplevel))
    in  (_tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_hd_exports_collect ++ _tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_hd_imports_collect ++ _tl_imports_collect,_hd_initialTypes ++ _tl_initialTypes,_hd_initialValues ++ _tl_initialValues,_tl_methods_collect,_hd_nonrecs ++ _tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_rawrequest_collect,_hd_self : _tl_self)
sem_Imports_Nil :: (T_Imports)
sem_Imports_Nil (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_rawrequest_collect)
                (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_rawrequest_collect,[])
-- Infix -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      ptsdist              : FMap QualName PTS
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Infix

-}
{-
   local variables for Infix.Left:

-}
{-
   local variables for Infix.No:

-}
{-
   local variables for Infix.Right:

-}
-- semantic domain
type T_Infix = (Set QualName) ->
               ([Request_BimapImply]) ->
               (Maybe QualName) ->
               (Consigs) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Set QualName) ->
               (Set QualName) ->
               (Exports) ->
               ([Request_FunImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               ([Request_TypeImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (PConsigs) ->
               (PConsigs) ->
               (FMap QualName PKT) ->
               (FMap QualName PKT) ->
               (FMap QualName PTS) ->
               (FMap QualName PTS) ->
               ([RawRequest]) ->
               (Bool) ->
               ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Infix))
-- cata
sem_Infix :: (Infix) ->
             (T_Infix)
sem_Infix ((Infix_Left )) =
    (sem_Infix_Left )
sem_Infix ((Infix_No )) =
    (sem_Infix_No )
sem_Infix ((Infix_Right )) =
    (sem_Infix_Right )
sem_Infix_Left :: (T_Infix)
sem_Infix_Left (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,Infix_Left)
sem_Infix_No :: (T_Infix)
sem_Infix_No (_lhs_abstracttps_collect)
             (_lhs_bimapimps_collect)
             (_lhs_classname)
             (_lhs_consigs)
             (_lhs_constructors_collect)
             (_lhs_constructors_dist)
             (_lhs_currentModule)
             (_lhs_deps)
             (_lhs_deps_collect)
             (_lhs_exportedTypes)
             (_lhs_exportedValues)
             (_lhs_exports)
             (_lhs_funimps_collect)
             (_lhs_genabs)
             (_lhs_genabs_collect)
             (_lhs_hiddenTypes)
             (_lhs_hiddenValues)
             (_lhs_hiding)
             (_lhs_implications_collect)
             (_lhs_impliedTypes)
             (_lhs_impliedValues)
             (_lhs_importedModule)
             (_lhs_importedTypes)
             (_lhs_importedValues)
             (_lhs_local)
             (_lhs_methods_collect)
             (_lhs_methods_dist)
             (_lhs_pconsigs)
             (_lhs_pconsigs_col)
             (_lhs_pktcoll)
             (_lhs_pktdist)
             (_lhs_ptscoll)
             (_lhs_ptsdist)
             (_lhs_rawrequest_collect)
             (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,Infix_No)
sem_Infix_Right :: (T_Infix)
sem_Infix_Right (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,Infix_Right)
-- Kind --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      ptsdist              : FMap QualName PTS
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      fixedKind            : Bool
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Kind

-}
{-
   local variables for Kind.Arr:

-}
{-
   local variables for Kind.Box:

-}
{-
   local variables for Kind.Error:

-}
{-
   local variables for Kind.Star:

-}
{-
   local variables for Kind.Var:

-}
-- semantic domain
type T_Kind = (Set QualName) ->
              ([Request_BimapImply]) ->
              (Maybe QualName) ->
              (Consigs) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Modid) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Set QualName) ->
              (Set QualName) ->
              (Exports) ->
              ([Request_FunImply]) ->
              (Set QualName) ->
              (Set QualName) ->
              (Set QualName) ->
              (Set QualName) ->
              (Bool) ->
              ([Request_TypeImply]) ->
              (Set QualName) ->
              (Set QualName) ->
              (Bool) ->
              (Set QualName) ->
              (Set QualName) ->
              (Bool) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (PConsigs) ->
              (PConsigs) ->
              (FMap QualName PKT) ->
              (FMap QualName PKT) ->
              (FMap QualName PTS) ->
              (FMap QualName PTS) ->
              ([RawRequest]) ->
              (Bool) ->
              ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),(Bool),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Kind))
-- cata
sem_Kind :: (Kind) ->
            (T_Kind)
sem_Kind ((Kind_Arr (_left) (_right))) =
    (sem_Kind_Arr ((sem_Kind (_left))) ((sem_Kind (_right))))
sem_Kind ((Kind_Box (_kind))) =
    (sem_Kind_Box ((sem_Kind (_kind))))
sem_Kind ((Kind_Error )) =
    (sem_Kind_Error )
sem_Kind ((Kind_Star )) =
    (sem_Kind_Star )
sem_Kind ((Kind_Var (_name))) =
    (sem_Kind_Var ((sem_QualName (_name))))
sem_Kind_Arr :: (T_Kind) ->
                (T_Kind) ->
                (T_Kind)
sem_Kind_Arr (_left)
             (_right)
             (_lhs_abstracttps_collect)
             (_lhs_bimapimps_collect)
             (_lhs_classname)
             (_lhs_consigs)
             (_lhs_constructors_collect)
             (_lhs_constructors_dist)
             (_lhs_currentModule)
             (_lhs_deps)
             (_lhs_deps_collect)
             (_lhs_exportedTypes)
             (_lhs_exportedValues)
             (_lhs_exports)
             (_lhs_funimps_collect)
             (_lhs_genabs)
             (_lhs_genabs_collect)
             (_lhs_hiddenTypes)
             (_lhs_hiddenValues)
             (_lhs_hiding)
             (_lhs_implications_collect)
             (_lhs_impliedTypes)
             (_lhs_impliedValues)
             (_lhs_importedModule)
             (_lhs_importedTypes)
             (_lhs_importedValues)
             (_lhs_local)
             (_lhs_methods_collect)
             (_lhs_methods_dist)
             (_lhs_pconsigs)
             (_lhs_pconsigs_col)
             (_lhs_pktcoll)
             (_lhs_pktdist)
             (_lhs_ptscoll)
             (_lhs_ptsdist)
             (_lhs_rawrequest_collect)
             (_lhs_toplevel) =
    let ( _left_abstracttps_collect,_left_bimapimps_collect,_left_constructors_collect,_left_deps_collect,_left_exports_collect,_left_fixedKind,_left_funimps_collect,_left_genabs_collect,_left_implications_collect,_left_imports_collect,_left_initialTypes,_left_initialValues,_left_methods_collect,_left_nonrecs,_left_pconsigs_col,_left_pktcoll,_left_ptscoll,_left_rawrequest_collect,_left_self) =
            (_left (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
        ( _right_abstracttps_collect,_right_bimapimps_collect,_right_constructors_collect,_right_deps_collect,_right_exports_collect,_right_fixedKind,_right_funimps_collect,_right_genabs_collect,_right_implications_collect,_right_imports_collect,_right_initialTypes,_right_initialValues,_right_methods_collect,_right_nonrecs,_right_pconsigs_col,_right_pktcoll,_right_ptscoll,_right_rawrequest_collect,_right_self) =
            (_right (_left_abstracttps_collect)
                    (_left_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_left_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_left_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_left_funimps_collect)
                    (_lhs_genabs)
                    (_left_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_left_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_local)
                    (_left_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_pconsigs)
                    (_left_pconsigs_col)
                    (_left_pktcoll)
                    (_lhs_pktdist)
                    (_left_ptscoll)
                    (_lhs_ptsdist)
                    (_left_rawrequest_collect)
                    (_lhs_toplevel))
    in  (_right_abstracttps_collect
        ,_right_bimapimps_collect
        ,_right_constructors_collect
        ,_right_deps_collect
        ,_left_exports_collect ++ _right_exports_collect
        ,_left_fixedKind && _right_fixedKind
        ,_right_funimps_collect
        ,_right_genabs_collect
        ,_right_implications_collect
        ,_left_imports_collect ++ _right_imports_collect
        ,_left_initialTypes ++ _right_initialTypes
        ,_left_initialValues ++ _right_initialValues
        ,_right_methods_collect
        ,_left_nonrecs ++ _right_nonrecs
        ,_right_pconsigs_col
        ,_right_pktcoll
        ,_right_ptscoll
        ,_right_rawrequest_collect
        ,Kind_Arr _left_self _right_self
        )
sem_Kind_Box :: (T_Kind) ->
                (T_Kind)
sem_Kind_Box (_kind)
             (_lhs_abstracttps_collect)
             (_lhs_bimapimps_collect)
             (_lhs_classname)
             (_lhs_consigs)
             (_lhs_constructors_collect)
             (_lhs_constructors_dist)
             (_lhs_currentModule)
             (_lhs_deps)
             (_lhs_deps_collect)
             (_lhs_exportedTypes)
             (_lhs_exportedValues)
             (_lhs_exports)
             (_lhs_funimps_collect)
             (_lhs_genabs)
             (_lhs_genabs_collect)
             (_lhs_hiddenTypes)
             (_lhs_hiddenValues)
             (_lhs_hiding)
             (_lhs_implications_collect)
             (_lhs_impliedTypes)
             (_lhs_impliedValues)
             (_lhs_importedModule)
             (_lhs_importedTypes)
             (_lhs_importedValues)
             (_lhs_local)
             (_lhs_methods_collect)
             (_lhs_methods_dist)
             (_lhs_pconsigs)
             (_lhs_pconsigs_col)
             (_lhs_pktcoll)
             (_lhs_pktdist)
             (_lhs_ptscoll)
             (_lhs_ptsdist)
             (_lhs_rawrequest_collect)
             (_lhs_toplevel) =
    let ( _kind_abstracttps_collect,_kind_bimapimps_collect,_kind_constructors_collect,_kind_deps_collect,_kind_exports_collect,_kind_fixedKind,_kind_funimps_collect,_kind_genabs_collect,_kind_implications_collect,_kind_imports_collect,_kind_initialTypes,_kind_initialValues,_kind_methods_collect,_kind_nonrecs,_kind_pconsigs_col,_kind_pktcoll,_kind_ptscoll,_kind_rawrequest_collect,_kind_self) =
            (_kind (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_kind_abstracttps_collect,_kind_bimapimps_collect,_kind_constructors_collect,_kind_deps_collect,_kind_exports_collect,_kind_fixedKind,_kind_funimps_collect,_kind_genabs_collect,_kind_implications_collect,_kind_imports_collect,_kind_initialTypes,_kind_initialValues,_kind_methods_collect,_kind_nonrecs,_kind_pconsigs_col,_kind_pktcoll,_kind_ptscoll,_kind_rawrequest_collect,Kind_Box _kind_self)
sem_Kind_Error :: (T_Kind)
sem_Kind_Error (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],internalError "Request.Kind.Error: kind error",_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,Kind_Error)
sem_Kind_Star :: (T_Kind)
sem_Kind_Star (_lhs_abstracttps_collect)
              (_lhs_bimapimps_collect)
              (_lhs_classname)
              (_lhs_consigs)
              (_lhs_constructors_collect)
              (_lhs_constructors_dist)
              (_lhs_currentModule)
              (_lhs_deps)
              (_lhs_deps_collect)
              (_lhs_exportedTypes)
              (_lhs_exportedValues)
              (_lhs_exports)
              (_lhs_funimps_collect)
              (_lhs_genabs)
              (_lhs_genabs_collect)
              (_lhs_hiddenTypes)
              (_lhs_hiddenValues)
              (_lhs_hiding)
              (_lhs_implications_collect)
              (_lhs_impliedTypes)
              (_lhs_impliedValues)
              (_lhs_importedModule)
              (_lhs_importedTypes)
              (_lhs_importedValues)
              (_lhs_local)
              (_lhs_methods_collect)
              (_lhs_methods_dist)
              (_lhs_pconsigs)
              (_lhs_pconsigs_col)
              (_lhs_pktcoll)
              (_lhs_pktdist)
              (_lhs_ptscoll)
              (_lhs_ptsdist)
              (_lhs_rawrequest_collect)
              (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],True,_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,Kind_Star)
sem_Kind_Var :: (T_QualName) ->
                (T_Kind)
sem_Kind_Var (_name)
             (_lhs_abstracttps_collect)
             (_lhs_bimapimps_collect)
             (_lhs_classname)
             (_lhs_consigs)
             (_lhs_constructors_collect)
             (_lhs_constructors_dist)
             (_lhs_currentModule)
             (_lhs_deps)
             (_lhs_deps_collect)
             (_lhs_exportedTypes)
             (_lhs_exportedValues)
             (_lhs_exports)
             (_lhs_funimps_collect)
             (_lhs_genabs)
             (_lhs_genabs_collect)
             (_lhs_hiddenTypes)
             (_lhs_hiddenValues)
             (_lhs_hiding)
             (_lhs_implications_collect)
             (_lhs_impliedTypes)
             (_lhs_impliedValues)
             (_lhs_importedModule)
             (_lhs_importedTypes)
             (_lhs_importedValues)
             (_lhs_local)
             (_lhs_methods_collect)
             (_lhs_methods_dist)
             (_lhs_pconsigs)
             (_lhs_pconsigs_col)
             (_lhs_pktcoll)
             (_lhs_pktdist)
             (_lhs_ptscoll)
             (_lhs_ptsdist)
             (_lhs_rawrequest_collect)
             (_lhs_toplevel) =
    let ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,False,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_lhs_ptscoll,_name_rawrequest_collect,Kind_Var _name_self)
-- LabelType ---------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kname                : QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      toplevel             : Bool
      tpname               : QualName

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      constructors         : QualNames
      exports_collect      : Exports
      hasLabels            : Bool
      implications         : [Type]
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      kind_errors          : [GHError]
      nonrecs              : [TypedBinding]
      self                 : LabelType

-}
{-
   local variables for LabelType.LabelType:
      kind_errors
      ks
      is_imported_h
      is_hidden
      is_imported
      is_exported
      hasLabels

-}
{-
   local variables for LabelType.Type:
      kind_errors
      ks
      hasLabels

-}
-- semantic domain
type T_LabelType = (Set QualName) ->
                   ([Request_BimapImply]) ->
                   (Maybe QualName) ->
                   (Consigs) ->
                   (FMap QualName QualNames) ->
                   (FMap QualName QualNames) ->
                   (Modid) ->
                   (FMap QualName QualNames) ->
                   (FMap QualName QualNames) ->
                   (Set QualName) ->
                   (Set QualName) ->
                   (Exports) ->
                   ([Request_FunImply]) ->
                   (Set QualName) ->
                   (Set QualName) ->
                   (Set QualName) ->
                   (Set QualName) ->
                   (Bool) ->
                   ([Request_TypeImply]) ->
                   (Set QualName) ->
                   (Set QualName) ->
                   (Bool) ->
                   (Set QualName) ->
                   (Set QualName) ->
                   (KSubst) ->
                   (Int) ->
                   (QualName) ->
                   (KSubst) ->
                   (Bool) ->
                   (FMap QualName QualNames) ->
                   (FMap QualName QualNames) ->
                   (PConsigs) ->
                   (PConsigs) ->
                   (FMap QualName PKT) ->
                   (FMap QualName PKT) ->
                   (KSubst) ->
                   (FMap QualName PTS) ->
                   (FMap QualName PTS) ->
                   ([RawRequest]) ->
                   (Bool) ->
                   (QualName) ->
                   ((Set QualName),([Request_BimapImply]),(QualNames),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),(Bool),([Type]),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),([GHError]),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(LabelType))
-- cata
sem_LabelType :: (LabelType) ->
                 (T_LabelType)
sem_LabelType ((LabelType_LabelType (_label) (_strict) (_body))) =
    (sem_LabelType_LabelType ((sem_QualName (_label))) (_strict) ((sem_Type (_body))))
sem_LabelType ((LabelType_Type (_strict) (_body))) =
    (sem_LabelType_Type (_strict) ((sem_Type (_body))))
sem_LabelType_LabelType :: (T_QualName) ->
                           (Bool) ->
                           (T_Type) ->
                           (T_LabelType)
sem_LabelType_LabelType (_label)
                        (_strict)
                        (_body)
                        (_lhs_abstracttps_collect)
                        (_lhs_bimapimps_collect)
                        (_lhs_classname)
                        (_lhs_consigs)
                        (_lhs_constructors_collect)
                        (_lhs_constructors_dist)
                        (_lhs_currentModule)
                        (_lhs_deps)
                        (_lhs_deps_collect)
                        (_lhs_exportedTypes)
                        (_lhs_exportedValues)
                        (_lhs_exports)
                        (_lhs_funimps_collect)
                        (_lhs_genabs)
                        (_lhs_genabs_collect)
                        (_lhs_hiddenTypes)
                        (_lhs_hiddenValues)
                        (_lhs_hiding)
                        (_lhs_implications_collect)
                        (_lhs_impliedTypes)
                        (_lhs_impliedValues)
                        (_lhs_importedModule)
                        (_lhs_importedTypes)
                        (_lhs_importedValues)
                        (_lhs_kinames)
                        (_lhs_kindvar)
                        (_lhs_kname)
                        (_lhs_ksubst)
                        (_lhs_local)
                        (_lhs_methods_collect)
                        (_lhs_methods_dist)
                        (_lhs_pconsigs)
                        (_lhs_pconsigs_col)
                        (_lhs_pktcoll)
                        (_lhs_pktdist)
                        (_lhs_prekind)
                        (_lhs_ptscoll)
                        (_lhs_ptsdist)
                        (_lhs_rawrequest_collect)
                        (_lhs_toplevel)
                        (_lhs_tpname) =
    let (_hasLabels) =
            True
        (_is_exported) =
            _label_self `Set.elementOf` _lhs_exportedValues
        (_is_imported) =
            _label_self `Set.elementOf` _lhs_importedValues
        (_is_hidden) =
            _label_self `Set.elementOf` _lhs_hiddenValues
        (_is_imported_h) =
            if _lhs_hiding then _is_hidden else _is_imported
        ((_ks,_kind_errors)) =
            unifyWithError (GHError_KindUCError _body_kloc
                              (PP.ppQualName False _lhs_kname)
                              (Just (PP.ppQualName False _label_self))
                              (applyKind _body_ksubst _body_inferkind)
                           ) _body_inferkind Kind_Star _body_ksubst
        ( _label_abstracttps_collect,_label_bimapimps_collect,_label_constructors_collect,_label_deps_collect,_label_exports_collect,_label_funimps_collect,_label_genabs_collect,_label_implications_collect,_label_imports_collect,_label_initialTypes,_label_initialValues,_label_methods_collect,_label_nonrecs,_label_pconsigs_col,_label_pktcoll,_label_rawrequest_collect,_label_self) =
            (_label (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_toplevel))
        ( _body_abstracttps_collect
         ,_body_bimapimps_collect
         ,_body_constructors_collect
         ,_body_deps_collect
         ,_body_exports_collect
         ,_body_funimps_collect
         ,_body_genabs_collect
         ,_body_implications_collect
         ,_body_imports_collect
         ,_body_inferkind
         ,_body_initialTypes
         ,_body_initialValues
         ,_body_kinames
         ,_body_kind_errors
         ,_body_kindvar
         ,_body_kloc
         ,_body_ksubst
         ,_body_methods_collect
         ,_body_nonrecs
         ,_body_pconsigs_col
         ,_body_pktcoll
         ,_body_ptscoll
         ,_body_rawrequest_collect
         ,_body_self
         ) =
            (_body (_label_abstracttps_collect)
                   (_label_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_label_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_label_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_label_funimps_collect)
                   (_lhs_genabs)
                   (_label_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_label_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_label_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_label_pconsigs_col)
                   (_label_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_label_rawrequest_collect)
                   (False))
    in  (_body_abstracttps_collect
        ,_body_bimapimps_collect
        ,[_label_self]
        ,_body_constructors_collect
        ,_body_deps_collect
        ,_label_exports_collect ++ _body_exports_collect
        ,_body_funimps_collect
        ,_body_genabs_collect
        ,_hasLabels
        ,[_body_self]
        ,_body_implications_collect
        ,_label_imports_collect ++ _body_imports_collect
        ,_label_initialTypes ++ _body_initialTypes
        ,_label_initialValues ++ _body_initialValues
        ,_body_kinames
        ,_body_kind_errors ++ _kind_errors
        ,_body_kindvar
        ,_ks
        ,_body_methods_collect
        ,_label_nonrecs ++ _body_nonrecs
        ,_body_pconsigs_col
        ,_body_pktcoll
        ,_body_ptscoll
        ,_body_rawrequest_collect
        ,LabelType_LabelType _label_self _strict
                             _body_self
        )
sem_LabelType_Type :: (Bool) ->
                      (T_Type) ->
                      (T_LabelType)
sem_LabelType_Type (_strict)
                   (_body)
                   (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kindvar)
                   (_lhs_kname)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel)
                   (_lhs_tpname) =
    let (_hasLabels) =
            False
        ((_ks,_kind_errors)) =
            unifyWithError (GHError_KindUCError _body_kloc
                              (PP.ppQualName False _lhs_kname) Nothing
                              (applyKind _body_ksubst _body_inferkind)
                           ) _body_inferkind Kind_Star _body_ksubst
        ( _body_abstracttps_collect
         ,_body_bimapimps_collect
         ,_body_constructors_collect
         ,_body_deps_collect
         ,_body_exports_collect
         ,_body_funimps_collect
         ,_body_genabs_collect
         ,_body_implications_collect
         ,_body_imports_collect
         ,_body_inferkind
         ,_body_initialTypes
         ,_body_initialValues
         ,_body_kinames
         ,_body_kind_errors
         ,_body_kindvar
         ,_body_kloc
         ,_body_ksubst
         ,_body_methods_collect
         ,_body_nonrecs
         ,_body_pconsigs_col
         ,_body_pktcoll
         ,_body_ptscoll
         ,_body_rawrequest_collect
         ,_body_self
         ) =
            (_body (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (False))
    in  (_body_abstracttps_collect
        ,_body_bimapimps_collect
        ,[]
        ,_body_constructors_collect
        ,_body_deps_collect
        ,_body_exports_collect
        ,_body_funimps_collect
        ,_body_genabs_collect
        ,_hasLabels
        ,[_body_self]
        ,_body_implications_collect
        ,_body_imports_collect
        ,_body_initialTypes
        ,_body_initialValues
        ,_body_kinames
        ,_body_kind_errors ++ _kind_errors
        ,_body_kindvar
        ,_ks
        ,_body_methods_collect
        ,_body_nonrecs
        ,_body_pconsigs_col
        ,_body_pktcoll
        ,_body_ptscoll
        ,_body_rawrequest_collect
        ,LabelType_Type _strict _body_self
        )
-- LabelTypes --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kname                : QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      toplevel             : Bool
      tpname               : QualName

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      constructors         : QualNames
      count                : Int
      exports_collect      : Exports
      hasLabels            : Bool
      implications         : [Type]
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      kind_errors          : [GHError]
      nil                  : Bool
      nonrecs              : [TypedBinding]
      self                 : LabelTypes

-}
{-
   local variables for LabelTypes.Cons:

-}
{-
   local variables for LabelTypes.Nil:

-}
-- semantic domain
type T_LabelTypes = (Set QualName) ->
                    ([Request_BimapImply]) ->
                    (Maybe QualName) ->
                    (Consigs) ->
                    (FMap QualName QualNames) ->
                    (FMap QualName QualNames) ->
                    (Modid) ->
                    (FMap QualName QualNames) ->
                    (FMap QualName QualNames) ->
                    (Set QualName) ->
                    (Set QualName) ->
                    (Exports) ->
                    ([Request_FunImply]) ->
                    (Set QualName) ->
                    (Set QualName) ->
                    (Set QualName) ->
                    (Set QualName) ->
                    (Bool) ->
                    ([Request_TypeImply]) ->
                    (Set QualName) ->
                    (Set QualName) ->
                    (Bool) ->
                    (Set QualName) ->
                    (Set QualName) ->
                    (KSubst) ->
                    (Int) ->
                    (QualName) ->
                    (KSubst) ->
                    (Bool) ->
                    (FMap QualName QualNames) ->
                    (FMap QualName QualNames) ->
                    (PConsigs) ->
                    (PConsigs) ->
                    (FMap QualName PKT) ->
                    (FMap QualName PKT) ->
                    (KSubst) ->
                    (FMap QualName PTS) ->
                    (FMap QualName PTS) ->
                    ([RawRequest]) ->
                    (Bool) ->
                    (QualName) ->
                    ((Set QualName),([Request_BimapImply]),(QualNames),(FMap QualName QualNames),(Int),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),(Bool),([Type]),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),([GHError]),(Int),(KSubst),(FMap QualName QualNames),(Bool),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(LabelTypes))
-- cata
sem_LabelTypes :: (LabelTypes) ->
                  (T_LabelTypes)
sem_LabelTypes (list) =
    (foldr (sem_LabelTypes_Cons) (sem_LabelTypes_Nil) ((map sem_LabelType list)))
sem_LabelTypes_Cons :: (T_LabelType) ->
                       (T_LabelTypes) ->
                       (T_LabelTypes)
sem_LabelTypes_Cons (_hd)
                    (_tl)
                    (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_kinames)
                    (_lhs_kindvar)
                    (_lhs_kname)
                    (_lhs_ksubst)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_lhs_ptscoll)
                    (_lhs_ptsdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_toplevel)
                    (_lhs_tpname) =
    let ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_hasLabels,_hd_implications,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_kinames,_hd_kind_errors,_hd_kindvar,_hd_ksubst,_hd_methods_collect,_hd_nonrecs,_hd_pconsigs_col,_hd_pktcoll,_hd_ptscoll,_hd_rawrequest_collect,_hd_self) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kindvar)
                 (_lhs_kname)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel)
                 (_lhs_tpname))
        ( _tl_abstracttps_collect
         ,_tl_bimapimps_collect
         ,_tl_constructors
         ,_tl_constructors_collect
         ,_tl_count
         ,_tl_deps_collect
         ,_tl_exports_collect
         ,_tl_funimps_collect
         ,_tl_genabs_collect
         ,_tl_hasLabels
         ,_tl_implications
         ,_tl_implications_collect
         ,_tl_imports_collect
         ,_tl_initialTypes
         ,_tl_initialValues
         ,_tl_kinames
         ,_tl_kind_errors
         ,_tl_kindvar
         ,_tl_ksubst
         ,_tl_methods_collect
         ,_tl_nil
         ,_tl_nonrecs
         ,_tl_pconsigs_col
         ,_tl_pktcoll
         ,_tl_ptscoll
         ,_tl_rawrequest_collect
         ,_tl_self
         ) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_hd_kinames)
                 (_hd_kindvar)
                 (_lhs_kname)
                 (_hd_ksubst)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_hd_ptscoll)
                 (_lhs_ptsdist)
                 (_hd_rawrequest_collect)
                 (_lhs_toplevel)
                 (_lhs_tpname))
    in  (_tl_abstracttps_collect
        ,_tl_bimapimps_collect
        ,_hd_constructors ++ _tl_constructors
        ,_tl_constructors_collect
        ,_tl_count + 1
        ,_tl_deps_collect
        ,_hd_exports_collect ++ _tl_exports_collect
        ,_tl_funimps_collect
        ,_tl_genabs_collect
        ,_hd_hasLabels
        ,_hd_implications ++ _tl_implications
        ,_tl_implications_collect
        ,_hd_imports_collect ++ _tl_imports_collect
        ,_hd_initialTypes ++ _tl_initialTypes
        ,_hd_initialValues ++ _tl_initialValues
        ,_tl_kinames
        ,_hd_kind_errors ++ _tl_kind_errors
        ,_tl_kindvar
        ,_tl_ksubst
        ,_tl_methods_collect
        ,False
        ,_hd_nonrecs ++ _tl_nonrecs
        ,_tl_pconsigs_col
        ,_tl_pktcoll
        ,_tl_ptscoll
        ,_tl_rawrequest_collect
        ,_hd_self : _tl_self
        )
sem_LabelTypes_Nil :: (T_LabelTypes)
sem_LabelTypes_Nil (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kindvar)
                   (_lhs_kname)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel)
                   (_lhs_tpname) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,[],_lhs_constructors_collect,0,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,False,[],_lhs_implications_collect,[],[],[],_lhs_kinames,[],_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,True,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,[])
-- Literal -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      ptsdist              : FMap QualName PTS
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Literal

-}
{-
   local variables for Literal.Char:

-}
{-
   local variables for Literal.Float:

-}
{-
   local variables for Literal.Frac:

-}
{-
   local variables for Literal.Int:

-}
{-
   local variables for Literal.String:

-}
-- semantic domain
type T_Literal = (Set QualName) ->
                 ([Request_BimapImply]) ->
                 (Maybe QualName) ->
                 (Consigs) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Modid) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Exports) ->
                 ([Request_FunImply]) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Bool) ->
                 ([Request_TypeImply]) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Bool) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Bool) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (PConsigs) ->
                 (PConsigs) ->
                 (FMap QualName PKT) ->
                 (FMap QualName PKT) ->
                 (FMap QualName PTS) ->
                 (FMap QualName PTS) ->
                 ([RawRequest]) ->
                 (Bool) ->
                 ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Literal))
-- cata
sem_Literal :: (Literal) ->
               (T_Literal)
sem_Literal ((Literal_Char (_name))) =
    (sem_Literal_Char (_name))
sem_Literal ((Literal_Float (_name))) =
    (sem_Literal_Float (_name))
sem_Literal ((Literal_Frac (_name))) =
    (sem_Literal_Frac (_name))
sem_Literal ((Literal_Int (_name))) =
    (sem_Literal_Int (_name))
sem_Literal ((Literal_String (_name))) =
    (sem_Literal_String (_name))
sem_Literal_Char :: (String) ->
                    (T_Literal)
sem_Literal_Char (_name)
                 (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,Literal_Char   _name)
sem_Literal_Float :: (String) ->
                     (T_Literal)
sem_Literal_Float (_name)
                  (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_ptscoll)
                  (_lhs_ptsdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,Literal_Float  _name)
sem_Literal_Frac :: (String) ->
                    (T_Literal)
sem_Literal_Frac (_name)
                 (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,Literal_Frac   _name)
sem_Literal_Int :: (String) ->
                   (T_Literal)
sem_Literal_Int (_name)
                (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,Literal_Int    _name)
sem_Literal_String :: (String) ->
                      (T_Literal)
sem_Literal_String (_name)
                   (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,Literal_String _name)
-- Module ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      genabs               : Set QualName
      hiddenEntities       : [(Set QualName,Set QualName)]
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedEntities     : [(Set QualName,Set QualName)]
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      output               : [PP_Doc]
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]
      strtypes             : FMap QualName StrTypeDecl

   synthesised attributes:
      compiledModule       : Modid
      initialTypes         : [QualName]
      initialValues        : [QualName]
      kind_errors          : [GHError]
      nonrecs              : [TypedBinding]
      outputi              : [PP_Doc]
      self                 : Module
      titypes              : [(QualName,TDecl)]

-}
{-
   local variables for Module.Main:
      final_exports
      exports
      local
      compiledModule
      currentModule

-}
{-
   local variables for Module.Named:
      final_exports
      exports
      local
      compiledModule
      currentModule

-}
-- semantic domain
type T_Module = (Set QualName) ->
                ([Request_BimapImply]) ->
                (Maybe QualName) ->
                (Consigs) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Set QualName) ->
                (Set QualName) ->
                ([Request_FunImply]) ->
                (Set QualName) ->
                (Set QualName) ->
                ([(Set QualName,Set QualName)]) ->
                (Set QualName) ->
                (Set QualName) ->
                (Bool) ->
                ([Request_TypeImply]) ->
                (Set QualName) ->
                (Set QualName) ->
                ([(Set QualName,Set QualName)]) ->
                (Bool) ->
                (Set QualName) ->
                (Set QualName) ->
                (KSubst) ->
                (KSubst) ->
                (Int) ->
                (KSubst) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Set Modid) ->
                ([PP_Doc]) ->
                (PConsigs) ->
                (PConsigs) ->
                (FMap QualName PKT) ->
                (FMap QualName PKT) ->
                (KSubst) ->
                (FMap QualName PTS) ->
                (FMap QualName PTS) ->
                ([RawRequest]) ->
                ([RawRequest]) ->
                (FMap QualName StrTypeDecl) ->
                (Bool) ->
                (Int) ->
                ((Set QualName),([Request_BimapImply]),(Modid),(FMap QualName QualNames),(FMap QualName QualNames),([Request_FunImply]),(Set QualName),([Request_TypeImply]),([QualName]),([QualName]),(KSubst),([GHError]),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),([PP_Doc]),([PP_Doc]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Module),(FMap QualName StrTypeDecl),([(QualName,TDecl)]))
-- cata
sem_Module :: (Module) ->
              (T_Module)
sem_Module ((Module_Main (_body))) =
    (sem_Module_Main ((sem_Body (_body))))
sem_Module ((Module_Named (_modid) (_exported) (_body))) =
    (sem_Module_Named (_modid) ((sem_Exported (_exported))) ((sem_Body (_body))))
sem_Module_Main :: (T_Body) ->
                   (T_Module)
sem_Module_Main (_body)
                (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenEntities)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedEntities)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_kinames)
                (_lhs_kinds)
                (_lhs_kindvar)
                (_lhs_ksubst)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_modules)
                (_lhs_output)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_prekind)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_requests_gas)
                (_lhs_strtypes)
                (_lhs_toplevel)
                (_lhs_verbosity) =
    let (_currentModule) =
            "Main"
        (_compiledModule) =
            "Main"
        (_local) =
            True
        (_exports) =
            internalError "Exports.Module.Main.exports: not used"
        (_final_exports) =
            [Export_Module _currentModule]
        ( _body_abstracttps_collect
         ,_body_bimapimps_collect
         ,_body_constructors_collect
         ,_body_deps_collect
         ,_body_exports_collect
         ,_body_funimps_collect
         ,_body_genabs_collect
         ,_body_implications_collect
         ,_body_imports_collect
         ,_body_initialTypes
         ,_body_initialValues
         ,_body_kinames
         ,_body_kind_errors
         ,_body_kindvar
         ,_body_ksubst
         ,_body_methods_collect
         ,_body_nonrecs
         ,_body_output
         ,_body_outputi
         ,_body_pconsigs_col
         ,_body_pktcoll
         ,_body_ptscoll
         ,_body_rawrequest_collect
         ,_body_self
         ,_body_strtypes
         ,_body_titypes
         ) =
            (_body (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenEntities)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedEntities)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (PP.ppModuleHeader
                      _currentModule
                      (PP.ppExported False (Exported_Exports _final_exports))
                     ++ _lhs_output)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_strtypes)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_body_abstracttps_collect
        ,_body_bimapimps_collect
        ,_compiledModule
        ,_body_constructors_collect
        ,_body_deps_collect
        ,_body_funimps_collect
        ,_body_genabs_collect
        ,_body_implications_collect
        ,_body_initialTypes
        ,_body_initialValues
        ,_body_kinames
        ,_body_kind_errors
        ,_body_kindvar
        ,_body_ksubst
        ,_body_methods_collect
        ,_body_nonrecs
        ,_body_output
        ,PPI.ppiModule "Main" : _body_outputi
        ,_body_pconsigs_col
        ,_body_pktcoll
        ,_body_ptscoll
        ,_body_rawrequest_collect
        ,Module_Main _body_self
        ,_body_strtypes
        ,_body_titypes
        )
sem_Module_Named :: (Modid) ->
                    (T_Exported) ->
                    (T_Body) ->
                    (T_Module)
sem_Module_Named (_modid)
                 (_exported)
                 (_body)
                 (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenEntities)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedEntities)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kinds)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_output)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_strtypes)
                 (_lhs_toplevel)
                 (_lhs_verbosity) =
    let (_currentModule) =
            _modid
        (_compiledModule) =
            _modid
        (_local) =
            True
        (_exports) =
            internalError "Exports.Module.Named.exports: not used"
        (_final_exports) =
            _exported_exports_collect
        ( _exported_abstracttps_collect
         ,_exported_bimapimps_collect
         ,_exported_constructors_collect
         ,_exported_deps_collect
         ,_exported_exports_collect
         ,_exported_funimps_collect
         ,_exported_genabs_collect
         ,_exported_implications_collect
         ,_exported_imports_collect
         ,_exported_initialTypes
         ,_exported_initialValues
         ,_exported_methods_collect
         ,_exported_nonrecs
         ,_exported_pconsigs_col
         ,_exported_pktcoll
         ,_exported_rawrequest_collect
         ,_exported_self
         ,_exported_strtypes
         ) =
            (_exported (_lhs_abstracttps_collect)
                       (_lhs_bimapimps_collect)
                       (_lhs_classname)
                       (_lhs_consigs)
                       (_lhs_constructors_collect)
                       (_lhs_constructors_dist)
                       (_currentModule)
                       (_lhs_deps)
                       (_lhs_deps_collect)
                       (_lhs_exportedTypes)
                       (_lhs_exportedValues)
                       (internalError "Exports.Module.Named.exports: not used")
                       (_lhs_funimps_collect)
                       (_lhs_genabs)
                       (_lhs_genabs_collect)
                       (_lhs_hiddenTypes)
                       (_lhs_hiddenValues)
                       (_lhs_hiding)
                       (_lhs_implications_collect)
                       (_lhs_impliedTypes)
                       (_lhs_impliedValues)
                       (_lhs_importedModule)
                       (_lhs_importedTypes)
                       (_lhs_importedValues)
                       (_local)
                       (_lhs_methods_collect)
                       (_lhs_methods_dist)
                       (_lhs_pconsigs)
                       (_lhs_pconsigs_col)
                       (_lhs_pktcoll)
                       (_lhs_pktdist)
                       (_lhs_rawrequest_collect)
                       (_lhs_strtypes)
                       (_lhs_toplevel))
        ( _body_abstracttps_collect
         ,_body_bimapimps_collect
         ,_body_constructors_collect
         ,_body_deps_collect
         ,_body_exports_collect
         ,_body_funimps_collect
         ,_body_genabs_collect
         ,_body_implications_collect
         ,_body_imports_collect
         ,_body_initialTypes
         ,_body_initialValues
         ,_body_kinames
         ,_body_kind_errors
         ,_body_kindvar
         ,_body_ksubst
         ,_body_methods_collect
         ,_body_nonrecs
         ,_body_output
         ,_body_outputi
         ,_body_pconsigs_col
         ,_body_pktcoll
         ,_body_ptscoll
         ,_body_rawrequest_collect
         ,_body_self
         ,_body_strtypes
         ,_body_titypes
         ) =
            (_body (_exported_abstracttps_collect)
                   (_exported_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_exported_constructors_collect)
                   (_lhs_constructors_dist)
                   (_currentModule)
                   (_lhs_deps)
                   (_exported_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_exports)
                   (_exported_funimps_collect)
                   (_lhs_genabs)
                   (_exported_genabs_collect)
                   (_lhs_hiddenEntities)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_exported_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedEntities)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_local)
                   (_exported_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (PP.ppModuleHeader
                      _modid
                      (PP.ppExported False (Exported_Exports _final_exports))
                     ++ _lhs_output)
                   (_lhs_pconsigs)
                   (_exported_pconsigs_col)
                   (_exported_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_exported_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_exported_strtypes)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_body_abstracttps_collect
        ,_body_bimapimps_collect
        ,_compiledModule
        ,_body_constructors_collect
        ,_body_deps_collect
        ,_body_funimps_collect
        ,_body_genabs_collect
        ,_body_implications_collect
        ,_exported_initialTypes ++ _body_initialTypes
        ,_exported_initialValues ++ _body_initialValues
        ,_body_kinames
        ,_body_kind_errors
        ,_body_kindvar
        ,_body_ksubst
        ,_body_methods_collect
        ,_exported_nonrecs ++ _body_nonrecs
        ,_body_output
        ,PPI.ppiModule _modid : _body_outputi
        ,_body_pconsigs_col
        ,_body_pktcoll
        ,_body_ptscoll
        ,_body_rawrequest_collect
        ,Module_Named _modid _exported_self _body_self
        ,_body_strtypes
        ,_body_titypes
        )
-- ModuleSystem ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      genabs               : Set QualName
      hiddenEntities       : [(Set QualName,Set QualName)]
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedEntities     : [(Set QualName,Set QualName)]
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      output               : [PP_Doc]
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]
      strtypes             : FMap QualName StrTypeDecl

   synthesised attributes:
      compiledModule       : Modid
      initialTypes         : [QualName]
      initialValues        : [QualName]
      kind_errors          : [GHError]
      nonrecs              : [TypedBinding]
      outputi              : [PP_Doc]
      self                 : ModuleSystem
      titypes              : [(QualName,TDecl)]

-}
{-
   local variables for ModuleSystem.ModuleSystem:
      exports

-}
-- semantic domain
type T_ModuleSystem = (Set QualName) ->
                      ([Request_BimapImply]) ->
                      (Maybe QualName) ->
                      (Consigs) ->
                      (FMap QualName QualNames) ->
                      (FMap QualName QualNames) ->
                      (FMap QualName QualNames) ->
                      (FMap QualName QualNames) ->
                      (Set QualName) ->
                      (Set QualName) ->
                      ([Request_FunImply]) ->
                      (Set QualName) ->
                      (Set QualName) ->
                      ([(Set QualName,Set QualName)]) ->
                      (Set QualName) ->
                      (Set QualName) ->
                      (Bool) ->
                      ([Request_TypeImply]) ->
                      (Set QualName) ->
                      (Set QualName) ->
                      ([(Set QualName,Set QualName)]) ->
                      (Bool) ->
                      (Set QualName) ->
                      (Set QualName) ->
                      (KSubst) ->
                      (KSubst) ->
                      (Int) ->
                      (KSubst) ->
                      (FMap QualName QualNames) ->
                      (FMap QualName QualNames) ->
                      (Set Modid) ->
                      ([PP_Doc]) ->
                      (PConsigs) ->
                      (PConsigs) ->
                      (FMap QualName PKT) ->
                      (FMap QualName PKT) ->
                      (KSubst) ->
                      (FMap QualName PTS) ->
                      (FMap QualName PTS) ->
                      ([RawRequest]) ->
                      ([RawRequest]) ->
                      (FMap QualName StrTypeDecl) ->
                      (Bool) ->
                      (Int) ->
                      ((Set QualName),([Request_BimapImply]),(Modid),(FMap QualName QualNames),(FMap QualName QualNames),([Request_FunImply]),(Set QualName),([Request_TypeImply]),([QualName]),([QualName]),(KSubst),([GHError]),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),([PP_Doc]),([PP_Doc]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(ModuleSystem),(FMap QualName StrTypeDecl),([(QualName,TDecl)]))
-- cata
sem_ModuleSystem :: (ModuleSystem) ->
                    (T_ModuleSystem)
sem_ModuleSystem ((ModuleSystem_ModuleSystem (_imports) (_module))) =
    (sem_ModuleSystem_ModuleSystem ((sem_ImportedModules (_imports))) ((sem_Module (_module))))
sem_ModuleSystem_ModuleSystem :: (T_ImportedModules) ->
                                 (T_Module) ->
                                 (T_ModuleSystem)
sem_ModuleSystem_ModuleSystem (_imports)
                              (_module)
                              (_lhs_abstracttps_collect)
                              (_lhs_bimapimps_collect)
                              (_lhs_classname)
                              (_lhs_consigs)
                              (_lhs_constructors_collect)
                              (_lhs_constructors_dist)
                              (_lhs_deps)
                              (_lhs_deps_collect)
                              (_lhs_exportedTypes)
                              (_lhs_exportedValues)
                              (_lhs_funimps_collect)
                              (_lhs_genabs)
                              (_lhs_genabs_collect)
                              (_lhs_hiddenEntities)
                              (_lhs_hiddenTypes)
                              (_lhs_hiddenValues)
                              (_lhs_hiding)
                              (_lhs_implications_collect)
                              (_lhs_impliedTypes)
                              (_lhs_impliedValues)
                              (_lhs_importedEntities)
                              (_lhs_importedModule)
                              (_lhs_importedTypes)
                              (_lhs_importedValues)
                              (_lhs_kinames)
                              (_lhs_kinds)
                              (_lhs_kindvar)
                              (_lhs_ksubst)
                              (_lhs_methods_collect)
                              (_lhs_methods_dist)
                              (_lhs_modules)
                              (_lhs_output)
                              (_lhs_pconsigs)
                              (_lhs_pconsigs_col)
                              (_lhs_pktcoll)
                              (_lhs_pktdist)
                              (_lhs_prekind)
                              (_lhs_ptscoll)
                              (_lhs_ptsdist)
                              (_lhs_rawrequest_collect)
                              (_lhs_requests_gas)
                              (_lhs_strtypes)
                              (_lhs_toplevel)
                              (_lhs_verbosity) =
    let (_exports) =
            internalError "Exports.ModuleSystem.ModuleSystem.exports: not used"
        ( _imports_abstracttps_collect
         ,_imports_bimapimps_collect
         ,_imports_constructors_collect
         ,_imports_deps_collect
         ,_imports_exports_collect
         ,_imports_funimps_collect
         ,_imports_genabs_collect
         ,_imports_implications_collect
         ,_imports_imports_collect
         ,_imports_initialTypes
         ,_imports_initialValues
         ,_imports_kinames
         ,_imports_kind_errors
         ,_imports_kindvar
         ,_imports_ksubst
         ,_imports_methods_collect
         ,_imports_nonrecs
         ,_imports_pconsigs_col
         ,_imports_pktcoll
         ,_imports_ptscoll
         ,_imports_rawrequest_collect
         ,_imports_self
         ,_imports_strtypes
         ,_imports_titypes
         ) =
            (_imports (_lhs_abstracttps_collect)
                      (_lhs_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_deps)
                      (_lhs_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_exports)
                      (_lhs_funimps_collect)
                      (_lhs_genabs)
                      (_lhs_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_lhs_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_lhs_kinames)
                      (_lhs_kinds)
                      (_lhs_kindvar)
                      (_lhs_ksubst)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_modules)
                      (_lhs_pconsigs)
                      (_lhs_pconsigs_col)
                      (_lhs_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_prekind)
                      (_lhs_ptscoll)
                      (_lhs_ptsdist)
                      (_lhs_rawrequest_collect)
                      (_lhs_requests_gas)
                      (_lhs_strtypes)
                      (_lhs_toplevel)
                      (_lhs_verbosity))
        ( _module_abstracttps_collect
         ,_module_bimapimps_collect
         ,_module_compiledModule
         ,_module_constructors_collect
         ,_module_deps_collect
         ,_module_funimps_collect
         ,_module_genabs_collect
         ,_module_implications_collect
         ,_module_initialTypes
         ,_module_initialValues
         ,_module_kinames
         ,_module_kind_errors
         ,_module_kindvar
         ,_module_ksubst
         ,_module_methods_collect
         ,_module_nonrecs
         ,_module_output
         ,_module_outputi
         ,_module_pconsigs_col
         ,_module_pktcoll
         ,_module_ptscoll
         ,_module_rawrequest_collect
         ,_module_self
         ,_module_strtypes
         ,_module_titypes
         ) =
            (_module (_imports_abstracttps_collect)
                     (_imports_bimapimps_collect)
                     (_lhs_classname)
                     (_lhs_consigs)
                     (_imports_constructors_collect)
                     (_lhs_constructors_dist)
                     (_lhs_deps)
                     (_imports_deps_collect)
                     (_lhs_exportedTypes)
                     (_lhs_exportedValues)
                     (_imports_funimps_collect)
                     (_lhs_genabs)
                     (_imports_genabs_collect)
                     (_lhs_hiddenEntities)
                     (_lhs_hiddenTypes)
                     (_lhs_hiddenValues)
                     (_lhs_hiding)
                     (_imports_implications_collect)
                     (_lhs_impliedTypes)
                     (_lhs_impliedValues)
                     (_lhs_importedEntities)
                     (_lhs_importedModule)
                     (_lhs_importedTypes)
                     (_lhs_importedValues)
                     (_imports_kinames)
                     (_lhs_kinds)
                     (_imports_kindvar)
                     (_imports_ksubst)
                     (_imports_methods_collect)
                     (_lhs_methods_dist)
                     (_lhs_modules)
                     (_lhs_output)
                     (_lhs_pconsigs)
                     (_imports_pconsigs_col)
                     (_imports_pktcoll)
                     (_lhs_pktdist)
                     (_lhs_prekind)
                     (_imports_ptscoll)
                     (_lhs_ptsdist)
                     (_imports_rawrequest_collect)
                     (_lhs_requests_gas)
                     (_imports_strtypes)
                     (_lhs_toplevel)
                     (_lhs_verbosity))
    in  (_module_abstracttps_collect
        ,_module_bimapimps_collect
        ,_module_compiledModule
        ,_module_constructors_collect
        ,_module_deps_collect
        ,_module_funimps_collect
        ,_module_genabs_collect
        ,_module_implications_collect
        ,_imports_initialTypes ++ _module_initialTypes
        ,_imports_initialValues ++ _module_initialValues
        ,_module_kinames
        ,_imports_kind_errors ++ _module_kind_errors
        ,_module_kindvar
        ,_module_ksubst
        ,_module_methods_collect
        ,_imports_nonrecs ++ _module_nonrecs
        ,_module_output
        ,_module_outputi
        ,_module_pconsigs_col
        ,_module_pktcoll
        ,_module_ptscoll
        ,_module_rawrequest_collect
        ,ModuleSystem_ModuleSystem _imports_self _module_self
        ,_module_strtypes
        ,_imports_titypes ++ _module_titypes
        )
-- Name --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Name

-}
{-
   local variables for Name.Ident:
      self

-}
{-
   local variables for Name.Special:
      self

-}
{-
   local variables for Name.Symbol:
      self

-}
-- semantic domain
type T_Name = (Set QualName) ->
              ([Request_BimapImply]) ->
              (Maybe QualName) ->
              (Consigs) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Modid) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Set QualName) ->
              (Set QualName) ->
              (Exports) ->
              ([Request_FunImply]) ->
              (Set QualName) ->
              (Set QualName) ->
              (Set QualName) ->
              (Set QualName) ->
              (Bool) ->
              ([Request_TypeImply]) ->
              (Set QualName) ->
              (Set QualName) ->
              (Bool) ->
              (Set QualName) ->
              (Set QualName) ->
              (Bool) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (PConsigs) ->
              (PConsigs) ->
              (FMap QualName PKT) ->
              (FMap QualName PKT) ->
              ([RawRequest]) ->
              (Bool) ->
              ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),([RawRequest]),(Name))
-- cata
sem_Name :: (Name) ->
            (T_Name)
sem_Name ((Name_Ident (_range) (_name))) =
    (sem_Name_Ident ((sem_Range (_range))) (_name))
sem_Name ((Name_Special (_range) (_name))) =
    (sem_Name_Special ((sem_Range (_range))) (_name))
sem_Name ((Name_Symbol (_range) (_name))) =
    (sem_Name_Symbol ((sem_Range (_range))) (_name))
sem_Name_Ident :: (T_Range) ->
                  (String) ->
                  (T_Name)
sem_Name_Ident (_range)
               (_name)
               (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_rawrequest_collect)
               (_lhs_toplevel) =
    let (_self) =
            Name_Ident   _range_self _name
        ( _range_self) =
            (_range )
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_rawrequest_collect,_self)
sem_Name_Special :: (T_Range) ->
                    (String) ->
                    (T_Name)
sem_Name_Special (_range)
                 (_name)
                 (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel) =
    let (_self) =
            Name_Special _range_self _name
        ( _range_self) =
            (_range )
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_rawrequest_collect,_self)
sem_Name_Symbol :: (T_Range) ->
                   (String) ->
                   (T_Name)
sem_Name_Symbol (_range)
                (_name)
                (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_rawrequest_collect)
                (_lhs_toplevel) =
    let (_self) =
            Name_Symbol  _range_self _name
        ( _range_self) =
            (_range )
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_rawrequest_collect,_self)
-- Names -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Names

-}
{-
   local variables for Names.Cons:

-}
{-
   local variables for Names.Nil:

-}
-- semantic domain
type T_Names = (Set QualName) ->
               ([Request_BimapImply]) ->
               (Maybe QualName) ->
               (Consigs) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Set QualName) ->
               (Set QualName) ->
               (Exports) ->
               ([Request_FunImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               ([Request_TypeImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (PConsigs) ->
               (PConsigs) ->
               (FMap QualName PKT) ->
               (FMap QualName PKT) ->
               ([RawRequest]) ->
               (Bool) ->
               ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),([RawRequest]),(Names))
-- cata
sem_Names :: (Names) ->
             (T_Names)
sem_Names (list) =
    (foldr (sem_Names_Cons) (sem_Names_Nil) ((map sem_Name list)))
sem_Names_Cons :: (T_Name) ->
                  (T_Names) ->
                  (T_Names)
sem_Names_Cons (_hd)
               (_tl)
               (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_rawrequest_collect)
               (_lhs_toplevel) =
    let ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_methods_collect,_hd_nonrecs,_hd_pconsigs_col,_hd_pktcoll,_hd_rawrequest_collect,_hd_self) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_initialTypes,_tl_initialValues,_tl_methods_collect,_tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_rawrequest_collect,_tl_self) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_hd_rawrequest_collect)
                 (_lhs_toplevel))
    in  (_tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_hd_exports_collect ++ _tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_hd_imports_collect ++ _tl_imports_collect,_hd_initialTypes ++ _tl_initialTypes,_hd_initialValues ++ _tl_initialValues,_tl_methods_collect,_hd_nonrecs ++ _tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_rawrequest_collect,_hd_self : _tl_self)
sem_Names_Nil :: (T_Names)
sem_Names_Nil (_lhs_abstracttps_collect)
              (_lhs_bimapimps_collect)
              (_lhs_classname)
              (_lhs_consigs)
              (_lhs_constructors_collect)
              (_lhs_constructors_dist)
              (_lhs_currentModule)
              (_lhs_deps)
              (_lhs_deps_collect)
              (_lhs_exportedTypes)
              (_lhs_exportedValues)
              (_lhs_exports)
              (_lhs_funimps_collect)
              (_lhs_genabs)
              (_lhs_genabs_collect)
              (_lhs_hiddenTypes)
              (_lhs_hiddenValues)
              (_lhs_hiding)
              (_lhs_implications_collect)
              (_lhs_impliedTypes)
              (_lhs_impliedValues)
              (_lhs_importedModule)
              (_lhs_importedTypes)
              (_lhs_importedValues)
              (_lhs_local)
              (_lhs_methods_collect)
              (_lhs_methods_dist)
              (_lhs_pconsigs)
              (_lhs_pconsigs_col)
              (_lhs_pktcoll)
              (_lhs_pktdist)
              (_lhs_rawrequest_collect)
              (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_rawrequest_collect,[])
-- PBind -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      ptsdist              : FMap QualName PTS
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : PBind

-}
{-
   local variables for PBind.PBind:

-}
-- semantic domain
type T_PBind = (Set QualName) ->
               ([Request_BimapImply]) ->
               (Maybe QualName) ->
               (Consigs) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Set QualName) ->
               (Set QualName) ->
               (Exports) ->
               ([Request_FunImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               ([Request_TypeImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (PConsigs) ->
               (PConsigs) ->
               (FMap QualName PKT) ->
               (FMap QualName PKT) ->
               (FMap QualName PTS) ->
               (FMap QualName PTS) ->
               ([RawRequest]) ->
               (Bool) ->
               ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(PBind))
-- cata
sem_PBind :: (PBind) ->
             (T_PBind)
sem_PBind ((PBind_PBind (_field) (_pattern))) =
    (sem_PBind_PBind ((sem_QualName (_field))) ((sem_Pattern (_pattern))))
sem_PBind_PBind :: (T_QualName) ->
                   (T_Pattern) ->
                   (T_PBind)
sem_PBind_PBind (_field)
                (_pattern)
                (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_toplevel) =
    let ( _field_abstracttps_collect,_field_bimapimps_collect,_field_constructors_collect,_field_deps_collect,_field_exports_collect,_field_funimps_collect,_field_genabs_collect,_field_implications_collect,_field_imports_collect,_field_initialTypes,_field_initialValues,_field_methods_collect,_field_nonrecs,_field_pconsigs_col,_field_pktcoll,_field_rawrequest_collect,_field_self) =
            (_field (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_toplevel))
        ( _pattern_abstracttps_collect,_pattern_bimapimps_collect,_pattern_constructors_collect,_pattern_deps_collect,_pattern_exports_collect,_pattern_funimps_collect,_pattern_genabs_collect,_pattern_implications_collect,_pattern_imports_collect,_pattern_initialTypes,_pattern_initialValues,_pattern_methods_collect,_pattern_nonrecs,_pattern_pconsigs_col,_pattern_pktcoll,_pattern_ptscoll,_pattern_rawrequest_collect,_pattern_self) =
            (_pattern (_field_abstracttps_collect)
                      (_field_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_field_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_field_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_field_funimps_collect)
                      (_lhs_genabs)
                      (_field_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_field_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_lhs_local)
                      (_field_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_pconsigs)
                      (_field_pconsigs_col)
                      (_field_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_ptscoll)
                      (_lhs_ptsdist)
                      (_field_rawrequest_collect)
                      (_lhs_toplevel))
    in  (_pattern_abstracttps_collect
        ,_pattern_bimapimps_collect
        ,_pattern_constructors_collect
        ,_pattern_deps_collect
        ,_field_exports_collect ++ _pattern_exports_collect
        ,_pattern_funimps_collect
        ,_pattern_genabs_collect
        ,_pattern_implications_collect
        ,_field_imports_collect ++ _pattern_imports_collect
        ,_field_initialTypes ++ _pattern_initialTypes
        ,_field_initialValues ++ _pattern_initialValues
        ,_pattern_methods_collect
        ,_field_nonrecs ++ _pattern_nonrecs
        ,_pattern_pconsigs_col
        ,_pattern_pktcoll
        ,_pattern_ptscoll
        ,_pattern_rawrequest_collect
        ,PBind_PBind _field_self _pattern_self
        )
-- PBinds ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      ptsdist              : FMap QualName PTS
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : PBinds

-}
{-
   local variables for PBinds.Cons:

-}
{-
   local variables for PBinds.Nil:

-}
-- semantic domain
type T_PBinds = (Set QualName) ->
                ([Request_BimapImply]) ->
                (Maybe QualName) ->
                (Consigs) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Modid) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Set QualName) ->
                (Set QualName) ->
                (Exports) ->
                ([Request_FunImply]) ->
                (Set QualName) ->
                (Set QualName) ->
                (Set QualName) ->
                (Set QualName) ->
                (Bool) ->
                ([Request_TypeImply]) ->
                (Set QualName) ->
                (Set QualName) ->
                (Bool) ->
                (Set QualName) ->
                (Set QualName) ->
                (Bool) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (PConsigs) ->
                (PConsigs) ->
                (FMap QualName PKT) ->
                (FMap QualName PKT) ->
                (FMap QualName PTS) ->
                (FMap QualName PTS) ->
                ([RawRequest]) ->
                (Bool) ->
                ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(PBinds))
-- cata
sem_PBinds :: (PBinds) ->
              (T_PBinds)
sem_PBinds (list) =
    (foldr (sem_PBinds_Cons) (sem_PBinds_Nil) ((map sem_PBind list)))
sem_PBinds_Cons :: (T_PBind) ->
                   (T_PBinds) ->
                   (T_PBinds)
sem_PBinds_Cons (_hd)
                (_tl)
                (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_toplevel) =
    let ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_methods_collect,_hd_nonrecs,_hd_pconsigs_col,_hd_pktcoll,_hd_ptscoll,_hd_rawrequest_collect,_hd_self) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_initialTypes,_tl_initialValues,_tl_methods_collect,_tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_ptscoll,_tl_rawrequest_collect,_tl_self) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_hd_ptscoll)
                 (_lhs_ptsdist)
                 (_hd_rawrequest_collect)
                 (_lhs_toplevel))
    in  (_tl_abstracttps_collect
        ,_tl_bimapimps_collect
        ,_tl_constructors_collect
        ,_tl_deps_collect
        ,_hd_exports_collect ++ _tl_exports_collect
        ,_tl_funimps_collect
        ,_tl_genabs_collect
        ,_tl_implications_collect
        ,_hd_imports_collect ++ _tl_imports_collect
        ,_hd_initialTypes ++ _tl_initialTypes
        ,_hd_initialValues ++ _tl_initialValues
        ,_tl_methods_collect
        ,_hd_nonrecs ++ _tl_nonrecs
        ,_tl_pconsigs_col
        ,_tl_pktcoll
        ,_tl_ptscoll
        ,_tl_rawrequest_collect
        ,_hd_self : _tl_self
        )
sem_PBinds_Nil :: (T_PBinds)
sem_PBinds_Nil (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,[])
-- PTS ---------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      fixedKind            : Bool
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : PTS

-}
{-
   local variables for PTS.PTS:

-}
-- semantic domain
type T_PTS = (Set QualName) ->
             ([Request_BimapImply]) ->
             (Maybe QualName) ->
             (Consigs) ->
             (FMap QualName QualNames) ->
             (FMap QualName QualNames) ->
             (Modid) ->
             (FMap QualName QualNames) ->
             (FMap QualName QualNames) ->
             (Set QualName) ->
             (Set QualName) ->
             (Exports) ->
             ([Request_FunImply]) ->
             (Set QualName) ->
             (Set QualName) ->
             (Set QualName) ->
             (Set QualName) ->
             (Bool) ->
             ([Request_TypeImply]) ->
             (Set QualName) ->
             (Set QualName) ->
             (Bool) ->
             (Set QualName) ->
             (Set QualName) ->
             (KSubst) ->
             (KSubst) ->
             (Int) ->
             (KSubst) ->
             (Bool) ->
             (FMap QualName QualNames) ->
             (FMap QualName QualNames) ->
             (PConsigs) ->
             (PConsigs) ->
             (FMap QualName PKT) ->
             (FMap QualName PKT) ->
             (KSubst) ->
             (FMap QualName PTS) ->
             (FMap QualName PTS) ->
             ([RawRequest]) ->
             (Bool) ->
             ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),(Bool),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(PTS))
-- cata
sem_PTS :: (PTS) ->
           (T_PTS)
sem_PTS ((PTS_PTS (_tpvar) (_kind) (_tp))) =
    (sem_PTS_PTS ((sem_QualName (_tpvar))) ((sem_Kind (_kind))) ((sem_QualType (_tp))))
sem_PTS_PTS :: (T_QualName) ->
               (T_Kind) ->
               (T_QualType) ->
               (T_PTS)
sem_PTS_PTS (_tpvar)
            (_kind)
            (_tp)
            (_lhs_abstracttps_collect)
            (_lhs_bimapimps_collect)
            (_lhs_classname)
            (_lhs_consigs)
            (_lhs_constructors_collect)
            (_lhs_constructors_dist)
            (_lhs_currentModule)
            (_lhs_deps)
            (_lhs_deps_collect)
            (_lhs_exportedTypes)
            (_lhs_exportedValues)
            (_lhs_exports)
            (_lhs_funimps_collect)
            (_lhs_genabs)
            (_lhs_genabs_collect)
            (_lhs_hiddenTypes)
            (_lhs_hiddenValues)
            (_lhs_hiding)
            (_lhs_implications_collect)
            (_lhs_impliedTypes)
            (_lhs_impliedValues)
            (_lhs_importedModule)
            (_lhs_importedTypes)
            (_lhs_importedValues)
            (_lhs_kinames)
            (_lhs_kinds)
            (_lhs_kindvar)
            (_lhs_ksubst)
            (_lhs_local)
            (_lhs_methods_collect)
            (_lhs_methods_dist)
            (_lhs_pconsigs)
            (_lhs_pconsigs_col)
            (_lhs_pktcoll)
            (_lhs_pktdist)
            (_lhs_prekind)
            (_lhs_ptscoll)
            (_lhs_ptsdist)
            (_lhs_rawrequest_collect)
            (_lhs_toplevel) =
    let ( _tpvar_abstracttps_collect,_tpvar_bimapimps_collect,_tpvar_constructors_collect,_tpvar_deps_collect,_tpvar_exports_collect,_tpvar_funimps_collect,_tpvar_genabs_collect,_tpvar_implications_collect,_tpvar_imports_collect,_tpvar_initialTypes,_tpvar_initialValues,_tpvar_methods_collect,_tpvar_nonrecs,_tpvar_pconsigs_col,_tpvar_pktcoll,_tpvar_rawrequest_collect,_tpvar_self) =
            (_tpvar (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_toplevel))
        ( _kind_abstracttps_collect,_kind_bimapimps_collect,_kind_constructors_collect,_kind_deps_collect,_kind_exports_collect,_kind_fixedKind,_kind_funimps_collect,_kind_genabs_collect,_kind_implications_collect,_kind_imports_collect,_kind_initialTypes,_kind_initialValues,_kind_methods_collect,_kind_nonrecs,_kind_pconsigs_col,_kind_pktcoll,_kind_ptscoll,_kind_rawrequest_collect,_kind_self) =
            (_kind (_tpvar_abstracttps_collect)
                   (_tpvar_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_tpvar_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_tpvar_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_tpvar_funimps_collect)
                   (_lhs_genabs)
                   (_tpvar_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_tpvar_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_tpvar_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_tpvar_pconsigs_col)
                   (_tpvar_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_tpvar_rawrequest_collect)
                   (_lhs_toplevel))
        ( _tp_abstracttps_collect,_tp_bimapimps_collect,_tp_constructors_collect,_tp_deps_collect,_tp_exports_collect,_tp_funimps_collect,_tp_genabs_collect,_tp_implications_collect,_tp_imports_collect,_tp_initialTypes,_tp_initialValues,_tp_kinames,_tp_kind_errors,_tp_kindvar,_tp_ksubst,_tp_methods_collect,_tp_nonrecs,_tp_pconsigs_col,_tp_pktcoll,_tp_ptscoll,_tp_rawrequest_collect,_tp_self) =
            (_tp (_kind_abstracttps_collect)
                 (_kind_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_kind_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_kind_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_kind_funimps_collect)
                 (_lhs_genabs)
                 (_kind_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_kind_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_kind_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_kind_pconsigs_col)
                 (_kind_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_kind_ptscoll)
                 (_lhs_ptsdist)
                 (_kind_rawrequest_collect)
                 (_lhs_toplevel))
    in  (_tp_abstracttps_collect
        ,_tp_bimapimps_collect
        ,_tp_constructors_collect
        ,_tp_deps_collect
        ,_tpvar_exports_collect ++ _kind_exports_collect ++ _tp_exports_collect
        ,_kind_fixedKind
        ,_tp_funimps_collect
        ,_tp_genabs_collect
        ,_tp_implications_collect
        ,_tpvar_imports_collect ++ _kind_imports_collect ++ _tp_imports_collect
        ,_tpvar_initialTypes ++ _kind_initialTypes ++ _tp_initialTypes
        ,_tpvar_initialValues ++ _kind_initialValues ++ _tp_initialValues
        ,_tp_kinames
        ,_tp_kindvar
        ,_tp_ksubst
        ,_tp_methods_collect
        ,_tpvar_nonrecs ++ _kind_nonrecs ++ _tp_nonrecs
        ,_tp_pconsigs_col
        ,_tp_pktcoll
        ,_tp_ptscoll
        ,_tp_rawrequest_collect
        ,PTS_PTS _tpvar_self _kind_self _tp_self
        )
-- Pattern -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      ptsdist              : FMap QualName PTS
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Pattern

-}
{-
   local variables for Pattern.As:

-}
{-
   local variables for Pattern.Con:

-}
{-
   local variables for Pattern.Irr:

-}
{-
   local variables for Pattern.Lab:

-}
{-
   local variables for Pattern.List:

-}
{-
   local variables for Pattern.Lit:

-}
{-
   local variables for Pattern.Negate:

-}
{-
   local variables for Pattern.OpApp:

-}
{-
   local variables for Pattern.Parens:

-}
{-
   local variables for Pattern.Tuple:

-}
{-
   local variables for Pattern.Var:

-}
{-
   local variables for Pattern.Wild:

-}
-- semantic domain
type T_Pattern = (Set QualName) ->
                 ([Request_BimapImply]) ->
                 (Maybe QualName) ->
                 (Consigs) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Modid) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Exports) ->
                 ([Request_FunImply]) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Bool) ->
                 ([Request_TypeImply]) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Bool) ->
                 (Set QualName) ->
                 (Set QualName) ->
                 (Bool) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (PConsigs) ->
                 (PConsigs) ->
                 (FMap QualName PKT) ->
                 (FMap QualName PKT) ->
                 (FMap QualName PTS) ->
                 (FMap QualName PTS) ->
                 ([RawRequest]) ->
                 (Bool) ->
                 ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Pattern))
-- cata
sem_Pattern :: (Pattern) ->
               (T_Pattern)
sem_Pattern ((Pattern_As (_name) (_pattern))) =
    (sem_Pattern_As ((sem_QualName (_name))) ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_Con (_name) (_args))) =
    (sem_Pattern_Con ((sem_QualName (_name))) ((sem_Patterns (_args))))
sem_Pattern ((Pattern_Irr (_pattern))) =
    (sem_Pattern_Irr ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_Lab (_name) (_pbinds))) =
    (sem_Pattern_Lab ((sem_QualName (_name))) ((sem_PBinds (_pbinds))))
sem_Pattern ((Pattern_List (_patterns))) =
    (sem_Pattern_List ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_Lit (_name))) =
    (sem_Pattern_Lit ((sem_Literal (_name))))
sem_Pattern ((Pattern_Negate (_pattern))) =
    (sem_Pattern_Negate ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_OpApp (_op) (_left) (_right))) =
    (sem_Pattern_OpApp ((sem_QualName (_op))) ((sem_Pattern (_left))) ((sem_Pattern (_right))))
sem_Pattern ((Pattern_Parens (_pattern))) =
    (sem_Pattern_Parens ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_Tuple (_patterns))) =
    (sem_Pattern_Tuple ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_Var (_name))) =
    (sem_Pattern_Var ((sem_QualName (_name))))
sem_Pattern ((Pattern_Wild )) =
    (sem_Pattern_Wild )
sem_Pattern_As :: (T_QualName) ->
                  (T_Pattern) ->
                  (T_Pattern)
sem_Pattern_As (_name)
               (_pattern)
               (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_toplevel) =
    let ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
        ( _pattern_abstracttps_collect,_pattern_bimapimps_collect,_pattern_constructors_collect,_pattern_deps_collect,_pattern_exports_collect,_pattern_funimps_collect,_pattern_genabs_collect,_pattern_implications_collect,_pattern_imports_collect,_pattern_initialTypes,_pattern_initialValues,_pattern_methods_collect,_pattern_nonrecs,_pattern_pconsigs_col,_pattern_pktcoll,_pattern_ptscoll,_pattern_rawrequest_collect,_pattern_self) =
            (_pattern (_name_abstracttps_collect)
                      (_name_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_name_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_name_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_name_funimps_collect)
                      (_lhs_genabs)
                      (_name_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_name_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_lhs_local)
                      (_name_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_pconsigs)
                      (_name_pconsigs_col)
                      (_name_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_ptscoll)
                      (_lhs_ptsdist)
                      (_name_rawrequest_collect)
                      (_lhs_toplevel))
    in  (_pattern_abstracttps_collect
        ,_pattern_bimapimps_collect
        ,_pattern_constructors_collect
        ,_pattern_deps_collect
        ,_name_exports_collect ++ _pattern_exports_collect
        ,_pattern_funimps_collect
        ,_pattern_genabs_collect
        ,_pattern_implications_collect
        ,_name_imports_collect ++ _pattern_imports_collect
        ,_name_initialTypes ++ _pattern_initialTypes
        ,_name_initialValues ++ _pattern_initialValues
        ,_pattern_methods_collect
        ,_name_nonrecs ++ _pattern_nonrecs
        ,_pattern_pconsigs_col
        ,_pattern_pktcoll
        ,_pattern_ptscoll
        ,_pattern_rawrequest_collect
        ,Pattern_As  _name_self _pattern_self
        )
sem_Pattern_Con :: (T_QualName) ->
                   (T_Patterns) ->
                   (T_Pattern)
sem_Pattern_Con (_name)
                (_args)
                (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_toplevel) =
    let ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
        ( _args_abstracttps_collect,_args_bimapimps_collect,_args_constructors_collect,_args_deps_collect,_args_exports_collect,_args_funimps_collect,_args_genabs_collect,_args_implications_collect,_args_imports_collect,_args_initialTypes,_args_initialValues,_args_methods_collect,_args_nonrecs,_args_pconsigs_col,_args_pktcoll,_args_ptscoll,_args_rawrequest_collect,_args_self) =
            (_args (_name_abstracttps_collect)
                   (_name_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_name_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_name_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_name_funimps_collect)
                   (_lhs_genabs)
                   (_name_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_name_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_name_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_name_pconsigs_col)
                   (_name_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_name_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_args_abstracttps_collect
        ,_args_bimapimps_collect
        ,_args_constructors_collect
        ,_args_deps_collect
        ,_name_exports_collect ++ _args_exports_collect
        ,_args_funimps_collect
        ,_args_genabs_collect
        ,_args_implications_collect
        ,_name_imports_collect ++ _args_imports_collect
        ,_name_initialTypes ++ _args_initialTypes
        ,_name_initialValues ++ _args_initialValues
        ,_args_methods_collect
        ,_name_nonrecs ++ _args_nonrecs
        ,_args_pconsigs_col
        ,_args_pktcoll
        ,_args_ptscoll
        ,_args_rawrequest_collect
        ,Pattern_Con _name_self _args_self
        )
sem_Pattern_Irr :: (T_Pattern) ->
                   (T_Pattern)
sem_Pattern_Irr (_pattern)
                (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_toplevel) =
    let ( _pattern_abstracttps_collect,_pattern_bimapimps_collect,_pattern_constructors_collect,_pattern_deps_collect,_pattern_exports_collect,_pattern_funimps_collect,_pattern_genabs_collect,_pattern_implications_collect,_pattern_imports_collect,_pattern_initialTypes,_pattern_initialValues,_pattern_methods_collect,_pattern_nonrecs,_pattern_pconsigs_col,_pattern_pktcoll,_pattern_ptscoll,_pattern_rawrequest_collect,_pattern_self) =
            (_pattern (_lhs_abstracttps_collect)
                      (_lhs_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_lhs_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_lhs_funimps_collect)
                      (_lhs_genabs)
                      (_lhs_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_lhs_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_pconsigs)
                      (_lhs_pconsigs_col)
                      (_lhs_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_ptscoll)
                      (_lhs_ptsdist)
                      (_lhs_rawrequest_collect)
                      (_lhs_toplevel))
    in  (_pattern_abstracttps_collect,_pattern_bimapimps_collect,_pattern_constructors_collect,_pattern_deps_collect,_pattern_exports_collect,_pattern_funimps_collect,_pattern_genabs_collect,_pattern_implications_collect,_pattern_imports_collect,_pattern_initialTypes,_pattern_initialValues,_pattern_methods_collect,_pattern_nonrecs,_pattern_pconsigs_col,_pattern_pktcoll,_pattern_ptscoll,_pattern_rawrequest_collect,Pattern_Irr _pattern_self)
sem_Pattern_Lab :: (T_QualName) ->
                   (T_PBinds) ->
                   (T_Pattern)
sem_Pattern_Lab (_name)
                (_pbinds)
                (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_toplevel) =
    let ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
        ( _pbinds_abstracttps_collect,_pbinds_bimapimps_collect,_pbinds_constructors_collect,_pbinds_deps_collect,_pbinds_exports_collect,_pbinds_funimps_collect,_pbinds_genabs_collect,_pbinds_implications_collect,_pbinds_imports_collect,_pbinds_initialTypes,_pbinds_initialValues,_pbinds_methods_collect,_pbinds_nonrecs,_pbinds_pconsigs_col,_pbinds_pktcoll,_pbinds_ptscoll,_pbinds_rawrequest_collect,_pbinds_self) =
            (_pbinds (_name_abstracttps_collect)
                     (_name_bimapimps_collect)
                     (_lhs_classname)
                     (_lhs_consigs)
                     (_name_constructors_collect)
                     (_lhs_constructors_dist)
                     (_lhs_currentModule)
                     (_lhs_deps)
                     (_name_deps_collect)
                     (_lhs_exportedTypes)
                     (_lhs_exportedValues)
                     (_lhs_exports)
                     (_name_funimps_collect)
                     (_lhs_genabs)
                     (_name_genabs_collect)
                     (_lhs_hiddenTypes)
                     (_lhs_hiddenValues)
                     (_lhs_hiding)
                     (_name_implications_collect)
                     (_lhs_impliedTypes)
                     (_lhs_impliedValues)
                     (_lhs_importedModule)
                     (_lhs_importedTypes)
                     (_lhs_importedValues)
                     (_lhs_local)
                     (_name_methods_collect)
                     (_lhs_methods_dist)
                     (_lhs_pconsigs)
                     (_name_pconsigs_col)
                     (_name_pktcoll)
                     (_lhs_pktdist)
                     (_lhs_ptscoll)
                     (_lhs_ptsdist)
                     (_name_rawrequest_collect)
                     (_lhs_toplevel))
    in  (_pbinds_abstracttps_collect
        ,_pbinds_bimapimps_collect
        ,_pbinds_constructors_collect
        ,_pbinds_deps_collect
        ,_name_exports_collect ++ _pbinds_exports_collect
        ,_pbinds_funimps_collect
        ,_pbinds_genabs_collect
        ,_pbinds_implications_collect
        ,_name_imports_collect ++ _pbinds_imports_collect
        ,_name_initialTypes ++ _pbinds_initialTypes
        ,_name_initialValues ++ _pbinds_initialValues
        ,_pbinds_methods_collect
        ,_name_nonrecs ++ _pbinds_nonrecs
        ,_pbinds_pconsigs_col
        ,_pbinds_pktcoll
        ,_pbinds_ptscoll
        ,_pbinds_rawrequest_collect
        ,Pattern_Lab _name_self _pbinds_self
        )
sem_Pattern_List :: (T_Patterns) ->
                    (T_Pattern)
sem_Pattern_List (_patterns)
                 (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel) =
    let ( _patterns_abstracttps_collect
         ,_patterns_bimapimps_collect
         ,_patterns_constructors_collect
         ,_patterns_deps_collect
         ,_patterns_exports_collect
         ,_patterns_funimps_collect
         ,_patterns_genabs_collect
         ,_patterns_implications_collect
         ,_patterns_imports_collect
         ,_patterns_initialTypes
         ,_patterns_initialValues
         ,_patterns_methods_collect
         ,_patterns_nonrecs
         ,_patterns_pconsigs_col
         ,_patterns_pktcoll
         ,_patterns_ptscoll
         ,_patterns_rawrequest_collect
         ,_patterns_self
         ) =
            (_patterns (_lhs_abstracttps_collect)
                       (_lhs_bimapimps_collect)
                       (_lhs_classname)
                       (_lhs_consigs)
                       (_lhs_constructors_collect)
                       (_lhs_constructors_dist)
                       (_lhs_currentModule)
                       (_lhs_deps)
                       (_lhs_deps_collect)
                       (_lhs_exportedTypes)
                       (_lhs_exportedValues)
                       (_lhs_exports)
                       (_lhs_funimps_collect)
                       (_lhs_genabs)
                       (_lhs_genabs_collect)
                       (_lhs_hiddenTypes)
                       (_lhs_hiddenValues)
                       (_lhs_hiding)
                       (_lhs_implications_collect)
                       (_lhs_impliedTypes)
                       (_lhs_impliedValues)
                       (_lhs_importedModule)
                       (_lhs_importedTypes)
                       (_lhs_importedValues)
                       (_lhs_local)
                       (_lhs_methods_collect)
                       (_lhs_methods_dist)
                       (_lhs_pconsigs)
                       (_lhs_pconsigs_col)
                       (_lhs_pktcoll)
                       (_lhs_pktdist)
                       (_lhs_ptscoll)
                       (_lhs_ptsdist)
                       (_lhs_rawrequest_collect)
                       (_lhs_toplevel))
    in  (_patterns_abstracttps_collect
        ,_patterns_bimapimps_collect
        ,_patterns_constructors_collect
        ,_patterns_deps_collect
        ,_patterns_exports_collect
        ,_patterns_funimps_collect
        ,_patterns_genabs_collect
        ,_patterns_implications_collect
        ,_patterns_imports_collect
        ,_patterns_initialTypes
        ,_patterns_initialValues
        ,_patterns_methods_collect
        ,_patterns_nonrecs
        ,_patterns_pconsigs_col
        ,_patterns_pktcoll
        ,_patterns_ptscoll
        ,_patterns_rawrequest_collect
        ,Pattern_List  _patterns_self
        )
sem_Pattern_Lit :: (T_Literal) ->
                   (T_Pattern)
sem_Pattern_Lit (_name)
                (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_toplevel) =
    let ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_ptscoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_ptscoll,_name_rawrequest_collect,Pattern_Lit _name_self)
sem_Pattern_Negate :: (T_Pattern) ->
                      (T_Pattern)
sem_Pattern_Negate (_pattern)
                   (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel) =
    let ( _pattern_abstracttps_collect,_pattern_bimapimps_collect,_pattern_constructors_collect,_pattern_deps_collect,_pattern_exports_collect,_pattern_funimps_collect,_pattern_genabs_collect,_pattern_implications_collect,_pattern_imports_collect,_pattern_initialTypes,_pattern_initialValues,_pattern_methods_collect,_pattern_nonrecs,_pattern_pconsigs_col,_pattern_pktcoll,_pattern_ptscoll,_pattern_rawrequest_collect,_pattern_self) =
            (_pattern (_lhs_abstracttps_collect)
                      (_lhs_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_lhs_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_lhs_funimps_collect)
                      (_lhs_genabs)
                      (_lhs_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_lhs_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_pconsigs)
                      (_lhs_pconsigs_col)
                      (_lhs_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_ptscoll)
                      (_lhs_ptsdist)
                      (_lhs_rawrequest_collect)
                      (_lhs_toplevel))
    in  (_pattern_abstracttps_collect,_pattern_bimapimps_collect,_pattern_constructors_collect,_pattern_deps_collect,_pattern_exports_collect,_pattern_funimps_collect,_pattern_genabs_collect,_pattern_implications_collect,_pattern_imports_collect,_pattern_initialTypes,_pattern_initialValues,_pattern_methods_collect,_pattern_nonrecs,_pattern_pconsigs_col,_pattern_pktcoll,_pattern_ptscoll,_pattern_rawrequest_collect,Pattern_Negate _pattern_self)
sem_Pattern_OpApp :: (T_QualName) ->
                     (T_Pattern) ->
                     (T_Pattern) ->
                     (T_Pattern)
sem_Pattern_OpApp (_op)
                  (_left)
                  (_right)
                  (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_ptscoll)
                  (_lhs_ptsdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_toplevel) =
    let ( _op_abstracttps_collect,_op_bimapimps_collect,_op_constructors_collect,_op_deps_collect,_op_exports_collect,_op_funimps_collect,_op_genabs_collect,_op_implications_collect,_op_imports_collect,_op_initialTypes,_op_initialValues,_op_methods_collect,_op_nonrecs,_op_pconsigs_col,_op_pktcoll,_op_rawrequest_collect,_op_self) =
            (_op (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel))
        ( _left_abstracttps_collect,_left_bimapimps_collect,_left_constructors_collect,_left_deps_collect,_left_exports_collect,_left_funimps_collect,_left_genabs_collect,_left_implications_collect,_left_imports_collect,_left_initialTypes,_left_initialValues,_left_methods_collect,_left_nonrecs,_left_pconsigs_col,_left_pktcoll,_left_ptscoll,_left_rawrequest_collect,_left_self) =
            (_left (_op_abstracttps_collect)
                   (_op_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_op_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_op_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_op_funimps_collect)
                   (_lhs_genabs)
                   (_op_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_op_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_op_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_op_pconsigs_col)
                   (_op_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_op_rawrequest_collect)
                   (_lhs_toplevel))
        ( _right_abstracttps_collect,_right_bimapimps_collect,_right_constructors_collect,_right_deps_collect,_right_exports_collect,_right_funimps_collect,_right_genabs_collect,_right_implications_collect,_right_imports_collect,_right_initialTypes,_right_initialValues,_right_methods_collect,_right_nonrecs,_right_pconsigs_col,_right_pktcoll,_right_ptscoll,_right_rawrequest_collect,_right_self) =
            (_right (_left_abstracttps_collect)
                    (_left_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_left_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_left_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_left_funimps_collect)
                    (_lhs_genabs)
                    (_left_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_left_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_local)
                    (_left_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_pconsigs)
                    (_left_pconsigs_col)
                    (_left_pktcoll)
                    (_lhs_pktdist)
                    (_left_ptscoll)
                    (_lhs_ptsdist)
                    (_left_rawrequest_collect)
                    (_lhs_toplevel))
    in  (_right_abstracttps_collect
        ,_right_bimapimps_collect
        ,_right_constructors_collect
        ,_right_deps_collect
        ,_op_exports_collect ++ _left_exports_collect ++ _right_exports_collect
        ,_right_funimps_collect
        ,_right_genabs_collect
        ,_right_implications_collect
        ,_op_imports_collect ++ _left_imports_collect ++ _right_imports_collect
        ,_op_initialTypes ++ _left_initialTypes ++ _right_initialTypes
        ,_op_initialValues ++ _left_initialValues ++ _right_initialValues
        ,_right_methods_collect
        ,_op_nonrecs ++ _left_nonrecs ++ _right_nonrecs
        ,_right_pconsigs_col
        ,_right_pktcoll
        ,_right_ptscoll
        ,_right_rawrequest_collect
        ,Pattern_OpApp _op_self _left_self
                                _right_self
        )
sem_Pattern_Parens :: (T_Pattern) ->
                      (T_Pattern)
sem_Pattern_Parens (_pattern)
                   (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel) =
    let ( _pattern_abstracttps_collect,_pattern_bimapimps_collect,_pattern_constructors_collect,_pattern_deps_collect,_pattern_exports_collect,_pattern_funimps_collect,_pattern_genabs_collect,_pattern_implications_collect,_pattern_imports_collect,_pattern_initialTypes,_pattern_initialValues,_pattern_methods_collect,_pattern_nonrecs,_pattern_pconsigs_col,_pattern_pktcoll,_pattern_ptscoll,_pattern_rawrequest_collect,_pattern_self) =
            (_pattern (_lhs_abstracttps_collect)
                      (_lhs_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_lhs_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_lhs_funimps_collect)
                      (_lhs_genabs)
                      (_lhs_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_lhs_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_pconsigs)
                      (_lhs_pconsigs_col)
                      (_lhs_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_ptscoll)
                      (_lhs_ptsdist)
                      (_lhs_rawrequest_collect)
                      (_lhs_toplevel))
    in  (_pattern_abstracttps_collect,_pattern_bimapimps_collect,_pattern_constructors_collect,_pattern_deps_collect,_pattern_exports_collect,_pattern_funimps_collect,_pattern_genabs_collect,_pattern_implications_collect,_pattern_imports_collect,_pattern_initialTypes,_pattern_initialValues,_pattern_methods_collect,_pattern_nonrecs,_pattern_pconsigs_col,_pattern_pktcoll,_pattern_ptscoll,_pattern_rawrequest_collect,Pattern_Parens _pattern_self)
sem_Pattern_Tuple :: (T_Patterns) ->
                     (T_Pattern)
sem_Pattern_Tuple (_patterns)
                  (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_ptscoll)
                  (_lhs_ptsdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_toplevel) =
    let ( _patterns_abstracttps_collect
         ,_patterns_bimapimps_collect
         ,_patterns_constructors_collect
         ,_patterns_deps_collect
         ,_patterns_exports_collect
         ,_patterns_funimps_collect
         ,_patterns_genabs_collect
         ,_patterns_implications_collect
         ,_patterns_imports_collect
         ,_patterns_initialTypes
         ,_patterns_initialValues
         ,_patterns_methods_collect
         ,_patterns_nonrecs
         ,_patterns_pconsigs_col
         ,_patterns_pktcoll
         ,_patterns_ptscoll
         ,_patterns_rawrequest_collect
         ,_patterns_self
         ) =
            (_patterns (_lhs_abstracttps_collect)
                       (_lhs_bimapimps_collect)
                       (_lhs_classname)
                       (_lhs_consigs)
                       (_lhs_constructors_collect)
                       (_lhs_constructors_dist)
                       (_lhs_currentModule)
                       (_lhs_deps)
                       (_lhs_deps_collect)
                       (_lhs_exportedTypes)
                       (_lhs_exportedValues)
                       (_lhs_exports)
                       (_lhs_funimps_collect)
                       (_lhs_genabs)
                       (_lhs_genabs_collect)
                       (_lhs_hiddenTypes)
                       (_lhs_hiddenValues)
                       (_lhs_hiding)
                       (_lhs_implications_collect)
                       (_lhs_impliedTypes)
                       (_lhs_impliedValues)
                       (_lhs_importedModule)
                       (_lhs_importedTypes)
                       (_lhs_importedValues)
                       (_lhs_local)
                       (_lhs_methods_collect)
                       (_lhs_methods_dist)
                       (_lhs_pconsigs)
                       (_lhs_pconsigs_col)
                       (_lhs_pktcoll)
                       (_lhs_pktdist)
                       (_lhs_ptscoll)
                       (_lhs_ptsdist)
                       (_lhs_rawrequest_collect)
                       (_lhs_toplevel))
    in  (_patterns_abstracttps_collect
        ,_patterns_bimapimps_collect
        ,_patterns_constructors_collect
        ,_patterns_deps_collect
        ,_patterns_exports_collect
        ,_patterns_funimps_collect
        ,_patterns_genabs_collect
        ,_patterns_implications_collect
        ,_patterns_imports_collect
        ,_patterns_initialTypes
        ,_patterns_initialValues
        ,_patterns_methods_collect
        ,_patterns_nonrecs
        ,_patterns_pconsigs_col
        ,_patterns_pktcoll
        ,_patterns_ptscoll
        ,_patterns_rawrequest_collect
        ,Pattern_Tuple _patterns_self
        )
sem_Pattern_Var :: (T_QualName) ->
                   (T_Pattern)
sem_Pattern_Var (_name)
                (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_toplevel) =
    let ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_lhs_ptscoll,_name_rawrequest_collect,Pattern_Var _name_self)
sem_Pattern_Wild :: (T_Pattern)
sem_Pattern_Wild (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,Pattern_Wild)
-- Patterns ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      ptsdist              : FMap QualName PTS
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Patterns

-}
{-
   local variables for Patterns.Cons:

-}
{-
   local variables for Patterns.Nil:

-}
-- semantic domain
type T_Patterns = (Set QualName) ->
                  ([Request_BimapImply]) ->
                  (Maybe QualName) ->
                  (Consigs) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Modid) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Exports) ->
                  ([Request_FunImply]) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Bool) ->
                  ([Request_TypeImply]) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Bool) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Bool) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (PConsigs) ->
                  (PConsigs) ->
                  (FMap QualName PKT) ->
                  (FMap QualName PKT) ->
                  (FMap QualName PTS) ->
                  (FMap QualName PTS) ->
                  ([RawRequest]) ->
                  (Bool) ->
                  ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Patterns))
-- cata
sem_Patterns :: (Patterns) ->
                (T_Patterns)
sem_Patterns (list) =
    (foldr (sem_Patterns_Cons) (sem_Patterns_Nil) ((map sem_Pattern list)))
sem_Patterns_Cons :: (T_Pattern) ->
                     (T_Patterns) ->
                     (T_Patterns)
sem_Patterns_Cons (_hd)
                  (_tl)
                  (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_ptscoll)
                  (_lhs_ptsdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_toplevel) =
    let ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_methods_collect,_hd_nonrecs,_hd_pconsigs_col,_hd_pktcoll,_hd_ptscoll,_hd_rawrequest_collect,_hd_self) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_initialTypes,_tl_initialValues,_tl_methods_collect,_tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_ptscoll,_tl_rawrequest_collect,_tl_self) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_hd_ptscoll)
                 (_lhs_ptsdist)
                 (_hd_rawrequest_collect)
                 (_lhs_toplevel))
    in  (_tl_abstracttps_collect
        ,_tl_bimapimps_collect
        ,_tl_constructors_collect
        ,_tl_deps_collect
        ,_hd_exports_collect ++ _tl_exports_collect
        ,_tl_funimps_collect
        ,_tl_genabs_collect
        ,_tl_implications_collect
        ,_hd_imports_collect ++ _tl_imports_collect
        ,_hd_initialTypes ++ _tl_initialTypes
        ,_hd_initialValues ++ _tl_initialValues
        ,_tl_methods_collect
        ,_hd_nonrecs ++ _tl_nonrecs
        ,_tl_pconsigs_col
        ,_tl_pktcoll
        ,_tl_ptscoll
        ,_tl_rawrequest_collect
        ,_hd_self : _tl_self
        )
sem_Patterns_Nil :: (T_Patterns)
sem_Patterns_Nil (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,[])
-- Position ----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Position

-}
{-
   local variables for Position.Position:

-}
{-
   local variables for Position.Unknown:

-}
-- semantic domain
type T_Position = ((Position))
-- cata
sem_Position :: (Position) ->
                (T_Position)
sem_Position ((Position_Position (_filename) (_line) (_column))) =
    (sem_Position_Position (_filename) (_line) (_column))
sem_Position ((Position_Unknown )) =
    (sem_Position_Unknown )
sem_Position_Position :: (String) ->
                         (Int) ->
                         (Int) ->
                         (T_Position)
sem_Position_Position (_filename) (_line) (_column) =
    let 
    in  (Position_Position _filename _line _column)
sem_Position_Unknown :: (T_Position)
sem_Position_Unknown  =
    let 
    in  (Position_Unknown)
-- Qual --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Qual

-}
{-
   local variables for Qual.Empty:

-}
{-
   local variables for Qual.Gen:

-}
{-
   local variables for Qual.Guard:

-}
{-
   local variables for Qual.Let:

-}
-- semantic domain
type T_Qual = (Set QualName) ->
              ([Request_BimapImply]) ->
              (Maybe QualName) ->
              (Consigs) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Modid) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Set QualName) ->
              (Set QualName) ->
              (Exports) ->
              ([Request_FunImply]) ->
              (Set QualName) ->
              (Set QualName) ->
              (Set QualName) ->
              (Set QualName) ->
              (Bool) ->
              ([Request_TypeImply]) ->
              (Set QualName) ->
              (Set QualName) ->
              (Bool) ->
              (Set QualName) ->
              (Set QualName) ->
              (KSubst) ->
              (KSubst) ->
              (Int) ->
              (KSubst) ->
              (Bool) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Set Modid) ->
              (PConsigs) ->
              (PConsigs) ->
              (FMap QualName PKT) ->
              (FMap QualName PKT) ->
              (KSubst) ->
              (FMap QualName PTS) ->
              (FMap QualName PTS) ->
              ([RawRequest]) ->
              ([RawRequest]) ->
              (Bool) ->
              (Int) ->
              ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Qual))
-- cata
sem_Qual :: (Qual) ->
            (T_Qual)
sem_Qual ((Qual_Empty )) =
    (sem_Qual_Empty )
sem_Qual ((Qual_Gen (_pattern) (_body))) =
    (sem_Qual_Gen ((sem_Pattern (_pattern))) ((sem_Expr (_body))))
sem_Qual ((Qual_Guard (_expr))) =
    (sem_Qual_Guard ((sem_Expr (_expr))))
sem_Qual ((Qual_Let (_decls))) =
    (sem_Qual_Let ((sem_SDecls (_decls))))
sem_Qual_Empty :: (T_Qual)
sem_Qual_Empty (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_kinames)
               (_lhs_kinds)
               (_lhs_kindvar)
               (_lhs_ksubst)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_modules)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_prekind)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_requests_gas)
               (_lhs_toplevel)
               (_lhs_verbosity) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_kinames,_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,Qual_Empty)
sem_Qual_Gen :: (T_Pattern) ->
                (T_Expr) ->
                (T_Qual)
sem_Qual_Gen (_pattern)
             (_body)
             (_lhs_abstracttps_collect)
             (_lhs_bimapimps_collect)
             (_lhs_classname)
             (_lhs_consigs)
             (_lhs_constructors_collect)
             (_lhs_constructors_dist)
             (_lhs_currentModule)
             (_lhs_deps)
             (_lhs_deps_collect)
             (_lhs_exportedTypes)
             (_lhs_exportedValues)
             (_lhs_exports)
             (_lhs_funimps_collect)
             (_lhs_genabs)
             (_lhs_genabs_collect)
             (_lhs_hiddenTypes)
             (_lhs_hiddenValues)
             (_lhs_hiding)
             (_lhs_implications_collect)
             (_lhs_impliedTypes)
             (_lhs_impliedValues)
             (_lhs_importedModule)
             (_lhs_importedTypes)
             (_lhs_importedValues)
             (_lhs_kinames)
             (_lhs_kinds)
             (_lhs_kindvar)
             (_lhs_ksubst)
             (_lhs_local)
             (_lhs_methods_collect)
             (_lhs_methods_dist)
             (_lhs_modules)
             (_lhs_pconsigs)
             (_lhs_pconsigs_col)
             (_lhs_pktcoll)
             (_lhs_pktdist)
             (_lhs_prekind)
             (_lhs_ptscoll)
             (_lhs_ptsdist)
             (_lhs_rawrequest_collect)
             (_lhs_requests_gas)
             (_lhs_toplevel)
             (_lhs_verbosity) =
    let ( _pattern_abstracttps_collect,_pattern_bimapimps_collect,_pattern_constructors_collect,_pattern_deps_collect,_pattern_exports_collect,_pattern_funimps_collect,_pattern_genabs_collect,_pattern_implications_collect,_pattern_imports_collect,_pattern_initialTypes,_pattern_initialValues,_pattern_methods_collect,_pattern_nonrecs,_pattern_pconsigs_col,_pattern_pktcoll,_pattern_ptscoll,_pattern_rawrequest_collect,_pattern_self) =
            (_pattern (_lhs_abstracttps_collect)
                      (_lhs_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_lhs_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_lhs_funimps_collect)
                      (_lhs_genabs)
                      (_lhs_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_lhs_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_pconsigs)
                      (_lhs_pconsigs_col)
                      (_lhs_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_ptscoll)
                      (_lhs_ptsdist)
                      (_lhs_rawrequest_collect)
                      (_lhs_toplevel))
        ( _body_abstracttps_collect,_body_bimapimps_collect,_body_constructors_collect,_body_deps_collect,_body_exports_collect,_body_funimps_collect,_body_genabs_collect,_body_implications_collect,_body_imports_collect,_body_initialTypes,_body_initialValues,_body_kinames,_body_kindvar,_body_ksubst,_body_linkname,_body_methods_collect,_body_nonrecs,_body_pconsigs_col,_body_pktcoll,_body_ptscoll,_body_rawrequest_collect,_body_self) =
            (_body (_pattern_abstracttps_collect)
                   (_pattern_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_pattern_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_pattern_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_pattern_funimps_collect)
                   (_lhs_genabs)
                   (_pattern_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_pattern_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_pattern_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_pattern_pconsigs_col)
                   (_pattern_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_pattern_ptscoll)
                   (_lhs_ptsdist)
                   (_pattern_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_body_abstracttps_collect
        ,_body_bimapimps_collect
        ,_body_constructors_collect
        ,_body_deps_collect
        ,_pattern_exports_collect ++ _body_exports_collect
        ,_body_funimps_collect
        ,_body_genabs_collect
        ,_body_implications_collect
        ,_pattern_imports_collect ++ _body_imports_collect
        ,_pattern_initialTypes ++ _body_initialTypes
        ,_pattern_initialValues ++ _body_initialValues
        ,_body_kinames
        ,_body_kindvar
        ,_body_ksubst
        ,_body_methods_collect
        ,_pattern_nonrecs ++ _body_nonrecs
        ,_body_pconsigs_col
        ,_body_pktcoll
        ,_body_ptscoll
        ,_body_rawrequest_collect
        ,Qual_Gen _pattern_self _body_self
        )
sem_Qual_Guard :: (T_Expr) ->
                  (T_Qual)
sem_Qual_Guard (_expr)
               (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_kinames)
               (_lhs_kinds)
               (_lhs_kindvar)
               (_lhs_ksubst)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_modules)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_prekind)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_requests_gas)
               (_lhs_toplevel)
               (_lhs_verbosity) =
    let ( _expr_abstracttps_collect,_expr_bimapimps_collect,_expr_constructors_collect,_expr_deps_collect,_expr_exports_collect,_expr_funimps_collect,_expr_genabs_collect,_expr_implications_collect,_expr_imports_collect,_expr_initialTypes,_expr_initialValues,_expr_kinames,_expr_kindvar,_expr_ksubst,_expr_linkname,_expr_methods_collect,_expr_nonrecs,_expr_pconsigs_col,_expr_pktcoll,_expr_ptscoll,_expr_rawrequest_collect,_expr_self) =
            (_expr (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_expr_abstracttps_collect,_expr_bimapimps_collect,_expr_constructors_collect,_expr_deps_collect,_expr_exports_collect,_expr_funimps_collect,_expr_genabs_collect,_expr_implications_collect,_expr_imports_collect,_expr_initialTypes,_expr_initialValues,_expr_kinames,_expr_kindvar,_expr_ksubst,_expr_methods_collect,_expr_nonrecs,_expr_pconsigs_col,_expr_pktcoll,_expr_ptscoll,_expr_rawrequest_collect,Qual_Guard _expr_self)
sem_Qual_Let :: (T_SDecls) ->
                (T_Qual)
sem_Qual_Let (_decls)
             (_lhs_abstracttps_collect)
             (_lhs_bimapimps_collect)
             (_lhs_classname)
             (_lhs_consigs)
             (_lhs_constructors_collect)
             (_lhs_constructors_dist)
             (_lhs_currentModule)
             (_lhs_deps)
             (_lhs_deps_collect)
             (_lhs_exportedTypes)
             (_lhs_exportedValues)
             (_lhs_exports)
             (_lhs_funimps_collect)
             (_lhs_genabs)
             (_lhs_genabs_collect)
             (_lhs_hiddenTypes)
             (_lhs_hiddenValues)
             (_lhs_hiding)
             (_lhs_implications_collect)
             (_lhs_impliedTypes)
             (_lhs_impliedValues)
             (_lhs_importedModule)
             (_lhs_importedTypes)
             (_lhs_importedValues)
             (_lhs_kinames)
             (_lhs_kinds)
             (_lhs_kindvar)
             (_lhs_ksubst)
             (_lhs_local)
             (_lhs_methods_collect)
             (_lhs_methods_dist)
             (_lhs_modules)
             (_lhs_pconsigs)
             (_lhs_pconsigs_col)
             (_lhs_pktcoll)
             (_lhs_pktdist)
             (_lhs_prekind)
             (_lhs_ptscoll)
             (_lhs_ptsdist)
             (_lhs_rawrequest_collect)
             (_lhs_requests_gas)
             (_lhs_toplevel)
             (_lhs_verbosity) =
    let ( _decls_abstracttps_collect
         ,_decls_bimapimps_collect
         ,_decls_constructors_collect
         ,_decls_count
         ,_decls_deps_collect
         ,_decls_exports_collect
         ,_decls_funimps_collect
         ,_decls_genabs_collect
         ,_decls_implications_collect
         ,_decls_imports_collect
         ,_decls_initialTypes
         ,_decls_initialValues
         ,_decls_kinames
         ,_decls_kindvar
         ,_decls_ksubst
         ,_decls_methods_collect
         ,_decls_nil
         ,_decls_nonrecs
         ,_decls_pconsigs_col
         ,_decls_pktcoll
         ,_decls_ptscoll
         ,_decls_rawrequest_collect
         ,_decls_self
         ) =
            (_decls (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_kinames)
                    (_lhs_kinds)
                    (_lhs_kindvar)
                    (_lhs_ksubst)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_lhs_ptscoll)
                    (_lhs_ptsdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_toplevel)
                    (_lhs_verbosity))
    in  (_decls_abstracttps_collect,_decls_bimapimps_collect,_decls_constructors_collect,_decls_deps_collect,_decls_exports_collect,_decls_funimps_collect,_decls_genabs_collect,_decls_implications_collect,_decls_imports_collect,_decls_initialTypes,_decls_initialValues,_decls_kinames,_decls_kindvar,_decls_ksubst,_decls_methods_collect,_decls_nonrecs,_decls_pconsigs_col,_decls_pktcoll,_decls_ptscoll,_decls_rawrequest_collect,Qual_Let _decls_self)
-- QualName ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : QualName

-}
{-
   local variables for QualName.Entity:
      self

-}
{-
   local variables for QualName.Plain:
      self

-}
{-
   local variables for QualName.Qual:
      self

-}
-- semantic domain
type T_QualName = (Set QualName) ->
                  ([Request_BimapImply]) ->
                  (Maybe QualName) ->
                  (Consigs) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Modid) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Exports) ->
                  ([Request_FunImply]) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Bool) ->
                  ([Request_TypeImply]) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Bool) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Bool) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (PConsigs) ->
                  (PConsigs) ->
                  (FMap QualName PKT) ->
                  (FMap QualName PKT) ->
                  ([RawRequest]) ->
                  (Bool) ->
                  ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),([RawRequest]),(QualName))
-- cata
sem_QualName :: (QualName) ->
                (T_QualName)
sem_QualName ((QualName_Entity (_range) (_entity) (_inscope))) =
    (sem_QualName_Entity ((sem_Range (_range))) ((sem_Entity (_entity))) (_inscope))
sem_QualName ((QualName_Plain (_range) (_name))) =
    (sem_QualName_Plain ((sem_Range (_range))) ((sem_Name (_name))))
sem_QualName ((QualName_Qual (_range) (_modid) (_name))) =
    (sem_QualName_Qual ((sem_Range (_range))) (_modid) ((sem_Name (_name))))
sem_QualName_Entity :: (T_Range) ->
                       (T_Entity) ->
                       (Maybe QualName) ->
                       (T_QualName)
sem_QualName_Entity (_range)
                    (_entity)
                    (_inscope)
                    (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_toplevel) =
    let (_self) =
            QualName_Entity _range_self _entity_self _inscope
        ( _range_self) =
            (_range )
        ( _entity_abstracttps_collect,_entity_bimapimps_collect,_entity_constructors_collect,_entity_deps_collect,_entity_exports_collect,_entity_funimps_collect,_entity_genabs_collect,_entity_implications_collect,_entity_imports_collect,_entity_initialTypes,_entity_initialValues,_entity_methods_collect,_entity_nonrecs,_entity_pconsigs_col,_entity_pktcoll,_entity_rawrequest_collect,_entity_self) =
            (_entity (_lhs_abstracttps_collect)
                     (_lhs_bimapimps_collect)
                     (_lhs_classname)
                     (_lhs_consigs)
                     (_lhs_constructors_collect)
                     (_lhs_constructors_dist)
                     (_lhs_currentModule)
                     (_lhs_deps)
                     (_lhs_deps_collect)
                     (_lhs_exportedTypes)
                     (_lhs_exportedValues)
                     (_lhs_exports)
                     (_lhs_funimps_collect)
                     (_lhs_genabs)
                     (_lhs_genabs_collect)
                     (_lhs_hiddenTypes)
                     (_lhs_hiddenValues)
                     (_lhs_hiding)
                     (_lhs_implications_collect)
                     (_lhs_impliedTypes)
                     (_lhs_impliedValues)
                     (_lhs_importedModule)
                     (_lhs_importedTypes)
                     (_lhs_importedValues)
                     (_lhs_local)
                     (_lhs_methods_collect)
                     (_lhs_methods_dist)
                     (_lhs_pconsigs)
                     (_lhs_pconsigs_col)
                     (_lhs_pktcoll)
                     (_lhs_pktdist)
                     (_lhs_rawrequest_collect)
                     (_lhs_toplevel))
    in  (_entity_abstracttps_collect,_entity_bimapimps_collect,_entity_constructors_collect,_entity_deps_collect,_entity_exports_collect,_entity_funimps_collect,_entity_genabs_collect,_entity_implications_collect,_entity_imports_collect,_entity_initialTypes,_entity_initialValues,_entity_methods_collect,_entity_nonrecs,_entity_pconsigs_col,_entity_pktcoll,_entity_rawrequest_collect,_self)
sem_QualName_Plain :: (T_Range) ->
                      (T_Name) ->
                      (T_QualName)
sem_QualName_Plain (_range)
                   (_name)
                   (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel) =
    let (_self) =
            QualName_Plain  _range_self        _name_self
        ( _range_self) =
            (_range )
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_self)
sem_QualName_Qual :: (T_Range) ->
                     (Modid) ->
                     (T_Name) ->
                     (T_QualName)
sem_QualName_Qual (_range)
                  (_modid)
                  (_name)
                  (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_toplevel) =
    let (_self) =
            QualName_Qual   _range_self _modid _name_self
        ( _range_self) =
            (_range )
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_self)
-- QualNames ---------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : QualNames

-}
{-
   local variables for QualNames.Cons:

-}
{-
   local variables for QualNames.Nil:

-}
-- semantic domain
type T_QualNames = (Set QualName) ->
                   ([Request_BimapImply]) ->
                   (Maybe QualName) ->
                   (Consigs) ->
                   (FMap QualName QualNames) ->
                   (FMap QualName QualNames) ->
                   (Modid) ->
                   (FMap QualName QualNames) ->
                   (FMap QualName QualNames) ->
                   (Set QualName) ->
                   (Set QualName) ->
                   (Exports) ->
                   ([Request_FunImply]) ->
                   (Set QualName) ->
                   (Set QualName) ->
                   (Set QualName) ->
                   (Set QualName) ->
                   (Bool) ->
                   ([Request_TypeImply]) ->
                   (Set QualName) ->
                   (Set QualName) ->
                   (Bool) ->
                   (Set QualName) ->
                   (Set QualName) ->
                   (Bool) ->
                   (FMap QualName QualNames) ->
                   (FMap QualName QualNames) ->
                   (PConsigs) ->
                   (PConsigs) ->
                   (FMap QualName PKT) ->
                   (FMap QualName PKT) ->
                   ([RawRequest]) ->
                   (Bool) ->
                   ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),([RawRequest]),(QualNames))
-- cata
sem_QualNames :: (QualNames) ->
                 (T_QualNames)
sem_QualNames (list) =
    (foldr (sem_QualNames_Cons) (sem_QualNames_Nil) ((map sem_QualName list)))
sem_QualNames_Cons :: (T_QualName) ->
                      (T_QualNames) ->
                      (T_QualNames)
sem_QualNames_Cons (_hd)
                   (_tl)
                   (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel) =
    let ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_methods_collect,_hd_nonrecs,_hd_pconsigs_col,_hd_pktcoll,_hd_rawrequest_collect,_hd_self) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_initialTypes,_tl_initialValues,_tl_methods_collect,_tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_rawrequest_collect,_tl_self) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_hd_rawrequest_collect)
                 (_lhs_toplevel))
    in  (_tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_hd_exports_collect ++ _tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_hd_imports_collect ++ _tl_imports_collect,_hd_initialTypes ++ _tl_initialTypes,_hd_initialValues ++ _tl_initialValues,_tl_methods_collect,_hd_nonrecs ++ _tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_rawrequest_collect,_hd_self : _tl_self)
sem_QualNames_Nil :: (T_QualNames)
sem_QualNames_Nil (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_rawrequest_collect,[])
-- QualType ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      kind_errors          : [GHError]
      nonrecs              : [TypedBinding]
      self                 : QualType

-}
{-
   local variables for QualType.QualType:

-}
-- semantic domain
type T_QualType = (Set QualName) ->
                  ([Request_BimapImply]) ->
                  (Maybe QualName) ->
                  (Consigs) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Modid) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Exports) ->
                  ([Request_FunImply]) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Bool) ->
                  ([Request_TypeImply]) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (Bool) ->
                  (Set QualName) ->
                  (Set QualName) ->
                  (KSubst) ->
                  (Int) ->
                  (KSubst) ->
                  (Bool) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (PConsigs) ->
                  (PConsigs) ->
                  (FMap QualName PKT) ->
                  (FMap QualName PKT) ->
                  (KSubst) ->
                  (FMap QualName PTS) ->
                  (FMap QualName PTS) ->
                  ([RawRequest]) ->
                  (Bool) ->
                  ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),([GHError]),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(QualType))
-- cata
sem_QualType :: (QualType) ->
                (T_QualType)
sem_QualType ((QualType_QualType (_context) (_tp))) =
    (sem_QualType_QualType ((sem_Context (_context))) ((sem_Type (_tp))))
sem_QualType_QualType :: (T_Context) ->
                         (T_Type) ->
                         (T_QualType)
sem_QualType_QualType (_context)
                      (_tp)
                      (_lhs_abstracttps_collect)
                      (_lhs_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_lhs_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_lhs_funimps_collect)
                      (_lhs_genabs)
                      (_lhs_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_lhs_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_lhs_kinames)
                      (_lhs_kindvar)
                      (_lhs_ksubst)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_pconsigs)
                      (_lhs_pconsigs_col)
                      (_lhs_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_prekind)
                      (_lhs_ptscoll)
                      (_lhs_ptsdist)
                      (_lhs_rawrequest_collect)
                      (_lhs_toplevel) =
    let ( _context_abstracttps_collect
         ,_context_bimapimps_collect
         ,_context_constructors_collect
         ,_context_deps_collect
         ,_context_exports_collect
         ,_context_funimps_collect
         ,_context_genabs_collect
         ,_context_implications_collect
         ,_context_imports_collect
         ,_context_initialTypes
         ,_context_initialValues
         ,_context_kinames
         ,_context_kindvar
         ,_context_ksubst
         ,_context_methods_collect
         ,_context_nonrecs
         ,_context_pconsigs_col
         ,_context_pktcoll
         ,_context_ptscoll
         ,_context_rawrequest_collect
         ,_context_self
         ) =
            (_context (_lhs_abstracttps_collect)
                      (_lhs_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_lhs_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_lhs_funimps_collect)
                      (_lhs_genabs)
                      (_lhs_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_lhs_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_lhs_kinames)
                      (_lhs_kindvar)
                      (_lhs_ksubst)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_pconsigs)
                      (_lhs_pconsigs_col)
                      (_lhs_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_prekind)
                      (_lhs_ptscoll)
                      (_lhs_ptsdist)
                      (_lhs_rawrequest_collect)
                      (_lhs_toplevel))
        ( _tp_abstracttps_collect,_tp_bimapimps_collect,_tp_constructors_collect,_tp_deps_collect,_tp_exports_collect,_tp_funimps_collect,_tp_genabs_collect,_tp_implications_collect,_tp_imports_collect,_tp_inferkind,_tp_initialTypes,_tp_initialValues,_tp_kinames,_tp_kind_errors,_tp_kindvar,_tp_kloc,_tp_ksubst,_tp_methods_collect,_tp_nonrecs,_tp_pconsigs_col,_tp_pktcoll,_tp_ptscoll,_tp_rawrequest_collect,_tp_self) =
            (_tp (_context_abstracttps_collect)
                 (_context_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_context_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_context_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_context_funimps_collect)
                 (_lhs_genabs)
                 (_context_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_context_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_context_kinames)
                 (_context_kindvar)
                 (_context_ksubst)
                 (_lhs_local)
                 (_context_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_context_pconsigs_col)
                 (_context_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_context_ptscoll)
                 (_lhs_ptsdist)
                 (_context_rawrequest_collect)
                 (_lhs_toplevel))
    in  (_tp_abstracttps_collect
        ,_tp_bimapimps_collect
        ,_tp_constructors_collect
        ,_tp_deps_collect
        ,_context_exports_collect ++ _tp_exports_collect
        ,_tp_funimps_collect
        ,_tp_genabs_collect
        ,_tp_implications_collect
        ,_context_imports_collect ++ _tp_imports_collect
        ,_context_initialTypes ++ _tp_initialTypes
        ,_context_initialValues ++ _tp_initialValues
        ,_tp_kinames
        ,_tp_kind_errors
        ,_tp_kindvar
        ,_tp_ksubst
        ,_tp_methods_collect
        ,_context_nonrecs ++ _tp_nonrecs
        ,_tp_pconsigs_col
        ,_tp_pktcoll
        ,_tp_ptscoll
        ,_tp_rawrequest_collect
        ,QualType_QualType _context_self _tp_self
        )
-- Quals -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Quals

-}
{-
   local variables for Quals.Cons:

-}
{-
   local variables for Quals.Nil:

-}
-- semantic domain
type T_Quals = (Set QualName) ->
               ([Request_BimapImply]) ->
               (Maybe QualName) ->
               (Consigs) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Set QualName) ->
               (Set QualName) ->
               (Exports) ->
               ([Request_FunImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               ([Request_TypeImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               (Set QualName) ->
               (Set QualName) ->
               (KSubst) ->
               (KSubst) ->
               (Int) ->
               (KSubst) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Set Modid) ->
               (PConsigs) ->
               (PConsigs) ->
               (FMap QualName PKT) ->
               (FMap QualName PKT) ->
               (KSubst) ->
               (FMap QualName PTS) ->
               (FMap QualName PTS) ->
               ([RawRequest]) ->
               ([RawRequest]) ->
               (Bool) ->
               (Int) ->
               ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Quals))
-- cata
sem_Quals :: (Quals) ->
             (T_Quals)
sem_Quals (list) =
    (foldr (sem_Quals_Cons) (sem_Quals_Nil) ((map sem_Qual list)))
sem_Quals_Cons :: (T_Qual) ->
                  (T_Quals) ->
                  (T_Quals)
sem_Quals_Cons (_hd)
               (_tl)
               (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_kinames)
               (_lhs_kinds)
               (_lhs_kindvar)
               (_lhs_ksubst)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_modules)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_prekind)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_requests_gas)
               (_lhs_toplevel)
               (_lhs_verbosity) =
    let ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_kinames,_hd_kindvar,_hd_ksubst,_hd_methods_collect,_hd_nonrecs,_hd_pconsigs_col,_hd_pktcoll,_hd_ptscoll,_hd_rawrequest_collect,_hd_self) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kinds)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_initialTypes,_tl_initialValues,_tl_kinames,_tl_kindvar,_tl_ksubst,_tl_methods_collect,_tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_ptscoll,_tl_rawrequest_collect,_tl_self) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_hd_kinames)
                 (_lhs_kinds)
                 (_hd_kindvar)
                 (_hd_ksubst)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_hd_ptscoll)
                 (_lhs_ptsdist)
                 (_hd_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
    in  (_tl_abstracttps_collect
        ,_tl_bimapimps_collect
        ,_tl_constructors_collect
        ,_tl_deps_collect
        ,_hd_exports_collect ++ _tl_exports_collect
        ,_tl_funimps_collect
        ,_tl_genabs_collect
        ,_tl_implications_collect
        ,_hd_imports_collect ++ _tl_imports_collect
        ,_hd_initialTypes ++ _tl_initialTypes
        ,_hd_initialValues ++ _tl_initialValues
        ,_tl_kinames
        ,_tl_kindvar
        ,_tl_ksubst
        ,_tl_methods_collect
        ,_hd_nonrecs ++ _tl_nonrecs
        ,_tl_pconsigs_col
        ,_tl_pktcoll
        ,_tl_ptscoll
        ,_tl_rawrequest_collect
        ,_hd_self : _tl_self
        )
sem_Quals_Nil :: (T_Quals)
sem_Quals_Nil (_lhs_abstracttps_collect)
              (_lhs_bimapimps_collect)
              (_lhs_classname)
              (_lhs_consigs)
              (_lhs_constructors_collect)
              (_lhs_constructors_dist)
              (_lhs_currentModule)
              (_lhs_deps)
              (_lhs_deps_collect)
              (_lhs_exportedTypes)
              (_lhs_exportedValues)
              (_lhs_exports)
              (_lhs_funimps_collect)
              (_lhs_genabs)
              (_lhs_genabs_collect)
              (_lhs_hiddenTypes)
              (_lhs_hiddenValues)
              (_lhs_hiding)
              (_lhs_implications_collect)
              (_lhs_impliedTypes)
              (_lhs_impliedValues)
              (_lhs_importedModule)
              (_lhs_importedTypes)
              (_lhs_importedValues)
              (_lhs_kinames)
              (_lhs_kinds)
              (_lhs_kindvar)
              (_lhs_ksubst)
              (_lhs_local)
              (_lhs_methods_collect)
              (_lhs_methods_dist)
              (_lhs_modules)
              (_lhs_pconsigs)
              (_lhs_pconsigs_col)
              (_lhs_pktcoll)
              (_lhs_pktdist)
              (_lhs_prekind)
              (_lhs_ptscoll)
              (_lhs_ptsdist)
              (_lhs_rawrequest_collect)
              (_lhs_requests_gas)
              (_lhs_toplevel)
              (_lhs_verbosity) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_kinames,_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,[])
-- Range -------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Range

-}
{-
   local variables for Range.Range:

-}
-- semantic domain
type T_Range = ((Range))
-- cata
sem_Range :: (Range) ->
             (T_Range)
sem_Range ((Range_Range (_start) (_stop))) =
    (sem_Range_Range ((sem_Position (_start))) ((sem_Position (_stop))))
sem_Range_Range :: (T_Position) ->
                   (T_Position) ->
                   (T_Range)
sem_Range_Range (_start) (_stop) =
    let ( _start_self) =
            (_start )
        ( _stop_self) =
            (_stop )
    in  (Range_Range _start_self _stop_self)
-- Rhs ---------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      linkname             : Maybe QualName
      nonrecs              : [TypedBinding]
      self                 : Rhs

-}
{-
   local variables for Rhs.Guarded:

-}
{-
   local variables for Rhs.Unguarded:

-}
-- semantic domain
type T_Rhs = (Set QualName) ->
             ([Request_BimapImply]) ->
             (Maybe QualName) ->
             (Consigs) ->
             (FMap QualName QualNames) ->
             (FMap QualName QualNames) ->
             (Modid) ->
             (FMap QualName QualNames) ->
             (FMap QualName QualNames) ->
             (Set QualName) ->
             (Set QualName) ->
             (Exports) ->
             ([Request_FunImply]) ->
             (Set QualName) ->
             (Set QualName) ->
             (Set QualName) ->
             (Set QualName) ->
             (Bool) ->
             ([Request_TypeImply]) ->
             (Set QualName) ->
             (Set QualName) ->
             (Bool) ->
             (Set QualName) ->
             (Set QualName) ->
             (KSubst) ->
             (KSubst) ->
             (Int) ->
             (KSubst) ->
             (Bool) ->
             (FMap QualName QualNames) ->
             (FMap QualName QualNames) ->
             (Set Modid) ->
             (PConsigs) ->
             (PConsigs) ->
             (FMap QualName PKT) ->
             (FMap QualName PKT) ->
             (KSubst) ->
             (FMap QualName PTS) ->
             (FMap QualName PTS) ->
             ([RawRequest]) ->
             ([RawRequest]) ->
             (Bool) ->
             (Int) ->
             ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(Maybe QualName),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Rhs))
-- cata
sem_Rhs :: (Rhs) ->
           (T_Rhs)
sem_Rhs ((Rhs_Guarded (_grds))) =
    (sem_Rhs_Guarded ((sem_GuardedRhss (_grds))))
sem_Rhs ((Rhs_Unguarded (_expr))) =
    (sem_Rhs_Unguarded ((sem_Expr (_expr))))
sem_Rhs_Guarded :: (T_GuardedRhss) ->
                   (T_Rhs)
sem_Rhs_Guarded (_grds)
                (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_kinames)
                (_lhs_kinds)
                (_lhs_kindvar)
                (_lhs_ksubst)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_modules)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_prekind)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_requests_gas)
                (_lhs_toplevel)
                (_lhs_verbosity) =
    let ( _grds_abstracttps_collect,_grds_bimapimps_collect,_grds_constructors_collect,_grds_deps_collect,_grds_exports_collect,_grds_funimps_collect,_grds_genabs_collect,_grds_implications_collect,_grds_imports_collect,_grds_initialTypes,_grds_initialValues,_grds_kinames,_grds_kindvar,_grds_ksubst,_grds_linkname,_grds_methods_collect,_grds_nonrecs,_grds_pconsigs_col,_grds_pktcoll,_grds_ptscoll,_grds_rawrequest_collect,_grds_self) =
            (_grds (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_grds_abstracttps_collect,_grds_bimapimps_collect,_grds_constructors_collect,_grds_deps_collect,_grds_exports_collect,_grds_funimps_collect,_grds_genabs_collect,_grds_implications_collect,_grds_imports_collect,_grds_initialTypes,_grds_initialValues,_grds_kinames,_grds_kindvar,_grds_ksubst,_grds_linkname,_grds_methods_collect,_grds_nonrecs,_grds_pconsigs_col,_grds_pktcoll,_grds_ptscoll,_grds_rawrequest_collect,Rhs_Guarded _grds_self)
sem_Rhs_Unguarded :: (T_Expr) ->
                     (T_Rhs)
sem_Rhs_Unguarded (_expr)
                  (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_kinames)
                  (_lhs_kinds)
                  (_lhs_kindvar)
                  (_lhs_ksubst)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_modules)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_prekind)
                  (_lhs_ptscoll)
                  (_lhs_ptsdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_requests_gas)
                  (_lhs_toplevel)
                  (_lhs_verbosity) =
    let ( _expr_abstracttps_collect,_expr_bimapimps_collect,_expr_constructors_collect,_expr_deps_collect,_expr_exports_collect,_expr_funimps_collect,_expr_genabs_collect,_expr_implications_collect,_expr_imports_collect,_expr_initialTypes,_expr_initialValues,_expr_kinames,_expr_kindvar,_expr_ksubst,_expr_linkname,_expr_methods_collect,_expr_nonrecs,_expr_pconsigs_col,_expr_pktcoll,_expr_ptscoll,_expr_rawrequest_collect,_expr_self) =
            (_expr (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_expr_abstracttps_collect,_expr_bimapimps_collect,_expr_constructors_collect,_expr_deps_collect,_expr_exports_collect,_expr_funimps_collect,_expr_genabs_collect,_expr_implications_collect,_expr_imports_collect,_expr_initialTypes,_expr_initialValues,_expr_kinames,_expr_kindvar,_expr_ksubst,_expr_linkname,_expr_methods_collect,_expr_nonrecs,_expr_pconsigs_col,_expr_pktcoll,_expr_ptscoll,_expr_rawrequest_collect,Rhs_Unguarded _expr_self)
-- Root --------------------------------------------------------
{-
   inherited attributes:
      in                   : (Int,Int,Set QualName,Set QualName,[(Set QualName,Set QualName)],[(Set QualName,Set QualName)],Set Modid)

   chained attributes:

   synthesised attributes:
      output               : (String,Bool,String,String,String)

-}
{-
   local variables for Root.Root:
      nonrecs
      requests_t
      requests
      requests_components_t
      requests_components
      requests_gas
      request_errors
      nonterm_error
      calc_rto
      calc_rtc
      calc_ro
      calc_rc
      calc_rt
      calc_rn
      calc_mpcs
      calc_gas
      rest_it
      rawrequests
      consigs
      pktdist
      ptsdist
      kinds
      prekind
      outputi
      calc_tps
      calc_vals
      ex_rest_it
      output
      specs_t
      specs
      reqstop
      reqerrors
      reqoutput
      deps
      kistop
      kierrors
      kioutput
      expoutput
      imp_pkts
      imp_ptss
      imp_strtypes
      imp_kinds
      modules
      hiddenEntities
      importedEntities
      exportedTypes
      exportedValues
      max_it
      verbosity

-}
-- semantic domain
type T_Root = ((Int,Int,Set QualName,Set QualName,[(Set QualName,Set QualName)],[(Set QualName,Set QualName)],Set Modid)) ->
              (((String,Bool,String,String,String)))
-- cata
sem_Root :: (Root) ->
            (T_Root)
sem_Root ((Root_Root (_contents))) =
    (sem_Root_Root ((sem_ModuleSystem (_contents))))
sem_Root_Root :: (T_ModuleSystem) ->
                 (T_Root)
sem_Root_Root (_contents) (_lhs_in) =
    let ((_verbosity,_max_it,_exportedValues,_exportedTypes,_importedEntities,_hiddenEntities,_modules)) =
            _lhs_in
        ((_imp_kinds,_imp_strtypes,_imp_ptss,_imp_pkts)) =
            ( internalError "GH.Root.Root.imp_kinds"
            , internalError "GH.Root.Root.imp_strtypes"
            , internalError "GH.Root.Root.imp_ptss"
            , internalError "GH.Root.Root.imp_pkts"
            )
        (_expoutput) =
            ( if   _verbosity >= 3
              then "\nInitial types from source:\n"
                ++ unlines (map (pretty . PP.ppQualName True) _contents_initialTypes)
                ++ "\nInitial values from source:\n"
                ++ unlines (map (pretty . PP.ppQualName True) _contents_initialValues)
                ++ "\nImplied types:\n"
                ++ unlines (map (pretty . PP.ppQualName True) _calc_tps)
                ++ "\nImplied values:\n"
                ++ unlines (map (pretty . PP.ppQualName True) _calc_vals)
              else ""
            ) ++ (
              if   _verbosity >= 2
              then let tps            = length _calc_tps
                       vals           = length _calc_vals
                       total          = tps + vals
                   in  show total ++ " implied exports after "
                    ++ show (_max_it - _ex_rest_it) ++ " iterations.\n"
                    ++ "(" ++ show tps ++ " types, "
                    ++ show vals ++ " values.)\n"
              else ""
            )
        (_kioutput) =
            if _verbosity >= 2
            then "\nResults of kind inferencing:\n"
              ++ ppKSubst _contents_compiledModule _kinds
            else ""
        (_kierrors) =
            concatMap (printErrorV _verbosity) _contents_kind_errors
        (_kistop) =
            or . map isError $ _contents_kind_errors
        (_deps) =
            _contents_deps_collect
        (_reqoutput) =
            ( if   _verbosity >= 3
              then "\nRaw requests from source:\n"
                ++ unlines (map showRawRequest _rawrequests)
                ++ "\nImplications from source:\n"
                ++ unlines (map showTypeImply  _contents_implications_collect)
                ++ unlines (map showBimapImply _contents_bimapimps_collect   )
                ++ unlines (map showFunImply   _contents_funimps_collect     )
                ++ "\nComponent requests:\n"
                ++ unlines (map showRawRequest _calc_rc                      )
                ++ (if null _calc_rtc then "" else "(type-indexed types:)\n")
                ++ unlines (map showRawRequest _calc_rtc                     )
              else ""
            ) ++ (
              if   _verbosity >= 2
              then "\nSpecialisation requests:\n"
                ++ unlines (map showRequest    _requests                     )
                ++ (if null _requests_gas then "" else "(generic abstractions:)\n")
                ++ unlines (map showRawRequest _requests_gas                 )
                ++ (if null _requests_t then "" else "(type-indexed types:)\n")
                ++ unlines (map showRequestTIT _requests_t                   )
                ++ "\n"
              else ""
            ) ++ (
              if   _verbosity >= 1
              then let component_reqs = length _calc_rc + length _calc_rtc
                       spec_reqs      = length _requests
                       gas_reqs       = length _requests_gas
                       spec_reqs_t    = length _requests_t
                       total          = component_reqs + spec_reqs + gas_reqs + spec_reqs_t
                   in  show total ++ " specialisation requests after "
                    ++ show (_max_it - _rest_it) ++ " iterations.\n"
                    ++ "(" ++ show component_reqs ++ " components, "
                    ++ show spec_reqs ++ " MPC/normal, "
                    ++ show gas_reqs ++ " generic abstractions, "
                    ++ show spec_reqs_t ++ " type-indexed types.)\n"
              else ""
            )
        (_reqerrors) =
            concatMap (printErrorV _verbosity) (_nonterm_error ++ _request_errors)
        (_reqstop) =
            or . map isError $ _request_errors
        (_specs) =
            concatMap
                (\(n,str,pts) -> SPEC.specialise n str
                                                 _kinds
                                                 _pktdist
                                                 _deps
                                                 pts
                )
                _requests
              ++
            concatMap
                (\(n,tp,pts)  -> SPEC.specialise_component
                                                 n tp
                                                 _kinds
                                                 _pktdist
                                                 _deps
                                                 pts
                )
                _requests_components
        (_specs_t) =
            map
                (\(n,str,tit) -> SPEC.specialise_t n str
                                                   tit
                                                   _deps
                )
                _requests_t
              ++
            map
                (\(n,tp) -> SPEC.specialise_component_t n tp)
                _requests_components_t
        (_output) =
            reverse _contents_output
             ++ [pp $ comment $ "normal/MPC specialisations"]
             ++ map (PP.ppTB False) _specs
             ++ [pp $ comment $ "generic abstraction specialisations"]
             ++ map (PP.ppTB False) _nonrecs
             ++ [pp $ comment $ "type-indexed type specialisations"]
             ++ concatMap (\(t,b)
                          -> map (PP.ppTDecl False) t
                          ++ map (PP.ppTB    False) b
                          ) _specs_t
        ((_ex_rest_it,_calc_vals,_calc_tps)) =
            exports_iterate _max_it
                            _contents_initialValues
                            _contents_initialTypes
                            _contents_implications_collect
                            _contents_funimps_collect
        (_outputi) =
            _contents_outputi
        (_prekind) =
            _contents_kinames
        (_kinds) =
            _prekind `compKind` _contents_ksubst
        (_ptsdist) =
            _contents_ptscoll
        (_pktdist) =
            _contents_pktcoll
        (_consigs) =
            consigs_expand _contents_pconsigs_col _consigs
        (_rawrequests) =
            _contents_rawrequest_collect
        ((_rest_it,_calc_gas,_calc_mpcs)) =
            request_iterate _max_it
                            _rawrequests
                            _contents_genabs_collect
                            _contents_implications_collect
                            _contents_bimapimps_collect
                            _contents_funimps_collect
                            (mapFM (map stype_to_type) _consigs)
        ((_calc_rn,_calc_rt)) =
            List.partition (\(RawRequest (n,t)) -> isVar n) _calc_mpcs
        ((_calc_rc,_calc_ro)) =
            List.partition (\(RawRequest (n,t))
                           -> simpleType t &&
                              (type_to_name t `elem`
                               map stype_ctor (applyFMM _consigs (const []) n))
                           ) _calc_rn
        ((_calc_rtc,_calc_rto)) =
            List.partition (\(RawRequest (n,t))
                           -> simpleType t &&
                              (type_to_name t `elem`
                               map stype_ctor (applyFMM _consigs (const []) n))
                           ) _calc_rt
        (_nonterm_error) =
            if   _rest_it < 0
            then [GHError_RequestNonTerminate _max_it]
            else []
        (_request_errors) =
            [ GHError_RequestAbstractError n t
            | (RawRequest (n,t)) <- _calc_ro
            , simpleType t
            , type_to_name t `Set.elementOf` _contents_abstracttps_collect
            ]
        (_requests_gas) =
            _calc_gas
        (_requests_components) =
            [ (n,tp,pts)
            | (RawRequest (n,t)) <- _calc_rc
            ,
              let tp  = type_to_name t
            , let pts = maybe (internalError
                                $ "Request.Root.Root.requests_components: "
                               ++ "no type signature for " ++ (pretty $ PP.ppQualName False n))
                              id
                              (find _ptsdist n)
            ]
        (_requests_components_t) =
            [ (n,tp)
            | (RawRequest (n,t)) <- _calc_rtc
            ,
              let tp  = type_to_name t
            ]
        (_requests) =
            [ (n,stp,pts)
            | (RawRequest (n,t)) <- _calc_ro
            , simpleType t
            , let tn  = type_to_name t
            , let stp = maybe (internalError
                                $ "Request.Root.Root.requests: "
                               ++ "no structure type for " ++ (pretty $ PP.ppQualName False tn))
                              id
                              (find _contents_strtypes tn)
            , let pts = maybe (internalError
                                $ "Request.Root.Root.requests: "
                               ++ "no type signature for " ++ (pretty $ PP.ppQualName False n))
                              id
                              (find _ptsdist n)
            ]
        (_requests_t) =
            [ (n,stp,tit)
            | (RawRequest (n,t)) <- _calc_rto
            , simpleType t
            , let tn  = type_to_name t
            , let stp = maybe (internalError
                                $ "Request.Root.Root.requests_t: "
                               ++ "no structure type for " ++ (pretty $ PP.ppQualName False tn))
                              id
                              (find _contents_strtypes tn)
            , let tit = maybe (internalError
                                $ "Request.Root.Root.requests_t: "
                               ++ "no type-indexed type for " ++ (pretty $ PP.ppQualName False n))
                              id
                              (lookup n _contents_titypes)
            ]
        (_nonrecs) =
            _contents_nonrecs
        ( _contents_abstracttps_collect
         ,_contents_bimapimps_collect
         ,_contents_compiledModule
         ,_contents_constructors_collect
         ,_contents_deps_collect
         ,_contents_funimps_collect
         ,_contents_genabs_collect
         ,_contents_implications_collect
         ,_contents_initialTypes
         ,_contents_initialValues
         ,_contents_kinames
         ,_contents_kind_errors
         ,_contents_kindvar
         ,_contents_ksubst
         ,_contents_methods_collect
         ,_contents_nonrecs
         ,_contents_output
         ,_contents_outputi
         ,_contents_pconsigs_col
         ,_contents_pktcoll
         ,_contents_ptscoll
         ,_contents_rawrequest_collect
         ,_contents_self
         ,_contents_strtypes
         ,_contents_titypes
         ) =
            (_contents (emptySet)
                       ([])
                       (Nothing)
                       (_consigs)
                       (emptyFM)
                       (_contents_constructors_collect)
                       (_deps)
                       (emptyFM)
                       (_exportedTypes)
                       (_exportedValues)
                       ([])
                       (_contents_genabs_collect)
                       (emptySet)
                       (_hiddenEntities)
                       (Set.emptySet)
                       (Set.emptySet)
                       (False)
                       ([])
                       (Set.mkSet _calc_tps)
                       (Set.mkSet _calc_vals)
                       (_importedEntities)
                       (False)
                       (Set.emptySet)
                       (Set.emptySet)
                       (emptyFM)
                       (_kinds)
                       (0)
                       (emptyFM)
                       (emptyFM)
                       (_contents_methods_collect)
                       (_modules)
                       ([])
                       (_contents_pconsigs_col)
                       (emptyFM)
                       (emptyFM)
                       (_pktdist)
                       (_prekind)
                       (emptyFM)
                       (_ptsdist)
                       ([])
                       (_requests_gas)
                       (emptyFM)
                       (True)
                       (_verbosity))
    in  ((_kierrors ++ if _kistop then [] else _reqerrors
         ,_kistop || _reqstop
         ,_kioutput ++ _reqoutput ++ _expoutput
         ,unlines . map pretty $ _output
         ,unlines . map pretty $ _outputi
         )
        )
-- SDecl -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      output               : PP_Doc
      outputi              : [PP_Doc]
      self                 : SDecl

-}
{-
   local variables for SDecl.Binding:
      is_classmethod
      is_imported_h
      is_hidden
      is_imported
      is_exported
      self

-}
{-
   local variables for SDecl.Empty:
      self

-}
{-
   local variables for SDecl.Fixity:
      self

-}
{-
   local variables for SDecl.PatBinding:
      self

-}
{-
   local variables for SDecl.PolyBinding:
      restricted
      nonrecs'
      funimps_collect
      component
      component'
      consig_difference
      linkname
      setlinkname
      pconsigs_col
      pts
      is_implied
      is_imported_h
      is_hidden
      is_imported
      is_exported
      self

-}
{-
   local variables for SDecl.PolyTypeSig:
      funimps_collect
      bimapimps_collect
      basetype
      pkt
      pctx
      genabs_collect
      consig
      is_implied
      is_imported_h
      is_hidden
      is_imported
      is_exported
      self

-}
{-
   local variables for SDecl.TypeSig:
      self

-}
-- semantic domain
type T_SDecl = (Set QualName) ->
               ([Request_BimapImply]) ->
               (Maybe QualName) ->
               (Consigs) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Set QualName) ->
               (Set QualName) ->
               (Exports) ->
               ([Request_FunImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               ([Request_TypeImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               (Set QualName) ->
               (Set QualName) ->
               (KSubst) ->
               (KSubst) ->
               (Int) ->
               (KSubst) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Set Modid) ->
               (PConsigs) ->
               (PConsigs) ->
               (FMap QualName PKT) ->
               (FMap QualName PKT) ->
               (KSubst) ->
               (FMap QualName PTS) ->
               (FMap QualName PTS) ->
               ([RawRequest]) ->
               ([RawRequest]) ->
               (Bool) ->
               (Int) ->
               ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PP_Doc),([PP_Doc]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(SDecl))
-- cata
sem_SDecl :: (SDecl) ->
             (T_SDecl)
sem_SDecl ((SDecl_Binding (_srcloc) (_name) (_bindings))) =
    (sem_SDecl_Binding ((sem_Position (_srcloc))) ((sem_QualName (_name))) ((sem_Bindings (_bindings))))
sem_SDecl ((SDecl_Empty )) =
    (sem_SDecl_Empty )
sem_SDecl ((SDecl_Fixity (_srcloc) (_inf) (_priority) (_ops))) =
    (sem_SDecl_Fixity ((sem_Position (_srcloc))) ((sem_Infix (_inf))) (_priority) ((sem_QualNames (_ops))))
sem_SDecl ((SDecl_PatBinding (_srcloc) (_pat) (_rhs) (_where))) =
    (sem_SDecl_PatBinding ((sem_Position (_srcloc))) ((sem_Pattern (_pat))) ((sem_Rhs (_rhs))) ((sem_SDecls (_where))))
sem_SDecl ((SDecl_PolyBinding (_srcloc) (_name) (_tp) (_bindings))) =
    (sem_SDecl_PolyBinding ((sem_Position (_srcloc))) ((sem_QualName (_name))) ((sem_SType (_tp))) ((sem_Bindings (_bindings))))
sem_SDecl ((SDecl_PolyTypeSig (_srcloc) (_name) (_pts))) =
    (sem_SDecl_PolyTypeSig ((sem_Position (_srcloc))) ((sem_QualName (_name))) ((sem_PTS (_pts))))
sem_SDecl ((SDecl_TypeSig (_srcloc) (_name) (_tp))) =
    (sem_SDecl_TypeSig ((sem_Position (_srcloc))) ((sem_QualName (_name))) ((sem_QualType (_tp))))
sem_SDecl_Binding :: (T_Position) ->
                     (T_QualName) ->
                     (T_Bindings) ->
                     (T_SDecl)
sem_SDecl_Binding (_srcloc)
                  (_name)
                  (_bindings)
                  (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_kinames)
                  (_lhs_kinds)
                  (_lhs_kindvar)
                  (_lhs_ksubst)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_modules)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_prekind)
                  (_lhs_ptscoll)
                  (_lhs_ptsdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_requests_gas)
                  (_lhs_toplevel)
                  (_lhs_verbosity) =
    let (_self) =
            SDecl_Binding _srcloc_self _name_self _bindings_self
        (_is_exported) =
            _name_self `Set.elementOf` _lhs_exportedValues
        (_is_imported) =
            _name_self `Set.elementOf` _lhs_importedValues
        (_is_hidden) =
            _name_self `Set.elementOf` _lhs_hiddenValues
        (_is_imported_h) =
            if _lhs_hiding then _is_hidden else _is_imported
        (_is_classmethod) =
            maybe False (const True) _lhs_classname
        ( _srcloc_self) =
            (_srcloc )
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
        ( _bindings_abstracttps_collect
         ,_bindings_bimapimps_collect
         ,_bindings_constructors_collect
         ,_bindings_deps_collect
         ,_bindings_exports_collect
         ,_bindings_funimps_collect
         ,_bindings_genabs_collect
         ,_bindings_implications_collect
         ,_bindings_imports_collect
         ,_bindings_initialTypes
         ,_bindings_initialValues
         ,_bindings_kinames
         ,_bindings_kindvar
         ,_bindings_ksubst
         ,_bindings_linkname
         ,_bindings_methods_collect
         ,_bindings_nonrecs
         ,_bindings_pconsigs_col
         ,_bindings_pktcoll
         ,_bindings_ptscoll
         ,_bindings_rawrequest_collect
         ,_bindings_self
         ) =
            (_bindings (_name_abstracttps_collect)
                       (_name_bimapimps_collect)
                       (_lhs_classname)
                       (_lhs_consigs)
                       (_name_constructors_collect)
                       (_lhs_constructors_dist)
                       (_lhs_currentModule)
                       (_lhs_deps)
                       (_name_deps_collect)
                       (_lhs_exportedTypes)
                       (_lhs_exportedValues)
                       (_lhs_exports)
                       (_name_funimps_collect)
                       (_lhs_genabs)
                       (_name_genabs_collect)
                       (_lhs_hiddenTypes)
                       (_lhs_hiddenValues)
                       (_lhs_hiding)
                       (_name_implications_collect)
                       (_lhs_impliedTypes)
                       (_lhs_impliedValues)
                       (_lhs_importedModule)
                       (_lhs_importedTypes)
                       (_lhs_importedValues)
                       (_lhs_kinames)
                       (_lhs_kinds)
                       (_lhs_kindvar)
                       (_lhs_ksubst)
                       (_lhs_local)
                       (_name_methods_collect)
                       (_lhs_methods_dist)
                       (_lhs_modules)
                       (_lhs_pconsigs)
                       (_name_pconsigs_col)
                       (_name_pktcoll)
                       (_lhs_pktdist)
                       (_lhs_prekind)
                       (_lhs_ptscoll)
                       (_lhs_ptsdist)
                       (_name_rawrequest_collect)
                       (_lhs_requests_gas)
                       (False)
                       (_lhs_verbosity))
    in  (_bindings_abstracttps_collect
        ,_bindings_bimapimps_collect
        ,_bindings_constructors_collect
        ,_bindings_deps_collect
        ,_name_exports_collect ++ _bindings_exports_collect
        ,_bindings_funimps_collect
        ,_bindings_genabs_collect
        ,_bindings_implications_collect
        ,_name_imports_collect ++ _bindings_imports_collect
        ,_name_initialTypes ++ _bindings_initialTypes
        ,_name_initialValues ++ _bindings_initialValues
        ,_bindings_kinames
        ,_bindings_kindvar
        ,_bindings_ksubst
        ,case _lhs_classname of
           Nothing -> _lhs_methods_collect
           Just c  -> addLBack _lhs_methods_collect
                               (c,[_name_self])
        ,_name_nonrecs ++ _bindings_nonrecs
        ,PP.ppSDecl False (ER.replaceSDecl _lhs_deps emptyFM _lhs_genabs _self)
        ,[]
        ,_bindings_pconsigs_col
        ,_bindings_pktcoll
        ,_bindings_ptscoll
        ,_bindings_rawrequest_collect
        ,_self
        )
sem_SDecl_Empty :: (T_SDecl)
sem_SDecl_Empty (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_kinames)
                (_lhs_kinds)
                (_lhs_kindvar)
                (_lhs_ksubst)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_modules)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_prekind)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_requests_gas)
                (_lhs_toplevel)
                (_lhs_verbosity) =
    let (_self) =
            SDecl_Empty
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_kinames,_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,[],PP.ppSDecl False _self,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,_self)
sem_SDecl_Fixity :: (T_Position) ->
                    (T_Infix) ->
                    (Priority) ->
                    (T_QualNames) ->
                    (T_SDecl)
sem_SDecl_Fixity (_srcloc)
                 (_inf)
                 (_priority)
                 (_ops)
                 (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kinds)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity) =
    let (_self) =
            SDecl_Fixity _srcloc_self _inf_self _priority _ops_self
        ( _srcloc_self) =
            (_srcloc )
        ( _inf_abstracttps_collect,_inf_bimapimps_collect,_inf_constructors_collect,_inf_deps_collect,_inf_exports_collect,_inf_funimps_collect,_inf_genabs_collect,_inf_implications_collect,_inf_imports_collect,_inf_initialTypes,_inf_initialValues,_inf_methods_collect,_inf_nonrecs,_inf_pconsigs_col,_inf_pktcoll,_inf_ptscoll,_inf_rawrequest_collect,_inf_self) =
            (_inf (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_ptscoll)
                  (_lhs_ptsdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_toplevel))
        ( _ops_abstracttps_collect,_ops_bimapimps_collect,_ops_constructors_collect,_ops_deps_collect,_ops_exports_collect,_ops_funimps_collect,_ops_genabs_collect,_ops_implications_collect,_ops_imports_collect,_ops_initialTypes,_ops_initialValues,_ops_methods_collect,_ops_nonrecs,_ops_pconsigs_col,_ops_pktcoll,_ops_rawrequest_collect,_ops_self) =
            (_ops (_inf_abstracttps_collect)
                  (_inf_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_inf_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_inf_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_inf_funimps_collect)
                  (_lhs_genabs)
                  (_inf_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_inf_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_local)
                  (_inf_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_inf_pconsigs_col)
                  (_inf_pktcoll)
                  (_lhs_pktdist)
                  (_inf_rawrequest_collect)
                  (_lhs_toplevel))
    in  (_ops_abstracttps_collect
        ,_ops_bimapimps_collect
        ,_ops_constructors_collect
        ,_ops_deps_collect
        ,_inf_exports_collect ++ _ops_exports_collect
        ,_ops_funimps_collect
        ,_ops_genabs_collect
        ,_ops_implications_collect
        ,_inf_imports_collect ++ _ops_imports_collect
        ,_inf_initialTypes ++ _ops_initialTypes
        ,_inf_initialValues ++ _ops_initialValues
        ,_lhs_kinames
        ,_lhs_kindvar
        ,_lhs_ksubst
        ,_ops_methods_collect
        ,_inf_nonrecs ++ _ops_nonrecs
        ,PP.ppSDecl False _self
        ,[]
        ,_ops_pconsigs_col
        ,_ops_pktcoll
        ,_inf_ptscoll
        ,_ops_rawrequest_collect
        ,_self
        )
sem_SDecl_PatBinding :: (T_Position) ->
                        (T_Pattern) ->
                        (T_Rhs) ->
                        (T_SDecls) ->
                        (T_SDecl)
sem_SDecl_PatBinding (_srcloc)
                     (_pat)
                     (_rhs)
                     (_where)
                     (_lhs_abstracttps_collect)
                     (_lhs_bimapimps_collect)
                     (_lhs_classname)
                     (_lhs_consigs)
                     (_lhs_constructors_collect)
                     (_lhs_constructors_dist)
                     (_lhs_currentModule)
                     (_lhs_deps)
                     (_lhs_deps_collect)
                     (_lhs_exportedTypes)
                     (_lhs_exportedValues)
                     (_lhs_exports)
                     (_lhs_funimps_collect)
                     (_lhs_genabs)
                     (_lhs_genabs_collect)
                     (_lhs_hiddenTypes)
                     (_lhs_hiddenValues)
                     (_lhs_hiding)
                     (_lhs_implications_collect)
                     (_lhs_impliedTypes)
                     (_lhs_impliedValues)
                     (_lhs_importedModule)
                     (_lhs_importedTypes)
                     (_lhs_importedValues)
                     (_lhs_kinames)
                     (_lhs_kinds)
                     (_lhs_kindvar)
                     (_lhs_ksubst)
                     (_lhs_local)
                     (_lhs_methods_collect)
                     (_lhs_methods_dist)
                     (_lhs_modules)
                     (_lhs_pconsigs)
                     (_lhs_pconsigs_col)
                     (_lhs_pktcoll)
                     (_lhs_pktdist)
                     (_lhs_prekind)
                     (_lhs_ptscoll)
                     (_lhs_ptsdist)
                     (_lhs_rawrequest_collect)
                     (_lhs_requests_gas)
                     (_lhs_toplevel)
                     (_lhs_verbosity) =
    let (_self) =
            SDecl_PatBinding _srcloc_self _pat_self _rhs_self
                             _where_self
        ( _srcloc_self) =
            (_srcloc )
        ( _pat_abstracttps_collect,_pat_bimapimps_collect,_pat_constructors_collect,_pat_deps_collect,_pat_exports_collect,_pat_funimps_collect,_pat_genabs_collect,_pat_implications_collect,_pat_imports_collect,_pat_initialTypes,_pat_initialValues,_pat_methods_collect,_pat_nonrecs,_pat_pconsigs_col,_pat_pktcoll,_pat_ptscoll,_pat_rawrequest_collect,_pat_self) =
            (_pat (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_ptscoll)
                  (_lhs_ptsdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_toplevel))
        ( _rhs_abstracttps_collect,_rhs_bimapimps_collect,_rhs_constructors_collect,_rhs_deps_collect,_rhs_exports_collect,_rhs_funimps_collect,_rhs_genabs_collect,_rhs_implications_collect,_rhs_imports_collect,_rhs_initialTypes,_rhs_initialValues,_rhs_kinames,_rhs_kindvar,_rhs_ksubst,_rhs_linkname,_rhs_methods_collect,_rhs_nonrecs,_rhs_pconsigs_col,_rhs_pktcoll,_rhs_ptscoll,_rhs_rawrequest_collect,_rhs_self) =
            (_rhs (_pat_abstracttps_collect)
                  (_pat_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_pat_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_pat_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_pat_funimps_collect)
                  (_lhs_genabs)
                  (_pat_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_pat_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_kinames)
                  (_lhs_kinds)
                  (_lhs_kindvar)
                  (_lhs_ksubst)
                  (_lhs_local)
                  (_pat_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_modules)
                  (_lhs_pconsigs)
                  (_pat_pconsigs_col)
                  (_pat_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_prekind)
                  (_pat_ptscoll)
                  (_lhs_ptsdist)
                  (_pat_rawrequest_collect)
                  (_lhs_requests_gas)
                  (False)
                  (_lhs_verbosity))
        ( _where_abstracttps_collect
         ,_where_bimapimps_collect
         ,_where_constructors_collect
         ,_where_count
         ,_where_deps_collect
         ,_where_exports_collect
         ,_where_funimps_collect
         ,_where_genabs_collect
         ,_where_implications_collect
         ,_where_imports_collect
         ,_where_initialTypes
         ,_where_initialValues
         ,_where_kinames
         ,_where_kindvar
         ,_where_ksubst
         ,_where_methods_collect
         ,_where_nil
         ,_where_nonrecs
         ,_where_pconsigs_col
         ,_where_pktcoll
         ,_where_ptscoll
         ,_where_rawrequest_collect
         ,_where_self
         ) =
            (_where (_rhs_abstracttps_collect)
                    (_rhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_rhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_rhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_rhs_funimps_collect)
                    (_lhs_genabs)
                    (_rhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_rhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_rhs_kinames)
                    (_lhs_kinds)
                    (_rhs_kindvar)
                    (_rhs_ksubst)
                    (_lhs_local)
                    (_rhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_rhs_pconsigs_col)
                    (_rhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_rhs_ptscoll)
                    (_lhs_ptsdist)
                    (_rhs_rawrequest_collect)
                    (_lhs_requests_gas)
                    (False)
                    (_lhs_verbosity))
    in  (_where_abstracttps_collect
        ,_where_bimapimps_collect
        ,_where_constructors_collect
        ,_where_deps_collect
        ,_pat_exports_collect ++ _rhs_exports_collect ++ _where_exports_collect
        ,_where_funimps_collect
        ,_where_genabs_collect
        ,_where_implications_collect
        ,_pat_imports_collect ++ _rhs_imports_collect ++ _where_imports_collect
        ,_pat_initialTypes ++ _rhs_initialTypes ++ _where_initialTypes
        ,_pat_initialValues ++ _rhs_initialValues ++ _where_initialValues
        ,_where_kinames
        ,_where_kindvar
        ,_where_ksubst
        ,_where_methods_collect
        ,_pat_nonrecs ++ _rhs_nonrecs ++ _where_nonrecs
        ,PP.ppSDecl False _self
        ,[]
        ,_where_pconsigs_col
        ,_where_pktcoll
        ,_where_ptscoll
        ,_where_rawrequest_collect
        ,_self
        )
sem_SDecl_PolyBinding :: (T_Position) ->
                         (T_QualName) ->
                         (T_SType) ->
                         (T_Bindings) ->
                         (T_SDecl)
sem_SDecl_PolyBinding (_srcloc)
                      (_name)
                      (_tp)
                      (_bindings)
                      (_lhs_abstracttps_collect)
                      (_lhs_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_lhs_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_lhs_funimps_collect)
                      (_lhs_genabs)
                      (_lhs_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_lhs_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_lhs_kinames)
                      (_lhs_kinds)
                      (_lhs_kindvar)
                      (_lhs_ksubst)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_modules)
                      (_lhs_pconsigs)
                      (_lhs_pconsigs_col)
                      (_lhs_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_prekind)
                      (_lhs_ptscoll)
                      (_lhs_ptsdist)
                      (_lhs_rawrequest_collect)
                      (_lhs_requests_gas)
                      (_lhs_toplevel)
                      (_lhs_verbosity) =
    let (_self) =
            SDecl_PolyBinding _srcloc_self _name_self _tp_self
                              _bindings_self
        (_is_exported) =
            _name_self `Set.elementOf` _lhs_exportedValues
        (_is_imported) =
            _name_self `Set.elementOf` _lhs_importedValues
        (_is_hidden) =
            _name_self `Set.elementOf` _lhs_hiddenValues
        (_is_imported_h) =
            if _lhs_hiding then _is_hidden else _is_imported
        (_is_implied) =
            _name_self `Set.elementOf` _lhs_impliedValues
        (_pts) =
            case find _lhs_ptsdist _name_self of
              Just x  -> x
              Nothing -> ptsMissingError _name_self
        (_pconsigs_col) =
            case find _lhs_pconsigs_col _name_self of
              Nothing -> add _lhs_pconsigs_col (_name_self,([],Nothing))
              Just _  -> _lhs_pconsigs_col
        (_setlinkname) =
            case _tp_self of
              SType_Var _ _ -> not _restricted
              _             -> False
        (_linkname) =
            maybe (unstaticError "undefined copy case")
                  id
                  _bindings_linkname
        (_consig_difference) =
            (applyFMM _lhs_consigs
                      (const $ internalError "Components.SDecl.PolyBinding.consig_difference: no consig for link")
                      _linkname)
             List.\\ fst
            (applyFMM _lhs_pconsigs
                      (const $ internalError "Components.SDecl.PolyBinding.consig_difference: no consig for generic function")
                      _name_self)
        (_component') =
            case _tp_self of
              SType_Var _ n ->
                               let
                                   d   = _consig_difference
                                   pkt = TRR.liftPKT _pts _lhs_pktdist
                               in  map (\tp -> makeComponent (applyFMM _lhs_kinds
                                                                       (const $ internalError "Components.SDecl.PolyBinding.component': no kind for component in copy line")
                                                                       (stype_ctor tp))
                                                             pkt _name_self tp []
                                                             _lhs_genabs
                                                             _lhs_deps
                                                             (ER.replaceBindings _lhs_deps
                                                                (fromList [(n,Type_Con genloc (stype_ctor tp))])
                                                                _lhs_genabs
                                                                _bindings_self
                                                                )) d
              _             -> let
                                   pkt = TRR.liftPKT _pts _lhs_pktdist
                                   k   = applyFMM _lhs_kinds
                                                  (const $ internalError "Components.SDecl.PolyBinding.component': no kind for component")
                                                  _tp_ctor
                               in  [makeComponent k pkt
                                                  _name_self _tp_self (stype_eargs _tp_self)
                                                  _lhs_genabs
                                                  _lhs_deps
                                                  _bindings_self]
        (_component) =
            if _restricted then [] else _component'
        (_funimps_collect) =
            case _tp_self of
              SType_Var _ n ->
                               if   _restricted
                               then
                                    let lambda = Type_Lam n
                                        calls = _bindings_rawrequest_collect
                                    in  (if   null calls
                                        then []
                                        else
                                             [Request_FunImply
                                               (_name_self
                                               , [ RawRequest (f,lambda tp)
                                                 | (RawRequest (f,tp)) <- calls
                                                 ]
                                               )
                                             ]
                                        ) ++ _lhs_funimps_collect
                               else _lhs_funimps_collect
              _             -> _lhs_funimps_collect
        (_nonrecs') =
            let
                rel_reqs = filter (\ (RawRequest (n,_)) -> (n == _name_self))
                                  _lhs_requests_gas
                (ctx,pkt) = TRR.liftPKT _pts _lhs_pktdist
                tp = pkt (internalError "NonRec.SDecl.PolyBinding")
                nonrecs' = map (makeNonRec (ctx,tp) _name_self
                                           (fromJust _tp_isvar)
                                           _lhs_genabs
                                           _lhs_deps
                                           _bindings_self
                               )
                               rel_reqs
            in  maybe [] (const nonrecs') _tp_isvar
        (_restricted) =
            case find _lhs_ptsdist _name_self of
               Nothing -> unstaticError "no type signature for generic function"
               Just (PTS_PTS _ k _) -> isRestricted k
        ( _srcloc_self) =
            (_srcloc )
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
        ( _tp_abstracttps_collect,_tp_bimapimps_collect,_tp_constructors_collect,_tp_ctor,_tp_ctpprefix,_tp_deps_collect,_tp_eargs,_tp_exports_collect,_tp_funimps_collect,_tp_genabs_collect,_tp_implications_collect,_tp_imports_collect,_tp_initialTypes,_tp_initialValues,_tp_isvar,_tp_kinames,_tp_kindvar,_tp_ksubst,_tp_methods_collect,_tp_nonrecs,_tp_pconsigs_col,_tp_pktcoll,_tp_ptscoll,_tp_rawrequest_collect,_tp_self) =
            (_tp (_name_abstracttps_collect)
                 (_name_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_name_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_name_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_name_funimps_collect)
                 (_lhs_genabs)
                 (_name_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_name_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_name_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_name_pconsigs_col)
                 (_name_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_name_rawrequest_collect)
                 (False))
        ( _bindings_abstracttps_collect
         ,_bindings_bimapimps_collect
         ,_bindings_constructors_collect
         ,_bindings_deps_collect
         ,_bindings_exports_collect
         ,_bindings_funimps_collect
         ,_bindings_genabs_collect
         ,_bindings_implications_collect
         ,_bindings_imports_collect
         ,_bindings_initialTypes
         ,_bindings_initialValues
         ,_bindings_kinames
         ,_bindings_kindvar
         ,_bindings_ksubst
         ,_bindings_linkname
         ,_bindings_methods_collect
         ,_bindings_nonrecs
         ,_bindings_pconsigs_col
         ,_bindings_pktcoll
         ,_bindings_ptscoll
         ,_bindings_rawrequest_collect
         ,_bindings_self
         ) =
            (_bindings (_tp_abstracttps_collect)
                       (_tp_bimapimps_collect)
                       (_lhs_classname)
                       (_lhs_consigs)
                       (_tp_constructors_collect)
                       (_lhs_constructors_dist)
                       (_lhs_currentModule)
                       (_lhs_deps)
                       (_tp_deps_collect)
                       (_lhs_exportedTypes)
                       (_lhs_exportedValues)
                       (_lhs_exports)
                       (_tp_funimps_collect)
                       (_lhs_genabs)
                       (_tp_genabs_collect)
                       (_lhs_hiddenTypes)
                       (_lhs_hiddenValues)
                       (_lhs_hiding)
                       (_tp_implications_collect)
                       (_lhs_impliedTypes)
                       (_lhs_impliedValues)
                       (_lhs_importedModule)
                       (_lhs_importedTypes)
                       (_lhs_importedValues)
                       (_tp_kinames)
                       (_lhs_kinds)
                       (_tp_kindvar)
                       (_tp_ksubst)
                       (_lhs_local)
                       (_tp_methods_collect)
                       (_lhs_methods_dist)
                       (_lhs_modules)
                       (_lhs_pconsigs)
                       (_tp_pconsigs_col)
                       (_tp_pktcoll)
                       (_lhs_pktdist)
                       (_lhs_prekind)
                       (_tp_ptscoll)
                       (_lhs_ptsdist)
                       (case _tp_self of
                          SType_Var _ n -> []
                          _             -> _lhs_rawrequest_collect)
                       (_lhs_requests_gas)
                       (False)
                       (_lhs_verbosity))
    in  (_bindings_abstracttps_collect
        ,_bindings_bimapimps_collect
        ,_bindings_constructors_collect
        ,_bindings_deps_collect
        ,_name_exports_collect ++ _tp_exports_collect ++ _bindings_exports_collect
        ,_bindings_funimps_collect
        ,_bindings_genabs_collect
        ,_bindings_implications_collect
        ,_name_imports_collect ++ _tp_imports_collect ++ _bindings_imports_collect
        ,_name_initialTypes ++ _tp_initialTypes ++ _bindings_initialTypes
        ,if _restricted  then [_name_self]
                         else []
        ,_bindings_kinames
        ,_bindings_kindvar
        ,_bindings_ksubst
        ,_bindings_methods_collect
        ,if _restricted then _nonrecs' else []
        ,vlist $ map (PP.ppTB False) _component
        ,if   _is_implied && _restricted
         then [PPI.ppiSDecl _self]
         else []
        ,if   _setlinkname
         then modify _pconsigs_col _name_self (\(stps,link) -> (stps,Just _linkname))
         else if   _restricted
              then _pconsigs_col
              else modify _pconsigs_col _name_self (\(stps,link) -> (_tp_self:stps,link))
        ,_bindings_pktcoll
        ,_bindings_ptscoll
        ,case _tp_self of
           SType_Var _ n -> if   _restricted
                            then _lhs_rawrequest_collect
                            else
                                 let lambda = Type_Lam n
                                     calls  = _bindings_rawrequest_collect
                                 in  (if null calls
                                      then []
                                      else [RawRequest
                                              (f,TR.reduce (lambda tp) [stype_to_type cst])
                                           | (RawRequest (f,tp)) <- calls
                                           , cst <- _consig_difference
                                           ]
                                     ) ++ _lhs_rawrequest_collect
           _             -> (RawRequest (_name_self,stype_to_type _tp_self))
                               : _bindings_rawrequest_collect
        ,_self
        )
sem_SDecl_PolyTypeSig :: (T_Position) ->
                         (T_QualName) ->
                         (T_PTS) ->
                         (T_SDecl)
sem_SDecl_PolyTypeSig (_srcloc)
                      (_name)
                      (_pts)
                      (_lhs_abstracttps_collect)
                      (_lhs_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_lhs_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_lhs_funimps_collect)
                      (_lhs_genabs)
                      (_lhs_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_lhs_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_lhs_kinames)
                      (_lhs_kinds)
                      (_lhs_kindvar)
                      (_lhs_ksubst)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_modules)
                      (_lhs_pconsigs)
                      (_lhs_pconsigs_col)
                      (_lhs_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_prekind)
                      (_lhs_ptscoll)
                      (_lhs_ptsdist)
                      (_lhs_rawrequest_collect)
                      (_lhs_requests_gas)
                      (_lhs_toplevel)
                      (_lhs_verbosity) =
    let (_self) =
            SDecl_PolyTypeSig _srcloc_self _name_self _pts_self
        (_is_exported) =
            _name_self `Set.elementOf` _lhs_exportedValues
        (_is_imported) =
            _name_self `Set.elementOf` _lhs_importedValues
        (_is_hidden) =
            _name_self `Set.elementOf` _lhs_hiddenValues
        (_is_imported_h) =
            if _lhs_hiding then _is_hidden else _is_imported
        (_is_implied) =
            _name_self `Set.elementOf` _lhs_impliedValues
        (_consig) =
            case find _lhs_consigs _name_self of
              Nothing -> internalError "Consig.SDecl.PolyTypeSig.consig: consig not found"
              Just x  -> x
        (_genabs_collect) =
            if   _pts_fixedKind
            then unitSet _name_self `Set.union` _lhs_genabs_collect
            else _lhs_genabs_collect
        ((_pctx,_pkt)) =
            TRR.liftPKT _pts_self _lhs_pktdist
        (_basetype) =
            _pkt Kind_Star
        (_bimapimps_collect) =
            if   _pts_fixedKind
            then _lhs_bimapimps_collect
            else (Request_BimapImply (_name_self,_basetype)) : _lhs_bimapimps_collect
        (_funimps_collect) =
            let calls = extracttitypes _basetype
            in  (if   null calls
                 then []
                 else [Request_FunImply (_name_self,calls)]
                ) ++ _lhs_funimps_collect
        ( _srcloc_self) =
            (_srcloc )
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_funimps_collect)
                   (_lhs_genabs)
                   (_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
        ( _pts_abstracttps_collect,_pts_bimapimps_collect,_pts_constructors_collect,_pts_deps_collect,_pts_exports_collect,_pts_fixedKind,_pts_funimps_collect,_pts_genabs_collect,_pts_implications_collect,_pts_imports_collect,_pts_initialTypes,_pts_initialValues,_pts_kinames,_pts_kindvar,_pts_ksubst,_pts_methods_collect,_pts_nonrecs,_pts_pconsigs_col,_pts_pktcoll,_pts_ptscoll,_pts_rawrequest_collect,_pts_self) =
            (_pts (_name_abstracttps_collect)
                  (_name_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_name_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_name_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_name_funimps_collect)
                  (_lhs_genabs)
                  (_name_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_name_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_kinames)
                  (_lhs_kinds)
                  (_lhs_kindvar)
                  (_lhs_ksubst)
                  (_lhs_local)
                  (_name_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_name_pconsigs_col)
                  (_name_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_prekind)
                  (_lhs_ptscoll)
                  (_lhs_ptsdist)
                  (_name_rawrequest_collect)
                  (False))
    in  (_pts_abstracttps_collect
        ,_pts_bimapimps_collect
        ,_pts_constructors_collect
        ,_pts_deps_collect
        ,[]
        ,_pts_funimps_collect
        ,_pts_genabs_collect
        ,_pts_implications_collect
        ,[]
        ,_name_initialTypes ++ _pts_initialTypes
        ,_name_initialValues ++ _pts_initialValues
        ,_pts_kinames
        ,_pts_kindvar
        ,_pts_ksubst
        ,_pts_methods_collect
        ,_name_nonrecs ++ _pts_nonrecs
        ,empty
        ,if   _is_implied || _is_exported
         then [PPI.ppiSDecl _self
              ,PPI.ppiConsig _name_self (map stype_ctor _consig)
              ]
         else []
        ,_pts_pconsigs_col
        ,_pts_pktcoll
        ,add _lhs_ptscoll (_name_self,_pts_self)
        ,_pts_rawrequest_collect
        ,_self
        )
sem_SDecl_TypeSig :: (T_Position) ->
                     (T_QualName) ->
                     (T_QualType) ->
                     (T_SDecl)
sem_SDecl_TypeSig (_srcloc)
                  (_name)
                  (_tp)
                  (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_kinames)
                  (_lhs_kinds)
                  (_lhs_kindvar)
                  (_lhs_ksubst)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_modules)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_prekind)
                  (_lhs_ptscoll)
                  (_lhs_ptsdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_requests_gas)
                  (_lhs_toplevel)
                  (_lhs_verbosity) =
    let (_self) =
            SDecl_TypeSig _srcloc_self _name_self _tp_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
        ( _tp_abstracttps_collect,_tp_bimapimps_collect,_tp_constructors_collect,_tp_deps_collect,_tp_exports_collect,_tp_funimps_collect,_tp_genabs_collect,_tp_implications_collect,_tp_imports_collect,_tp_initialTypes,_tp_initialValues,_tp_kinames,_tp_kind_errors,_tp_kindvar,_tp_ksubst,_tp_methods_collect,_tp_nonrecs,_tp_pconsigs_col,_tp_pktcoll,_tp_ptscoll,_tp_rawrequest_collect,_tp_self) =
            (_tp (_name_abstracttps_collect)
                 (_name_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_name_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_name_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_name_funimps_collect)
                 (_lhs_genabs)
                 (_name_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_name_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_name_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_name_pconsigs_col)
                 (_name_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_name_rawrequest_collect)
                 (False))
    in  (_tp_abstracttps_collect
        ,_tp_bimapimps_collect
        ,_tp_constructors_collect
        ,_tp_deps_collect
        ,_name_exports_collect ++ _tp_exports_collect
        ,_tp_funimps_collect
        ,_tp_genabs_collect
        ,_tp_implications_collect
        ,_name_imports_collect ++ _tp_imports_collect
        ,_name_initialTypes ++ _tp_initialTypes
        ,_name_initialValues ++ _tp_initialValues
        ,_tp_kinames
        ,_tp_kindvar
        ,_tp_ksubst
        ,_tp_methods_collect
        ,_name_nonrecs ++ _tp_nonrecs
        ,PP.ppSDecl False (SDecl_TypeSig _srcloc_self _name_self (handleTiTypesQ _lhs_deps _tp_self))
        ,[]
        ,_tp_pconsigs_col
        ,_tp_pktcoll
        ,_tp_ptscoll
        ,_tp_rawrequest_collect
        ,_self
        )
-- SDecls ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      count                : Int
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nil                  : Bool
      nonrecs              : [TypedBinding]
      self                 : SDecls

-}
{-
   local variables for SDecls.Cons:

-}
{-
   local variables for SDecls.Nil:

-}
-- semantic domain
type T_SDecls = (Set QualName) ->
                ([Request_BimapImply]) ->
                (Maybe QualName) ->
                (Consigs) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Modid) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Set QualName) ->
                (Set QualName) ->
                (Exports) ->
                ([Request_FunImply]) ->
                (Set QualName) ->
                (Set QualName) ->
                (Set QualName) ->
                (Set QualName) ->
                (Bool) ->
                ([Request_TypeImply]) ->
                (Set QualName) ->
                (Set QualName) ->
                (Bool) ->
                (Set QualName) ->
                (Set QualName) ->
                (KSubst) ->
                (KSubst) ->
                (Int) ->
                (KSubst) ->
                (Bool) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Set Modid) ->
                (PConsigs) ->
                (PConsigs) ->
                (FMap QualName PKT) ->
                (FMap QualName PKT) ->
                (KSubst) ->
                (FMap QualName PTS) ->
                (FMap QualName PTS) ->
                ([RawRequest]) ->
                ([RawRequest]) ->
                (Bool) ->
                (Int) ->
                ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(Int),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(FMap QualName QualNames),(Bool),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(SDecls))
-- cata
sem_SDecls :: (SDecls) ->
              (T_SDecls)
sem_SDecls (list) =
    (foldr (sem_SDecls_Cons) (sem_SDecls_Nil) ((map sem_SDecl list)))
sem_SDecls_Cons :: (T_SDecl) ->
                   (T_SDecls) ->
                   (T_SDecls)
sem_SDecls_Cons (_hd)
                (_tl)
                (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_kinames)
                (_lhs_kinds)
                (_lhs_kindvar)
                (_lhs_ksubst)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_modules)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_prekind)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_requests_gas)
                (_lhs_toplevel)
                (_lhs_verbosity) =
    let ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_kinames,_hd_kindvar,_hd_ksubst,_hd_methods_collect,_hd_nonrecs,_hd_output,_hd_outputi,_hd_pconsigs_col,_hd_pktcoll,_hd_ptscoll,_hd_rawrequest_collect,_hd_self) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kinds)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_count,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_initialTypes,_tl_initialValues,_tl_kinames,_tl_kindvar,_tl_ksubst,_tl_methods_collect,_tl_nil,_tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_ptscoll,_tl_rawrequest_collect,_tl_self) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_hd_kinames)
                 (_lhs_kinds)
                 (_hd_kindvar)
                 (_hd_ksubst)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_hd_ptscoll)
                 (_lhs_ptsdist)
                 (_hd_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
    in  (_tl_abstracttps_collect
        ,_tl_bimapimps_collect
        ,_tl_constructors_collect
        ,_tl_count + 1
        ,_tl_deps_collect
        ,_hd_exports_collect ++ _tl_exports_collect
        ,_tl_funimps_collect
        ,_tl_genabs_collect
        ,_tl_implications_collect
        ,_hd_imports_collect ++ _tl_imports_collect
        ,_hd_initialTypes ++ _tl_initialTypes
        ,_hd_initialValues ++ _tl_initialValues
        ,_tl_kinames
        ,_tl_kindvar
        ,_tl_ksubst
        ,_tl_methods_collect
        ,False
        ,_hd_nonrecs ++ _tl_nonrecs
        ,_tl_pconsigs_col
        ,_tl_pktcoll
        ,_tl_ptscoll
        ,_tl_rawrequest_collect
        ,_hd_self : _tl_self
        )
sem_SDecls_Nil :: (T_SDecls)
sem_SDecls_Nil (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_kinames)
               (_lhs_kinds)
               (_lhs_kindvar)
               (_lhs_ksubst)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_modules)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_prekind)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_requests_gas)
               (_lhs_toplevel)
               (_lhs_verbosity) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,0,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_kinames,_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,True,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,[])
-- SKind -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      ptsdist              : FMap QualName PTS
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : SKind

-}
{-
   local variables for SKind.Arr:

-}
{-
   local variables for SKind.Star:

-}
-- semantic domain
type T_SKind = (Set QualName) ->
               ([Request_BimapImply]) ->
               (Maybe QualName) ->
               (Consigs) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Set QualName) ->
               (Set QualName) ->
               (Exports) ->
               ([Request_FunImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               ([Request_TypeImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (PConsigs) ->
               (PConsigs) ->
               (FMap QualName PKT) ->
               (FMap QualName PKT) ->
               (FMap QualName PTS) ->
               (FMap QualName PTS) ->
               ([RawRequest]) ->
               (Bool) ->
               ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(SKind))
-- cata
sem_SKind :: (SKind) ->
             (T_SKind)
sem_SKind ((SKind_Arr (_left) (_right))) =
    (sem_SKind_Arr ((sem_QualName (_left))) ((sem_QualName (_right))))
sem_SKind ((SKind_Star )) =
    (sem_SKind_Star )
sem_SKind_Arr :: (T_QualName) ->
                 (T_QualName) ->
                 (T_SKind)
sem_SKind_Arr (_left)
              (_right)
              (_lhs_abstracttps_collect)
              (_lhs_bimapimps_collect)
              (_lhs_classname)
              (_lhs_consigs)
              (_lhs_constructors_collect)
              (_lhs_constructors_dist)
              (_lhs_currentModule)
              (_lhs_deps)
              (_lhs_deps_collect)
              (_lhs_exportedTypes)
              (_lhs_exportedValues)
              (_lhs_exports)
              (_lhs_funimps_collect)
              (_lhs_genabs)
              (_lhs_genabs_collect)
              (_lhs_hiddenTypes)
              (_lhs_hiddenValues)
              (_lhs_hiding)
              (_lhs_implications_collect)
              (_lhs_impliedTypes)
              (_lhs_impliedValues)
              (_lhs_importedModule)
              (_lhs_importedTypes)
              (_lhs_importedValues)
              (_lhs_local)
              (_lhs_methods_collect)
              (_lhs_methods_dist)
              (_lhs_pconsigs)
              (_lhs_pconsigs_col)
              (_lhs_pktcoll)
              (_lhs_pktdist)
              (_lhs_ptscoll)
              (_lhs_ptsdist)
              (_lhs_rawrequest_collect)
              (_lhs_toplevel) =
    let ( _left_abstracttps_collect,_left_bimapimps_collect,_left_constructors_collect,_left_deps_collect,_left_exports_collect,_left_funimps_collect,_left_genabs_collect,_left_implications_collect,_left_imports_collect,_left_initialTypes,_left_initialValues,_left_methods_collect,_left_nonrecs,_left_pconsigs_col,_left_pktcoll,_left_rawrequest_collect,_left_self) =
            (_left (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
        ( _right_abstracttps_collect,_right_bimapimps_collect,_right_constructors_collect,_right_deps_collect,_right_exports_collect,_right_funimps_collect,_right_genabs_collect,_right_implications_collect,_right_imports_collect,_right_initialTypes,_right_initialValues,_right_methods_collect,_right_nonrecs,_right_pconsigs_col,_right_pktcoll,_right_rawrequest_collect,_right_self) =
            (_right (_left_abstracttps_collect)
                    (_left_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_left_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_left_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_left_funimps_collect)
                    (_lhs_genabs)
                    (_left_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_left_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_local)
                    (_left_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_pconsigs)
                    (_left_pconsigs_col)
                    (_left_pktcoll)
                    (_lhs_pktdist)
                    (_left_rawrequest_collect)
                    (_lhs_toplevel))
    in  (_right_abstracttps_collect
        ,_right_bimapimps_collect
        ,_right_constructors_collect
        ,_right_deps_collect
        ,_left_exports_collect ++ _right_exports_collect
        ,_right_funimps_collect
        ,_right_genabs_collect
        ,_right_implications_collect
        ,_left_imports_collect ++ _right_imports_collect
        ,_left_initialTypes ++ _right_initialTypes
        ,_left_initialValues ++ _right_initialValues
        ,_right_methods_collect
        ,_left_nonrecs ++ _right_nonrecs
        ,_right_pconsigs_col
        ,_right_pktcoll
        ,_lhs_ptscoll
        ,_right_rawrequest_collect
        ,SKind_Arr _left_self _right_self
        )
sem_SKind_Star :: (T_SKind)
sem_SKind_Star (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,SKind_Star)
-- SType -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      ctor                 : QualName
      ctpprefix            : Type -> Type
      eargs                : QualNames
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      isvar                : Maybe QualName
      nonrecs              : [TypedBinding]
      self                 : SType

-}
{-
   local variables for SType.Con:

-}
{-
   local variables for SType.ConCase:

-}
{-
   local variables for SType.Const:

-}
{-
   local variables for SType.Fun:

-}
{-
   local variables for SType.Label:

-}
{-
   local variables for SType.Prod:

-}
{-
   local variables for SType.Sum:

-}
{-
   local variables for SType.Unit:

-}
{-
   local variables for SType.Var:

-}
-- semantic domain
type T_SType = (Set QualName) ->
               ([Request_BimapImply]) ->
               (Maybe QualName) ->
               (Consigs) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Set QualName) ->
               (Set QualName) ->
               (Exports) ->
               ([Request_FunImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               ([Request_TypeImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               (Set QualName) ->
               (Set QualName) ->
               (KSubst) ->
               (Int) ->
               (KSubst) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (PConsigs) ->
               (PConsigs) ->
               (FMap QualName PKT) ->
               (FMap QualName PKT) ->
               (KSubst) ->
               (FMap QualName PTS) ->
               (FMap QualName PTS) ->
               ([RawRequest]) ->
               (Bool) ->
               ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(QualName),(Type -> Type),(FMap QualName QualNames),(QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(Maybe QualName),(KSubst),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(SType))
-- cata
sem_SType :: (SType) ->
             (T_SType)
sem_SType ((SType_Con (_var))) =
    (sem_SType_Con ((sem_QualName (_var))))
sem_SType ((SType_ConCase (_srcloc) (_name))) =
    (sem_SType_ConCase ((sem_Position (_srcloc))) ((sem_QualName (_name))))
sem_SType ((SType_Const (_srcloc) (_name))) =
    (sem_SType_Const ((sem_Position (_srcloc))) ((sem_QualName (_name))))
sem_SType ((SType_Fun )) =
    (sem_SType_Fun )
sem_SType ((SType_Label (_var))) =
    (sem_SType_Label ((sem_QualName (_var))))
sem_SType ((SType_Prod )) =
    (sem_SType_Prod )
sem_SType ((SType_Sum )) =
    (sem_SType_Sum )
sem_SType ((SType_Unit )) =
    (sem_SType_Unit )
sem_SType ((SType_Var (_srcloc) (_name))) =
    (sem_SType_Var ((sem_Position (_srcloc))) ((sem_QualName (_name))))
sem_SType_Con :: (T_QualName) ->
                 (T_SType)
sem_SType_Con (_var)
              (_lhs_abstracttps_collect)
              (_lhs_bimapimps_collect)
              (_lhs_classname)
              (_lhs_consigs)
              (_lhs_constructors_collect)
              (_lhs_constructors_dist)
              (_lhs_currentModule)
              (_lhs_deps)
              (_lhs_deps_collect)
              (_lhs_exportedTypes)
              (_lhs_exportedValues)
              (_lhs_exports)
              (_lhs_funimps_collect)
              (_lhs_genabs)
              (_lhs_genabs_collect)
              (_lhs_hiddenTypes)
              (_lhs_hiddenValues)
              (_lhs_hiding)
              (_lhs_implications_collect)
              (_lhs_impliedTypes)
              (_lhs_impliedValues)
              (_lhs_importedModule)
              (_lhs_importedTypes)
              (_lhs_importedValues)
              (_lhs_kinames)
              (_lhs_kindvar)
              (_lhs_ksubst)
              (_lhs_local)
              (_lhs_methods_collect)
              (_lhs_methods_dist)
              (_lhs_pconsigs)
              (_lhs_pconsigs_col)
              (_lhs_pktcoll)
              (_lhs_pktdist)
              (_lhs_prekind)
              (_lhs_ptscoll)
              (_lhs_ptsdist)
              (_lhs_rawrequest_collect)
              (_lhs_toplevel) =
    let ( _var_abstracttps_collect,_var_bimapimps_collect,_var_constructors_collect,_var_deps_collect,_var_exports_collect,_var_funimps_collect,_var_genabs_collect,_var_implications_collect,_var_imports_collect,_var_initialTypes,_var_initialValues,_var_methods_collect,_var_nonrecs,_var_pconsigs_col,_var_pktcoll,_var_rawrequest_collect,_var_self) =
            (_var (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_toplevel))
    in  (_var_abstracttps_collect
        ,_var_bimapimps_collect
        ,_var_constructors_collect
        ,conName
        ,arr (Type_Var genloc condescrName)
        ,_var_deps_collect
        ,[_var_self]
        ,_var_exports_collect
        ,_var_funimps_collect
        ,_var_genabs_collect
        ,_var_implications_collect
        ,_var_imports_collect
        ,_var_initialTypes
        ,_var_initialValues
        ,Nothing
        ,_lhs_kinames
        ,_lhs_kindvar
        ,_lhs_ksubst
        ,_var_methods_collect
        ,_var_nonrecs
        ,_var_pconsigs_col
        ,_var_pktcoll
        ,_lhs_ptscoll
        ,_var_rawrequest_collect
        ,SType_Con   _var_self
        )
sem_SType_ConCase :: (T_Position) ->
                     (T_QualName) ->
                     (T_SType)
sem_SType_ConCase (_srcloc)
                  (_name)
                  (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_kinames)
                  (_lhs_kindvar)
                  (_lhs_ksubst)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_prekind)
                  (_lhs_ptscoll)
                  (_lhs_ptsdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_toplevel) =
    let ( _srcloc_self) =
            (_srcloc )
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_name_abstracttps_collect
        ,_name_bimapimps_collect
        ,_name_constructors_collect
        ,concaseName _name_self
        ,id
        ,_name_deps_collect
        ,[]
        ,_name_exports_collect
        ,_name_funimps_collect
        ,_name_genabs_collect
        ,_name_implications_collect
        ,_name_imports_collect
        ,_name_initialTypes
        ,_name_initialValues
        ,Nothing
        ,_lhs_kinames
        ,_lhs_kindvar
        ,_lhs_ksubst
        ,_name_methods_collect
        ,_name_nonrecs
        ,_name_pconsigs_col
        ,_name_pktcoll
        ,_lhs_ptscoll
        ,_name_rawrequest_collect
        ,SType_ConCase _srcloc_self _name_self
        )
sem_SType_Const :: (T_Position) ->
                   (T_QualName) ->
                   (T_SType)
sem_SType_Const (_srcloc)
                (_name)
                (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_kinames)
                (_lhs_kindvar)
                (_lhs_ksubst)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_prekind)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_toplevel) =
    let ( _srcloc_self) =
            (_srcloc )
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_name_abstracttps_collect
        ,_name_bimapimps_collect
        ,_name_constructors_collect
        ,_name_self
        ,id
        ,_name_deps_collect
        ,[]
        ,_name_exports_collect
        ,_name_funimps_collect
        ,_name_genabs_collect
        ,_name_implications_collect
        ,_name_imports_collect
        ,_name_initialTypes
        ,_name_initialValues
        ,Nothing
        ,_lhs_kinames
        ,_lhs_kindvar
        ,_lhs_ksubst
        ,_name_methods_collect
        ,_name_nonrecs
        ,_name_pconsigs_col
        ,_name_pktcoll
        ,_lhs_ptscoll
        ,_name_rawrequest_collect
        ,SType_Const   _srcloc_self _name_self
        )
sem_SType_Fun :: (T_SType)
sem_SType_Fun (_lhs_abstracttps_collect)
              (_lhs_bimapimps_collect)
              (_lhs_classname)
              (_lhs_consigs)
              (_lhs_constructors_collect)
              (_lhs_constructors_dist)
              (_lhs_currentModule)
              (_lhs_deps)
              (_lhs_deps_collect)
              (_lhs_exportedTypes)
              (_lhs_exportedValues)
              (_lhs_exports)
              (_lhs_funimps_collect)
              (_lhs_genabs)
              (_lhs_genabs_collect)
              (_lhs_hiddenTypes)
              (_lhs_hiddenValues)
              (_lhs_hiding)
              (_lhs_implications_collect)
              (_lhs_impliedTypes)
              (_lhs_impliedValues)
              (_lhs_importedModule)
              (_lhs_importedTypes)
              (_lhs_importedValues)
              (_lhs_kinames)
              (_lhs_kindvar)
              (_lhs_ksubst)
              (_lhs_local)
              (_lhs_methods_collect)
              (_lhs_methods_dist)
              (_lhs_pconsigs)
              (_lhs_pconsigs_col)
              (_lhs_pktcoll)
              (_lhs_pktdist)
              (_lhs_prekind)
              (_lhs_ptscoll)
              (_lhs_ptsdist)
              (_lhs_rawrequest_collect)
              (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,funName,id,_lhs_deps_collect,[],[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],Nothing,_lhs_kinames,_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,SType_Fun)
sem_SType_Label :: (T_QualName) ->
                   (T_SType)
sem_SType_Label (_var)
                (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_kinames)
                (_lhs_kindvar)
                (_lhs_ksubst)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_prekind)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_toplevel) =
    let ( _var_abstracttps_collect,_var_bimapimps_collect,_var_constructors_collect,_var_deps_collect,_var_exports_collect,_var_funimps_collect,_var_genabs_collect,_var_implications_collect,_var_imports_collect,_var_initialTypes,_var_initialValues,_var_methods_collect,_var_nonrecs,_var_pconsigs_col,_var_pktcoll,_var_rawrequest_collect,_var_self) =
            (_var (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_toplevel))
    in  (_var_abstracttps_collect
        ,_var_bimapimps_collect
        ,_var_constructors_collect
        ,labelName
        ,arr (Type_Var genloc labeldescrName)
        ,_var_deps_collect
        ,[_var_self]
        ,_var_exports_collect
        ,_var_funimps_collect
        ,_var_genabs_collect
        ,_var_implications_collect
        ,_var_imports_collect
        ,_var_initialTypes
        ,_var_initialValues
        ,Nothing
        ,_lhs_kinames
        ,_lhs_kindvar
        ,_lhs_ksubst
        ,_var_methods_collect
        ,_var_nonrecs
        ,_var_pconsigs_col
        ,_var_pktcoll
        ,_lhs_ptscoll
        ,_var_rawrequest_collect
        ,SType_Label _var_self
        )
sem_SType_Prod :: (T_SType)
sem_SType_Prod (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_kinames)
               (_lhs_kindvar)
               (_lhs_ksubst)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_prekind)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,prodName,id,_lhs_deps_collect,[],[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],Nothing,_lhs_kinames,_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,SType_Prod)
sem_SType_Sum :: (T_SType)
sem_SType_Sum (_lhs_abstracttps_collect)
              (_lhs_bimapimps_collect)
              (_lhs_classname)
              (_lhs_consigs)
              (_lhs_constructors_collect)
              (_lhs_constructors_dist)
              (_lhs_currentModule)
              (_lhs_deps)
              (_lhs_deps_collect)
              (_lhs_exportedTypes)
              (_lhs_exportedValues)
              (_lhs_exports)
              (_lhs_funimps_collect)
              (_lhs_genabs)
              (_lhs_genabs_collect)
              (_lhs_hiddenTypes)
              (_lhs_hiddenValues)
              (_lhs_hiding)
              (_lhs_implications_collect)
              (_lhs_impliedTypes)
              (_lhs_impliedValues)
              (_lhs_importedModule)
              (_lhs_importedTypes)
              (_lhs_importedValues)
              (_lhs_kinames)
              (_lhs_kindvar)
              (_lhs_ksubst)
              (_lhs_local)
              (_lhs_methods_collect)
              (_lhs_methods_dist)
              (_lhs_pconsigs)
              (_lhs_pconsigs_col)
              (_lhs_pktcoll)
              (_lhs_pktdist)
              (_lhs_prekind)
              (_lhs_ptscoll)
              (_lhs_ptsdist)
              (_lhs_rawrequest_collect)
              (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,sumName,id,_lhs_deps_collect,[],[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],Nothing,_lhs_kinames,_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,SType_Sum)
sem_SType_Unit :: (T_SType)
sem_SType_Unit (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_kinames)
               (_lhs_kindvar)
               (_lhs_ksubst)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_prekind)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,unitName,id,_lhs_deps_collect,[],[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],Nothing,_lhs_kinames,_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,SType_Unit)
sem_SType_Var :: (T_Position) ->
                 (T_QualName) ->
                 (T_SType)
sem_SType_Var (_srcloc)
              (_name)
              (_lhs_abstracttps_collect)
              (_lhs_bimapimps_collect)
              (_lhs_classname)
              (_lhs_consigs)
              (_lhs_constructors_collect)
              (_lhs_constructors_dist)
              (_lhs_currentModule)
              (_lhs_deps)
              (_lhs_deps_collect)
              (_lhs_exportedTypes)
              (_lhs_exportedValues)
              (_lhs_exports)
              (_lhs_funimps_collect)
              (_lhs_genabs)
              (_lhs_genabs_collect)
              (_lhs_hiddenTypes)
              (_lhs_hiddenValues)
              (_lhs_hiding)
              (_lhs_implications_collect)
              (_lhs_impliedTypes)
              (_lhs_impliedValues)
              (_lhs_importedModule)
              (_lhs_importedTypes)
              (_lhs_importedValues)
              (_lhs_kinames)
              (_lhs_kindvar)
              (_lhs_ksubst)
              (_lhs_local)
              (_lhs_methods_collect)
              (_lhs_methods_dist)
              (_lhs_pconsigs)
              (_lhs_pconsigs_col)
              (_lhs_pktcoll)
              (_lhs_pktdist)
              (_lhs_prekind)
              (_lhs_ptscoll)
              (_lhs_ptsdist)
              (_lhs_rawrequest_collect)
              (_lhs_toplevel) =
    let ( _srcloc_self) =
            (_srcloc )
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_name_abstracttps_collect
        ,_name_bimapimps_collect
        ,_name_constructors_collect
        ,QualName_Plain unkrange (Name_Ident unkrange "")
        ,id
        ,_name_deps_collect
        ,[]
        ,_name_exports_collect
        ,_name_funimps_collect
        ,_name_genabs_collect
        ,_name_implications_collect
        ,_name_imports_collect
        ,_name_initialTypes
        ,_name_initialValues
        ,Just _name_self
        ,_lhs_kinames
        ,_lhs_kindvar
        ,_lhs_ksubst
        ,_name_methods_collect
        ,_name_nonrecs
        ,_name_pconsigs_col
        ,_name_pktcoll
        ,_lhs_ptscoll
        ,_name_rawrequest_collect
        ,SType_Var     _srcloc_self _name_self
        )
-- Stmt --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Stmt

-}
{-
   local variables for Stmt.Empty:

-}
{-
   local variables for Stmt.Expr:

-}
{-
   local variables for Stmt.Gen:

-}
{-
   local variables for Stmt.Let:

-}
-- semantic domain
type T_Stmt = (Set QualName) ->
              ([Request_BimapImply]) ->
              (Maybe QualName) ->
              (Consigs) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Modid) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Set QualName) ->
              (Set QualName) ->
              (Exports) ->
              ([Request_FunImply]) ->
              (Set QualName) ->
              (Set QualName) ->
              (Set QualName) ->
              (Set QualName) ->
              (Bool) ->
              ([Request_TypeImply]) ->
              (Set QualName) ->
              (Set QualName) ->
              (Bool) ->
              (Set QualName) ->
              (Set QualName) ->
              (KSubst) ->
              (KSubst) ->
              (Int) ->
              (KSubst) ->
              (Bool) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Set Modid) ->
              (PConsigs) ->
              (PConsigs) ->
              (FMap QualName PKT) ->
              (FMap QualName PKT) ->
              (KSubst) ->
              (FMap QualName PTS) ->
              (FMap QualName PTS) ->
              ([RawRequest]) ->
              ([RawRequest]) ->
              (Bool) ->
              (Int) ->
              ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Stmt))
-- cata
sem_Stmt :: (Stmt) ->
            (T_Stmt)
sem_Stmt ((Stmt_Empty )) =
    (sem_Stmt_Empty )
sem_Stmt ((Stmt_Expr (_expr))) =
    (sem_Stmt_Expr ((sem_Expr (_expr))))
sem_Stmt ((Stmt_Gen (_pattern) (_body))) =
    (sem_Stmt_Gen ((sem_Pattern (_pattern))) ((sem_Expr (_body))))
sem_Stmt ((Stmt_Let (_decls))) =
    (sem_Stmt_Let ((sem_SDecls (_decls))))
sem_Stmt_Empty :: (T_Stmt)
sem_Stmt_Empty (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_kinames)
               (_lhs_kinds)
               (_lhs_kindvar)
               (_lhs_ksubst)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_modules)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_prekind)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_requests_gas)
               (_lhs_toplevel)
               (_lhs_verbosity) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_kinames,_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,Stmt_Empty)
sem_Stmt_Expr :: (T_Expr) ->
                 (T_Stmt)
sem_Stmt_Expr (_expr)
              (_lhs_abstracttps_collect)
              (_lhs_bimapimps_collect)
              (_lhs_classname)
              (_lhs_consigs)
              (_lhs_constructors_collect)
              (_lhs_constructors_dist)
              (_lhs_currentModule)
              (_lhs_deps)
              (_lhs_deps_collect)
              (_lhs_exportedTypes)
              (_lhs_exportedValues)
              (_lhs_exports)
              (_lhs_funimps_collect)
              (_lhs_genabs)
              (_lhs_genabs_collect)
              (_lhs_hiddenTypes)
              (_lhs_hiddenValues)
              (_lhs_hiding)
              (_lhs_implications_collect)
              (_lhs_impliedTypes)
              (_lhs_impliedValues)
              (_lhs_importedModule)
              (_lhs_importedTypes)
              (_lhs_importedValues)
              (_lhs_kinames)
              (_lhs_kinds)
              (_lhs_kindvar)
              (_lhs_ksubst)
              (_lhs_local)
              (_lhs_methods_collect)
              (_lhs_methods_dist)
              (_lhs_modules)
              (_lhs_pconsigs)
              (_lhs_pconsigs_col)
              (_lhs_pktcoll)
              (_lhs_pktdist)
              (_lhs_prekind)
              (_lhs_ptscoll)
              (_lhs_ptsdist)
              (_lhs_rawrequest_collect)
              (_lhs_requests_gas)
              (_lhs_toplevel)
              (_lhs_verbosity) =
    let ( _expr_abstracttps_collect,_expr_bimapimps_collect,_expr_constructors_collect,_expr_deps_collect,_expr_exports_collect,_expr_funimps_collect,_expr_genabs_collect,_expr_implications_collect,_expr_imports_collect,_expr_initialTypes,_expr_initialValues,_expr_kinames,_expr_kindvar,_expr_ksubst,_expr_linkname,_expr_methods_collect,_expr_nonrecs,_expr_pconsigs_col,_expr_pktcoll,_expr_ptscoll,_expr_rawrequest_collect,_expr_self) =
            (_expr (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_expr_abstracttps_collect,_expr_bimapimps_collect,_expr_constructors_collect,_expr_deps_collect,_expr_exports_collect,_expr_funimps_collect,_expr_genabs_collect,_expr_implications_collect,_expr_imports_collect,_expr_initialTypes,_expr_initialValues,_expr_kinames,_expr_kindvar,_expr_ksubst,_expr_methods_collect,_expr_nonrecs,_expr_pconsigs_col,_expr_pktcoll,_expr_ptscoll,_expr_rawrequest_collect,Stmt_Expr _expr_self)
sem_Stmt_Gen :: (T_Pattern) ->
                (T_Expr) ->
                (T_Stmt)
sem_Stmt_Gen (_pattern)
             (_body)
             (_lhs_abstracttps_collect)
             (_lhs_bimapimps_collect)
             (_lhs_classname)
             (_lhs_consigs)
             (_lhs_constructors_collect)
             (_lhs_constructors_dist)
             (_lhs_currentModule)
             (_lhs_deps)
             (_lhs_deps_collect)
             (_lhs_exportedTypes)
             (_lhs_exportedValues)
             (_lhs_exports)
             (_lhs_funimps_collect)
             (_lhs_genabs)
             (_lhs_genabs_collect)
             (_lhs_hiddenTypes)
             (_lhs_hiddenValues)
             (_lhs_hiding)
             (_lhs_implications_collect)
             (_lhs_impliedTypes)
             (_lhs_impliedValues)
             (_lhs_importedModule)
             (_lhs_importedTypes)
             (_lhs_importedValues)
             (_lhs_kinames)
             (_lhs_kinds)
             (_lhs_kindvar)
             (_lhs_ksubst)
             (_lhs_local)
             (_lhs_methods_collect)
             (_lhs_methods_dist)
             (_lhs_modules)
             (_lhs_pconsigs)
             (_lhs_pconsigs_col)
             (_lhs_pktcoll)
             (_lhs_pktdist)
             (_lhs_prekind)
             (_lhs_ptscoll)
             (_lhs_ptsdist)
             (_lhs_rawrequest_collect)
             (_lhs_requests_gas)
             (_lhs_toplevel)
             (_lhs_verbosity) =
    let ( _pattern_abstracttps_collect,_pattern_bimapimps_collect,_pattern_constructors_collect,_pattern_deps_collect,_pattern_exports_collect,_pattern_funimps_collect,_pattern_genabs_collect,_pattern_implications_collect,_pattern_imports_collect,_pattern_initialTypes,_pattern_initialValues,_pattern_methods_collect,_pattern_nonrecs,_pattern_pconsigs_col,_pattern_pktcoll,_pattern_ptscoll,_pattern_rawrequest_collect,_pattern_self) =
            (_pattern (_lhs_abstracttps_collect)
                      (_lhs_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_lhs_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_lhs_funimps_collect)
                      (_lhs_genabs)
                      (_lhs_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_lhs_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_pconsigs)
                      (_lhs_pconsigs_col)
                      (_lhs_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_ptscoll)
                      (_lhs_ptsdist)
                      (_lhs_rawrequest_collect)
                      (_lhs_toplevel))
        ( _body_abstracttps_collect,_body_bimapimps_collect,_body_constructors_collect,_body_deps_collect,_body_exports_collect,_body_funimps_collect,_body_genabs_collect,_body_implications_collect,_body_imports_collect,_body_initialTypes,_body_initialValues,_body_kinames,_body_kindvar,_body_ksubst,_body_linkname,_body_methods_collect,_body_nonrecs,_body_pconsigs_col,_body_pktcoll,_body_ptscoll,_body_rawrequest_collect,_body_self) =
            (_body (_pattern_abstracttps_collect)
                   (_pattern_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_pattern_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_pattern_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_pattern_funimps_collect)
                   (_lhs_genabs)
                   (_pattern_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_pattern_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_pattern_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_pattern_pconsigs_col)
                   (_pattern_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_pattern_ptscoll)
                   (_lhs_ptsdist)
                   (_pattern_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_toplevel)
                   (_lhs_verbosity))
    in  (_body_abstracttps_collect
        ,_body_bimapimps_collect
        ,_body_constructors_collect
        ,_body_deps_collect
        ,_pattern_exports_collect ++ _body_exports_collect
        ,_body_funimps_collect
        ,_body_genabs_collect
        ,_body_implications_collect
        ,_pattern_imports_collect ++ _body_imports_collect
        ,_pattern_initialTypes ++ _body_initialTypes
        ,_pattern_initialValues ++ _body_initialValues
        ,_body_kinames
        ,_body_kindvar
        ,_body_ksubst
        ,_body_methods_collect
        ,_pattern_nonrecs ++ _body_nonrecs
        ,_body_pconsigs_col
        ,_body_pktcoll
        ,_body_ptscoll
        ,_body_rawrequest_collect
        ,Stmt_Gen _pattern_self _body_self
        )
sem_Stmt_Let :: (T_SDecls) ->
                (T_Stmt)
sem_Stmt_Let (_decls)
             (_lhs_abstracttps_collect)
             (_lhs_bimapimps_collect)
             (_lhs_classname)
             (_lhs_consigs)
             (_lhs_constructors_collect)
             (_lhs_constructors_dist)
             (_lhs_currentModule)
             (_lhs_deps)
             (_lhs_deps_collect)
             (_lhs_exportedTypes)
             (_lhs_exportedValues)
             (_lhs_exports)
             (_lhs_funimps_collect)
             (_lhs_genabs)
             (_lhs_genabs_collect)
             (_lhs_hiddenTypes)
             (_lhs_hiddenValues)
             (_lhs_hiding)
             (_lhs_implications_collect)
             (_lhs_impliedTypes)
             (_lhs_impliedValues)
             (_lhs_importedModule)
             (_lhs_importedTypes)
             (_lhs_importedValues)
             (_lhs_kinames)
             (_lhs_kinds)
             (_lhs_kindvar)
             (_lhs_ksubst)
             (_lhs_local)
             (_lhs_methods_collect)
             (_lhs_methods_dist)
             (_lhs_modules)
             (_lhs_pconsigs)
             (_lhs_pconsigs_col)
             (_lhs_pktcoll)
             (_lhs_pktdist)
             (_lhs_prekind)
             (_lhs_ptscoll)
             (_lhs_ptsdist)
             (_lhs_rawrequest_collect)
             (_lhs_requests_gas)
             (_lhs_toplevel)
             (_lhs_verbosity) =
    let ( _decls_abstracttps_collect
         ,_decls_bimapimps_collect
         ,_decls_constructors_collect
         ,_decls_count
         ,_decls_deps_collect
         ,_decls_exports_collect
         ,_decls_funimps_collect
         ,_decls_genabs_collect
         ,_decls_implications_collect
         ,_decls_imports_collect
         ,_decls_initialTypes
         ,_decls_initialValues
         ,_decls_kinames
         ,_decls_kindvar
         ,_decls_ksubst
         ,_decls_methods_collect
         ,_decls_nil
         ,_decls_nonrecs
         ,_decls_pconsigs_col
         ,_decls_pktcoll
         ,_decls_ptscoll
         ,_decls_rawrequest_collect
         ,_decls_self
         ) =
            (_decls (_lhs_abstracttps_collect)
                    (_lhs_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_lhs_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_lhs_funimps_collect)
                    (_lhs_genabs)
                    (_lhs_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_lhs_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_kinames)
                    (_lhs_kinds)
                    (_lhs_kindvar)
                    (_lhs_ksubst)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_lhs_pconsigs_col)
                    (_lhs_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_lhs_ptscoll)
                    (_lhs_ptsdist)
                    (_lhs_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_toplevel)
                    (_lhs_verbosity))
    in  (_decls_abstracttps_collect,_decls_bimapimps_collect,_decls_constructors_collect,_decls_deps_collect,_decls_exports_collect,_decls_funimps_collect,_decls_genabs_collect,_decls_implications_collect,_decls_imports_collect,_decls_initialTypes,_decls_initialValues,_decls_kinames,_decls_kindvar,_decls_ksubst,_decls_methods_collect,_decls_nonrecs,_decls_pconsigs_col,_decls_pktcoll,_decls_ptscoll,_decls_rawrequest_collect,Stmt_Let _decls_self)
-- Stmts -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      nonrecs              : [TypedBinding]
      self                 : Stmts

-}
{-
   local variables for Stmts.Cons:

-}
{-
   local variables for Stmts.Nil:

-}
-- semantic domain
type T_Stmts = (Set QualName) ->
               ([Request_BimapImply]) ->
               (Maybe QualName) ->
               (Consigs) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Set QualName) ->
               (Set QualName) ->
               (Exports) ->
               ([Request_FunImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               ([Request_TypeImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               (Set QualName) ->
               (Set QualName) ->
               (KSubst) ->
               (KSubst) ->
               (Int) ->
               (KSubst) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Set Modid) ->
               (PConsigs) ->
               (PConsigs) ->
               (FMap QualName PKT) ->
               (FMap QualName PKT) ->
               (KSubst) ->
               (FMap QualName PTS) ->
               (FMap QualName PTS) ->
               ([RawRequest]) ->
               ([RawRequest]) ->
               (Bool) ->
               (Int) ->
               ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Stmts))
-- cata
sem_Stmts :: (Stmts) ->
             (T_Stmts)
sem_Stmts (list) =
    (foldr (sem_Stmts_Cons) (sem_Stmts_Nil) ((map sem_Stmt list)))
sem_Stmts_Cons :: (T_Stmt) ->
                  (T_Stmts) ->
                  (T_Stmts)
sem_Stmts_Cons (_hd)
               (_tl)
               (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_kinames)
               (_lhs_kinds)
               (_lhs_kindvar)
               (_lhs_ksubst)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_modules)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_prekind)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_requests_gas)
               (_lhs_toplevel)
               (_lhs_verbosity) =
    let ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_kinames,_hd_kindvar,_hd_ksubst,_hd_methods_collect,_hd_nonrecs,_hd_pconsigs_col,_hd_pktcoll,_hd_ptscoll,_hd_rawrequest_collect,_hd_self) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kinds)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_initialTypes,_tl_initialValues,_tl_kinames,_tl_kindvar,_tl_ksubst,_tl_methods_collect,_tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_ptscoll,_tl_rawrequest_collect,_tl_self) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_hd_kinames)
                 (_lhs_kinds)
                 (_hd_kindvar)
                 (_hd_ksubst)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_hd_ptscoll)
                 (_lhs_ptsdist)
                 (_hd_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_toplevel)
                 (_lhs_verbosity))
    in  (_tl_abstracttps_collect
        ,_tl_bimapimps_collect
        ,_tl_constructors_collect
        ,_tl_deps_collect
        ,_hd_exports_collect ++ _tl_exports_collect
        ,_tl_funimps_collect
        ,_tl_genabs_collect
        ,_tl_implications_collect
        ,_hd_imports_collect ++ _tl_imports_collect
        ,_hd_initialTypes ++ _tl_initialTypes
        ,_hd_initialValues ++ _tl_initialValues
        ,_tl_kinames
        ,_tl_kindvar
        ,_tl_ksubst
        ,_tl_methods_collect
        ,_hd_nonrecs ++ _tl_nonrecs
        ,_tl_pconsigs_col
        ,_tl_pktcoll
        ,_tl_ptscoll
        ,_tl_rawrequest_collect
        ,_hd_self : _tl_self
        )
sem_Stmts_Nil :: (T_Stmts)
sem_Stmts_Nil (_lhs_abstracttps_collect)
              (_lhs_bimapimps_collect)
              (_lhs_classname)
              (_lhs_consigs)
              (_lhs_constructors_collect)
              (_lhs_constructors_dist)
              (_lhs_currentModule)
              (_lhs_deps)
              (_lhs_deps_collect)
              (_lhs_exportedTypes)
              (_lhs_exportedValues)
              (_lhs_exports)
              (_lhs_funimps_collect)
              (_lhs_genabs)
              (_lhs_genabs_collect)
              (_lhs_hiddenTypes)
              (_lhs_hiddenValues)
              (_lhs_hiding)
              (_lhs_implications_collect)
              (_lhs_impliedTypes)
              (_lhs_impliedValues)
              (_lhs_importedModule)
              (_lhs_importedTypes)
              (_lhs_importedValues)
              (_lhs_kinames)
              (_lhs_kinds)
              (_lhs_kindvar)
              (_lhs_ksubst)
              (_lhs_local)
              (_lhs_methods_collect)
              (_lhs_methods_dist)
              (_lhs_modules)
              (_lhs_pconsigs)
              (_lhs_pconsigs_col)
              (_lhs_pktcoll)
              (_lhs_pktdist)
              (_lhs_prekind)
              (_lhs_ptscoll)
              (_lhs_ptsdist)
              (_lhs_rawrequest_collect)
              (_lhs_requests_gas)
              (_lhs_toplevel)
              (_lhs_verbosity) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_kinames,_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,[])
-- TDecl -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      kinds                : KSubst
      local                : Bool
      methods_dist         : FMap QualName QualNames
      modules              : Set Modid
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      requests_gas         : [RawRequest]
      toplevel             : Bool
      verbosity            : Int

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]
      strtypes             : FMap QualName StrTypeDecl

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      kind_errors          : [GHError]
      nonrecs              : [TypedBinding]
      output               : PP_Doc
      outputi              : [PP_Doc]
      self                 : TDecl
      titypes              : [(QualName,TDecl)]

-}
{-
   local variables for TDecl.Class:
      methods_imported_h
      methods_exported
      is_imported_h
      is_hidden
      is_imported
      is_exported
      classname
      self

-}
{-
   local variables for TDecl.Data:
      implications
      imp_sum
      imp_con
      implications_collect
      kind
      kind_errors
      ksubstKV
      kinames
      new_kinames
      kvar
      kindvar
      is_implied
      subs_imported_h
      subs_exported
      structure_imported
      structure_exported
      is_imported_h
      is_hidden
      is_imported
      is_exported
      self
      contype
      ep
      strtype

-}
{-
   local variables for TDecl.Default:
      self

-}
{-
   local variables for TDecl.Dependency:
      funimps_collect
      is_implied
      is_exported
      self
      deps_collect

-}
{-
   local variables for TDecl.Instance:
      self

-}
{-
   local variables for TDecl.New:
      implications
      imp_con
      implications_collect
      kind
      kind_errors
      ksubstKV
      kinames
      new_kinames
      kvar
      kindvar
      is_implied
      subs_imported_h
      subs_exported
      structure_imported
      structure_exported
      is_imported_h
      is_hidden
      is_imported
      is_exported
      self
      contype
      ep
      strtype

-}
{-
   local variables for TDecl.Poly:
      pkt
      wellformed
      is_imported_h
      is_hidden
      is_imported
      is_exported
      self

-}
{-
   local variables for TDecl.TiType:
      compname
      component
      consig
      pconsigs_col
      first
      kind_errors
      ksubstKV
      kinames
      kvar
      kindvar
      is_imported_h
      is_hidden
      is_imported
      is_exported
      self

-}
{-
   local variables for TDecl.Type:
      implications_collect
      kind
      kind_errors'
      ksubstKV
      kind_errors
      ksubst'
      kinames
      kvar
      kindvar
      is_implied
      is_imported_h
      is_hidden
      is_imported
      is_exported
      self
      ep
      strtype

-}
-- semantic domain
type T_TDecl = (Set QualName) ->
               ([Request_BimapImply]) ->
               (Maybe QualName) ->
               (Consigs) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Set QualName) ->
               (Set QualName) ->
               (Exports) ->
               ([Request_FunImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               ([Request_TypeImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               (Set QualName) ->
               (Set QualName) ->
               (KSubst) ->
               (KSubst) ->
               (Int) ->
               (KSubst) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Set Modid) ->
               (PConsigs) ->
               (PConsigs) ->
               (FMap QualName PKT) ->
               (FMap QualName PKT) ->
               (KSubst) ->
               (FMap QualName PTS) ->
               (FMap QualName PTS) ->
               ([RawRequest]) ->
               ([RawRequest]) ->
               (FMap QualName StrTypeDecl) ->
               (Bool) ->
               (Int) ->
               ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),([GHError]),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PP_Doc),([PP_Doc]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(TDecl),(FMap QualName StrTypeDecl),([(QualName,TDecl)]))
-- cata
sem_TDecl :: (TDecl) ->
             (T_TDecl)
sem_TDecl ((TDecl_Class (_srcloc) (_context) (_name) (_args) (_decls))) =
    (sem_TDecl_Class ((sem_Position (_srcloc))) ((sem_Context (_context))) ((sem_QualName (_name))) ((sem_Args (_args))) ((sem_SDecls (_decls))))
sem_TDecl ((TDecl_Data (_srcloc) (_context) (_name) (_args) (_conss) (_ders))) =
    (sem_TDecl_Data ((sem_Position (_srcloc))) ((sem_Context (_context))) ((sem_QualName (_name))) ((sem_Args (_args))) ((sem_Constrs (_conss))) ((sem_Derivings (_ders))))
sem_TDecl ((TDecl_Default (_srcloc) (_tps))) =
    (sem_TDecl_Default ((sem_Position (_srcloc))) ((sem_Types (_tps))))
sem_TDecl ((TDecl_Dependency (_srcloc) (_istp) (_name) (_names))) =
    (sem_TDecl_Dependency ((sem_Position (_srcloc))) (_istp) ((sem_QualName (_name))) ((sem_QualNames (_names))))
sem_TDecl ((TDecl_Instance (_srcloc) (_context) (_name) (_tps) (_decls))) =
    (sem_TDecl_Instance ((sem_Position (_srcloc))) ((sem_Context (_context))) ((sem_QualName (_name))) ((sem_Types (_tps))) ((sem_SDecls (_decls))))
sem_TDecl ((TDecl_New (_srcloc) (_context) (_name) (_args) (_cons) (_ders))) =
    (sem_TDecl_New ((sem_Position (_srcloc))) ((sem_Context (_context))) ((sem_QualName (_name))) ((sem_Args (_args))) ((sem_Constr (_cons))) ((sem_Derivings (_ders))))
sem_TDecl ((TDecl_Poly (_srcloc) (_name) (_bindings))) =
    (sem_TDecl_Poly ((sem_Position (_srcloc))) ((sem_QualName (_name))) ((sem_TypeBindings (_bindings))))
sem_TDecl ((TDecl_TiType (_srcloc) (_name) (_tp) (_args) (_cons))) =
    (sem_TDecl_TiType ((sem_Position (_srcloc))) ((sem_QualName (_name))) ((sem_SType (_tp))) ((sem_Args (_args))) ((sem_Constr (_cons))))
sem_TDecl ((TDecl_Type (_srcloc) (_name) (_args) (_tp))) =
    (sem_TDecl_Type ((sem_Position (_srcloc))) ((sem_QualName (_name))) ((sem_Args (_args))) ((sem_Type (_tp))))
sem_TDecl_Class :: (T_Position) ->
                   (T_Context) ->
                   (T_QualName) ->
                   (T_Args) ->
                   (T_SDecls) ->
                   (T_TDecl)
sem_TDecl_Class (_srcloc)
                (_context)
                (_name)
                (_args)
                (_decls)
                (_lhs_abstracttps_collect)
                (_lhs_bimapimps_collect)
                (_lhs_classname)
                (_lhs_consigs)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_deps)
                (_lhs_deps_collect)
                (_lhs_exportedTypes)
                (_lhs_exportedValues)
                (_lhs_exports)
                (_lhs_funimps_collect)
                (_lhs_genabs)
                (_lhs_genabs_collect)
                (_lhs_hiddenTypes)
                (_lhs_hiddenValues)
                (_lhs_hiding)
                (_lhs_implications_collect)
                (_lhs_impliedTypes)
                (_lhs_impliedValues)
                (_lhs_importedModule)
                (_lhs_importedTypes)
                (_lhs_importedValues)
                (_lhs_kinames)
                (_lhs_kinds)
                (_lhs_kindvar)
                (_lhs_ksubst)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_modules)
                (_lhs_pconsigs)
                (_lhs_pconsigs_col)
                (_lhs_pktcoll)
                (_lhs_pktdist)
                (_lhs_prekind)
                (_lhs_ptscoll)
                (_lhs_ptsdist)
                (_lhs_rawrequest_collect)
                (_lhs_requests_gas)
                (_lhs_strtypes)
                (_lhs_toplevel)
                (_lhs_verbosity) =
    let (_self) =
            TDecl_Class _srcloc_self _context_self _name_self
                        _args_self _decls_self
        (_classname) =
            Just _name_self
        (_is_exported) =
            _name_self `Set.elementOf` _lhs_exportedTypes
        (_is_imported) =
            _name_self `Set.elementOf` _lhs_importedTypes
        (_is_hidden) =
            _name_self `Set.elementOf` _lhs_hiddenTypes
        (_is_imported_h) =
            if _lhs_hiding then _is_hidden else _is_imported
        (_methods_exported) =
            map (makeExplicitName (not _lhs_local)) $
             filter (`Set.elementOf` _lhs_exportedValues)
                    (findL _decls_methods_collect _name_self)
        (_methods_imported_h) =
            map makePlainName $
             filter (\x -> (x `Set.elementOf` _lhs_exportedValues) &&
                           ((x `Set.elementOf` _lhs_importedValues) /= _lhs_hiding))
                    (findL _decls_methods_collect _name_self)
        ( _srcloc_self) =
            (_srcloc )
        ( _context_abstracttps_collect
         ,_context_bimapimps_collect
         ,_context_constructors_collect
         ,_context_deps_collect
         ,_context_exports_collect
         ,_context_funimps_collect
         ,_context_genabs_collect
         ,_context_implications_collect
         ,_context_imports_collect
         ,_context_initialTypes
         ,_context_initialValues
         ,_context_kinames
         ,_context_kindvar
         ,_context_ksubst
         ,_context_methods_collect
         ,_context_nonrecs
         ,_context_pconsigs_col
         ,_context_pktcoll
         ,_context_ptscoll
         ,_context_rawrequest_collect
         ,_context_self
         ) =
            (_context (_lhs_abstracttps_collect)
                      (_lhs_bimapimps_collect)
                      (_classname)
                      (_lhs_consigs)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_lhs_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_lhs_funimps_collect)
                      (_lhs_genabs)
                      (_lhs_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_lhs_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_lhs_kinames)
                      (_lhs_kindvar)
                      (_lhs_ksubst)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_pconsigs)
                      (_lhs_pconsigs_col)
                      (_lhs_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_prekind)
                      (_lhs_ptscoll)
                      (_lhs_ptsdist)
                      (_lhs_rawrequest_collect)
                      (_lhs_toplevel))
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_context_abstracttps_collect)
                   (_context_bimapimps_collect)
                   (_classname)
                   (_lhs_consigs)
                   (_context_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_context_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_context_funimps_collect)
                   (_lhs_genabs)
                   (_context_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_context_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_context_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_context_pconsigs_col)
                   (_context_pktcoll)
                   (_lhs_pktdist)
                   (_context_rawrequest_collect)
                   (_lhs_toplevel))
        ( _args_abstracttps_collect
         ,_args_bimapimps_collect
         ,_args_constructors_collect
         ,_args_count
         ,_args_deps_collect
         ,_args_exports_collect
         ,_args_funimps_collect
         ,_args_genabs_collect
         ,_args_implications_collect
         ,_args_imports_collect
         ,_args_inferkind
         ,_args_initialTypes
         ,_args_initialValues
         ,_args_kinames
         ,_args_kindvar
         ,_args_ksubst
         ,_args_methods_collect
         ,_args_nil
         ,_args_nonrecs
         ,_args_pconsigs_col
         ,_args_pktcoll
         ,_args_ptscoll
         ,_args_rawrequest_collect
         ,_args_self
         ) =
            (_args (_name_abstracttps_collect)
                   (_name_bimapimps_collect)
                   (_classname)
                   (_lhs_consigs)
                   (_name_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_name_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_name_funimps_collect)
                   (_lhs_genabs)
                   (_name_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_name_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_context_kinames)
                   (_context_kindvar)
                   (_context_ksubst)
                   (_lhs_local)
                   (_name_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_name_pconsigs_col)
                   (_name_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_context_ptscoll)
                   (_lhs_ptsdist)
                   (_name_rawrequest_collect)
                   (False))
        ( _decls_abstracttps_collect
         ,_decls_bimapimps_collect
         ,_decls_constructors_collect
         ,_decls_count
         ,_decls_deps_collect
         ,_decls_exports_collect
         ,_decls_funimps_collect
         ,_decls_genabs_collect
         ,_decls_implications_collect
         ,_decls_imports_collect
         ,_decls_initialTypes
         ,_decls_initialValues
         ,_decls_kinames
         ,_decls_kindvar
         ,_decls_ksubst
         ,_decls_methods_collect
         ,_decls_nil
         ,_decls_nonrecs
         ,_decls_pconsigs_col
         ,_decls_pktcoll
         ,_decls_ptscoll
         ,_decls_rawrequest_collect
         ,_decls_self
         ) =
            (_decls (_args_abstracttps_collect)
                    (_args_bimapimps_collect)
                    (_classname)
                    (_lhs_consigs)
                    (_args_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_args_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_args_funimps_collect)
                    (_lhs_genabs)
                    (_args_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_args_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_args_kinames)
                    (_lhs_kinds)
                    (_args_kindvar)
                    (_args_ksubst)
                    (_lhs_local)
                    (add _lhs_methods_collect
                         (_name_self,[]))
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_args_pconsigs_col)
                    (_args_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_args_ptscoll)
                    (_lhs_ptsdist)
                    (_args_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_toplevel)
                    (_lhs_verbosity))
    in  (_decls_abstracttps_collect
        ,_decls_bimapimps_collect
        ,_decls_constructors_collect
        ,_decls_deps_collect
        ,_context_exports_collect ++ _name_exports_collect ++ _args_exports_collect ++ _decls_exports_collect
        ,_decls_funimps_collect
        ,_decls_genabs_collect
        ,_decls_implications_collect
        ,_context_imports_collect ++ _name_imports_collect ++ _args_imports_collect ++ _decls_imports_collect
        ,_context_initialTypes ++ _name_initialTypes ++ _args_initialTypes ++ _decls_initialTypes
        ,_context_initialValues ++ _name_initialValues ++ _args_initialValues ++ _decls_initialValues
        ,_decls_kinames
        ,[]
        ,_lhs_kindvar
        ,_lhs_ksubst
        ,_decls_methods_collect
        ,_context_nonrecs ++ _name_nonrecs ++ _args_nonrecs ++ _decls_nonrecs
        ,PP.ppTDecl False
                    (TDecl_Class _srcloc_self
                                 _context_self
                                 _name_self
                                 _args_self
                                 (map (ER.replaceSDecl _lhs_deps emptyFM _lhs_genabs) _decls_self)
                    )
        ,[]
        ,_decls_pconsigs_col
        ,_decls_pktcoll
        ,_decls_ptscoll
        ,_decls_rawrequest_collect
        ,_self
        ,_lhs_strtypes
        ,[]
        )
sem_TDecl_Data :: (T_Position) ->
                  (T_Context) ->
                  (T_QualName) ->
                  (T_Args) ->
                  (T_Constrs) ->
                  (T_Derivings) ->
                  (T_TDecl)
sem_TDecl_Data (_srcloc)
               (_context)
               (_name)
               (_args)
               (_conss)
               (_ders)
               (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_kinames)
               (_lhs_kinds)
               (_lhs_kindvar)
               (_lhs_ksubst)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_modules)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_prekind)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_requests_gas)
               (_lhs_strtypes)
               (_lhs_toplevel)
               (_lhs_verbosity) =
    let (_strtype) =
            ST.strtype _self
        (_ep) =
            ST.ep      _self
        (_contype) =
            ST.contype _self
        (_self) =
            TDecl_Data _srcloc_self _context_self _name_self
                       _args_self _conss_self _ders_self
        (_is_exported) =
            _name_self `Set.elementOf` _lhs_exportedTypes
        (_is_imported) =
            _name_self `Set.elementOf` _lhs_importedTypes
        (_is_hidden) =
            _name_self `Set.elementOf` _lhs_hiddenTypes
        (_is_imported_h) =
            if _lhs_hiding then _is_hidden else _is_imported
        (_structure_exported) =
            all (`Set.elementOf` _lhs_exportedValues) _conss_constructors
        (_structure_imported) =
            all (`Set.elementOf` _lhs_importedValues) _conss_constructors
        (_subs_exported) =
            map (makeExplicitName (not _lhs_local)) $
             filter (`Set.elementOf` _lhs_exportedValues) _conss_constructors
        (_subs_imported_h) =
            map makePlainName $
             filter (\x -> (x `Set.elementOf` _lhs_exportedValues) &&
                           ((x `Set.elementOf` _lhs_importedValues) /= _lhs_hiding))
                    _conss_constructors
        (_is_implied) =
            _name_self `Set.elementOf` _lhs_impliedTypes
        (_kindvar) =
            _lhs_kindvar + 1
        (_kvar) =
            mkKindVar' _kindvar
        (_new_kinames) =
            map (\n -> (n,_kvar)) (_name_self : _conss_consname)
        (_kinames) =
            foldl add _lhs_kinames _new_kinames
        ((_ksubstKV,_kind_errors)) =
            unifyToplevel _srcloc_self (PP.ppQualName False _name_self) "data"
                          _kvar _args_inferkind
                          _conss_ksubst
        (_kind) =
            fromJust $ find _lhs_kinds _name_self
        (_implications_collect) =
            Request_TypeImply (Type_Con genloc _name_self
                              ,_implications)
              : _lhs_implications_collect
        (_imp_con) =
            [Type_Con genloc conName]
        (_imp_sum) =
            if   length _conss_self > 1
            then [Type_Con genloc sumName]
            else []
        (_implications) =
            List.nubBy matchType (_imp_con ++ _imp_sum ++ _conss_implications)
        ( _srcloc_self) =
            (_srcloc )
        ( _context_abstracttps_collect
         ,_context_bimapimps_collect
         ,_context_constructors_collect
         ,_context_deps_collect
         ,_context_exports_collect
         ,_context_funimps_collect
         ,_context_genabs_collect
         ,_context_implications_collect
         ,_context_imports_collect
         ,_context_initialTypes
         ,_context_initialValues
         ,_context_kinames
         ,_context_kindvar
         ,_context_ksubst
         ,_context_methods_collect
         ,_context_nonrecs
         ,_context_pconsigs_col
         ,_context_pktcoll
         ,_context_ptscoll
         ,_context_rawrequest_collect
         ,_context_self
         ) =
            (_context (_lhs_abstracttps_collect)
                      (_lhs_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_lhs_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_lhs_funimps_collect)
                      (_lhs_genabs)
                      (_lhs_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_kinames)
                      (_kindvar)
                      (_lhs_ksubst)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_pconsigs)
                      (_lhs_pconsigs_col)
                      (_lhs_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_prekind)
                      (_lhs_ptscoll)
                      (_lhs_ptsdist)
                      (_lhs_rawrequest_collect)
                      (_lhs_toplevel))
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_context_abstracttps_collect)
                   (_context_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_context_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_context_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_context_funimps_collect)
                   (_lhs_genabs)
                   (_context_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_context_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_context_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_context_pconsigs_col)
                   (_context_pktcoll)
                   (_lhs_pktdist)
                   (_context_rawrequest_collect)
                   (_lhs_toplevel))
        ( _args_abstracttps_collect
         ,_args_bimapimps_collect
         ,_args_constructors_collect
         ,_args_count
         ,_args_deps_collect
         ,_args_exports_collect
         ,_args_funimps_collect
         ,_args_genabs_collect
         ,_args_implications_collect
         ,_args_imports_collect
         ,_args_inferkind
         ,_args_initialTypes
         ,_args_initialValues
         ,_args_kinames
         ,_args_kindvar
         ,_args_ksubst
         ,_args_methods_collect
         ,_args_nil
         ,_args_nonrecs
         ,_args_pconsigs_col
         ,_args_pktcoll
         ,_args_ptscoll
         ,_args_rawrequest_collect
         ,_args_self
         ) =
            (_args (_name_abstracttps_collect)
                   (_name_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_name_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_name_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_name_funimps_collect)
                   (_lhs_genabs)
                   (_name_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_name_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_prekind)
                   (_context_kindvar)
                   (_context_ksubst)
                   (_lhs_local)
                   (_name_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_name_pconsigs_col)
                   (_name_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_context_ptscoll)
                   (_lhs_ptsdist)
                   (_name_rawrequest_collect)
                   (False))
        ( _conss_abstracttps_collect
         ,_conss_bimapimps_collect
         ,_conss_consname
         ,_conss_constructors
         ,_conss_constructors_collect
         ,_conss_count
         ,_conss_deps_collect
         ,_conss_exports_collect
         ,_conss_funimps_collect
         ,_conss_genabs_collect
         ,_conss_implications
         ,_conss_implications_collect
         ,_conss_imports_collect
         ,_conss_initialTypes
         ,_conss_initialValues
         ,_conss_kinames
         ,_conss_kind_errors
         ,_conss_kindvar
         ,_conss_ksubst
         ,_conss_methods_collect
         ,_conss_nil
         ,_conss_nonrecs
         ,_conss_pconsigs_col
         ,_conss_pktcoll
         ,_conss_ptscoll
         ,_conss_rawrequest_collect
         ,_conss_self
         ) =
            (_conss (_args_abstracttps_collect)
                    (_args_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_args_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_args_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_args_funimps_collect)
                    (_lhs_genabs)
                    (_args_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_args_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_args_kinames)
                    (_args_kindvar)
                    (_args_ksubst)
                    (_lhs_local)
                    (_args_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_pconsigs)
                    (_args_pconsigs_col)
                    (_args_pktcoll)
                    (_lhs_pktdist)
                    (_args_kinames)
                    (_args_ptscoll)
                    (_lhs_ptsdist)
                    (_args_rawrequest_collect)
                    (_lhs_toplevel)
                    (_name_self))
        ( _ders_abstracttps_collect,_ders_bimapimps_collect,_ders_constructors_collect,_ders_deps_collect,_ders_exports_collect,_ders_funimps_collect,_ders_genabs_collect,_ders_implications_collect,_ders_imports_collect,_ders_initialTypes,_ders_initialValues,_ders_methods_collect,_ders_nonrecs,_ders_pconsigs_col,_ders_pktcoll,_ders_ptscoll,_ders_rawrequest_collect,_ders_self) =
            (_ders (_conss_abstracttps_collect)
                   (_conss_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_conss_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_conss_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_conss_funimps_collect)
                   (_lhs_genabs)
                   (_conss_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_conss_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_conss_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_conss_pconsigs_col)
                   (_conss_pktcoll)
                   (_lhs_pktdist)
                   (_conss_ptscoll)
                   (_lhs_ptsdist)
                   (_conss_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_ders_abstracttps_collect
        ,_ders_bimapimps_collect
        ,add _lhs_constructors_collect
             (_name_self,_conss_constructors)
        ,_ders_deps_collect
        ,_context_exports_collect ++ _name_exports_collect ++ _args_exports_collect ++ _conss_exports_collect ++ _ders_exports_collect
        ,_ders_funimps_collect
        ,_ders_genabs_collect
        ,_ders_implications_collect
        ,_context_imports_collect ++ _name_imports_collect ++ _args_imports_collect ++ _conss_imports_collect ++ _ders_imports_collect
        ,if _structure_exported then [_name_self]
                                else []
        ,_context_initialValues ++ _name_initialValues ++ _args_initialValues ++ _conss_initialValues ++ _ders_initialValues
        ,_kinames
        ,_conss_kind_errors ++ _kind_errors
        ,_conss_kindvar
        ,removeKindVars _kvar _ksubstKV
        ,_ders_methods_collect
        ,_context_nonrecs ++ _name_nonrecs ++ _args_nonrecs ++ _conss_nonrecs ++ _ders_nonrecs
        ,let kc = mkKindComment _name_self _kind
             sc = mkStrTypeComment _name_self
             ec = mkEPComment _name_self
         in  vlist [ kc, PP.ppTDecl        False _self
                   ,     PP.ppTDecls       False _contype
                   , sc, PP.ppStrTypeDecls       _strtype
                   , ec, PP.ppTBs          False _ep
                   ]
        ,if   _is_implied
         then [PPI.ppiTDecl _self]
         else if   _is_exported
              then [PPI.ppiAbstract _name_self _subs_exported _kind]
              else []
        ,_ders_pconsigs_col
        ,_ders_pktcoll
        ,_ders_ptscoll
        ,_ders_rawrequest_collect
        ,_self
        ,foldl add _lhs_strtypes (map (\st@(StrTypeDecl_Decl tpn _ _) -> (tpn,st)) _strtype)
        ,[]
        )
sem_TDecl_Default :: (T_Position) ->
                     (T_Types) ->
                     (T_TDecl)
sem_TDecl_Default (_srcloc)
                  (_tps)
                  (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_kinames)
                  (_lhs_kinds)
                  (_lhs_kindvar)
                  (_lhs_ksubst)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_modules)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_prekind)
                  (_lhs_ptscoll)
                  (_lhs_ptsdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_requests_gas)
                  (_lhs_strtypes)
                  (_lhs_toplevel)
                  (_lhs_verbosity) =
    let (_self) =
            TDecl_Default _srcloc_self _tps_self
        ( _srcloc_self) =
            (_srcloc )
        ( _tps_abstracttps_collect,_tps_bimapimps_collect,_tps_constructors_collect,_tps_count,_tps_deps_collect,_tps_exports_collect,_tps_funimps_collect,_tps_genabs_collect,_tps_implications_collect,_tps_imports_collect,_tps_initialTypes,_tps_initialValues,_tps_kinames,_tps_kind_errors,_tps_kindvar,_tps_ksubst,_tps_methods_collect,_tps_nil,_tps_nonrecs,_tps_pconsigs_col,_tps_pktcoll,_tps_ptscoll,_tps_rawrequest_collect,_tps_self) =
            (_tps (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_kinames)
                  (_lhs_kindvar)
                  (_lhs_ksubst)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_prekind)
                  (_lhs_ptscoll)
                  (_lhs_ptsdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_toplevel))
    in  (_tps_abstracttps_collect,_tps_bimapimps_collect,_tps_constructors_collect,_tps_deps_collect,_tps_exports_collect,_tps_funimps_collect,_tps_genabs_collect,_tps_implications_collect,_tps_imports_collect,_tps_initialTypes,_tps_initialValues,_tps_kinames,[],_lhs_kindvar,_lhs_ksubst,_tps_methods_collect,_tps_nonrecs,PP.ppTDecl False _self,[],_tps_pconsigs_col,_tps_pktcoll,_tps_ptscoll,_tps_rawrequest_collect,_self,_lhs_strtypes,[])
sem_TDecl_Dependency :: (T_Position) ->
                        (Bool) ->
                        (T_QualName) ->
                        (T_QualNames) ->
                        (T_TDecl)
sem_TDecl_Dependency (_srcloc)
                     (_istp)
                     (_name)
                     (_names)
                     (_lhs_abstracttps_collect)
                     (_lhs_bimapimps_collect)
                     (_lhs_classname)
                     (_lhs_consigs)
                     (_lhs_constructors_collect)
                     (_lhs_constructors_dist)
                     (_lhs_currentModule)
                     (_lhs_deps)
                     (_lhs_deps_collect)
                     (_lhs_exportedTypes)
                     (_lhs_exportedValues)
                     (_lhs_exports)
                     (_lhs_funimps_collect)
                     (_lhs_genabs)
                     (_lhs_genabs_collect)
                     (_lhs_hiddenTypes)
                     (_lhs_hiddenValues)
                     (_lhs_hiding)
                     (_lhs_implications_collect)
                     (_lhs_impliedTypes)
                     (_lhs_impliedValues)
                     (_lhs_importedModule)
                     (_lhs_importedTypes)
                     (_lhs_importedValues)
                     (_lhs_kinames)
                     (_lhs_kinds)
                     (_lhs_kindvar)
                     (_lhs_ksubst)
                     (_lhs_local)
                     (_lhs_methods_collect)
                     (_lhs_methods_dist)
                     (_lhs_modules)
                     (_lhs_pconsigs)
                     (_lhs_pconsigs_col)
                     (_lhs_pktcoll)
                     (_lhs_pktdist)
                     (_lhs_prekind)
                     (_lhs_ptscoll)
                     (_lhs_ptsdist)
                     (_lhs_rawrequest_collect)
                     (_lhs_requests_gas)
                     (_lhs_strtypes)
                     (_lhs_toplevel)
                     (_lhs_verbosity) =
    let (_deps_collect) =
            add _lhs_deps_collect
                (_name_self,_names_self)
        (_self) =
            TDecl_Dependency _srcloc_self _istp _name_self _names_self
        (_is_exported) =
            (  _name_self `Set.elementOf` _lhs_exportedValues
            || _name_self `Set.elementOf` _lhs_exportedTypes
            )
        (_is_implied) =
            (  _name_self `Set.elementOf` _lhs_impliedTypes
            || _name_self `Set.elementOf` _lhs_impliedValues
            )
        (_funimps_collect) =
            Request_FunImply  (_name_self
                              ,map (\ n -> RawRequest (n,
                                Type_Lam (head varNames)
                                         (Type_Var genloc (head varNames))
                                   )) _names_self
                              )
              : _lhs_funimps_collect
        ( _srcloc_self) =
            (_srcloc )
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
        ( _names_abstracttps_collect,_names_bimapimps_collect,_names_constructors_collect,_names_deps_collect,_names_exports_collect,_names_funimps_collect,_names_genabs_collect,_names_implications_collect,_names_imports_collect,_names_initialTypes,_names_initialValues,_names_methods_collect,_names_nonrecs,_names_pconsigs_col,_names_pktcoll,_names_rawrequest_collect,_names_self) =
            (_names (_name_abstracttps_collect)
                    (_name_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_name_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_name_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_name_funimps_collect)
                    (_lhs_genabs)
                    (_name_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_name_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_lhs_local)
                    (_name_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_pconsigs)
                    (_name_pconsigs_col)
                    (_name_pktcoll)
                    (_lhs_pktdist)
                    (_name_rawrequest_collect)
                    (_lhs_toplevel))
    in  (_names_abstracttps_collect
        ,_names_bimapimps_collect
        ,_names_constructors_collect
        ,_names_deps_collect
        ,_name_exports_collect ++ _names_exports_collect
        ,_names_funimps_collect
        ,_names_genabs_collect
        ,_names_implications_collect
        ,_name_imports_collect ++ _names_imports_collect
        ,_name_initialTypes ++ _names_initialTypes
        ,_name_initialValues ++ _names_initialValues
        ,_lhs_kinames
        ,[]
        ,_lhs_kindvar
        ,_lhs_ksubst
        ,_names_methods_collect
        ,_name_nonrecs ++ _names_nonrecs
        ,empty
        ,if   _is_implied || _is_exported
         then [PPI.ppiTDecl _self]
         else []
        ,_names_pconsigs_col
        ,_names_pktcoll
        ,_lhs_ptscoll
        ,_names_rawrequest_collect
        ,_self
        ,_lhs_strtypes
        ,[]
        )
sem_TDecl_Instance :: (T_Position) ->
                      (T_Context) ->
                      (T_QualName) ->
                      (T_Types) ->
                      (T_SDecls) ->
                      (T_TDecl)
sem_TDecl_Instance (_srcloc)
                   (_context)
                   (_name)
                   (_tps)
                   (_decls)
                   (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kinds)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_modules)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_requests_gas)
                   (_lhs_strtypes)
                   (_lhs_toplevel)
                   (_lhs_verbosity) =
    let (_self) =
            TDecl_Instance _srcloc_self _context_self _name_self
                           _tps_self _decls_self
        ( _srcloc_self) =
            (_srcloc )
        ( _context_abstracttps_collect
         ,_context_bimapimps_collect
         ,_context_constructors_collect
         ,_context_deps_collect
         ,_context_exports_collect
         ,_context_funimps_collect
         ,_context_genabs_collect
         ,_context_implications_collect
         ,_context_imports_collect
         ,_context_initialTypes
         ,_context_initialValues
         ,_context_kinames
         ,_context_kindvar
         ,_context_ksubst
         ,_context_methods_collect
         ,_context_nonrecs
         ,_context_pconsigs_col
         ,_context_pktcoll
         ,_context_ptscoll
         ,_context_rawrequest_collect
         ,_context_self
         ) =
            (_context (_lhs_abstracttps_collect)
                      (_lhs_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_lhs_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_lhs_funimps_collect)
                      (_lhs_genabs)
                      (_lhs_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_lhs_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_lhs_kinames)
                      (_lhs_kindvar)
                      (_lhs_ksubst)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_pconsigs)
                      (_lhs_pconsigs_col)
                      (_lhs_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_prekind)
                      (_lhs_ptscoll)
                      (_lhs_ptsdist)
                      (_lhs_rawrequest_collect)
                      (_lhs_toplevel))
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_context_abstracttps_collect)
                   (_context_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_context_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_context_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_context_funimps_collect)
                   (_lhs_genabs)
                   (_context_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_context_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_context_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_context_pconsigs_col)
                   (_context_pktcoll)
                   (_lhs_pktdist)
                   (_context_rawrequest_collect)
                   (_lhs_toplevel))
        ( _tps_abstracttps_collect,_tps_bimapimps_collect,_tps_constructors_collect,_tps_count,_tps_deps_collect,_tps_exports_collect,_tps_funimps_collect,_tps_genabs_collect,_tps_implications_collect,_tps_imports_collect,_tps_initialTypes,_tps_initialValues,_tps_kinames,_tps_kind_errors,_tps_kindvar,_tps_ksubst,_tps_methods_collect,_tps_nil,_tps_nonrecs,_tps_pconsigs_col,_tps_pktcoll,_tps_ptscoll,_tps_rawrequest_collect,_tps_self) =
            (_tps (_name_abstracttps_collect)
                  (_name_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_name_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_name_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_name_funimps_collect)
                  (_lhs_genabs)
                  (_name_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_name_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_context_kinames)
                  (_context_kindvar)
                  (_context_ksubst)
                  (_lhs_local)
                  (_name_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_name_pconsigs_col)
                  (_name_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_prekind)
                  (_context_ptscoll)
                  (_lhs_ptsdist)
                  (_name_rawrequest_collect)
                  (_lhs_toplevel))
        ( _decls_abstracttps_collect
         ,_decls_bimapimps_collect
         ,_decls_constructors_collect
         ,_decls_count
         ,_decls_deps_collect
         ,_decls_exports_collect
         ,_decls_funimps_collect
         ,_decls_genabs_collect
         ,_decls_implications_collect
         ,_decls_imports_collect
         ,_decls_initialTypes
         ,_decls_initialValues
         ,_decls_kinames
         ,_decls_kindvar
         ,_decls_ksubst
         ,_decls_methods_collect
         ,_decls_nil
         ,_decls_nonrecs
         ,_decls_pconsigs_col
         ,_decls_pktcoll
         ,_decls_ptscoll
         ,_decls_rawrequest_collect
         ,_decls_self
         ) =
            (_decls (_tps_abstracttps_collect)
                    (_tps_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_tps_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_tps_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_tps_funimps_collect)
                    (_lhs_genabs)
                    (_tps_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_tps_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_tps_kinames)
                    (_lhs_kinds)
                    (_tps_kindvar)
                    (_tps_ksubst)
                    (_lhs_local)
                    (_tps_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_modules)
                    (_lhs_pconsigs)
                    (_tps_pconsigs_col)
                    (_tps_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_tps_ptscoll)
                    (_lhs_ptsdist)
                    (_tps_rawrequest_collect)
                    (_lhs_requests_gas)
                    (_lhs_toplevel)
                    (_lhs_verbosity))
    in  (_decls_abstracttps_collect
        ,_decls_bimapimps_collect
        ,_decls_constructors_collect
        ,_decls_deps_collect
        ,[]
        ,_decls_funimps_collect
        ,_decls_genabs_collect
        ,_decls_implications_collect
        ,[]
        ,_context_initialTypes ++ _name_initialTypes ++ _tps_initialTypes ++ _decls_initialTypes
        ,_context_initialValues ++ _name_initialValues ++ _tps_initialValues ++ _decls_initialValues
        ,_decls_kinames
        ,[]
        ,_lhs_kindvar
        ,_lhs_ksubst
        ,_decls_methods_collect
        ,_context_nonrecs ++ _name_nonrecs ++ _tps_nonrecs ++ _decls_nonrecs
        ,PP.ppTDecl False
                    (TDecl_Instance _srcloc_self
                                    _context_self
                                    _name_self
                                    _tps_self
                                    (map (ER.replaceSDecl _lhs_deps emptyFM _lhs_genabs) _decls_self)
                    )
        ,[]
        ,_decls_pconsigs_col
        ,_decls_pktcoll
        ,_decls_ptscoll
        ,_decls_rawrequest_collect
        ,_self
        ,_lhs_strtypes
        ,[]
        )
sem_TDecl_New :: (T_Position) ->
                 (T_Context) ->
                 (T_QualName) ->
                 (T_Args) ->
                 (T_Constr) ->
                 (T_Derivings) ->
                 (T_TDecl)
sem_TDecl_New (_srcloc)
              (_context)
              (_name)
              (_args)
              (_cons)
              (_ders)
              (_lhs_abstracttps_collect)
              (_lhs_bimapimps_collect)
              (_lhs_classname)
              (_lhs_consigs)
              (_lhs_constructors_collect)
              (_lhs_constructors_dist)
              (_lhs_currentModule)
              (_lhs_deps)
              (_lhs_deps_collect)
              (_lhs_exportedTypes)
              (_lhs_exportedValues)
              (_lhs_exports)
              (_lhs_funimps_collect)
              (_lhs_genabs)
              (_lhs_genabs_collect)
              (_lhs_hiddenTypes)
              (_lhs_hiddenValues)
              (_lhs_hiding)
              (_lhs_implications_collect)
              (_lhs_impliedTypes)
              (_lhs_impliedValues)
              (_lhs_importedModule)
              (_lhs_importedTypes)
              (_lhs_importedValues)
              (_lhs_kinames)
              (_lhs_kinds)
              (_lhs_kindvar)
              (_lhs_ksubst)
              (_lhs_local)
              (_lhs_methods_collect)
              (_lhs_methods_dist)
              (_lhs_modules)
              (_lhs_pconsigs)
              (_lhs_pconsigs_col)
              (_lhs_pktcoll)
              (_lhs_pktdist)
              (_lhs_prekind)
              (_lhs_ptscoll)
              (_lhs_ptsdist)
              (_lhs_rawrequest_collect)
              (_lhs_requests_gas)
              (_lhs_strtypes)
              (_lhs_toplevel)
              (_lhs_verbosity) =
    let (_strtype) =
            ST.strtype _self
        (_ep) =
            ST.ep      _self
        (_contype) =
            ST.contype _self
        (_self) =
            TDecl_New _srcloc_self _context_self _name_self
                      _args_self _cons_self _ders_self
        (_is_exported) =
            _name_self `Set.elementOf` _lhs_exportedTypes
        (_is_imported) =
            _name_self `Set.elementOf` _lhs_importedTypes
        (_is_hidden) =
            _name_self `Set.elementOf` _lhs_hiddenTypes
        (_is_imported_h) =
            if _lhs_hiding then _is_hidden else _is_imported
        (_structure_exported) =
            all (`Set.elementOf` _lhs_exportedValues) _cons_constructors
        (_structure_imported) =
            all (`Set.elementOf` _lhs_importedValues) _cons_constructors
        (_subs_exported) =
            map (makeExplicitName (not _lhs_local)) $
             filter (`Set.elementOf` _lhs_exportedValues) _cons_constructors
        (_subs_imported_h) =
            map makePlainName $
             filter (\x -> (x `Set.elementOf` _lhs_exportedValues) &&
                           ((x `Set.elementOf` _lhs_importedValues) /= _lhs_hiding))
                    _cons_constructors
        (_is_implied) =
            _name_self `Set.elementOf` _lhs_impliedTypes
        (_kindvar) =
            _lhs_kindvar + 1
        (_kvar) =
            mkKindVar' _kindvar
        (_new_kinames) =
            map (\n -> (n,_kvar)) [_name_self, _cons_consname]
        (_kinames) =
            foldl add _lhs_kinames _new_kinames
        ((_ksubstKV,_kind_errors)) =
            unifyToplevel _srcloc_self (PP.ppQualName False _name_self) "newtype"
                          _kvar _args_inferkind
                          _cons_ksubst
        (_kind) =
            fromJust $ find _lhs_kinds _name_self
        (_implications_collect) =
            Request_TypeImply (Type_Con genloc _name_self
                              ,_implications)
              : _lhs_implications_collect
        (_imp_con) =
            [Type_Con genloc conName]
        (_implications) =
            _imp_con ++ _cons_implications
        ( _srcloc_self) =
            (_srcloc )
        ( _context_abstracttps_collect
         ,_context_bimapimps_collect
         ,_context_constructors_collect
         ,_context_deps_collect
         ,_context_exports_collect
         ,_context_funimps_collect
         ,_context_genabs_collect
         ,_context_implications_collect
         ,_context_imports_collect
         ,_context_initialTypes
         ,_context_initialValues
         ,_context_kinames
         ,_context_kindvar
         ,_context_ksubst
         ,_context_methods_collect
         ,_context_nonrecs
         ,_context_pconsigs_col
         ,_context_pktcoll
         ,_context_ptscoll
         ,_context_rawrequest_collect
         ,_context_self
         ) =
            (_context (_lhs_abstracttps_collect)
                      (_lhs_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_lhs_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_lhs_funimps_collect)
                      (_lhs_genabs)
                      (_lhs_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_kinames)
                      (_kindvar)
                      (_lhs_ksubst)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_pconsigs)
                      (_lhs_pconsigs_col)
                      (_lhs_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_prekind)
                      (_lhs_ptscoll)
                      (_lhs_ptsdist)
                      (_lhs_rawrequest_collect)
                      (_lhs_toplevel))
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_context_abstracttps_collect)
                   (_context_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_context_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_context_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_context_funimps_collect)
                   (_lhs_genabs)
                   (_context_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_context_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_context_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_context_pconsigs_col)
                   (_context_pktcoll)
                   (_lhs_pktdist)
                   (_context_rawrequest_collect)
                   (_lhs_toplevel))
        ( _args_abstracttps_collect
         ,_args_bimapimps_collect
         ,_args_constructors_collect
         ,_args_count
         ,_args_deps_collect
         ,_args_exports_collect
         ,_args_funimps_collect
         ,_args_genabs_collect
         ,_args_implications_collect
         ,_args_imports_collect
         ,_args_inferkind
         ,_args_initialTypes
         ,_args_initialValues
         ,_args_kinames
         ,_args_kindvar
         ,_args_ksubst
         ,_args_methods_collect
         ,_args_nil
         ,_args_nonrecs
         ,_args_pconsigs_col
         ,_args_pktcoll
         ,_args_ptscoll
         ,_args_rawrequest_collect
         ,_args_self
         ) =
            (_args (_name_abstracttps_collect)
                   (_name_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_name_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_name_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_name_funimps_collect)
                   (_lhs_genabs)
                   (_name_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_name_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_prekind)
                   (_context_kindvar)
                   (_context_ksubst)
                   (_lhs_local)
                   (_name_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_name_pconsigs_col)
                   (_name_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_context_ptscoll)
                   (_lhs_ptsdist)
                   (_name_rawrequest_collect)
                   (False))
        ( _cons_abstracttps_collect
         ,_cons_arity
         ,_cons_bimapimps_collect
         ,_cons_consname
         ,_cons_constructors
         ,_cons_constructors_collect
         ,_cons_deps_collect
         ,_cons_exports_collect
         ,_cons_funimps_collect
         ,_cons_genabs_collect
         ,_cons_hasLabels
         ,_cons_implications
         ,_cons_implications_collect
         ,_cons_imports_collect
         ,_cons_initialTypes
         ,_cons_initialValues
         ,_cons_kinames
         ,_cons_kind_errors
         ,_cons_kindvar
         ,_cons_ksubst
         ,_cons_methods_collect
         ,_cons_nonrecs
         ,_cons_pconsigs_col
         ,_cons_pktcoll
         ,_cons_ptscoll
         ,_cons_rawrequest_collect
         ,_cons_self
         ) =
            (_cons (_args_abstracttps_collect)
                   (_args_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_args_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_args_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_args_funimps_collect)
                   (_lhs_genabs)
                   (_args_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_args_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_args_kinames)
                   (_args_kindvar)
                   (_args_ksubst)
                   (_lhs_local)
                   (_args_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_args_pconsigs_col)
                   (_args_pktcoll)
                   (_lhs_pktdist)
                   (_args_kinames)
                   (_args_ptscoll)
                   (_lhs_ptsdist)
                   (_args_rawrequest_collect)
                   (_lhs_toplevel)
                   (_name_self))
        ( _ders_abstracttps_collect,_ders_bimapimps_collect,_ders_constructors_collect,_ders_deps_collect,_ders_exports_collect,_ders_funimps_collect,_ders_genabs_collect,_ders_implications_collect,_ders_imports_collect,_ders_initialTypes,_ders_initialValues,_ders_methods_collect,_ders_nonrecs,_ders_pconsigs_col,_ders_pktcoll,_ders_ptscoll,_ders_rawrequest_collect,_ders_self) =
            (_ders (_cons_abstracttps_collect)
                   (_cons_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_cons_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_cons_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_cons_funimps_collect)
                   (_lhs_genabs)
                   (_cons_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_cons_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_cons_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_cons_pconsigs_col)
                   (_cons_pktcoll)
                   (_lhs_pktdist)
                   (_cons_ptscoll)
                   (_lhs_ptsdist)
                   (_cons_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_ders_abstracttps_collect
        ,_ders_bimapimps_collect
        ,add _lhs_constructors_collect
             (_name_self,_cons_constructors)
        ,_ders_deps_collect
        ,_context_exports_collect ++ _name_exports_collect ++ _args_exports_collect ++ _cons_exports_collect ++ _ders_exports_collect
        ,_ders_funimps_collect
        ,_ders_genabs_collect
        ,_ders_implications_collect
        ,_context_imports_collect ++ _name_imports_collect ++ _args_imports_collect ++ _cons_imports_collect ++ _ders_imports_collect
        ,if _structure_exported then [_name_self]
                                else []
        ,_context_initialValues ++ _name_initialValues ++ _args_initialValues ++ _cons_initialValues ++ _ders_initialValues
        ,_kinames
        ,_cons_kind_errors ++ _kind_errors
        ,_cons_kindvar
        ,removeKindVars _kvar _ksubstKV
        ,_ders_methods_collect
        ,_context_nonrecs ++ _name_nonrecs ++ _args_nonrecs ++ _cons_nonrecs ++ _ders_nonrecs
        ,let kc = mkKindComment _name_self _kind
             sc = mkStrTypeComment _name_self
             ec = mkEPComment _name_self
         in  vlist [ kc, PP.ppTDecl        False _self
                   ,     PP.ppTDecls       False _contype
                   , sc, PP.ppStrTypeDecls       _strtype
                   , ec, PP.ppTBs          False _ep
                   ]
        ,if   _is_implied
         then [PPI.ppiTDecl _self]
         else if   _is_exported
              then [PPI.ppiAbstract _name_self _subs_exported _kind]
              else []
        ,_ders_pconsigs_col
        ,_ders_pktcoll
        ,_ders_ptscoll
        ,_ders_rawrequest_collect
        ,_self
        ,foldl add _lhs_strtypes (map (\st@(StrTypeDecl_Decl tpn _ _) -> (tpn,st)) _strtype)
        ,[]
        )
sem_TDecl_Poly :: (T_Position) ->
                  (T_QualName) ->
                  (T_TypeBindings) ->
                  (T_TDecl)
sem_TDecl_Poly (_srcloc)
               (_name)
               (_bindings)
               (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_kinames)
               (_lhs_kinds)
               (_lhs_kindvar)
               (_lhs_ksubst)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_modules)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_prekind)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_requests_gas)
               (_lhs_strtypes)
               (_lhs_toplevel)
               (_lhs_verbosity) =
    let (_self) =
            TDecl_Poly _srcloc_self _name_self _bindings_self
        (_is_exported) =
            _name_self `Set.elementOf` _lhs_exportedTypes
        (_is_imported) =
            _name_self `Set.elementOf` _lhs_importedTypes
        (_is_hidden) =
            _name_self `Set.elementOf` _lhs_hiddenTypes
        (_is_imported_h) =
            if _lhs_hiding then _is_hidden else _is_imported
        (_wellformed) =
            _bindings_wellformed
        (_pkt) =
            TRR.makePKT _bindings_self _lhs_pktdist
        ( _srcloc_self) =
            (_srcloc )
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
        ( _bindings_abstracttps_collect
         ,_bindings_bimapimps_collect
         ,_bindings_constructors_collect
         ,_bindings_deps_collect
         ,_bindings_exports_collect
         ,_bindings_funimps_collect
         ,_bindings_genabs_collect
         ,_bindings_implications_collect
         ,_bindings_imports_collect
         ,_bindings_initialTypes
         ,_bindings_initialValues
         ,_bindings_kinames
         ,_bindings_kind
         ,_bindings_kind_errors
         ,_bindings_kindvar
         ,_bindings_ksubst
         ,_bindings_methods_collect
         ,_bindings_nonrecs
         ,_bindings_pconsigs_col
         ,_bindings_pktcoll
         ,_bindings_ptscoll
         ,_bindings_rawrequest_collect
         ,_bindings_self
         ,_bindings_wellformed
         ) =
            (_bindings (_name_abstracttps_collect)
                       (_name_bimapimps_collect)
                       (_lhs_classname)
                       (_lhs_consigs)
                       (_name_constructors_collect)
                       (_lhs_constructors_dist)
                       (_lhs_currentModule)
                       (_lhs_deps)
                       (_name_deps_collect)
                       (_lhs_exportedTypes)
                       (_lhs_exportedValues)
                       (_lhs_exports)
                       (_name_funimps_collect)
                       (_lhs_genabs)
                       (_name_genabs_collect)
                       (_lhs_hiddenTypes)
                       (_lhs_hiddenValues)
                       (_lhs_hiding)
                       (_name_implications_collect)
                       (_lhs_impliedTypes)
                       (_lhs_impliedValues)
                       (_lhs_importedModule)
                       (_lhs_importedTypes)
                       (_lhs_importedValues)
                       (_lhs_kinames)
                       (_lhs_kindvar)
                       (_lhs_ksubst)
                       (_lhs_local)
                       (_name_methods_collect)
                       (_lhs_methods_dist)
                       (_lhs_pconsigs)
                       (_name_pconsigs_col)
                       (_name_pktcoll)
                       (_lhs_pktdist)
                       (_lhs_prekind)
                       (_lhs_ptscoll)
                       (_lhs_ptsdist)
                       (_name_rawrequest_collect)
                       (False))
    in  (_bindings_abstracttps_collect
        ,_bindings_bimapimps_collect
        ,_bindings_constructors_collect
        ,_bindings_deps_collect
        ,[]
        ,_bindings_funimps_collect
        ,_bindings_genabs_collect
        ,_bindings_implications_collect
        ,[]
        ,_name_initialTypes ++ _bindings_initialTypes
        ,_name_initialValues ++ _bindings_initialValues
        ,_lhs_kinames
        ,[]
        ,_lhs_kindvar
        ,_lhs_ksubst
        ,_bindings_methods_collect
        ,_name_nonrecs ++ _bindings_nonrecs
        ,empty
        ,if _is_exported then [PPI.ppiTDecl _self] else []
        ,_bindings_pconsigs_col
        ,add _lhs_pktcoll (_name_self,_pkt)
        ,_bindings_ptscoll
        ,_bindings_rawrequest_collect
        ,_self
        ,_lhs_strtypes
        ,[]
        )
sem_TDecl_TiType :: (T_Position) ->
                    (T_QualName) ->
                    (T_SType) ->
                    (T_Args) ->
                    (T_Constr) ->
                    (T_TDecl)
sem_TDecl_TiType (_srcloc)
                 (_name)
                 (_tp)
                 (_args)
                 (_cons)
                 (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kinds)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_modules)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_requests_gas)
                 (_lhs_strtypes)
                 (_lhs_toplevel)
                 (_lhs_verbosity) =
    let (_self) =
            TDecl_TiType _srcloc_self _name_self _tp_self _args_self
                         _cons_self
        (_is_exported) =
            _name_self `Set.elementOf` _lhs_exportedTypes
        (_is_imported) =
            _name_self `Set.elementOf` _lhs_importedTypes
        (_is_hidden) =
            _name_self `Set.elementOf` _lhs_hiddenTypes
        (_is_imported_h) =
            if _lhs_hiding then _is_hidden else _is_imported
        (_kindvar) =
            _lhs_kindvar + 1
        (_kvar) =
            mkKindVar' _kindvar
        (_kinames) =
            add _lhs_kinames (_compname
                             ,_kvar)
        ((_ksubstKV,_kind_errors)) =
            unifyToplevel _srcloc_self (PP.ppQualName False _name_self) "type-indexed type"
                          _kvar _args_inferkind
                          _cons_ksubst
        (_first) =
            case find _lhs_pconsigs_col _name_self of
              Nothing -> True
              Just _  -> False
        (_pconsigs_col) =
            if   _first
            then add _lhs_pconsigs_col (_name_self,([],Nothing))
            else _lhs_pconsigs_col
        (_consig) =
            case find _lhs_consigs _name_self of
              Nothing -> internalError "Consig.TDecl.TiType.consig: consig not found"
              Just x  -> x
        (_component) =
            TDecl_New genloc
                      Context_Empty
                      _compname
                      _args_self
                      _cons_self
                      [QualName_Plain unkrange (Name_Ident unkrange "Show")]
        (_compname) =
            componentTITName _name_self _tp_ctor
        ( _srcloc_self) =
            (_srcloc )
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
        ( _tp_abstracttps_collect,_tp_bimapimps_collect,_tp_constructors_collect,_tp_ctor,_tp_ctpprefix,_tp_deps_collect,_tp_eargs,_tp_exports_collect,_tp_funimps_collect,_tp_genabs_collect,_tp_implications_collect,_tp_imports_collect,_tp_initialTypes,_tp_initialValues,_tp_isvar,_tp_kinames,_tp_kindvar,_tp_ksubst,_tp_methods_collect,_tp_nonrecs,_tp_pconsigs_col,_tp_pktcoll,_tp_ptscoll,_tp_rawrequest_collect,_tp_self) =
            (_tp (_name_abstracttps_collect)
                 (_name_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_name_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_name_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_name_funimps_collect)
                 (_lhs_genabs)
                 (_name_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_name_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_kinames)
                 (_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_name_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_name_pconsigs_col)
                 (_name_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_name_rawrequest_collect)
                 (_lhs_toplevel))
        ( _args_abstracttps_collect
         ,_args_bimapimps_collect
         ,_args_constructors_collect
         ,_args_count
         ,_args_deps_collect
         ,_args_exports_collect
         ,_args_funimps_collect
         ,_args_genabs_collect
         ,_args_implications_collect
         ,_args_imports_collect
         ,_args_inferkind
         ,_args_initialTypes
         ,_args_initialValues
         ,_args_kinames
         ,_args_kindvar
         ,_args_ksubst
         ,_args_methods_collect
         ,_args_nil
         ,_args_nonrecs
         ,_args_pconsigs_col
         ,_args_pktcoll
         ,_args_ptscoll
         ,_args_rawrequest_collect
         ,_args_self
         ) =
            (_args (_tp_abstracttps_collect)
                   (_tp_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_tp_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_tp_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_tp_funimps_collect)
                   (_lhs_genabs)
                   (_tp_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_tp_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_prekind)
                   (_tp_kindvar)
                   (_tp_ksubst)
                   (_lhs_local)
                   (_tp_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_tp_pconsigs_col)
                   (_tp_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_tp_ptscoll)
                   (_lhs_ptsdist)
                   (_tp_rawrequest_collect)
                   (False))
        ( _cons_abstracttps_collect
         ,_cons_arity
         ,_cons_bimapimps_collect
         ,_cons_consname
         ,_cons_constructors
         ,_cons_constructors_collect
         ,_cons_deps_collect
         ,_cons_exports_collect
         ,_cons_funimps_collect
         ,_cons_genabs_collect
         ,_cons_hasLabels
         ,_cons_implications
         ,_cons_implications_collect
         ,_cons_imports_collect
         ,_cons_initialTypes
         ,_cons_initialValues
         ,_cons_kinames
         ,_cons_kind_errors
         ,_cons_kindvar
         ,_cons_ksubst
         ,_cons_methods_collect
         ,_cons_nonrecs
         ,_cons_pconsigs_col
         ,_cons_pktcoll
         ,_cons_ptscoll
         ,_cons_rawrequest_collect
         ,_cons_self
         ) =
            (_cons (_args_abstracttps_collect)
                   (_args_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_args_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_args_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_args_funimps_collect)
                   (_lhs_genabs)
                   (_args_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_args_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_args_kinames)
                   (_args_kindvar)
                   (_args_ksubst)
                   (_lhs_local)
                   (_args_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_args_pconsigs_col)
                   (_args_pktcoll)
                   (_lhs_pktdist)
                   (_args_kinames)
                   (_args_ptscoll)
                   (_lhs_ptsdist)
                   (_args_rawrequest_collect)
                   (_lhs_toplevel)
                   (_name_self))
    in  (_cons_abstracttps_collect
        ,_cons_bimapimps_collect
        ,addLBack _lhs_constructors_collect
                  (_name_self,_cons_constructors)
        ,_cons_deps_collect
        ,_name_exports_collect ++ _tp_exports_collect ++ _args_exports_collect ++ _cons_exports_collect
        ,_cons_funimps_collect
        ,_cons_genabs_collect
        ,_cons_implications_collect
        ,_name_imports_collect ++ _tp_imports_collect ++ _args_imports_collect ++ _cons_imports_collect
        ,_name_initialTypes ++ _tp_initialTypes ++ _args_initialTypes ++ _cons_initialTypes
        ,_name_initialValues ++ _tp_initialValues ++ _args_initialValues ++ _cons_initialValues
        ,_kinames
        ,_cons_kind_errors ++ _kind_errors
        ,_cons_kindvar
        ,removeKindVars _kvar _ksubstKV
        ,_cons_methods_collect
        ,_name_nonrecs ++ _tp_nonrecs ++ _args_nonrecs ++ _cons_nonrecs
        ,PP.ppTDecl False _component
        ,if   _is_exported
         then (if   _first
               then [PPI.ppiConsig _name_self (map stype_ctor _consig)]
               else []
              ) ++ [PPI.ppiTDecl _self]
         else []
        ,modify _pconsigs_col _name_self (\(stps,link) -> (_tp_self:stps,link))
        ,_cons_pktcoll
        ,_cons_ptscoll
        ,_cons_rawrequest_collect
        ,_self
        ,_lhs_strtypes
        ,if isUnit _tp_self then [(_name_self,_self)]
                            else []
        )
sem_TDecl_Type :: (T_Position) ->
                  (T_QualName) ->
                  (T_Args) ->
                  (T_Type) ->
                  (T_TDecl)
sem_TDecl_Type (_srcloc)
               (_name)
               (_args)
               (_tp)
               (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_kinames)
               (_lhs_kinds)
               (_lhs_kindvar)
               (_lhs_ksubst)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_modules)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_prekind)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_requests_gas)
               (_lhs_strtypes)
               (_lhs_toplevel)
               (_lhs_verbosity) =
    let (_strtype) =
            ST.strtype _self
        (_ep) =
            ST.ep      _self
        (_self) =
            TDecl_Type _srcloc_self _name_self _args_self _tp_self
        (_is_exported) =
            _name_self `Set.elementOf` _lhs_exportedTypes
        (_is_imported) =
            _name_self `Set.elementOf` _lhs_importedTypes
        (_is_hidden) =
            _name_self `Set.elementOf` _lhs_hiddenTypes
        (_is_imported_h) =
            if _lhs_hiding then _is_hidden else _is_imported
        (_is_implied) =
            _name_self `Set.elementOf` _lhs_impliedTypes
        (_kindvar) =
            _lhs_kindvar + 1
        (_kvar) =
            mkKindVar' _kindvar
        (_kinames) =
            add _lhs_kinames (_name_self,_kvar)
        ((_ksubst',_kind_errors)) =
            unifyWithError (GHError_KindUTsError _srcloc_self
                               (PP.ppQualName False _name_self)
                               (applyKind _tp_ksubst _tp_inferkind)
                           ) _tp_inferkind Kind_Star _tp_ksubst
        ((_ksubstKV,_kind_errors')) =
            unifyToplevel _srcloc_self (PP.ppQualName False _name_self) "type"
                          _kvar _args_inferkind
                          _ksubst'
        (_kind) =
            fromJust $ find _lhs_kinds _name_self
        (_implications_collect) =
            Request_TypeImply (Type_Con genloc _name_self
                              ,[_tp_self])
              : _lhs_implications_collect
        ( _srcloc_self) =
            (_srcloc )
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
        ( _args_abstracttps_collect
         ,_args_bimapimps_collect
         ,_args_constructors_collect
         ,_args_count
         ,_args_deps_collect
         ,_args_exports_collect
         ,_args_funimps_collect
         ,_args_genabs_collect
         ,_args_implications_collect
         ,_args_imports_collect
         ,_args_inferkind
         ,_args_initialTypes
         ,_args_initialValues
         ,_args_kinames
         ,_args_kindvar
         ,_args_ksubst
         ,_args_methods_collect
         ,_args_nil
         ,_args_nonrecs
         ,_args_pconsigs_col
         ,_args_pktcoll
         ,_args_ptscoll
         ,_args_rawrequest_collect
         ,_args_self
         ) =
            (_args (_name_abstracttps_collect)
                   (_name_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_name_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_name_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_name_funimps_collect)
                   (_lhs_genabs)
                   (_name_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_name_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_prekind)
                   (_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_name_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_name_pconsigs_col)
                   (_name_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_name_rawrequest_collect)
                   (False))
        ( _tp_abstracttps_collect,_tp_bimapimps_collect,_tp_constructors_collect,_tp_deps_collect,_tp_exports_collect,_tp_funimps_collect,_tp_genabs_collect,_tp_implications_collect,_tp_imports_collect,_tp_inferkind,_tp_initialTypes,_tp_initialValues,_tp_kinames,_tp_kind_errors,_tp_kindvar,_tp_kloc,_tp_ksubst,_tp_methods_collect,_tp_nonrecs,_tp_pconsigs_col,_tp_pktcoll,_tp_ptscoll,_tp_rawrequest_collect,_tp_self) =
            (_tp (_args_abstracttps_collect)
                 (_args_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_args_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_args_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_args_funimps_collect)
                 (_lhs_genabs)
                 (_args_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_args_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_args_kinames)
                 (_args_kindvar)
                 (_args_ksubst)
                 (_lhs_local)
                 (_args_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_args_pconsigs_col)
                 (_args_pktcoll)
                 (_lhs_pktdist)
                 (_args_kinames)
                 (_args_ptscoll)
                 (_lhs_ptsdist)
                 (_args_rawrequest_collect)
                 (False))
    in  (_tp_abstracttps_collect
        ,_tp_bimapimps_collect
        ,_tp_constructors_collect
        ,_tp_deps_collect
        ,_name_exports_collect ++ _args_exports_collect ++ _tp_exports_collect
        ,_tp_funimps_collect
        ,_tp_genabs_collect
        ,_tp_implications_collect
        ,_name_imports_collect ++ _args_imports_collect ++ _tp_imports_collect
        ,if _is_exported        then [_name_self]
                                else []
        ,_name_initialValues ++ _args_initialValues ++ _tp_initialValues
        ,_kinames
        ,_tp_kind_errors ++ _kind_errors ++ _kind_errors'
        ,_tp_kindvar
        ,removeKindVars _kvar _ksubstKV
        ,_tp_methods_collect
        ,_name_nonrecs ++ _args_nonrecs ++ _tp_nonrecs
        ,let kc = mkKindComment _name_self _kind
             sc = mkStrTypeComment _name_self
             ec = mkEPComment _name_self
         in  vlist [ kc, PP.ppTDecl        False _self
                   , sc, PP.ppStrTypeDecls       _strtype
                   , ec, PP.ppTBs          False _ep
                   ]
        ,if _is_implied then [PPI.ppiTDecl _self] else []
        ,_tp_pconsigs_col
        ,_tp_pktcoll
        ,_tp_ptscoll
        ,_tp_rawrequest_collect
        ,_self
        ,foldl add _lhs_strtypes (map (\st@(StrTypeDecl_Decl tpn _ _) -> (tpn,st)) _strtype)
        ,[]
        )
-- Type --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      inferkind            : Kind
      initialTypes         : [QualName]
      initialValues        : [QualName]
      kind_errors          : [GHError]
      kloc                 : Position
      nonrecs              : [TypedBinding]
      self                 : Type

-}
{-
   local variables for Type.All:
      self

-}
{-
   local variables for Type.App:
      kind_errors
      ks
      kvar
      kindvar
      self

-}
{-
   local variables for Type.Con:
      known_kind
      self

-}
{-
   local variables for Type.ConCase:
      self

-}
{-
   local variables for Type.Fun:
      self

-}
{-
   local variables for Type.KindApp:
      self

-}
{-
   local variables for Type.Lam:
      self

-}
{-
   local variables for Type.List:
      self

-}
{-
   local variables for Type.Tuple:
      self

-}
{-
   local variables for Type.TypeApp:
      rawrequest_collect
      self

-}
{-
   local variables for Type.Unit:
      self

-}
{-
   local variables for Type.Var:
      known_kind
      self

-}
-- semantic domain
type T_Type = (Set QualName) ->
              ([Request_BimapImply]) ->
              (Maybe QualName) ->
              (Consigs) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Modid) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Set QualName) ->
              (Set QualName) ->
              (Exports) ->
              ([Request_FunImply]) ->
              (Set QualName) ->
              (Set QualName) ->
              (Set QualName) ->
              (Set QualName) ->
              (Bool) ->
              ([Request_TypeImply]) ->
              (Set QualName) ->
              (Set QualName) ->
              (Bool) ->
              (Set QualName) ->
              (Set QualName) ->
              (KSubst) ->
              (Int) ->
              (KSubst) ->
              (Bool) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (PConsigs) ->
              (PConsigs) ->
              (FMap QualName PKT) ->
              (FMap QualName PKT) ->
              (KSubst) ->
              (FMap QualName PTS) ->
              (FMap QualName PTS) ->
              ([RawRequest]) ->
              (Bool) ->
              ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),(Kind),([QualName]),([QualName]),(KSubst),([GHError]),(Int),(Position),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Type))
-- cata
sem_Type :: (Type) ->
            (T_Type)
sem_Type ((Type_All (_var) (_body))) =
    (sem_Type_All ((sem_QualName (_var))) ((sem_Type (_body))))
sem_Type ((Type_App (_left) (_right))) =
    (sem_Type_App ((sem_Type (_left))) ((sem_Type (_right))))
sem_Type ((Type_Con (_srcloc) (_name))) =
    (sem_Type_Con ((sem_Position (_srcloc))) ((sem_QualName (_name))))
sem_Type ((Type_ConCase (_srcloc) (_name))) =
    (sem_Type_ConCase ((sem_Position (_srcloc))) ((sem_QualName (_name))))
sem_Type ((Type_Fun )) =
    (sem_Type_Fun )
sem_Type ((Type_KindApp (_srcloc) (_tp) (_kind))) =
    (sem_Type_KindApp ((sem_Position (_srcloc))) ((sem_QualName (_tp))) ((sem_Kind (_kind))))
sem_Type ((Type_Lam (_from) (_body))) =
    (sem_Type_Lam ((sem_QualName (_from))) ((sem_Type (_body))))
sem_Type ((Type_List )) =
    (sem_Type_List )
sem_Type ((Type_Tuple (_n))) =
    (sem_Type_Tuple (_n))
sem_Type ((Type_TypeApp (_srcloc) (_tp) (_type))) =
    (sem_Type_TypeApp ((sem_Position (_srcloc))) ((sem_QualName (_tp))) ((sem_Type (_type))))
sem_Type ((Type_Unit )) =
    (sem_Type_Unit )
sem_Type ((Type_Var (_srcloc) (_name))) =
    (sem_Type_Var ((sem_Position (_srcloc))) ((sem_QualName (_name))))
sem_Type_All :: (T_QualName) ->
                (T_Type) ->
                (T_Type)
sem_Type_All (_var)
             (_body)
             (_lhs_abstracttps_collect)
             (_lhs_bimapimps_collect)
             (_lhs_classname)
             (_lhs_consigs)
             (_lhs_constructors_collect)
             (_lhs_constructors_dist)
             (_lhs_currentModule)
             (_lhs_deps)
             (_lhs_deps_collect)
             (_lhs_exportedTypes)
             (_lhs_exportedValues)
             (_lhs_exports)
             (_lhs_funimps_collect)
             (_lhs_genabs)
             (_lhs_genabs_collect)
             (_lhs_hiddenTypes)
             (_lhs_hiddenValues)
             (_lhs_hiding)
             (_lhs_implications_collect)
             (_lhs_impliedTypes)
             (_lhs_impliedValues)
             (_lhs_importedModule)
             (_lhs_importedTypes)
             (_lhs_importedValues)
             (_lhs_kinames)
             (_lhs_kindvar)
             (_lhs_ksubst)
             (_lhs_local)
             (_lhs_methods_collect)
             (_lhs_methods_dist)
             (_lhs_pconsigs)
             (_lhs_pconsigs_col)
             (_lhs_pktcoll)
             (_lhs_pktdist)
             (_lhs_prekind)
             (_lhs_ptscoll)
             (_lhs_ptsdist)
             (_lhs_rawrequest_collect)
             (_lhs_toplevel) =
    let (_self) =
            Type_All _var_self _body_self
        ( _var_abstracttps_collect,_var_bimapimps_collect,_var_constructors_collect,_var_deps_collect,_var_exports_collect,_var_funimps_collect,_var_genabs_collect,_var_implications_collect,_var_imports_collect,_var_initialTypes,_var_initialValues,_var_methods_collect,_var_nonrecs,_var_pconsigs_col,_var_pktcoll,_var_rawrequest_collect,_var_self) =
            (_var (_lhs_abstracttps_collect)
                  (_lhs_bimapimps_collect)
                  (_lhs_classname)
                  (_lhs_consigs)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_deps)
                  (_lhs_deps_collect)
                  (_lhs_exportedTypes)
                  (_lhs_exportedValues)
                  (_lhs_exports)
                  (_lhs_funimps_collect)
                  (_lhs_genabs)
                  (_lhs_genabs_collect)
                  (_lhs_hiddenTypes)
                  (_lhs_hiddenValues)
                  (_lhs_hiding)
                  (_lhs_implications_collect)
                  (_lhs_impliedTypes)
                  (_lhs_impliedValues)
                  (_lhs_importedModule)
                  (_lhs_importedTypes)
                  (_lhs_importedValues)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_pconsigs)
                  (_lhs_pconsigs_col)
                  (_lhs_pktcoll)
                  (_lhs_pktdist)
                  (_lhs_rawrequest_collect)
                  (_lhs_toplevel))
        ( _body_abstracttps_collect
         ,_body_bimapimps_collect
         ,_body_constructors_collect
         ,_body_deps_collect
         ,_body_exports_collect
         ,_body_funimps_collect
         ,_body_genabs_collect
         ,_body_implications_collect
         ,_body_imports_collect
         ,_body_inferkind
         ,_body_initialTypes
         ,_body_initialValues
         ,_body_kinames
         ,_body_kind_errors
         ,_body_kindvar
         ,_body_kloc
         ,_body_ksubst
         ,_body_methods_collect
         ,_body_nonrecs
         ,_body_pconsigs_col
         ,_body_pktcoll
         ,_body_ptscoll
         ,_body_rawrequest_collect
         ,_body_self
         ) =
            (_body (_var_abstracttps_collect)
                   (_var_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_var_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_var_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_var_funimps_collect)
                   (_lhs_genabs)
                   (_var_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_var_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_var_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_var_pconsigs_col)
                   (_var_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_var_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_body_abstracttps_collect
        ,_body_bimapimps_collect
        ,_body_constructors_collect
        ,_body_deps_collect
        ,_var_exports_collect ++ _body_exports_collect
        ,_body_funimps_collect
        ,_body_genabs_collect
        ,_body_implications_collect
        ,_var_imports_collect ++ _body_imports_collect
        ,internalError
           "Forall should not occur in a type"
        ,_var_initialTypes ++ _body_initialTypes
        ,_var_initialValues ++ _body_initialValues
        ,_body_kinames
        ,_body_kind_errors
        ,_body_kindvar
        ,_body_kloc
        ,_body_ksubst
        ,_body_methods_collect
        ,_var_nonrecs ++ _body_nonrecs
        ,_body_pconsigs_col
        ,_body_pktcoll
        ,_body_ptscoll
        ,_body_rawrequest_collect
        ,_self
        )
sem_Type_App :: (T_Type) ->
                (T_Type) ->
                (T_Type)
sem_Type_App (_left)
             (_right)
             (_lhs_abstracttps_collect)
             (_lhs_bimapimps_collect)
             (_lhs_classname)
             (_lhs_consigs)
             (_lhs_constructors_collect)
             (_lhs_constructors_dist)
             (_lhs_currentModule)
             (_lhs_deps)
             (_lhs_deps_collect)
             (_lhs_exportedTypes)
             (_lhs_exportedValues)
             (_lhs_exports)
             (_lhs_funimps_collect)
             (_lhs_genabs)
             (_lhs_genabs_collect)
             (_lhs_hiddenTypes)
             (_lhs_hiddenValues)
             (_lhs_hiding)
             (_lhs_implications_collect)
             (_lhs_impliedTypes)
             (_lhs_impliedValues)
             (_lhs_importedModule)
             (_lhs_importedTypes)
             (_lhs_importedValues)
             (_lhs_kinames)
             (_lhs_kindvar)
             (_lhs_ksubst)
             (_lhs_local)
             (_lhs_methods_collect)
             (_lhs_methods_dist)
             (_lhs_pconsigs)
             (_lhs_pconsigs_col)
             (_lhs_pktcoll)
             (_lhs_pktdist)
             (_lhs_prekind)
             (_lhs_ptscoll)
             (_lhs_ptsdist)
             (_lhs_rawrequest_collect)
             (_lhs_toplevel) =
    let (_self) =
            Type_App _left_self _right_self
        (_kindvar) =
            _lhs_kindvar + 1
        (_kvar) =
            mkKindVar' _kindvar
        ((_ks,_kind_errors)) =
            let kr = Kind_Arr _right_inferkind _kvar
                kl = _left_inferkind
            in  unifyWithError (GHError_KindUAError _left_kloc
                                   (PP.ppType False _left_self)
                                   (PP.ppType False _right_self)
                                   (applyKind _right_ksubst _left_inferkind)
                                   (applyKind _right_ksubst _right_inferkind)
                               )
                               kl kr _right_ksubst
        ( _left_abstracttps_collect
         ,_left_bimapimps_collect
         ,_left_constructors_collect
         ,_left_deps_collect
         ,_left_exports_collect
         ,_left_funimps_collect
         ,_left_genabs_collect
         ,_left_implications_collect
         ,_left_imports_collect
         ,_left_inferkind
         ,_left_initialTypes
         ,_left_initialValues
         ,_left_kinames
         ,_left_kind_errors
         ,_left_kindvar
         ,_left_kloc
         ,_left_ksubst
         ,_left_methods_collect
         ,_left_nonrecs
         ,_left_pconsigs_col
         ,_left_pktcoll
         ,_left_ptscoll
         ,_left_rawrequest_collect
         ,_left_self
         ) =
            (_left (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
        ( _right_abstracttps_collect
         ,_right_bimapimps_collect
         ,_right_constructors_collect
         ,_right_deps_collect
         ,_right_exports_collect
         ,_right_funimps_collect
         ,_right_genabs_collect
         ,_right_implications_collect
         ,_right_imports_collect
         ,_right_inferkind
         ,_right_initialTypes
         ,_right_initialValues
         ,_right_kinames
         ,_right_kind_errors
         ,_right_kindvar
         ,_right_kloc
         ,_right_ksubst
         ,_right_methods_collect
         ,_right_nonrecs
         ,_right_pconsigs_col
         ,_right_pktcoll
         ,_right_ptscoll
         ,_right_rawrequest_collect
         ,_right_self
         ) =
            (_right (_left_abstracttps_collect)
                    (_left_bimapimps_collect)
                    (_lhs_classname)
                    (_lhs_consigs)
                    (_left_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_deps)
                    (_left_deps_collect)
                    (_lhs_exportedTypes)
                    (_lhs_exportedValues)
                    (_lhs_exports)
                    (_left_funimps_collect)
                    (_lhs_genabs)
                    (_left_genabs_collect)
                    (_lhs_hiddenTypes)
                    (_lhs_hiddenValues)
                    (_lhs_hiding)
                    (_left_implications_collect)
                    (_lhs_impliedTypes)
                    (_lhs_impliedValues)
                    (_lhs_importedModule)
                    (_lhs_importedTypes)
                    (_lhs_importedValues)
                    (_left_kinames)
                    (_left_kindvar)
                    (_left_ksubst)
                    (_lhs_local)
                    (_left_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_pconsigs)
                    (_left_pconsigs_col)
                    (_left_pktcoll)
                    (_lhs_pktdist)
                    (_lhs_prekind)
                    (_left_ptscoll)
                    (_lhs_ptsdist)
                    (_left_rawrequest_collect)
                    (_lhs_toplevel))
    in  (_right_abstracttps_collect
        ,_right_bimapimps_collect
        ,_right_constructors_collect
        ,_right_deps_collect
        ,_left_exports_collect ++ _right_exports_collect
        ,_right_funimps_collect
        ,_right_genabs_collect
        ,_right_implications_collect
        ,_left_imports_collect ++ _right_imports_collect
        ,_kvar
        ,_left_initialTypes ++ _right_initialTypes
        ,_left_initialValues ++ _right_initialValues
        ,_right_kinames
        ,_left_kind_errors ++ _right_kind_errors ++ _kind_errors
        ,_right_kindvar
        ,_left_kloc
        ,_ks
        ,_right_methods_collect
        ,_left_nonrecs ++ _right_nonrecs
        ,_right_pconsigs_col
        ,_right_pktcoll
        ,_right_ptscoll
        ,_right_rawrequest_collect
        ,_self
        )
sem_Type_Con :: (T_Position) ->
                (T_QualName) ->
                (T_Type)
sem_Type_Con (_srcloc)
             (_name)
             (_lhs_abstracttps_collect)
             (_lhs_bimapimps_collect)
             (_lhs_classname)
             (_lhs_consigs)
             (_lhs_constructors_collect)
             (_lhs_constructors_dist)
             (_lhs_currentModule)
             (_lhs_deps)
             (_lhs_deps_collect)
             (_lhs_exportedTypes)
             (_lhs_exportedValues)
             (_lhs_exports)
             (_lhs_funimps_collect)
             (_lhs_genabs)
             (_lhs_genabs_collect)
             (_lhs_hiddenTypes)
             (_lhs_hiddenValues)
             (_lhs_hiding)
             (_lhs_implications_collect)
             (_lhs_impliedTypes)
             (_lhs_impliedValues)
             (_lhs_importedModule)
             (_lhs_importedTypes)
             (_lhs_importedValues)
             (_lhs_kinames)
             (_lhs_kindvar)
             (_lhs_ksubst)
             (_lhs_local)
             (_lhs_methods_collect)
             (_lhs_methods_dist)
             (_lhs_pconsigs)
             (_lhs_pconsigs_col)
             (_lhs_pktcoll)
             (_lhs_pktdist)
             (_lhs_prekind)
             (_lhs_ptscoll)
             (_lhs_ptsdist)
             (_lhs_rawrequest_collect)
             (_lhs_toplevel) =
    let (_self) =
            Type_Con _srcloc_self _name_self
        (_known_kind) =
            find _lhs_prekind _name_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_name_abstracttps_collect
        ,_name_bimapimps_collect
        ,_name_constructors_collect
        ,_name_deps_collect
        ,_name_exports_collect
        ,_name_funimps_collect
        ,_name_genabs_collect
        ,_name_implications_collect
        ,_name_imports_collect
        ,case _known_kind of
           Just k  -> k
           Nothing -> Kind_Error
        ,_name_initialTypes
        ,_name_initialValues
        ,_lhs_kinames
        ,case _known_kind of
           Just k  -> []
           Nothing -> [GHError_KindUnkTWarn _srcloc_self
                                          (PP.ppQualName False _name_self)]
        ,_lhs_kindvar
        ,_srcloc_self
        ,_lhs_ksubst
        ,_name_methods_collect
        ,_name_nonrecs
        ,_name_pconsigs_col
        ,_name_pktcoll
        ,_lhs_ptscoll
        ,_name_rawrequest_collect
        ,_self
        )
sem_Type_ConCase :: (T_Position) ->
                    (T_QualName) ->
                    (T_Type)
sem_Type_ConCase (_srcloc)
                 (_name)
                 (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel) =
    let (_self) =
            Type_ConCase _srcloc_self _name_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_name_abstracttps_collect
        ,_name_bimapimps_collect
        ,_name_constructors_collect
        ,_name_deps_collect
        ,_name_exports_collect
        ,_name_funimps_collect
        ,_name_genabs_collect
        ,_name_implications_collect
        ,_name_imports_collect
        ,internalError
           "Kind.Type.ConCase.inferkind: concase should not need kind inference"
        ,_name_initialTypes
        ,_name_initialValues
        ,_lhs_kinames
        ,[]
        ,_lhs_kindvar
        ,genloc
        ,_lhs_ksubst
        ,_name_methods_collect
        ,_name_nonrecs
        ,_name_pconsigs_col
        ,_name_pktcoll
        ,_lhs_ptscoll
        ,_name_rawrequest_collect
        ,_self
        )
sem_Type_Fun :: (T_Type)
sem_Type_Fun (_lhs_abstracttps_collect)
             (_lhs_bimapimps_collect)
             (_lhs_classname)
             (_lhs_consigs)
             (_lhs_constructors_collect)
             (_lhs_constructors_dist)
             (_lhs_currentModule)
             (_lhs_deps)
             (_lhs_deps_collect)
             (_lhs_exportedTypes)
             (_lhs_exportedValues)
             (_lhs_exports)
             (_lhs_funimps_collect)
             (_lhs_genabs)
             (_lhs_genabs_collect)
             (_lhs_hiddenTypes)
             (_lhs_hiddenValues)
             (_lhs_hiding)
             (_lhs_implications_collect)
             (_lhs_impliedTypes)
             (_lhs_impliedValues)
             (_lhs_importedModule)
             (_lhs_importedTypes)
             (_lhs_importedValues)
             (_lhs_kinames)
             (_lhs_kindvar)
             (_lhs_ksubst)
             (_lhs_local)
             (_lhs_methods_collect)
             (_lhs_methods_dist)
             (_lhs_pconsigs)
             (_lhs_pconsigs_col)
             (_lhs_pktcoll)
             (_lhs_pktdist)
             (_lhs_prekind)
             (_lhs_ptscoll)
             (_lhs_ptsdist)
             (_lhs_rawrequest_collect)
             (_lhs_toplevel) =
    let (_self) =
            Type_Fun
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],simpleKind 2,[],[],_lhs_kinames,[],_lhs_kindvar,genloc,_lhs_ksubst,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,_self)
sem_Type_KindApp :: (T_Position) ->
                    (T_QualName) ->
                    (T_Kind) ->
                    (T_Type)
sem_Type_KindApp (_srcloc)
                 (_tp)
                 (_kind)
                 (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel) =
    let (_self) =
            Type_KindApp _srcloc_self _tp_self _kind_self
        ( _srcloc_self) =
            (_srcloc )
        ( _tp_abstracttps_collect,_tp_bimapimps_collect,_tp_constructors_collect,_tp_deps_collect,_tp_exports_collect,_tp_funimps_collect,_tp_genabs_collect,_tp_implications_collect,_tp_imports_collect,_tp_initialTypes,_tp_initialValues,_tp_methods_collect,_tp_nonrecs,_tp_pconsigs_col,_tp_pktcoll,_tp_rawrequest_collect,_tp_self) =
            (_tp (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel))
        ( _kind_abstracttps_collect,_kind_bimapimps_collect,_kind_constructors_collect,_kind_deps_collect,_kind_exports_collect,_kind_fixedKind,_kind_funimps_collect,_kind_genabs_collect,_kind_implications_collect,_kind_imports_collect,_kind_initialTypes,_kind_initialValues,_kind_methods_collect,_kind_nonrecs,_kind_pconsigs_col,_kind_pktcoll,_kind_ptscoll,_kind_rawrequest_collect,_kind_self) =
            (_kind (_tp_abstracttps_collect)
                   (_tp_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_tp_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_tp_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_tp_funimps_collect)
                   (_lhs_genabs)
                   (_tp_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_tp_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_tp_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_tp_pconsigs_col)
                   (_tp_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_tp_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_kind_abstracttps_collect
        ,_kind_bimapimps_collect
        ,_kind_constructors_collect
        ,_kind_deps_collect
        ,_tp_exports_collect ++ _kind_exports_collect
        ,_kind_funimps_collect
        ,_kind_genabs_collect
        ,_kind_implications_collect
        ,_tp_imports_collect ++ _kind_imports_collect
        ,internalError
           "Kind.Type.KindApp.inferkind: not implemented"
        ,_tp_initialTypes ++ _kind_initialTypes
        ,_tp_initialValues ++ _kind_initialValues
        ,_lhs_kinames
        ,[]
        ,_lhs_kindvar
        ,genloc
        ,_lhs_ksubst
        ,_kind_methods_collect
        ,_tp_nonrecs ++ _kind_nonrecs
        ,_kind_pconsigs_col
        ,_kind_pktcoll
        ,_kind_ptscoll
        ,_kind_rawrequest_collect
        ,_self
        )
sem_Type_Lam :: (T_QualName) ->
                (T_Type) ->
                (T_Type)
sem_Type_Lam (_from)
             (_body)
             (_lhs_abstracttps_collect)
             (_lhs_bimapimps_collect)
             (_lhs_classname)
             (_lhs_consigs)
             (_lhs_constructors_collect)
             (_lhs_constructors_dist)
             (_lhs_currentModule)
             (_lhs_deps)
             (_lhs_deps_collect)
             (_lhs_exportedTypes)
             (_lhs_exportedValues)
             (_lhs_exports)
             (_lhs_funimps_collect)
             (_lhs_genabs)
             (_lhs_genabs_collect)
             (_lhs_hiddenTypes)
             (_lhs_hiddenValues)
             (_lhs_hiding)
             (_lhs_implications_collect)
             (_lhs_impliedTypes)
             (_lhs_impliedValues)
             (_lhs_importedModule)
             (_lhs_importedTypes)
             (_lhs_importedValues)
             (_lhs_kinames)
             (_lhs_kindvar)
             (_lhs_ksubst)
             (_lhs_local)
             (_lhs_methods_collect)
             (_lhs_methods_dist)
             (_lhs_pconsigs)
             (_lhs_pconsigs_col)
             (_lhs_pktcoll)
             (_lhs_pktdist)
             (_lhs_prekind)
             (_lhs_ptscoll)
             (_lhs_ptsdist)
             (_lhs_rawrequest_collect)
             (_lhs_toplevel) =
    let (_self) =
            Type_Lam _from_self _body_self
        ( _from_abstracttps_collect,_from_bimapimps_collect,_from_constructors_collect,_from_deps_collect,_from_exports_collect,_from_funimps_collect,_from_genabs_collect,_from_implications_collect,_from_imports_collect,_from_initialTypes,_from_initialValues,_from_methods_collect,_from_nonrecs,_from_pconsigs_col,_from_pktcoll,_from_rawrequest_collect,_from_self) =
            (_from (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
        ( _body_abstracttps_collect
         ,_body_bimapimps_collect
         ,_body_constructors_collect
         ,_body_deps_collect
         ,_body_exports_collect
         ,_body_funimps_collect
         ,_body_genabs_collect
         ,_body_implications_collect
         ,_body_imports_collect
         ,_body_inferkind
         ,_body_initialTypes
         ,_body_initialValues
         ,_body_kinames
         ,_body_kind_errors
         ,_body_kindvar
         ,_body_kloc
         ,_body_ksubst
         ,_body_methods_collect
         ,_body_nonrecs
         ,_body_pconsigs_col
         ,_body_pktcoll
         ,_body_ptscoll
         ,_body_rawrequest_collect
         ,_body_self
         ) =
            (_body (_from_abstracttps_collect)
                   (_from_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_from_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_from_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_from_funimps_collect)
                   (_lhs_genabs)
                   (_from_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_from_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_from_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_from_pconsigs_col)
                   (_from_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_from_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_body_abstracttps_collect
        ,_body_bimapimps_collect
        ,_body_constructors_collect
        ,_body_deps_collect
        ,_from_exports_collect ++ _body_exports_collect
        ,_body_funimps_collect
        ,_body_genabs_collect
        ,_body_implications_collect
        ,_from_imports_collect ++ _body_imports_collect
        ,internalError
           "Lambda should not occur in a type"
        ,_from_initialTypes ++ _body_initialTypes
        ,_from_initialValues ++ _body_initialValues
        ,_body_kinames
        ,_body_kind_errors
        ,_body_kindvar
        ,_body_kloc
        ,_body_ksubst
        ,_body_methods_collect
        ,_from_nonrecs ++ _body_nonrecs
        ,_body_pconsigs_col
        ,_body_pktcoll
        ,_body_ptscoll
        ,_body_rawrequest_collect
        ,_self
        )
sem_Type_List :: (T_Type)
sem_Type_List (_lhs_abstracttps_collect)
              (_lhs_bimapimps_collect)
              (_lhs_classname)
              (_lhs_consigs)
              (_lhs_constructors_collect)
              (_lhs_constructors_dist)
              (_lhs_currentModule)
              (_lhs_deps)
              (_lhs_deps_collect)
              (_lhs_exportedTypes)
              (_lhs_exportedValues)
              (_lhs_exports)
              (_lhs_funimps_collect)
              (_lhs_genabs)
              (_lhs_genabs_collect)
              (_lhs_hiddenTypes)
              (_lhs_hiddenValues)
              (_lhs_hiding)
              (_lhs_implications_collect)
              (_lhs_impliedTypes)
              (_lhs_impliedValues)
              (_lhs_importedModule)
              (_lhs_importedTypes)
              (_lhs_importedValues)
              (_lhs_kinames)
              (_lhs_kindvar)
              (_lhs_ksubst)
              (_lhs_local)
              (_lhs_methods_collect)
              (_lhs_methods_dist)
              (_lhs_pconsigs)
              (_lhs_pconsigs_col)
              (_lhs_pktcoll)
              (_lhs_pktdist)
              (_lhs_prekind)
              (_lhs_ptscoll)
              (_lhs_ptsdist)
              (_lhs_rawrequest_collect)
              (_lhs_toplevel) =
    let (_self) =
            Type_List
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],simpleKind 1,[],[],_lhs_kinames,[],_lhs_kindvar,genloc,_lhs_ksubst,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,_self)
sem_Type_Tuple :: (Int) ->
                  (T_Type)
sem_Type_Tuple (_n)
               (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_kinames)
               (_lhs_kindvar)
               (_lhs_ksubst)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_prekind)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_toplevel) =
    let (_self) =
            Type_Tuple _n
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],simpleKind _n,[],[],_lhs_kinames,[],_lhs_kindvar,genloc,_lhs_ksubst,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,_self)
sem_Type_TypeApp :: (T_Position) ->
                    (T_QualName) ->
                    (T_Type) ->
                    (T_Type)
sem_Type_TypeApp (_srcloc)
                 (_tp)
                 (_type)
                 (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel) =
    let (_self) =
            Type_TypeApp _srcloc_self _tp_self _type_self
        (_rawrequest_collect) =
            RawRequest (_tp_self,_type_self) : _lhs_rawrequest_collect
        ( _srcloc_self) =
            (_srcloc )
        ( _tp_abstracttps_collect,_tp_bimapimps_collect,_tp_constructors_collect,_tp_deps_collect,_tp_exports_collect,_tp_funimps_collect,_tp_genabs_collect,_tp_implications_collect,_tp_imports_collect,_tp_initialTypes,_tp_initialValues,_tp_methods_collect,_tp_nonrecs,_tp_pconsigs_col,_tp_pktcoll,_tp_rawrequest_collect,_tp_self) =
            (_tp (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_rawrequest_collect)
                 (_lhs_toplevel))
        ( _type_abstracttps_collect
         ,_type_bimapimps_collect
         ,_type_constructors_collect
         ,_type_deps_collect
         ,_type_exports_collect
         ,_type_funimps_collect
         ,_type_genabs_collect
         ,_type_implications_collect
         ,_type_imports_collect
         ,_type_inferkind
         ,_type_initialTypes
         ,_type_initialValues
         ,_type_kinames
         ,_type_kind_errors
         ,_type_kindvar
         ,_type_kloc
         ,_type_ksubst
         ,_type_methods_collect
         ,_type_nonrecs
         ,_type_pconsigs_col
         ,_type_pktcoll
         ,_type_ptscoll
         ,_type_rawrequest_collect
         ,_type_self
         ) =
            (_type (_tp_abstracttps_collect)
                   (_tp_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_tp_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_tp_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_tp_funimps_collect)
                   (_lhs_genabs)
                   (_tp_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_tp_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_kinames)
                   (_lhs_kindvar)
                   (_lhs_ksubst)
                   (_lhs_local)
                   (_tp_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_tp_pconsigs_col)
                   (_tp_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_prekind)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_tp_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_type_abstracttps_collect
        ,_type_bimapimps_collect
        ,_type_constructors_collect
        ,_type_deps_collect
        ,_tp_exports_collect ++ _type_exports_collect
        ,_type_funimps_collect
        ,_type_genabs_collect
        ,_type_implications_collect
        ,_tp_imports_collect ++ _type_imports_collect
        ,_type_inferkind
        ,_tp_initialTypes ++ _type_initialTypes
        ,_tp_initialValues ++ _type_initialValues
        ,_type_kinames
        ,_type_kind_errors
        ,_type_kindvar
        ,_type_kloc
        ,_type_ksubst
        ,_type_methods_collect
        ,_tp_nonrecs ++ _type_nonrecs
        ,_type_pconsigs_col
        ,_type_pktcoll
        ,_type_ptscoll
        ,_type_rawrequest_collect
        ,_self
        )
sem_Type_Unit :: (T_Type)
sem_Type_Unit (_lhs_abstracttps_collect)
              (_lhs_bimapimps_collect)
              (_lhs_classname)
              (_lhs_consigs)
              (_lhs_constructors_collect)
              (_lhs_constructors_dist)
              (_lhs_currentModule)
              (_lhs_deps)
              (_lhs_deps_collect)
              (_lhs_exportedTypes)
              (_lhs_exportedValues)
              (_lhs_exports)
              (_lhs_funimps_collect)
              (_lhs_genabs)
              (_lhs_genabs_collect)
              (_lhs_hiddenTypes)
              (_lhs_hiddenValues)
              (_lhs_hiding)
              (_lhs_implications_collect)
              (_lhs_impliedTypes)
              (_lhs_impliedValues)
              (_lhs_importedModule)
              (_lhs_importedTypes)
              (_lhs_importedValues)
              (_lhs_kinames)
              (_lhs_kindvar)
              (_lhs_ksubst)
              (_lhs_local)
              (_lhs_methods_collect)
              (_lhs_methods_dist)
              (_lhs_pconsigs)
              (_lhs_pconsigs_col)
              (_lhs_pktcoll)
              (_lhs_pktdist)
              (_lhs_prekind)
              (_lhs_ptscoll)
              (_lhs_ptsdist)
              (_lhs_rawrequest_collect)
              (_lhs_toplevel) =
    let (_self) =
            Type_Unit
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],simpleKind 0,[],[],_lhs_kinames,[],_lhs_kindvar,genloc,_lhs_ksubst,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,_self)
sem_Type_Var :: (T_Position) ->
                (T_QualName) ->
                (T_Type)
sem_Type_Var (_srcloc)
             (_name)
             (_lhs_abstracttps_collect)
             (_lhs_bimapimps_collect)
             (_lhs_classname)
             (_lhs_consigs)
             (_lhs_constructors_collect)
             (_lhs_constructors_dist)
             (_lhs_currentModule)
             (_lhs_deps)
             (_lhs_deps_collect)
             (_lhs_exportedTypes)
             (_lhs_exportedValues)
             (_lhs_exports)
             (_lhs_funimps_collect)
             (_lhs_genabs)
             (_lhs_genabs_collect)
             (_lhs_hiddenTypes)
             (_lhs_hiddenValues)
             (_lhs_hiding)
             (_lhs_implications_collect)
             (_lhs_impliedTypes)
             (_lhs_impliedValues)
             (_lhs_importedModule)
             (_lhs_importedTypes)
             (_lhs_importedValues)
             (_lhs_kinames)
             (_lhs_kindvar)
             (_lhs_ksubst)
             (_lhs_local)
             (_lhs_methods_collect)
             (_lhs_methods_dist)
             (_lhs_pconsigs)
             (_lhs_pconsigs_col)
             (_lhs_pktcoll)
             (_lhs_pktdist)
             (_lhs_prekind)
             (_lhs_ptscoll)
             (_lhs_ptsdist)
             (_lhs_rawrequest_collect)
             (_lhs_toplevel) =
    let (_self) =
            Type_Var _srcloc_self _name_self
        (_known_kind) =
            find _lhs_prekind _name_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_abstracttps_collect,_name_bimapimps_collect,_name_constructors_collect,_name_deps_collect,_name_exports_collect,_name_funimps_collect,_name_genabs_collect,_name_implications_collect,_name_imports_collect,_name_initialTypes,_name_initialValues,_name_methods_collect,_name_nonrecs,_name_pconsigs_col,_name_pktcoll,_name_rawrequest_collect,_name_self) =
            (_name (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
    in  (_name_abstracttps_collect
        ,_name_bimapimps_collect
        ,_name_constructors_collect
        ,_name_deps_collect
        ,_name_exports_collect
        ,_name_funimps_collect
        ,_name_genabs_collect
        ,_name_implications_collect
        ,_name_imports_collect
        ,case _known_kind of
           Just k  -> k
           Nothing -> Kind_Error
        ,_name_initialTypes
        ,_name_initialValues
        ,_lhs_kinames
        ,case _known_kind of
           Just k  -> []
           Nothing -> [GHError_KindUnkIError _srcloc_self
                                           (PP.ppQualName False _name_self)]
        ,_lhs_kindvar
        ,_srcloc_self
        ,_lhs_ksubst
        ,_name_methods_collect
        ,_name_nonrecs
        ,_name_pconsigs_col
        ,_name_pktcoll
        ,_lhs_ptscoll
        ,_name_rawrequest_collect
        ,_self
        )
-- TypeBinding -------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      kind                 : SKind
      kind_errors          : [GHError]
      nonrecs              : [TypedBinding]
      self                 : TypeBinding

-}
{-
   local variables for TypeBinding.Binding:

-}
-- semantic domain
type T_TypeBinding = (Set QualName) ->
                     ([Request_BimapImply]) ->
                     (Maybe QualName) ->
                     (Consigs) ->
                     (FMap QualName QualNames) ->
                     (FMap QualName QualNames) ->
                     (Modid) ->
                     (FMap QualName QualNames) ->
                     (FMap QualName QualNames) ->
                     (Set QualName) ->
                     (Set QualName) ->
                     (Exports) ->
                     ([Request_FunImply]) ->
                     (Set QualName) ->
                     (Set QualName) ->
                     (Set QualName) ->
                     (Set QualName) ->
                     (Bool) ->
                     ([Request_TypeImply]) ->
                     (Set QualName) ->
                     (Set QualName) ->
                     (Bool) ->
                     (Set QualName) ->
                     (Set QualName) ->
                     (KSubst) ->
                     (Int) ->
                     (KSubst) ->
                     (Bool) ->
                     (FMap QualName QualNames) ->
                     (FMap QualName QualNames) ->
                     (PConsigs) ->
                     (PConsigs) ->
                     (FMap QualName PKT) ->
                     (FMap QualName PKT) ->
                     (KSubst) ->
                     (FMap QualName PTS) ->
                     (FMap QualName PTS) ->
                     ([RawRequest]) ->
                     (Bool) ->
                     ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(SKind),([GHError]),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(TypeBinding))
-- cata
sem_TypeBinding :: (TypeBinding) ->
                   (T_TypeBinding)
sem_TypeBinding ((TypeBinding_Binding (_kind) (_lh) (_rh))) =
    (sem_TypeBinding_Binding ((sem_SKind (_kind))) ((sem_Args (_lh))) ((sem_Type (_rh))))
sem_TypeBinding_Binding :: (T_SKind) ->
                           (T_Args) ->
                           (T_Type) ->
                           (T_TypeBinding)
sem_TypeBinding_Binding (_kind)
                        (_lh)
                        (_rh)
                        (_lhs_abstracttps_collect)
                        (_lhs_bimapimps_collect)
                        (_lhs_classname)
                        (_lhs_consigs)
                        (_lhs_constructors_collect)
                        (_lhs_constructors_dist)
                        (_lhs_currentModule)
                        (_lhs_deps)
                        (_lhs_deps_collect)
                        (_lhs_exportedTypes)
                        (_lhs_exportedValues)
                        (_lhs_exports)
                        (_lhs_funimps_collect)
                        (_lhs_genabs)
                        (_lhs_genabs_collect)
                        (_lhs_hiddenTypes)
                        (_lhs_hiddenValues)
                        (_lhs_hiding)
                        (_lhs_implications_collect)
                        (_lhs_impliedTypes)
                        (_lhs_impliedValues)
                        (_lhs_importedModule)
                        (_lhs_importedTypes)
                        (_lhs_importedValues)
                        (_lhs_kinames)
                        (_lhs_kindvar)
                        (_lhs_ksubst)
                        (_lhs_local)
                        (_lhs_methods_collect)
                        (_lhs_methods_dist)
                        (_lhs_pconsigs)
                        (_lhs_pconsigs_col)
                        (_lhs_pktcoll)
                        (_lhs_pktdist)
                        (_lhs_prekind)
                        (_lhs_ptscoll)
                        (_lhs_ptsdist)
                        (_lhs_rawrequest_collect)
                        (_lhs_toplevel) =
    let ( _kind_abstracttps_collect,_kind_bimapimps_collect,_kind_constructors_collect,_kind_deps_collect,_kind_exports_collect,_kind_funimps_collect,_kind_genabs_collect,_kind_implications_collect,_kind_imports_collect,_kind_initialTypes,_kind_initialValues,_kind_methods_collect,_kind_nonrecs,_kind_pconsigs_col,_kind_pktcoll,_kind_ptscoll,_kind_rawrequest_collect,_kind_self) =
            (_kind (_lhs_abstracttps_collect)
                   (_lhs_bimapimps_collect)
                   (_lhs_classname)
                   (_lhs_consigs)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_deps)
                   (_lhs_deps_collect)
                   (_lhs_exportedTypes)
                   (_lhs_exportedValues)
                   (_lhs_exports)
                   (_lhs_funimps_collect)
                   (_lhs_genabs)
                   (_lhs_genabs_collect)
                   (_lhs_hiddenTypes)
                   (_lhs_hiddenValues)
                   (_lhs_hiding)
                   (_lhs_implications_collect)
                   (_lhs_impliedTypes)
                   (_lhs_impliedValues)
                   (_lhs_importedModule)
                   (_lhs_importedTypes)
                   (_lhs_importedValues)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_pconsigs)
                   (_lhs_pconsigs_col)
                   (_lhs_pktcoll)
                   (_lhs_pktdist)
                   (_lhs_ptscoll)
                   (_lhs_ptsdist)
                   (_lhs_rawrequest_collect)
                   (_lhs_toplevel))
        ( _lh_abstracttps_collect,_lh_bimapimps_collect,_lh_constructors_collect,_lh_count,_lh_deps_collect,_lh_exports_collect,_lh_funimps_collect,_lh_genabs_collect,_lh_implications_collect,_lh_imports_collect,_lh_inferkind,_lh_initialTypes,_lh_initialValues,_lh_kinames,_lh_kindvar,_lh_ksubst,_lh_methods_collect,_lh_nil,_lh_nonrecs,_lh_pconsigs_col,_lh_pktcoll,_lh_ptscoll,_lh_rawrequest_collect,_lh_self) =
            (_lh (_kind_abstracttps_collect)
                 (_kind_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_kind_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_kind_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_kind_funimps_collect)
                 (_lhs_genabs)
                 (_kind_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_kind_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_kind_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_kind_pconsigs_col)
                 (_kind_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_kind_ptscoll)
                 (_lhs_ptsdist)
                 (_kind_rawrequest_collect)
                 (_lhs_toplevel))
        ( _rh_abstracttps_collect,_rh_bimapimps_collect,_rh_constructors_collect,_rh_deps_collect,_rh_exports_collect,_rh_funimps_collect,_rh_genabs_collect,_rh_implications_collect,_rh_imports_collect,_rh_inferkind,_rh_initialTypes,_rh_initialValues,_rh_kinames,_rh_kind_errors,_rh_kindvar,_rh_kloc,_rh_ksubst,_rh_methods_collect,_rh_nonrecs,_rh_pconsigs_col,_rh_pktcoll,_rh_ptscoll,_rh_rawrequest_collect,_rh_self) =
            (_rh (_lh_abstracttps_collect)
                 (_lh_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lh_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lh_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lh_funimps_collect)
                 (_lhs_genabs)
                 (_lh_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lh_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lh_kinames)
                 (_lh_kindvar)
                 (_lh_ksubst)
                 (_lhs_local)
                 (_lh_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lh_pconsigs_col)
                 (_lh_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lh_ptscoll)
                 (_lhs_ptsdist)
                 (_lh_rawrequest_collect)
                 (_lhs_toplevel))
    in  (_rh_abstracttps_collect
        ,_rh_bimapimps_collect
        ,_rh_constructors_collect
        ,_rh_deps_collect
        ,_kind_exports_collect ++ _lh_exports_collect ++ _rh_exports_collect
        ,_rh_funimps_collect
        ,_rh_genabs_collect
        ,_rh_implications_collect
        ,_kind_imports_collect ++ _lh_imports_collect ++ _rh_imports_collect
        ,_kind_initialTypes ++ _lh_initialTypes ++ _rh_initialTypes
        ,_kind_initialValues ++ _lh_initialValues ++ _rh_initialValues
        ,_rh_kinames
        ,_kind_self
        ,_rh_kind_errors
        ,_rh_kindvar
        ,_rh_ksubst
        ,_rh_methods_collect
        ,_kind_nonrecs ++ _lh_nonrecs ++ _rh_nonrecs
        ,_rh_pconsigs_col
        ,_rh_pktcoll
        ,_rh_ptscoll
        ,_rh_rawrequest_collect
        ,TypeBinding_Binding _kind_self _lh_self
                             _rh_self
        )
-- TypeBindings ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      kind                 : SKind
      kind_errors          : [GHError]
      nonrecs              : [TypedBinding]
      self                 : TypeBindings
      wellformed           : Bool

-}
{-
   local variables for TypeBindings.Cons:

-}
{-
   local variables for TypeBindings.Nil:

-}
-- semantic domain
type T_TypeBindings = (Set QualName) ->
                      ([Request_BimapImply]) ->
                      (Maybe QualName) ->
                      (Consigs) ->
                      (FMap QualName QualNames) ->
                      (FMap QualName QualNames) ->
                      (Modid) ->
                      (FMap QualName QualNames) ->
                      (FMap QualName QualNames) ->
                      (Set QualName) ->
                      (Set QualName) ->
                      (Exports) ->
                      ([Request_FunImply]) ->
                      (Set QualName) ->
                      (Set QualName) ->
                      (Set QualName) ->
                      (Set QualName) ->
                      (Bool) ->
                      ([Request_TypeImply]) ->
                      (Set QualName) ->
                      (Set QualName) ->
                      (Bool) ->
                      (Set QualName) ->
                      (Set QualName) ->
                      (KSubst) ->
                      (Int) ->
                      (KSubst) ->
                      (Bool) ->
                      (FMap QualName QualNames) ->
                      (FMap QualName QualNames) ->
                      (PConsigs) ->
                      (PConsigs) ->
                      (FMap QualName PKT) ->
                      (FMap QualName PKT) ->
                      (KSubst) ->
                      (FMap QualName PTS) ->
                      (FMap QualName PTS) ->
                      ([RawRequest]) ->
                      (Bool) ->
                      ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),(SKind),([GHError]),(Int),(KSubst),(FMap QualName QualNames),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(TypeBindings),(Bool))
-- cata
sem_TypeBindings :: (TypeBindings) ->
                    (T_TypeBindings)
sem_TypeBindings (list) =
    (foldr (sem_TypeBindings_Cons) (sem_TypeBindings_Nil) ((map sem_TypeBinding list)))
sem_TypeBindings_Cons :: (T_TypeBinding) ->
                         (T_TypeBindings) ->
                         (T_TypeBindings)
sem_TypeBindings_Cons (_hd)
                      (_tl)
                      (_lhs_abstracttps_collect)
                      (_lhs_bimapimps_collect)
                      (_lhs_classname)
                      (_lhs_consigs)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_deps)
                      (_lhs_deps_collect)
                      (_lhs_exportedTypes)
                      (_lhs_exportedValues)
                      (_lhs_exports)
                      (_lhs_funimps_collect)
                      (_lhs_genabs)
                      (_lhs_genabs_collect)
                      (_lhs_hiddenTypes)
                      (_lhs_hiddenValues)
                      (_lhs_hiding)
                      (_lhs_implications_collect)
                      (_lhs_impliedTypes)
                      (_lhs_impliedValues)
                      (_lhs_importedModule)
                      (_lhs_importedTypes)
                      (_lhs_importedValues)
                      (_lhs_kinames)
                      (_lhs_kindvar)
                      (_lhs_ksubst)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_pconsigs)
                      (_lhs_pconsigs_col)
                      (_lhs_pktcoll)
                      (_lhs_pktdist)
                      (_lhs_prekind)
                      (_lhs_ptscoll)
                      (_lhs_ptsdist)
                      (_lhs_rawrequest_collect)
                      (_lhs_toplevel) =
    let ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_initialTypes,_hd_initialValues,_hd_kinames,_hd_kind,_hd_kind_errors,_hd_kindvar,_hd_ksubst,_hd_methods_collect,_hd_nonrecs,_hd_pconsigs_col,_hd_pktcoll,_hd_ptscoll,_hd_rawrequest_collect,_hd_self) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_initialTypes,_tl_initialValues,_tl_kinames,_tl_kind,_tl_kind_errors,_tl_kindvar,_tl_ksubst,_tl_methods_collect,_tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_ptscoll,_tl_rawrequest_collect,_tl_self,_tl_wellformed) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_hd_kinames)
                 (_hd_kindvar)
                 (_hd_ksubst)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_hd_ptscoll)
                 (_lhs_ptsdist)
                 (_hd_rawrequest_collect)
                 (_lhs_toplevel))
    in  (_tl_abstracttps_collect
        ,_tl_bimapimps_collect
        ,_tl_constructors_collect
        ,_tl_deps_collect
        ,_hd_exports_collect ++ _tl_exports_collect
        ,_tl_funimps_collect
        ,_tl_genabs_collect
        ,_tl_implications_collect
        ,_hd_imports_collect ++ _tl_imports_collect
        ,_hd_initialTypes ++ _tl_initialTypes
        ,_hd_initialValues ++ _tl_initialValues
        ,_tl_kinames
        ,_hd_kind
        ,_hd_kind_errors ++ _tl_kind_errors
        ,_tl_kindvar
        ,_tl_ksubst
        ,_tl_methods_collect
        ,_hd_nonrecs ++ _tl_nonrecs
        ,_tl_pconsigs_col
        ,_tl_pktcoll
        ,_tl_ptscoll
        ,_tl_rawrequest_collect
        ,_hd_self : _tl_self
        ,if _tl_wellformed
         then False
         else differentSKind _hd_kind _tl_kind
        )
sem_TypeBindings_Nil :: (T_TypeBindings)
sem_TypeBindings_Nil (_lhs_abstracttps_collect)
                     (_lhs_bimapimps_collect)
                     (_lhs_classname)
                     (_lhs_consigs)
                     (_lhs_constructors_collect)
                     (_lhs_constructors_dist)
                     (_lhs_currentModule)
                     (_lhs_deps)
                     (_lhs_deps_collect)
                     (_lhs_exportedTypes)
                     (_lhs_exportedValues)
                     (_lhs_exports)
                     (_lhs_funimps_collect)
                     (_lhs_genabs)
                     (_lhs_genabs_collect)
                     (_lhs_hiddenTypes)
                     (_lhs_hiddenValues)
                     (_lhs_hiding)
                     (_lhs_implications_collect)
                     (_lhs_impliedTypes)
                     (_lhs_impliedValues)
                     (_lhs_importedModule)
                     (_lhs_importedTypes)
                     (_lhs_importedValues)
                     (_lhs_kinames)
                     (_lhs_kindvar)
                     (_lhs_ksubst)
                     (_lhs_local)
                     (_lhs_methods_collect)
                     (_lhs_methods_dist)
                     (_lhs_pconsigs)
                     (_lhs_pconsigs_col)
                     (_lhs_pktcoll)
                     (_lhs_pktdist)
                     (_lhs_prekind)
                     (_lhs_ptscoll)
                     (_lhs_ptsdist)
                     (_lhs_rawrequest_collect)
                     (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_kinames,internalError "PolyKindedType.TypeBindings.Nil: not used",[],_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,[],False)
-- Types -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      consigs              : Consigs
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      deps                 : FMap QualName QualNames
      exportedTypes        : Set QualName
      exportedValues       : Set QualName
      exports              : Exports
      genabs               : Set QualName
      hiddenTypes          : Set QualName
      hiddenValues         : Set QualName
      hiding               : Bool
      impliedTypes         : Set QualName
      impliedValues        : Set QualName
      importedModule       : Bool
      importedTypes        : Set QualName
      importedValues       : Set QualName
      local                : Bool
      methods_dist         : FMap QualName QualNames
      pconsigs             : PConsigs
      pktdist              : FMap QualName PKT
      prekind              : KSubst
      ptsdist              : FMap QualName PTS
      toplevel             : Bool

   chained attributes:
      abstracttps_collect  : Set QualName
      bimapimps_collect    : [Request_BimapImply]
      constructors_collect : FMap QualName QualNames
      deps_collect         : FMap QualName QualNames
      funimps_collect      : [Request_FunImply]
      genabs_collect       : Set QualName
      implications_collect : [Request_TypeImply]
      kinames              : KSubst
      kindvar              : Int
      ksubst               : KSubst
      methods_collect      : FMap QualName QualNames
      pconsigs_col         : PConsigs
      pktcoll              : FMap QualName PKT
      ptscoll              : FMap QualName PTS
      rawrequest_collect   : [RawRequest]

   synthesised attributes:
      count                : Int
      exports_collect      : Exports
      imports_collect      : Imports
      initialTypes         : [QualName]
      initialValues        : [QualName]
      kind_errors          : [GHError]
      nil                  : Bool
      nonrecs              : [TypedBinding]
      self                 : Types

-}
{-
   local variables for Types.Cons:

-}
{-
   local variables for Types.Nil:

-}
-- semantic domain
type T_Types = (Set QualName) ->
               ([Request_BimapImply]) ->
               (Maybe QualName) ->
               (Consigs) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Set QualName) ->
               (Set QualName) ->
               (Exports) ->
               ([Request_FunImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               ([Request_TypeImply]) ->
               (Set QualName) ->
               (Set QualName) ->
               (Bool) ->
               (Set QualName) ->
               (Set QualName) ->
               (KSubst) ->
               (Int) ->
               (KSubst) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (PConsigs) ->
               (PConsigs) ->
               (FMap QualName PKT) ->
               (FMap QualName PKT) ->
               (KSubst) ->
               (FMap QualName PTS) ->
               (FMap QualName PTS) ->
               ([RawRequest]) ->
               (Bool) ->
               ((Set QualName),([Request_BimapImply]),(FMap QualName QualNames),(Int),(FMap QualName QualNames),(Exports),([Request_FunImply]),(Set QualName),([Request_TypeImply]),(Imports),([QualName]),([QualName]),(KSubst),([GHError]),(Int),(KSubst),(FMap QualName QualNames),(Bool),([TypedBinding]),(PConsigs),(FMap QualName PKT),(FMap QualName PTS),([RawRequest]),(Types))
-- cata
sem_Types :: (Types) ->
             (T_Types)
sem_Types (list) =
    (foldr (sem_Types_Cons) (sem_Types_Nil) ((map sem_Type list)))
sem_Types_Cons :: (T_Type) ->
                  (T_Types) ->
                  (T_Types)
sem_Types_Cons (_hd)
               (_tl)
               (_lhs_abstracttps_collect)
               (_lhs_bimapimps_collect)
               (_lhs_classname)
               (_lhs_consigs)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_deps)
               (_lhs_deps_collect)
               (_lhs_exportedTypes)
               (_lhs_exportedValues)
               (_lhs_exports)
               (_lhs_funimps_collect)
               (_lhs_genabs)
               (_lhs_genabs_collect)
               (_lhs_hiddenTypes)
               (_lhs_hiddenValues)
               (_lhs_hiding)
               (_lhs_implications_collect)
               (_lhs_impliedTypes)
               (_lhs_impliedValues)
               (_lhs_importedModule)
               (_lhs_importedTypes)
               (_lhs_importedValues)
               (_lhs_kinames)
               (_lhs_kindvar)
               (_lhs_ksubst)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_pconsigs)
               (_lhs_pconsigs_col)
               (_lhs_pktcoll)
               (_lhs_pktdist)
               (_lhs_prekind)
               (_lhs_ptscoll)
               (_lhs_ptsdist)
               (_lhs_rawrequest_collect)
               (_lhs_toplevel) =
    let ( _hd_abstracttps_collect,_hd_bimapimps_collect,_hd_constructors_collect,_hd_deps_collect,_hd_exports_collect,_hd_funimps_collect,_hd_genabs_collect,_hd_implications_collect,_hd_imports_collect,_hd_inferkind,_hd_initialTypes,_hd_initialValues,_hd_kinames,_hd_kind_errors,_hd_kindvar,_hd_kloc,_hd_ksubst,_hd_methods_collect,_hd_nonrecs,_hd_pconsigs_col,_hd_pktcoll,_hd_ptscoll,_hd_rawrequest_collect,_hd_self) =
            (_hd (_lhs_abstracttps_collect)
                 (_lhs_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_lhs_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_lhs_funimps_collect)
                 (_lhs_genabs)
                 (_lhs_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_lhs_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_lhs_kinames)
                 (_lhs_kindvar)
                 (_lhs_ksubst)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_lhs_pconsigs_col)
                 (_lhs_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_lhs_ptscoll)
                 (_lhs_ptsdist)
                 (_lhs_rawrequest_collect)
                 (_lhs_toplevel))
        ( _tl_abstracttps_collect,_tl_bimapimps_collect,_tl_constructors_collect,_tl_count,_tl_deps_collect,_tl_exports_collect,_tl_funimps_collect,_tl_genabs_collect,_tl_implications_collect,_tl_imports_collect,_tl_initialTypes,_tl_initialValues,_tl_kinames,_tl_kind_errors,_tl_kindvar,_tl_ksubst,_tl_methods_collect,_tl_nil,_tl_nonrecs,_tl_pconsigs_col,_tl_pktcoll,_tl_ptscoll,_tl_rawrequest_collect,_tl_self) =
            (_tl (_hd_abstracttps_collect)
                 (_hd_bimapimps_collect)
                 (_lhs_classname)
                 (_lhs_consigs)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_deps)
                 (_hd_deps_collect)
                 (_lhs_exportedTypes)
                 (_lhs_exportedValues)
                 (_lhs_exports)
                 (_hd_funimps_collect)
                 (_lhs_genabs)
                 (_hd_genabs_collect)
                 (_lhs_hiddenTypes)
                 (_lhs_hiddenValues)
                 (_lhs_hiding)
                 (_hd_implications_collect)
                 (_lhs_impliedTypes)
                 (_lhs_impliedValues)
                 (_lhs_importedModule)
                 (_lhs_importedTypes)
                 (_lhs_importedValues)
                 (_hd_kinames)
                 (_hd_kindvar)
                 (_hd_ksubst)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_pconsigs)
                 (_hd_pconsigs_col)
                 (_hd_pktcoll)
                 (_lhs_pktdist)
                 (_lhs_prekind)
                 (_hd_ptscoll)
                 (_lhs_ptsdist)
                 (_hd_rawrequest_collect)
                 (_lhs_toplevel))
    in  (_tl_abstracttps_collect
        ,_tl_bimapimps_collect
        ,_tl_constructors_collect
        ,_tl_count + 1
        ,_tl_deps_collect
        ,_hd_exports_collect ++ _tl_exports_collect
        ,_tl_funimps_collect
        ,_tl_genabs_collect
        ,_tl_implications_collect
        ,_hd_imports_collect ++ _tl_imports_collect
        ,_hd_initialTypes ++ _tl_initialTypes
        ,_hd_initialValues ++ _tl_initialValues
        ,_tl_kinames
        ,_hd_kind_errors ++ _tl_kind_errors
        ,_tl_kindvar
        ,_tl_ksubst
        ,_tl_methods_collect
        ,False
        ,_hd_nonrecs ++ _tl_nonrecs
        ,_tl_pconsigs_col
        ,_tl_pktcoll
        ,_tl_ptscoll
        ,_tl_rawrequest_collect
        ,_hd_self : _tl_self
        )
sem_Types_Nil :: (T_Types)
sem_Types_Nil (_lhs_abstracttps_collect)
              (_lhs_bimapimps_collect)
              (_lhs_classname)
              (_lhs_consigs)
              (_lhs_constructors_collect)
              (_lhs_constructors_dist)
              (_lhs_currentModule)
              (_lhs_deps)
              (_lhs_deps_collect)
              (_lhs_exportedTypes)
              (_lhs_exportedValues)
              (_lhs_exports)
              (_lhs_funimps_collect)
              (_lhs_genabs)
              (_lhs_genabs_collect)
              (_lhs_hiddenTypes)
              (_lhs_hiddenValues)
              (_lhs_hiding)
              (_lhs_implications_collect)
              (_lhs_impliedTypes)
              (_lhs_impliedValues)
              (_lhs_importedModule)
              (_lhs_importedTypes)
              (_lhs_importedValues)
              (_lhs_kinames)
              (_lhs_kindvar)
              (_lhs_ksubst)
              (_lhs_local)
              (_lhs_methods_collect)
              (_lhs_methods_dist)
              (_lhs_pconsigs)
              (_lhs_pconsigs_col)
              (_lhs_pktcoll)
              (_lhs_pktdist)
              (_lhs_prekind)
              (_lhs_ptscoll)
              (_lhs_ptsdist)
              (_lhs_rawrequest_collect)
              (_lhs_toplevel) =
    let 
    in  (_lhs_abstracttps_collect,_lhs_bimapimps_collect,_lhs_constructors_collect,0,_lhs_deps_collect,[],_lhs_funimps_collect,_lhs_genabs_collect,_lhs_implications_collect,[],[],[],_lhs_kinames,[],_lhs_kindvar,_lhs_ksubst,_lhs_methods_collect,True,[],_lhs_pconsigs_col,_lhs_pktcoll,_lhs_ptscoll,_lhs_rawrequest_collect,[])

