-- do not edit; automatically generated by UU_AG
module NameReplace where

import FMap
import ErrorUtils
import ErrorMessages
import Name

import qualified List
import qualified Set
import Set (mkSet,Set())

import AbstractD


prepareExportList              :: [QualName]   -- values
                               -> [QualName]   -- types
                               -> FMap QualName [QualName]  -- constructors
                               -> FMap QualName [QualName]  -- methods
                               -> Exports

prepareExportList vals types conss meths
                               =  prepare vals types
  where
    prepare vals []            =  map Export_Var vals
    prepare vals (t:ts)        =  let cms = findL conss t ++ findL meths t
                                      (rcms,others) = List.partition (`elem` cms) vals
                                  in  ( if   null rcms 
                                        then Export_Abstract t
                                        else if   length rcms == length cms
                                             then Export_TypeAll t
                                             else Export_TypeSome t rcms
                                      ) : prepare others ts



selectEFromV                           :: FMap QualName [Entity]  {- known values -} 
                                       -> FMap QualName [Entity]  {- known types -}
                                       -> Exports 
                                       -> FMap QualName QualNames {- constructor map -}
                                       -> FMap QualName QualNames {- methods map -}
                                       -> Set QualName
selectEFromV known knownT fs cs ms     =  Set.mkSet
                                       .  concatMap (map (\x -> QualName_Entity unkrange x Nothing) . snd) 
                                       .  filter select . toList $ known
  where 
    select                             :: (QualName,[Entity]) -> Bool
    select (n,(e:_))                   =  or . map (coveredBy n (QualName_Entity unkrange e Nothing)) $ fs
    select _                           =  False

    coveredBy                          :: QualName -> QualName -> Export -> Bool
    coveredBy _ m (Export_Var n)       =  m == n
    coveredBy _ m (Export_Abstract _)  =  False  {- only on type level -}
    coveredBy _ m (Export_TypeAll t)   =  let {- find all constructors/methods for this type -}
                                              vs = findL cs t ++ findL ms t 
                                          in  m `elem` vs
    coveredBy _ m (Export_TypeSome _ ns) =  m `elem` ns
    coveredBy _ _ (Export_Module _)    =  internalError "NameReplace.selectEFromV: unresolved module"

{-
    coveredBy (QualName_Qual _ m _) _ (Export_Module i)
                                       =  m == i
    coveredBy _ _ (Export_Module _)    =  False
    coveredBy (QualName_Qual _ m _) (QualName_Entity _ (Entity_Entity m' _) _) (Export_Local i)
                                       =  m == i && m' == m
-}

selectEFromT                           :: FMap QualName [Entity] -> Exports
                                       -> Set QualName
selectEFromT known fs                  =  mkSet
                                       .  concatMap (map (\x -> QualName_Entity unkrange x Nothing) . snd)
                                       .  filter select . toList $ known
  where 
    select                             :: (QualName,[Entity]) -> Bool
    select (n,(e:_))                   =  or . map (coveredBy n (QualName_Entity unkrange e Nothing)) $ fs
    select _                           =  False

    coveredBy                          :: QualName -> QualName -> Export -> Bool
    coveredBy _ m (Export_Var n)       =  m == n {- not . null $ findL known m `List.intersect` findL known n -}
    coveredBy _ m (Export_Abstract n)  =  m == n {- not . null $ findL known m `List.intersect` findL known n -}
    coveredBy _ m (Export_TypeAll n)   =  m == n {- not . null $ findL known m `List.intersect` findL known n -}
    coveredBy _ m (Export_TypeSome n _)=  m == n {- not . null $ findL known m `List.intersect` findL known n -}
    coveredBy _ _ (Export_Module _)    =  internalError "NameReplace.selectEFromV: unresolved module"

{-
    coveredBy (QualName_Qual _ m _) _ (Export_Module i)
                                       =  m == i
    coveredBy _ _ (Export_Module _)    =  False
-}



filterResolveError             :: ResolveResult -> [GHError]
filterResolveError (UnResolved _ _ e) = [e]
filterResolveError _                  = []

filterMessages                 :: ResolveResult -> String
filterMessages (Resolved n e)  =  "RES " ++ show n ++ (replicate (max (30 - length (show n)) 0) ' ') ++ " --> " ++ show e ++ "\n"
filterMessages (Defined e)     =  "DEF " ++ show e ++ "\n"
filterMessages (UnResolved n ns e)  =  "\n !!! " ++ show n ++ " not found among:\n" ++ show ns ++ "\n\n"
filterMessages (Mapping s m)   =  "\n" ++ s ++ "\n" ++ showFM m ++ "\n\n"



resolve                        :: Root -> Int -> (String,Bool,Root,Set QualName,Set QualName,[(Set QualName,Set QualName)],[(Set QualName,Set QualName)],Set Modid)
resolve root vbty              =  sem_Root root vbty



mergeImports :: FMap QualName [Entity] -> FMap QualName [Entity] -> FMap QualName [Entity]

{- It would be much better to find an implementation that does not go via lists ... -}

mergeImports ns os = let news = toList ns
                     in  foldr (\e fm -> addLUnion fm e) os news



selectFromV                            :: (Bool -> Bool) 
                                       -> FMap QualName [Entity]  {- known values -} 
                                       -> FMap QualName [Entity]  {- known types -}
                                       -> Imports 
                                       -> FMap QualName QualNames {- constructor map -}
                                       -> FMap QualName QualNames {- methods map -}
                                       -> FMap QualName [Entity]
selectFromV b known knownT fs cs ms    =  fromList . filter (b . select) . toList $ known
  where 
    select                             :: (QualName,[Entity]) -> Bool
    select (n,(e:_))                   =  or . map (coveredBy (QualName_Entity unkrange e Nothing)) $ fs
    select _                           =  False

    coveredBy                          :: QualName -> Import -> Bool
    coveredBy m (Import_Var n)         =  m == n
    coveredBy m (Import_Abstract _)    =  False  {- only on type level -}
    coveredBy m (Import_TypeAll t)     =  let {- find all constructors/methods for this type -}
                                              vs = findL cs t ++ findL ms t
                                          in  or . map (== m) $ vs
    coveredBy m (Import_TypeSome _ ns) =  or . map (coveredBy m . Import_Var) $ ns

selectFromT                            :: (Bool -> Bool) -> FMap QualName [Entity] -> Imports 
                                       -> FMap QualName [Entity]
selectFromT b known fs                 =  fromList . filter (b . select) . toList $ known
  where 
    select                             :: (QualName,[Entity]) -> Bool
    select (n,(e:_))                   =  or . map (coveredBy (QualName_Entity unkrange e Nothing)) $ fs
    select _                           =  False

    coveredBy                          :: QualName -> Import -> Bool
    coveredBy m (Import_Var n)         =  m == n
    coveredBy m (Import_Abstract n)    =  m == n
    coveredBy m (Import_TypeAll n)     =  m == n
    coveredBy m (Import_TypeSome n _)  =  m == n



prefixEntity                           :: Maybe Modid -> QualName -> (QualName,[Entity])
prefixEntity p (QualName_Plain _ n)    =  (prefixWith p n,[]) {- should not happen -}
prefixEntity p (QualName_Qual _ m n)   =  (prefixWith p n,[Entity_Entity (Just m) n])
prefixEntity p (QualName_Entity _ e@(Entity_Entity m n) _) =  (prefixWith p n,[e])

prefixWith                             :: Maybe Modid -> Name -> QualName
prefixWith Nothing n                   =  QualName_Plain unkrange n
prefixWith (Just m) n                  =  QualName_Qual  unkrange m n

{-
toEntity                               :: Modid -> QualName -> (QualName,[Entity])
toEntity m (QualName_Plain _ n)        =  (QualName_Qual unkrange m n,[]) {- should not happen -}
toEntity _ (QualName_Qual r m n)       =  (QualName_Qual r m n,[Entity_Entity (Just m) n])
toEntity _ (QualName_Entity _ _ _)     =  internalError "Names.toEntity: illegal entity discovered"
-}

getEntity                              :: QualName -> Entity
getEntity (QualName_Entity _ e _)      =  e
getEntity _                            =  internalError "Names.getEntity: unresolved name found"



data NameType = Def_Val | Def_Typ | Def_Kind | Ref_Val | Ref_Typ | Ref_Kind | NameType_None
  deriving (Eq,Show)

isDef :: NameType -> Bool
isDef Def_Val  = True
isDef Def_Typ  = True
isDef Def_Kind = True
isDef _        = False

isRef :: NameType -> Bool
isRef Ref_Val  = True
isRef Ref_Typ  = True
isRef Ref_Kind = True
isRef _        = False



data ResolveResult = Resolved QualName Entity 
                   | Defined Entity 
                   | UnResolved QualName [QualName] GHError 
                   | Mapping String (FMap QualName [Entity])

-- Alt ---------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Alt

-}
{-
   local variables for Alt.Alt:
      knownValues
      knownValues'

-}
{-
   local variables for Alt.Empty:

-}
-- semantic domain
type T_Alt = (Maybe QualName) ->
             (FMap QualName QualNames) ->
             (FMap QualName QualNames) ->
             (Modid) ->
             (Bool) ->
             (Bool) ->
             (Bool) ->
             (FMap QualName [Entity]) ->
             (FMap QualName [Entity]) ->
             (FMap QualName [Entity]) ->
             (FMap QualName [Entity]) ->
             (FMap QualName [Entity]) ->
             (FMap QualName [Entity]) ->
             (Bool) ->
             (FMap QualName QualNames) ->
             (FMap QualName QualNames) ->
             (FMap Modid [QualName]) ->
             (FMap Modid [QualName]) ->
             (NameType) ->
             (Bool) ->
             ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Alt))
-- cata
sem_Alt :: (Alt) ->
           (T_Alt)
sem_Alt ((Alt_Alt (_pattern) (_cs) (_where))) =
    (sem_Alt_Alt ((sem_Pattern (_pattern))) ((sem_Case (_cs))) ((sem_SDecls (_where))))
sem_Alt ((Alt_Empty )) =
    (sem_Alt_Empty )
sem_Alt_Alt :: (T_Pattern) ->
               (T_Case) ->
               (T_SDecls) ->
               (T_Alt)
sem_Alt_Alt (_pattern) (_cs) (_where) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_knownValues') =
            _pattern_knownValues_collect `mergeFM` _lhs_knownValues
        (_knownValues) =
            _where_knownValues_collect `mergeFM` _knownValues'
        ( _pattern_constructors_collect,_pattern_knownKinds_collect,_pattern_knownTypes_collect,_pattern_knownValues_collect,_pattern_methods_collect,_pattern_moduleTypes,_pattern_moduleValues,_pattern_modules,_pattern_res,_pattern_self) =
            (_pattern (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_knownValues) (emptyFM) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _cs_constructors_collect,_cs_knownKinds_collect,_cs_knownTypes_collect,_cs_knownValues_collect,_cs_methods_collect,_cs_moduleTypes,_cs_moduleValues,_cs_modules,_cs_res,_cs_self) =
            (_cs (_lhs_classname) (_pattern_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_pattern_knownKinds_collect) (_lhs_knownTypes) (_pattern_knownTypes_collect) (_knownValues) (_pattern_knownValues_collect) (_lhs_local) (_pattern_methods_collect) (_lhs_methods_dist) (_pattern_moduleTypes) (_pattern_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _where_constructors_collect,_where_knownKinds_collect,_where_knownTypes_collect,_where_knownValues_collect,_where_methods_collect,_where_moduleTypes,_where_moduleValues,_where_modules,_where_res,_where_self) =
            (_where (_lhs_classname) (_cs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_cs_knownKinds_collect) (_lhs_knownTypes) (_cs_knownTypes_collect) (_knownValues) (emptyFM) (_lhs_local) (_cs_methods_collect) (_lhs_methods_dist) (_cs_moduleTypes) (_cs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_where_constructors_collect,_where_knownKinds_collect,_where_knownTypes_collect,_lhs_knownValues_collect,_where_methods_collect,_where_moduleTypes,_where_moduleValues,_pattern_modules `Set.union` _cs_modules `Set.union` _where_modules,_pattern_res ++ _cs_res ++ _where_res,Alt_Alt _pattern_self _cs_self _where_self)
sem_Alt_Empty :: (T_Alt)
sem_Alt_Empty (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],Alt_Empty)
-- Alts --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Alts

-}
{-
   local variables for Alts.Cons:

-}
{-
   local variables for Alts.Nil:

-}
-- semantic domain
type T_Alts = (Maybe QualName) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Modid) ->
              (Bool) ->
              (Bool) ->
              (Bool) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (Bool) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (FMap Modid [QualName]) ->
              (FMap Modid [QualName]) ->
              (NameType) ->
              (Bool) ->
              ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Alts))
-- cata
sem_Alts :: (Alts) ->
            (T_Alts)
sem_Alts (list) =
    (foldr (sem_Alts_Cons) (sem_Alts_Nil) ((map sem_Alt list)))
sem_Alts_Cons :: (T_Alt) ->
                 (T_Alts) ->
                 (T_Alts)
sem_Alts_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _hd_constructors_collect,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self) =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_lhs_local) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_Alts_Nil :: (T_Alts)
sem_Alts_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])
-- Args --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Args

-}
{-
   local variables for Args.Cons:

-}
{-
   local variables for Args.Nil:

-}
-- semantic domain
type T_Args = (Maybe QualName) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Modid) ->
              (Bool) ->
              (Bool) ->
              (Bool) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (Bool) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (FMap Modid [QualName]) ->
              (FMap Modid [QualName]) ->
              (NameType) ->
              (Bool) ->
              ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Args))
-- cata
sem_Args :: (Args) ->
            (T_Args)
sem_Args (list) =
    (foldr (sem_Args_Cons) (sem_Args_Nil) ((map sem_QualName list)))
sem_Args_Cons :: (T_QualName) ->
                 (T_Args) ->
                 (T_Args)
sem_Args_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _hd_constructors_collect,_hd_entityName,_hd_fullName,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self,_hd_self') =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_lhs_local) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_Args_Nil :: (T_Args)
sem_Args_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])
-- Binding -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Binding

-}
{-
   local variables for Binding.Binding:
      knownValues
      knownValues'

-}
-- semantic domain
type T_Binding = (Maybe QualName) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Modid) ->
                 (Bool) ->
                 (Bool) ->
                 (Bool) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (Bool) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (FMap Modid [QualName]) ->
                 (FMap Modid [QualName]) ->
                 (NameType) ->
                 (Bool) ->
                 ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Binding))
-- cata
sem_Binding :: (Binding) ->
               (T_Binding)
sem_Binding ((Binding_Binding (_lh) (_rh) (_where))) =
    (sem_Binding_Binding ((sem_Patterns (_lh))) ((sem_Rhs (_rh))) ((sem_SDecls (_where))))
sem_Binding_Binding :: (T_Patterns) ->
                       (T_Rhs) ->
                       (T_SDecls) ->
                       (T_Binding)
sem_Binding_Binding (_lh) (_rh) (_where) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_knownValues') =
            _lh_knownValues_collect `mergeFM` _lhs_knownValues
        (_knownValues) =
            _where_knownValues_collect `mergeFM` _knownValues'
        ( _lh_constructors_collect,_lh_knownKinds_collect,_lh_knownTypes_collect,_lh_knownValues_collect,_lh_methods_collect,_lh_moduleTypes,_lh_moduleValues,_lh_modules,_lh_res,_lh_self) =
            (_lh (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_knownValues) (emptyFM) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _rh_constructors_collect,_rh_knownKinds_collect,_rh_knownTypes_collect,_rh_knownValues_collect,_rh_methods_collect,_rh_moduleTypes,_rh_moduleValues,_rh_modules,_rh_res,_rh_self) =
            (_rh (_lhs_classname) (_lh_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lh_knownKinds_collect) (_lhs_knownTypes) (_lh_knownTypes_collect) (_knownValues) (_lh_knownValues_collect) (_lhs_local) (_lh_methods_collect) (_lhs_methods_dist) (_lh_moduleTypes) (_lh_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _where_constructors_collect,_where_knownKinds_collect,_where_knownTypes_collect,_where_knownValues_collect,_where_methods_collect,_where_moduleTypes,_where_moduleValues,_where_modules,_where_res,_where_self) =
            (_where (_lhs_classname) (_rh_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_rh_knownKinds_collect) (_lhs_knownTypes) (_rh_knownTypes_collect) (_knownValues) (emptyFM) (_lhs_local) (_rh_methods_collect) (_lhs_methods_dist) (_rh_moduleTypes) (_rh_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_where_constructors_collect
        ,_where_knownKinds_collect
        ,_where_knownTypes_collect
        ,_lhs_knownValues_collect
        ,_where_methods_collect
        ,_where_moduleTypes
        ,_where_moduleValues
        ,_lh_modules `Set.union` _rh_modules `Set.union` _where_modules
        ,_lh_res ++ _rh_res ++ _where_res
        ,Binding_Binding _lh_self _rh_self
                         _where_self
        )
-- Bindings ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Bindings

-}
{-
   local variables for Bindings.Cons:

-}
{-
   local variables for Bindings.Nil:

-}
-- semantic domain
type T_Bindings = (Maybe QualName) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Modid) ->
                  (Bool) ->
                  (Bool) ->
                  (Bool) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (Bool) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (FMap Modid [QualName]) ->
                  (FMap Modid [QualName]) ->
                  (NameType) ->
                  (Bool) ->
                  ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Bindings))
-- cata
sem_Bindings :: (Bindings) ->
                (T_Bindings)
sem_Bindings (list) =
    (foldr (sem_Bindings_Cons) (sem_Bindings_Nil) ((map sem_Binding list)))
sem_Bindings_Cons :: (T_Binding) ->
                     (T_Bindings) ->
                     (T_Bindings)
sem_Bindings_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _hd_constructors_collect,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self) =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_lhs_local) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_Bindings_Nil :: (T_Bindings)
sem_Bindings_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])
-- Body --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      hiddenEntities       : [(Set QualName,Set QualName)]
      importedEntities     : [(Set QualName,Set QualName)]
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Body

-}
{-
   local variables for Body.Body:
      mapping

-}
-- semantic domain
type T_Body = (Maybe QualName) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Modid) ->
              (Bool) ->
              (Bool) ->
              (Bool) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (Bool) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (FMap Modid [QualName]) ->
              (FMap Modid [QualName]) ->
              (NameType) ->
              (Bool) ->
              ((FMap QualName QualNames),([(Set QualName,Set QualName)]),([(Set QualName,Set QualName)]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Body))
-- cata
sem_Body :: (Body) ->
            (T_Body)
sem_Body ((Body_Body (_impdecls) (_decls))) =
    (sem_Body_Body ((sem_Impdecls (_impdecls))) ((sem_Decls (_decls))))
sem_Body_Body :: (T_Impdecls) ->
                 (T_Decls) ->
                 (T_Body)
sem_Body_Body (_impdecls) (_decls) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_mapping) =
            [Mapping "imported values" _impdecls_knownValues_collect
            ,Mapping "imported types"  _impdecls_knownTypes_collect
            ]
        ( _impdecls_constructors_collect,_impdecls_hiddenEntities,_impdecls_importedEntities,_impdecls_knownKinds_collect,_impdecls_knownTypes_collect,_impdecls_knownValues_collect,_impdecls_methods_collect,_impdecls_moduleTypes,_impdecls_moduleValues,_impdecls_modules,_impdecls_res,_impdecls_self) =
            (_impdecls (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (emptyFM) (_lhs_knownValues) (emptyFM) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _decls_constructors_collect,_decls_knownKinds_collect,_decls_knownTypes_collect,_decls_knownValues_collect,_decls_methods_collect,_decls_moduleTypes,_decls_moduleValues,_decls_modules,_decls_res,_decls_self) =
            (_decls (_lhs_classname) (_impdecls_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_impdecls_knownKinds_collect) (_lhs_knownTypes) (emptyFM) (_lhs_knownValues) (emptyFM) (_lhs_local) (_impdecls_methods_collect) (_lhs_methods_dist) (_impdecls_moduleTypes) (_impdecls_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_decls_constructors_collect,_impdecls_hiddenEntities,_impdecls_importedEntities,_decls_knownKinds_collect,mergeImports _impdecls_knownTypes_collect _decls_knownTypes_collect,mergeImports _impdecls_knownValues_collect _decls_knownValues_collect,_decls_methods_collect,_decls_moduleTypes,_decls_moduleValues,_impdecls_modules `Set.union` _decls_modules,_impdecls_res ++ _mapping ++ _decls_res,Body_Body _impdecls_self _decls_self)
-- Case --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Case

-}
{-
   local variables for Case.Guarded:

-}
{-
   local variables for Case.Unguarded:

-}
-- semantic domain
type T_Case = (Maybe QualName) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Modid) ->
              (Bool) ->
              (Bool) ->
              (Bool) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (Bool) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (FMap Modid [QualName]) ->
              (FMap Modid [QualName]) ->
              (NameType) ->
              (Bool) ->
              ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Case))
-- cata
sem_Case :: (Case) ->
            (T_Case)
sem_Case ((Case_Guarded (_grds))) =
    (sem_Case_Guarded ((sem_GuardedAlts (_grds))))
sem_Case ((Case_Unguarded (_expr))) =
    (sem_Case_Unguarded ((sem_Expr (_expr))))
sem_Case_Guarded :: (T_GuardedAlts) ->
                    (T_Case)
sem_Case_Guarded (_grds) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _grds_constructors_collect,_grds_knownKinds_collect,_grds_knownTypes_collect,_grds_knownValues_collect,_grds_methods_collect,_grds_moduleTypes,_grds_moduleValues,_grds_modules,_grds_res,_grds_self) =
            (_grds (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_grds_constructors_collect,_grds_knownKinds_collect,_grds_knownTypes_collect,_grds_knownValues_collect,_grds_methods_collect,_grds_moduleTypes,_grds_moduleValues,_grds_modules,_grds_res,Case_Guarded _grds_self)
sem_Case_Unguarded :: (T_Expr) ->
                      (T_Case)
sem_Case_Unguarded (_expr) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _expr_constructors_collect,_expr_knownKinds_collect,_expr_knownTypes_collect,_expr_knownValues_collect,_expr_methods_collect,_expr_moduleTypes,_expr_moduleValues,_expr_modules,_expr_res,_expr_self) =
            (_expr (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_expr_constructors_collect,_expr_knownKinds_collect,_expr_knownTypes_collect,_expr_knownValues_collect,_expr_methods_collect,_expr_moduleTypes,_expr_moduleValues,_expr_modules,_expr_res,Case_Unguarded _expr_self)
-- Class -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Class

-}
{-
   local variables for Class.Class:

-}
-- semantic domain
type T_Class = (Maybe QualName) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (Bool) ->
               (Bool) ->
               (Bool) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (FMap Modid [QualName]) ->
               (FMap Modid [QualName]) ->
               (NameType) ->
               (Bool) ->
               ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Class))
-- cata
sem_Class :: (Class) ->
             (T_Class)
sem_Class ((Class_Class (_name) (_tps))) =
    (sem_Class_Class ((sem_QualName (_name))) ((sem_Types (_tps))))
sem_Class_Class :: (T_QualName) ->
                   (T_Types) ->
                   (T_Class)
sem_Class_Class (_name) (_tps) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Typ) (_lhs_toplevel))
        ( _tps_constructors_collect,_tps_knownKinds_collect,_tps_knownTypes_collect,_tps_knownValues_collect,_tps_methods_collect,_tps_moduleTypes,_tps_moduleValues,_tps_modules,_tps_res,_tps_self) =
            (_tps (_lhs_classname) (_name_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_name_knownKinds_collect) (_lhs_knownTypes) (_name_knownTypes_collect) (_lhs_knownValues) (_name_knownValues_collect) (_lhs_local) (_name_methods_collect) (_lhs_methods_dist) (_name_moduleTypes) (_name_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tps_constructors_collect,_tps_knownKinds_collect,_tps_knownTypes_collect,_tps_knownValues_collect,_tps_methods_collect,_tps_moduleTypes,_tps_moduleValues,_name_modules `Set.union` _tps_modules,_name_res ++ _tps_res,Class_Class _name_self _tps_self)
-- Classes -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Classes

-}
{-
   local variables for Classes.Cons:

-}
{-
   local variables for Classes.Nil:

-}
-- semantic domain
type T_Classes = (Maybe QualName) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Modid) ->
                 (Bool) ->
                 (Bool) ->
                 (Bool) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (Bool) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (FMap Modid [QualName]) ->
                 (FMap Modid [QualName]) ->
                 (NameType) ->
                 (Bool) ->
                 ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Classes))
-- cata
sem_Classes :: (Classes) ->
               (T_Classes)
sem_Classes (list) =
    (foldr (sem_Classes_Cons) (sem_Classes_Nil) ((map sem_Class list)))
sem_Classes_Cons :: (T_Class) ->
                    (T_Classes) ->
                    (T_Classes)
sem_Classes_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _hd_constructors_collect,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self) =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_lhs_local) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_Classes_Nil :: (T_Classes)
sem_Classes_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])
-- Constr ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool
      tpname               : QualName

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      constructors         : QualNames
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Constr

-}
{-
   local variables for Constr.Constr:

-}
-- semantic domain
type T_Constr = (Maybe QualName) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Modid) ->
                (Bool) ->
                (Bool) ->
                (Bool) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (Bool) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (FMap Modid [QualName]) ->
                (FMap Modid [QualName]) ->
                (NameType) ->
                (Bool) ->
                (QualName) ->
                ((QualNames),(FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Constr))
-- cata
sem_Constr :: (Constr) ->
              (T_Constr)
sem_Constr ((Constr_Constr (_name) (_types))) =
    (sem_Constr_Constr ((sem_QualName (_name))) ((sem_LabelTypes (_types))))
sem_Constr_Constr :: (T_QualName) ->
                     (T_LabelTypes) ->
                     (T_Constr)
sem_Constr_Constr (_name)
                  (_types)
                  (_lhs_classname)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_importedModule)
                  (_lhs_ininstance)
                  (_lhs_intitype)
                  (_lhs_knownKinds)
                  (_lhs_knownKinds_collect)
                  (_lhs_knownTypes)
                  (_lhs_knownTypes_collect)
                  (_lhs_knownValues)
                  (_lhs_knownValues_collect)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_moduleTypes)
                  (_lhs_moduleValues)
                  (_lhs_nameType)
                  (_lhs_toplevel)
                  (_lhs_tpname) =
    let ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Def_Val) (_lhs_toplevel))
        ( _types_constructors,_types_constructors_collect,_types_knownKinds_collect,_types_knownTypes_collect,_types_knownValues_collect,_types_methods_collect,_types_moduleTypes,_types_moduleValues,_types_modules,_types_res,_types_self) =
            (_types (_lhs_classname) (_name_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_name_knownKinds_collect) (_lhs_knownTypes) (_name_knownTypes_collect) (_lhs_knownValues) (_name_knownValues_collect) (_lhs_local) (_name_methods_collect) (_lhs_methods_dist) (_name_moduleTypes) (_name_moduleValues) (_lhs_nameType) (_lhs_toplevel) (_lhs_tpname))
    in  ([_name_self],_types_constructors_collect,_types_knownKinds_collect,_types_knownTypes_collect,_types_knownValues_collect,_types_methods_collect,_types_moduleTypes,_types_moduleValues,_name_modules `Set.union` _types_modules,_name_res ++ _types_res,Constr_Constr _name_self _types_self)
-- Constrs -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool
      tpname               : QualName

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      constructors         : QualNames
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Constrs

-}
{-
   local variables for Constrs.Cons:

-}
{-
   local variables for Constrs.Nil:

-}
-- semantic domain
type T_Constrs = (Maybe QualName) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Modid) ->
                 (Bool) ->
                 (Bool) ->
                 (Bool) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (Bool) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (FMap Modid [QualName]) ->
                 (FMap Modid [QualName]) ->
                 (NameType) ->
                 (Bool) ->
                 (QualName) ->
                 ((QualNames),(FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Constrs))
-- cata
sem_Constrs :: (Constrs) ->
               (T_Constrs)
sem_Constrs (list) =
    (foldr (sem_Constrs_Cons) (sem_Constrs_Nil) ((map sem_Constr list)))
sem_Constrs_Cons :: (T_Constr) ->
                    (T_Constrs) ->
                    (T_Constrs)
sem_Constrs_Cons (_hd)
                 (_tl)
                 (_lhs_classname)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_importedModule)
                 (_lhs_ininstance)
                 (_lhs_intitype)
                 (_lhs_knownKinds)
                 (_lhs_knownKinds_collect)
                 (_lhs_knownTypes)
                 (_lhs_knownTypes_collect)
                 (_lhs_knownValues)
                 (_lhs_knownValues_collect)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_moduleTypes)
                 (_lhs_moduleValues)
                 (_lhs_nameType)
                 (_lhs_toplevel)
                 (_lhs_tpname) =
    let ( _hd_constructors,_hd_constructors_collect,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self) =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) (_lhs_tpname))
        ( _tl_constructors,_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_lhs_local) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_lhs_nameType) (_lhs_toplevel) (_lhs_tpname))
    in  (_hd_constructors ++ _tl_constructors,_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_Constrs_Nil :: (T_Constrs)
sem_Constrs_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) (_lhs_tpname) =
    let 
    in  ([],_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])
-- Context -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Context

-}
{-
   local variables for Context.Context:

-}
{-
   local variables for Context.Empty:

-}
-- semantic domain
type T_Context = (Maybe QualName) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Modid) ->
                 (Bool) ->
                 (Bool) ->
                 (Bool) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (Bool) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (FMap Modid [QualName]) ->
                 (FMap Modid [QualName]) ->
                 (NameType) ->
                 (Bool) ->
                 ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Context))
-- cata
sem_Context :: (Context) ->
               (T_Context)
sem_Context ((Context_Context (_classes))) =
    (sem_Context_Context ((sem_Classes (_classes))))
sem_Context ((Context_Empty )) =
    (sem_Context_Empty )
sem_Context_Context :: (T_Classes) ->
                       (T_Context)
sem_Context_Context (_classes) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _classes_constructors_collect,_classes_knownKinds_collect,_classes_knownTypes_collect,_classes_knownValues_collect,_classes_methods_collect,_classes_moduleTypes,_classes_moduleValues,_classes_modules,_classes_res,_classes_self) =
            (_classes (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_classes_constructors_collect,_classes_knownKinds_collect,_classes_knownTypes_collect,_classes_knownValues_collect,_classes_methods_collect,_classes_moduleTypes,_classes_moduleValues,_classes_modules,_classes_res,Context_Context _classes_self)
sem_Context_Empty :: (T_Context)
sem_Context_Empty (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],Context_Empty)
-- Decl --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Decl

-}
{-
   local variables for Decl.Simple:

-}
{-
   local variables for Decl.Top:

-}
-- semantic domain
type T_Decl = (Maybe QualName) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Modid) ->
              (Bool) ->
              (Bool) ->
              (Bool) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (Bool) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (FMap Modid [QualName]) ->
              (FMap Modid [QualName]) ->
              (NameType) ->
              (Bool) ->
              ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Decl))
-- cata
sem_Decl :: (Decl) ->
            (T_Decl)
sem_Decl ((Decl_Simple (_decl))) =
    (sem_Decl_Simple ((sem_SDecl (_decl))))
sem_Decl ((Decl_Top (_decl))) =
    (sem_Decl_Top ((sem_TDecl (_decl))))
sem_Decl_Simple :: (T_SDecl) ->
                   (T_Decl)
sem_Decl_Simple (_decl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _decl_constructors_collect,_decl_knownKinds_collect,_decl_knownTypes_collect,_decl_knownValues_collect,_decl_methods_collect,_decl_moduleTypes,_decl_moduleValues,_decl_modules,_decl_res,_decl_self) =
            (_decl (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_decl_constructors_collect,_decl_knownKinds_collect,_decl_knownTypes_collect,_decl_knownValues_collect,_decl_methods_collect,_decl_moduleTypes,_decl_moduleValues,_decl_modules,_decl_res,Decl_Simple _decl_self)
sem_Decl_Top :: (T_TDecl) ->
                (T_Decl)
sem_Decl_Top (_decl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _decl_constructors_collect,_decl_knownKinds_collect,_decl_knownTypes_collect,_decl_knownValues_collect,_decl_methods_collect,_decl_moduleTypes,_decl_moduleValues,_decl_modules,_decl_res,_decl_self) =
            (_decl (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_decl_constructors_collect,_decl_knownKinds_collect,_decl_knownTypes_collect,_decl_knownValues_collect,_decl_methods_collect,_decl_moduleTypes,_decl_moduleValues,_decl_modules,_decl_res,Decl_Top _decl_self)
-- Decls -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Decls

-}
{-
   local variables for Decls.Cons:

-}
{-
   local variables for Decls.Nil:

-}
-- semantic domain
type T_Decls = (Maybe QualName) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (Bool) ->
               (Bool) ->
               (Bool) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (FMap Modid [QualName]) ->
               (FMap Modid [QualName]) ->
               (NameType) ->
               (Bool) ->
               ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Decls))
-- cata
sem_Decls :: (Decls) ->
             (T_Decls)
sem_Decls (list) =
    (foldr (sem_Decls_Cons) (sem_Decls_Nil) ((map sem_Decl list)))
sem_Decls_Cons :: (T_Decl) ->
                  (T_Decls) ->
                  (T_Decls)
sem_Decls_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _hd_constructors_collect,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self) =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_lhs_local) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_Decls_Nil :: (T_Decls)
sem_Decls_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])
-- Derivings ---------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Derivings

-}
{-
   local variables for Derivings.Cons:
      nameType

-}
{-
   local variables for Derivings.Nil:

-}
-- semantic domain
type T_Derivings = (Maybe QualName) ->
                   (FMap QualName QualNames) ->
                   (FMap QualName QualNames) ->
                   (Modid) ->
                   (Bool) ->
                   (Bool) ->
                   (Bool) ->
                   (FMap QualName [Entity]) ->
                   (FMap QualName [Entity]) ->
                   (FMap QualName [Entity]) ->
                   (FMap QualName [Entity]) ->
                   (FMap QualName [Entity]) ->
                   (FMap QualName [Entity]) ->
                   (Bool) ->
                   (FMap QualName QualNames) ->
                   (FMap QualName QualNames) ->
                   (FMap Modid [QualName]) ->
                   (FMap Modid [QualName]) ->
                   (NameType) ->
                   (Bool) ->
                   ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Derivings))
-- cata
sem_Derivings :: (Derivings) ->
                 (T_Derivings)
sem_Derivings (list) =
    (foldr (sem_Derivings_Cons) (sem_Derivings_Nil) ((map sem_QualName list)))
sem_Derivings_Cons :: (T_QualName) ->
                      (T_Derivings) ->
                      (T_Derivings)
sem_Derivings_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_nameType) =
            Ref_Typ
        ( _hd_constructors_collect,_hd_entityName,_hd_fullName,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self,_hd_self') =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_lhs_local) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_nameType) (_lhs_toplevel))
    in  (_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_Derivings_Nil :: (T_Derivings)
sem_Derivings_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])
-- Entities ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Entities

-}
{-
   local variables for Entities.Cons:

-}
{-
   local variables for Entities.Nil:

-}
-- semantic domain
type T_Entities = (Maybe QualName) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Modid) ->
                  (Bool) ->
                  (Bool) ->
                  (Bool) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (Bool) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (FMap Modid [QualName]) ->
                  (FMap Modid [QualName]) ->
                  (NameType) ->
                  (Bool) ->
                  ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Entities))
-- cata
sem_Entities :: (Entities) ->
                (T_Entities)
sem_Entities (list) =
    (foldr (sem_Entities_Cons) (sem_Entities_Nil) ((map sem_Entity list)))
sem_Entities_Cons :: (T_Entity) ->
                     (T_Entities) ->
                     (T_Entities)
sem_Entities_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _hd_constructors_collect,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self) =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_lhs_local) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_Entities_Nil :: (T_Entities)
sem_Entities_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])
-- Entity ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Entity

-}
{-
   local variables for Entity.Entity:
      self

-}
-- semantic domain
type T_Entity = (Maybe QualName) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Modid) ->
                (Bool) ->
                (Bool) ->
                (Bool) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (Bool) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (FMap Modid [QualName]) ->
                (FMap Modid [QualName]) ->
                (NameType) ->
                (Bool) ->
                ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Entity))
-- cata
sem_Entity :: (Entity) ->
              (T_Entity)
sem_Entity ((Entity_Entity (_modid) (_name))) =
    (sem_Entity_Entity (_modid) ((sem_Name (_name))))
sem_Entity_Entity :: (Maybe Modid) ->
                     (T_Name) ->
                     (T_Entity)
sem_Entity_Entity (_modid) (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Entity_Entity _modid _name_self
        ( _name_constructors_collect,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self) =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_name_constructors_collect,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_self)
-- Export ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      replace              : Exports
      res                  : [ResolveResult]
      self                 : Export

-}
{-
   local variables for Export.Abstract:

-}
{-
   local variables for Export.Module:
      relevantValues
      relevantTypes

-}
{-
   local variables for Export.TypeAll:

-}
{-
   local variables for Export.TypeSome:
      relevantEntities

-}
{-
   local variables for Export.Var:

-}
-- semantic domain
type T_Export = (Maybe QualName) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Modid) ->
                (Bool) ->
                (Bool) ->
                (Bool) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (Bool) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (FMap Modid [QualName]) ->
                (FMap Modid [QualName]) ->
                (NameType) ->
                (Bool) ->
                ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),(Exports),([ResolveResult]),(Export))
-- cata
sem_Export :: (Export) ->
              (T_Export)
sem_Export ((Export_Abstract (_name))) =
    (sem_Export_Abstract ((sem_QualName (_name))))
sem_Export ((Export_Module (_modid))) =
    (sem_Export_Module (_modid))
sem_Export ((Export_TypeAll (_name))) =
    (sem_Export_TypeAll ((sem_QualName (_name))))
sem_Export ((Export_TypeSome (_name) (_conss))) =
    (sem_Export_TypeSome ((sem_QualName (_name))) ((sem_QualNames (_conss))))
sem_Export ((Export_Var (_name))) =
    (sem_Export_Var ((sem_QualName (_name))))
sem_Export_Abstract :: (T_QualName) ->
                       (T_Export)
sem_Export_Abstract (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Typ) (_lhs_toplevel))
    in  (_name_constructors_collect,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,[Export_Abstract _name_self],_name_res,Export_Abstract _name_self)
sem_Export_Module :: (Modid) ->
                     (T_Export)
sem_Export_Module (_modid) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_relevantTypes) =
            concatMap (\ (n,es) -> case n of
                            QualName_Qual _ m u
                               | m == _modid ->
                                   let uq = QualName_Plain unkrange u
                                   in  map (\ e -> case findL _lhs_knownTypes uq of
                                                 [e'] | e == e' -> QualName_Entity unkrange e (Just uq)
                                                 _ -> QualName_Entity unkrange e (Just n)) es
                            _                -> []
                      ) $
            toList _lhs_knownTypes
        (_relevantValues) =
            concatMap (\ (n,es) -> case n of
                            QualName_Qual _ m u
                               | m == _modid ->
                                   let uq = QualName_Plain unkrange u
                                   in  map (\ e -> case findL _lhs_knownValues uq of
                                                 [e'] | e == e' -> QualName_Entity unkrange e (Just uq)
                                                 _ -> QualName_Entity unkrange e (Just n)) es
                            _                -> []
                      ) $
            toList _lhs_knownValues
    in  (_lhs_constructors_collect
        ,_lhs_knownKinds_collect
        ,_lhs_knownTypes_collect
        ,_lhs_knownValues_collect
        ,_lhs_methods_collect
        ,_lhs_moduleTypes
        ,_lhs_moduleValues
        ,Set.emptySet
        ,prepareExportList
            _relevantValues
            _relevantTypes
            _lhs_constructors_dist
            _lhs_methods_dist
        ,[]
        ,Export_Module   _modid
        )
sem_Export_TypeAll :: (T_QualName) ->
                      (T_Export)
sem_Export_TypeAll (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Typ) (_lhs_toplevel))
    in  (_name_constructors_collect,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,[Export_TypeAll _name_self],_name_res,Export_TypeAll  _name_self)
sem_Export_TypeSome :: (T_QualName) ->
                       (T_QualNames) ->
                       (T_Export)
sem_Export_TypeSome (_name) (_conss) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_relevantEntities) =
            map getEntity $
            findL _lhs_methods_dist _name_self
              ++
            findL _lhs_constructors_dist _name_self
        ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Typ) (_lhs_toplevel))
        ( _conss_constructors_collect,_conss_knownKinds_collect,_conss_knownTypes_collect,_conss_knownValues_collect,_conss_methods_collect,_conss_moduleTypes,_conss_moduleValues,_conss_modules,_conss_res,_conss_self,_conss_self') =
            (_conss (_lhs_classname)
                    (_name_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_importedModule)
                    (_lhs_ininstance)
                    (_lhs_intitype)
                    (_lhs_knownKinds)
                    (_name_knownKinds_collect)
                    (_lhs_knownTypes)
                    (_name_knownTypes_collect)
                    (( fromList
                     . filter (\ (_,es) -> not . null $ es `List.intersect`
                                                          _relevantEntities)
                     . toList
                     ) _lhs_knownValues)
                    (_name_knownValues_collect)
                    (_lhs_local)
                    (_name_methods_collect)
                    (_lhs_methods_dist)
                    (_name_moduleTypes)
                    (_name_moduleValues)
                    (Ref_Val)
                    (_lhs_toplevel))
    in  (_conss_constructors_collect,_conss_knownKinds_collect,_conss_knownTypes_collect,_lhs_knownValues_collect,_conss_methods_collect,_conss_moduleTypes,_conss_moduleValues,_name_modules `Set.union` _conss_modules,[Export_TypeSome _name_self _conss_self],_name_res ++ _conss_res,Export_TypeSome _name_self _conss_self)
sem_Export_Var :: (T_QualName) ->
                  (T_Export)
sem_Export_Var (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Val) (_lhs_toplevel))
    in  (_name_constructors_collect,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,[Export_Var _name_self],_name_res,Export_Var      _name_self)
-- Exported ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      exported             : Exports
      modules              : Set.Set Modid
      replace              : Exported
      res                  : [ResolveResult]
      self                 : Exported

-}
{-
   local variables for Exported.Exports:

-}
{-
   local variables for Exported.NoExports:
      exports_replace
      relevantValues
      relevantTypes

-}
-- semantic domain
type T_Exported = (Maybe QualName) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Modid) ->
                  (Bool) ->
                  (Bool) ->
                  (Bool) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (Bool) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (FMap Modid [QualName]) ->
                  (FMap Modid [QualName]) ->
                  (NameType) ->
                  (Bool) ->
                  ((FMap QualName QualNames),(Exports),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),(Exported),([ResolveResult]),(Exported))
-- cata
sem_Exported :: (Exported) ->
                (T_Exported)
sem_Exported ((Exported_Exports (_exports))) =
    (sem_Exported_Exports ((sem_Exports (_exports))))
sem_Exported ((Exported_NoExports )) =
    (sem_Exported_NoExports )
sem_Exported_Exports :: (T_Exports) ->
                        (T_Exported)
sem_Exported_Exports (_exports) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _exports_constructors_collect,_exports_knownKinds_collect,_exports_knownTypes_collect,_exports_knownValues_collect,_exports_methods_collect,_exports_moduleTypes,_exports_moduleValues,_exports_modules,_exports_replace,_exports_res,_exports_self) =
            (_exports (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_exports_constructors_collect,_exports_replace,_exports_knownKinds_collect,_exports_knownTypes_collect,_exports_knownValues_collect,_exports_methods_collect,_exports_moduleTypes,_exports_moduleValues,_exports_modules,Exported_Exports _exports_replace,_exports_res,Exported_Exports _exports_self)
sem_Exported_NoExports :: (T_Exported)
sem_Exported_NoExports (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_relevantTypes) =
            concatMap (\ (n,es) -> case n of
                            QualName_Qual _ m u
                               | m == _lhs_currentModule ->
                                   let uq = QualName_Plain unkrange u
                                   in  ( map (\ e -> case findL _lhs_knownTypes uq of
                                                   [e'] | e == e' -> QualName_Entity unkrange e (Just uq)
                                                   _   -> QualName_Entity unkrange e (Just n))
                                       . filter (\ (Entity_Entity m' _)
                                                -> Just m == m')
                                       ) es
                            _ -> []
                      ) $
            toList _lhs_knownTypes
        (_relevantValues) =
            concatMap (\ (n,es) -> case n of
                            QualName_Qual _ m u
                               | m == _lhs_currentModule ->
                                   let uq = QualName_Plain unkrange u
                                   in  ( map (\ e -> case findL _lhs_knownValues uq of
                                                   [e'] | e == e' -> QualName_Entity unkrange e (Just uq)
                                                   _   -> QualName_Entity unkrange e (Just n))
                                       . filter (\ (Entity_Entity m' _)
                                                -> Just m == m')
                                       ) es
                            _ -> []
                      ) $
            toList _lhs_knownValues
        (_exports_replace) =
            prepareExportList
               _relevantValues
               _relevantTypes
               _lhs_constructors_dist
               _lhs_methods_dist
    in  (_lhs_constructors_collect,_exports_replace,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,Exported_Exports _exports_replace,[],Exported_NoExports)
-- Exports -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      replace              : Exports
      res                  : [ResolveResult]
      self                 : Exports

-}
{-
   local variables for Exports.Cons:

-}
{-
   local variables for Exports.Nil:

-}
-- semantic domain
type T_Exports = (Maybe QualName) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Modid) ->
                 (Bool) ->
                 (Bool) ->
                 (Bool) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (Bool) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (FMap Modid [QualName]) ->
                 (FMap Modid [QualName]) ->
                 (NameType) ->
                 (Bool) ->
                 ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),(Exports),([ResolveResult]),(Exports))
-- cata
sem_Exports :: (Exports) ->
               (T_Exports)
sem_Exports (list) =
    (foldr (sem_Exports_Cons) (sem_Exports_Nil) ((map sem_Export list)))
sem_Exports_Cons :: (T_Export) ->
                    (T_Exports) ->
                    (T_Exports)
sem_Exports_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _hd_constructors_collect,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_replace,_hd_res,_hd_self) =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_replace,_tl_res,_tl_self) =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_lhs_local) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_replace ++ _tl_replace,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_Exports_Nil :: (T_Exports)
sem_Exports_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[],[])
-- Expr --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Expr

-}
{-
   local variables for Expr.App:
      self

-}
{-
   local variables for Expr.As:
      self

-}
{-
   local variables for Expr.Case:
      self

-}
{-
   local variables for Expr.Compr:
      self

-}
{-
   local variables for Expr.Con:
      self

-}
{-
   local variables for Expr.Do:
      self

-}
{-
   local variables for Expr.EnumFrom:
      self

-}
{-
   local variables for Expr.EnumFromThen:
      self

-}
{-
   local variables for Expr.EnumFromThenTo:
      self

-}
{-
   local variables for Expr.EnumFromTo:
      self

-}
{-
   local variables for Expr.If:
      self

-}
{-
   local variables for Expr.Irr:
      self

-}
{-
   local variables for Expr.LabCon:
      self

-}
{-
   local variables for Expr.LabUp:
      self

-}
{-
   local variables for Expr.Lam:
      self
      knownValues

-}
{-
   local variables for Expr.LeftSection:
      self

-}
{-
   local variables for Expr.Let:
      self
      knownValues

-}
{-
   local variables for Expr.List:
      self

-}
{-
   local variables for Expr.Lit:
      self

-}
{-
   local variables for Expr.Negate:
      self

-}
{-
   local variables for Expr.OpApp:
      self

-}
{-
   local variables for Expr.Parens:
      self

-}
{-
   local variables for Expr.RightSection:
      self

-}
{-
   local variables for Expr.Tuple:
      self

-}
{-
   local variables for Expr.TyApp:
      self

-}
{-
   local variables for Expr.TypeSig:
      self

-}
{-
   local variables for Expr.Var:
      self

-}
{-
   local variables for Expr.Wild:
      self

-}
-- semantic domain
type T_Expr = (Maybe QualName) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Modid) ->
              (Bool) ->
              (Bool) ->
              (Bool) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (Bool) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (FMap Modid [QualName]) ->
              (FMap Modid [QualName]) ->
              (NameType) ->
              (Bool) ->
              ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Expr))
-- cata
sem_Expr :: (Expr) ->
            (T_Expr)
sem_Expr ((Expr_App (_left) (_right))) =
    (sem_Expr_App ((sem_Expr (_left))) ((sem_Expr (_right))))
sem_Expr ((Expr_As (_name) (_expr))) =
    (sem_Expr_As ((sem_QualName (_name))) ((sem_Expr (_expr))))
sem_Expr ((Expr_Case (_expr) (_alts))) =
    (sem_Expr_Case ((sem_Expr (_expr))) ((sem_Alts (_alts))))
sem_Expr ((Expr_Compr (_body) (_quals))) =
    (sem_Expr_Compr ((sem_Expr (_body))) ((sem_Quals (_quals))))
sem_Expr ((Expr_Con (_srcloc) (_name))) =
    (sem_Expr_Con ((sem_Position (_srcloc))) ((sem_QualName (_name))))
sem_Expr ((Expr_Do (_stmts))) =
    (sem_Expr_Do ((sem_Stmts (_stmts))))
sem_Expr ((Expr_EnumFrom (_from))) =
    (sem_Expr_EnumFrom ((sem_Expr (_from))))
sem_Expr ((Expr_EnumFromThen (_from) (_then))) =
    (sem_Expr_EnumFromThen ((sem_Expr (_from))) ((sem_Expr (_then))))
sem_Expr ((Expr_EnumFromThenTo (_from) (_then) (_to))) =
    (sem_Expr_EnumFromThenTo ((sem_Expr (_from))) ((sem_Expr (_then))) ((sem_Expr (_to))))
sem_Expr ((Expr_EnumFromTo (_from) (_to))) =
    (sem_Expr_EnumFromTo ((sem_Expr (_from))) ((sem_Expr (_to))))
sem_Expr ((Expr_If (_cond) (_thenp) (_elsep))) =
    (sem_Expr_If ((sem_Expr (_cond))) ((sem_Expr (_thenp))) ((sem_Expr (_elsep))))
sem_Expr ((Expr_Irr (_expr))) =
    (sem_Expr_Irr ((sem_Expr (_expr))))
sem_Expr ((Expr_LabCon (_con) (_fbinds))) =
    (sem_Expr_LabCon ((sem_QualName (_con))) ((sem_FBinds (_fbinds))))
sem_Expr ((Expr_LabUp (_body) (_fbinds))) =
    (sem_Expr_LabUp ((sem_Expr (_body))) ((sem_FBinds (_fbinds))))
sem_Expr ((Expr_Lam (_from) (_body))) =
    (sem_Expr_Lam ((sem_Patterns (_from))) ((sem_Expr (_body))))
sem_Expr ((Expr_LeftSection (_op) (_left))) =
    (sem_Expr_LeftSection ((sem_QualName (_op))) ((sem_Expr (_left))))
sem_Expr ((Expr_Let (_decls) (_body))) =
    (sem_Expr_Let ((sem_SDecls (_decls))) ((sem_Expr (_body))))
sem_Expr ((Expr_List (_exprs))) =
    (sem_Expr_List ((sem_Exprs (_exprs))))
sem_Expr ((Expr_Lit (_name))) =
    (sem_Expr_Lit ((sem_Literal (_name))))
sem_Expr ((Expr_Negate (_expr))) =
    (sem_Expr_Negate ((sem_Expr (_expr))))
sem_Expr ((Expr_OpApp (_op) (_left) (_right))) =
    (sem_Expr_OpApp ((sem_QualName (_op))) ((sem_Expr (_left))) ((sem_Expr (_right))))
sem_Expr ((Expr_Parens (_body))) =
    (sem_Expr_Parens ((sem_Expr (_body))))
sem_Expr ((Expr_RightSection (_op) (_right))) =
    (sem_Expr_RightSection ((sem_QualName (_op))) ((sem_Expr (_right))))
sem_Expr ((Expr_Tuple (_exprs))) =
    (sem_Expr_Tuple ((sem_Exprs (_exprs))))
sem_Expr ((Expr_TyApp (_srcloc) (_expr) (_tp))) =
    (sem_Expr_TyApp ((sem_Position (_srcloc))) ((sem_QualName (_expr))) ((sem_Type (_tp))))
sem_Expr ((Expr_TypeSig (_body) (_tp))) =
    (sem_Expr_TypeSig ((sem_Expr (_body))) ((sem_QualType (_tp))))
sem_Expr ((Expr_Var (_srcloc) (_name))) =
    (sem_Expr_Var ((sem_Position (_srcloc))) ((sem_QualName (_name))))
sem_Expr ((Expr_Wild )) =
    (sem_Expr_Wild )
sem_Expr_App :: (T_Expr) ->
                (T_Expr) ->
                (T_Expr)
sem_Expr_App (_left) (_right) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_App _left_self _right_self
        ( _left_constructors_collect,_left_knownKinds_collect,_left_knownTypes_collect,_left_knownValues_collect,_left_methods_collect,_left_moduleTypes,_left_moduleValues,_left_modules,_left_res,_left_self) =
            (_left (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _right_constructors_collect,_right_knownKinds_collect,_right_knownTypes_collect,_right_knownValues_collect,_right_methods_collect,_right_moduleTypes,_right_moduleValues,_right_modules,_right_res,_right_self) =
            (_right (_lhs_classname) (_left_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_left_knownKinds_collect) (_lhs_knownTypes) (_left_knownTypes_collect) (_lhs_knownValues) (_left_knownValues_collect) (_lhs_local) (_left_methods_collect) (_lhs_methods_dist) (_left_moduleTypes) (_left_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_right_constructors_collect,_right_knownKinds_collect,_right_knownTypes_collect,_right_knownValues_collect,_right_methods_collect,_right_moduleTypes,_right_moduleValues,_left_modules `Set.union` _right_modules,_left_res ++ _right_res,_self)
sem_Expr_As :: (T_QualName) ->
               (T_Expr) ->
               (T_Expr)
sem_Expr_As (_name) (_expr) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_As _name_self _expr_self
        ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _expr_constructors_collect,_expr_knownKinds_collect,_expr_knownTypes_collect,_expr_knownValues_collect,_expr_methods_collect,_expr_moduleTypes,_expr_moduleValues,_expr_modules,_expr_res,_expr_self) =
            (_expr (_lhs_classname) (_name_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_name_knownKinds_collect) (_lhs_knownTypes) (_name_knownTypes_collect) (_lhs_knownValues) (_name_knownValues_collect) (_lhs_local) (_name_methods_collect) (_lhs_methods_dist) (_name_moduleTypes) (_name_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_expr_constructors_collect,_expr_knownKinds_collect,_expr_knownTypes_collect,_expr_knownValues_collect,_expr_methods_collect,_expr_moduleTypes,_expr_moduleValues,_name_modules `Set.union` _expr_modules,_name_res ++ _expr_res,_self)
sem_Expr_Case :: (T_Expr) ->
                 (T_Alts) ->
                 (T_Expr)
sem_Expr_Case (_expr) (_alts) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_Case _expr_self _alts_self
        ( _expr_constructors_collect,_expr_knownKinds_collect,_expr_knownTypes_collect,_expr_knownValues_collect,_expr_methods_collect,_expr_moduleTypes,_expr_moduleValues,_expr_modules,_expr_res,_expr_self) =
            (_expr (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _alts_constructors_collect,_alts_knownKinds_collect,_alts_knownTypes_collect,_alts_knownValues_collect,_alts_methods_collect,_alts_moduleTypes,_alts_moduleValues,_alts_modules,_alts_res,_alts_self) =
            (_alts (_lhs_classname) (_expr_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_expr_knownKinds_collect) (_lhs_knownTypes) (_expr_knownTypes_collect) (_lhs_knownValues) (_expr_knownValues_collect) (_lhs_local) (_expr_methods_collect) (_lhs_methods_dist) (_expr_moduleTypes) (_expr_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_alts_constructors_collect,_alts_knownKinds_collect,_alts_knownTypes_collect,_alts_knownValues_collect,_alts_methods_collect,_alts_moduleTypes,_alts_moduleValues,_expr_modules `Set.union` _alts_modules,_expr_res ++ _alts_res,_self)
sem_Expr_Compr :: (T_Expr) ->
                  (T_Quals) ->
                  (T_Expr)
sem_Expr_Compr (_body) (_quals) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_Compr _body_self _quals_self
        ( _body_constructors_collect,_body_knownKinds_collect,_body_knownTypes_collect,_body_knownValues_collect,_body_methods_collect,_body_moduleTypes,_body_moduleValues,_body_modules,_body_res,_body_self) =
            (_body (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_quals_knownValues_collect) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _quals_constructors_collect,_quals_knownKinds_collect,_quals_knownTypes_collect,_quals_knownValues_collect,_quals_methods_collect,_quals_moduleTypes,_quals_moduleValues,_quals_modules,_quals_res,_quals_self) =
            (_quals (_lhs_classname) (_body_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_body_knownKinds_collect) (_lhs_knownTypes) (_body_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues) (_lhs_local) (_body_methods_collect) (_lhs_methods_dist) (_body_moduleTypes) (_body_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_quals_constructors_collect,_quals_knownKinds_collect,_quals_knownTypes_collect,_lhs_knownValues_collect,_quals_methods_collect,_quals_moduleTypes,_quals_moduleValues,_body_modules `Set.union` _quals_modules,_body_res ++ _quals_res,_self)
sem_Expr_Con :: (T_Position) ->
                (T_QualName) ->
                (T_Expr)
sem_Expr_Con (_srcloc) (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_Con _srcloc_self _name_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Val) (_lhs_toplevel))
    in  (_name_constructors_collect,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_self)
sem_Expr_Do :: (T_Stmts) ->
               (T_Expr)
sem_Expr_Do (_stmts) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_Do _stmts_self
        ( _stmts_constructors_collect,_stmts_knownKinds_collect,_stmts_knownTypes_collect,_stmts_knownValues_collect,_stmts_methods_collect,_stmts_moduleTypes,_stmts_moduleValues,_stmts_modules,_stmts_res,_stmts_self) =
            (_stmts (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_stmts_constructors_collect,_stmts_knownKinds_collect,_stmts_knownTypes_collect,_lhs_knownValues_collect,_stmts_methods_collect,_stmts_moduleTypes,_stmts_moduleValues,_stmts_modules,_stmts_res,_self)
sem_Expr_EnumFrom :: (T_Expr) ->
                     (T_Expr)
sem_Expr_EnumFrom (_from) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_EnumFrom _from_self
        ( _from_constructors_collect,_from_knownKinds_collect,_from_knownTypes_collect,_from_knownValues_collect,_from_methods_collect,_from_moduleTypes,_from_moduleValues,_from_modules,_from_res,_from_self) =
            (_from (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_from_constructors_collect,_from_knownKinds_collect,_from_knownTypes_collect,_from_knownValues_collect,_from_methods_collect,_from_moduleTypes,_from_moduleValues,_from_modules,_from_res,_self)
sem_Expr_EnumFromThen :: (T_Expr) ->
                         (T_Expr) ->
                         (T_Expr)
sem_Expr_EnumFromThen (_from) (_then) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_EnumFromThen _from_self _then_self
        ( _from_constructors_collect,_from_knownKinds_collect,_from_knownTypes_collect,_from_knownValues_collect,_from_methods_collect,_from_moduleTypes,_from_moduleValues,_from_modules,_from_res,_from_self) =
            (_from (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _then_constructors_collect,_then_knownKinds_collect,_then_knownTypes_collect,_then_knownValues_collect,_then_methods_collect,_then_moduleTypes,_then_moduleValues,_then_modules,_then_res,_then_self) =
            (_then (_lhs_classname) (_from_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_from_knownKinds_collect) (_lhs_knownTypes) (_from_knownTypes_collect) (_lhs_knownValues) (_from_knownValues_collect) (_lhs_local) (_from_methods_collect) (_lhs_methods_dist) (_from_moduleTypes) (_from_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_then_constructors_collect,_then_knownKinds_collect,_then_knownTypes_collect,_then_knownValues_collect,_then_methods_collect,_then_moduleTypes,_then_moduleValues,_from_modules `Set.union` _then_modules,_from_res ++ _then_res,_self)
sem_Expr_EnumFromThenTo :: (T_Expr) ->
                           (T_Expr) ->
                           (T_Expr) ->
                           (T_Expr)
sem_Expr_EnumFromThenTo (_from)
                        (_then)
                        (_to)
                        (_lhs_classname)
                        (_lhs_constructors_collect)
                        (_lhs_constructors_dist)
                        (_lhs_currentModule)
                        (_lhs_importedModule)
                        (_lhs_ininstance)
                        (_lhs_intitype)
                        (_lhs_knownKinds)
                        (_lhs_knownKinds_collect)
                        (_lhs_knownTypes)
                        (_lhs_knownTypes_collect)
                        (_lhs_knownValues)
                        (_lhs_knownValues_collect)
                        (_lhs_local)
                        (_lhs_methods_collect)
                        (_lhs_methods_dist)
                        (_lhs_moduleTypes)
                        (_lhs_moduleValues)
                        (_lhs_nameType)
                        (_lhs_toplevel) =
    let (_self) =
            Expr_EnumFromThenTo
              _from_self _then_self _to_self
        ( _from_constructors_collect,_from_knownKinds_collect,_from_knownTypes_collect,_from_knownValues_collect,_from_methods_collect,_from_moduleTypes,_from_moduleValues,_from_modules,_from_res,_from_self) =
            (_from (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _then_constructors_collect,_then_knownKinds_collect,_then_knownTypes_collect,_then_knownValues_collect,_then_methods_collect,_then_moduleTypes,_then_moduleValues,_then_modules,_then_res,_then_self) =
            (_then (_lhs_classname) (_from_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_from_knownKinds_collect) (_lhs_knownTypes) (_from_knownTypes_collect) (_lhs_knownValues) (_from_knownValues_collect) (_lhs_local) (_from_methods_collect) (_lhs_methods_dist) (_from_moduleTypes) (_from_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _to_constructors_collect,_to_knownKinds_collect,_to_knownTypes_collect,_to_knownValues_collect,_to_methods_collect,_to_moduleTypes,_to_moduleValues,_to_modules,_to_res,_to_self) =
            (_to (_lhs_classname) (_then_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_then_knownKinds_collect) (_lhs_knownTypes) (_then_knownTypes_collect) (_lhs_knownValues) (_then_knownValues_collect) (_lhs_local) (_then_methods_collect) (_lhs_methods_dist) (_then_moduleTypes) (_then_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_to_constructors_collect,_to_knownKinds_collect,_to_knownTypes_collect,_to_knownValues_collect,_to_methods_collect,_to_moduleTypes,_to_moduleValues,_from_modules `Set.union` _then_modules `Set.union` _to_modules,_from_res ++ _then_res ++ _to_res,_self)
sem_Expr_EnumFromTo :: (T_Expr) ->
                       (T_Expr) ->
                       (T_Expr)
sem_Expr_EnumFromTo (_from) (_to) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_EnumFromTo _from_self _to_self
        ( _from_constructors_collect,_from_knownKinds_collect,_from_knownTypes_collect,_from_knownValues_collect,_from_methods_collect,_from_moduleTypes,_from_moduleValues,_from_modules,_from_res,_from_self) =
            (_from (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _to_constructors_collect,_to_knownKinds_collect,_to_knownTypes_collect,_to_knownValues_collect,_to_methods_collect,_to_moduleTypes,_to_moduleValues,_to_modules,_to_res,_to_self) =
            (_to (_lhs_classname) (_from_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_from_knownKinds_collect) (_lhs_knownTypes) (_from_knownTypes_collect) (_lhs_knownValues) (_from_knownValues_collect) (_lhs_local) (_from_methods_collect) (_lhs_methods_dist) (_from_moduleTypes) (_from_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_to_constructors_collect,_to_knownKinds_collect,_to_knownTypes_collect,_to_knownValues_collect,_to_methods_collect,_to_moduleTypes,_to_moduleValues,_from_modules `Set.union` _to_modules,_from_res ++ _to_res,_self)
sem_Expr_If :: (T_Expr) ->
               (T_Expr) ->
               (T_Expr) ->
               (T_Expr)
sem_Expr_If (_cond) (_thenp) (_elsep) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_If _cond_self _thenp_self _elsep_self
        ( _cond_constructors_collect,_cond_knownKinds_collect,_cond_knownTypes_collect,_cond_knownValues_collect,_cond_methods_collect,_cond_moduleTypes,_cond_moduleValues,_cond_modules,_cond_res,_cond_self) =
            (_cond (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _thenp_constructors_collect,_thenp_knownKinds_collect,_thenp_knownTypes_collect,_thenp_knownValues_collect,_thenp_methods_collect,_thenp_moduleTypes,_thenp_moduleValues,_thenp_modules,_thenp_res,_thenp_self) =
            (_thenp (_lhs_classname) (_cond_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_cond_knownKinds_collect) (_lhs_knownTypes) (_cond_knownTypes_collect) (_lhs_knownValues) (_cond_knownValues_collect) (_lhs_local) (_cond_methods_collect) (_lhs_methods_dist) (_cond_moduleTypes) (_cond_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _elsep_constructors_collect,_elsep_knownKinds_collect,_elsep_knownTypes_collect,_elsep_knownValues_collect,_elsep_methods_collect,_elsep_moduleTypes,_elsep_moduleValues,_elsep_modules,_elsep_res,_elsep_self) =
            (_elsep (_lhs_classname) (_thenp_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_thenp_knownKinds_collect) (_lhs_knownTypes) (_thenp_knownTypes_collect) (_lhs_knownValues) (_thenp_knownValues_collect) (_lhs_local) (_thenp_methods_collect) (_lhs_methods_dist) (_thenp_moduleTypes) (_thenp_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_elsep_constructors_collect,_elsep_knownKinds_collect,_elsep_knownTypes_collect,_elsep_knownValues_collect,_elsep_methods_collect,_elsep_moduleTypes,_elsep_moduleValues,_cond_modules `Set.union` _thenp_modules `Set.union` _elsep_modules,_cond_res ++ _thenp_res ++ _elsep_res,_self)
sem_Expr_Irr :: (T_Expr) ->
                (T_Expr)
sem_Expr_Irr (_expr) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_Irr _expr_self
        ( _expr_constructors_collect,_expr_knownKinds_collect,_expr_knownTypes_collect,_expr_knownValues_collect,_expr_methods_collect,_expr_moduleTypes,_expr_moduleValues,_expr_modules,_expr_res,_expr_self) =
            (_expr (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_expr_constructors_collect,_expr_knownKinds_collect,_expr_knownTypes_collect,_expr_knownValues_collect,_expr_methods_collect,_expr_moduleTypes,_expr_moduleValues,_expr_modules,_expr_res,_self)
sem_Expr_LabCon :: (T_QualName) ->
                   (T_FBinds) ->
                   (T_Expr)
sem_Expr_LabCon (_con) (_fbinds) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_LabCon _con_self _fbinds_self
        ( _con_constructors_collect,_con_entityName,_con_fullName,_con_knownKinds_collect,_con_knownTypes_collect,_con_knownValues_collect,_con_methods_collect,_con_moduleTypes,_con_moduleValues,_con_modules,_con_res,_con_self,_con_self') =
            (_con (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Val) (_lhs_toplevel))
        ( _fbinds_constructors_collect,_fbinds_knownKinds_collect,_fbinds_knownTypes_collect,_fbinds_knownValues_collect,_fbinds_methods_collect,_fbinds_moduleTypes,_fbinds_moduleValues,_fbinds_modules,_fbinds_res,_fbinds_self) =
            (_fbinds (_lhs_classname) (_con_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_con_knownKinds_collect) (_lhs_knownTypes) (_con_knownTypes_collect) (_lhs_knownValues) (_con_knownValues_collect) (_lhs_local) (_con_methods_collect) (_lhs_methods_dist) (_con_moduleTypes) (_con_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_fbinds_constructors_collect,_fbinds_knownKinds_collect,_fbinds_knownTypes_collect,_fbinds_knownValues_collect,_fbinds_methods_collect,_fbinds_moduleTypes,_fbinds_moduleValues,_con_modules `Set.union` _fbinds_modules,_con_res ++ _fbinds_res,_self)
sem_Expr_LabUp :: (T_Expr) ->
                  (T_FBinds) ->
                  (T_Expr)
sem_Expr_LabUp (_body) (_fbinds) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_LabUp _body_self _fbinds_self
        ( _body_constructors_collect,_body_knownKinds_collect,_body_knownTypes_collect,_body_knownValues_collect,_body_methods_collect,_body_moduleTypes,_body_moduleValues,_body_modules,_body_res,_body_self) =
            (_body (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _fbinds_constructors_collect,_fbinds_knownKinds_collect,_fbinds_knownTypes_collect,_fbinds_knownValues_collect,_fbinds_methods_collect,_fbinds_moduleTypes,_fbinds_moduleValues,_fbinds_modules,_fbinds_res,_fbinds_self) =
            (_fbinds (_lhs_classname) (_body_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_body_knownKinds_collect) (_lhs_knownTypes) (_body_knownTypes_collect) (_lhs_knownValues) (_body_knownValues_collect) (_lhs_local) (_body_methods_collect) (_lhs_methods_dist) (_body_moduleTypes) (_body_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_fbinds_constructors_collect,_fbinds_knownKinds_collect,_fbinds_knownTypes_collect,_fbinds_knownValues_collect,_fbinds_methods_collect,_fbinds_moduleTypes,_fbinds_moduleValues,_body_modules `Set.union` _fbinds_modules,_body_res ++ _fbinds_res,_self)
sem_Expr_Lam :: (T_Patterns) ->
                (T_Expr) ->
                (T_Expr)
sem_Expr_Lam (_from) (_body) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_knownValues) =
            _from_knownValues_collect `mergeFM` _lhs_knownValues
        (_self) =
            Expr_Lam _from_self _body_self
        ( _from_constructors_collect,_from_knownKinds_collect,_from_knownTypes_collect,_from_knownValues_collect,_from_methods_collect,_from_moduleTypes,_from_moduleValues,_from_modules,_from_res,_from_self) =
            (_from (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_knownValues) (emptyFM) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _body_constructors_collect,_body_knownKinds_collect,_body_knownTypes_collect,_body_knownValues_collect,_body_methods_collect,_body_moduleTypes,_body_moduleValues,_body_modules,_body_res,_body_self) =
            (_body (_lhs_classname) (_from_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_from_knownKinds_collect) (_lhs_knownTypes) (_from_knownTypes_collect) (_knownValues) (_from_knownValues_collect) (_lhs_local) (_from_methods_collect) (_lhs_methods_dist) (_from_moduleTypes) (_from_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_body_constructors_collect,_body_knownKinds_collect,_body_knownTypes_collect,_lhs_knownValues_collect,_body_methods_collect,_body_moduleTypes,_body_moduleValues,_from_modules `Set.union` _body_modules,_from_res ++ _body_res,_self)
sem_Expr_LeftSection :: (T_QualName) ->
                        (T_Expr) ->
                        (T_Expr)
sem_Expr_LeftSection (_op) (_left) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_LeftSection _op_self _left_self
        ( _op_constructors_collect,_op_entityName,_op_fullName,_op_knownKinds_collect,_op_knownTypes_collect,_op_knownValues_collect,_op_methods_collect,_op_moduleTypes,_op_moduleValues,_op_modules,_op_res,_op_self,_op_self') =
            (_op (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Val) (_lhs_toplevel))
        ( _left_constructors_collect,_left_knownKinds_collect,_left_knownTypes_collect,_left_knownValues_collect,_left_methods_collect,_left_moduleTypes,_left_moduleValues,_left_modules,_left_res,_left_self) =
            (_left (_lhs_classname) (_op_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_op_knownKinds_collect) (_lhs_knownTypes) (_op_knownTypes_collect) (_lhs_knownValues) (_op_knownValues_collect) (_lhs_local) (_op_methods_collect) (_lhs_methods_dist) (_op_moduleTypes) (_op_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_left_constructors_collect,_left_knownKinds_collect,_left_knownTypes_collect,_left_knownValues_collect,_left_methods_collect,_left_moduleTypes,_left_moduleValues,_op_modules `Set.union` _left_modules,_op_res ++ _left_res,_self)
sem_Expr_Let :: (T_SDecls) ->
                (T_Expr) ->
                (T_Expr)
sem_Expr_Let (_decls) (_body) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_knownValues) =
            _decls_knownValues_collect `mergeFM` _lhs_knownValues
        (_self) =
            Expr_Let _decls_self _body_self
        ( _decls_constructors_collect,_decls_knownKinds_collect,_decls_knownTypes_collect,_decls_knownValues_collect,_decls_methods_collect,_decls_moduleTypes,_decls_moduleValues,_decls_modules,_decls_res,_decls_self) =
            (_decls (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_knownValues) (emptyFM) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _body_constructors_collect,_body_knownKinds_collect,_body_knownTypes_collect,_body_knownValues_collect,_body_methods_collect,_body_moduleTypes,_body_moduleValues,_body_modules,_body_res,_body_self) =
            (_body (_lhs_classname) (_decls_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_decls_knownKinds_collect) (_lhs_knownTypes) (_decls_knownTypes_collect) (_knownValues) (_decls_knownValues_collect) (_lhs_local) (_decls_methods_collect) (_lhs_methods_dist) (_decls_moduleTypes) (_decls_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_body_constructors_collect,_body_knownKinds_collect,_body_knownTypes_collect,_lhs_knownValues_collect,_body_methods_collect,_body_moduleTypes,_body_moduleValues,_decls_modules `Set.union` _body_modules,_decls_res ++ _body_res,_self)
sem_Expr_List :: (T_Exprs) ->
                 (T_Expr)
sem_Expr_List (_exprs) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_List _exprs_self
        ( _exprs_constructors_collect,_exprs_knownKinds_collect,_exprs_knownTypes_collect,_exprs_knownValues_collect,_exprs_methods_collect,_exprs_moduleTypes,_exprs_moduleValues,_exprs_modules,_exprs_res,_exprs_self) =
            (_exprs (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_exprs_constructors_collect,_exprs_knownKinds_collect,_exprs_knownTypes_collect,_exprs_knownValues_collect,_exprs_methods_collect,_exprs_moduleTypes,_exprs_moduleValues,_exprs_modules,_exprs_res,_self)
sem_Expr_Lit :: (T_Literal) ->
                (T_Expr)
sem_Expr_Lit (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_Lit _name_self
        ( _name_constructors_collect,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self) =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_name_constructors_collect,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_self)
sem_Expr_Negate :: (T_Expr) ->
                   (T_Expr)
sem_Expr_Negate (_expr) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_Negate _expr_self
        ( _expr_constructors_collect,_expr_knownKinds_collect,_expr_knownTypes_collect,_expr_knownValues_collect,_expr_methods_collect,_expr_moduleTypes,_expr_moduleValues,_expr_modules,_expr_res,_expr_self) =
            (_expr (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_expr_constructors_collect,_expr_knownKinds_collect,_expr_knownTypes_collect,_expr_knownValues_collect,_expr_methods_collect,_expr_moduleTypes,_expr_moduleValues,_expr_modules,_expr_res,_self)
sem_Expr_OpApp :: (T_QualName) ->
                  (T_Expr) ->
                  (T_Expr) ->
                  (T_Expr)
sem_Expr_OpApp (_op) (_left) (_right) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_OpApp _op_self _left_self _right_self
        ( _op_constructors_collect,_op_entityName,_op_fullName,_op_knownKinds_collect,_op_knownTypes_collect,_op_knownValues_collect,_op_methods_collect,_op_moduleTypes,_op_moduleValues,_op_modules,_op_res,_op_self,_op_self') =
            (_op (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Val) (_lhs_toplevel))
        ( _left_constructors_collect,_left_knownKinds_collect,_left_knownTypes_collect,_left_knownValues_collect,_left_methods_collect,_left_moduleTypes,_left_moduleValues,_left_modules,_left_res,_left_self) =
            (_left (_lhs_classname) (_op_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_op_knownKinds_collect) (_lhs_knownTypes) (_op_knownTypes_collect) (_lhs_knownValues) (_op_knownValues_collect) (_lhs_local) (_op_methods_collect) (_lhs_methods_dist) (_op_moduleTypes) (_op_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _right_constructors_collect,_right_knownKinds_collect,_right_knownTypes_collect,_right_knownValues_collect,_right_methods_collect,_right_moduleTypes,_right_moduleValues,_right_modules,_right_res,_right_self) =
            (_right (_lhs_classname) (_left_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_left_knownKinds_collect) (_lhs_knownTypes) (_left_knownTypes_collect) (_lhs_knownValues) (_left_knownValues_collect) (_lhs_local) (_left_methods_collect) (_lhs_methods_dist) (_left_moduleTypes) (_left_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_right_constructors_collect,_right_knownKinds_collect,_right_knownTypes_collect,_right_knownValues_collect,_right_methods_collect,_right_moduleTypes,_right_moduleValues,_op_modules `Set.union` _left_modules `Set.union` _right_modules,_op_res ++ _left_res ++ _right_res,_self)
sem_Expr_Parens :: (T_Expr) ->
                   (T_Expr)
sem_Expr_Parens (_body) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_Parens _body_self
        ( _body_constructors_collect,_body_knownKinds_collect,_body_knownTypes_collect,_body_knownValues_collect,_body_methods_collect,_body_moduleTypes,_body_moduleValues,_body_modules,_body_res,_body_self) =
            (_body (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_body_constructors_collect,_body_knownKinds_collect,_body_knownTypes_collect,_body_knownValues_collect,_body_methods_collect,_body_moduleTypes,_body_moduleValues,_body_modules,_body_res,_self)
sem_Expr_RightSection :: (T_QualName) ->
                         (T_Expr) ->
                         (T_Expr)
sem_Expr_RightSection (_op) (_right) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_RightSection _op_self _right_self
        ( _op_constructors_collect,_op_entityName,_op_fullName,_op_knownKinds_collect,_op_knownTypes_collect,_op_knownValues_collect,_op_methods_collect,_op_moduleTypes,_op_moduleValues,_op_modules,_op_res,_op_self,_op_self') =
            (_op (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Val) (_lhs_toplevel))
        ( _right_constructors_collect,_right_knownKinds_collect,_right_knownTypes_collect,_right_knownValues_collect,_right_methods_collect,_right_moduleTypes,_right_moduleValues,_right_modules,_right_res,_right_self) =
            (_right (_lhs_classname) (_op_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_op_knownKinds_collect) (_lhs_knownTypes) (_op_knownTypes_collect) (_lhs_knownValues) (_op_knownValues_collect) (_lhs_local) (_op_methods_collect) (_lhs_methods_dist) (_op_moduleTypes) (_op_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_right_constructors_collect,_right_knownKinds_collect,_right_knownTypes_collect,_right_knownValues_collect,_right_methods_collect,_right_moduleTypes,_right_moduleValues,_op_modules `Set.union` _right_modules,_op_res ++ _right_res,_self)
sem_Expr_Tuple :: (T_Exprs) ->
                  (T_Expr)
sem_Expr_Tuple (_exprs) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_Tuple _exprs_self
        ( _exprs_constructors_collect,_exprs_knownKinds_collect,_exprs_knownTypes_collect,_exprs_knownValues_collect,_exprs_methods_collect,_exprs_moduleTypes,_exprs_moduleValues,_exprs_modules,_exprs_res,_exprs_self) =
            (_exprs (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_exprs_constructors_collect,_exprs_knownKinds_collect,_exprs_knownTypes_collect,_exprs_knownValues_collect,_exprs_methods_collect,_exprs_moduleTypes,_exprs_moduleValues,_exprs_modules,_exprs_res,_self)
sem_Expr_TyApp :: (T_Position) ->
                  (T_QualName) ->
                  (T_Type) ->
                  (T_Expr)
sem_Expr_TyApp (_srcloc) (_expr) (_tp) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_TyApp _srcloc_self _expr_self _tp_self
        ( _srcloc_self) =
            (_srcloc )
        ( _expr_constructors_collect,_expr_entityName,_expr_fullName,_expr_knownKinds_collect,_expr_knownTypes_collect,_expr_knownValues_collect,_expr_methods_collect,_expr_moduleTypes,_expr_moduleValues,_expr_modules,_expr_res,_expr_self,_expr_self') =
            (_expr (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Val) (_lhs_toplevel))
        ( _tp_constructors_collect,_tp_knownKinds_collect,_tp_knownTypes_collect,_tp_knownValues_collect,_tp_methods_collect,_tp_moduleTypes,_tp_moduleValues,_tp_modules,_tp_res,_tp_self) =
            (_tp (_lhs_classname) (_expr_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_expr_knownKinds_collect) (_lhs_knownTypes) (_expr_knownTypes_collect) (_lhs_knownValues) (_expr_knownValues_collect) (_lhs_local) (_expr_methods_collect) (_lhs_methods_dist) (_expr_moduleTypes) (_expr_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tp_constructors_collect,_tp_knownKinds_collect,_tp_knownTypes_collect,_tp_knownValues_collect,_tp_methods_collect,_tp_moduleTypes,_tp_moduleValues,_expr_modules `Set.union` _tp_modules,_expr_res ++ _tp_res,_self)
sem_Expr_TypeSig :: (T_Expr) ->
                    (T_QualType) ->
                    (T_Expr)
sem_Expr_TypeSig (_body) (_tp) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_TypeSig _body_self _tp_self
        ( _body_constructors_collect,_body_knownKinds_collect,_body_knownTypes_collect,_body_knownValues_collect,_body_methods_collect,_body_moduleTypes,_body_moduleValues,_body_modules,_body_res,_body_self) =
            (_body (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tp_constructors_collect,_tp_knownKinds_collect,_tp_knownTypes_collect,_tp_knownValues_collect,_tp_methods_collect,_tp_moduleTypes,_tp_moduleValues,_tp_modules,_tp_res,_tp_self) =
            (_tp (_lhs_classname) (_body_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_body_knownKinds_collect) (_lhs_knownTypes) (_body_knownTypes_collect) (_lhs_knownValues) (_body_knownValues_collect) (_lhs_local) (_body_methods_collect) (_lhs_methods_dist) (_body_moduleTypes) (_body_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tp_constructors_collect,_tp_knownKinds_collect,_tp_knownTypes_collect,_tp_knownValues_collect,_tp_methods_collect,_tp_moduleTypes,_tp_moduleValues,_body_modules `Set.union` _tp_modules,_body_res ++ _tp_res,_self)
sem_Expr_Var :: (T_Position) ->
                (T_QualName) ->
                (T_Expr)
sem_Expr_Var (_srcloc) (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_Var _srcloc_self _name_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Val) (_lhs_toplevel))
    in  (_name_constructors_collect,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_self)
sem_Expr_Wild :: (T_Expr)
sem_Expr_Wild (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Expr_Wild
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],_self)
-- Exprs -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Exprs

-}
{-
   local variables for Exprs.Cons:

-}
{-
   local variables for Exprs.Nil:

-}
-- semantic domain
type T_Exprs = (Maybe QualName) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (Bool) ->
               (Bool) ->
               (Bool) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (FMap Modid [QualName]) ->
               (FMap Modid [QualName]) ->
               (NameType) ->
               (Bool) ->
               ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Exprs))
-- cata
sem_Exprs :: (Exprs) ->
             (T_Exprs)
sem_Exprs (list) =
    (foldr (sem_Exprs_Cons) (sem_Exprs_Nil) ((map sem_Expr list)))
sem_Exprs_Cons :: (T_Expr) ->
                  (T_Exprs) ->
                  (T_Exprs)
sem_Exprs_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _hd_constructors_collect,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self) =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_lhs_local) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_Exprs_Nil :: (T_Exprs)
sem_Exprs_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])
-- FBind -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : FBind

-}
{-
   local variables for FBind.FBind:

-}
-- semantic domain
type T_FBind = (Maybe QualName) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (Bool) ->
               (Bool) ->
               (Bool) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (FMap Modid [QualName]) ->
               (FMap Modid [QualName]) ->
               (NameType) ->
               (Bool) ->
               ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(FBind))
-- cata
sem_FBind :: (FBind) ->
             (T_FBind)
sem_FBind ((FBind_FBind (_field) (_expr))) =
    (sem_FBind_FBind ((sem_QualName (_field))) ((sem_Expr (_expr))))
sem_FBind_FBind :: (T_QualName) ->
                   (T_Expr) ->
                   (T_FBind)
sem_FBind_FBind (_field) (_expr) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _field_constructors_collect,_field_entityName,_field_fullName,_field_knownKinds_collect,_field_knownTypes_collect,_field_knownValues_collect,_field_methods_collect,_field_moduleTypes,_field_moduleValues,_field_modules,_field_res,_field_self,_field_self') =
            (_field (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Val) (_lhs_toplevel))
        ( _expr_constructors_collect,_expr_knownKinds_collect,_expr_knownTypes_collect,_expr_knownValues_collect,_expr_methods_collect,_expr_moduleTypes,_expr_moduleValues,_expr_modules,_expr_res,_expr_self) =
            (_expr (_lhs_classname) (_field_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_field_knownKinds_collect) (_lhs_knownTypes) (_field_knownTypes_collect) (_lhs_knownValues) (_field_knownValues_collect) (_lhs_local) (_field_methods_collect) (_lhs_methods_dist) (_field_moduleTypes) (_field_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_expr_constructors_collect,_expr_knownKinds_collect,_expr_knownTypes_collect,_expr_knownValues_collect,_expr_methods_collect,_expr_moduleTypes,_expr_moduleValues,_field_modules `Set.union` _expr_modules,_field_res ++ _expr_res,FBind_FBind _field_self _expr_self)
-- FBinds ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : FBinds

-}
{-
   local variables for FBinds.Cons:

-}
{-
   local variables for FBinds.Nil:

-}
-- semantic domain
type T_FBinds = (Maybe QualName) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Modid) ->
                (Bool) ->
                (Bool) ->
                (Bool) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (Bool) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (FMap Modid [QualName]) ->
                (FMap Modid [QualName]) ->
                (NameType) ->
                (Bool) ->
                ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(FBinds))
-- cata
sem_FBinds :: (FBinds) ->
              (T_FBinds)
sem_FBinds (list) =
    (foldr (sem_FBinds_Cons) (sem_FBinds_Nil) ((map sem_FBind list)))
sem_FBinds_Cons :: (T_FBind) ->
                   (T_FBinds) ->
                   (T_FBinds)
sem_FBinds_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _hd_constructors_collect,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self) =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_lhs_local) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_FBinds_Nil :: (T_FBinds)
sem_FBinds_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])
-- GuardedAlt --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : GuardedAlt

-}
{-
   local variables for GuardedAlt.GuardedAlt:

-}
-- semantic domain
type T_GuardedAlt = (Maybe QualName) ->
                    (FMap QualName QualNames) ->
                    (FMap QualName QualNames) ->
                    (Modid) ->
                    (Bool) ->
                    (Bool) ->
                    (Bool) ->
                    (FMap QualName [Entity]) ->
                    (FMap QualName [Entity]) ->
                    (FMap QualName [Entity]) ->
                    (FMap QualName [Entity]) ->
                    (FMap QualName [Entity]) ->
                    (FMap QualName [Entity]) ->
                    (Bool) ->
                    (FMap QualName QualNames) ->
                    (FMap QualName QualNames) ->
                    (FMap Modid [QualName]) ->
                    (FMap Modid [QualName]) ->
                    (NameType) ->
                    (Bool) ->
                    ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(GuardedAlt))
-- cata
sem_GuardedAlt :: (GuardedAlt) ->
                  (T_GuardedAlt)
sem_GuardedAlt ((GuardedAlt_GuardedAlt (_guard) (_expr))) =
    (sem_GuardedAlt_GuardedAlt ((sem_Expr (_guard))) ((sem_Expr (_expr))))
sem_GuardedAlt_GuardedAlt :: (T_Expr) ->
                             (T_Expr) ->
                             (T_GuardedAlt)
sem_GuardedAlt_GuardedAlt (_guard)
                          (_expr)
                          (_lhs_classname)
                          (_lhs_constructors_collect)
                          (_lhs_constructors_dist)
                          (_lhs_currentModule)
                          (_lhs_importedModule)
                          (_lhs_ininstance)
                          (_lhs_intitype)
                          (_lhs_knownKinds)
                          (_lhs_knownKinds_collect)
                          (_lhs_knownTypes)
                          (_lhs_knownTypes_collect)
                          (_lhs_knownValues)
                          (_lhs_knownValues_collect)
                          (_lhs_local)
                          (_lhs_methods_collect)
                          (_lhs_methods_dist)
                          (_lhs_moduleTypes)
                          (_lhs_moduleValues)
                          (_lhs_nameType)
                          (_lhs_toplevel) =
    let ( _guard_constructors_collect,_guard_knownKinds_collect,_guard_knownTypes_collect,_guard_knownValues_collect,_guard_methods_collect,_guard_moduleTypes,_guard_moduleValues,_guard_modules,_guard_res,_guard_self) =
            (_guard (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _expr_constructors_collect,_expr_knownKinds_collect,_expr_knownTypes_collect,_expr_knownValues_collect,_expr_methods_collect,_expr_moduleTypes,_expr_moduleValues,_expr_modules,_expr_res,_expr_self) =
            (_expr (_lhs_classname) (_guard_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_guard_knownKinds_collect) (_lhs_knownTypes) (_guard_knownTypes_collect) (_lhs_knownValues) (_guard_knownValues_collect) (_lhs_local) (_guard_methods_collect) (_lhs_methods_dist) (_guard_moduleTypes) (_guard_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_expr_constructors_collect,_expr_knownKinds_collect,_expr_knownTypes_collect,_expr_knownValues_collect,_expr_methods_collect,_expr_moduleTypes,_expr_moduleValues,_guard_modules `Set.union` _expr_modules,_guard_res ++ _expr_res,GuardedAlt_GuardedAlt _guard_self _expr_self)
-- GuardedAlts -------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : GuardedAlts

-}
{-
   local variables for GuardedAlts.Cons:

-}
{-
   local variables for GuardedAlts.Nil:

-}
-- semantic domain
type T_GuardedAlts = (Maybe QualName) ->
                     (FMap QualName QualNames) ->
                     (FMap QualName QualNames) ->
                     (Modid) ->
                     (Bool) ->
                     (Bool) ->
                     (Bool) ->
                     (FMap QualName [Entity]) ->
                     (FMap QualName [Entity]) ->
                     (FMap QualName [Entity]) ->
                     (FMap QualName [Entity]) ->
                     (FMap QualName [Entity]) ->
                     (FMap QualName [Entity]) ->
                     (Bool) ->
                     (FMap QualName QualNames) ->
                     (FMap QualName QualNames) ->
                     (FMap Modid [QualName]) ->
                     (FMap Modid [QualName]) ->
                     (NameType) ->
                     (Bool) ->
                     ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(GuardedAlts))
-- cata
sem_GuardedAlts :: (GuardedAlts) ->
                   (T_GuardedAlts)
sem_GuardedAlts (list) =
    (foldr (sem_GuardedAlts_Cons) (sem_GuardedAlts_Nil) ((map sem_GuardedAlt list)))
sem_GuardedAlts_Cons :: (T_GuardedAlt) ->
                        (T_GuardedAlts) ->
                        (T_GuardedAlts)
sem_GuardedAlts_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _hd_constructors_collect,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self) =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_lhs_local) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_GuardedAlts_Nil :: (T_GuardedAlts)
sem_GuardedAlts_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])
-- GuardedRhs --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : GuardedRhs

-}
{-
   local variables for GuardedRhs.GuardedRhs:

-}
-- semantic domain
type T_GuardedRhs = (Maybe QualName) ->
                    (FMap QualName QualNames) ->
                    (FMap QualName QualNames) ->
                    (Modid) ->
                    (Bool) ->
                    (Bool) ->
                    (Bool) ->
                    (FMap QualName [Entity]) ->
                    (FMap QualName [Entity]) ->
                    (FMap QualName [Entity]) ->
                    (FMap QualName [Entity]) ->
                    (FMap QualName [Entity]) ->
                    (FMap QualName [Entity]) ->
                    (Bool) ->
                    (FMap QualName QualNames) ->
                    (FMap QualName QualNames) ->
                    (FMap Modid [QualName]) ->
                    (FMap Modid [QualName]) ->
                    (NameType) ->
                    (Bool) ->
                    ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(GuardedRhs))
-- cata
sem_GuardedRhs :: (GuardedRhs) ->
                  (T_GuardedRhs)
sem_GuardedRhs ((GuardedRhs_GuardedRhs (_guard) (_expr))) =
    (sem_GuardedRhs_GuardedRhs ((sem_Expr (_guard))) ((sem_Expr (_expr))))
sem_GuardedRhs_GuardedRhs :: (T_Expr) ->
                             (T_Expr) ->
                             (T_GuardedRhs)
sem_GuardedRhs_GuardedRhs (_guard)
                          (_expr)
                          (_lhs_classname)
                          (_lhs_constructors_collect)
                          (_lhs_constructors_dist)
                          (_lhs_currentModule)
                          (_lhs_importedModule)
                          (_lhs_ininstance)
                          (_lhs_intitype)
                          (_lhs_knownKinds)
                          (_lhs_knownKinds_collect)
                          (_lhs_knownTypes)
                          (_lhs_knownTypes_collect)
                          (_lhs_knownValues)
                          (_lhs_knownValues_collect)
                          (_lhs_local)
                          (_lhs_methods_collect)
                          (_lhs_methods_dist)
                          (_lhs_moduleTypes)
                          (_lhs_moduleValues)
                          (_lhs_nameType)
                          (_lhs_toplevel) =
    let ( _guard_constructors_collect,_guard_knownKinds_collect,_guard_knownTypes_collect,_guard_knownValues_collect,_guard_methods_collect,_guard_moduleTypes,_guard_moduleValues,_guard_modules,_guard_res,_guard_self) =
            (_guard (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _expr_constructors_collect,_expr_knownKinds_collect,_expr_knownTypes_collect,_expr_knownValues_collect,_expr_methods_collect,_expr_moduleTypes,_expr_moduleValues,_expr_modules,_expr_res,_expr_self) =
            (_expr (_lhs_classname) (_guard_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_guard_knownKinds_collect) (_lhs_knownTypes) (_guard_knownTypes_collect) (_lhs_knownValues) (_guard_knownValues_collect) (_lhs_local) (_guard_methods_collect) (_lhs_methods_dist) (_guard_moduleTypes) (_guard_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_expr_constructors_collect,_expr_knownKinds_collect,_expr_knownTypes_collect,_expr_knownValues_collect,_expr_methods_collect,_expr_moduleTypes,_expr_moduleValues,_guard_modules `Set.union` _expr_modules,_guard_res ++ _expr_res,GuardedRhs_GuardedRhs _guard_self _expr_self)
-- GuardedRhss -------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : GuardedRhss

-}
{-
   local variables for GuardedRhss.Cons:

-}
{-
   local variables for GuardedRhss.Nil:

-}
-- semantic domain
type T_GuardedRhss = (Maybe QualName) ->
                     (FMap QualName QualNames) ->
                     (FMap QualName QualNames) ->
                     (Modid) ->
                     (Bool) ->
                     (Bool) ->
                     (Bool) ->
                     (FMap QualName [Entity]) ->
                     (FMap QualName [Entity]) ->
                     (FMap QualName [Entity]) ->
                     (FMap QualName [Entity]) ->
                     (FMap QualName [Entity]) ->
                     (FMap QualName [Entity]) ->
                     (Bool) ->
                     (FMap QualName QualNames) ->
                     (FMap QualName QualNames) ->
                     (FMap Modid [QualName]) ->
                     (FMap Modid [QualName]) ->
                     (NameType) ->
                     (Bool) ->
                     ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(GuardedRhss))
-- cata
sem_GuardedRhss :: (GuardedRhss) ->
                   (T_GuardedRhss)
sem_GuardedRhss (list) =
    (foldr (sem_GuardedRhss_Cons) (sem_GuardedRhss_Nil) ((map sem_GuardedRhs list)))
sem_GuardedRhss_Cons :: (T_GuardedRhs) ->
                        (T_GuardedRhss) ->
                        (T_GuardedRhss)
sem_GuardedRhss_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _hd_constructors_collect,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self) =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_lhs_local) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_GuardedRhss_Nil :: (T_GuardedRhss)
sem_GuardedRhss_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])
-- Impdecl -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      hiddenEntities       : [(Set QualName,Set QualName)]
      importedEntities     : [(Set QualName,Set QualName)]
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Impdecl

-}
{-
   local variables for Impdecl.Empty:
      self

-}
{-
   local variables for Impdecl.Import:
      self
      local
      currentModule
      hiddenTypes
      importedTypes
      hiddenValues
      importedValues
      prefixes
      knownTypesForModule
      knownValuesForModule

-}
-- semantic domain
type T_Impdecl = (Maybe QualName) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Modid) ->
                 (Bool) ->
                 (Bool) ->
                 (Bool) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (Bool) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (FMap Modid [QualName]) ->
                 (FMap Modid [QualName]) ->
                 (NameType) ->
                 (Bool) ->
                 ((FMap QualName QualNames),([(Set QualName,Set QualName)]),([(Set QualName,Set QualName)]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Impdecl))
-- cata
sem_Impdecl :: (Impdecl) ->
               (T_Impdecl)
sem_Impdecl ((Impdecl_Empty )) =
    (sem_Impdecl_Empty )
sem_Impdecl ((Impdecl_Import (_srcloc) (_qual) (_modid) (_as) (_imported))) =
    (sem_Impdecl_Import ((sem_Position (_srcloc))) (_qual) (_modid) (_as) ((sem_Imported (_imported))))
sem_Impdecl_Empty :: (T_Impdecl)
sem_Impdecl_Empty (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Impdecl_Empty
    in  (_lhs_constructors_collect,[],[],_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],_self)
sem_Impdecl_Import :: (T_Position) ->
                      (Bool) ->
                      (Modid) ->
                      (Maybe Modid) ->
                      (T_Imported) ->
                      (T_Impdecl)
sem_Impdecl_Import (_srcloc)
                   (_qual)
                   (_modid)
                   (_as)
                   (_imported)
                   (_lhs_classname)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_importedModule)
                   (_lhs_ininstance)
                   (_lhs_intitype)
                   (_lhs_knownKinds)
                   (_lhs_knownKinds_collect)
                   (_lhs_knownTypes)
                   (_lhs_knownTypes_collect)
                   (_lhs_knownValues)
                   (_lhs_knownValues_collect)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_moduleTypes)
                   (_lhs_moduleValues)
                   (_lhs_nameType)
                   (_lhs_toplevel) =
    let (_knownValuesForModule) =
            applyFMM _lhs_moduleValues
                     (const [])
                     _modid
        (_knownTypesForModule) =
            applyFMM _lhs_moduleTypes
                     (const [])
                     _modid
        (_prefixes) =
            let unqual = if _qual then [] else [Nothing]
                qual Nothing  = [Just _modid]
                qual (Just x) = [Just x]
            in  unqual ++ qual _as
        (_importedValues) =
            Set.mkSet
             . map (\x -> QualName_Entity unkrange x Nothing)
             . concatMap snd . toList $ _imported_knownValues_collect
        (_hiddenValues) =
            Set.mkSet
             . map (\x -> QualName_Entity unkrange x Nothing)
             . concatMap snd . toList $ _imported_hiddenValues_collect
        (_importedTypes) =
            Set.mkSet
             . map (\x -> QualName_Entity unkrange x Nothing)
             . concatMap snd . toList $ _imported_knownTypes_collect
        (_hiddenTypes) =
            Set.mkSet
             . map (\x -> QualName_Entity unkrange x Nothing)
             . concatMap snd . toList $ _imported_hiddenTypes_collect
        (_currentModule) =
            _modid
        (_local) =
            False
        (_self) =
            Impdecl_Import _srcloc_self _qual _modid _as _imported_self
        ( _srcloc_self) =
            (_srcloc )
        ( _imported_constructors_collect,_imported_hiddenTypes_collect,_imported_hiddenValues_collect,_imported_knownKinds_collect,_imported_knownTypes_collect,_imported_knownValues_collect,_imported_methods_collect,_imported_moduleTypes,_imported_moduleValues,_imported_modules,_imported_res,_imported_self) =
            (_imported (_lhs_classname)
                       (_lhs_constructors_collect)
                       (_lhs_constructors_dist)
                       (_currentModule)
                       (_lhs_importedModule)
                       (_lhs_ininstance)
                       (_lhs_intitype)
                       (_lhs_knownKinds)
                       (_lhs_knownKinds_collect)
                       (fromList $
                        map (\n -> (makePlainName n,[getEntity n]))
                            _knownTypesForModule)
                       (let prefixed_tps p  = map (prefixEntity p) _knownTypesForModule
                            all_prefixes    = concatMap prefixed_tps _prefixes
                            add_tps tps     = foldl addLReplace _lhs_knownTypes_collect tps
                        in  add_tps all_prefixes)
                       (fromList $
                        map (\n -> (makePlainName n,[getEntity n]))
                            _knownValuesForModule)
                       (let prefixed_vals p = map (prefixEntity p) _knownValuesForModule
                            all_prefixes    = concatMap prefixed_vals _prefixes
                            add_vals vals   = foldl addLReplace _lhs_knownValues_collect vals
                        in  add_vals all_prefixes)
                       (_local)
                       (_lhs_methods_collect)
                       (_lhs_methods_dist)
                       (_lhs_moduleTypes)
                       (_lhs_moduleValues)
                       (_lhs_nameType)
                       (_lhs_toplevel))
    in  (_imported_constructors_collect,[ (_hiddenValues,_hiddenTypes) ],[ (_importedValues,_importedTypes) ],_lhs_knownKinds_collect,_imported_knownTypes_collect,_imported_knownValues_collect,_imported_methods_collect,_imported_moduleTypes,_imported_moduleValues,_imported_modules,_imported_res,_self)
-- Impdecls ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      hiddenEntities       : [(Set QualName,Set QualName)]
      importedEntities     : [(Set QualName,Set QualName)]
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Impdecls

-}
{-
   local variables for Impdecls.Cons:

-}
{-
   local variables for Impdecls.Nil:

-}
-- semantic domain
type T_Impdecls = (Maybe QualName) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Modid) ->
                  (Bool) ->
                  (Bool) ->
                  (Bool) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (Bool) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (FMap Modid [QualName]) ->
                  (FMap Modid [QualName]) ->
                  (NameType) ->
                  (Bool) ->
                  ((FMap QualName QualNames),([(Set QualName,Set QualName)]),([(Set QualName,Set QualName)]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Impdecls))
-- cata
sem_Impdecls :: (Impdecls) ->
                (T_Impdecls)
sem_Impdecls (list) =
    (foldr (sem_Impdecls_Cons) (sem_Impdecls_Nil) ((map sem_Impdecl list)))
sem_Impdecls_Cons :: (T_Impdecl) ->
                     (T_Impdecls) ->
                     (T_Impdecls)
sem_Impdecls_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _hd_constructors_collect,_hd_hiddenEntities,_hd_importedEntities,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self) =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_hiddenEntities,_tl_importedEntities,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_lhs_local) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tl_constructors_collect,_hd_hiddenEntities ++ _tl_hiddenEntities,_hd_importedEntities ++ _tl_importedEntities,_tl_knownKinds_collect,mergeImports _hd_knownTypes_collect _tl_knownTypes_collect,mergeImports _hd_knownValues_collect _tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_Impdecls_Nil :: (T_Impdecls)
sem_Impdecls_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,[],[],_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])
-- Import ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Import

-}
{-
   local variables for Import.Abstract:

-}
{-
   local variables for Import.TypeAll:

-}
{-
   local variables for Import.TypeSome:
      relevantEntities

-}
{-
   local variables for Import.Var:

-}
-- semantic domain
type T_Import = (Maybe QualName) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Modid) ->
                (Bool) ->
                (Bool) ->
                (Bool) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (Bool) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (FMap Modid [QualName]) ->
                (FMap Modid [QualName]) ->
                (NameType) ->
                (Bool) ->
                ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Import))
-- cata
sem_Import :: (Import) ->
              (T_Import)
sem_Import ((Import_Abstract (_name))) =
    (sem_Import_Abstract ((sem_QualName (_name))))
sem_Import ((Import_TypeAll (_name))) =
    (sem_Import_TypeAll ((sem_QualName (_name))))
sem_Import ((Import_TypeSome (_name) (_conss))) =
    (sem_Import_TypeSome ((sem_QualName (_name))) ((sem_QualNames (_conss))))
sem_Import ((Import_Var (_name))) =
    (sem_Import_Var ((sem_QualName (_name))))
sem_Import_Abstract :: (T_QualName) ->
                       (T_Import)
sem_Import_Abstract (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Typ) (_lhs_toplevel))
    in  (_name_constructors_collect,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,Import_Abstract _name_self)
sem_Import_TypeAll :: (T_QualName) ->
                      (T_Import)
sem_Import_TypeAll (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Typ) (_lhs_toplevel))
    in  (_name_constructors_collect,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,Import_TypeAll  _name_self)
sem_Import_TypeSome :: (T_QualName) ->
                       (T_QualNames) ->
                       (T_Import)
sem_Import_TypeSome (_name) (_conss) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_relevantEntities) =
            map getEntity $
            findL _lhs_methods_dist _name_self
              ++
            findL _lhs_constructors_dist _name_self
        ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Typ) (_lhs_toplevel))
        ( _conss_constructors_collect,_conss_knownKinds_collect,_conss_knownTypes_collect,_conss_knownValues_collect,_conss_methods_collect,_conss_moduleTypes,_conss_moduleValues,_conss_modules,_conss_res,_conss_self,_conss_self') =
            (_conss (_lhs_classname)
                    (_name_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_importedModule)
                    (_lhs_ininstance)
                    (_lhs_intitype)
                    (_lhs_knownKinds)
                    (_name_knownKinds_collect)
                    (_lhs_knownTypes)
                    (_name_knownTypes_collect)
                    (( fromList
                     . filter (\ (_,es) -> not . null $ es `List.intersect`
                                                          _relevantEntities)
                     . toList
                     ) _lhs_knownValues)
                    (_name_knownValues_collect)
                    (_lhs_local)
                    (_name_methods_collect)
                    (_lhs_methods_dist)
                    (_name_moduleTypes)
                    (_name_moduleValues)
                    (Ref_Val)
                    (_lhs_toplevel))
    in  (_conss_constructors_collect,_conss_knownKinds_collect,_conss_knownTypes_collect,_lhs_knownValues_collect,_conss_methods_collect,_conss_moduleTypes,_conss_moduleValues,_name_modules `Set.union` _conss_modules,_name_res ++ _conss_res,Import_TypeSome _name_self _conss_self)
sem_Import_Var :: (T_QualName) ->
                  (T_Import)
sem_Import_Var (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Val) (_lhs_toplevel))
    in  (_name_constructors_collect,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,Import_Var      _name_self)
-- ImportData --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : ImportData

-}
{-
   local variables for ImportData.Abstract:

-}
{-
   local variables for ImportData.Binding:

-}
{-
   local variables for ImportData.Consig:

-}
{-
   local variables for ImportData.Decl:

-}
{-
   local variables for ImportData.Import:

-}
{-
   local variables for ImportData.SetModule:
      currentModule

-}
-- semantic domain
type T_ImportData = (Maybe QualName) ->
                    (FMap QualName QualNames) ->
                    (FMap QualName QualNames) ->
                    (Modid) ->
                    (Bool) ->
                    (Bool) ->
                    (Bool) ->
                    (FMap QualName [Entity]) ->
                    (FMap QualName [Entity]) ->
                    (FMap QualName [Entity]) ->
                    (FMap QualName [Entity]) ->
                    (FMap QualName [Entity]) ->
                    (FMap QualName [Entity]) ->
                    (Bool) ->
                    (FMap QualName QualNames) ->
                    (FMap QualName QualNames) ->
                    (FMap Modid [QualName]) ->
                    (FMap Modid [QualName]) ->
                    (NameType) ->
                    (Bool) ->
                    ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(ImportData))
-- cata
sem_ImportData :: (ImportData) ->
                  (T_ImportData)
sem_ImportData ((ImportData_Abstract (_name) (_conss) (_kind))) =
    (sem_ImportData_Abstract ((sem_QualName (_name))) ((sem_QualNames (_conss))) ((sem_Kind (_kind))))
sem_ImportData ((ImportData_Binding (_name))) =
    (sem_ImportData_Binding ((sem_QualName (_name))))
sem_ImportData ((ImportData_Consig (_name) (_tps))) =
    (sem_ImportData_Consig ((sem_QualName (_name))) ((sem_QualNames (_tps))))
sem_ImportData ((ImportData_Decl (_decls))) =
    (sem_ImportData_Decl ((sem_Decls (_decls))))
sem_ImportData ((ImportData_Import (_modid))) =
    (sem_ImportData_Import (_modid))
sem_ImportData ((ImportData_SetModule (_modid) (_datas))) =
    (sem_ImportData_SetModule (_modid) ((sem_ImportDatas (_datas))))
sem_ImportData_Abstract :: (T_QualName) ->
                           (T_QualNames) ->
                           (T_Kind) ->
                           (T_ImportData)
sem_ImportData_Abstract (_name)
                        (_conss)
                        (_kind)
                        (_lhs_classname)
                        (_lhs_constructors_collect)
                        (_lhs_constructors_dist)
                        (_lhs_currentModule)
                        (_lhs_importedModule)
                        (_lhs_ininstance)
                        (_lhs_intitype)
                        (_lhs_knownKinds)
                        (_lhs_knownKinds_collect)
                        (_lhs_knownTypes)
                        (_lhs_knownTypes_collect)
                        (_lhs_knownValues)
                        (_lhs_knownValues_collect)
                        (_lhs_local)
                        (_lhs_methods_collect)
                        (_lhs_methods_dist)
                        (_lhs_moduleTypes)
                        (_lhs_moduleValues)
                        (_lhs_nameType)
                        (_lhs_toplevel) =
    let ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Def_Typ) (_lhs_toplevel))
        ( _conss_constructors_collect,_conss_knownKinds_collect,_conss_knownTypes_collect,_conss_knownValues_collect,_conss_methods_collect,_conss_moduleTypes,_conss_moduleValues,_conss_modules,_conss_res,_conss_self,_conss_self') =
            (_conss (_lhs_classname) (_name_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_name_knownKinds_collect) (_lhs_knownTypes) (_name_knownTypes_collect) (_lhs_knownValues) (_name_knownValues_collect) (_lhs_local) (_name_methods_collect) (_lhs_methods_dist) (_name_moduleTypes) (_name_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _kind_constructors_collect,_kind_knownKinds_collect,_kind_knownTypes_collect,_kind_knownValues_collect,_kind_methods_collect,_kind_moduleTypes,_kind_moduleValues,_kind_modules,_kind_res,_kind_self) =
            (_kind (_lhs_classname) (_conss_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_conss_knownKinds_collect) (_lhs_knownTypes) (_conss_knownTypes_collect) (_lhs_knownValues) (_conss_knownValues_collect) (_lhs_local) (_conss_methods_collect) (_lhs_methods_dist) (_conss_moduleTypes) (_conss_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_kind_constructors_collect,_kind_knownKinds_collect,_kind_knownTypes_collect,_kind_knownValues_collect,_kind_methods_collect,_kind_moduleTypes,_kind_moduleValues,_name_modules `Set.union` _conss_modules `Set.union` _kind_modules,_name_res ++ _conss_res ++ _kind_res,ImportData_Abstract _name_self _conss_self _kind_self)
sem_ImportData_Binding :: (T_QualName) ->
                          (T_ImportData)
sem_ImportData_Binding (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_name_constructors_collect,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,ImportData_Binding _name_self)
sem_ImportData_Consig :: (T_QualName) ->
                         (T_QualNames) ->
                         (T_ImportData)
sem_ImportData_Consig (_name) (_tps) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Def_Val) (_lhs_toplevel))
        ( _tps_constructors_collect,_tps_knownKinds_collect,_tps_knownTypes_collect,_tps_knownValues_collect,_tps_methods_collect,_tps_moduleTypes,_tps_moduleValues,_tps_modules,_tps_res,_tps_self,_tps_self') =
            (_tps (_lhs_classname) (_name_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_name_knownKinds_collect) (_lhs_knownTypes) (_name_knownTypes_collect) (_lhs_knownValues) (_name_knownValues_collect) (_lhs_local) (_name_methods_collect) (_lhs_methods_dist) (_name_moduleTypes) (_name_moduleValues) (Ref_Typ) (_lhs_toplevel))
    in  (_tps_constructors_collect,_tps_knownKinds_collect,_tps_knownTypes_collect,_tps_knownValues_collect,_tps_methods_collect,_tps_moduleTypes,_tps_moduleValues,_name_modules `Set.union` _tps_modules,_name_res ++ _tps_res,ImportData_Consig _name_self _tps_self)
sem_ImportData_Decl :: (T_Decls) ->
                       (T_ImportData)
sem_ImportData_Decl (_decls) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _decls_constructors_collect,_decls_knownKinds_collect,_decls_knownTypes_collect,_decls_knownValues_collect,_decls_methods_collect,_decls_moduleTypes,_decls_moduleValues,_decls_modules,_decls_res,_decls_self) =
            (_decls (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_decls_constructors_collect,_decls_knownKinds_collect,_decls_knownTypes_collect,_decls_knownValues_collect,_decls_methods_collect,_decls_moduleTypes,_decls_moduleValues,_decls_modules,_decls_res,ImportData_Decl _decls_self)
sem_ImportData_Import :: (Modid) ->
                         (T_ImportData)
sem_ImportData_Import (_modid) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],ImportData_Import _modid)
sem_ImportData_SetModule :: (Modid) ->
                            (T_ImportDatas) ->
                            (T_ImportData)
sem_ImportData_SetModule (_modid)
                         (_datas)
                         (_lhs_classname)
                         (_lhs_constructors_collect)
                         (_lhs_constructors_dist)
                         (_lhs_currentModule)
                         (_lhs_importedModule)
                         (_lhs_ininstance)
                         (_lhs_intitype)
                         (_lhs_knownKinds)
                         (_lhs_knownKinds_collect)
                         (_lhs_knownTypes)
                         (_lhs_knownTypes_collect)
                         (_lhs_knownValues)
                         (_lhs_knownValues_collect)
                         (_lhs_local)
                         (_lhs_methods_collect)
                         (_lhs_methods_dist)
                         (_lhs_moduleTypes)
                         (_lhs_moduleValues)
                         (_lhs_nameType)
                         (_lhs_toplevel) =
    let (_currentModule) =
            _modid
        ( _datas_constructors_collect,_datas_knownKinds_collect,_datas_knownTypes_collect,_datas_knownValues_collect,_datas_methods_collect,_datas_moduleTypes,_datas_moduleValues,_datas_modules,_datas_res,_datas_self) =
            (_datas (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_datas_constructors_collect,_datas_knownKinds_collect,_datas_knownTypes_collect,_datas_knownValues_collect,_datas_methods_collect,_datas_moduleTypes,_datas_moduleValues,_datas_modules,_datas_res,ImportData_SetModule _modid _datas_self)
-- ImportDatas -------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : ImportDatas

-}
{-
   local variables for ImportDatas.Cons:

-}
{-
   local variables for ImportDatas.Nil:

-}
-- semantic domain
type T_ImportDatas = (Maybe QualName) ->
                     (FMap QualName QualNames) ->
                     (FMap QualName QualNames) ->
                     (Modid) ->
                     (Bool) ->
                     (Bool) ->
                     (Bool) ->
                     (FMap QualName [Entity]) ->
                     (FMap QualName [Entity]) ->
                     (FMap QualName [Entity]) ->
                     (FMap QualName [Entity]) ->
                     (FMap QualName [Entity]) ->
                     (FMap QualName [Entity]) ->
                     (Bool) ->
                     (FMap QualName QualNames) ->
                     (FMap QualName QualNames) ->
                     (FMap Modid [QualName]) ->
                     (FMap Modid [QualName]) ->
                     (NameType) ->
                     (Bool) ->
                     ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(ImportDatas))
-- cata
sem_ImportDatas :: (ImportDatas) ->
                   (T_ImportDatas)
sem_ImportDatas (list) =
    (foldr (sem_ImportDatas_Cons) (sem_ImportDatas_Nil) ((map sem_ImportData list)))
sem_ImportDatas_Cons :: (T_ImportData) ->
                        (T_ImportDatas) ->
                        (T_ImportDatas)
sem_ImportDatas_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _hd_constructors_collect,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self) =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_lhs_local) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_ImportDatas_Nil :: (T_ImportDatas)
sem_ImportDatas_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])
-- Imported ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      hiddenTypes_collect  : FMap QualName [Entity]
      hiddenValues_collect : FMap QualName [Entity]
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Imported

-}
{-
   local variables for Imported.Hiding:

-}
{-
   local variables for Imported.Imports:

-}
{-
   local variables for Imported.NoImports:

-}
-- semantic domain
type T_Imported = (Maybe QualName) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Modid) ->
                  (Bool) ->
                  (Bool) ->
                  (Bool) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (Bool) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (FMap Modid [QualName]) ->
                  (FMap Modid [QualName]) ->
                  (NameType) ->
                  (Bool) ->
                  ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Imported))
-- cata
sem_Imported :: (Imported) ->
                (T_Imported)
sem_Imported ((Imported_Hiding (_imports))) =
    (sem_Imported_Hiding ((sem_Imports (_imports))))
sem_Imported ((Imported_Imports (_imports))) =
    (sem_Imported_Imports ((sem_Imports (_imports))))
sem_Imported ((Imported_NoImports )) =
    (sem_Imported_NoImports )
sem_Imported_Hiding :: (T_Imports) ->
                       (T_Imported)
sem_Imported_Hiding (_imports) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _imports_constructors_collect,_imports_knownKinds_collect,_imports_knownTypes_collect,_imports_knownValues_collect,_imports_methods_collect,_imports_moduleTypes,_imports_moduleValues,_imports_modules,_imports_res,_imports_self) =
            (_imports (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_imports_constructors_collect
        ,selectFromT id  _imports_knownTypes_collect  _imports_self
        ,selectFromV id _lhs_knownValues
                        _lhs_knownTypes
                        _imports_self
                        _lhs_constructors_dist
                        _lhs_methods_dist
        ,_imports_knownKinds_collect
        ,selectFromT not _imports_knownTypes_collect  _imports_self
        ,selectFromV not _lhs_knownValues
                         _lhs_knownTypes
                         _imports_self
                         _lhs_constructors_dist
                         _lhs_methods_dist
        ,_imports_methods_collect
        ,_imports_moduleTypes
        ,_imports_moduleValues
        ,_imports_modules
        ,_imports_res
        ,Imported_Hiding _imports_self
        )
sem_Imported_Imports :: (T_Imports) ->
                        (T_Imported)
sem_Imported_Imports (_imports) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _imports_constructors_collect,_imports_knownKinds_collect,_imports_knownTypes_collect,_imports_knownValues_collect,_imports_methods_collect,_imports_moduleTypes,_imports_moduleValues,_imports_modules,_imports_res,_imports_self) =
            (_imports (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_imports_constructors_collect
        ,selectFromT not _imports_knownTypes_collect _imports_self
        ,selectFromV not _lhs_knownValues
                         _lhs_knownTypes
                         _imports_self
                         _lhs_constructors_dist
                         _lhs_methods_dist
        ,_imports_knownKinds_collect
        ,selectFromT id _imports_knownTypes_collect _imports_self
        ,selectFromV id _lhs_knownValues
                        _lhs_knownTypes
                        _imports_self
                        _lhs_constructors_dist
                        _lhs_methods_dist
        ,_imports_methods_collect
        ,_imports_moduleTypes
        ,_imports_moduleValues
        ,_imports_modules
        ,_imports_res
        ,Imported_Imports _imports_self
        )
sem_Imported_NoImports :: (T_Imported)
sem_Imported_NoImports (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,emptyFM,emptyFM,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],Imported_NoImports)
-- ImportedModule ----------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : ImportedModule

-}
{-
   local variables for ImportedModule.Empty:

-}
{-
   local variables for ImportedModule.Module:
      local
      toplevel
      importedModule
      currentModule

-}
-- semantic domain
type T_ImportedModule = (Maybe QualName) ->
                        (FMap QualName QualNames) ->
                        (FMap QualName QualNames) ->
                        (Bool) ->
                        (Bool) ->
                        (Bool) ->
                        (FMap QualName [Entity]) ->
                        (FMap QualName [Entity]) ->
                        (FMap QualName [Entity]) ->
                        (FMap QualName [Entity]) ->
                        (FMap QualName [Entity]) ->
                        (FMap QualName [Entity]) ->
                        (FMap QualName QualNames) ->
                        (FMap QualName QualNames) ->
                        (FMap Modid [QualName]) ->
                        (FMap Modid [QualName]) ->
                        (NameType) ->
                        (Bool) ->
                        ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(ImportedModule))
-- cata
sem_ImportedModule :: (ImportedModule) ->
                      (T_ImportedModule)
sem_ImportedModule ((ImportedModule_Empty )) =
    (sem_ImportedModule_Empty )
sem_ImportedModule ((ImportedModule_Module (_modid) (_export_tp) (_export_val) (_datas))) =
    (sem_ImportedModule_Module (_modid) ((sem_QualNames (_export_tp))) ((sem_QualNames (_export_val))) ((sem_ImportDatas (_datas))))
sem_ImportedModule_Empty :: (T_ImportedModule)
sem_ImportedModule_Empty (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],ImportedModule_Empty)
sem_ImportedModule_Module :: (Modid) ->
                             (T_QualNames) ->
                             (T_QualNames) ->
                             (T_ImportDatas) ->
                             (T_ImportedModule)
sem_ImportedModule_Module (_modid) (_export_tp) (_export_val) (_datas) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_currentModule) =
            _modid
        (_importedModule) =
            True
        (_toplevel) =
            True
        (_local) =
            False
        ( _export_tp_constructors_collect,_export_tp_knownKinds_collect,_export_tp_knownTypes_collect,_export_tp_knownValues_collect,_export_tp_methods_collect,_export_tp_moduleTypes,_export_tp_moduleValues,_export_tp_modules,_export_tp_res,_export_tp_self,_export_tp_self') =
            (_export_tp (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_currentModule) (_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_toplevel))
        ( _export_val_constructors_collect,_export_val_knownKinds_collect,_export_val_knownTypes_collect,_export_val_knownValues_collect,_export_val_methods_collect,_export_val_moduleTypes,_export_val_moduleValues,_export_val_modules,_export_val_res,_export_val_self,_export_val_self') =
            (_export_val (_lhs_classname)
                         (_export_tp_constructors_collect)
                         (_lhs_constructors_dist)
                         (_currentModule)
                         (_importedModule)
                         (_lhs_ininstance)
                         (_lhs_intitype)
                         (_lhs_knownKinds)
                         (_export_tp_knownKinds_collect)
                         (_lhs_knownTypes)
                         (_export_tp_knownTypes_collect)
                         (_lhs_knownValues)
                         (_export_tp_knownValues_collect)
                         (_local)
                         (_export_tp_methods_collect)
                         (_lhs_methods_dist)
                         (_export_tp_moduleTypes)
                         (_export_tp_moduleValues)
                         (_lhs_nameType)
                         (_toplevel))
        ( _datas_constructors_collect,_datas_knownKinds_collect,_datas_knownTypes_collect,_datas_knownValues_collect,_datas_methods_collect,_datas_moduleTypes,_datas_moduleValues,_datas_modules,_datas_res,_datas_self) =
            (_datas (_lhs_classname)
                    (emptyFM)
                    (_lhs_constructors_dist)
                    (_currentModule)
                    (_importedModule)
                    (_lhs_ininstance)
                    (_lhs_intitype)
                    (_lhs_knownKinds)
                    (_export_val_knownKinds_collect)
                    (internalError "Names.ImportedModule.Module.datas.knownTypes: not used")
                    (internalError "Names.ImportedModule.Module.datas.knownTypes_collect: not used")
                    (internalError "Names.ImportedModule.Module.datas.knownValues: not used")
                    (internalError "Names.ImportedModule.Module.datas.knownValues_collect: not used")
                    (_local)
                    (emptyFM)
                    (_lhs_methods_dist)
                    (_export_val_moduleTypes)
                    (_export_val_moduleValues)
                    (_lhs_nameType)
                    (_toplevel))
    in  (mergeFM _lhs_constructors_collect
                 _datas_constructors_collect
        ,_datas_knownKinds_collect
        ,_lhs_knownTypes_collect
        ,_lhs_knownValues_collect
        ,mergeFM _lhs_methods_collect
                 _datas_methods_collect
        ,add _lhs_moduleTypes  (_modid,_export_tp_self)
        ,add _lhs_moduleValues (_modid,_export_val_self)
        ,_export_tp_modules `Set.union` _export_val_modules `Set.union` _datas_modules
        ,_export_tp_res ++ _export_val_res ++ _datas_res
        ,ImportedModule_Module _modid _export_tp_self
                               _export_val_self _datas_self
        )
-- ImportedModules ---------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : ImportedModules

-}
{-
   local variables for ImportedModules.Cons:

-}
{-
   local variables for ImportedModules.Nil:

-}
-- semantic domain
type T_ImportedModules = (Maybe QualName) ->
                         (FMap QualName QualNames) ->
                         (FMap QualName QualNames) ->
                         (Bool) ->
                         (Bool) ->
                         (Bool) ->
                         (FMap QualName [Entity]) ->
                         (FMap QualName [Entity]) ->
                         (FMap QualName [Entity]) ->
                         (FMap QualName [Entity]) ->
                         (FMap QualName [Entity]) ->
                         (FMap QualName [Entity]) ->
                         (FMap QualName QualNames) ->
                         (FMap QualName QualNames) ->
                         (FMap Modid [QualName]) ->
                         (FMap Modid [QualName]) ->
                         (NameType) ->
                         (Bool) ->
                         ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(ImportedModules))
-- cata
sem_ImportedModules :: (ImportedModules) ->
                       (T_ImportedModules)
sem_ImportedModules (list) =
    (foldr (sem_ImportedModules_Cons) (sem_ImportedModules_Nil) ((map sem_ImportedModule list)))
sem_ImportedModules_Cons :: (T_ImportedModule) ->
                            (T_ImportedModules) ->
                            (T_ImportedModules)
sem_ImportedModules_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _hd_constructors_collect,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self) =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_ImportedModules_Nil :: (T_ImportedModules)
sem_ImportedModules_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])
-- Imports -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Imports

-}
{-
   local variables for Imports.Cons:

-}
{-
   local variables for Imports.Nil:

-}
-- semantic domain
type T_Imports = (Maybe QualName) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Modid) ->
                 (Bool) ->
                 (Bool) ->
                 (Bool) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (Bool) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (FMap Modid [QualName]) ->
                 (FMap Modid [QualName]) ->
                 (NameType) ->
                 (Bool) ->
                 ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Imports))
-- cata
sem_Imports :: (Imports) ->
               (T_Imports)
sem_Imports (list) =
    (foldr (sem_Imports_Cons) (sem_Imports_Nil) ((map sem_Import list)))
sem_Imports_Cons :: (T_Import) ->
                    (T_Imports) ->
                    (T_Imports)
sem_Imports_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _hd_constructors_collect,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self) =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_lhs_local) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_Imports_Nil :: (T_Imports)
sem_Imports_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])
-- Infix -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Infix

-}
{-
   local variables for Infix.Left:

-}
{-
   local variables for Infix.No:

-}
{-
   local variables for Infix.Right:

-}
-- semantic domain
type T_Infix = (Maybe QualName) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (Bool) ->
               (Bool) ->
               (Bool) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (FMap Modid [QualName]) ->
               (FMap Modid [QualName]) ->
               (NameType) ->
               (Bool) ->
               ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Infix))
-- cata
sem_Infix :: (Infix) ->
             (T_Infix)
sem_Infix ((Infix_Left )) =
    (sem_Infix_Left )
sem_Infix ((Infix_No )) =
    (sem_Infix_No )
sem_Infix ((Infix_Right )) =
    (sem_Infix_Right )
sem_Infix_Left :: (T_Infix)
sem_Infix_Left (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],Infix_Left)
sem_Infix_No :: (T_Infix)
sem_Infix_No (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],Infix_No)
sem_Infix_Right :: (T_Infix)
sem_Infix_Right (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],Infix_Right)
-- Kind --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Kind

-}
{-
   local variables for Kind.Arr:

-}
{-
   local variables for Kind.Box:

-}
{-
   local variables for Kind.Error:

-}
{-
   local variables for Kind.Star:

-}
{-
   local variables for Kind.Var:

-}
-- semantic domain
type T_Kind = (Maybe QualName) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Modid) ->
              (Bool) ->
              (Bool) ->
              (Bool) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (Bool) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (FMap Modid [QualName]) ->
              (FMap Modid [QualName]) ->
              (NameType) ->
              (Bool) ->
              ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Kind))
-- cata
sem_Kind :: (Kind) ->
            (T_Kind)
sem_Kind ((Kind_Arr (_left) (_right))) =
    (sem_Kind_Arr ((sem_Kind (_left))) ((sem_Kind (_right))))
sem_Kind ((Kind_Box (_kind))) =
    (sem_Kind_Box ((sem_Kind (_kind))))
sem_Kind ((Kind_Error )) =
    (sem_Kind_Error )
sem_Kind ((Kind_Star )) =
    (sem_Kind_Star )
sem_Kind ((Kind_Var (_name))) =
    (sem_Kind_Var ((sem_QualName (_name))))
sem_Kind_Arr :: (T_Kind) ->
                (T_Kind) ->
                (T_Kind)
sem_Kind_Arr (_left) (_right) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _left_constructors_collect,_left_knownKinds_collect,_left_knownTypes_collect,_left_knownValues_collect,_left_methods_collect,_left_moduleTypes,_left_moduleValues,_left_modules,_left_res,_left_self) =
            (_left (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _right_constructors_collect,_right_knownKinds_collect,_right_knownTypes_collect,_right_knownValues_collect,_right_methods_collect,_right_moduleTypes,_right_moduleValues,_right_modules,_right_res,_right_self) =
            (_right (_lhs_classname) (_left_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_left_knownKinds_collect) (_lhs_knownTypes) (_left_knownTypes_collect) (_lhs_knownValues) (_left_knownValues_collect) (_lhs_local) (_left_methods_collect) (_lhs_methods_dist) (_left_moduleTypes) (_left_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_right_constructors_collect,_right_knownKinds_collect,_right_knownTypes_collect,_right_knownValues_collect,_right_methods_collect,_right_moduleTypes,_right_moduleValues,_left_modules `Set.union` _right_modules,_left_res ++ _right_res,Kind_Arr _left_self _right_self)
sem_Kind_Box :: (T_Kind) ->
                (T_Kind)
sem_Kind_Box (_kind) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _kind_constructors_collect,_kind_knownKinds_collect,_kind_knownTypes_collect,_kind_knownValues_collect,_kind_methods_collect,_kind_moduleTypes,_kind_moduleValues,_kind_modules,_kind_res,_kind_self) =
            (_kind (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_kind_constructors_collect,_kind_knownKinds_collect,_kind_knownTypes_collect,_kind_knownValues_collect,_kind_methods_collect,_kind_moduleTypes,_kind_moduleValues,_kind_modules,_kind_res,Kind_Box _kind_self)
sem_Kind_Error :: (T_Kind)
sem_Kind_Error (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],Kind_Error)
sem_Kind_Star :: (T_Kind)
sem_Kind_Star (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],Kind_Star)
sem_Kind_Var :: (T_QualName) ->
                (T_Kind)
sem_Kind_Var (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_name_constructors_collect,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,Kind_Var _name_self)
-- LabelType ---------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool
      tpname               : QualName

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      constructors         : QualNames
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : LabelType

-}
{-
   local variables for LabelType.LabelType:

-}
{-
   local variables for LabelType.Type:

-}
-- semantic domain
type T_LabelType = (Maybe QualName) ->
                   (FMap QualName QualNames) ->
                   (FMap QualName QualNames) ->
                   (Modid) ->
                   (Bool) ->
                   (Bool) ->
                   (Bool) ->
                   (FMap QualName [Entity]) ->
                   (FMap QualName [Entity]) ->
                   (FMap QualName [Entity]) ->
                   (FMap QualName [Entity]) ->
                   (FMap QualName [Entity]) ->
                   (FMap QualName [Entity]) ->
                   (Bool) ->
                   (FMap QualName QualNames) ->
                   (FMap QualName QualNames) ->
                   (FMap Modid [QualName]) ->
                   (FMap Modid [QualName]) ->
                   (NameType) ->
                   (Bool) ->
                   (QualName) ->
                   ((QualNames),(FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(LabelType))
-- cata
sem_LabelType :: (LabelType) ->
                 (T_LabelType)
sem_LabelType ((LabelType_LabelType (_label) (_strict) (_body))) =
    (sem_LabelType_LabelType ((sem_QualName (_label))) (_strict) ((sem_Type (_body))))
sem_LabelType ((LabelType_Type (_strict) (_body))) =
    (sem_LabelType_Type (_strict) ((sem_Type (_body))))
sem_LabelType_LabelType :: (T_QualName) ->
                           (Bool) ->
                           (T_Type) ->
                           (T_LabelType)
sem_LabelType_LabelType (_label)
                        (_strict)
                        (_body)
                        (_lhs_classname)
                        (_lhs_constructors_collect)
                        (_lhs_constructors_dist)
                        (_lhs_currentModule)
                        (_lhs_importedModule)
                        (_lhs_ininstance)
                        (_lhs_intitype)
                        (_lhs_knownKinds)
                        (_lhs_knownKinds_collect)
                        (_lhs_knownTypes)
                        (_lhs_knownTypes_collect)
                        (_lhs_knownValues)
                        (_lhs_knownValues_collect)
                        (_lhs_local)
                        (_lhs_methods_collect)
                        (_lhs_methods_dist)
                        (_lhs_moduleTypes)
                        (_lhs_moduleValues)
                        (_lhs_nameType)
                        (_lhs_toplevel)
                        (_lhs_tpname) =
    let ( _label_constructors_collect,_label_entityName,_label_fullName,_label_knownKinds_collect,_label_knownTypes_collect,_label_knownValues_collect,_label_methods_collect,_label_moduleTypes,_label_moduleValues,_label_modules,_label_res,_label_self,_label_self') =
            (_label (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Def_Val) (_lhs_toplevel))
        ( _body_constructors_collect,_body_knownKinds_collect,_body_knownTypes_collect,_body_knownValues_collect,_body_methods_collect,_body_moduleTypes,_body_moduleValues,_body_modules,_body_res,_body_self) =
            (_body (_lhs_classname) (_label_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_label_knownKinds_collect) (_lhs_knownTypes) (_label_knownTypes_collect) (_lhs_knownValues) (_label_knownValues_collect) (_lhs_local) (_label_methods_collect) (_lhs_methods_dist) (_label_moduleTypes) (_label_moduleValues) (_lhs_nameType) (False))
    in  ([_label_self]
        ,_body_constructors_collect
        ,_body_knownKinds_collect
        ,_body_knownTypes_collect
        ,_body_knownValues_collect
        ,_body_methods_collect
        ,_body_moduleTypes
        ,_body_moduleValues
        ,_label_modules `Set.union` _body_modules
        ,_label_res ++ _body_res
        ,LabelType_LabelType _label_self _strict
                             _body_self
        )
sem_LabelType_Type :: (Bool) ->
                      (T_Type) ->
                      (T_LabelType)
sem_LabelType_Type (_strict)
                   (_body)
                   (_lhs_classname)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_importedModule)
                   (_lhs_ininstance)
                   (_lhs_intitype)
                   (_lhs_knownKinds)
                   (_lhs_knownKinds_collect)
                   (_lhs_knownTypes)
                   (_lhs_knownTypes_collect)
                   (_lhs_knownValues)
                   (_lhs_knownValues_collect)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_moduleTypes)
                   (_lhs_moduleValues)
                   (_lhs_nameType)
                   (_lhs_toplevel)
                   (_lhs_tpname) =
    let ( _body_constructors_collect,_body_knownKinds_collect,_body_knownTypes_collect,_body_knownValues_collect,_body_methods_collect,_body_moduleTypes,_body_moduleValues,_body_modules,_body_res,_body_self) =
            (_body (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (False))
    in  ([],_body_constructors_collect,_body_knownKinds_collect,_body_knownTypes_collect,_body_knownValues_collect,_body_methods_collect,_body_moduleTypes,_body_moduleValues,_body_modules,_body_res,LabelType_Type _strict _body_self)
-- LabelTypes --------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool
      tpname               : QualName

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      constructors         : QualNames
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : LabelTypes

-}
{-
   local variables for LabelTypes.Cons:

-}
{-
   local variables for LabelTypes.Nil:

-}
-- semantic domain
type T_LabelTypes = (Maybe QualName) ->
                    (FMap QualName QualNames) ->
                    (FMap QualName QualNames) ->
                    (Modid) ->
                    (Bool) ->
                    (Bool) ->
                    (Bool) ->
                    (FMap QualName [Entity]) ->
                    (FMap QualName [Entity]) ->
                    (FMap QualName [Entity]) ->
                    (FMap QualName [Entity]) ->
                    (FMap QualName [Entity]) ->
                    (FMap QualName [Entity]) ->
                    (Bool) ->
                    (FMap QualName QualNames) ->
                    (FMap QualName QualNames) ->
                    (FMap Modid [QualName]) ->
                    (FMap Modid [QualName]) ->
                    (NameType) ->
                    (Bool) ->
                    (QualName) ->
                    ((QualNames),(FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(LabelTypes))
-- cata
sem_LabelTypes :: (LabelTypes) ->
                  (T_LabelTypes)
sem_LabelTypes (list) =
    (foldr (sem_LabelTypes_Cons) (sem_LabelTypes_Nil) ((map sem_LabelType list)))
sem_LabelTypes_Cons :: (T_LabelType) ->
                       (T_LabelTypes) ->
                       (T_LabelTypes)
sem_LabelTypes_Cons (_hd)
                    (_tl)
                    (_lhs_classname)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_importedModule)
                    (_lhs_ininstance)
                    (_lhs_intitype)
                    (_lhs_knownKinds)
                    (_lhs_knownKinds_collect)
                    (_lhs_knownTypes)
                    (_lhs_knownTypes_collect)
                    (_lhs_knownValues)
                    (_lhs_knownValues_collect)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_moduleTypes)
                    (_lhs_moduleValues)
                    (_lhs_nameType)
                    (_lhs_toplevel)
                    (_lhs_tpname) =
    let ( _hd_constructors,_hd_constructors_collect,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self) =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) (_lhs_tpname))
        ( _tl_constructors,_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_lhs_local) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_lhs_nameType) (_lhs_toplevel) (_lhs_tpname))
    in  (_hd_constructors ++ _tl_constructors,_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_LabelTypes_Nil :: (T_LabelTypes)
sem_LabelTypes_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) (_lhs_tpname) =
    let 
    in  ([],_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])
-- Literal -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Literal

-}
{-
   local variables for Literal.Char:

-}
{-
   local variables for Literal.Float:

-}
{-
   local variables for Literal.Frac:

-}
{-
   local variables for Literal.Int:

-}
{-
   local variables for Literal.String:

-}
-- semantic domain
type T_Literal = (Maybe QualName) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Modid) ->
                 (Bool) ->
                 (Bool) ->
                 (Bool) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (Bool) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (FMap Modid [QualName]) ->
                 (FMap Modid [QualName]) ->
                 (NameType) ->
                 (Bool) ->
                 ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Literal))
-- cata
sem_Literal :: (Literal) ->
               (T_Literal)
sem_Literal ((Literal_Char (_name))) =
    (sem_Literal_Char (_name))
sem_Literal ((Literal_Float (_name))) =
    (sem_Literal_Float (_name))
sem_Literal ((Literal_Frac (_name))) =
    (sem_Literal_Frac (_name))
sem_Literal ((Literal_Int (_name))) =
    (sem_Literal_Int (_name))
sem_Literal ((Literal_String (_name))) =
    (sem_Literal_String (_name))
sem_Literal_Char :: (String) ->
                    (T_Literal)
sem_Literal_Char (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],Literal_Char   _name)
sem_Literal_Float :: (String) ->
                     (T_Literal)
sem_Literal_Float (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],Literal_Float  _name)
sem_Literal_Frac :: (String) ->
                    (T_Literal)
sem_Literal_Frac (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],Literal_Frac   _name)
sem_Literal_Int :: (String) ->
                   (T_Literal)
sem_Literal_Int (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],Literal_Int    _name)
sem_Literal_String :: (String) ->
                      (T_Literal)
sem_Literal_String (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],Literal_String _name)
-- Module ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      compiledModule       : Modid
      exported             : Exports
      hiddenEntities       : [(Set QualName,Set QualName)]
      importedEntities     : [(Set QualName,Set QualName)]
      modules              : Set.Set Modid
      replace              : Module
      res                  : [ResolveResult]
      self                 : Module

-}
{-
   local variables for Module.Main:
      local
      compiledModule
      currentModule
      exported_replace
      exports_replace
      relevantValues
      relevantTypes

-}
{-
   local variables for Module.Named:
      local
      compiledModule
      currentModule

-}
-- semantic domain
type T_Module = (Maybe QualName) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Bool) ->
                (Bool) ->
                (Bool) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (FMap Modid [QualName]) ->
                (FMap Modid [QualName]) ->
                (NameType) ->
                (Bool) ->
                ((Modid),(FMap QualName QualNames),(Exports),([(Set QualName,Set QualName)]),([(Set QualName,Set QualName)]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),(Module),([ResolveResult]),(Module))
-- cata
sem_Module :: (Module) ->
              (T_Module)
sem_Module ((Module_Main (_body))) =
    (sem_Module_Main ((sem_Body (_body))))
sem_Module ((Module_Named (_modid) (_exported) (_body))) =
    (sem_Module_Named (_modid) ((sem_Exported (_exported))) ((sem_Body (_body))))
sem_Module_Main :: (T_Body) ->
                   (T_Module)
sem_Module_Main (_body) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_relevantTypes) =
            concatMap (\ (n,es) -> case n of
                            QualName_Qual _ m u
                               | m == _currentModule ->
                                   let uq = QualName_Plain unkrange u
                                   in  ( map (\ e -> case findL _lhs_knownTypes uq of
                                                   [e'] | e == e' -> QualName_Entity unkrange e (Just uq)
                                                   _   -> QualName_Entity unkrange e (Just n))
                                       . filter (\ (Entity_Entity m' _)
                                                -> Just m == m')
                                       ) es
                            _ -> []
                      ) $
            toList _lhs_knownTypes
        (_relevantValues) =
            concatMap (\ (n,es) -> case n of
                            QualName_Qual _ m u
                               | m == _currentModule ->
                                   let uq = QualName_Plain unkrange u
                                   in  ( map (\ e -> case findL _lhs_knownValues uq of
                                                   [e'] | e == e' -> QualName_Entity unkrange e (Just uq)
                                                   _   -> QualName_Entity unkrange e (Just n))
                                       . filter (\ (Entity_Entity m' _)
                                                -> Just m == m')
                                       ) es
                            _ -> []
                      ) $
            toList _lhs_knownValues
        (_exports_replace) =
            prepareExportList
               _relevantValues
               _relevantTypes
               _lhs_constructors_dist
               _lhs_methods_dist
        (_exported_replace) =
            Exported_Exports _exports_replace
        (_currentModule) =
            "Main"
        (_compiledModule) =
            "Main"
        (_local) =
            True
        ( _body_constructors_collect,_body_hiddenEntities,_body_importedEntities,_body_knownKinds_collect,_body_knownTypes_collect,_body_knownValues_collect,_body_methods_collect,_body_moduleTypes,_body_moduleValues,_body_modules,_body_res,_body_self) =
            (_body (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_compiledModule,_body_constructors_collect,_exports_replace,_body_hiddenEntities,_body_importedEntities,_body_knownKinds_collect,_body_knownTypes_collect,_body_knownValues_collect,_body_methods_collect,_body_moduleTypes,_body_moduleValues,_body_modules,Module_Named _currentModule _exported_replace _body_self,_body_res,Module_Main _body_self)
sem_Module_Named :: (Modid) ->
                    (T_Exported) ->
                    (T_Body) ->
                    (T_Module)
sem_Module_Named (_modid) (_exported) (_body) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_currentModule) =
            _modid
        (_compiledModule) =
            _modid
        (_local) =
            True
        ( _exported_constructors_collect,_exported_exported,_exported_knownKinds_collect,_exported_knownTypes_collect,_exported_knownValues_collect,_exported_methods_collect,_exported_moduleTypes,_exported_moduleValues,_exported_modules,_exported_replace,_exported_res,_exported_self) =
            (_exported (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _body_constructors_collect,_body_hiddenEntities,_body_importedEntities,_body_knownKinds_collect,_body_knownTypes_collect,_body_knownValues_collect,_body_methods_collect,_body_moduleTypes,_body_moduleValues,_body_modules,_body_res,_body_self) =
            (_body (_lhs_classname)
                   (_exported_constructors_collect)
                   (_lhs_constructors_dist)
                   (_currentModule)
                   (_lhs_importedModule)
                   (_lhs_ininstance)
                   (_lhs_intitype)
                   (_lhs_knownKinds)
                   (_exported_knownKinds_collect)
                   (_lhs_knownTypes)
                   (_exported_knownTypes_collect)
                   (_lhs_knownValues)
                   (_exported_knownValues_collect)
                   (_local)
                   (_exported_methods_collect)
                   (_lhs_methods_dist)
                   (_exported_moduleTypes)
                   (_exported_moduleValues)
                   (_lhs_nameType)
                   (_lhs_toplevel))
    in  (_compiledModule,_body_constructors_collect,_exported_exported,_body_hiddenEntities,_body_importedEntities,_body_knownKinds_collect,_body_knownTypes_collect,_body_knownValues_collect,_body_methods_collect,_body_moduleTypes,_body_moduleValues,_exported_modules `Set.union` _body_modules,Module_Named _modid _exported_replace _body_self,_exported_res ++ _body_res,Module_Named _modid _exported_self _body_self)
-- ModuleSystem ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      compiledModule       : Modid
      exported             : Exports
      hiddenEntities       : [(Set QualName,Set QualName)]
      importedEntities     : [(Set QualName,Set QualName)]
      modules              : Set.Set Modid
      replace              : ModuleSystem
      res                  : [ResolveResult]
      self                 : ModuleSystem

-}
{-
   local variables for ModuleSystem.ModuleSystem:

-}
-- semantic domain
type T_ModuleSystem = (Maybe QualName) ->
                      (FMap QualName QualNames) ->
                      (FMap QualName QualNames) ->
                      (Bool) ->
                      (Bool) ->
                      (Bool) ->
                      (FMap QualName [Entity]) ->
                      (FMap QualName [Entity]) ->
                      (FMap QualName [Entity]) ->
                      (FMap QualName [Entity]) ->
                      (FMap QualName [Entity]) ->
                      (FMap QualName [Entity]) ->
                      (FMap QualName QualNames) ->
                      (FMap QualName QualNames) ->
                      (FMap Modid [QualName]) ->
                      (FMap Modid [QualName]) ->
                      (NameType) ->
                      (Bool) ->
                      ((Modid),(FMap QualName QualNames),(Exports),([(Set QualName,Set QualName)]),([(Set QualName,Set QualName)]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),(ModuleSystem),([ResolveResult]),(ModuleSystem))
-- cata
sem_ModuleSystem :: (ModuleSystem) ->
                    (T_ModuleSystem)
sem_ModuleSystem ((ModuleSystem_ModuleSystem (_imports) (_module))) =
    (sem_ModuleSystem_ModuleSystem ((sem_ImportedModules (_imports))) ((sem_Module (_module))))
sem_ModuleSystem_ModuleSystem :: (T_ImportedModules) ->
                                 (T_Module) ->
                                 (T_ModuleSystem)
sem_ModuleSystem_ModuleSystem (_imports) (_module) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _imports_constructors_collect,_imports_knownKinds_collect,_imports_knownTypes_collect,_imports_knownValues_collect,_imports_methods_collect,_imports_moduleTypes,_imports_moduleValues,_imports_modules,_imports_res,_imports_self) =
            (_imports (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _module_compiledModule,_module_constructors_collect,_module_exported,_module_hiddenEntities,_module_importedEntities,_module_knownKinds_collect,_module_knownTypes_collect,_module_knownValues_collect,_module_methods_collect,_module_moduleTypes,_module_moduleValues,_module_modules,_module_replace,_module_res,_module_self) =
            (_module (_lhs_classname) (_imports_constructors_collect) (_lhs_constructors_dist) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_imports_knownKinds_collect) (_lhs_knownTypes) (_imports_knownTypes_collect) (_lhs_knownValues) (_imports_knownValues_collect) (_imports_methods_collect) (_lhs_methods_dist) (_imports_moduleTypes) (_imports_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_module_compiledModule
        ,_module_constructors_collect
        ,_module_exported
        ,_module_hiddenEntities
        ,_module_importedEntities
        ,_module_knownKinds_collect
        ,_module_knownTypes_collect
        ,_module_knownValues_collect
        ,_module_methods_collect
        ,_module_moduleTypes
        ,_module_moduleValues
        ,_imports_modules `Set.union` _module_modules
        ,ModuleSystem_ModuleSystem _imports_self _module_replace
        ,_imports_res ++ _module_res
        ,ModuleSystem_ModuleSystem _imports_self _module_self
        )
-- Name --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      fullName             : QualName
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Name

-}
{-
   local variables for Name.Ident:
      fullName
      self

-}
{-
   local variables for Name.Special:
      fullName
      self

-}
{-
   local variables for Name.Symbol:
      fullName
      self

-}
-- semantic domain
type T_Name = (Maybe QualName) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Modid) ->
              (Bool) ->
              (Bool) ->
              (Bool) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (Bool) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (FMap Modid [QualName]) ->
              (FMap Modid [QualName]) ->
              (NameType) ->
              (Bool) ->
              ((FMap QualName QualNames),(QualName),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Name))
-- cata
sem_Name :: (Name) ->
            (T_Name)
sem_Name ((Name_Ident (_range) (_name))) =
    (sem_Name_Ident ((sem_Range (_range))) (_name))
sem_Name ((Name_Special (_range) (_name))) =
    (sem_Name_Special ((sem_Range (_range))) (_name))
sem_Name ((Name_Symbol (_range) (_name))) =
    (sem_Name_Symbol ((sem_Range (_range))) (_name))
sem_Name_Ident :: (T_Range) ->
                  (String) ->
                  (T_Name)
sem_Name_Ident (_range) (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Name_Ident   _range_self _name
        (_fullName) =
            QualName_Qual unkrange _lhs_currentModule
                          _self
        ( _range_self) =
            (_range )
    in  (_lhs_constructors_collect,_fullName,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],_self)
sem_Name_Special :: (T_Range) ->
                    (String) ->
                    (T_Name)
sem_Name_Special (_range) (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Name_Special _range_self _name
        (_fullName) =
            QualName_Qual unkrange _lhs_currentModule
                          _self
        ( _range_self) =
            (_range )
    in  (_lhs_constructors_collect,_fullName,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],_self)
sem_Name_Symbol :: (T_Range) ->
                   (String) ->
                   (T_Name)
sem_Name_Symbol (_range) (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Name_Symbol  _range_self _name
        (_fullName) =
            QualName_Qual unkrange _lhs_currentModule
                          _self
        ( _range_self) =
            (_range )
    in  (_lhs_constructors_collect,_fullName,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],_self)
-- Names -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Names

-}
{-
   local variables for Names.Cons:

-}
{-
   local variables for Names.Nil:

-}
-- semantic domain
type T_Names = (Maybe QualName) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (Bool) ->
               (Bool) ->
               (Bool) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (FMap Modid [QualName]) ->
               (FMap Modid [QualName]) ->
               (NameType) ->
               (Bool) ->
               ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Names))
-- cata
sem_Names :: (Names) ->
             (T_Names)
sem_Names (list) =
    (foldr (sem_Names_Cons) (sem_Names_Nil) ((map sem_Name list)))
sem_Names_Cons :: (T_Name) ->
                  (T_Names) ->
                  (T_Names)
sem_Names_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _hd_constructors_collect,_hd_fullName,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self) =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_lhs_local) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_Names_Nil :: (T_Names)
sem_Names_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])
-- PBind -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : PBind

-}
{-
   local variables for PBind.PBind:

-}
-- semantic domain
type T_PBind = (Maybe QualName) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (Bool) ->
               (Bool) ->
               (Bool) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (FMap Modid [QualName]) ->
               (FMap Modid [QualName]) ->
               (NameType) ->
               (Bool) ->
               ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(PBind))
-- cata
sem_PBind :: (PBind) ->
             (T_PBind)
sem_PBind ((PBind_PBind (_field) (_pattern))) =
    (sem_PBind_PBind ((sem_QualName (_field))) ((sem_Pattern (_pattern))))
sem_PBind_PBind :: (T_QualName) ->
                   (T_Pattern) ->
                   (T_PBind)
sem_PBind_PBind (_field) (_pattern) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _field_constructors_collect,_field_entityName,_field_fullName,_field_knownKinds_collect,_field_knownTypes_collect,_field_knownValues_collect,_field_methods_collect,_field_moduleTypes,_field_moduleValues,_field_modules,_field_res,_field_self,_field_self') =
            (_field (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Val) (_lhs_toplevel))
        ( _pattern_constructors_collect,_pattern_knownKinds_collect,_pattern_knownTypes_collect,_pattern_knownValues_collect,_pattern_methods_collect,_pattern_moduleTypes,_pattern_moduleValues,_pattern_modules,_pattern_res,_pattern_self) =
            (_pattern (_lhs_classname) (_field_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_field_knownKinds_collect) (_lhs_knownTypes) (_field_knownTypes_collect) (_lhs_knownValues) (_field_knownValues_collect) (_lhs_local) (_field_methods_collect) (_lhs_methods_dist) (_field_moduleTypes) (_field_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_pattern_constructors_collect,_pattern_knownKinds_collect,_pattern_knownTypes_collect,_pattern_knownValues_collect,_pattern_methods_collect,_pattern_moduleTypes,_pattern_moduleValues,_field_modules `Set.union` _pattern_modules,_field_res ++ _pattern_res,PBind_PBind _field_self _pattern_self)
-- PBinds ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : PBinds

-}
{-
   local variables for PBinds.Cons:

-}
{-
   local variables for PBinds.Nil:

-}
-- semantic domain
type T_PBinds = (Maybe QualName) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Modid) ->
                (Bool) ->
                (Bool) ->
                (Bool) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (Bool) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (FMap Modid [QualName]) ->
                (FMap Modid [QualName]) ->
                (NameType) ->
                (Bool) ->
                ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(PBinds))
-- cata
sem_PBinds :: (PBinds) ->
              (T_PBinds)
sem_PBinds (list) =
    (foldr (sem_PBinds_Cons) (sem_PBinds_Nil) ((map sem_PBind list)))
sem_PBinds_Cons :: (T_PBind) ->
                   (T_PBinds) ->
                   (T_PBinds)
sem_PBinds_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _hd_constructors_collect,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self) =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_lhs_local) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_PBinds_Nil :: (T_PBinds)
sem_PBinds_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])
-- PTS ---------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : PTS

-}
{-
   local variables for PTS.PTS:

-}
-- semantic domain
type T_PTS = (Maybe QualName) ->
             (FMap QualName QualNames) ->
             (FMap QualName QualNames) ->
             (Modid) ->
             (Bool) ->
             (Bool) ->
             (Bool) ->
             (FMap QualName [Entity]) ->
             (FMap QualName [Entity]) ->
             (FMap QualName [Entity]) ->
             (FMap QualName [Entity]) ->
             (FMap QualName [Entity]) ->
             (FMap QualName [Entity]) ->
             (Bool) ->
             (FMap QualName QualNames) ->
             (FMap QualName QualNames) ->
             (FMap Modid [QualName]) ->
             (FMap Modid [QualName]) ->
             (NameType) ->
             (Bool) ->
             ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(PTS))
-- cata
sem_PTS :: (PTS) ->
           (T_PTS)
sem_PTS ((PTS_PTS (_tpvar) (_kind) (_tp))) =
    (sem_PTS_PTS ((sem_QualName (_tpvar))) ((sem_Kind (_kind))) ((sem_QualType (_tp))))
sem_PTS_PTS :: (T_QualName) ->
               (T_Kind) ->
               (T_QualType) ->
               (T_PTS)
sem_PTS_PTS (_tpvar) (_kind) (_tp) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _tpvar_constructors_collect,_tpvar_entityName,_tpvar_fullName,_tpvar_knownKinds_collect,_tpvar_knownTypes_collect,_tpvar_knownValues_collect,_tpvar_methods_collect,_tpvar_moduleTypes,_tpvar_moduleValues,_tpvar_modules,_tpvar_res,_tpvar_self,_tpvar_self') =
            (_tpvar (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (emptyFM) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Def_Typ) (_lhs_toplevel))
        ( _kind_constructors_collect,_kind_knownKinds_collect,_kind_knownTypes_collect,_kind_knownValues_collect,_kind_methods_collect,_kind_moduleTypes,_kind_moduleValues,_kind_modules,_kind_res,_kind_self) =
            (_kind (_lhs_classname) (_tpvar_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (emptyFM) (_lhs_knownTypes) (_tpvar_knownTypes_collect) (_lhs_knownValues) (_tpvar_knownValues_collect) (_lhs_local) (_tpvar_methods_collect) (_lhs_methods_dist) (_tpvar_moduleTypes) (_tpvar_moduleValues) (Def_Kind) (_lhs_toplevel))
        ( _tp_constructors_collect,_tp_knownKinds_collect,_tp_knownTypes_collect,_tp_knownValues_collect,_tp_methods_collect,_tp_moduleTypes,_tp_moduleValues,_tp_modules,_tp_res,_tp_self) =
            (_tp (_lhs_classname)
                 (_kind_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_importedModule)
                 (_lhs_ininstance)
                 (_lhs_intitype)
                 (_kind_knownKinds_collect `mergeFM` _lhs_knownKinds)
                 (_kind_knownKinds_collect)
                 (_tpvar_knownTypes_collect `mergeFM` _lhs_knownTypes)
                 (_kind_knownTypes_collect)
                 (_lhs_knownValues)
                 (_kind_knownValues_collect)
                 (_lhs_local)
                 (_kind_methods_collect)
                 (_lhs_methods_dist)
                 (_kind_moduleTypes)
                 (_kind_moduleValues)
                 (_lhs_nameType)
                 (_lhs_toplevel))
    in  (_tp_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_tp_knownValues_collect,_tp_methods_collect,_tp_moduleTypes,_tp_moduleValues,_tpvar_modules `Set.union` _kind_modules `Set.union` _tp_modules,_tpvar_res ++ _kind_res ++ _tp_res,PTS_PTS _tpvar_self _kind_self _tp_self)
-- Pattern -----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Pattern

-}
{-
   local variables for Pattern.As:

-}
{-
   local variables for Pattern.Con:

-}
{-
   local variables for Pattern.Irr:

-}
{-
   local variables for Pattern.Lab:

-}
{-
   local variables for Pattern.List:

-}
{-
   local variables for Pattern.Lit:

-}
{-
   local variables for Pattern.Negate:

-}
{-
   local variables for Pattern.OpApp:

-}
{-
   local variables for Pattern.Parens:

-}
{-
   local variables for Pattern.Tuple:

-}
{-
   local variables for Pattern.Var:

-}
{-
   local variables for Pattern.Wild:

-}
-- semantic domain
type T_Pattern = (Maybe QualName) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (Modid) ->
                 (Bool) ->
                 (Bool) ->
                 (Bool) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (FMap QualName [Entity]) ->
                 (Bool) ->
                 (FMap QualName QualNames) ->
                 (FMap QualName QualNames) ->
                 (FMap Modid [QualName]) ->
                 (FMap Modid [QualName]) ->
                 (NameType) ->
                 (Bool) ->
                 ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Pattern))
-- cata
sem_Pattern :: (Pattern) ->
               (T_Pattern)
sem_Pattern ((Pattern_As (_name) (_pattern))) =
    (sem_Pattern_As ((sem_QualName (_name))) ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_Con (_name) (_args))) =
    (sem_Pattern_Con ((sem_QualName (_name))) ((sem_Patterns (_args))))
sem_Pattern ((Pattern_Irr (_pattern))) =
    (sem_Pattern_Irr ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_Lab (_name) (_pbinds))) =
    (sem_Pattern_Lab ((sem_QualName (_name))) ((sem_PBinds (_pbinds))))
sem_Pattern ((Pattern_List (_patterns))) =
    (sem_Pattern_List ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_Lit (_name))) =
    (sem_Pattern_Lit ((sem_Literal (_name))))
sem_Pattern ((Pattern_Negate (_pattern))) =
    (sem_Pattern_Negate ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_OpApp (_op) (_left) (_right))) =
    (sem_Pattern_OpApp ((sem_QualName (_op))) ((sem_Pattern (_left))) ((sem_Pattern (_right))))
sem_Pattern ((Pattern_Parens (_pattern))) =
    (sem_Pattern_Parens ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_Tuple (_patterns))) =
    (sem_Pattern_Tuple ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_Var (_name))) =
    (sem_Pattern_Var ((sem_QualName (_name))))
sem_Pattern ((Pattern_Wild )) =
    (sem_Pattern_Wild )
sem_Pattern_As :: (T_QualName) ->
                  (T_Pattern) ->
                  (T_Pattern)
sem_Pattern_As (_name) (_pattern) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Def_Val) (_lhs_toplevel))
        ( _pattern_constructors_collect,_pattern_knownKinds_collect,_pattern_knownTypes_collect,_pattern_knownValues_collect,_pattern_methods_collect,_pattern_moduleTypes,_pattern_moduleValues,_pattern_modules,_pattern_res,_pattern_self) =
            (_pattern (_lhs_classname) (_name_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_name_knownKinds_collect) (_lhs_knownTypes) (_name_knownTypes_collect) (_lhs_knownValues) (_name_knownValues_collect) (_lhs_local) (_name_methods_collect) (_lhs_methods_dist) (_name_moduleTypes) (_name_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_pattern_constructors_collect,_pattern_knownKinds_collect,_pattern_knownTypes_collect,_pattern_knownValues_collect,_pattern_methods_collect,_pattern_moduleTypes,_pattern_moduleValues,_name_modules `Set.union` _pattern_modules,_name_res ++ _pattern_res,Pattern_As  _name_self _pattern_self)
sem_Pattern_Con :: (T_QualName) ->
                   (T_Patterns) ->
                   (T_Pattern)
sem_Pattern_Con (_name) (_args) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Val) (_lhs_toplevel))
        ( _args_constructors_collect,_args_knownKinds_collect,_args_knownTypes_collect,_args_knownValues_collect,_args_methods_collect,_args_moduleTypes,_args_moduleValues,_args_modules,_args_res,_args_self) =
            (_args (_lhs_classname) (_name_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_name_knownKinds_collect) (_lhs_knownTypes) (_name_knownTypes_collect) (_lhs_knownValues) (_name_knownValues_collect) (_lhs_local) (_name_methods_collect) (_lhs_methods_dist) (_name_moduleTypes) (_name_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_args_constructors_collect,_args_knownKinds_collect,_args_knownTypes_collect,_args_knownValues_collect,_args_methods_collect,_args_moduleTypes,_args_moduleValues,_name_modules `Set.union` _args_modules,_name_res ++ _args_res,Pattern_Con _name_self _args_self)
sem_Pattern_Irr :: (T_Pattern) ->
                   (T_Pattern)
sem_Pattern_Irr (_pattern) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _pattern_constructors_collect,_pattern_knownKinds_collect,_pattern_knownTypes_collect,_pattern_knownValues_collect,_pattern_methods_collect,_pattern_moduleTypes,_pattern_moduleValues,_pattern_modules,_pattern_res,_pattern_self) =
            (_pattern (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_pattern_constructors_collect,_pattern_knownKinds_collect,_pattern_knownTypes_collect,_pattern_knownValues_collect,_pattern_methods_collect,_pattern_moduleTypes,_pattern_moduleValues,_pattern_modules,_pattern_res,Pattern_Irr _pattern_self)
sem_Pattern_Lab :: (T_QualName) ->
                   (T_PBinds) ->
                   (T_Pattern)
sem_Pattern_Lab (_name) (_pbinds) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Val) (_lhs_toplevel))
        ( _pbinds_constructors_collect,_pbinds_knownKinds_collect,_pbinds_knownTypes_collect,_pbinds_knownValues_collect,_pbinds_methods_collect,_pbinds_moduleTypes,_pbinds_moduleValues,_pbinds_modules,_pbinds_res,_pbinds_self) =
            (_pbinds (_lhs_classname) (_name_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_name_knownKinds_collect) (_lhs_knownTypes) (_name_knownTypes_collect) (_lhs_knownValues) (_name_knownValues_collect) (_lhs_local) (_name_methods_collect) (_lhs_methods_dist) (_name_moduleTypes) (_name_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_pbinds_constructors_collect,_pbinds_knownKinds_collect,_pbinds_knownTypes_collect,_pbinds_knownValues_collect,_pbinds_methods_collect,_pbinds_moduleTypes,_pbinds_moduleValues,_name_modules `Set.union` _pbinds_modules,_name_res ++ _pbinds_res,Pattern_Lab _name_self _pbinds_self)
sem_Pattern_List :: (T_Patterns) ->
                    (T_Pattern)
sem_Pattern_List (_patterns) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _patterns_constructors_collect,_patterns_knownKinds_collect,_patterns_knownTypes_collect,_patterns_knownValues_collect,_patterns_methods_collect,_patterns_moduleTypes,_patterns_moduleValues,_patterns_modules,_patterns_res,_patterns_self) =
            (_patterns (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_patterns_constructors_collect,_patterns_knownKinds_collect,_patterns_knownTypes_collect,_patterns_knownValues_collect,_patterns_methods_collect,_patterns_moduleTypes,_patterns_moduleValues,_patterns_modules,_patterns_res,Pattern_List  _patterns_self)
sem_Pattern_Lit :: (T_Literal) ->
                   (T_Pattern)
sem_Pattern_Lit (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _name_constructors_collect,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self) =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_name_constructors_collect,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,Pattern_Lit _name_self)
sem_Pattern_Negate :: (T_Pattern) ->
                      (T_Pattern)
sem_Pattern_Negate (_pattern) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _pattern_constructors_collect,_pattern_knownKinds_collect,_pattern_knownTypes_collect,_pattern_knownValues_collect,_pattern_methods_collect,_pattern_moduleTypes,_pattern_moduleValues,_pattern_modules,_pattern_res,_pattern_self) =
            (_pattern (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_pattern_constructors_collect,_pattern_knownKinds_collect,_pattern_knownTypes_collect,_pattern_knownValues_collect,_pattern_methods_collect,_pattern_moduleTypes,_pattern_moduleValues,_pattern_modules,_pattern_res,Pattern_Negate _pattern_self)
sem_Pattern_OpApp :: (T_QualName) ->
                     (T_Pattern) ->
                     (T_Pattern) ->
                     (T_Pattern)
sem_Pattern_OpApp (_op) (_left) (_right) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _op_constructors_collect,_op_entityName,_op_fullName,_op_knownKinds_collect,_op_knownTypes_collect,_op_knownValues_collect,_op_methods_collect,_op_moduleTypes,_op_moduleValues,_op_modules,_op_res,_op_self,_op_self') =
            (_op (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Val) (_lhs_toplevel))
        ( _left_constructors_collect,_left_knownKinds_collect,_left_knownTypes_collect,_left_knownValues_collect,_left_methods_collect,_left_moduleTypes,_left_moduleValues,_left_modules,_left_res,_left_self) =
            (_left (_lhs_classname) (_op_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_op_knownKinds_collect) (_lhs_knownTypes) (_op_knownTypes_collect) (_lhs_knownValues) (_op_knownValues_collect) (_lhs_local) (_op_methods_collect) (_lhs_methods_dist) (_op_moduleTypes) (_op_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _right_constructors_collect,_right_knownKinds_collect,_right_knownTypes_collect,_right_knownValues_collect,_right_methods_collect,_right_moduleTypes,_right_moduleValues,_right_modules,_right_res,_right_self) =
            (_right (_lhs_classname) (_left_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_left_knownKinds_collect) (_lhs_knownTypes) (_left_knownTypes_collect) (_lhs_knownValues) (_left_knownValues_collect) (_lhs_local) (_left_methods_collect) (_lhs_methods_dist) (_left_moduleTypes) (_left_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_right_constructors_collect
        ,_right_knownKinds_collect
        ,_right_knownTypes_collect
        ,_right_knownValues_collect
        ,_right_methods_collect
        ,_right_moduleTypes
        ,_right_moduleValues
        ,_op_modules `Set.union` _left_modules `Set.union` _right_modules
        ,_op_res ++ _left_res ++ _right_res
        ,Pattern_OpApp _op_self _left_self
                                _right_self
        )
sem_Pattern_Parens :: (T_Pattern) ->
                      (T_Pattern)
sem_Pattern_Parens (_pattern) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _pattern_constructors_collect,_pattern_knownKinds_collect,_pattern_knownTypes_collect,_pattern_knownValues_collect,_pattern_methods_collect,_pattern_moduleTypes,_pattern_moduleValues,_pattern_modules,_pattern_res,_pattern_self) =
            (_pattern (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_pattern_constructors_collect,_pattern_knownKinds_collect,_pattern_knownTypes_collect,_pattern_knownValues_collect,_pattern_methods_collect,_pattern_moduleTypes,_pattern_moduleValues,_pattern_modules,_pattern_res,Pattern_Parens _pattern_self)
sem_Pattern_Tuple :: (T_Patterns) ->
                     (T_Pattern)
sem_Pattern_Tuple (_patterns) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _patterns_constructors_collect,_patterns_knownKinds_collect,_patterns_knownTypes_collect,_patterns_knownValues_collect,_patterns_methods_collect,_patterns_moduleTypes,_patterns_moduleValues,_patterns_modules,_patterns_res,_patterns_self) =
            (_patterns (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_patterns_constructors_collect,_patterns_knownKinds_collect,_patterns_knownTypes_collect,_patterns_knownValues_collect,_patterns_methods_collect,_patterns_moduleTypes,_patterns_moduleValues,_patterns_modules,_patterns_res,Pattern_Tuple _patterns_self)
sem_Pattern_Var :: (T_QualName) ->
                   (T_Pattern)
sem_Pattern_Var (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Def_Val) (_lhs_toplevel))
    in  (_name_constructors_collect,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,Pattern_Var _name_self)
sem_Pattern_Wild :: (T_Pattern)
sem_Pattern_Wild (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],Pattern_Wild)
-- Patterns ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Patterns

-}
{-
   local variables for Patterns.Cons:

-}
{-
   local variables for Patterns.Nil:

-}
-- semantic domain
type T_Patterns = (Maybe QualName) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Modid) ->
                  (Bool) ->
                  (Bool) ->
                  (Bool) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (Bool) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (FMap Modid [QualName]) ->
                  (FMap Modid [QualName]) ->
                  (NameType) ->
                  (Bool) ->
                  ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Patterns))
-- cata
sem_Patterns :: (Patterns) ->
                (T_Patterns)
sem_Patterns (list) =
    (foldr (sem_Patterns_Cons) (sem_Patterns_Nil) ((map sem_Pattern list)))
sem_Patterns_Cons :: (T_Pattern) ->
                     (T_Patterns) ->
                     (T_Patterns)
sem_Patterns_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _hd_constructors_collect,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self) =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_lhs_local) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_Patterns_Nil :: (T_Patterns)
sem_Patterns_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])
-- Position ----------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Position

-}
{-
   local variables for Position.Position:

-}
{-
   local variables for Position.Unknown:

-}
-- semantic domain
type T_Position = ((Position))
-- cata
sem_Position :: (Position) ->
                (T_Position)
sem_Position ((Position_Position (_filename) (_line) (_column))) =
    (sem_Position_Position (_filename) (_line) (_column))
sem_Position ((Position_Unknown )) =
    (sem_Position_Unknown )
sem_Position_Position :: (String) ->
                         (Int) ->
                         (Int) ->
                         (T_Position)
sem_Position_Position (_filename) (_line) (_column) =
    let 
    in  (Position_Position _filename _line _column)
sem_Position_Unknown :: (T_Position)
sem_Position_Unknown  =
    let 
    in  (Position_Unknown)
-- Qual --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Qual

-}
{-
   local variables for Qual.Empty:

-}
{-
   local variables for Qual.Gen:

-}
{-
   local variables for Qual.Guard:

-}
{-
   local variables for Qual.Let:

-}
-- semantic domain
type T_Qual = (Maybe QualName) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Modid) ->
              (Bool) ->
              (Bool) ->
              (Bool) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (Bool) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (FMap Modid [QualName]) ->
              (FMap Modid [QualName]) ->
              (NameType) ->
              (Bool) ->
              ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Qual))
-- cata
sem_Qual :: (Qual) ->
            (T_Qual)
sem_Qual ((Qual_Empty )) =
    (sem_Qual_Empty )
sem_Qual ((Qual_Gen (_pattern) (_body))) =
    (sem_Qual_Gen ((sem_Pattern (_pattern))) ((sem_Expr (_body))))
sem_Qual ((Qual_Guard (_expr))) =
    (sem_Qual_Guard ((sem_Expr (_expr))))
sem_Qual ((Qual_Let (_decls))) =
    (sem_Qual_Let ((sem_SDecls (_decls))))
sem_Qual_Empty :: (T_Qual)
sem_Qual_Empty (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],Qual_Empty)
sem_Qual_Gen :: (T_Pattern) ->
                (T_Expr) ->
                (T_Qual)
sem_Qual_Gen (_pattern) (_body) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _pattern_constructors_collect,_pattern_knownKinds_collect,_pattern_knownTypes_collect,_pattern_knownValues_collect,_pattern_methods_collect,_pattern_moduleTypes,_pattern_moduleValues,_pattern_modules,_pattern_res,_pattern_self) =
            (_pattern (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _body_constructors_collect,_body_knownKinds_collect,_body_knownTypes_collect,_body_knownValues_collect,_body_methods_collect,_body_moduleTypes,_body_moduleValues,_body_modules,_body_res,_body_self) =
            (_body (_lhs_classname)
                   (_pattern_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_importedModule)
                   (_lhs_ininstance)
                   (_lhs_intitype)
                   (_lhs_knownKinds)
                   (_pattern_knownKinds_collect)
                   (_lhs_knownTypes)
                   (_pattern_knownTypes_collect)
                   (_lhs_knownValues)
                   (_pattern_knownValues_collect)
                   (_lhs_local)
                   (_pattern_methods_collect)
                   (_lhs_methods_dist)
                   (_pattern_moduleTypes)
                   (_pattern_moduleValues)
                   (_lhs_nameType)
                   (_lhs_toplevel))
    in  (_body_constructors_collect,_body_knownKinds_collect,_body_knownTypes_collect,_body_knownValues_collect,_body_methods_collect,_body_moduleTypes,_body_moduleValues,_pattern_modules `Set.union` _body_modules,_pattern_res ++ _body_res,Qual_Gen _pattern_self _body_self)
sem_Qual_Guard :: (T_Expr) ->
                  (T_Qual)
sem_Qual_Guard (_expr) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _expr_constructors_collect,_expr_knownKinds_collect,_expr_knownTypes_collect,_expr_knownValues_collect,_expr_methods_collect,_expr_moduleTypes,_expr_moduleValues,_expr_modules,_expr_res,_expr_self) =
            (_expr (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_expr_constructors_collect,_expr_knownKinds_collect,_expr_knownTypes_collect,_expr_knownValues_collect,_expr_methods_collect,_expr_moduleTypes,_expr_moduleValues,_expr_modules,_expr_res,Qual_Guard _expr_self)
sem_Qual_Let :: (T_SDecls) ->
                (T_Qual)
sem_Qual_Let (_decls) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _decls_constructors_collect,_decls_knownKinds_collect,_decls_knownTypes_collect,_decls_knownValues_collect,_decls_methods_collect,_decls_moduleTypes,_decls_moduleValues,_decls_modules,_decls_res,_decls_self) =
            (_decls (_lhs_classname)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_importedModule)
                    (_lhs_ininstance)
                    (_lhs_intitype)
                    (_lhs_knownKinds)
                    (_lhs_knownKinds_collect)
                    (_lhs_knownTypes)
                    (_lhs_knownTypes_collect)
                    (_decls_knownValues_collect `mergeFM` _lhs_knownValues)
                    (_lhs_knownValues_collect)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_moduleTypes)
                    (_lhs_moduleValues)
                    (_lhs_nameType)
                    (_lhs_toplevel))
    in  (_decls_constructors_collect,_decls_knownKinds_collect,_decls_knownTypes_collect,_decls_knownValues_collect,_decls_methods_collect,_decls_moduleTypes,_decls_moduleValues,_decls_modules,_decls_res,Qual_Let _decls_self)
-- QualName ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      entityName           : Entity
      fullName             : QualName
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : QualName
      self'                : QualName

-}
{-
   local variables for QualName.Entity:
      entityName
      fullName
      self

-}
{-
   local variables for QualName.Plain:
      r_ref
      entityName_ref
      r_def
      entityName_def
      modid_def
      refEnvironment
      res
      entityName
      fullName
      self'
      self

-}
{-
   local variables for QualName.Qual:
      r_ref
      entityName_ref
      r_def
      entityName_def
      refEnvironment
      res
      entityName
      fullName
      self'
      self

-}
-- semantic domain
type T_QualName = (Maybe QualName) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Modid) ->
                  (Bool) ->
                  (Bool) ->
                  (Bool) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (Bool) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (FMap Modid [QualName]) ->
                  (FMap Modid [QualName]) ->
                  (NameType) ->
                  (Bool) ->
                  ((FMap QualName QualNames),(Entity),(QualName),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(QualName),(QualName))
-- cata
sem_QualName :: (QualName) ->
                (T_QualName)
sem_QualName ((QualName_Entity (_range) (_entity) (_inscope))) =
    (sem_QualName_Entity ((sem_Range (_range))) ((sem_Entity (_entity))) (_inscope))
sem_QualName ((QualName_Plain (_range) (_name))) =
    (sem_QualName_Plain ((sem_Range (_range))) ((sem_Name (_name))))
sem_QualName ((QualName_Qual (_range) (_modid) (_name))) =
    (sem_QualName_Qual ((sem_Range (_range))) (_modid) ((sem_Name (_name))))
sem_QualName_Entity :: (T_Range) ->
                       (T_Entity) ->
                       (Maybe QualName) ->
                       (T_QualName)
sem_QualName_Entity (_range)
                    (_entity)
                    (_inscope)
                    (_lhs_classname)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_importedModule)
                    (_lhs_ininstance)
                    (_lhs_intitype)
                    (_lhs_knownKinds)
                    (_lhs_knownKinds_collect)
                    (_lhs_knownTypes)
                    (_lhs_knownTypes_collect)
                    (_lhs_knownValues)
                    (_lhs_knownValues_collect)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_moduleTypes)
                    (_lhs_moduleValues)
                    (_lhs_nameType)
                    (_lhs_toplevel) =
    let (_self) =
            QualName_Entity _range_self _entity_self _inscope
        (_fullName) =
            internalError "Names.QualName.Entity.fullName: not used"
        (_entityName) =
            internalError "Names.QualName.Entity.entityName: not used"
        ( _range_self) =
            (_range )
        ( _entity_constructors_collect,_entity_knownKinds_collect,_entity_knownTypes_collect,_entity_knownValues_collect,_entity_methods_collect,_entity_moduleTypes,_entity_moduleValues,_entity_modules,_entity_res,_entity_self) =
            (_entity (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_entity_constructors_collect,_entityName,_fullName,_entity_knownKinds_collect,_entity_knownTypes_collect,_entity_knownValues_collect,_entity_methods_collect,_entity_moduleTypes,_entity_moduleValues,_entity_modules,_entity_res,_self,internalError "Names.QualName.Entity.self': not used")
sem_QualName_Plain :: (T_Range) ->
                      (T_Name) ->
                      (T_QualName)
sem_QualName_Plain (_range) (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            if   _lhs_nameType /= NameType_None
            then QualName_Entity _range_self _entityName (if _lhs_local then (Just _self') else Nothing)
            else _self'
        (_self') =
            QualName_Plain _range_self _name_self
        (_fullName) =
            _name_fullName
        ((_entityName,_res)) =
            if   isDef _lhs_nameType
            then (_entityName_def,_r_def)
            else if   isRef _lhs_nameType
                 then (_entityName_ref,_r_ref)
                 else (internalError $
                         "Names.QualName.Qual.refEnvironment: non-resolved name used `" ++ show _self' ++ "'"
                      ,[]
                      )
        (_refEnvironment) =
            case _lhs_nameType of
              Ref_Val  -> _lhs_knownValues
              Ref_Typ  -> _lhs_knownTypes
              Ref_Kind -> _lhs_knownKinds
              _        -> internalError $
                            "Names.QualName.Plain.refEnvironment: definition treated as reference `" ++ show _self' ++ "'"
        (_modid_def) =
            if _lhs_toplevel then Just _lhs_currentModule else Nothing
        ((_entityName_def,_r_def)) =
            let new_entity = Entity_Entity _modid_def _name_self
            in  (new_entity,[Defined new_entity])
        ((_entityName_ref,_r_ref)) =
            if   _lhs_importedModule
            then (_entityName_def,[Resolved _self' _entityName_def])
            else let es = findL _refEnvironment _self'
                 in  case es of
                       [entity] -> (entity,[Resolved _self' entity])
                       []       -> (Entity_Entity Nothing _name_self
                                   ,[UnResolved _self' (domain _refEnvironment)
                                                (GHError_ResolveError _range_self _self')]
                                   )
                       _        -> (head es
                                   ,[UnResolved _self' (domain _refEnvironment)
                                                (GHError_NameClashError _range_self _self' es)]
                                   )
        ( _range_self) =
            (_range )
        ( _name_constructors_collect,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self) =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_name_constructors_collect
        ,_entityName
        ,_name_fullName
        ,case _lhs_nameType of
           Def_Kind -> foldl addLReplace _lhs_knownKinds_collect
                             [(_self'   ,[_entityName])
                             ,(_fullName,[_entityName])
                             ]
           _        -> _lhs_knownKinds_collect
        ,case _lhs_nameType of
           Def_Typ  -> foldl addLReplace _lhs_knownTypes_collect
                             [(_self'   ,[_entityName])
                             ,(_fullName,[_entityName])
                             ]
           _        -> _lhs_knownTypes_collect
        ,case _lhs_nameType of
           Def_Val  -> foldl addLReplace _lhs_knownValues_collect
                             [(_self'   ,[_entityName])
                             ,(_fullName,[_entityName])
                             ]
           _        -> _lhs_knownValues_collect
        ,_name_methods_collect
        ,_name_moduleTypes
        ,_name_moduleValues
        ,if   _lhs_importedModule && isDef _lhs_nameType
         then Set.unitSet _lhs_currentModule
         else Set.emptySet
        ,_res
        ,_self
        ,_self'
        )
sem_QualName_Qual :: (T_Range) ->
                     (Modid) ->
                     (T_Name) ->
                     (T_QualName)
sem_QualName_Qual (_range)
                  (_modid)
                  (_name)
                  (_lhs_classname)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_importedModule)
                  (_lhs_ininstance)
                  (_lhs_intitype)
                  (_lhs_knownKinds)
                  (_lhs_knownKinds_collect)
                  (_lhs_knownTypes)
                  (_lhs_knownTypes_collect)
                  (_lhs_knownValues)
                  (_lhs_knownValues_collect)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_moduleTypes)
                  (_lhs_moduleValues)
                  (_lhs_nameType)
                  (_lhs_toplevel) =
    let (_self) =
            if   _lhs_nameType /= NameType_None
            then QualName_Entity _range_self _entityName (if _lhs_local then (Just _self') else Nothing)
            else _self'
        (_self') =
            QualName_Qual _range_self _modid _name_self
        (_fullName) =
            _self'
        ((_entityName,_res)) =
            if   isDef _lhs_nameType
            then (_entityName_def,_r_def)
            else if   isRef _lhs_nameType
                 then (_entityName_ref,_r_ref)
                 else (internalError $
                         "Names.QualName.Qual.refEnvironment: non-resolved name used `" ++ show _self' ++ "'"
                      ,[]
                      )
        (_refEnvironment) =
            case _lhs_nameType of
              Ref_Val  -> _lhs_knownValues
              Ref_Typ  -> _lhs_knownTypes
              Ref_Kind -> _lhs_knownKinds
              _        -> internalError $
                            "Names.QualName.Qual.refEnvironment: definition treated as reference `" ++ show _self' ++ "'"
        ((_entityName_def,_r_def)) =
            let new_entity = Entity_Entity (Just _modid) _name_self
            in  (new_entity,[Defined new_entity])
        ((_entityName_ref,_r_ref)) =
            if   _lhs_importedModule
            then (_entityName_def,[Resolved _self' _entityName_def])
            else let es = findL _refEnvironment _self'
                 in  case es of
                       [entity] -> (entity,[Resolved _self' entity])
                       []       -> (unstaticError "Names.QualName.Qual.entityName_ref: name not in scope"
                                   ,[UnResolved _self' (domain _refEnvironment)
                                                (GHError_ResolveError _range_self _self')]
                                   )
                       _        -> (unstaticError "Names.QualName.Qual.entityName_ref: name clash"
                                   ,[UnResolved _self' (domain _refEnvironment)
                                                (GHError_NameClashError _range_self _self' es)]
                                   )
        ( _range_self) =
            (_range )
        ( _name_constructors_collect,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self) =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_name_constructors_collect
        ,_entityName
        ,_name_fullName
        ,case _lhs_nameType of
           Def_Kind -> foldl addLReplace _lhs_knownKinds_collect
                             [(_self'   ,[_entityName])
                             ,(_fullName,[_entityName])
                             ]
           _        -> _lhs_knownKinds_collect
        ,case _lhs_nameType of
           Def_Typ  -> foldl addLReplace _lhs_knownTypes_collect
                             [(_self'   ,[_entityName])
                             ,(_fullName,[_entityName])
                             ]
           _        -> _lhs_knownTypes_collect
        ,case _lhs_nameType of
           Def_Val  -> foldl addLReplace _lhs_knownValues_collect
                             [(_self'   ,[_entityName])
                             ,(_fullName,[_entityName])
                             ]
           _        -> _lhs_knownValues_collect
        ,_name_methods_collect
        ,_name_moduleTypes
        ,_name_moduleValues
        ,if   _lhs_importedModule
         then Set.unitSet _modid
         else Set.emptySet
        ,_res
        ,_self
        ,_self'
        )
-- QualNames ---------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : QualNames
      self'                : QualNames

-}
{-
   local variables for QualNames.Cons:

-}
{-
   local variables for QualNames.Nil:

-}
-- semantic domain
type T_QualNames = (Maybe QualName) ->
                   (FMap QualName QualNames) ->
                   (FMap QualName QualNames) ->
                   (Modid) ->
                   (Bool) ->
                   (Bool) ->
                   (Bool) ->
                   (FMap QualName [Entity]) ->
                   (FMap QualName [Entity]) ->
                   (FMap QualName [Entity]) ->
                   (FMap QualName [Entity]) ->
                   (FMap QualName [Entity]) ->
                   (FMap QualName [Entity]) ->
                   (Bool) ->
                   (FMap QualName QualNames) ->
                   (FMap QualName QualNames) ->
                   (FMap Modid [QualName]) ->
                   (FMap Modid [QualName]) ->
                   (NameType) ->
                   (Bool) ->
                   ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(QualNames),(QualNames))
-- cata
sem_QualNames :: (QualNames) ->
                 (T_QualNames)
sem_QualNames (list) =
    (foldr (sem_QualNames_Cons) (sem_QualNames_Nil) ((map sem_QualName list)))
sem_QualNames_Cons :: (T_QualName) ->
                      (T_QualNames) ->
                      (T_QualNames)
sem_QualNames_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _hd_constructors_collect,_hd_entityName,_hd_fullName,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self,_hd_self') =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self,_tl_self') =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_lhs_local) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self,_hd_self' : _tl_self')
sem_QualNames_Nil :: (T_QualNames)
sem_QualNames_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[],[])
-- QualType ----------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : QualType

-}
{-
   local variables for QualType.QualType:

-}
-- semantic domain
type T_QualType = (Maybe QualName) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (Modid) ->
                  (Bool) ->
                  (Bool) ->
                  (Bool) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (FMap QualName [Entity]) ->
                  (Bool) ->
                  (FMap QualName QualNames) ->
                  (FMap QualName QualNames) ->
                  (FMap Modid [QualName]) ->
                  (FMap Modid [QualName]) ->
                  (NameType) ->
                  (Bool) ->
                  ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(QualType))
-- cata
sem_QualType :: (QualType) ->
                (T_QualType)
sem_QualType ((QualType_QualType (_context) (_tp))) =
    (sem_QualType_QualType ((sem_Context (_context))) ((sem_Type (_tp))))
sem_QualType_QualType :: (T_Context) ->
                         (T_Type) ->
                         (T_QualType)
sem_QualType_QualType (_context) (_tp) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _context_constructors_collect,_context_knownKinds_collect,_context_knownTypes_collect,_context_knownValues_collect,_context_methods_collect,_context_moduleTypes,_context_moduleValues,_context_modules,_context_res,_context_self) =
            (_context (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tp_constructors_collect,_tp_knownKinds_collect,_tp_knownTypes_collect,_tp_knownValues_collect,_tp_methods_collect,_tp_moduleTypes,_tp_moduleValues,_tp_modules,_tp_res,_tp_self) =
            (_tp (_lhs_classname)
                 (_context_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_importedModule)
                 (_lhs_ininstance)
                 (_lhs_intitype)
                 (_lhs_knownKinds)
                 (_context_knownKinds_collect)
                 (_lhs_knownTypes)
                 (_context_knownTypes_collect)
                 (_lhs_knownValues)
                 (_context_knownValues_collect)
                 (_lhs_local)
                 (_context_methods_collect)
                 (_lhs_methods_dist)
                 (_context_moduleTypes)
                 (_context_moduleValues)
                 (_lhs_nameType)
                 (_lhs_toplevel))
    in  (_tp_constructors_collect,_tp_knownKinds_collect,_tp_knownTypes_collect,_tp_knownValues_collect,_tp_methods_collect,_tp_moduleTypes,_tp_moduleValues,_context_modules `Set.union` _tp_modules,_context_res ++ _tp_res,QualType_QualType _context_self _tp_self)
-- Quals -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Quals

-}
{-
   local variables for Quals.Cons:

-}
{-
   local variables for Quals.Nil:

-}
-- semantic domain
type T_Quals = (Maybe QualName) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (Bool) ->
               (Bool) ->
               (Bool) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (FMap Modid [QualName]) ->
               (FMap Modid [QualName]) ->
               (NameType) ->
               (Bool) ->
               ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Quals))
-- cata
sem_Quals :: (Quals) ->
             (T_Quals)
sem_Quals (list) =
    (foldr (sem_Quals_Cons) (sem_Quals_Nil) ((map sem_Qual list)))
sem_Quals_Cons :: (T_Qual) ->
                  (T_Quals) ->
                  (T_Quals)
sem_Quals_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _hd_constructors_collect,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self) =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (emptyFM) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_importedModule)
                 (_lhs_ininstance)
                 (_lhs_intitype)
                 (_lhs_knownKinds)
                 (_hd_knownKinds_collect)
                 (_lhs_knownTypes)
                 (_hd_knownTypes_collect)
                 (_hd_knownValues_collect `mergeFM` _lhs_knownValues)
                 (_hd_knownValues_collect)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_hd_moduleTypes)
                 (_hd_moduleValues)
                 (_lhs_nameType)
                 (_lhs_toplevel))
    in  (_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_Quals_Nil :: (T_Quals)
sem_Quals_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])
-- Range -------------------------------------------------------
{-
   inherited attributes:

   chained attributes:

   synthesised attributes:
      self                 : Range

-}
{-
   local variables for Range.Range:

-}
-- semantic domain
type T_Range = ((Range))
-- cata
sem_Range :: (Range) ->
             (T_Range)
sem_Range ((Range_Range (_start) (_stop))) =
    (sem_Range_Range ((sem_Position (_start))) ((sem_Position (_stop))))
sem_Range_Range :: (T_Position) ->
                   (T_Position) ->
                   (T_Range)
sem_Range_Range (_start) (_stop) =
    let ( _start_self) =
            (_start )
        ( _stop_self) =
            (_stop )
    in  (Range_Range _start_self _stop_self)
-- Rhs ---------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Rhs

-}
{-
   local variables for Rhs.Guarded:

-}
{-
   local variables for Rhs.Unguarded:

-}
-- semantic domain
type T_Rhs = (Maybe QualName) ->
             (FMap QualName QualNames) ->
             (FMap QualName QualNames) ->
             (Modid) ->
             (Bool) ->
             (Bool) ->
             (Bool) ->
             (FMap QualName [Entity]) ->
             (FMap QualName [Entity]) ->
             (FMap QualName [Entity]) ->
             (FMap QualName [Entity]) ->
             (FMap QualName [Entity]) ->
             (FMap QualName [Entity]) ->
             (Bool) ->
             (FMap QualName QualNames) ->
             (FMap QualName QualNames) ->
             (FMap Modid [QualName]) ->
             (FMap Modid [QualName]) ->
             (NameType) ->
             (Bool) ->
             ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Rhs))
-- cata
sem_Rhs :: (Rhs) ->
           (T_Rhs)
sem_Rhs ((Rhs_Guarded (_grds))) =
    (sem_Rhs_Guarded ((sem_GuardedRhss (_grds))))
sem_Rhs ((Rhs_Unguarded (_expr))) =
    (sem_Rhs_Unguarded ((sem_Expr (_expr))))
sem_Rhs_Guarded :: (T_GuardedRhss) ->
                   (T_Rhs)
sem_Rhs_Guarded (_grds) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _grds_constructors_collect,_grds_knownKinds_collect,_grds_knownTypes_collect,_grds_knownValues_collect,_grds_methods_collect,_grds_moduleTypes,_grds_moduleValues,_grds_modules,_grds_res,_grds_self) =
            (_grds (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_grds_constructors_collect,_grds_knownKinds_collect,_grds_knownTypes_collect,_grds_knownValues_collect,_grds_methods_collect,_grds_moduleTypes,_grds_moduleValues,_grds_modules,_grds_res,Rhs_Guarded _grds_self)
sem_Rhs_Unguarded :: (T_Expr) ->
                     (T_Rhs)
sem_Rhs_Unguarded (_expr) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _expr_constructors_collect,_expr_knownKinds_collect,_expr_knownTypes_collect,_expr_knownValues_collect,_expr_methods_collect,_expr_moduleTypes,_expr_moduleValues,_expr_modules,_expr_res,_expr_self) =
            (_expr (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_expr_constructors_collect,_expr_knownKinds_collect,_expr_knownTypes_collect,_expr_knownValues_collect,_expr_methods_collect,_expr_moduleTypes,_expr_moduleValues,_expr_modules,_expr_res,Rhs_Unguarded _expr_self)
-- Root --------------------------------------------------------
{-
   inherited attributes:
      in                   : Int

   chained attributes:

   synthesised attributes:
      out                  : (String,Bool,Root,Set QualName,Set QualName,[(Set QualName,Set QualName)],[(Set QualName,Set QualName)],Set Modid)

-}
{-
   local variables for Root.Root:
      moduleTypes
      moduleValues
      knownKinds
      knownTypes
      knownValues
      knownKinds_collect
      knownTypes_collect
      knownValues_collect
      stop
      errors
      replace
      out
      verbosity
      debug
      the_errors
      exportedTypes
      exportedValues

-}
-- semantic domain
type T_Root = (Int) ->
              (((String,Bool,Root,Set QualName,Set QualName,[(Set QualName,Set QualName)],[(Set QualName,Set QualName)],Set Modid)))
-- cata
sem_Root :: (Root) ->
            (T_Root)
sem_Root ((Root_Root (_contents))) =
    (sem_Root_Root ((sem_ModuleSystem (_contents))))
sem_Root_Root :: (T_ModuleSystem) ->
                 (T_Root)
sem_Root_Root (_contents) (_lhs_in) =
    let (_exportedValues) =
            selectEFromV _knownValues _knownTypes
                         _contents_exported
                         _contents_constructors_collect
                         _contents_methods_collect
        (_exportedTypes) =
            selectEFromT _knownTypes _contents_exported
        (_the_errors) =
            concatMap filterResolveError _contents_res
        (_debug) =
            concatMap filterMessages     _contents_res
        (_verbosity) =
            _lhs_in
        (_out) =
            (_errors,_stop,_replace
            ,_exportedValues,_exportedTypes
            ,_contents_importedEntities
            ,_contents_hiddenEntities
            ,_contents_modules)
        (_replace) =
            Root_Root _contents_replace
        (_errors) =
            concatMap (printErrorV _verbosity) _the_errors
             ++ if _verbosity >= 3 then _debug
                                   else ""
        (_stop) =
            or . map isError $ _the_errors
        (_knownValues_collect) =
            emptyFM
        (_knownTypes_collect) =
            emptyFM
        (_knownKinds_collect) =
            emptyFM
        (_knownValues) =
            _contents_knownValues_collect
        (_knownTypes) =
            _contents_knownTypes_collect
        (_knownKinds) =
            _contents_knownKinds_collect
        (_moduleValues) =
            emptyFM
        (_moduleTypes) =
            emptyFM
        ( _contents_compiledModule,_contents_constructors_collect,_contents_exported,_contents_hiddenEntities,_contents_importedEntities,_contents_knownKinds_collect,_contents_knownTypes_collect,_contents_knownValues_collect,_contents_methods_collect,_contents_moduleTypes,_contents_moduleValues,_contents_modules,_contents_replace,_contents_res,_contents_self) =
            (_contents (Nothing) (emptyFM) (_contents_constructors_collect) (False) (False) (False) (_knownKinds) (_knownKinds_collect) (_knownTypes) (_knownTypes_collect) (_knownValues) (_knownValues_collect) (emptyFM) (_contents_methods_collect) (_moduleTypes) (_moduleValues) (Def_Typ) (True))
    in  (_out)
-- SDecl -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : SDecl

-}
{-
   local variables for SDecl.Binding:
      self

-}
{-
   local variables for SDecl.Empty:
      self

-}
{-
   local variables for SDecl.Fixity:
      self

-}
{-
   local variables for SDecl.PatBinding:
      self
      knownValues

-}
{-
   local variables for SDecl.PolyBinding:
      self

-}
{-
   local variables for SDecl.PolyTypeSig:
      self

-}
{-
   local variables for SDecl.TypeSig:
      self

-}
-- semantic domain
type T_SDecl = (Maybe QualName) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (Bool) ->
               (Bool) ->
               (Bool) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (FMap Modid [QualName]) ->
               (FMap Modid [QualName]) ->
               (NameType) ->
               (Bool) ->
               ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(SDecl))
-- cata
sem_SDecl :: (SDecl) ->
             (T_SDecl)
sem_SDecl ((SDecl_Binding (_srcloc) (_name) (_bindings))) =
    (sem_SDecl_Binding ((sem_Position (_srcloc))) ((sem_QualName (_name))) ((sem_Bindings (_bindings))))
sem_SDecl ((SDecl_Empty )) =
    (sem_SDecl_Empty )
sem_SDecl ((SDecl_Fixity (_srcloc) (_inf) (_priority) (_ops))) =
    (sem_SDecl_Fixity ((sem_Position (_srcloc))) ((sem_Infix (_inf))) (_priority) ((sem_QualNames (_ops))))
sem_SDecl ((SDecl_PatBinding (_srcloc) (_pat) (_rhs) (_where))) =
    (sem_SDecl_PatBinding ((sem_Position (_srcloc))) ((sem_Pattern (_pat))) ((sem_Rhs (_rhs))) ((sem_SDecls (_where))))
sem_SDecl ((SDecl_PolyBinding (_srcloc) (_name) (_tp) (_bindings))) =
    (sem_SDecl_PolyBinding ((sem_Position (_srcloc))) ((sem_QualName (_name))) ((sem_SType (_tp))) ((sem_Bindings (_bindings))))
sem_SDecl ((SDecl_PolyTypeSig (_srcloc) (_name) (_pts))) =
    (sem_SDecl_PolyTypeSig ((sem_Position (_srcloc))) ((sem_QualName (_name))) ((sem_PTS (_pts))))
sem_SDecl ((SDecl_TypeSig (_srcloc) (_name) (_tp))) =
    (sem_SDecl_TypeSig ((sem_Position (_srcloc))) ((sem_QualName (_name))) ((sem_QualType (_tp))))
sem_SDecl_Binding :: (T_Position) ->
                     (T_QualName) ->
                     (T_Bindings) ->
                     (T_SDecl)
sem_SDecl_Binding (_srcloc)
                  (_name)
                  (_bindings)
                  (_lhs_classname)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_importedModule)
                  (_lhs_ininstance)
                  (_lhs_intitype)
                  (_lhs_knownKinds)
                  (_lhs_knownKinds_collect)
                  (_lhs_knownTypes)
                  (_lhs_knownTypes_collect)
                  (_lhs_knownValues)
                  (_lhs_knownValues_collect)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_moduleTypes)
                  (_lhs_moduleValues)
                  (_lhs_nameType)
                  (_lhs_toplevel) =
    let (_self) =
            SDecl_Binding _srcloc_self _name_self _bindings_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_importedModule)
                   (_lhs_ininstance)
                   (_lhs_intitype)
                   (_lhs_knownKinds)
                   (_lhs_knownKinds_collect)
                   (_lhs_knownTypes)
                   (_lhs_knownTypes_collect)
                   (_lhs_knownValues)
                   (_lhs_knownValues_collect)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_moduleTypes)
                   (_lhs_moduleValues)
                   (if _lhs_ininstance then Ref_Val
                                       else Def_Val)
                   (_lhs_toplevel))
        ( _bindings_constructors_collect,_bindings_knownKinds_collect,_bindings_knownTypes_collect,_bindings_knownValues_collect,_bindings_methods_collect,_bindings_moduleTypes,_bindings_moduleValues,_bindings_modules,_bindings_res,_bindings_self) =
            (_bindings (_lhs_classname) (_name_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (False) (_lhs_intitype) (_lhs_knownKinds) (_name_knownKinds_collect) (_lhs_knownTypes) (_name_knownTypes_collect) (_lhs_knownValues) (_name_knownValues_collect) (_lhs_local) (_name_methods_collect) (_lhs_methods_dist) (_name_moduleTypes) (_name_moduleValues) (_lhs_nameType) (False))
    in  (_bindings_constructors_collect
        ,_bindings_knownKinds_collect
        ,_bindings_knownTypes_collect
        ,_bindings_knownValues_collect
        ,case _lhs_classname of
           Nothing -> _lhs_methods_collect
           Just c  -> addLBack _lhs_methods_collect
                               (c,[_name_self])
        ,_bindings_moduleTypes
        ,_bindings_moduleValues
        ,_name_modules `Set.union` _bindings_modules
        ,_name_res ++ _bindings_res
        ,_self
        )
sem_SDecl_Empty :: (T_SDecl)
sem_SDecl_Empty (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            SDecl_Empty
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],_self)
sem_SDecl_Fixity :: (T_Position) ->
                    (T_Infix) ->
                    (Priority) ->
                    (T_QualNames) ->
                    (T_SDecl)
sem_SDecl_Fixity (_srcloc)
                 (_inf)
                 (_priority)
                 (_ops)
                 (_lhs_classname)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_importedModule)
                 (_lhs_ininstance)
                 (_lhs_intitype)
                 (_lhs_knownKinds)
                 (_lhs_knownKinds_collect)
                 (_lhs_knownTypes)
                 (_lhs_knownTypes_collect)
                 (_lhs_knownValues)
                 (_lhs_knownValues_collect)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_moduleTypes)
                 (_lhs_moduleValues)
                 (_lhs_nameType)
                 (_lhs_toplevel) =
    let (_self) =
            SDecl_Fixity _srcloc_self _inf_self _priority _ops_self
        ( _srcloc_self) =
            (_srcloc )
        ( _inf_constructors_collect,_inf_knownKinds_collect,_inf_knownTypes_collect,_inf_knownValues_collect,_inf_methods_collect,_inf_moduleTypes,_inf_moduleValues,_inf_modules,_inf_res,_inf_self) =
            (_inf (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _ops_constructors_collect,_ops_knownKinds_collect,_ops_knownTypes_collect,_ops_knownValues_collect,_ops_methods_collect,_ops_moduleTypes,_ops_moduleValues,_ops_modules,_ops_res,_ops_self,_ops_self') =
            (_ops (_lhs_classname) (_inf_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_inf_knownKinds_collect) (_lhs_knownTypes) (_inf_knownTypes_collect) (_lhs_knownValues) (_inf_knownValues_collect) (_lhs_local) (_inf_methods_collect) (_lhs_methods_dist) (_inf_moduleTypes) (_inf_moduleValues) (Ref_Val) (_lhs_toplevel))
    in  (_ops_constructors_collect,_ops_knownKinds_collect,_ops_knownTypes_collect,_ops_knownValues_collect,_ops_methods_collect,_ops_moduleTypes,_ops_moduleValues,_inf_modules `Set.union` _ops_modules,_inf_res ++ _ops_res,_self)
sem_SDecl_PatBinding :: (T_Position) ->
                        (T_Pattern) ->
                        (T_Rhs) ->
                        (T_SDecls) ->
                        (T_SDecl)
sem_SDecl_PatBinding (_srcloc)
                     (_pat)
                     (_rhs)
                     (_where)
                     (_lhs_classname)
                     (_lhs_constructors_collect)
                     (_lhs_constructors_dist)
                     (_lhs_currentModule)
                     (_lhs_importedModule)
                     (_lhs_ininstance)
                     (_lhs_intitype)
                     (_lhs_knownKinds)
                     (_lhs_knownKinds_collect)
                     (_lhs_knownTypes)
                     (_lhs_knownTypes_collect)
                     (_lhs_knownValues)
                     (_lhs_knownValues_collect)
                     (_lhs_local)
                     (_lhs_methods_collect)
                     (_lhs_methods_dist)
                     (_lhs_moduleTypes)
                     (_lhs_moduleValues)
                     (_lhs_nameType)
                     (_lhs_toplevel) =
    let (_knownValues) =
            _where_knownValues_collect `mergeFM` _lhs_knownValues
        (_self) =
            SDecl_PatBinding _srcloc_self _pat_self _rhs_self
                             _where_self
        ( _srcloc_self) =
            (_srcloc )
        ( _pat_constructors_collect,_pat_knownKinds_collect,_pat_knownTypes_collect,_pat_knownValues_collect,_pat_methods_collect,_pat_moduleTypes,_pat_moduleValues,_pat_modules,_pat_res,_pat_self) =
            (_pat (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _rhs_constructors_collect,_rhs_knownKinds_collect,_rhs_knownTypes_collect,_rhs_knownValues_collect,_rhs_methods_collect,_rhs_moduleTypes,_rhs_moduleValues,_rhs_modules,_rhs_res,_rhs_self) =
            (_rhs (_lhs_classname) (_pat_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_pat_knownKinds_collect) (_lhs_knownTypes) (_pat_knownTypes_collect) (_knownValues) (_pat_knownValues_collect) (_lhs_local) (_pat_methods_collect) (_lhs_methods_dist) (_pat_moduleTypes) (_pat_moduleValues) (_lhs_nameType) (False))
        ( _where_constructors_collect,_where_knownKinds_collect,_where_knownTypes_collect,_where_knownValues_collect,_where_methods_collect,_where_moduleTypes,_where_moduleValues,_where_modules,_where_res,_where_self) =
            (_where (_lhs_classname) (_rhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_rhs_knownKinds_collect) (_lhs_knownTypes) (_rhs_knownTypes_collect) (_knownValues) (emptyFM) (_lhs_local) (_rhs_methods_collect) (_lhs_methods_dist) (_rhs_moduleTypes) (_rhs_moduleValues) (_lhs_nameType) (False))
    in  (_where_constructors_collect,_where_knownKinds_collect,_where_knownTypes_collect,_pat_knownValues_collect,_where_methods_collect,_where_moduleTypes,_where_moduleValues,_pat_modules `Set.union` _rhs_modules `Set.union` _where_modules,_pat_res ++ _rhs_res ++ _where_res,_self)
sem_SDecl_PolyBinding :: (T_Position) ->
                         (T_QualName) ->
                         (T_SType) ->
                         (T_Bindings) ->
                         (T_SDecl)
sem_SDecl_PolyBinding (_srcloc)
                      (_name)
                      (_tp)
                      (_bindings)
                      (_lhs_classname)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_importedModule)
                      (_lhs_ininstance)
                      (_lhs_intitype)
                      (_lhs_knownKinds)
                      (_lhs_knownKinds_collect)
                      (_lhs_knownTypes)
                      (_lhs_knownTypes_collect)
                      (_lhs_knownValues)
                      (_lhs_knownValues_collect)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_moduleTypes)
                      (_lhs_moduleValues)
                      (_lhs_nameType)
                      (_lhs_toplevel) =
    let (_self) =
            SDecl_PolyBinding _srcloc_self _name_self _tp_self
                              _bindings_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Def_Val) (_lhs_toplevel))
        ( _tp_constructors_collect,_tp_knownKinds_collect,_tp_knownTypes_collect,_tp_knownValues_collect,_tp_methods_collect,_tp_moduleTypes,_tp_moduleValues,_tp_modules,_tp_res,_tp_self) =
            (_tp (_lhs_classname) (_name_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_name_knownKinds_collect) (_lhs_knownTypes) (emptyFM) (_lhs_knownValues) (emptyFM) (_lhs_local) (_name_methods_collect) (_lhs_methods_dist) (_name_moduleTypes) (_name_moduleValues) (_lhs_nameType) (False))
        ( _bindings_constructors_collect,_bindings_knownKinds_collect,_bindings_knownTypes_collect,_bindings_knownValues_collect,_bindings_methods_collect,_bindings_moduleTypes,_bindings_moduleValues,_bindings_modules,_bindings_res,_bindings_self) =
            (_bindings (_lhs_classname)
                       (_tp_constructors_collect)
                       (_lhs_constructors_dist)
                       (_lhs_currentModule)
                       (_lhs_importedModule)
                       (_lhs_ininstance)
                       (_lhs_intitype)
                       (_lhs_knownKinds)
                       (_tp_knownKinds_collect)
                       (_tp_knownTypes_collect `mergeFM` _lhs_knownTypes)
                       (_tp_knownTypes_collect)
                       (_tp_knownValues_collect `mergeFM` _lhs_knownValues)
                       (_tp_knownValues_collect)
                       (_lhs_local)
                       (_tp_methods_collect)
                       (_lhs_methods_dist)
                       (_tp_moduleTypes)
                       (_tp_moduleValues)
                       (_lhs_nameType)
                       (False))
    in  (_bindings_constructors_collect,_bindings_knownKinds_collect,_lhs_knownTypes_collect,_name_knownValues_collect,_bindings_methods_collect,_bindings_moduleTypes,_bindings_moduleValues,_name_modules `Set.union` _tp_modules `Set.union` _bindings_modules,_name_res ++ _tp_res ++ _bindings_res,_self)
sem_SDecl_PolyTypeSig :: (T_Position) ->
                         (T_QualName) ->
                         (T_PTS) ->
                         (T_SDecl)
sem_SDecl_PolyTypeSig (_srcloc)
                      (_name)
                      (_pts)
                      (_lhs_classname)
                      (_lhs_constructors_collect)
                      (_lhs_constructors_dist)
                      (_lhs_currentModule)
                      (_lhs_importedModule)
                      (_lhs_ininstance)
                      (_lhs_intitype)
                      (_lhs_knownKinds)
                      (_lhs_knownKinds_collect)
                      (_lhs_knownTypes)
                      (_lhs_knownTypes_collect)
                      (_lhs_knownValues)
                      (_lhs_knownValues_collect)
                      (_lhs_local)
                      (_lhs_methods_collect)
                      (_lhs_methods_dist)
                      (_lhs_moduleTypes)
                      (_lhs_moduleValues)
                      (_lhs_nameType)
                      (_lhs_toplevel) =
    let (_self) =
            SDecl_PolyTypeSig _srcloc_self _name_self _pts_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Def_Val) (_lhs_toplevel))
        ( _pts_constructors_collect,_pts_knownKinds_collect,_pts_knownTypes_collect,_pts_knownValues_collect,_pts_methods_collect,_pts_moduleTypes,_pts_moduleValues,_pts_modules,_pts_res,_pts_self) =
            (_pts (_lhs_classname) (_name_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_name_knownKinds_collect) (_lhs_knownTypes) (_name_knownTypes_collect) (_lhs_knownValues) (_name_knownValues_collect) (_lhs_local) (_name_methods_collect) (_lhs_methods_dist) (_name_moduleTypes) (_name_moduleValues) (_lhs_nameType) (False))
    in  (_pts_constructors_collect,_pts_knownKinds_collect,_pts_knownTypes_collect,_pts_knownValues_collect,_pts_methods_collect,_pts_moduleTypes,_pts_moduleValues,_name_modules `Set.union` _pts_modules,_name_res ++ _pts_res,_self)
sem_SDecl_TypeSig :: (T_Position) ->
                     (T_QualName) ->
                     (T_QualType) ->
                     (T_SDecl)
sem_SDecl_TypeSig (_srcloc)
                  (_name)
                  (_tp)
                  (_lhs_classname)
                  (_lhs_constructors_collect)
                  (_lhs_constructors_dist)
                  (_lhs_currentModule)
                  (_lhs_importedModule)
                  (_lhs_ininstance)
                  (_lhs_intitype)
                  (_lhs_knownKinds)
                  (_lhs_knownKinds_collect)
                  (_lhs_knownTypes)
                  (_lhs_knownTypes_collect)
                  (_lhs_knownValues)
                  (_lhs_knownValues_collect)
                  (_lhs_local)
                  (_lhs_methods_collect)
                  (_lhs_methods_dist)
                  (_lhs_moduleTypes)
                  (_lhs_moduleValues)
                  (_lhs_nameType)
                  (_lhs_toplevel) =
    let (_self) =
            SDecl_TypeSig _srcloc_self _name_self _tp_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Def_Val) (_lhs_toplevel))
        ( _tp_constructors_collect,_tp_knownKinds_collect,_tp_knownTypes_collect,_tp_knownValues_collect,_tp_methods_collect,_tp_moduleTypes,_tp_moduleValues,_tp_modules,_tp_res,_tp_self) =
            (_tp (_lhs_classname) (_name_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_name_knownKinds_collect) (_lhs_knownTypes) (_name_knownTypes_collect) (_lhs_knownValues) (_name_knownValues_collect) (_lhs_local) (_name_methods_collect) (_lhs_methods_dist) (_name_moduleTypes) (_name_moduleValues) (_lhs_nameType) (False))
    in  (_tp_constructors_collect,_tp_knownKinds_collect,_tp_knownTypes_collect,_tp_knownValues_collect,_tp_methods_collect,_tp_moduleTypes,_tp_moduleValues,_name_modules `Set.union` _tp_modules,_name_res ++ _tp_res,_self)
-- SDecls ------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : SDecls

-}
{-
   local variables for SDecls.Cons:

-}
{-
   local variables for SDecls.Nil:

-}
-- semantic domain
type T_SDecls = (Maybe QualName) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (Modid) ->
                (Bool) ->
                (Bool) ->
                (Bool) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (FMap QualName [Entity]) ->
                (Bool) ->
                (FMap QualName QualNames) ->
                (FMap QualName QualNames) ->
                (FMap Modid [QualName]) ->
                (FMap Modid [QualName]) ->
                (NameType) ->
                (Bool) ->
                ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(SDecls))
-- cata
sem_SDecls :: (SDecls) ->
              (T_SDecls)
sem_SDecls (list) =
    (foldr (sem_SDecls_Cons) (sem_SDecls_Nil) ((map sem_SDecl list)))
sem_SDecls_Cons :: (T_SDecl) ->
                   (T_SDecls) ->
                   (T_SDecls)
sem_SDecls_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _hd_constructors_collect,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self) =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_lhs_local) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_SDecls_Nil :: (T_SDecls)
sem_SDecls_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])
-- SKind -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : SKind

-}
{-
   local variables for SKind.Arr:

-}
{-
   local variables for SKind.Star:

-}
-- semantic domain
type T_SKind = (Maybe QualName) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (Bool) ->
               (Bool) ->
               (Bool) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (FMap Modid [QualName]) ->
               (FMap Modid [QualName]) ->
               (NameType) ->
               (Bool) ->
               ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(SKind))
-- cata
sem_SKind :: (SKind) ->
             (T_SKind)
sem_SKind ((SKind_Arr (_left) (_right))) =
    (sem_SKind_Arr ((sem_QualName (_left))) ((sem_QualName (_right))))
sem_SKind ((SKind_Star )) =
    (sem_SKind_Star )
sem_SKind_Arr :: (T_QualName) ->
                 (T_QualName) ->
                 (T_SKind)
sem_SKind_Arr (_left) (_right) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _left_constructors_collect,_left_entityName,_left_fullName,_left_knownKinds_collect,_left_knownTypes_collect,_left_knownValues_collect,_left_methods_collect,_left_moduleTypes,_left_moduleValues,_left_modules,_left_res,_left_self,_left_self') =
            (_left (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Def_Kind) (_lhs_toplevel))
        ( _right_constructors_collect,_right_entityName,_right_fullName,_right_knownKinds_collect,_right_knownTypes_collect,_right_knownValues_collect,_right_methods_collect,_right_moduleTypes,_right_moduleValues,_right_modules,_right_res,_right_self,_right_self') =
            (_right (_lhs_classname) (_left_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_left_knownKinds_collect) (_lhs_knownTypes) (_left_knownTypes_collect) (_lhs_knownValues) (_left_knownValues_collect) (_lhs_local) (_left_methods_collect) (_lhs_methods_dist) (_left_moduleTypes) (_left_moduleValues) (Def_Kind) (_lhs_toplevel))
    in  (_right_constructors_collect,_right_knownKinds_collect,_right_knownTypes_collect,_right_knownValues_collect,_right_methods_collect,_right_moduleTypes,_right_moduleValues,_left_modules `Set.union` _right_modules,_left_res ++ _right_res,SKind_Arr _left_self _right_self)
sem_SKind_Star :: (T_SKind)
sem_SKind_Star (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],SKind_Star)
-- SType -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : SType

-}
{-
   local variables for SType.Con:

-}
{-
   local variables for SType.ConCase:

-}
{-
   local variables for SType.Const:

-}
{-
   local variables for SType.Fun:

-}
{-
   local variables for SType.Label:

-}
{-
   local variables for SType.Prod:

-}
{-
   local variables for SType.Sum:

-}
{-
   local variables for SType.Unit:

-}
{-
   local variables for SType.Var:

-}
-- semantic domain
type T_SType = (Maybe QualName) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (Bool) ->
               (Bool) ->
               (Bool) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (FMap Modid [QualName]) ->
               (FMap Modid [QualName]) ->
               (NameType) ->
               (Bool) ->
               ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(SType))
-- cata
sem_SType :: (SType) ->
             (T_SType)
sem_SType ((SType_Con (_var))) =
    (sem_SType_Con ((sem_QualName (_var))))
sem_SType ((SType_ConCase (_srcloc) (_name))) =
    (sem_SType_ConCase ((sem_Position (_srcloc))) ((sem_QualName (_name))))
sem_SType ((SType_Const (_srcloc) (_name))) =
    (sem_SType_Const ((sem_Position (_srcloc))) ((sem_QualName (_name))))
sem_SType ((SType_Fun )) =
    (sem_SType_Fun )
sem_SType ((SType_Label (_var))) =
    (sem_SType_Label ((sem_QualName (_var))))
sem_SType ((SType_Prod )) =
    (sem_SType_Prod )
sem_SType ((SType_Sum )) =
    (sem_SType_Sum )
sem_SType ((SType_Unit )) =
    (sem_SType_Unit )
sem_SType ((SType_Var (_srcloc) (_name))) =
    (sem_SType_Var ((sem_Position (_srcloc))) ((sem_QualName (_name))))
sem_SType_Con :: (T_QualName) ->
                 (T_SType)
sem_SType_Con (_var) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _var_constructors_collect,_var_entityName,_var_fullName,_var_knownKinds_collect,_var_knownTypes_collect,_var_knownValues_collect,_var_methods_collect,_var_moduleTypes,_var_moduleValues,_var_modules,_var_res,_var_self,_var_self') =
            (_var (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Def_Val) (_lhs_toplevel))
    in  (_var_constructors_collect
        ,if   _lhs_intitype
         then _lhs_knownKinds_collect
         else _var_knownKinds_collect
        ,if   _lhs_intitype
         then _lhs_knownTypes_collect
         else _var_knownTypes_collect
        ,if   _lhs_intitype
         then _lhs_knownValues_collect
         else _var_knownValues_collect
        ,_var_methods_collect
        ,_var_moduleTypes
        ,_var_moduleValues
        ,_var_modules
        ,_var_res
        ,SType_Con   _var_self
        )
sem_SType_ConCase :: (T_Position) ->
                     (T_QualName) ->
                     (T_SType)
sem_SType_ConCase (_srcloc) (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _srcloc_self) =
            (_srcloc )
        ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Val) (_lhs_toplevel))
    in  (_name_constructors_collect,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,SType_ConCase _srcloc_self _name_self)
sem_SType_Const :: (T_Position) ->
                   (T_QualName) ->
                   (T_SType)
sem_SType_Const (_srcloc) (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _srcloc_self) =
            (_srcloc )
        ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Typ) (_lhs_toplevel))
    in  (_name_constructors_collect,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,SType_Const   _srcloc_self _name_self)
sem_SType_Fun :: (T_SType)
sem_SType_Fun (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],SType_Fun)
sem_SType_Label :: (T_QualName) ->
                   (T_SType)
sem_SType_Label (_var) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _var_constructors_collect,_var_entityName,_var_fullName,_var_knownKinds_collect,_var_knownTypes_collect,_var_knownValues_collect,_var_methods_collect,_var_moduleTypes,_var_moduleValues,_var_modules,_var_res,_var_self,_var_self') =
            (_var (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Def_Val) (_lhs_toplevel))
    in  (_var_constructors_collect
        ,if   _lhs_intitype
         then _lhs_knownKinds_collect
         else _var_knownKinds_collect
        ,if   _lhs_intitype
         then _lhs_knownTypes_collect
         else _var_knownTypes_collect
        ,if   _lhs_intitype
         then _lhs_knownValues_collect
         else _var_knownValues_collect
        ,_var_methods_collect
        ,_var_moduleTypes
        ,_var_moduleValues
        ,_var_modules
        ,_var_res
        ,SType_Label _var_self
        )
sem_SType_Prod :: (T_SType)
sem_SType_Prod (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],SType_Prod)
sem_SType_Sum :: (T_SType)
sem_SType_Sum (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],SType_Sum)
sem_SType_Unit :: (T_SType)
sem_SType_Unit (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],SType_Unit)
sem_SType_Var :: (T_Position) ->
                 (T_QualName) ->
                 (T_SType)
sem_SType_Var (_srcloc) (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _srcloc_self) =
            (_srcloc )
        ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Def_Typ) (_lhs_toplevel))
    in  (_name_constructors_collect,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,SType_Var     _srcloc_self _name_self)
-- Stmt --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Stmt

-}
{-
   local variables for Stmt.Empty:

-}
{-
   local variables for Stmt.Expr:

-}
{-
   local variables for Stmt.Gen:

-}
{-
   local variables for Stmt.Let:

-}
-- semantic domain
type T_Stmt = (Maybe QualName) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Modid) ->
              (Bool) ->
              (Bool) ->
              (Bool) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (Bool) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (FMap Modid [QualName]) ->
              (FMap Modid [QualName]) ->
              (NameType) ->
              (Bool) ->
              ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Stmt))
-- cata
sem_Stmt :: (Stmt) ->
            (T_Stmt)
sem_Stmt ((Stmt_Empty )) =
    (sem_Stmt_Empty )
sem_Stmt ((Stmt_Expr (_expr))) =
    (sem_Stmt_Expr ((sem_Expr (_expr))))
sem_Stmt ((Stmt_Gen (_pattern) (_body))) =
    (sem_Stmt_Gen ((sem_Pattern (_pattern))) ((sem_Expr (_body))))
sem_Stmt ((Stmt_Let (_decls))) =
    (sem_Stmt_Let ((sem_SDecls (_decls))))
sem_Stmt_Empty :: (T_Stmt)
sem_Stmt_Empty (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],Stmt_Empty)
sem_Stmt_Expr :: (T_Expr) ->
                 (T_Stmt)
sem_Stmt_Expr (_expr) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _expr_constructors_collect,_expr_knownKinds_collect,_expr_knownTypes_collect,_expr_knownValues_collect,_expr_methods_collect,_expr_moduleTypes,_expr_moduleValues,_expr_modules,_expr_res,_expr_self) =
            (_expr (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_expr_constructors_collect,_expr_knownKinds_collect,_expr_knownTypes_collect,_expr_knownValues_collect,_expr_methods_collect,_expr_moduleTypes,_expr_moduleValues,_expr_modules,_expr_res,Stmt_Expr _expr_self)
sem_Stmt_Gen :: (T_Pattern) ->
                (T_Expr) ->
                (T_Stmt)
sem_Stmt_Gen (_pattern) (_body) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _pattern_constructors_collect,_pattern_knownKinds_collect,_pattern_knownTypes_collect,_pattern_knownValues_collect,_pattern_methods_collect,_pattern_moduleTypes,_pattern_moduleValues,_pattern_modules,_pattern_res,_pattern_self) =
            (_pattern (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _body_constructors_collect,_body_knownKinds_collect,_body_knownTypes_collect,_body_knownValues_collect,_body_methods_collect,_body_moduleTypes,_body_moduleValues,_body_modules,_body_res,_body_self) =
            (_body (_lhs_classname)
                   (_pattern_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_importedModule)
                   (_lhs_ininstance)
                   (_lhs_intitype)
                   (_lhs_knownKinds)
                   (_pattern_knownKinds_collect)
                   (_lhs_knownTypes)
                   (_pattern_knownTypes_collect)
                   (_lhs_knownValues)
                   (_pattern_knownValues_collect)
                   (_lhs_local)
                   (_pattern_methods_collect)
                   (_lhs_methods_dist)
                   (_pattern_moduleTypes)
                   (_pattern_moduleValues)
                   (_lhs_nameType)
                   (_lhs_toplevel))
    in  (_body_constructors_collect,_body_knownKinds_collect,_body_knownTypes_collect,_body_knownValues_collect,_body_methods_collect,_body_moduleTypes,_body_moduleValues,_pattern_modules `Set.union` _body_modules,_pattern_res ++ _body_res,Stmt_Gen _pattern_self _body_self)
sem_Stmt_Let :: (T_SDecls) ->
                (T_Stmt)
sem_Stmt_Let (_decls) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _decls_constructors_collect,_decls_knownKinds_collect,_decls_knownTypes_collect,_decls_knownValues_collect,_decls_methods_collect,_decls_moduleTypes,_decls_moduleValues,_decls_modules,_decls_res,_decls_self) =
            (_decls (_lhs_classname)
                    (_lhs_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_importedModule)
                    (_lhs_ininstance)
                    (_lhs_intitype)
                    (_lhs_knownKinds)
                    (_lhs_knownKinds_collect)
                    (_lhs_knownTypes)
                    (_lhs_knownTypes_collect)
                    (_decls_knownValues_collect `mergeFM` _lhs_knownValues)
                    (_lhs_knownValues_collect)
                    (_lhs_local)
                    (_lhs_methods_collect)
                    (_lhs_methods_dist)
                    (_lhs_moduleTypes)
                    (_lhs_moduleValues)
                    (_lhs_nameType)
                    (_lhs_toplevel))
    in  (_decls_constructors_collect,_decls_knownKinds_collect,_decls_knownTypes_collect,_decls_knownValues_collect,_decls_methods_collect,_decls_moduleTypes,_decls_moduleValues,_decls_modules,_decls_res,Stmt_Let _decls_self)
-- Stmts -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Stmts

-}
{-
   local variables for Stmts.Cons:

-}
{-
   local variables for Stmts.Nil:

-}
-- semantic domain
type T_Stmts = (Maybe QualName) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (Bool) ->
               (Bool) ->
               (Bool) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (FMap Modid [QualName]) ->
               (FMap Modid [QualName]) ->
               (NameType) ->
               (Bool) ->
               ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Stmts))
-- cata
sem_Stmts :: (Stmts) ->
             (T_Stmts)
sem_Stmts (list) =
    (foldr (sem_Stmts_Cons) (sem_Stmts_Nil) ((map sem_Stmt list)))
sem_Stmts_Cons :: (T_Stmt) ->
                  (T_Stmts) ->
                  (T_Stmts)
sem_Stmts_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _hd_constructors_collect,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self) =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (emptyFM) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname)
                 (_hd_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_importedModule)
                 (_lhs_ininstance)
                 (_lhs_intitype)
                 (_lhs_knownKinds)
                 (_hd_knownKinds_collect)
                 (_lhs_knownTypes)
                 (_hd_knownTypes_collect)
                 (_hd_knownValues_collect `mergeFM` _lhs_knownValues)
                 (_hd_knownValues_collect)
                 (_lhs_local)
                 (_hd_methods_collect)
                 (_lhs_methods_dist)
                 (_hd_moduleTypes)
                 (_hd_moduleValues)
                 (_lhs_nameType)
                 (_lhs_toplevel))
    in  (_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_Stmts_Nil :: (T_Stmts)
sem_Stmts_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])
-- TDecl -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : TDecl

-}
{-
   local variables for TDecl.Class:
      self
      classname

-}
{-
   local variables for TDecl.Data:
      self

-}
{-
   local variables for TDecl.Default:
      self

-}
{-
   local variables for TDecl.Dependency:
      self

-}
{-
   local variables for TDecl.Instance:
      self

-}
{-
   local variables for TDecl.New:
      self

-}
{-
   local variables for TDecl.Poly:
      self

-}
{-
   local variables for TDecl.TiType:
      self

-}
{-
   local variables for TDecl.Type:
      self

-}
-- semantic domain
type T_TDecl = (Maybe QualName) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (Bool) ->
               (Bool) ->
               (Bool) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (FMap Modid [QualName]) ->
               (FMap Modid [QualName]) ->
               (NameType) ->
               (Bool) ->
               ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(TDecl))
-- cata
sem_TDecl :: (TDecl) ->
             (T_TDecl)
sem_TDecl ((TDecl_Class (_srcloc) (_context) (_name) (_args) (_decls))) =
    (sem_TDecl_Class ((sem_Position (_srcloc))) ((sem_Context (_context))) ((sem_QualName (_name))) ((sem_Args (_args))) ((sem_SDecls (_decls))))
sem_TDecl ((TDecl_Data (_srcloc) (_context) (_name) (_args) (_conss) (_ders))) =
    (sem_TDecl_Data ((sem_Position (_srcloc))) ((sem_Context (_context))) ((sem_QualName (_name))) ((sem_Args (_args))) ((sem_Constrs (_conss))) ((sem_Derivings (_ders))))
sem_TDecl ((TDecl_Default (_srcloc) (_tps))) =
    (sem_TDecl_Default ((sem_Position (_srcloc))) ((sem_Types (_tps))))
sem_TDecl ((TDecl_Dependency (_srcloc) (_istp) (_name) (_names))) =
    (sem_TDecl_Dependency ((sem_Position (_srcloc))) (_istp) ((sem_QualName (_name))) ((sem_QualNames (_names))))
sem_TDecl ((TDecl_Instance (_srcloc) (_context) (_name) (_tps) (_decls))) =
    (sem_TDecl_Instance ((sem_Position (_srcloc))) ((sem_Context (_context))) ((sem_QualName (_name))) ((sem_Types (_tps))) ((sem_SDecls (_decls))))
sem_TDecl ((TDecl_New (_srcloc) (_context) (_name) (_args) (_cons) (_ders))) =
    (sem_TDecl_New ((sem_Position (_srcloc))) ((sem_Context (_context))) ((sem_QualName (_name))) ((sem_Args (_args))) ((sem_Constr (_cons))) ((sem_Derivings (_ders))))
sem_TDecl ((TDecl_Poly (_srcloc) (_name) (_bindings))) =
    (sem_TDecl_Poly ((sem_Position (_srcloc))) ((sem_QualName (_name))) ((sem_TypeBindings (_bindings))))
sem_TDecl ((TDecl_TiType (_srcloc) (_name) (_tp) (_args) (_cons))) =
    (sem_TDecl_TiType ((sem_Position (_srcloc))) ((sem_QualName (_name))) ((sem_SType (_tp))) ((sem_Args (_args))) ((sem_Constr (_cons))))
sem_TDecl ((TDecl_Type (_srcloc) (_name) (_args) (_tp))) =
    (sem_TDecl_Type ((sem_Position (_srcloc))) ((sem_QualName (_name))) ((sem_Args (_args))) ((sem_Type (_tp))))
sem_TDecl_Class :: (T_Position) ->
                   (T_Context) ->
                   (T_QualName) ->
                   (T_Args) ->
                   (T_SDecls) ->
                   (T_TDecl)
sem_TDecl_Class (_srcloc)
                (_context)
                (_name)
                (_args)
                (_decls)
                (_lhs_classname)
                (_lhs_constructors_collect)
                (_lhs_constructors_dist)
                (_lhs_currentModule)
                (_lhs_importedModule)
                (_lhs_ininstance)
                (_lhs_intitype)
                (_lhs_knownKinds)
                (_lhs_knownKinds_collect)
                (_lhs_knownTypes)
                (_lhs_knownTypes_collect)
                (_lhs_knownValues)
                (_lhs_knownValues_collect)
                (_lhs_local)
                (_lhs_methods_collect)
                (_lhs_methods_dist)
                (_lhs_moduleTypes)
                (_lhs_moduleValues)
                (_lhs_nameType)
                (_lhs_toplevel) =
    let (_classname) =
            Just _name_self
        (_self) =
            TDecl_Class _srcloc_self _context_self _name_self
                        _args_self _decls_self
        ( _srcloc_self) =
            (_srcloc )
        ( _context_constructors_collect,_context_knownKinds_collect,_context_knownTypes_collect,_context_knownValues_collect,_context_methods_collect,_context_moduleTypes,_context_moduleValues,_context_modules,_context_res,_context_self) =
            (_context (_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_classname) (_context_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_context_knownKinds_collect) (_lhs_knownTypes) (_context_knownTypes_collect) (_lhs_knownValues) (_context_knownValues_collect) (_lhs_local) (_context_methods_collect) (_lhs_methods_dist) (_context_moduleTypes) (_context_moduleValues) (Def_Typ) (_lhs_toplevel))
        ( _args_constructors_collect,_args_knownKinds_collect,_args_knownTypes_collect,_args_knownValues_collect,_args_methods_collect,_args_moduleTypes,_args_moduleValues,_args_modules,_args_res,_args_self) =
            (_args (_classname) (_name_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_name_knownKinds_collect) (_lhs_knownTypes) (emptyFM) (_lhs_knownValues) (_name_knownValues_collect) (_lhs_local) (_name_methods_collect) (_lhs_methods_dist) (_name_moduleTypes) (_name_moduleValues) (Def_Typ) (False))
        ( _decls_constructors_collect,_decls_knownKinds_collect,_decls_knownTypes_collect,_decls_knownValues_collect,_decls_methods_collect,_decls_moduleTypes,_decls_moduleValues,_decls_modules,_decls_res,_decls_self) =
            (_decls (_classname)
                    (_args_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_importedModule)
                    (_lhs_ininstance)
                    (_lhs_intitype)
                    (_lhs_knownKinds)
                    (_args_knownKinds_collect)
                    (_args_knownTypes_collect `mergeFM` _lhs_knownTypes)
                    (_name_knownTypes_collect)
                    (_lhs_knownValues)
                    (_args_knownValues_collect)
                    (_lhs_local)
                    (add _lhs_methods_collect
                         (_name_self,[]))
                    (_lhs_methods_dist)
                    (_args_moduleTypes)
                    (_args_moduleValues)
                    (_lhs_nameType)
                    (_lhs_toplevel))
    in  (_decls_constructors_collect,_decls_knownKinds_collect,_decls_knownTypes_collect,_decls_knownValues_collect,_decls_methods_collect,_decls_moduleTypes,_decls_moduleValues,_context_modules `Set.union` _name_modules `Set.union` _args_modules `Set.union` _decls_modules,_context_res ++ _name_res ++ _args_res ++ _decls_res,_self)
sem_TDecl_Data :: (T_Position) ->
                  (T_Context) ->
                  (T_QualName) ->
                  (T_Args) ->
                  (T_Constrs) ->
                  (T_Derivings) ->
                  (T_TDecl)
sem_TDecl_Data (_srcloc)
               (_context)
               (_name)
               (_args)
               (_conss)
               (_ders)
               (_lhs_classname)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_importedModule)
               (_lhs_ininstance)
               (_lhs_intitype)
               (_lhs_knownKinds)
               (_lhs_knownKinds_collect)
               (_lhs_knownTypes)
               (_lhs_knownTypes_collect)
               (_lhs_knownValues)
               (_lhs_knownValues_collect)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_moduleTypes)
               (_lhs_moduleValues)
               (_lhs_nameType)
               (_lhs_toplevel) =
    let (_self) =
            TDecl_Data _srcloc_self _context_self _name_self
                       _args_self _conss_self _ders_self
        ( _srcloc_self) =
            (_srcloc )
        ( _context_constructors_collect,_context_knownKinds_collect,_context_knownTypes_collect,_context_knownValues_collect,_context_methods_collect,_context_moduleTypes,_context_moduleValues,_context_modules,_context_res,_context_self) =
            (_context (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_context_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_context_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_context_knownValues_collect) (_lhs_local) (_context_methods_collect) (_lhs_methods_dist) (_context_moduleTypes) (_context_moduleValues) (Def_Typ) (_lhs_toplevel))
        ( _args_constructors_collect,_args_knownKinds_collect,_args_knownTypes_collect,_args_knownValues_collect,_args_methods_collect,_args_moduleTypes,_args_moduleValues,_args_modules,_args_res,_args_self) =
            (_args (_lhs_classname) (_name_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_name_knownKinds_collect) (_lhs_knownTypes) (emptyFM) (_lhs_knownValues) (_name_knownValues_collect) (_lhs_local) (_name_methods_collect) (_lhs_methods_dist) (_name_moduleTypes) (_name_moduleValues) (Def_Typ) (False))
        ( _conss_constructors,_conss_constructors_collect,_conss_knownKinds_collect,_conss_knownTypes_collect,_conss_knownValues_collect,_conss_methods_collect,_conss_moduleTypes,_conss_moduleValues,_conss_modules,_conss_res,_conss_self) =
            (_conss (_lhs_classname)
                    (_args_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_importedModule)
                    (_lhs_ininstance)
                    (_lhs_intitype)
                    (_lhs_knownKinds)
                    (_args_knownKinds_collect)
                    (_args_knownTypes_collect `mergeFM` _lhs_knownTypes)
                    (_args_knownTypes_collect)
                    (_lhs_knownValues)
                    (_args_knownValues_collect)
                    (_lhs_local)
                    (_args_methods_collect)
                    (_lhs_methods_dist)
                    (_args_moduleTypes)
                    (_args_moduleValues)
                    (_lhs_nameType)
                    (_lhs_toplevel)
                    (_name_self))
        ( _ders_constructors_collect,_ders_knownKinds_collect,_ders_knownTypes_collect,_ders_knownValues_collect,_ders_methods_collect,_ders_moduleTypes,_ders_moduleValues,_ders_modules,_ders_res,_ders_self) =
            (_ders (_lhs_classname) (_conss_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_conss_knownKinds_collect) (_lhs_knownTypes) (_conss_knownTypes_collect) (_lhs_knownValues) (_conss_knownValues_collect) (_lhs_local) (_conss_methods_collect) (_lhs_methods_dist) (_conss_moduleTypes) (_conss_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (add _lhs_constructors_collect
             (_name_self,_conss_constructors)
        ,_ders_knownKinds_collect
        ,_name_knownTypes_collect
        ,_ders_knownValues_collect
        ,_ders_methods_collect
        ,_ders_moduleTypes
        ,_ders_moduleValues
        ,_context_modules `Set.union` _name_modules `Set.union` _args_modules `Set.union` _conss_modules `Set.union` _ders_modules
        ,_context_res ++ _name_res ++ _args_res ++ _conss_res ++ _ders_res
        ,_self
        )
sem_TDecl_Default :: (T_Position) ->
                     (T_Types) ->
                     (T_TDecl)
sem_TDecl_Default (_srcloc) (_tps) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            TDecl_Default _srcloc_self _tps_self
        ( _srcloc_self) =
            (_srcloc )
        ( _tps_constructors_collect,_tps_knownKinds_collect,_tps_knownTypes_collect,_tps_knownValues_collect,_tps_methods_collect,_tps_moduleTypes,_tps_moduleValues,_tps_modules,_tps_res,_tps_self) =
            (_tps (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tps_constructors_collect,_tps_knownKinds_collect,_tps_knownTypes_collect,_tps_knownValues_collect,_tps_methods_collect,_tps_moduleTypes,_tps_moduleValues,_tps_modules,_tps_res,_self)
sem_TDecl_Dependency :: (T_Position) ->
                        (Bool) ->
                        (T_QualName) ->
                        (T_QualNames) ->
                        (T_TDecl)
sem_TDecl_Dependency (_srcloc)
                     (_istp)
                     (_name)
                     (_names)
                     (_lhs_classname)
                     (_lhs_constructors_collect)
                     (_lhs_constructors_dist)
                     (_lhs_currentModule)
                     (_lhs_importedModule)
                     (_lhs_ininstance)
                     (_lhs_intitype)
                     (_lhs_knownKinds)
                     (_lhs_knownKinds_collect)
                     (_lhs_knownTypes)
                     (_lhs_knownTypes_collect)
                     (_lhs_knownValues)
                     (_lhs_knownValues_collect)
                     (_lhs_local)
                     (_lhs_methods_collect)
                     (_lhs_methods_dist)
                     (_lhs_moduleTypes)
                     (_lhs_moduleValues)
                     (_lhs_nameType)
                     (_lhs_toplevel) =
    let (_self) =
            TDecl_Dependency _srcloc_self _istp _name_self _names_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_importedModule)
                   (_lhs_ininstance)
                   (_lhs_intitype)
                   (_lhs_knownKinds)
                   (_lhs_knownKinds_collect)
                   (_lhs_knownTypes)
                   (_lhs_knownTypes_collect)
                   (_lhs_knownValues)
                   (_lhs_knownValues_collect)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_moduleTypes)
                   (_lhs_moduleValues)
                   (if _istp then Ref_Typ
                             else Ref_Val)
                   (_lhs_toplevel))
        ( _names_constructors_collect,_names_knownKinds_collect,_names_knownTypes_collect,_names_knownValues_collect,_names_methods_collect,_names_moduleTypes,_names_moduleValues,_names_modules,_names_res,_names_self,_names_self') =
            (_names (_lhs_classname)
                    (_name_constructors_collect)
                    (_lhs_constructors_dist)
                    (_lhs_currentModule)
                    (_lhs_importedModule)
                    (_lhs_ininstance)
                    (_lhs_intitype)
                    (_lhs_knownKinds)
                    (_name_knownKinds_collect)
                    (_lhs_knownTypes)
                    (_name_knownTypes_collect)
                    (_lhs_knownValues)
                    (_name_knownValues_collect)
                    (_lhs_local)
                    (_name_methods_collect)
                    (_lhs_methods_dist)
                    (_name_moduleTypes)
                    (_name_moduleValues)
                    (if _istp then Ref_Typ
                              else Ref_Val)
                    (_lhs_toplevel))
    in  (_names_constructors_collect,_names_knownKinds_collect,_names_knownTypes_collect,_names_knownValues_collect,_names_methods_collect,_names_moduleTypes,_names_moduleValues,_name_modules `Set.union` _names_modules,_name_res ++ _names_res,_self)
sem_TDecl_Instance :: (T_Position) ->
                      (T_Context) ->
                      (T_QualName) ->
                      (T_Types) ->
                      (T_SDecls) ->
                      (T_TDecl)
sem_TDecl_Instance (_srcloc)
                   (_context)
                   (_name)
                   (_tps)
                   (_decls)
                   (_lhs_classname)
                   (_lhs_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_importedModule)
                   (_lhs_ininstance)
                   (_lhs_intitype)
                   (_lhs_knownKinds)
                   (_lhs_knownKinds_collect)
                   (_lhs_knownTypes)
                   (_lhs_knownTypes_collect)
                   (_lhs_knownValues)
                   (_lhs_knownValues_collect)
                   (_lhs_local)
                   (_lhs_methods_collect)
                   (_lhs_methods_dist)
                   (_lhs_moduleTypes)
                   (_lhs_moduleValues)
                   (_lhs_nameType)
                   (_lhs_toplevel) =
    let (_self) =
            TDecl_Instance _srcloc_self _context_self _name_self
                           _tps_self _decls_self
        ( _srcloc_self) =
            (_srcloc )
        ( _context_constructors_collect,_context_knownKinds_collect,_context_knownTypes_collect,_context_knownValues_collect,_context_methods_collect,_context_moduleTypes,_context_moduleValues,_context_modules,_context_res,_context_self) =
            (_context (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_context_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_context_knownKinds_collect) (_lhs_knownTypes) (_context_knownTypes_collect) (_lhs_knownValues) (_context_knownValues_collect) (_lhs_local) (_context_methods_collect) (_lhs_methods_dist) (_context_moduleTypes) (_context_moduleValues) (Ref_Typ) (_lhs_toplevel))
        ( _tps_constructors_collect,_tps_knownKinds_collect,_tps_knownTypes_collect,_tps_knownValues_collect,_tps_methods_collect,_tps_moduleTypes,_tps_moduleValues,_tps_modules,_tps_res,_tps_self) =
            (_tps (_lhs_classname) (_name_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_name_knownKinds_collect) (_lhs_knownTypes) (_name_knownTypes_collect) (_lhs_knownValues) (_name_knownValues_collect) (_lhs_local) (_name_methods_collect) (_lhs_methods_dist) (_name_moduleTypes) (_name_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _decls_constructors_collect,_decls_knownKinds_collect,_decls_knownTypes_collect,_decls_knownValues_collect,_decls_methods_collect,_decls_moduleTypes,_decls_moduleValues,_decls_modules,_decls_res,_decls_self) =
            (_decls (_lhs_classname) (_tps_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (True) (_lhs_intitype) (_lhs_knownKinds) (_tps_knownKinds_collect) (_lhs_knownTypes) (emptyFM) (_lhs_knownValues) (_tps_knownValues_collect) (_lhs_local) (_tps_methods_collect) (_lhs_methods_dist) (_tps_moduleTypes) (_tps_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_decls_constructors_collect,_decls_knownKinds_collect,_lhs_knownTypes_collect,_decls_knownValues_collect,_decls_methods_collect,_decls_moduleTypes,_decls_moduleValues,_context_modules `Set.union` _name_modules `Set.union` _tps_modules `Set.union` _decls_modules,_context_res ++ _name_res ++ _tps_res ++ _decls_res,_self)
sem_TDecl_New :: (T_Position) ->
                 (T_Context) ->
                 (T_QualName) ->
                 (T_Args) ->
                 (T_Constr) ->
                 (T_Derivings) ->
                 (T_TDecl)
sem_TDecl_New (_srcloc)
              (_context)
              (_name)
              (_args)
              (_cons)
              (_ders)
              (_lhs_classname)
              (_lhs_constructors_collect)
              (_lhs_constructors_dist)
              (_lhs_currentModule)
              (_lhs_importedModule)
              (_lhs_ininstance)
              (_lhs_intitype)
              (_lhs_knownKinds)
              (_lhs_knownKinds_collect)
              (_lhs_knownTypes)
              (_lhs_knownTypes_collect)
              (_lhs_knownValues)
              (_lhs_knownValues_collect)
              (_lhs_local)
              (_lhs_methods_collect)
              (_lhs_methods_dist)
              (_lhs_moduleTypes)
              (_lhs_moduleValues)
              (_lhs_nameType)
              (_lhs_toplevel) =
    let (_self) =
            TDecl_New _srcloc_self _context_self _name_self
                      _args_self _cons_self _ders_self
        ( _srcloc_self) =
            (_srcloc )
        ( _context_constructors_collect,_context_knownKinds_collect,_context_knownTypes_collect,_context_knownValues_collect,_context_methods_collect,_context_moduleTypes,_context_moduleValues,_context_modules,_context_res,_context_self) =
            (_context (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_context_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_context_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_context_knownValues_collect) (_lhs_local) (_context_methods_collect) (_lhs_methods_dist) (_context_moduleTypes) (_context_moduleValues) (Def_Typ) (_lhs_toplevel))
        ( _args_constructors_collect,_args_knownKinds_collect,_args_knownTypes_collect,_args_knownValues_collect,_args_methods_collect,_args_moduleTypes,_args_moduleValues,_args_modules,_args_res,_args_self) =
            (_args (_lhs_classname) (_name_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_name_knownKinds_collect) (_lhs_knownTypes) (emptyFM) (_lhs_knownValues) (_name_knownValues_collect) (_lhs_local) (_name_methods_collect) (_lhs_methods_dist) (_name_moduleTypes) (_name_moduleValues) (Def_Typ) (False))
        ( _cons_constructors,_cons_constructors_collect,_cons_knownKinds_collect,_cons_knownTypes_collect,_cons_knownValues_collect,_cons_methods_collect,_cons_moduleTypes,_cons_moduleValues,_cons_modules,_cons_res,_cons_self) =
            (_cons (_lhs_classname)
                   (_args_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_importedModule)
                   (_lhs_ininstance)
                   (_lhs_intitype)
                   (_lhs_knownKinds)
                   (_args_knownKinds_collect)
                   (_args_knownTypes_collect `mergeFM` _lhs_knownTypes)
                   (_args_knownTypes_collect)
                   (_lhs_knownValues)
                   (_args_knownValues_collect)
                   (_lhs_local)
                   (_args_methods_collect)
                   (_lhs_methods_dist)
                   (_args_moduleTypes)
                   (_args_moduleValues)
                   (_lhs_nameType)
                   (_lhs_toplevel)
                   (_name_self))
        ( _ders_constructors_collect,_ders_knownKinds_collect,_ders_knownTypes_collect,_ders_knownValues_collect,_ders_methods_collect,_ders_moduleTypes,_ders_moduleValues,_ders_modules,_ders_res,_ders_self) =
            (_ders (_lhs_classname) (_cons_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_cons_knownKinds_collect) (_lhs_knownTypes) (_cons_knownTypes_collect) (_lhs_knownValues) (_cons_knownValues_collect) (_lhs_local) (_cons_methods_collect) (_lhs_methods_dist) (_cons_moduleTypes) (_cons_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (add _lhs_constructors_collect
             (_name_self,_cons_constructors)
        ,_ders_knownKinds_collect
        ,_name_knownTypes_collect
        ,_ders_knownValues_collect
        ,_ders_methods_collect
        ,_ders_moduleTypes
        ,_ders_moduleValues
        ,_context_modules `Set.union` _name_modules `Set.union` _args_modules `Set.union` _cons_modules `Set.union` _ders_modules
        ,_context_res ++ _name_res ++ _args_res ++ _cons_res ++ _ders_res
        ,_self
        )
sem_TDecl_Poly :: (T_Position) ->
                  (T_QualName) ->
                  (T_TypeBindings) ->
                  (T_TDecl)
sem_TDecl_Poly (_srcloc)
               (_name)
               (_bindings)
               (_lhs_classname)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_importedModule)
               (_lhs_ininstance)
               (_lhs_intitype)
               (_lhs_knownKinds)
               (_lhs_knownKinds_collect)
               (_lhs_knownTypes)
               (_lhs_knownTypes_collect)
               (_lhs_knownValues)
               (_lhs_knownValues_collect)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_moduleTypes)
               (_lhs_moduleValues)
               (_lhs_nameType)
               (_lhs_toplevel) =
    let (_self) =
            TDecl_Poly _srcloc_self _name_self _bindings_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Def_Typ) (_lhs_toplevel))
        ( _bindings_constructors_collect,_bindings_knownKinds_collect,_bindings_knownTypes_collect,_bindings_knownValues_collect,_bindings_methods_collect,_bindings_moduleTypes,_bindings_moduleValues,_bindings_modules,_bindings_res,_bindings_self) =
            (_bindings (_lhs_classname) (_name_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_name_knownKinds_collect) (_lhs_knownTypes) (_name_knownTypes_collect) (_lhs_knownValues) (_name_knownValues_collect) (_lhs_local) (_name_methods_collect) (_lhs_methods_dist) (_name_moduleTypes) (_name_moduleValues) (_lhs_nameType) (False))
    in  (_bindings_constructors_collect,_bindings_knownKinds_collect,_bindings_knownTypes_collect,_bindings_knownValues_collect,_bindings_methods_collect,_bindings_moduleTypes,_bindings_moduleValues,_name_modules `Set.union` _bindings_modules,_name_res ++ _bindings_res,_self)
sem_TDecl_TiType :: (T_Position) ->
                    (T_QualName) ->
                    (T_SType) ->
                    (T_Args) ->
                    (T_Constr) ->
                    (T_TDecl)
sem_TDecl_TiType (_srcloc)
                 (_name)
                 (_tp)
                 (_args)
                 (_cons)
                 (_lhs_classname)
                 (_lhs_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_importedModule)
                 (_lhs_ininstance)
                 (_lhs_intitype)
                 (_lhs_knownKinds)
                 (_lhs_knownKinds_collect)
                 (_lhs_knownTypes)
                 (_lhs_knownTypes_collect)
                 (_lhs_knownValues)
                 (_lhs_knownValues_collect)
                 (_lhs_local)
                 (_lhs_methods_collect)
                 (_lhs_methods_dist)
                 (_lhs_moduleTypes)
                 (_lhs_moduleValues)
                 (_lhs_nameType)
                 (_lhs_toplevel) =
    let (_self) =
            TDecl_TiType _srcloc_self _name_self _tp_self _args_self
                         _cons_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Def_Typ) (_lhs_toplevel))
        ( _tp_constructors_collect,_tp_knownKinds_collect,_tp_knownTypes_collect,_tp_knownValues_collect,_tp_methods_collect,_tp_moduleTypes,_tp_moduleValues,_tp_modules,_tp_res,_tp_self) =
            (_tp (_lhs_classname) (_name_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (True) (_lhs_knownKinds) (_name_knownKinds_collect) (_lhs_knownTypes) (emptyFM) (_lhs_knownValues) (_name_knownValues_collect) (_lhs_local) (_name_methods_collect) (_lhs_methods_dist) (_name_moduleTypes) (_name_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _args_constructors_collect,_args_knownKinds_collect,_args_knownTypes_collect,_args_knownValues_collect,_args_methods_collect,_args_moduleTypes,_args_moduleValues,_args_modules,_args_res,_args_self) =
            (_args (_lhs_classname) (_tp_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_tp_knownKinds_collect) (_lhs_knownTypes) (_tp_knownTypes_collect) (_lhs_knownValues) (_tp_knownValues_collect) (_lhs_local) (_tp_methods_collect) (_lhs_methods_dist) (_tp_moduleTypes) (_tp_moduleValues) (Def_Typ) (False))
        ( _cons_constructors,_cons_constructors_collect,_cons_knownKinds_collect,_cons_knownTypes_collect,_cons_knownValues_collect,_cons_methods_collect,_cons_moduleTypes,_cons_moduleValues,_cons_modules,_cons_res,_cons_self) =
            (_cons (_lhs_classname)
                   (_args_constructors_collect)
                   (_lhs_constructors_dist)
                   (_lhs_currentModule)
                   (_lhs_importedModule)
                   (_lhs_ininstance)
                   (_lhs_intitype)
                   (_lhs_knownKinds)
                   (_args_knownKinds_collect)
                   (_args_knownTypes_collect `mergeFM` _lhs_knownTypes)
                   (_args_knownTypes_collect)
                   (_lhs_knownValues)
                   (_args_knownValues_collect)
                   (_lhs_local)
                   (_args_methods_collect)
                   (_lhs_methods_dist)
                   (_args_moduleTypes)
                   (_args_moduleValues)
                   (_lhs_nameType)
                   (_lhs_toplevel)
                   (_name_self))
    in  (addLBack _lhs_constructors_collect
                  (_name_self,_cons_constructors)
        ,_cons_knownKinds_collect
        ,_name_knownTypes_collect
        ,_cons_knownValues_collect
        ,_cons_methods_collect
        ,_cons_moduleTypes
        ,_cons_moduleValues
        ,_name_modules `Set.union` _tp_modules `Set.union` _args_modules `Set.union` _cons_modules
        ,_name_res ++ _tp_res ++ _args_res ++ _cons_res
        ,_self
        )
sem_TDecl_Type :: (T_Position) ->
                  (T_QualName) ->
                  (T_Args) ->
                  (T_Type) ->
                  (T_TDecl)
sem_TDecl_Type (_srcloc)
               (_name)
               (_args)
               (_tp)
               (_lhs_classname)
               (_lhs_constructors_collect)
               (_lhs_constructors_dist)
               (_lhs_currentModule)
               (_lhs_importedModule)
               (_lhs_ininstance)
               (_lhs_intitype)
               (_lhs_knownKinds)
               (_lhs_knownKinds_collect)
               (_lhs_knownTypes)
               (_lhs_knownTypes_collect)
               (_lhs_knownValues)
               (_lhs_knownValues_collect)
               (_lhs_local)
               (_lhs_methods_collect)
               (_lhs_methods_dist)
               (_lhs_moduleTypes)
               (_lhs_moduleValues)
               (_lhs_nameType)
               (_lhs_toplevel) =
    let (_self) =
            TDecl_Type _srcloc_self _name_self _args_self _tp_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Def_Typ) (_lhs_toplevel))
        ( _args_constructors_collect,_args_knownKinds_collect,_args_knownTypes_collect,_args_knownValues_collect,_args_methods_collect,_args_moduleTypes,_args_moduleValues,_args_modules,_args_res,_args_self) =
            (_args (_lhs_classname) (_name_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_name_knownKinds_collect) (_lhs_knownTypes) (emptyFM) (_lhs_knownValues) (_name_knownValues_collect) (_lhs_local) (_name_methods_collect) (_lhs_methods_dist) (_name_moduleTypes) (_name_moduleValues) (Def_Typ) (False))
        ( _tp_constructors_collect,_tp_knownKinds_collect,_tp_knownTypes_collect,_tp_knownValues_collect,_tp_methods_collect,_tp_moduleTypes,_tp_moduleValues,_tp_modules,_tp_res,_tp_self) =
            (_tp (_lhs_classname)
                 (_args_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_importedModule)
                 (_lhs_ininstance)
                 (_lhs_intitype)
                 (_lhs_knownKinds)
                 (_args_knownKinds_collect)
                 (_args_knownTypes_collect `mergeFM` _lhs_knownTypes)
                 (_args_knownTypes_collect)
                 (_lhs_knownValues)
                 (_args_knownValues_collect)
                 (_lhs_local)
                 (_args_methods_collect)
                 (_lhs_methods_dist)
                 (_args_moduleTypes)
                 (_args_moduleValues)
                 (_lhs_nameType)
                 (False))
    in  (_tp_constructors_collect,_tp_knownKinds_collect,_name_knownTypes_collect,_tp_knownValues_collect,_tp_methods_collect,_tp_moduleTypes,_tp_moduleValues,_name_modules `Set.union` _args_modules `Set.union` _tp_modules,_name_res ++ _args_res ++ _tp_res,_self)
-- Type --------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Type

-}
{-
   local variables for Type.All:
      self
      knownTypes

-}
{-
   local variables for Type.App:
      self

-}
{-
   local variables for Type.Con:
      self

-}
{-
   local variables for Type.ConCase:
      self

-}
{-
   local variables for Type.Fun:
      self

-}
{-
   local variables for Type.KindApp:
      self

-}
{-
   local variables for Type.Lam:
      self
      knownTypes

-}
{-
   local variables for Type.List:
      self

-}
{-
   local variables for Type.Tuple:
      self

-}
{-
   local variables for Type.TypeApp:
      self

-}
{-
   local variables for Type.Unit:
      self

-}
{-
   local variables for Type.Var:
      self

-}
-- semantic domain
type T_Type = (Maybe QualName) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (Modid) ->
              (Bool) ->
              (Bool) ->
              (Bool) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (FMap QualName [Entity]) ->
              (Bool) ->
              (FMap QualName QualNames) ->
              (FMap QualName QualNames) ->
              (FMap Modid [QualName]) ->
              (FMap Modid [QualName]) ->
              (NameType) ->
              (Bool) ->
              ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Type))
-- cata
sem_Type :: (Type) ->
            (T_Type)
sem_Type ((Type_All (_var) (_body))) =
    (sem_Type_All ((sem_QualName (_var))) ((sem_Type (_body))))
sem_Type ((Type_App (_left) (_right))) =
    (sem_Type_App ((sem_Type (_left))) ((sem_Type (_right))))
sem_Type ((Type_Con (_srcloc) (_name))) =
    (sem_Type_Con ((sem_Position (_srcloc))) ((sem_QualName (_name))))
sem_Type ((Type_ConCase (_srcloc) (_name))) =
    (sem_Type_ConCase ((sem_Position (_srcloc))) ((sem_QualName (_name))))
sem_Type ((Type_Fun )) =
    (sem_Type_Fun )
sem_Type ((Type_KindApp (_srcloc) (_tp) (_kind))) =
    (sem_Type_KindApp ((sem_Position (_srcloc))) ((sem_QualName (_tp))) ((sem_Kind (_kind))))
sem_Type ((Type_Lam (_from) (_body))) =
    (sem_Type_Lam ((sem_QualName (_from))) ((sem_Type (_body))))
sem_Type ((Type_List )) =
    (sem_Type_List )
sem_Type ((Type_Tuple (_n))) =
    (sem_Type_Tuple (_n))
sem_Type ((Type_TypeApp (_srcloc) (_tp) (_type))) =
    (sem_Type_TypeApp ((sem_Position (_srcloc))) ((sem_QualName (_tp))) ((sem_Type (_type))))
sem_Type ((Type_Unit )) =
    (sem_Type_Unit )
sem_Type ((Type_Var (_srcloc) (_name))) =
    (sem_Type_Var ((sem_Position (_srcloc))) ((sem_QualName (_name))))
sem_Type_All :: (T_QualName) ->
                (T_Type) ->
                (T_Type)
sem_Type_All (_var) (_body) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_knownTypes) =
            _var_knownTypes_collect `mergeFM` _lhs_knownTypes
        (_self) =
            Type_All _var_self _body_self
        ( _var_constructors_collect,_var_entityName,_var_fullName,_var_knownKinds_collect,_var_knownTypes_collect,_var_knownValues_collect,_var_methods_collect,_var_moduleTypes,_var_moduleValues,_var_modules,_var_res,_var_self,_var_self') =
            (_var (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_knownTypes) (emptyFM) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Def_Typ) (_lhs_toplevel))
        ( _body_constructors_collect,_body_knownKinds_collect,_body_knownTypes_collect,_body_knownValues_collect,_body_methods_collect,_body_moduleTypes,_body_moduleValues,_body_modules,_body_res,_body_self) =
            (_body (_lhs_classname) (_var_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_var_knownKinds_collect) (_knownTypes) (_var_knownTypes_collect) (_lhs_knownValues) (_var_knownValues_collect) (_lhs_local) (_var_methods_collect) (_lhs_methods_dist) (_var_moduleTypes) (_var_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_body_constructors_collect,_body_knownKinds_collect,_lhs_knownTypes_collect,_body_knownValues_collect,_body_methods_collect,_body_moduleTypes,_body_moduleValues,_var_modules `Set.union` _body_modules,_var_res ++ _body_res,_self)
sem_Type_App :: (T_Type) ->
                (T_Type) ->
                (T_Type)
sem_Type_App (_left) (_right) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Type_App _left_self _right_self
        ( _left_constructors_collect,_left_knownKinds_collect,_left_knownTypes_collect,_left_knownValues_collect,_left_methods_collect,_left_moduleTypes,_left_moduleValues,_left_modules,_left_res,_left_self) =
            (_left (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _right_constructors_collect,_right_knownKinds_collect,_right_knownTypes_collect,_right_knownValues_collect,_right_methods_collect,_right_moduleTypes,_right_moduleValues,_right_modules,_right_res,_right_self) =
            (_right (_lhs_classname) (_left_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_left_knownKinds_collect) (_lhs_knownTypes) (_left_knownTypes_collect) (_lhs_knownValues) (_left_knownValues_collect) (_lhs_local) (_left_methods_collect) (_lhs_methods_dist) (_left_moduleTypes) (_left_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_right_constructors_collect,_right_knownKinds_collect,_right_knownTypes_collect,_right_knownValues_collect,_right_methods_collect,_right_moduleTypes,_right_moduleValues,_left_modules `Set.union` _right_modules,_left_res ++ _right_res,_self)
sem_Type_Con :: (T_Position) ->
                (T_QualName) ->
                (T_Type)
sem_Type_Con (_srcloc) (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Type_Con _srcloc_self _name_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Typ) (_lhs_toplevel))
    in  (_name_constructors_collect,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_self)
sem_Type_ConCase :: (T_Position) ->
                    (T_QualName) ->
                    (T_Type)
sem_Type_ConCase (_srcloc) (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Type_ConCase _srcloc_self _name_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Val) (_lhs_toplevel))
    in  (_name_constructors_collect,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_self)
sem_Type_Fun :: (T_Type)
sem_Type_Fun (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Type_Fun
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],_self)
sem_Type_KindApp :: (T_Position) ->
                    (T_QualName) ->
                    (T_Kind) ->
                    (T_Type)
sem_Type_KindApp (_srcloc) (_tp) (_kind) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Type_KindApp _srcloc_self _tp_self _kind_self
        ( _srcloc_self) =
            (_srcloc )
        ( _tp_constructors_collect,_tp_entityName,_tp_fullName,_tp_knownKinds_collect,_tp_knownTypes_collect,_tp_knownValues_collect,_tp_methods_collect,_tp_moduleTypes,_tp_moduleValues,_tp_modules,_tp_res,_tp_self,_tp_self') =
            (_tp (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Typ) (_lhs_toplevel))
        ( _kind_constructors_collect,_kind_knownKinds_collect,_kind_knownTypes_collect,_kind_knownValues_collect,_kind_methods_collect,_kind_moduleTypes,_kind_moduleValues,_kind_modules,_kind_res,_kind_self) =
            (_kind (_lhs_classname) (_tp_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_tp_knownKinds_collect) (_lhs_knownTypes) (_tp_knownTypes_collect) (_lhs_knownValues) (_tp_knownValues_collect) (_lhs_local) (_tp_methods_collect) (_lhs_methods_dist) (_tp_moduleTypes) (_tp_moduleValues) (Ref_Kind) (_lhs_toplevel))
    in  (_kind_constructors_collect,_kind_knownKinds_collect,_kind_knownTypes_collect,_kind_knownValues_collect,_kind_methods_collect,_kind_moduleTypes,_kind_moduleValues,_tp_modules `Set.union` _kind_modules,_tp_res ++ _kind_res,_self)
sem_Type_Lam :: (T_QualName) ->
                (T_Type) ->
                (T_Type)
sem_Type_Lam (_from) (_body) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_knownTypes) =
            _from_knownTypes_collect `mergeFM` _lhs_knownTypes
        (_self) =
            Type_Lam _from_self _body_self
        ( _from_constructors_collect,_from_entityName,_from_fullName,_from_knownKinds_collect,_from_knownTypes_collect,_from_knownValues_collect,_from_methods_collect,_from_moduleTypes,_from_moduleValues,_from_modules,_from_res,_from_self,_from_self') =
            (_from (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_knownTypes) (emptyFM) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Def_Typ) (_lhs_toplevel))
        ( _body_constructors_collect,_body_knownKinds_collect,_body_knownTypes_collect,_body_knownValues_collect,_body_methods_collect,_body_moduleTypes,_body_moduleValues,_body_modules,_body_res,_body_self) =
            (_body (_lhs_classname) (_from_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_from_knownKinds_collect) (_knownTypes) (_from_knownTypes_collect) (_lhs_knownValues) (_from_knownValues_collect) (_lhs_local) (_from_methods_collect) (_lhs_methods_dist) (_from_moduleTypes) (_from_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_body_constructors_collect,_body_knownKinds_collect,_lhs_knownTypes_collect,_body_knownValues_collect,_body_methods_collect,_body_moduleTypes,_body_moduleValues,_from_modules `Set.union` _body_modules,_from_res ++ _body_res,_self)
sem_Type_List :: (T_Type)
sem_Type_List (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Type_List
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],_self)
sem_Type_Tuple :: (Int) ->
                  (T_Type)
sem_Type_Tuple (_n) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Type_Tuple _n
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],_self)
sem_Type_TypeApp :: (T_Position) ->
                    (T_QualName) ->
                    (T_Type) ->
                    (T_Type)
sem_Type_TypeApp (_srcloc) (_tp) (_type) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Type_TypeApp _srcloc_self _tp_self _type_self
        ( _srcloc_self) =
            (_srcloc )
        ( _tp_constructors_collect,_tp_entityName,_tp_fullName,_tp_knownKinds_collect,_tp_knownTypes_collect,_tp_knownValues_collect,_tp_methods_collect,_tp_moduleTypes,_tp_moduleValues,_tp_modules,_tp_res,_tp_self,_tp_self') =
            (_tp (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Typ) (_lhs_toplevel))
        ( _type_constructors_collect,_type_knownKinds_collect,_type_knownTypes_collect,_type_knownValues_collect,_type_methods_collect,_type_moduleTypes,_type_moduleValues,_type_modules,_type_res,_type_self) =
            (_type (_lhs_classname) (_tp_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_tp_knownKinds_collect) (_lhs_knownTypes) (_tp_knownTypes_collect) (_lhs_knownValues) (_tp_knownValues_collect) (_lhs_local) (_tp_methods_collect) (_lhs_methods_dist) (_tp_moduleTypes) (_tp_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_type_constructors_collect,_type_knownKinds_collect,_type_knownTypes_collect,_type_knownValues_collect,_type_methods_collect,_type_moduleTypes,_type_moduleValues,_tp_modules `Set.union` _type_modules,_tp_res ++ _type_res,_self)
sem_Type_Unit :: (T_Type)
sem_Type_Unit (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Type_Unit
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],_self)
sem_Type_Var :: (T_Position) ->
                (T_QualName) ->
                (T_Type)
sem_Type_Var (_srcloc) (_name) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let (_self) =
            Type_Var _srcloc_self _name_self
        ( _srcloc_self) =
            (_srcloc )
        ( _name_constructors_collect,_name_entityName,_name_fullName,_name_knownKinds_collect,_name_knownTypes_collect,_name_knownValues_collect,_name_methods_collect,_name_moduleTypes,_name_moduleValues,_name_modules,_name_res,_name_self,_name_self') =
            (_name (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (Ref_Typ) (_lhs_toplevel))
    in  (_name_constructors_collect
        ,_name_knownKinds_collect
        ,_name_knownTypes_collect
        ,_name_knownValues_collect
        ,_name_methods_collect
        ,_name_moduleTypes
        ,_name_moduleValues
        ,_name_modules
        ,case _name_res of
           [UnResolved _ _ _] -> [Resolved _name_self' _name_entityName]
           x                  -> x
        ,_self
        )
-- TypeBinding -------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : TypeBinding

-}
{-
   local variables for TypeBinding.Binding:

-}
-- semantic domain
type T_TypeBinding = (Maybe QualName) ->
                     (FMap QualName QualNames) ->
                     (FMap QualName QualNames) ->
                     (Modid) ->
                     (Bool) ->
                     (Bool) ->
                     (Bool) ->
                     (FMap QualName [Entity]) ->
                     (FMap QualName [Entity]) ->
                     (FMap QualName [Entity]) ->
                     (FMap QualName [Entity]) ->
                     (FMap QualName [Entity]) ->
                     (FMap QualName [Entity]) ->
                     (Bool) ->
                     (FMap QualName QualNames) ->
                     (FMap QualName QualNames) ->
                     (FMap Modid [QualName]) ->
                     (FMap Modid [QualName]) ->
                     (NameType) ->
                     (Bool) ->
                     ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(TypeBinding))
-- cata
sem_TypeBinding :: (TypeBinding) ->
                   (T_TypeBinding)
sem_TypeBinding ((TypeBinding_Binding (_kind) (_lh) (_rh))) =
    (sem_TypeBinding_Binding ((sem_SKind (_kind))) ((sem_Args (_lh))) ((sem_Type (_rh))))
sem_TypeBinding_Binding :: (T_SKind) ->
                           (T_Args) ->
                           (T_Type) ->
                           (T_TypeBinding)
sem_TypeBinding_Binding (_kind)
                        (_lh)
                        (_rh)
                        (_lhs_classname)
                        (_lhs_constructors_collect)
                        (_lhs_constructors_dist)
                        (_lhs_currentModule)
                        (_lhs_importedModule)
                        (_lhs_ininstance)
                        (_lhs_intitype)
                        (_lhs_knownKinds)
                        (_lhs_knownKinds_collect)
                        (_lhs_knownTypes)
                        (_lhs_knownTypes_collect)
                        (_lhs_knownValues)
                        (_lhs_knownValues_collect)
                        (_lhs_local)
                        (_lhs_methods_collect)
                        (_lhs_methods_dist)
                        (_lhs_moduleTypes)
                        (_lhs_moduleValues)
                        (_lhs_nameType)
                        (_lhs_toplevel) =
    let ( _kind_constructors_collect,_kind_knownKinds_collect,_kind_knownTypes_collect,_kind_knownValues_collect,_kind_methods_collect,_kind_moduleTypes,_kind_moduleValues,_kind_modules,_kind_res,_kind_self) =
            (_kind (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (emptyFM) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _lh_constructors_collect,_lh_knownKinds_collect,_lh_knownTypes_collect,_lh_knownValues_collect,_lh_methods_collect,_lh_moduleTypes,_lh_moduleValues,_lh_modules,_lh_res,_lh_self) =
            (_lh (_lhs_classname) (_kind_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_kind_knownKinds_collect) (_lhs_knownTypes) (emptyFM) (_lhs_knownValues) (_kind_knownValues_collect) (_lhs_local) (_kind_methods_collect) (_lhs_methods_dist) (_kind_moduleTypes) (_kind_moduleValues) (Def_Typ) (_lhs_toplevel))
        ( _rh_constructors_collect,_rh_knownKinds_collect,_rh_knownTypes_collect,_rh_knownValues_collect,_rh_methods_collect,_rh_moduleTypes,_rh_moduleValues,_rh_modules,_rh_res,_rh_self) =
            (_rh (_lhs_classname)
                 (_lh_constructors_collect)
                 (_lhs_constructors_dist)
                 (_lhs_currentModule)
                 (_lhs_importedModule)
                 (_lhs_ininstance)
                 (_lhs_intitype)
                 (_lh_knownKinds_collect `mergeFM` _lhs_knownKinds)
                 (_lh_knownKinds_collect)
                 (_lh_knownTypes_collect `mergeFM` _lhs_knownTypes)
                 (_lh_knownTypes_collect)
                 (_lhs_knownValues)
                 (_lh_knownValues_collect)
                 (_lhs_local)
                 (_lh_methods_collect)
                 (_lhs_methods_dist)
                 (_lh_moduleTypes)
                 (_lh_moduleValues)
                 (_lhs_nameType)
                 (_lhs_toplevel))
    in  (_rh_constructors_collect
        ,_lhs_knownKinds_collect
        ,_lhs_knownTypes_collect
        ,_rh_knownValues_collect
        ,_rh_methods_collect
        ,_rh_moduleTypes
        ,_rh_moduleValues
        ,_kind_modules `Set.union` _lh_modules `Set.union` _rh_modules
        ,_kind_res ++ _lh_res ++ _rh_res
        ,TypeBinding_Binding _kind_self _lh_self
                             _rh_self
        )
-- TypeBindings ------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : TypeBindings

-}
{-
   local variables for TypeBindings.Cons:

-}
{-
   local variables for TypeBindings.Nil:

-}
-- semantic domain
type T_TypeBindings = (Maybe QualName) ->
                      (FMap QualName QualNames) ->
                      (FMap QualName QualNames) ->
                      (Modid) ->
                      (Bool) ->
                      (Bool) ->
                      (Bool) ->
                      (FMap QualName [Entity]) ->
                      (FMap QualName [Entity]) ->
                      (FMap QualName [Entity]) ->
                      (FMap QualName [Entity]) ->
                      (FMap QualName [Entity]) ->
                      (FMap QualName [Entity]) ->
                      (Bool) ->
                      (FMap QualName QualNames) ->
                      (FMap QualName QualNames) ->
                      (FMap Modid [QualName]) ->
                      (FMap Modid [QualName]) ->
                      (NameType) ->
                      (Bool) ->
                      ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(TypeBindings))
-- cata
sem_TypeBindings :: (TypeBindings) ->
                    (T_TypeBindings)
sem_TypeBindings (list) =
    (foldr (sem_TypeBindings_Cons) (sem_TypeBindings_Nil) ((map sem_TypeBinding list)))
sem_TypeBindings_Cons :: (T_TypeBinding) ->
                         (T_TypeBindings) ->
                         (T_TypeBindings)
sem_TypeBindings_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _hd_constructors_collect,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self) =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_lhs_local) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_TypeBindings_Nil :: (T_TypeBindings)
sem_TypeBindings_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])
-- Types -------------------------------------------------------
{-
   inherited attributes:
      classname            : Maybe QualName
      constructors_dist    : FMap QualName QualNames
      currentModule        : Modid
      importedModule       : Bool
      ininstance           : Bool
      intitype             : Bool
      knownKinds           : FMap QualName [Entity]
      knownTypes           : FMap QualName [Entity]
      knownValues          : FMap QualName [Entity]
      local                : Bool
      methods_dist         : FMap QualName QualNames
      nameType             : NameType
      toplevel             : Bool

   chained attributes:
      constructors_collect : FMap QualName QualNames
      knownKinds_collect   : FMap QualName [Entity]
      knownTypes_collect   : FMap QualName [Entity]
      knownValues_collect  : FMap QualName [Entity]
      methods_collect      : FMap QualName QualNames
      moduleTypes          : FMap Modid [QualName]
      moduleValues         : FMap Modid [QualName]

   synthesised attributes:
      modules              : Set.Set Modid
      res                  : [ResolveResult]
      self                 : Types

-}
{-
   local variables for Types.Cons:

-}
{-
   local variables for Types.Nil:

-}
-- semantic domain
type T_Types = (Maybe QualName) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (Modid) ->
               (Bool) ->
               (Bool) ->
               (Bool) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (FMap QualName [Entity]) ->
               (Bool) ->
               (FMap QualName QualNames) ->
               (FMap QualName QualNames) ->
               (FMap Modid [QualName]) ->
               (FMap Modid [QualName]) ->
               (NameType) ->
               (Bool) ->
               ((FMap QualName QualNames),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName [Entity]),(FMap QualName QualNames),(FMap Modid [QualName]),(FMap Modid [QualName]),(Set.Set Modid),([ResolveResult]),(Types))
-- cata
sem_Types :: (Types) ->
             (T_Types)
sem_Types (list) =
    (foldr (sem_Types_Cons) (sem_Types_Nil) ((map sem_Type list)))
sem_Types_Cons :: (T_Type) ->
                  (T_Types) ->
                  (T_Types)
sem_Types_Cons (_hd) (_tl) (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let ( _hd_constructors_collect,_hd_knownKinds_collect,_hd_knownTypes_collect,_hd_knownValues_collect,_hd_methods_collect,_hd_moduleTypes,_hd_moduleValues,_hd_modules,_hd_res,_hd_self) =
            (_hd (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel))
        ( _tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_tl_modules,_tl_res,_tl_self) =
            (_tl (_lhs_classname) (_hd_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_hd_knownKinds_collect) (_lhs_knownTypes) (_hd_knownTypes_collect) (_lhs_knownValues) (_hd_knownValues_collect) (_lhs_local) (_hd_methods_collect) (_lhs_methods_dist) (_hd_moduleTypes) (_hd_moduleValues) (_lhs_nameType) (_lhs_toplevel))
    in  (_tl_constructors_collect,_tl_knownKinds_collect,_tl_knownTypes_collect,_tl_knownValues_collect,_tl_methods_collect,_tl_moduleTypes,_tl_moduleValues,_hd_modules `Set.union` _tl_modules,_hd_res ++ _tl_res,_hd_self : _tl_self)
sem_Types_Nil :: (T_Types)
sem_Types_Nil (_lhs_classname) (_lhs_constructors_collect) (_lhs_constructors_dist) (_lhs_currentModule) (_lhs_importedModule) (_lhs_ininstance) (_lhs_intitype) (_lhs_knownKinds) (_lhs_knownKinds_collect) (_lhs_knownTypes) (_lhs_knownTypes_collect) (_lhs_knownValues) (_lhs_knownValues_collect) (_lhs_local) (_lhs_methods_collect) (_lhs_methods_dist) (_lhs_moduleTypes) (_lhs_moduleValues) (_lhs_nameType) (_lhs_toplevel) =
    let 
    in  (_lhs_constructors_collect,_lhs_knownKinds_collect,_lhs_knownTypes_collect,_lhs_knownValues_collect,_lhs_methods_collect,_lhs_moduleTypes,_lhs_moduleValues,Set.emptySet,[],[])

